/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// THE HUDSON WAR:
// CREATED BY DANY:
// MARCH 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
            int subCiv0=-1;
            int subCiv1=-1;
			
			if(cNumberNonGaiaPlayers == 2)  
			
			int subCiv2=-1;
            int subCiv3=-1;
		
	        // ONLY 2 NATIVES THIS MAP:
	        int whichNative=rmRandInt(1,2);
	        if ( whichNative == 1 )
	{
		    if (rmAllocateSubCivs(2) == true)
		{
			subCiv0=rmGetCivID("Cree");
			if (subCiv0 >= 0)
			rmSetSubCiv(0, "Cree");

			subCiv1=rmGetCivID("Cree");
			if (subCiv1 >= 0)
			rmSetSubCiv(1, "Cree");
		}
	}
	        else
	{
		    if (rmAllocateSubCivs(2) == true)
		{
			subCiv0=rmGetCivID("Nootka");
			if (subCiv0 >= 0)
			rmSetSubCiv(0, "Nootka");

			subCiv1=rmGetCivID("Nootka");
			if (subCiv1 >= 0)
			rmSetSubCiv(1, "Nootka");
		}
	}
	
	        if(cNumberNonGaiaPlayers == 2)    
		{
			subCiv2=rmGetCivID("Cherokee");
			if (subCiv2 >= 0)
			rmSetSubCiv(2, "Cherokee");

			subCiv3=rmGetCivID("Cree");
			if (subCiv3 >= 0)
			rmSetSubCiv(3, "Cree");
		}

/*================================================================================================================*/
// *********************************** WHICH MAP - FOUR POSSIBLE VARIATIONS: ************************************ //
// ******************* (EXCLUDING WHICH END THE PLAYERS START ON, WHICH IS A SEPARATE THING:) ******************* //
/*================================================================================================================*/
	    // int whichMap=rmRandInt(1,4);
	    int whichMap=2;	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ********************************************* PICKS THE MAP SIZE: ******************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/   
	    int playerTiles=25000;
		
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(650, 650);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //	
/*================================================================================================================*/
	    // PICKS THE WATER HEIGHT:
        rmSetSeaLevel(4.5);	// THIS IS HEIGHT OF RIVER SURFACE COMPARED TO SURROUNDING LAND: 
                            // THE RIVER DEPTH IS IN THE RIVER XML:
		
	    // SET THE SEA TYPE:
		rmSetSeaType("Yukon River");
	
	    // SET THE BASE TERRAIN MIX:
	    rmSetBaseTerrainMix("yukon snow");
   
        // SET THE TERRAIN INITIALIZATION:
        rmTerrainInitialize("yukon\ground1_yuk", 1.0);
   
        // SET THE LIGHTING:
        rmSetLightingSet("yukon");
	
	    // SET THE MAP TYPE:
	    rmSetMapType("yukon");
	    rmSetMapType("snow");
	    rmSetMapType("water");

	    // MAKE THE CORNERS:
	    rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
	    chooseMercs();

	    // MAKE IT SNOW:
        rmSetGlobalSnow( 0.7 );
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
        int classPlayer=rmDefineClass("player");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("nuggets");
		rmDefineClass("classSocket");
		int classGreatLake=rmDefineClass("great lake");
		rmDefineClass("classCliff");
		int canyon=rmDefineClass("canyon");
		rmDefineClass("classMountain");
		rmDefineClass("Center");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/   
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	    int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.02);
        int shortPlayerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 12.0);

		
		// MAP EDGE CONSTRAINTS:
        //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	    
        // CARDINAL DIRECTIONS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	    int NWconstraint = rmCreateBoxConstraint("stay in NW portion", 0, 0.5, 1, 1);
	    int SEconstraint = rmCreateBoxConstraint("stay in SE portion", 0, 0, 1, 0.5);
	    int NEconstraint = rmCreateBoxConstraint("stay in NE portion", 0.5, 0, 1, 1);
	    int SWconstraint = rmCreateBoxConstraint("stay in SW portion", 0, 0.0, 0.5, 1);
	    int extremeSEconstraint = rmCreateBoxConstraint("stay deep into SE portion", 0, 0, 1, 0.4);
		
		// FOREST AVOIDANCE:
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 12.0);
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
        int northForestConstraint=rmCreateClassDistanceConstraint("n forest vs. forest", rmClassID("classForest"), 8.0);
        int southForestConstraint=rmCreateClassDistanceConstraint("s forest vs. forest", rmClassID("classForest"), 10.0);
       		
		int mountainAvoidMountain=rmCreateClassDistanceConstraint("mountain vs. mountain", rmClassID("classMountain"), 60.0);
	    int avoidMountain=rmCreateClassDistanceConstraint("avoid mountain", rmClassID("classMountain"), 10.0);
        		
		// CANYONS AVOIDANCE:
		int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 10.0);
		int avoidCloseCanyons=rmCreateClassDistanceConstraint("forest avoid canyons", rmClassID("canyon"), 4.0);
	    int veryShortAvoidCanyons=rmCreateClassDistanceConstraint("very short avoid canyons", rmClassID("canyon"), 6.0);
		
		// SEA FOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 15.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 15.0);
   
		// NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
		int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
			
		// LAKE CONSTRAINTS:
	    int greatLakesConstraint=rmCreateClassDistanceConstraint("avoid the great lakes", classGreatLake, 5.0);
	    int farGreatLakesConstraint=rmCreateClassDistanceConstraint("far avoid the great lakes", classGreatLake, 20.0);
   
        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20.0);
		int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
        
        // FOREST AVOIDANCE:
		//int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
        
        // MONEY AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 20.0);
		
		// TREES AVOIDANCE:
		int avoidTree=rmCreateTypeDistanceConstraint("stuff avoid tree", "TreeYukon", 5.0);
		int avoidCloseTree=rmCreateTypeDistanceConstraint("lake avoid tree", "TreeYukon", 1.0);
		int avoidFarTree=rmCreateTypeDistanceConstraint("forest avoid tree", "TreeYukon", 15.0);
		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 5.0);
		int avoidFarGold=rmCreateTypeDistanceConstraint("gold avoid gold", "minegold", 60.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("forest avoid gold", "minegold", 2.0);

        // DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoid deer", "deer", 5.0);
		int avoidFarDeer=rmCreateTypeDistanceConstraint("deer avoid deer", "deer", 60.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("forest avoid deer", "deer", 2.0);
		
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoid sheep", "sheep", 5.0);
		int avoidFarSheep=rmCreateTypeDistanceConstraint("sheep avoid sheep", "sheep", 60.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("forest avoid sheep", "sheep", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 5.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium stuff avoid fruits", "berrybush", 30.0);
		int avoidFarFruits=rmCreateTypeDistanceConstraint("fruits avoid fruits", "berrybush", 60.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("forest avoid fruits", "berrybush", 2.0);
		
        // START RESOURCE AVOIDANCE:
		int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 2.0);
   		
		// AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
		int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close impassable land", "Land", false, 2.0);
				
		// CENTER AVOIDANCE:
		int avoidCenter=rmCreateClassDistanceConstraint("stuff vs. center", rmClassID("Center"), 5.0);
	   		
		// CLIFFS AVOIDANCE:
		int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 5.0);
	    		
		// UNIT AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
         
        // IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 60.0);
        int shortAvoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other by a bit", rmClassID("importantItem"), 10.0);
        	
	    // NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 2.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("forest avoids natives", rmClassID("natives"), 1.0);
	    
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 5.0);
		int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium stuff avoid nugget", "AbstractNugget", 30.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);
		int avoidFarNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 60.0);
		//int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 5.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // TRADE ROUTE AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
		int avoidTradeRouteNugget = rmCreateTradeRouteDistanceConstraint("trade route nugget", 7.0);
        int avoidTradeRouteForest = rmCreateTradeRouteDistanceConstraint("trade route forest", 10.0);
       	int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
		
		// CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
   
        	   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************************** DEFINE THE OBJECTS: ********************************************* //
// ************************** THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
		  if(cNumberNonGaiaPlayers == 2)
		{  
		  rmSetPlacementTeam(0);
		  rmPlacePlayer(1,0.75,0.75);
		  rmSetPlacementTeam(1);
		  rmPlacePlayer(2,0.25,0.25);
		}  
		  else
        {		
		  rmSetPlacementTeam(0);
		  rmPlacePlayer(1,0.8,0.8);
		  rmPlacePlayer(2,0.8,0.2);
		  rmSetPlacementTeam(1);
		  rmPlacePlayer(3,0.2,0.2);
          rmPlacePlayer(4,0.2,0.8);
		}  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE AREA NUMBER ONE: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int center1ID=rmCreateArea("center 1");
	    rmSetAreaSize(center1ID, 0.0275, 0.0275);
	    rmSetAreaLocation(center1ID, 0.15, 0.45);
	    rmSetAreaCoherence(center1ID, 1.0);
		//rmSetAreaMix(center1ID, "rockies_grass");
	    rmAddAreaToClass(center1ID, rmClassID("Center"));
		rmAddAreaConstraint(center1ID, avoidCenter);		
		
		int center2ID=rmCreateArea("center 2");
	    rmSetAreaSize(center2ID, 0.0275, 0.0275);
	    rmSetAreaLocation(center2ID, 0.45, 0.15);
	    rmSetAreaCoherence(center2ID, 1.0);
		//rmSetAreaMix(center2ID, "rockies_grass");
	    rmAddAreaToClass(center2ID, rmClassID("Center"));
		rmAddAreaConstraint(center2ID, avoidCenter);
		
		int center3ID=rmCreateArea("center 3");
	    rmSetAreaSize(center3ID, 0.0275, 0.0275);
	    rmSetAreaLocation(center3ID, 0.55, 0.85);
	    rmSetAreaCoherence(center3ID, 1.0);
		//rmSetAreaMix(center3ID, "rockies_grass");
	    rmAddAreaToClass(center3ID, rmClassID("Center"));
		rmAddAreaConstraint(center3ID, avoidCenter);
		
		int center4ID=rmCreateArea("center 4");
	    rmSetAreaSize(center4ID, 0.0275, 0.0275);
	    rmSetAreaLocation(center4ID, 0.85, 0.55);
	    rmSetAreaCoherence(center4ID, 1.0);
		//rmSetAreaMix(center4ID, "rockies_grass");
	    rmAddAreaToClass(center4ID, rmClassID("Center"));
		rmAddAreaConstraint(center4ID, avoidCenter);
		
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FROZEN LAKE:  ************************************* //
/*================================================================================================================*/

	rmClearClosestPointConstraints();
	
	int michiganID=rmCreateArea("Lake Michigan 1");
    	
	rmSetAreaSize(michiganID, 0.125, 0.125);
	rmSetAreaWaterType(michiganID, "great lakes ice");
	rmSetAreaCoherence(michiganID, 0.90);
	rmSetAreaLocation(michiganID, 0.50, 0.50);
	
	rmAddAreaToClass(michiganID, classGreatLake);
	rmSetAreaBaseHeight(michiganID, 1.0);
	rmSetAreaObeyWorldCircleConstraint(michiganID, false);
	rmSetAreaMinBlobs(michiganID, 2);
	rmSetAreaMaxBlobs(michiganID, 4);
	rmSetAreaMinBlobDistance(michiganID, 5);
	rmSetAreaMaxBlobDistance(michiganID, 8);
	rmSetAreaSmoothDistance(michiganID, 0);
	rmBuildArea(michiganID); 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE AREA NUMBER TWO: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE CLIFFS: ***************************************** // 
/*================================================================================================================*/
	    
		// DEFINE AND PLACE CLIFF NUMBER 1:
	    int numTries=cNumberNonGaiaPlayers*0.5;
	    int failCount=0;
	    for(i=0; <numTries)
	{
		int cliff1ID=rmCreateArea("cliff 1"+i);
	    rmSetAreaSize(cliff1ID, 0.0275, 0.0275);
		rmSetAreaWarnFailure(cliff1ID, false);
		rmSetAreaCliffType(cliff1ID, "rocky mountain2");
		rmAddAreaToClass(cliff1ID, rmClassID("classCliff"));
        //rmSetAreaCliffEdge(cliff1ID, 1, 1.0, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(cliff1ID, 2, 0.4, 0.1, 1.0, 0);		
		rmSetAreaCliffPainting(cliff1ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliff1ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(cliff1ID, 1);
		rmSetAreaObeyWorldCircleConstraint(cliff1ID, false);
		rmAddAreaConstraint(cliff1ID, avoidCliffs);				
		rmSetAreaCoherence(cliff1ID, 1.0);
		rmSetAreaSmoothDistance(cliff1ID, 30);						
		rmSetAreaLocation(cliff1ID,0.55, 0.85);

		if(rmBuildArea(cliff1ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

	    // DEFINE AND PLACE CLIFF NUMBER 2:
	    numTries=cNumberNonGaiaPlayers*0.5;
	    failCount=0;
	    for(i=0; <numTries)
	{
		int cliff2ID=rmCreateArea("cliff 2"+i);
	    rmSetAreaSize(cliff2ID, 0.0275, 0.0275);
		rmSetAreaWarnFailure(cliff2ID, false);
		rmSetAreaCliffType(cliff2ID, "rocky mountain2");
		rmAddAreaToClass(cliff2ID, rmClassID("classCliff"));
        //rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);		
		rmSetAreaCliffPainting(cliff2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliff2ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(cliff2ID, 1);
		rmSetAreaObeyWorldCircleConstraint(cliff2ID, false);
		rmAddAreaConstraint(cliff2ID, avoidCliffs);				
		rmSetAreaCoherence(cliff2ID, 1.0);
		rmSetAreaSmoothDistance(cliff2ID, 30);						
		rmSetAreaLocation(cliff2ID,0.85, 0.55);

		if(rmBuildArea(cliff2ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE CLIFF NUMBER 3:
	    numTries=cNumberNonGaiaPlayers*0.5;
	    failCount=0;
	    for(i=0; <numTries)
	{
		int cliff3ID=rmCreateArea("cliff 3"+i);
	    rmSetAreaSize(cliff3ID, 0.0275, 0.0275);
		rmSetAreaWarnFailure(cliff3ID, false);
		rmSetAreaCliffType(cliff3ID, "rocky mountain2");
		rmAddAreaToClass(cliff3ID, rmClassID("classCliff"));
        //rmSetAreaCliffEdge(cliff3ID, 1, 1.0, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(cliff3ID, 2, 0.4, 0.1, 1.0, 0);		
		rmSetAreaCliffPainting(cliff3ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliff3ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(cliff3ID, 1);
		rmSetAreaObeyWorldCircleConstraint(cliff3ID, false);
		rmAddAreaConstraint(cliff3ID, avoidCliffs);				
		rmSetAreaCoherence(cliff3ID, 1.0);
		rmSetAreaSmoothDistance(cliff3ID, 30);						
		rmSetAreaLocation(cliff3ID,0.15, 0.45);

		if(rmBuildArea(cliff3ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE CLIFF NUMBER 4:
	    numTries=cNumberNonGaiaPlayers*0.5;
	    failCount=0;
	    for(i=0; <numTries)
	{
		int cliff4ID=rmCreateArea("cliff 4"+i);
	    rmSetAreaSize(cliff4ID, 0.0275, 0.0275);
		rmSetAreaWarnFailure(cliff4ID, false);
		rmSetAreaCliffType(cliff4ID, "rocky mountain2");
		rmAddAreaToClass(cliff4ID, rmClassID("classCliff"));
        //rmSetAreaCliffEdge(cliff4ID, 1, 1.0, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(cliff4ID, 2, 0.4, 0.1, 1.0, 0);		
		rmSetAreaCliffPainting(cliff4ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliff4ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(cliff4ID, 1);
		rmSetAreaObeyWorldCircleConstraint(cliff4ID, false);
		rmAddAreaConstraint(cliff4ID, avoidCliffs);				
		rmSetAreaCoherence(cliff4ID, 1.0);
		rmSetAreaSmoothDistance(cliff4ID, 30);						
		rmSetAreaLocation(cliff4ID,0.45, 0.15);

		if(rmBuildArea(cliff4ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	} 	
	
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE AREA NUMBER THREE: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        float playerFraction = rmAreaTilesToFraction(100);
        
		for(i = 0; < cNumberNonGaiaPlayers)
   {
        // CREATE THE AREA:
        int id = rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); // removed by me for now:
        //rmAddAreaConstraint(id, playerEdgeConstraint); // removed by me for now:
	   
	    // SET AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "carolina\marshflats");
	    
		// SET AREA MIX:
		// rmSetAreaMix(id, "yukon snow"); // added by me as a possiblity:
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE TRADE ROUTE: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ******************************* DEFINE THE STARTING UNITS AND RESOURCES DEFS: ******************************** //
/*================================================================================================================*/
        // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints(); 

	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);

	    // DEFINE THE STARTING TCID:
		int startingTCID = rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
/*----------------------------------------------------------------------------------------------------------------*/
	    // DEFINE THE PLAYER GOLD:
		int playerGoldID=-1;
	    int silverType = -1;
	    int silverID = -1;

	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeYukon", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 15.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
		
		// DEFINE THE STARTING BERRYBUSH 1:
		int StartBerries1ID=rmCreateObjectDef("starting berries 1");
	    rmAddObjectDefItem(StartBerries1ID, "berrybush", rmRandInt(3,5), 5.0);
	    rmSetObjectDefMinDistance(StartBerries1ID, 20.0);
	    rmSetObjectDefMaxDistance(StartBerries1ID, 20.0);
	    rmSetObjectDefCreateHerd(StartBerries1ID, true);
	    rmAddObjectDefConstraint(StartBerries1ID, avoidStartingUnitsSmall);
		rmAddObjectDefConstraint(StartBerries1ID, avoidMediumFruits);
		
		// DEFINE THE STARTING BERRYBUSH 2:
		int StartBerries2ID=rmCreateObjectDef("starting berries 2");
	    rmAddObjectDefItem(StartBerries2ID, "berrybush", rmRandInt(3,5), 5.0);
	    rmSetObjectDefMinDistance(StartBerries2ID, 25.0);
	    rmSetObjectDefMaxDistance(StartBerries2ID, 25.0);
	    rmSetObjectDefCreateHerd(StartBerries2ID, true);
	    rmAddObjectDefConstraint(StartBerries2ID, avoidStartingUnitsSmall);
		rmAddObjectDefConstraint(StartBerries2ID, avoidMediumFruits);

	    // DEFINE THE STARTING CARIBOU NUMBER 1:
		int StartCaribouID=rmCreateObjectDef("starting caribou");
	    rmAddObjectDefItem(StartCaribouID, "caribou", 6, 4.0);
	    rmSetObjectDefMinDistance(StartCaribouID, 20.0);
	    rmSetObjectDefMaxDistance(StartCaribouID, 20.0);
	    rmSetObjectDefCreateHerd(StartCaribouID, true);
	    rmAddObjectDefConstraint(StartCaribouID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING CARIBOU NUMBER 2:
		int StartCaribouID2=rmCreateObjectDef("starting caribou 2");
	    rmAddObjectDefItem(StartCaribouID2, "caribou", 4, 4.0);
	    rmSetObjectDefMinDistance(StartCaribouID2, 25.0);
	    rmSetObjectDefMaxDistance(StartCaribouID2, 25.0);
	    rmSetObjectDefCreateHerd(StartCaribouID2, true);
	    rmAddObjectDefConstraint(StartCaribouID2, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidMediumNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ********************************* PLACE THE STARTING UNITS AND RESOURCES DEFS: ******************************* //
/*================================================================================================================*/
	    int waterFlagID=-1;
		for(i=1; <cNumberPlayers)
		
	{
		rmClearClosestPointConstraints();
		
		// PLACE THE TCID AND THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*----------------------------------------------------------------------------------------------------------------*/		
		// EVERYONE GETS ONE ORE GROUPING:
		// PLACE THE PLAYER GOLD:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);			
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmSetObjectDefMinDistance(playerGoldID, 16.0);
		rmSetObjectDefMaxDistance(playerGoldID, 19.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerries1ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerries2ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING CARIBOUS:
		rmPlaceObjectDefAtLoc(StartCaribouID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartCaribouID2, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
	    // WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		//rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		//rmAddClosestPointConstraint(Eastward);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();
	
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

       // DEFINE AND PLACE THE NATIVE TRIBE NUMBER 1:
		int creeVillageAID = -1;
	    int creeVillageType = rmRandInt(1,5);
	    if ( whichNative == 1 )
	{
		creeVillageAID = rmCreateGrouping("Cree village A", "native cree village "+creeVillageType);
	}
	    else
	{
		creeVillageAID = rmCreateGrouping("Nootka village A", "native nootka village "+creeVillageType);
	}
	    rmSetGroupingMinDistance(creeVillageAID, 0.0);
	    rmSetGroupingMaxDistance(creeVillageAID, 0.0);
	    // rmSetGroupingMaxDistance(creeVillageAID, rmXFractionToMeters(0.05));
	    //rmAddGroupingConstraint(creeVillageAID, avoidImpassableLand);
	    // rmAddGroupingConstraint(creeVillageAID, playerEdgeConstraint);
	    rmAddGroupingToClass(creeVillageAID, rmClassID("natives"));
	    rmAddGroupingToClass(creeVillageAID, rmClassID("importantItem"));
	    //rmAddGroupingConstraint(creeVillageAID, avoidTradeRoute);
		
		if ( whichMap == 4 )
	{
		rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.15, 0.45);
		rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.45, 0.15);
	}
	    else 
	{
		if (whichMap == 2 )
		{
			rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.15, 0.45);
		    rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.45, 0.15);
		}
		else
		{
			rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.15, 0.45);
		    rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.45, 0.15);
		}
	}
	    
		//rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.15, 0.45);
		//rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.45, 0.15);
		
	
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE THE NATIVE TRIBE NUMBER 2: 
	    int creeVillageBID = -1;
	    creeVillageType = rmRandInt(1,5);
	    if ( whichNative == 1 )
	{
		creeVillageBID = rmCreateGrouping("Cree village B", "native cree village "+creeVillageType);
	}
	    else
	{
		creeVillageBID = rmCreateGrouping("Nootka village B", "native nootka village "+creeVillageType);
	}
	    rmSetGroupingMinDistance(creeVillageBID, 0.0);
	    rmSetGroupingMaxDistance(creeVillageBID, 0.0);
	    // rmSetGroupingMaxDistance(creeVillageBID, rmXFractionToMeters(0.05));
	    //rmAddGroupingConstraint(creeVillageBID, avoidImpassableLand);
	    // rmAddGroupingConstraint(creeVillageBID, playerEdgeConstraint);
	    rmAddGroupingToClass(creeVillageBID, rmClassID("natives"));
	    rmAddGroupingToClass(creeVillageBID, rmClassID("importantItem"));
	    //rmAddGroupingConstraint(creeVillageBID, avoidTradeRoute);
		
		if ( whichMap == 4 )
	{
		rmPlaceGroupingAtLoc(creeVillageBID, 0, 0.55, 0.85);
		rmPlaceGroupingAtLoc(creeVillageBID, 0, 0.85, 0.55);
	}
	    else
	{
		if ( whichMap == 2 )
		{
			rmPlaceGroupingAtLoc(creeVillageBID, 0, 0.55, 0.85);
		    rmPlaceGroupingAtLoc(creeVillageBID, 0, 0.85, 0.55);
		}
		else
		{
			rmPlaceGroupingAtLoc(creeVillageBID, 0, 0.55, 0.85);
		    rmPlaceGroupingAtLoc(creeVillageBID, 0, 0.85, 0.55);
		}
	}	
	    
		//rmPlaceGroupingAtLoc(creeVillageBID, 0, 0.55, 0.85);
		//rmPlaceGroupingAtLoc(creeVillageBID, 0, 0.85, 0.55);
/*================================================================================================================*/
// ************************ DEFINE AND PLACE SOME MORE NATIVES TRIBES IF ONLY 2 PLAYERS: ************************ //		
/*================================================================================================================*/

		    
	    if (subCiv2 == rmGetCivID("cherokee"))
	{  
		int cherokeeVillageID = -1;
		cherokeeVillageID = rmCreateGrouping("cherokee village", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokeeVillageID, 0.0);
		//rmSetGroupingMaxDistance(cherokeeVillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(cherokeeVillageID, 0.0);
		//rmAddGroupingConstraint(cherokeeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokeeVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokeeVillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokeeVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.2, 0.8);
	} 
				
	    if (subCiv3 == rmGetCivID("cree"))
	{  
		int creeVillageID = -1;
		creeVillageID = rmCreateGrouping("cree village", "native cree village 1");
		rmSetGroupingMinDistance(creeVillageID, 0.0);
		//rmSetGroupingMaxDistance(creeVillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(creeVillageID, 0.0);
		//rmAddGroupingConstraint(creeVillageID, avoidImpassableLand);
		rmAddGroupingToClass(creeVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(creeVillageID, avoidNatives);
		//rmAddGroupingConstraint(creeVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(creeVillageID, 0, 0.8, 0.2);
	} 
        	
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE STUFFS ON CLIFF NUMBER 1: ******************************* //        
/*================================================================================================================*/

		int tree1ID= rmCreateObjectDef("The Trees 1"); 
	    rmAddObjectDefItem(tree1ID, "TreeYukon", 1.0, 0.0);
		rmSetObjectDefMinDistance(tree1ID, 0.0);
	    rmSetObjectDefMaxDistance(tree1ID, 0.0);
  	    //rmAddObjectDefConstraint(tree1ID, avoidCloseTree);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.49, 0.85);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.51, 0.85);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.59, 0.85);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.61, 0.85);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.55, 0.79);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.55, 0.81);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.55, 0.89);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.55, 0.91);	
		
        int gold1ID= rmCreateObjectDef("The Gold Mine 1"); 
	    rmAddObjectDefItem(gold1ID, "minegold", 1.0, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
	    rmSetObjectDefMaxDistance(gold1ID, 0.0);
  	    rmAddObjectDefConstraint(gold1ID, avoidGold);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.59, 0.89);
		
        int deer1ID= rmCreateObjectDef("The Deers 1"); 
	    rmAddObjectDefItem(deer1ID, "deer", rmRandInt(5,7), 4.0);
		rmSetObjectDefCreateHerd(deer1ID, true);
		rmSetObjectDefMinDistance(deer1ID, 0.0);
	    rmSetObjectDefMaxDistance(deer1ID, 0.0);
  	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.51, 0.81);

        int nugget1ID= rmCreateObjectDef("The Nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget1ID, rmClassID("nuggets"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
  	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.50, 0.88);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.58, 0.80);
		
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE STUFFS ON CLIFF NUMBER 2: ******************************* //        
/*================================================================================================================*/

		int tree2ID= rmCreateObjectDef("The Trees 2"); 
	    rmAddObjectDefItem(tree2ID, "TreeYukon", 1.0, 0.0);
		rmSetObjectDefMinDistance(tree2ID, 0.0);
	    rmSetObjectDefMaxDistance(tree2ID, 0.0);
  	    //rmAddObjectDefConstraint(tree2ID, avoidCloseTree);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.85, 0.50);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.85, 0.52);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.85, 0.58);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.85, 0.60);
        rmPlaceObjectDefAtLoc(tree2ID, 0, 0.79, 0.55);
        rmPlaceObjectDefAtLoc(tree2ID, 0, 0.81, 0.55);
        rmPlaceObjectDefAtLoc(tree2ID, 0, 0.89, 0.55);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.91, 0.55);	
		
        int gold2ID= rmCreateObjectDef("The Gold Mine 2"); 
	    rmAddObjectDefItem(gold2ID, "minegold", 1.0, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
	    rmSetObjectDefMaxDistance(gold2ID, 0.0);
  	    rmAddObjectDefConstraint(gold2ID, avoidGold);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.88, 0.58);
		
        int deer2ID= rmCreateObjectDef("The Deers 2"); 
	    rmAddObjectDefItem(deer2ID, "deer", rmRandInt(5,7), 4.0);
		rmSetObjectDefCreateHerd(deer2ID, true);
		rmSetObjectDefMinDistance(deer2ID, 0.0);
	    rmSetObjectDefMaxDistance(deer2ID, 0.0);
  	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.81, 0.52);

        int nugget2ID= rmCreateObjectDef("The Nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget2ID, rmClassID("nuggets"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
  	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.82, 0.58);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.88, 0.52);
		
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE STUFFS ON CLIFF NUMBER 3: ******************************* //        
/*================================================================================================================*/

		int tree3ID= rmCreateObjectDef("The Trees 3"); 
	    rmAddObjectDefItem(tree3ID, "TreeYukon", 1.0, 0.0);
		rmSetObjectDefMinDistance(tree3ID, 0.0);
	    rmSetObjectDefMaxDistance(tree3ID, 0.0);
  	    //rmAddObjectDefConstraint(tree3ID, avoidCloseTree);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.15, 0.50);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.15, 0.39);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.11, 0.45);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.20, 0.45);
        rmPlaceObjectDefAtLoc(tree3ID, 0, 0.09, 0.45);
        rmPlaceObjectDefAtLoc(tree3ID, 0, 0.18, 0.45);
        rmPlaceObjectDefAtLoc(tree3ID, 0, 0.15, 0.475);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.15, 0.415);	
		
        int gold3ID= rmCreateObjectDef("The Gold Mine 3"); 
	    rmAddObjectDefItem(gold3ID, "minegold", 1.0, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
	    rmSetObjectDefMaxDistance(gold3ID, 0.0);
  	    rmAddObjectDefConstraint(gold3ID, avoidGold);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.185, 0.485);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.7, 0.3);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.3, 0.7);

        int deer3ID= rmCreateObjectDef("The Deers 3"); 
	    rmAddObjectDefItem(deer3ID, "deer", rmRandInt(5,7), 4.0);
		rmSetObjectDefCreateHerd(deer3ID, true);
		rmSetObjectDefMinDistance(deer3ID, 0.0);
	    rmSetObjectDefMaxDistance(deer3ID, 0.0);
  	    rmAddObjectDefConstraint(deer3ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.115, 0.415);

        int nugget3ID= rmCreateObjectDef("The Nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget3ID, rmClassID("nuggets"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
  	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.125, 0.485);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.175, 0.415);
		
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE STUFFS ON CLIFF NUMBER 4: ******************************* //        
/*================================================================================================================*/

		int tree4ID= rmCreateObjectDef("The Trees 4"); 
	    rmAddObjectDefItem(tree4ID, "TreeYukon", 1.0, 0.0);
		rmSetObjectDefMinDistance(tree4ID, 0.0);
	    rmSetObjectDefMaxDistance(tree4ID, 0.0);
  	    //rmAddObjectDefConstraint(tree4ID, avoidCloseTree);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.45, 0.09);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.45, 0.11);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.45, 0.19);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.45, 0.21);
        rmPlaceObjectDefAtLoc(tree4ID, 0, 0.39, 0.15);
        rmPlaceObjectDefAtLoc(tree4ID, 0, 0.41, 0.15);
        rmPlaceObjectDefAtLoc(tree4ID, 0, 0.49, 0.15);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.51, 0.15);	
		
        int gold4ID= rmCreateObjectDef("The Gold Mine 4"); 
	    rmAddObjectDefItem(gold4ID, "minegold", 1.0, 0.0);
		rmSetObjectDefMinDistance(gold4ID, 0.0);
	    rmSetObjectDefMaxDistance(gold4ID, 0.0);
  	    rmAddObjectDefConstraint(gold4ID, avoidGold);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.49, 0.19);
		
        int deer4ID= rmCreateObjectDef("The Deers 4"); 
	    rmAddObjectDefItem(deer4ID, "deer", rmRandInt(5,7), 4.0);
		rmSetObjectDefCreateHerd(deer4ID, true);
		rmSetObjectDefMinDistance(deer4ID, 0.0);
	    rmSetObjectDefMaxDistance(deer4ID, 0.0);
  	    rmAddObjectDefConstraint(deer4ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer4ID, 0, 0.41, 0.11);

        int nugget4ID= rmCreateObjectDef("The Nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget4ID, rmClassID("nuggets"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
  	    rmAddObjectDefConstraint(nugget4ID, avoidNugget);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.41, 0.19);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.49, 0.11);
			 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE NUGGETS: *************************************** // 
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int nugget5ID= rmCreateObjectDef("The Nugget 5"); 
	    rmAddObjectDefItem(nugget5ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget5ID, rmClassID("nuggets"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget5ID, 0.0);
		rmSetObjectDefMaxDistance(nugget5ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget5ID, avoidFarNugget);
		rmAddObjectDefConstraint(nugget5ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(nugget5ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget5ID, avoidAll);
		rmAddObjectDefConstraint(nugget5ID, avoidCenter);
		rmAddObjectDefConstraint(nugget5ID, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget5ID, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget5ID, Northward);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
				
		int nugget6ID= rmCreateObjectDef("The Nugget 6"); 
	    rmAddObjectDefItem(nugget6ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget6ID, rmClassID("nuggets"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget6ID, 0.0);
		rmSetObjectDefMaxDistance(nugget6ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget6ID, avoidFarNugget);
		rmAddObjectDefConstraint(nugget6ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(nugget6ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget6ID, avoidAll);
		rmAddObjectDefConstraint(nugget6ID, avoidCenter);
		rmAddObjectDefConstraint(nugget6ID, avoidStartingUnits);
		rmAddObjectDefConstraint(nugget6ID, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget6ID, Southward);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
			
		int deer5ID= rmCreateObjectDef("The Deers 5"); 
	    rmAddObjectDefItem(deer5ID, "deer", rmRandInt(5,7), 4.0);
		rmSetObjectDefCreateHerd(deer5ID, true);
		rmSetObjectDefMinDistance(deer5ID, 0.0);
		rmSetObjectDefMaxDistance(deer5ID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(deer5ID, avoidFarDeer);
		rmAddObjectDefConstraint(deer5ID, avoidCloseNugget);
		rmAddObjectDefConstraint(deer5ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(deer5ID, avoidImpassableLand);
		rmAddObjectDefConstraint(deer5ID, avoidAll);
		rmAddObjectDefConstraint(deer5ID, avoidCenter);
		rmAddObjectDefConstraint(deer5ID, avoidStartingUnits);
		rmAddObjectDefConstraint(deer5ID, avoidCloseNatives);
		rmAddObjectDefConstraint(deer5ID, Northward);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(deer5ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(deer5ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		
		int deer6ID= rmCreateObjectDef("The Deers 6"); 
	    rmAddObjectDefItem(deer6ID, "deer", rmRandInt(5,7), 4.0);
		rmSetObjectDefCreateHerd(deer6ID, true);
		rmSetObjectDefMinDistance(deer6ID, 0.0);
		rmSetObjectDefMaxDistance(deer6ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(deer6ID, avoidFarDeer);
		rmAddObjectDefConstraint(deer6ID, avoidCloseNugget);
		rmAddObjectDefConstraint(deer6ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(deer6ID, avoidImpassableLand);
		rmAddObjectDefConstraint(deer6ID, avoidAll);
		rmAddObjectDefConstraint(deer6ID, avoidCenter);
		rmAddObjectDefConstraint(deer6ID, Southward);
		rmAddObjectDefConstraint(deer6ID, avoidStartingUnits);
		rmAddObjectDefConstraint(deer6ID, avoidCloseNatives);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(deer6ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(deer6ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		
		int gold5ID= rmCreateObjectDef("The Gold Mine 5"); 
	    rmAddObjectDefItem(gold5ID, "minegold", 1.0, 0.0);
		rmSetObjectDefMinDistance(gold5ID, 0.0);
		rmSetObjectDefMaxDistance(gold5ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(gold5ID, avoidFarGold);
		rmAddObjectDefConstraint(gold5ID, avoidCloseDeer);
		rmAddObjectDefConstraint(gold5ID, avoidCloseNugget);
		rmAddObjectDefConstraint(gold5ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(gold5ID, avoidImpassableLand);
		rmAddObjectDefConstraint(gold5ID, avoidAll);
		rmAddObjectDefConstraint(gold5ID, avoidCenter);
		rmAddObjectDefConstraint(gold5ID, Northward);
		rmAddObjectDefConstraint(gold5ID, avoidStartingUnits);
		rmAddObjectDefConstraint(gold5ID, avoidCloseNatives);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(gold5ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		
		int gold6ID= rmCreateObjectDef("The Gold Mine 6"); 
	    rmAddObjectDefItem(gold6ID, "minegold", 1.0, 0.0);
		rmSetObjectDefMinDistance(gold6ID, 0.0);
		rmSetObjectDefMaxDistance(gold6ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(gold6ID, avoidFarGold);
		rmAddObjectDefConstraint(gold6ID, avoidCloseDeer);
		rmAddObjectDefConstraint(gold6ID, avoidCloseNugget);
		rmAddObjectDefConstraint(gold6ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(gold6ID, avoidImpassableLand);
		rmAddObjectDefConstraint(gold6ID, avoidAll);
		rmAddObjectDefConstraint(gold6ID, avoidCenter);
		rmAddObjectDefConstraint(gold6ID, Southward);
		rmAddObjectDefConstraint(gold6ID, avoidStartingUnits);
		rmAddObjectDefConstraint(gold6ID, avoidCloseNatives);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(gold6ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(gold6ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
			
		int sheep5ID= rmCreateObjectDef("The Sheep 5"); 
	    rmAddObjectDefItem(sheep5ID, "sheep", rmRandInt(5,7), 6.0);
		rmSetObjectDefMinDistance(sheep5ID, 0.0);
		rmSetObjectDefMaxDistance(sheep5ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(sheep5ID, avoidFarSheep);
	    rmAddObjectDefConstraint(sheep5ID, avoidCloseGold);
		rmAddObjectDefConstraint(sheep5ID, avoidCloseDeer);
		rmAddObjectDefConstraint(sheep5ID, avoidCloseNugget);
		rmAddObjectDefConstraint(sheep5ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(sheep5ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sheep5ID, avoidAll);
		rmAddObjectDefConstraint(sheep5ID, avoidCenter);
		rmAddObjectDefConstraint(sheep5ID, Northward);
		rmAddObjectDefConstraint(sheep5ID, avoidStartingUnits);
		rmAddObjectDefConstraint(sheep5ID, avoidCloseNatives);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(sheep5ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(sheep5ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
				
		int sheep6ID= rmCreateObjectDef("The Sheep 6"); 
	    rmAddObjectDefItem(sheep6ID, "sheep", rmRandInt(5,7), 6.0);
		rmSetObjectDefMinDistance(sheep6ID, 0.0);
		rmSetObjectDefMaxDistance(sheep6ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(sheep6ID, avoidFarSheep);
	    rmAddObjectDefConstraint(sheep6ID, avoidCloseGold);
		rmAddObjectDefConstraint(sheep6ID, avoidCloseDeer);
		rmAddObjectDefConstraint(sheep6ID, avoidCloseNugget);
		rmAddObjectDefConstraint(sheep6ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(sheep6ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sheep6ID, avoidAll);
		rmAddObjectDefConstraint(sheep6ID, avoidCenter);
		rmAddObjectDefConstraint(sheep6ID, Southward);
		rmAddObjectDefConstraint(sheep6ID, avoidStartingUnits);
		rmAddObjectDefConstraint(sheep6ID, avoidCloseNatives);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(sheep6ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(sheep6ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE RANDOM BERRYBUSH: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int berries6ID= rmCreateObjectDef("Random Berries 6"); 
	    rmAddObjectDefItem(berries6ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries6ID, 0.0);
		rmSetObjectDefMaxDistance(berries6ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(berries6ID, avoidFarSheep);
	    rmAddObjectDefConstraint(berries6ID, avoidCloseGold);
		rmAddObjectDefConstraint(berries6ID, avoidCloseDeer);
		rmAddObjectDefConstraint(berries6ID, avoidCloseNugget);
		rmAddObjectDefConstraint(berries6ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(berries6ID, avoidImpassableLand);
		rmAddObjectDefConstraint(berries6ID, avoidAll);
		rmAddObjectDefConstraint(berries6ID, avoidCenter);
		rmAddObjectDefConstraint(berries6ID, Northward);
		rmAddObjectDefConstraint(berries6ID, avoidStartingUnits);
		rmAddObjectDefConstraint(berries6ID, avoidFarFruits);
		rmAddObjectDefConstraint(berries6ID, avoidCloseNatives);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(berries6ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(berries6ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
/*----------------------------------------------------------------------------------------------------------------*/
        int berries7ID= rmCreateObjectDef("Random Berries 7"); 
	    rmAddObjectDefItem(berries7ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries7ID, 0.0);
		rmSetObjectDefMaxDistance(berries7ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(berries7ID, avoidFarSheep);
	    rmAddObjectDefConstraint(berries7ID, avoidCloseGold);
		rmAddObjectDefConstraint(berries7ID, avoidCloseDeer);
		rmAddObjectDefConstraint(berries7ID, avoidCloseNugget);
		rmAddObjectDefConstraint(berries7ID, avoidCloseCanyons);
		rmAddObjectDefConstraint(berries7ID, avoidImpassableLand);
		rmAddObjectDefConstraint(berries7ID, avoidAll);
		rmAddObjectDefConstraint(berries7ID, avoidCenter);
		rmAddObjectDefConstraint(berries7ID, Southward);
		rmAddObjectDefConstraint(berries7ID, avoidStartingUnits);
		rmAddObjectDefConstraint(berries7ID, avoidFarFruits);
		rmAddObjectDefConstraint(berries7ID, avoidCloseNatives);
		
		if(cNumberNonGaiaPlayers == 2)  
		rmPlaceObjectDefAtLoc(berries7ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
        else
        rmPlaceObjectDefAtLoc(berries7ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);				
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ******************************** RESOURCES THAT CAN BE PLACED AFTER FOREST: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE FORESTS:
        //ABC NEED TO BE SCATTERED BETWEEN ALL THE PLAYERS:
        int forestTreeID = 0;
		if(cNumberNonGaiaPlayers == 2)
		numTries=12*cNumberNonGaiaPlayers;
		else
		numTries=8*cNumberNonGaiaPlayers;
        failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/        
		for (i=0; <numTries)
    {   
        int forest=rmCreateArea("forest 1"+i);
        rmSetAreaWarnFailure(forest, false);
		
		if(cNumberNonGaiaPlayers == 2)		
        rmSetAreaSize(forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
		else
		rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
        
		rmSetAreaForestType(forest, "yukon snow forest");
        rmSetAreaForestDensity(forest, 0.8);
        rmSetAreaForestClumpiness(forest, 0.6);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 1);
        rmSetAreaMinBlobDistance(forest, 1.0);
        rmSetAreaMaxBlobDistance(forest, 1.0);
        rmSetAreaCoherence(forest, 0.8);
        rmSetAreaSmoothDistance(forest, 10);
	    rmAddAreaToClass(forest, rmClassID("classForest"));
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidCloseImpassableLand); 
		rmAddAreaConstraint(forest, avoidCloseNatives);
        //rmAddAreaConstraint(forest, avoidCloseCanyons); 		
        //rmAddAreaConstraint(forest, avoidTradeRoute);
		//rmAddAreaConstraint(forest, avoidSocket);
		rmAddAreaConstraint(forest, avoidCenter);
		rmAddAreaConstraint(forest, avoidStartingUnits);
		rmAddAreaConstraint(forest, avoidNugget);
		rmAddAreaConstraint(forest, avoidImportantItem);
		rmAddAreaConstraint(forest, Northward);
		
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==6)
        break;
      }
        else
        failCount=0; 
    } 
	
/*================================================================================================================*/

        for (i=0; <numTries)
    {   
        int forest2=rmCreateArea("forest 2"+i);
        rmSetAreaWarnFailure(forest2, false);
		
		if(cNumberNonGaiaPlayers == 2)		
        rmSetAreaSize(forest2, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
		else
		rmSetAreaSize(forest2, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
        
		rmSetAreaForestType(forest2, "yukon snow forest");
        rmSetAreaForestDensity(forest2, 0.8);
        rmSetAreaForestClumpiness(forest2, 0.6);
        rmSetAreaForestUnderbrush(forest2, 0.0);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 1);
        rmSetAreaMinBlobDistance(forest2, 1.0);
        rmSetAreaMaxBlobDistance(forest2, 1.0);
        rmSetAreaCoherence(forest2, 0.8);
        rmSetAreaSmoothDistance(forest2, 10);
	    rmAddAreaToClass(forest2, rmClassID("classForest"));
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidCloseImpassableLand); 
		rmAddAreaConstraint(forest2, avoidCloseNatives);
        //rmAddAreaConstraint(forest2, avoidCloseCanyons); 		
        //rmAddAreaConstraint(forest2, avoidTradeRoute);
		//rmAddAreaConstraint(forest2, avoidSocket);
		rmAddAreaConstraint(forest2, avoidCenter);
		rmAddAreaConstraint(forest2, avoidStartingUnits);
		rmAddAreaConstraint(forest2, avoidNugget);
		rmAddAreaConstraint(forest2, avoidImportantItem);
		rmAddAreaConstraint(forest2, Southward);
		

        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==6)
        break;
      }
        else
        failCount=0; 
    }
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		
		if(cNumberNonGaiaPlayers == 2)
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 7.5*cNumberNonGaiaPlayers);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE FAST COIN -- WHALES: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/	 

	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "beluga", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        //rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(whaleID, 0.0);
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        //rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.45, 0.55);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.55, 0.45);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.45, 0.45);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.55, 0.55);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
// ****************************************** THIS IS THE END OF THE MAP: *************************************** //
/*================================================================================================================*/
}  
/*================================================================================================================*/










































