/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// LIMAY RIVER:
// CREATED BY DANY:
// OCTOBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// *********************************** ONLY TWO NATIVES APPEAR ON THIS MAP: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
	
/*----------------------------------------------------------------------------------------------------------------*/
		
        int whichVariation=-1;
	    whichVariation = rmRandInt(1,2);

/*----------------------------------------------------------------------------------------------------------------*/

       int whichNative=rmRandInt(1,3);
		
	    if ( whichNative == 1 )
	{
		subCiv0=rmGetCivID("Aztecs");
		rmEchoInfo("subCiv0 is Aztecs "+subCiv0);

		subCiv1=rmGetCivID("Aztecs");
		rmEchoInfo("subCiv1 is Aztecs "+subCiv1);
				
	}
	    else if ( whichNative == 2 )
	{
		subCiv0=rmGetCivID("Incas");
		rmEchoInfo("subCiv0 is Incas "+subCiv0);

		subCiv1=rmGetCivID("Incas");
		rmEchoInfo("subCiv1 is Incas "+subCiv1);
				
	}
	    else
	{	
		subCiv0=rmGetCivID("Incas");
		rmEchoInfo("subCiv0 is Incas "+subCiv0);

		subCiv1=rmGetCivID("Incas");
		rmEchoInfo("subCiv1 is Incas "+subCiv1);
	}	
		
	    rmSetSubCiv(0, "Incas", true);
	    rmSetSubCiv(1, "Aztecs", true);
		rmSetSubCiv(2, "Maya", true);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/

   	    int playerTiles = 22500;
	    
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(600, 600);
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(1.0);

        // SET MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	   	rmSetMapElevationParameters(cElevTurbulence, 0.04, 4, 0.4, 6.0);
        
		// SET SEA TYPE:
		rmSetSeaType("hudson bay");
 	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("patagonia_grass");
		
		// MAP INITIALIZATION:
        rmTerrainInitialize("water");
	    
		// SET MAP TYPE:
		rmSetMapType("patagonia");
	    rmSetMapType("water");
		rmSetMapType("grass");
	    
		// SET LIGHTING:
		rmSetLightingSet("patagonia");
		
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2);

	    // MAKE IT RAIN:
        rmSetGlobalRain( 0.7 );
		
		// CHOOSE THE MERCS:
		chooseMercs();
		
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
        
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ******************************************** DEFINE SOME CLASSES: ******************************************** //
// *********************************** THESE ARE USED LATER FOR CONSTRAINTS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("classCliff");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
        int classIsland=rmDefineClass("island");
        int classTeamIsland=rmDefineClass("teamIsland");
		rmDefineClass("classSocket");
		rmDefineClass("classTrees");
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
        
        // CARDINAL DIRECTIONS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.55, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.45, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.45, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.55, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stuff avoids players", classPlayer, 15.0);
        int playerCloseConstraint=rmCreateClassDistanceConstraint("close avoids players", classPlayer, 8.0);
        		
		// FLAG AVOIDANCE:
		int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 20.0);
        int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 10.0);
        int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
        int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-180, rmGetMapXSize()-40, 0, 0, 0);
        
		// ISLAND AVOIDANCE:
		int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 55.0);
 
        // NATURE AVOIDANCE:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
        
		// FOREST AVOIDANCE:
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 30.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 8.0);
        
		// RESOURCE AVOIDANCE:
		int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
		
		// Unit avoidance
	    int avoidStartingUnits=rmCreateClassDistanceConstraint("stuff avoid starting units", rmClassID("startingUnit"), 15.0);
	    int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close avoid starting units small", rmClassID("startingUnit"), 8.0);
        int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium avoid starting units", rmClassID("startingUnit"), 30.0);
		
		// COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 15.0);
        int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "gold", 8.0);
		int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "gold", 30.0);
		int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "gold", 60.0);
		int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoid coin", "gold", 90.0);
		
		// TREES AVOIDANCE:
	    int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 15.0);
	    int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 8.0);
	    int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 3.0);
	    int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
	    int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
	    int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
		
		// TAPIR AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("avoid deer", "deer", 15.0);
        int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoid deer", "deer", 8.0);
		int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoid deer", "deer", 30.0);
		int avoidFarDeer=rmCreateTypeDistanceConstraint("far avoid deer", "deer", 60.0);
		int avoidVeryFarDeer=rmCreateTypeDistanceConstraint("very far avoid deer", "deer", 90.0);
		
		// CAPYBARA AVOIDANCE:
		int avoidRhea=rmCreateTypeDistanceConstraint("avoid rhea", "rhea", 15.0);
        int avoidCloseRhea=rmCreateTypeDistanceConstraint("close avoid rhea", "rhea", 8.0);
		int avoidMediumRhea=rmCreateTypeDistanceConstraint("medium avoid rhea", "rhea", 30.0);
		int avoidFarRhea=rmCreateTypeDistanceConstraint("far avoid rhea", "rhea", 60.0);
		int avoidVeryFarRhea=rmCreateTypeDistanceConstraint("very far avoid rhea", "rhea", 90.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("avoid fruits", "berrybush", 15.0);
        int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 8.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid fruits", "berrybush", 30.0);
				
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 15.0);
        int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 8.0);
		int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium avoid nugget", "AbstractNugget", 30.0);
        int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 60.0);
    
        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 15.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        int mediumShortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("mediumshort avoid impassable land", "Land", false, 10.0);
        int mediumAvoidImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 12.0);
        int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 25.0);
        
		// CONSTRAINT TO AVOID WATER:
        int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 10.0);
		int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water medium15", "Land", false, 15.0);
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water large", "Land", false, 20.0);
        int ferryOnShore=rmCreateTerrainMaxDistanceConstraint("ferry v. water", "water", true, 12.0);

        // UNIT AVOIDANCE:
        int avoidImportantItem=rmCreateClassDistanceConstraint("avoid natives, secrets", rmClassID("importantItem"), 30.0);
        int farAvoidImportantItem=rmCreateClassDistanceConstraint("secrets avoid each other by a lot", rmClassID("importantItem"), 50.0);
        int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 15.0);
        int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 20.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 8.0);
        
		// DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
        
		// CLIFF AVOIDANCE:
		int avoidCliff=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);

        // TRADE ROUTE AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 15.0);
        int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 8.0);
        
		int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 15.0);
		
		// SOCKETS AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("stuff avoids socket", rmClassID("classSocket"), 15.0);
	    int avoidCloseSocket=rmCreateClassDistanceConstraint("close avoids socket", rmClassID("classSocket"), 8.0);
	   
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** //	
/*================================================================================================================*/

	    if ( whichVariation == 1 )
	{
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.65, 0.85, 0.85, 0.65, 0.0, 0.0);
		
		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.35, 0.15, 0.15, 0.35, 0.0, 0.0);
	}
	    else
	{
	   rmSetPlacementTeam(0);
	   rmPlacePlayersLine(0.35, 0.15, 0.15, 0.35, 0.0, 0.0); 
	   
	   rmSetPlacementTeam(1);
	   rmPlacePlayersLine(0.65, 0.85, 0.85, 0.65, 0.0, 0.0);
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// ************************************ MAKE AREAS FOR THE MAIN 2 ISLANDS: ************************************** //
// ************************************ KINDA HACKY I GUESS, BUT IT WORKS: ************************************** //
/*================================================================================================================*/

        int northIslandID = rmCreateArea("north island");
        int areaSizerNum = rmRandInt(1,10);
        float areaSizer = 0.33; 
        if (areaSizerNum > 6)
	    areaSizer = 0.38;
        rmEchoInfo("Island size "+areaSizer);
		
/*----------------------------------------------------------------------------------------------------------------*/		
   
        // BUILD AN INVISIBLE NORTH ISLAND AREA:
        //rmSetAreaLocation(northIslandID, 0.75, 0.75);
        rmSetAreaLocation(northIslandID, 1, 1);
        rmSetAreaMix(northIslandID, "caribbean grass");
        //rmSetAreaSize(northIslandID, 0.5, 0.5);
        rmSetAreaCoherence(northIslandID, 1.0);
        //rmAddAreaConstraint(northIslandID, avoidWater4);
        //rmSetAreaSize(northIslandID, isleSize, isleSize);
	    rmSetAreaSize(northIslandID, areaSizer, areaSizer);
        rmSetAreaMinBlobs(northIslandID, 10);
        rmSetAreaMaxBlobs(northIslandID, 15);
        rmSetAreaMinBlobDistance(northIslandID, 8.0);
        rmSetAreaMaxBlobDistance(northIslandID, 10.0);
        rmSetAreaCoherence(northIslandID, 0.60);
        rmSetAreaBaseHeight(northIslandID, 3.0);
        rmSetAreaSmoothDistance(northIslandID, 20);
		rmSetAreaMix(northIslandID, "patagonia_grass");
        rmAddAreaToClass(northIslandID, classIsland);
        rmAddAreaConstraint(northIslandID, islandConstraint);
        rmSetAreaObeyWorldCircleConstraint(northIslandID, false);
		//rmSetAreaEdgeFilling(northIslandID, 5);
        rmSetAreaElevationType(northIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(northIslandID, 3.0);
        rmSetAreaElevationMinFrequency(northIslandID, 0.09);
        rmSetAreaElevationOctaves(northIslandID, 3);
        rmSetAreaElevationPersistence(northIslandID, 0.2);
		rmSetAreaElevationNoiseBias(northIslandID, 1);
        rmSetAreaWarnFailure(northIslandID, false);
        //rmBuildArea(northIslandID);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // BUILD AN INVISIBLE SOUTH ISLAND AREA:
   
        int southIslandID = rmCreateArea("south island");
        //rmSetAreaLocation(southIslandID, 0.25, 0.25);
        rmSetAreaLocation(southIslandID, 0, 0);
        rmSetAreaMix(southIslandID, "caribbean grass");
        // rmSetAreaSize(southIslandID, 0.5, 0.5);
        rmSetAreaCoherence(southIslandID, 1.0);
        //rmAddAreaConstraint(southIslandID, avoidWater4);
        rmSetAreaSize(southIslandID, areaSizer, areaSizer);
        rmSetAreaMinBlobs(southIslandID, 10);
        rmSetAreaMaxBlobs(southIslandID, 15);
        rmSetAreaMinBlobDistance(southIslandID, 8.0);
        rmSetAreaMaxBlobDistance(southIslandID, 10.0);
        rmSetAreaCoherence(southIslandID, 0.60);
        rmSetAreaBaseHeight(southIslandID, 3.0);
        rmSetAreaSmoothDistance(southIslandID, 20);
		rmSetAreaMix(southIslandID, "patagonia_grass");
        rmAddAreaToClass(southIslandID, classIsland);
        rmAddAreaConstraint(southIslandID, islandConstraint);
        rmSetAreaObeyWorldCircleConstraint(southIslandID, false);
		//rmSetAreaEdgeFilling(southIslandID, 5);
        rmSetAreaElevationType(southIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(southIslandID, 3.0);
        rmSetAreaElevationMinFrequency(southIslandID, 0.09);
        rmSetAreaElevationOctaves(southIslandID, 3);
        rmSetAreaElevationPersistence(southIslandID, 0.2);
		rmSetAreaElevationNoiseBias(southIslandID, 1);
        rmSetAreaWarnFailure(southIslandID, false);
        //rmBuildArea(southIslandID);

        rmBuildAllAreas();
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // ADD ISLAND CONSTRAINTS:
        int northIslandConstraint=rmCreateAreaConstraint("north Island", northIslandID);
        int southIslandConstraint=rmCreateAreaConstraint("south Island", southIslandID);
		
/*================================================================================================================*/		
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(1750);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		// rmAddAreaConstraint(id, playerConstraint); 
        // rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
	
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "texas_dirt");
		
		//rmSetAreaMix(id, "rockies_grass");
	
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
	
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");
    
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   

// PLACEMENT ORDER:
// TRADE ROUTE -> RIVER (NONE ON THIS MAP) -> NATIVES -> SECRETS -> CLIFFS -> NUGGETS:

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE THE TRADE ROUTES AND SOCKETS: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // SOCKET DEFINITION:
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 1:
		int tradeRoute1ID = rmCreateTradeRoute();
	    rmAddTradeRouteWaypoint(tradeRoute1ID, 0.5, 0.975);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.5, 0.75);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.75, 0.5);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.975, 0.5);
	
	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

/*----------------------------------------------------------------------------------------------------------------*/		

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.285);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.70);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.975);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 2:
		int tradeRoute2ID = rmCreateTradeRoute();
	    rmAddTradeRouteWaypoint(tradeRoute2ID, 0.025, 0.50);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.25, 0.50);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.50, 0.25);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.50, 0.025);

	    bool placedTradeRoute2 = rmBuildTradeRoute(tradeRoute2ID, "dirt");
	    if(placedTradeRoute2 == false)
		rmEchoError("Failed to place trade route 2");
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);
	    vector socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);
	
    	socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.325);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);

		socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.675);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);
		
	    socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.975);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ***************** DEFINE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: **************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
        
		// DEFINE THE TCFLOAT:
		int TCfloat = -1;
        if (cNumberTeams == 2)
	    TCfloat = 10.0;
        else 
	    TCfloat = 10.0;

	    // DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);

	}
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, TCfloat);
		rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));

	    rmAddObjectDefConstraint(TCID, avoidTradeRouteFar);
	    rmAddObjectDefConstraint(TCID, avoidTownCenter);
	    rmAddObjectDefConstraint(TCID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(TCID, mediumShortAvoidImpassableLand);
	    //rmPlaceObjectDefPerPlayer(TCID, true);
		
		// DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
		rmAddObjectDefConstraint(startingUnits, avoidCloseStartingUnits);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    //VARIABLE FOR THE WATER HC ARRIVAL POINT:
        int waterFlagID = 0;
   
        // DEFINE THE WATER FLAG:
		for(i=1; <cNumberPlayers)
    {
        waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
	}  
        
		// DEFINE THE PLAYER SILVER:
	    int playerSilverID = rmCreateObjectDef("player mine");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
		rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmAddObjectDefConstraint(playerSilverID, avoidTownCenter);
	    rmSetObjectDefMinDistance(playerSilverID, 10.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 25.0);
        rmAddObjectDefConstraint(playerSilverID, avoidCloseStartingUnits);

	    // DEFINE THE PLAYER DEER:
		int playerDeerID=rmCreateObjectDef("player deer");
        rmAddObjectDefItem(playerDeerID, "deer", rmRandInt(2,3), 4.0);
		rmAddObjectDefToClass(playerDeerID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerDeerID, 12);
        rmSetObjectDefMaxDistance(playerDeerID, 18);
	    rmAddObjectDefConstraint(playerDeerID, avoidAll);
        rmAddObjectDefConstraint(playerDeerID, avoidCloseStartingUnits);
        rmSetObjectDefCreateHerd(playerDeerID, true);
		
		// DEFINE THE PLAYER BERRYBUSH:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berrybush", rmRandInt(3,5), 5.0);
		rmAddObjectDefToClass(playerBerryID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerBerryID, 20);
        rmSetObjectDefMaxDistance(playerBerryID, 25);
	    rmAddObjectDefConstraint(playerBerryID, avoidAll);
		rmAddObjectDefConstraint(playerBerryID, avoidMediumFruits);
        rmAddObjectDefConstraint(playerBerryID, avoidCloseStartingUnits);
        rmSetObjectDefCreateHerd(playerBerryID, true);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreePatagoniaDirt", rmRandInt(7,10), 6.0);
		rmAddObjectDefToClass(playerTreeID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerTreeID, 26);
        rmSetObjectDefMaxDistance(playerTreeID, 29);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, avoidCloseStartingUnits);
		
		// DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    //rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 31.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 33.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnits);
	    rmAddObjectDefConstraint(playerNuggetID, avoidMediumNugget);
	
/*================================================================================================================*/	
// ***************** PLACE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: ***************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    for(i=1; <cNumberPlayers)
   {
	    // PLACE THE TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER TREE:
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	   
		// PLACE THE PLAYER DEER:
		rmPlaceObjectDefAtLoc(playerDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		// PLACE THE PLAYER BERRYBUSH:
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
	    // Player nuggets
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// VECTOR CLOSEST POINT:
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	    
		// PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	
   }
        // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
     
        int aztecVillageAID = -1;
        int aztecVillageType = rmRandInt(1,3);
        
		if ( whichNative ==  1 )
   {
		aztecVillageAID = rmCreateGrouping("aztec village A", "native aztec village "+aztecVillageType);
   }
        else if ( whichNative == 2 )
   {
	   	aztecVillageAID = rmCreateGrouping("inca village A", "native inca village "+aztecVillageType);
   }
        else
	{	
		aztecVillageAID = rmCreateGrouping("maya village A", "native maya village "+aztecVillageType);
	}	
		
		rmSetGroupingMinDistance(aztecVillageAID, 0.0);
        rmSetGroupingMaxDistance(aztecVillageAID, 0.0);
        rmAddGroupingToClass(aztecVillageAID, rmClassID("natives"));
        
		rmPlaceGroupingAtLoc(aztecVillageAID, 0, 0.70, 0.70); 
		
/*----------------------------------------------------------------------------------------------------------------*/		
	
	    int aztecVillageBID = -1;
	    aztecVillageType = rmRandInt(1,3);
	    
		if ( whichNative == 1 )
	{
		aztecVillageBID = rmCreateGrouping("aztec village B", "native aztec village "+aztecVillageType);
	}
	    else if ( whichNative == 2 )
    {
	   	aztecVillageBID = rmCreateGrouping("inca village B", "native inca village "+aztecVillageType);
    }
	    else
	{
		aztecVillageBID = rmCreateGrouping("maya village B", "native maya village "+aztecVillageType);
	}
	    
		rmSetGroupingMinDistance(aztecVillageBID, 0.0);
	    rmSetGroupingMaxDistance(aztecVillageBID, 0.0);
	    rmAddGroupingToClass(aztecVillageBID, rmClassID("natives"));
	    
	    rmPlaceGroupingAtLoc(aztecVillageBID, 0, 0.30, 0.30);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// *********************************** DEFINE SOME VARIABLES NEEDED LATER: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int numTries = -1;
        int failCount = -1;

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// **************************** DEFINE AND PLACE NUGGETS ON BOTH SIDES OF THE RIVER: **************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int southNugget1= rmCreateObjectDef("south nugget easy"); 
	    rmAddObjectDefItem(southNugget1, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(southNugget1, 0.0);
	    rmSetObjectDefMaxDistance(southNugget1, rmXFractionToMeters(0.5));
	    rmSetNuggetDifficulty(1, 1);
	    
		rmAddObjectDefConstraint(southNugget1, avoidImpassableLand);
  	    rmAddObjectDefConstraint(southNugget1, avoidFarNugget);
  	    rmAddObjectDefConstraint(southNugget1, avoidTradeRoute);
		rmAddObjectDefConstraint(southNugget1, avoidCloseSocket);
  	    rmAddObjectDefConstraint(southNugget1, avoidAll);
		rmAddObjectDefConstraint(southNugget1, avoidCloseNatives);
		rmAddObjectDefConstraint(southNugget1, playerConstraint);
	    rmAddObjectDefConstraint(southNugget1, avoidWater20);
	    rmAddObjectDefConstraint(southNugget1, southIslandConstraint);
	    rmAddObjectDefConstraint(southNugget1, playerEdgeConstraint);
	    
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(southNugget1, 0, 0.5, 0.5, 2.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(southNugget1, 0, 0.5, 0.5, 1.25*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
	    int northNugget1= rmCreateObjectDef("north nugget easy"); 
	    rmAddObjectDefItem(northNugget1, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(northNugget1, 0.0);
	    rmSetObjectDefMaxDistance(northNugget1, rmXFractionToMeters(0.5));
	    rmSetNuggetDifficulty(1, 1);
	    
		rmAddObjectDefConstraint(northNugget1, avoidImpassableLand);
  	    rmAddObjectDefConstraint(northNugget1, avoidFarNugget);
  	    rmAddObjectDefConstraint(northNugget1, avoidTradeRoute);
		rmAddObjectDefConstraint(northNugget1, avoidCloseSocket);
  	    rmAddObjectDefConstraint(northNugget1, avoidAll);
		rmAddObjectDefConstraint(northNugget1, avoidCloseNatives);
		rmAddObjectDefConstraint(northNugget1, playerConstraint);
	    rmAddObjectDefConstraint(northNugget1, avoidWater20);
	    rmAddObjectDefConstraint(northNugget1, northIslandConstraint);
	    rmAddObjectDefConstraint(northNugget1, playerEdgeConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(northNugget1, 0, 0.5, 0.5, 2.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(northNugget1, 0, 0.5, 0.5, 1.25*cNumberNonGaiaPlayers);
	    
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE SOME FISHES: **************************************** //	   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 7.5*cNumberNonGaiaPlayers);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/   
// ************************** DEFINE AND PLACE THE NORTH AND THE SOUTH SILVER MINES: **************************** //    
/*================================================================================================================*/		

	    // THE SOUTH SILVER MINES:
		
	    int southSilverID = rmCreateObjectDef("south silver");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(southSilverID, "mine", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(southSilverID, "minegold", 1, 0.0);
	}	
	    
        rmSetObjectDefMinDistance(southSilverID, 0.0);
        rmSetObjectDefMaxDistance(southSilverID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(southSilverID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(southSilverID, avoidAll);
		rmAddObjectDefConstraint(southSilverID, avoidNugget);
		rmAddObjectDefConstraint(southSilverID, playerEdgeConstraint);
		rmAddObjectDefConstraint(southSilverID, playerConstraint);
		rmAddObjectDefConstraint(southSilverID, avoidWater20);
        rmAddObjectDefConstraint(southSilverID, avoidCloseNatives);
	    rmAddObjectDefConstraint(southSilverID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(southSilverID, avoidCloseSocket);
        rmAddObjectDefConstraint(southSilverID, avoidImpassableLand);
        rmAddObjectDefConstraint(southSilverID, southIslandConstraint);
	    
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(southSilverID, 0, 0.5, 0.5, 2.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(southSilverID, 0, 0.5, 0.5, 1.25*cNumberNonGaiaPlayers);

/*----------------------------------------------------------------------------------------------------------------*/   
        
		// THE SOUTH SILVER MINES:
		
	    int northSilverID = rmCreateObjectDef("north silver");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(northSilverID, "mine", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(northSilverID, "minegold", 1, 0.0);
	}	
	    
        rmSetObjectDefMinDistance(northSilverID, 0.0);
        rmSetObjectDefMaxDistance(northSilverID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(northSilverID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(northSilverID, avoidAll);
		rmAddObjectDefConstraint(northSilverID, avoidNugget);
		rmAddObjectDefConstraint(northSilverID, playerEdgeConstraint);
		rmAddObjectDefConstraint(northSilverID, playerConstraint);
		rmAddObjectDefConstraint(northSilverID, avoidWater20);
        rmAddObjectDefConstraint(northSilverID, avoidCloseNatives);
	    rmAddObjectDefConstraint(northSilverID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(northSilverID, avoidCloseSocket);
        rmAddObjectDefConstraint(northSilverID, avoidImpassableLand);
        rmAddObjectDefConstraint(northSilverID, northIslandConstraint);
	    
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(northSilverID, 0, 0.5, 0.5, 2.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(northSilverID, 0, 0.5, 0.5, 1.25*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE FORESTS: ******************************************* //
/*================================================================================================================*/ 		
        
		//ABC NEED TO BE SCATTERED BETWEEN THE TWO RIVERBANKS:
        int forestTreeID = 0;
		
		if (cNumberNonGaiaPlayers <= 2)
        numTries=16*cNumberNonGaiaPlayers;
		else
		numTries=8*cNumberNonGaiaPlayers;
        
		failCount=0;
        
		for (i=0; <numTries)
{   
        int forest=rmCreateArea("forest"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(125), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forest, "patagonia forest");
        rmSetAreaForestDensity(forest, 0.8);
        rmSetAreaForestClumpiness(forest, 0.6);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 6);
        rmSetAreaMaxBlobs(forest, 15);
        rmSetAreaMinBlobDistance(forest, 16.0);
        rmSetAreaMaxBlobDistance(forest, 25.0);
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 10);
	    rmAddAreaToClass(forest, rmClassID("classForest"));
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, forestObjConstraint);
        rmAddAreaConstraint(forest, shortAvoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest, avoidCloseSocket);
		rmAddAreaConstraint(forest, playerConstraint);
		rmAddAreaConstraint(forest, playerEdgeConstraint);
		rmAddAreaConstraint(forest, avoidCloseCoin);
		rmAddAreaConstraint(forest, avoidCloseNugget);
		rmAddAreaConstraint(forest, avoidWater10);
		rmAddAreaConstraint(forest, avoidCloseNatives);

        if(rmBuildArea(forest)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==6)
        break;
    }
        else
        failCount=0; 
} 
 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE NORTH AND SOUTH TAPIRS: ******************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
		
		int deerCount = rmRandInt(3,6);
	    int rheaCount = rmRandInt(9,12);
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // THE NORTH TAPIR:
		int deerNID=rmCreateObjectDef("north deer crash");
        rmAddObjectDefItem(deerNID, "deer", deerCount, 2.0);
        rmSetObjectDefMinDistance(deerNID, 0.0);
        rmSetObjectDefMaxDistance(deerNID, rmXFractionToMeters(0.4));
        rmAddObjectDefConstraint(deerNID, avoidImpassableLand);
		rmAddObjectDefConstraint(deerNID, playerConstraint);
		rmAddObjectDefConstraint(deerNID, avoidCloseNatives);
		rmAddObjectDefConstraint(deerNID, avoidWater10);
		rmAddObjectDefConstraint(deerNID, avoidCloseNugget);
		rmAddObjectDefConstraint(deerNID, avoidCloseCoin);
		rmAddObjectDefConstraint(deerNID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(deerNID, avoidCloseSocket);
		rmAddObjectDefConstraint(deerNID, forestCloseConstraint);
		rmAddObjectDefConstraint(deerNID, avoidFarDeer);
        rmAddObjectDefConstraint(deerNID, northIslandConstraint);
        rmSetObjectDefCreateHerd(deerNID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deerNID, 0, 0.5, 0.5, 2.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(deerNID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // THE SOUTH TAPIR:
		int deerSID=rmCreateObjectDef("south deer crash");
        rmAddObjectDefItem(deerSID, "deer", deerCount, 2.0);
        rmSetObjectDefMinDistance(deerSID, 0.0);
        rmSetObjectDefMaxDistance(deerSID, rmXFractionToMeters(0.4));
        rmAddObjectDefConstraint(deerSID, avoidImpassableLand);
		rmAddObjectDefConstraint(deerSID, playerConstraint);
		rmAddObjectDefConstraint(deerSID, avoidCloseNatives);
		rmAddObjectDefConstraint(deerSID, avoidWater10);
		rmAddObjectDefConstraint(deerSID, avoidCloseNugget);
		rmAddObjectDefConstraint(deerSID, avoidCloseCoin);
		rmAddObjectDefConstraint(deerSID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(deerSID, avoidCloseSocket);
		rmAddObjectDefConstraint(deerSID, forestCloseConstraint);
		rmAddObjectDefConstraint(deerSID, avoidFarDeer);
        rmAddObjectDefConstraint(deerSID, southIslandConstraint);
        rmSetObjectDefCreateHerd(deerSID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deerSID, 0, 0.5, 0.5, 2.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(deerSID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ****************************** DEFINE AND PLACE THE NORTH AND SOUTH CAPYBARAS: ******************************* //	
/*================================================================================================================*/

	    // THE NORTH RHEA:
		int rheaNID=rmCreateObjectDef("north rhea crash");
        rmAddObjectDefItem(rheaNID, "rhea", rheaCount, 2.0);
        rmSetObjectDefMinDistance(rheaNID, 0.0);
        rmSetObjectDefMaxDistance(rheaNID, rmXFractionToMeters(0.4));
        rmAddObjectDefConstraint(rheaNID, avoidImpassableLand);
		rmAddObjectDefConstraint(rheaNID, playerConstraint);
		rmAddObjectDefConstraint(rheaNID, avoidCloseNatives);
		rmAddObjectDefConstraint(rheaNID, avoidWater10);
		rmAddObjectDefConstraint(rheaNID, avoidCloseNugget);
		rmAddObjectDefConstraint(rheaNID, avoidCloseCoin);
		rmAddObjectDefConstraint(rheaNID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(rheaNID, avoidCloseSocket);
		rmAddObjectDefConstraint(rheaNID, forestCloseConstraint);
		rmAddObjectDefConstraint(rheaNID, avoidFarDeer);
		rmAddObjectDefConstraint(rheaNID, avoidFarRhea);
        rmAddObjectDefConstraint(rheaNID, northIslandConstraint);
        rmSetObjectDefCreateHerd(rheaNID, true);
		
		if (cNumberNonGaiaPlayers<=2)
        rmPlaceObjectDefAtLoc(rheaNID, 0, 0.5, 0.5, (2.5*cNumberNonGaiaPlayers));
		else
		rmPlaceObjectDefAtLoc(rheaNID, 0, 0.5, 0.5, (1.25*cNumberNonGaiaPlayers));

/*----------------------------------------------------------------------------------------------------------------*/
		
	    // THE SOUTH RHEA:
		int rheaSID=rmCreateObjectDef("south rhea crash");
        rmAddObjectDefItem(rheaSID, "rhea", rheaCount, 2.0);
        rmSetObjectDefMinDistance(rheaSID, 0.0);
        rmSetObjectDefMaxDistance(rheaSID, rmXFractionToMeters(0.4));
        rmAddObjectDefConstraint(rheaSID, avoidImpassableLand);
		rmAddObjectDefConstraint(rheaSID, playerConstraint);
		rmAddObjectDefConstraint(rheaSID, avoidCloseNatives);
		rmAddObjectDefConstraint(rheaSID, avoidWater10);
		rmAddObjectDefConstraint(rheaSID, avoidCloseNugget);
		rmAddObjectDefConstraint(rheaSID, avoidCloseCoin);
		rmAddObjectDefConstraint(rheaSID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(rheaSID, avoidCloseSocket);
		rmAddObjectDefConstraint(rheaSID, forestCloseConstraint);
		rmAddObjectDefConstraint(rheaSID, avoidFarDeer);
		rmAddObjectDefConstraint(rheaSID, avoidFarRhea);
        rmAddObjectDefConstraint(rheaSID, southIslandConstraint);
        rmSetObjectDefCreateHerd(rheaSID, true);
		
		if (cNumberNonGaiaPlayers<=2)
        rmPlaceObjectDefAtLoc(rheaSID, 0, 0.5, 0.5, (2.5*cNumberNonGaiaPlayers));
		else
		rmPlaceObjectDefAtLoc(rheaSID, 0, 0.5, 0.5, (1.25*cNumberNonGaiaPlayers));
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE NORTH ISLAND:
		int randomTreeID=rmCreateObjectDef("The Random Trees 1");
		rmAddObjectDefItem(randomTreeID, "TreePatagoniaDirt", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.4));
		
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint); 
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, northIslandConstraint);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseRhea);
		rmAddObjectDefConstraint(randomTreeID, avoidWater15);
		rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE SOUTH ISLAND:
		int randomTree2ID=rmCreateObjectDef("The Random Trees 2");
		rmAddObjectDefItem(randomTree2ID, "TreePatagoniaDirt", 1, 0.0);
		rmAddObjectDefToClass(randomTree2ID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.4));
		
		rmAddObjectDefConstraint(randomTree2ID, playerEdgeConstraint); 
	    rmAddObjectDefConstraint(randomTree2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTree2ID, avoidAll);
		rmAddObjectDefConstraint(randomTree2ID, southIslandConstraint);
		rmAddObjectDefConstraint(randomTree2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseRhea);
		rmAddObjectDefConstraint(randomTree2ID, avoidWater15);
		rmAddObjectDefConstraint(randomTree2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomTree2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);   

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/
   














