/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// MATO GROSSO WAR:
// CREATED BY DANY:
// SEPTEMBER 2007:

/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE WHICHVARIATION:
		int whichVariation=-1;
	    whichVariation = rmRandInt(1,2);		
		
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if ( whichVariation == 1 )
{	
		
        if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");

		subCiv1=rmGetCivID("Aztecs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Aztecs"); 

		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Aztecs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Aztecs");
   }
}
/*----------------------------------------------------------------------------------------------------------------*/
        else
/*----------------------------------------------------------------------------------------------------------------*/		
{		
	    if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Incas");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Incas");

		subCiv1=rmGetCivID("Incas");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Incas"); 

		subCiv2=rmGetCivID("Incas");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Incas");

		subCiv3=rmGetCivID("Incas");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Incas");
   }
}   

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/

   	    if(cNumberTeams > 2)
		int playerTiles=25000;
	    else if (rmGetNumberPlayersOnTeam(0) == rmGetNumberPlayersOnTeam(1))
		playerTiles=25000;
	    else
		playerTiles=25000;	
			
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(632, 632);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
		
	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(3.0);

        // SET SEA TYPE:
		rmSetSeaType("yucatan Coast");
			    
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);		

	    // SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("amazon grass");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("amazon\ground4_ama", 4);
	    
		// SET MAP TYPE:
		rmSetMapType("amazonia");
		rmSetMapType("tropical");
		rmSetMapType("water");
	    	    	    
		// SET LIGHTING:
		rmSetLightingSet("amazon");

	    // MAKE THE CORNERS:
	    rmSetWorldCircleConstraint(true);

	    // Choose Mercs
	    chooseMercs();
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("classSocket");
		int lakeClass=rmDefineClass("Lake");
		rmDefineClass("classTrees");
		rmDefineClass("canyon");
	    			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
   
    // MAP EDGE CONSTRAINTS:
    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
	int playerCloseEdgeConstraint=rmCreatePieConstraint("player close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
/*----------------------------------------------------------------------------------------------------------------*/

   	// PLAYER CONSTRAINTS:
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 15.0);
	int playerCloseConstraint=rmCreateClassDistanceConstraint("close stuff avoid players", classPlayer, 5.0);
	int playerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff avoid players", classPlayer, 2.0);
	int playerMediumConstraint=rmCreateClassDistanceConstraint("medium stuff avoid players", classPlayer, 25.0);
	int playerFarConstraint=rmCreateClassDistanceConstraint("far stuff avoid players", classPlayer, 50.0);
	int playerVeryFarConstraint=rmCreateClassDistanceConstraint("very far stuff avoid players", classPlayer, 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/

    // STARTING UNITS AVOIDANCE:
	int avoidStartingUnits=rmCreateClassDistanceConstraint("stuff avoid starting units", rmClassID("startingUnit"), 15.0);
    int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close stuff avoid starting units", rmClassID("startingUnit"), 5.0);
    int avoidVeryCloseStartingUnits=rmCreateClassDistanceConstraint("very close stuff avoid starting units", rmClassID("startingUnit"), 2.0);
    int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium stuff avoid starting units", rmClassID("startingUnit"), 25.0);
    int avoidFarStartingUnits=rmCreateClassDistanceConstraint("far stuff avoid starting units", rmClassID("startingUnit"), 50.0);
    int avoidVeryFarStartingUnits=rmCreateClassDistanceConstraint("very far stuff avoid starting units", rmClassID("startingUnit"), 75.0);
 
/*----------------------------------------------------------------------------------------------------------------*/

		// FISHES AVOIDANCE:
	     int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 8.0);
	     int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
		 
/*----------------------------------------------------------------------------------------------------------------*/		 
		 
		// NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** DEFINE THE CONSTRAINTS FOR THE FRUITS: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/		
				
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 15.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 5.0);
		int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoid fruits", "berrybush", 2.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid fruits", "berrybush", 25.0);
		int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid fruits", "berrybush", 50.0);
		int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoid fruits", "berrybush", 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
	
	// NATURE AVOIDANCE:
	int avoidForest=rmCreateClassDistanceConstraint("stuff avoids forest", rmClassID("classForest"), 15.0);
	int avoidCloseForest=rmCreateClassDistanceConstraint("close stuff avoids forest", rmClassID("classForest"), 5.0);
	int avoidVeryCloseForest=rmCreateClassDistanceConstraint("very close stuff avoids forest", rmClassID("classForest"), 2.0);
	int avoidMediumForest=rmCreateClassDistanceConstraint("medium avoids forest", rmClassID("classForest"), 25.0);
	int avoidFarForest=rmCreateClassDistanceConstraint("far stuff avoids forest", rmClassID("classForest"), 50.0);
	int avoidVeryFarForest=rmCreateClassDistanceConstraint("very far stuff avoids forest", rmClassID("classForest"), 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
	// TAPIR AVOIDANCE:
	int avoidTapir=rmCreateTypeDistanceConstraint("Tapir avoids Tapir", "Tapir", 15.0);
	int avoidFarTapir=rmCreateTypeDistanceConstraint("far stuff avoids Tapir", "Tapir", 50.0);
	int avoidVeryFarTapir=rmCreateTypeDistanceConstraint("stuff very far avoids Tapir", "Tapir", 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
   
   // SHEEP AVOIDANCE:
   int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 15.0);
   int avoidCloseSheep=rmCreateTypeDistanceConstraint("close stuff avoids sheep", "sheep", 5.0);
   int avoidVeryCloseSheep=rmCreateTypeDistanceConstraint("very close stuff avoids sheep", "sheep", 2.0);
   int avoidMediumSheep=rmCreateTypeDistanceConstraint("medium stuff avoids sheep", "sheep", 25.0);
   int avoidFarSheep=rmCreateTypeDistanceConstraint("far stuff avoids sheep", "sheep", 50.0);
   int avoidVeryFarSheep=rmCreateTypeDistanceConstraint("very far stuff avoids sheep", "sheep", 75.0);       	
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	// THE SILVER AND GOLD MINES AVOIDANCE:
	int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "gold", 15.0);
	int avoidCloseCoin=rmCreateTypeDistanceConstraint("close stuff avoid coin", "gold", 5.0);
	int avoidVeryCloseCoin=rmCreateTypeDistanceConstraint("very close stuff avoid coin", "gold", 2.0);
	int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium stuff avoid coin", "gold", 25.0);
	int avoidFarCoin=rmCreateTypeDistanceConstraint("far stuff avoid coin", "gold", 50.0);
	int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far stuff avoid coin", "gold", 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/	
   
    // AVOID IMPASSABLE LAND:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("stuff avoid impassable land", "Land", false, 15.0);
	int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close stuff avoid impassable land", "Land", false, 5.0);
	int avoidVeryCloseImpassableLand=rmCreateTerrainDistanceConstraint("very close avoid impassable land", "Land", false, 2.0);
	int avoidMediumImpassableLand=rmCreateTerrainDistanceConstraint("medium stuff avoid impassable land", "Land", false, 25.0);
	int avoidFarImpassableLand=rmCreateTerrainDistanceConstraint("far stuff avoid impassable land", "Land", false, 50.0);
	int avoidVeryfarImpassableLand=rmCreateTerrainDistanceConstraint("very far stuff avoid impassable land", "Land", false, 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/	
		 
		 // LAKE AVOIDANCE:
		 int avoidLake=rmCreateClassDistanceConstraint("stuff vs. lake", rmClassID("Lake"), 15.0);
		 int avoidCloseLake=rmCreateClassDistanceConstraint("close stuff vs. lake", rmClassID("Lake"), 5.0);
		 int avoidVeryCloseLake=rmCreateClassDistanceConstraint("very close stuff vs. lake", rmClassID("Lake"), 2.0);
		 int avoidMediumLake=rmCreateClassDistanceConstraint("medium stuff vs. lake", rmClassID("Lake"), 25.0);
		 int avoidFarLake=rmCreateClassDistanceConstraint("far stuff vs. lake", rmClassID("Lake"), 50.0);
		 int avoidVeryFarLake=rmCreateClassDistanceConstraint("very far stuff vs. lake", rmClassID("Lake"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/	
	
	// CLIFFS AVOIDANCE:
	int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 15.0);
	int avoidCloseCliff=rmCreateClassDistanceConstraint("close stuff vs. cliff", rmClassID("classCliff"), 5.0);
	int avoidVeryCloseCliff=rmCreateClassDistanceConstraint("very close stuff vs. cliff", rmClassID("classCliff"), 2.0);
	int avoidMediumCliff=rmCreateClassDistanceConstraint("medium stuff vs. cliff", rmClassID("classCliff"), 25.0);
	int avoidFarCliff=rmCreateClassDistanceConstraint("far stuff vs. cliff", rmClassID("classCliff"), 50.0);
	int avoidVeryFarCliff=rmCreateClassDistanceConstraint("very far stuff vs. cliff", rmClassID("classCliff"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/	
    
	// IMPORTANT ITEM AVOIDANCE:
	int avoidImportantItem=rmCreateClassDistanceConstraint("stuff avoid important item", rmClassID("importantItem"), 15.0);
    int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close stuff avoid important item", rmClassID("importantItem"), 5.0);
    int avoidVeryCloseImportantItem=rmCreateClassDistanceConstraint("very close stuff avoid important item", rmClassID("importantItem"), 2.0);
    int avoidMediumImportantItem=rmCreateClassDistanceConstraint("medium stuff avoid important item", rmClassID("importantItem"), 25.0);
    int avoidFarImportantItem=rmCreateClassDistanceConstraint("far stuff avoid important item", rmClassID("importantItem"), 50.0);
    int avoidVeryFarImportantItem=rmCreateClassDistanceConstraint("very far stuff avoid important item", rmClassID("importantItem"), 75.0);
  
/*----------------------------------------------------------------------------------------------------------------*/
    
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
    int avoidCloseNatives=rmCreateClassDistanceConstraint("close stuff avoids natives", rmClassID("natives"), 5.0);
    int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close stuff avoids natives", rmClassID("natives"), 2.0);
    int avoidMediumNatives=rmCreateClassDistanceConstraint("medium stuff avoids natives", rmClassID("natives"), 25.0);
    int avoidFarNatives=rmCreateClassDistanceConstraint("far stuff avoids natives", rmClassID("natives"), 50.0);
    int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far stuff avoids natives", rmClassID("natives"), 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
	// NUGGET AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 15.0);
	int avoidCloseNugget=rmCreateTypeDistanceConstraint("close stuff avoid nugget", "AbstractNugget", 5.0);
	int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close stuff avoid nugget", "AbstractNugget", 2.0);
	int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium stuff avoid nugget", "AbstractNugget", 25.0);
	int avoidFarNugget=rmCreateTypeDistanceConstraint("far stuff avoid nugget", "AbstractNugget", 50.0);
	int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far avoid nugget", "AbstractNugget", 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
    // DECORATION AVOIDANCE:
    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 10.0);
		int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 5.0);
		int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 2.0);
		int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
		int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
		int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	// TRADE ROUTE AVOIDANCE:
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("stuff avoid trade route", 15.0);
   int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close stuff avoid trade route", 5.0);
   int avoidVeryCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("very close stuff avoid trade route", 2.0);
   int avoidMediumTradeRoute = rmCreateTradeRouteDistanceConstraint("Medium stuff avoid trade route", 25.0);
   int avoidFarTradeRoute = rmCreateTradeRouteDistanceConstraint("far stuff avoid trade route", 50.0);
   int avoidVeryFarTradeRoute = rmCreateTradeRouteDistanceConstraint("very far stuff avoid trade route", 75.0);
   
/*----------------------------------------------------------------------------------------------------------------*/
   
   // SOCKETS AVOIDANCE:
   int avoidSocket = rmCreateClassDistanceConstraint("stuff avoid socket", rmClassID("classSocket"), 15.0);
   int avoidCloseSocket = rmCreateClassDistanceConstraint("close stuff avoid socket", rmClassID("classSocket"), 5.0);
   int avoidVeryCloseSocket = rmCreateClassDistanceConstraint("very close stuff avoid socket", rmClassID("classSocket"), 2.0);
   int avoidMediumSocket = rmCreateClassDistanceConstraint("medium stuff avoid socket", rmClassID("classSocket"), 25.0);
   int avoidFarSocket = rmCreateClassDistanceConstraint("far stuff avoid socket", rmClassID("classSocket"), 50.0);
   int avoidVeryFarSocket = rmCreateClassDistanceConstraint("very far stuff avoid socket", rmClassID("classSocket"), 75.0);
      
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/

        // DEFINE SOME OBJECTS:
        // THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER:
		
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE THE TRADE ROUTE AND THE SOCKETS: ***************************** //
/*================================================================================================================*/

        // CLEAR OUT CONSTRAINS FOR GOOD MEASURE:
        rmClearClosestPointConstraints();
   
/*----------------------------------------------------------------------------------------------------------------*/   

	    // SOCKET DEFINITION:
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 1:
		int tradeRoute1ID = rmCreateTradeRoute();
	    rmAddTradeRouteWaypoint(tradeRoute1ID, 0.160, 0.160);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.400, 0.400);
	    //rmAddRandomTradeRouteWaypoints(tradeRoute1ID, 0.8, 0.6, 6, 8);
	    //rmAddRandomTradeRouteWaypoints(tradeRoute1ID, 1.0, 1.0, 6, 8);

	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.95);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 2:
		int tradeRoute2ID = rmCreateTradeRoute();
	    rmAddTradeRouteWaypoint(tradeRoute2ID, 0.825, 0.825);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.600, 0.600);
	    //rmAddRandomTradeRouteWaypoints(tradeRoute2ID, 0.4, 0.2, 6, 8);
	    //rmAddRandomTradeRouteWaypoints(tradeRoute2ID, 0.0, 0.0, 6, 8);

	    bool placedTradeRoute2 = rmBuildTradeRoute(tradeRoute2ID, "dirt");
	    if(placedTradeRoute2 == false)
		rmEchoError("Failed to place trade route 2");

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);
	    vector socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);

	    socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.95);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************ SET UP PLAYER STARTING LOCATIONS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
	{
    	rmSetPlacementTeam(0);
		rmSetPlacementSection(0.05, 0.20);
		rmPlacePlayersCircular(0.38, 0.38, 0.0);

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.55, 0.70);
		rmPlacePlayersCircular(0.38, 0.38, 0.0);
    }
        
		else

    {		
        rmSetPlacementTeam(0);
		rmSetPlacementSection(0.55, 0.70);
		rmPlacePlayersCircular(0.38, 0.38, 0.0);
		
		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.05, 0.20);
		rmPlacePlayersCircular(0.38, 0.38, 0.0);
	}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************** DEFINE AND BUILD THE EAST AREA: *************************************** //
/*================================================================================================================*/

	    int eastIslandID = rmCreateArea("east island");
	    //rmSetAreaLocation(eastIslandID, 0.75, 0.50);
	    rmSetAreaLocation(eastIslandID, 0.775, 0.225); 
	    rmSetAreaWarnFailure(eastIslandID, false);
	    rmSetAreaSize(eastIslandID, 0.075, 0.075);
	    rmSetAreaCoherence(eastIslandID, 1.0);

	    rmSetAreaElevationType(eastIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(eastIslandID, 4.0);
	    rmSetAreaBaseHeight(eastIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(eastIslandID, 0.07);
	    rmSetAreaElevationOctaves(eastIslandID, 4);
	    rmSetAreaElevationPersistence(eastIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(eastIslandID, 1);
   
	    rmSetAreaObeyWorldCircleConstraint(eastIslandID, false);
	    rmSetAreaMix(eastIslandID, "amazon grass");
		//rmSetAreaMix(eastIslandID, "texas_dirt");
		//rmSetAreaMix(eastIslandID, "rockies_snow");
		
		rmBuildAllAreas();
		
		int eastIslandConstraint=rmCreateAreaConstraint("east Island", eastIslandID);

/*================================================================================================================*/
// ************************************** DEFINE AND BUILD THE WEST AREA: *************************************** //
/*================================================================================================================*/  

   	    int westIslandID = rmCreateArea("west island");
	    //rmSetAreaLocation(westIslandID, 0, 0.5);
	    rmSetAreaLocation(westIslandID, 0.225, 0.775);
	    rmSetAreaWarnFailure(westIslandID, false);
	    rmSetAreaSize(westIslandID, 0.075, 0.075);
	    rmSetAreaCoherence(westIslandID, 1.0);

	    rmSetAreaElevationType(westIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(westIslandID, 4.0);
	    rmSetAreaBaseHeight(westIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(westIslandID, 0.07);
	    rmSetAreaElevationOctaves(westIslandID, 4);
	    rmSetAreaElevationPersistence(westIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(westIslandID, 1); 
	    //rmAddAreaTerrainLayer(westIslandID, "andes\ground10_and", 0, 3);
//	    rmAddAreaTerrainLayer(westIslandID, "amazon\ground4_ama", 3, 12);
	    //rmAddAreaTerrainLayer(westIslandID, "andes\ground4_and", 6, 8);
   
	    rmSetAreaObeyWorldCircleConstraint(westIslandID, false);
	    rmSetAreaMix(westIslandID, "amazon grass");
	    //rmSetAreaMix(westIslandID, "rockies_grass");
		//rmSetAreaMix(westIslandID, "rockies_snow");

        rmBuildAllAreas();
		
		int westIslandConstraint=rmCreateAreaConstraint("west Island", westIslandID);

/*================================================================================================================*/
// ************************************** DEFINE AND BUILD THE NORTH AREA: *************************************** //
/*================================================================================================================*/

	    int northIslandID = rmCreateArea("north island");
	    //rmSetAreaLocation(northIslandID, 0.75, 0.50);
	    rmSetAreaLocation(northIslandID, 0.80, 0.80); 
	    rmSetAreaWarnFailure(northIslandID, false);
	    rmSetAreaSize(northIslandID, 0.35, 0.35);
	    rmSetAreaCoherence(northIslandID, 1.0);

	    rmSetAreaElevationType(northIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(northIslandID, 4.0);
	    rmSetAreaBaseHeight(northIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(northIslandID, 0.07);
	    rmSetAreaElevationOctaves(northIslandID, 4);
	    rmSetAreaElevationPersistence(northIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(northIslandID, 1);
   
	    rmSetAreaObeyWorldCircleConstraint(northIslandID, false);
	    rmSetAreaMix(northIslandID, "amazon grass");
		//rmSetAreaMix(northIslandID, "texas_dirt");
		
		rmBuildAllAreas();
		
		int northIslandConstraint=rmCreateAreaConstraint("north Island", northIslandID);

/*================================================================================================================*/
// ************************************** DEFINE AND BUILD THE SOUTH AREA: *************************************** //
/*================================================================================================================*/  

   	    int southIslandID = rmCreateArea("south island");
	    //rmSetAreaLocation(southIslandID, 0, 0.5);
	    rmSetAreaLocation(southIslandID, 0.20, 0.20);
	    rmSetAreaWarnFailure(southIslandID, false);
	    rmSetAreaSize(southIslandID, 0.35, 0.35);
	    rmSetAreaCoherence(southIslandID, 1.0);

	    rmSetAreaElevationType(southIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(southIslandID, 4.0);
	    rmSetAreaBaseHeight(southIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(southIslandID, 0.07);
	    rmSetAreaElevationOctaves(southIslandID, 4);
	    rmSetAreaElevationPersistence(southIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(southIslandID, 1); 
	    //rmAddAreaTerrainLayer(southIslandID, "andes\ground10_and", 0, 3);
//	    rmAddAreaTerrainLayer(southIslandID, "amazon\ground4_ama", 3, 12);
	    //rmAddAreaTerrainLayer(southIslandID, "andes\ground4_and", 6, 8);
   
	    rmSetAreaObeyWorldCircleConstraint(southIslandID, false);
	    rmSetAreaMix(southIslandID, "amazon grass");
	    //rmSetAreaMix(southIslandID, "rockies_grass");

        rmBuildAllAreas();
		
		int southIslandConstraint=rmCreateAreaConstraint("south Island", southIslandID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE MIDDLE LAKE: ************************************** //  
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        //int lakeClass=rmDefineClass("Lake");
	    //int lakeConstraint=rmCreateClassDistanceConstraint("the stuff vs. lake", rmClassID("Lake"), 20.0);
		
        if ( whichVariation == 1 )
{	
	 	int LakeID=rmCreateArea("The Lake 1");
		rmAddAreaToClass(LakeID, rmClassID("Lake"));
		rmSetAreaSize(LakeID, 0.075, 0.075);
		rmSetAreaWaterType(LakeID, "yucatan coast");
		rmSetAreaBaseHeight(LakeID, 4.0);
		
		rmSetAreaMinBlobs(LakeID, 1);
		rmSetAreaMaxBlobs(LakeID, 1);
		rmSetAreaMinBlobDistance(LakeID, 1.0);
		rmSetAreaMaxBlobDistance(LakeID, 1.0);
		
		rmSetAreaSmoothDistance(LakeID, 35);
		rmSetAreaCoherence(LakeID, 0.75);
		rmSetAreaWarnFailure(LakeID, false);
		
		rmAddAreaConstraint(LakeID, playerConstraint);

		rmAddAreaInfluenceSegment(LakeID, 0.40, 0.60, 0.60, 0.40);
		rmSetAreaLocation(LakeID, 0.50, 0.50);
		rmBuildArea(LakeID);
}	

        else 
{    
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa");
		rmSetAreaSize(smallMesaID, 0.075, 0.075);
		rmSetAreaWarnFailure(smallMesaID, false);
					
		rmSetAreaCliffType(smallMesaID, "Bayou");
			
		rmAddAreaToClass(smallMesaID, rmClassID("classCliff"));
        
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0);

        	
		rmAddAreaTerrainLayer(smallMesaID, "bayou\ground2_bay", 0, 2);
			
		rmSetAreaCoherence(smallMesaID, 0.88);
		rmSetAreaLocation(smallMesaID, 0.50, 0.50); 
		rmAddAreaInfluenceSegment(smallMesaID, 0.40, 0.60, 0.60, 0.40); 
		rmBuildArea(smallMesaID);
}

/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE CLIFFS: **************************************** //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int cliffEastID=rmCreateArea("cliff east");
		
	    //rmSetAreaSize(cliffEastID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));
        rmSetAreaSize(cliffEastID, 0.0125, 0.0125);		
		rmSetAreaWarnFailure(cliffEastID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(cliffEastID, "Amazon");
	}	
		else
	{	
		rmSetAreaCliffType(cliffEastID, "Bayou");
	}	
		
		rmAddAreaToClass(cliffEastID, rmClassID("classCliff"));	
		//rmSetAreaCliffEdge(cliffEastID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliffEastID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffEastID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffEastID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffEastID, 1);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(cliffEastID, "amazon\ground4_ama", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(cliffEastID, "bayou\ground2_bay", 0, 2);
	}	
		
		rmSetAreaObeyWorldCircleConstraint(cliffEastID, false);
		//rmAddAreaConstraint(cliffEastID, cliffsAvoidCliffs);				
						
		rmSetAreaMinBlobs(cliffEastID, 1);
		rmSetAreaMaxBlobs(cliffEastID, 1);
		rmSetAreaMinBlobDistance(cliffEastID, 1);
		rmSetAreaMaxBlobDistance(cliffEastID, 1);
		rmSetAreaCoherence(cliffEastID, 0.60);
		rmSetAreaSmoothDistance(cliffEastID, 30);						
		rmSetAreaCoherence(cliffEastID, 0.60);
		
		rmSetAreaLocation(cliffEastID, 0.775, 0.225);

		rmBuildArea(cliffEastID);
			
/*----------------------------------------------------------------------------------------------------------------*/	

	    int cliffWestID=rmCreateArea("cliff west");
	    //rmSetAreaSize(cliffWestID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));
		rmSetAreaSize(cliffWestID, 0.0125, 0.0125);
        rmSetAreaWarnFailure(cliffWestID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(cliffWestID, "Amazon");
	}	
		else
	{	
		rmSetAreaCliffType(cliffWestID, "Bayou");
	}	
		rmAddAreaToClass(cliffWestID, rmClassID("classCliff"));
        rmSetAreaCliffEdge(cliffWestID, 1, 1.0, 0.1, 1.0, 0);		
		//rmSetAreaCliffEdge(cliffWestID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffWestID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffWestID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffWestID, 1);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(cliffWestID, "amazon\ground4_ama", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(cliffWestID, "bayou\ground2_bay", 0, 2);
	}	

		rmSetAreaObeyWorldCircleConstraint(cliffWestID, false);
		//rmAddAreaConstraint(cliffWestID, cliffsAvoidCliffs);			
				
		rmSetAreaMinBlobs(cliffWestID, 1);
		rmSetAreaMaxBlobs(cliffWestID, 1);
		rmSetAreaMinBlobDistance(cliffWestID, 1);
		rmSetAreaMaxBlobDistance(cliffWestID, 1);
		
		rmSetAreaCoherence(cliffWestID, 0.60);
		rmSetAreaSmoothDistance(cliffWestID, 30);	
		rmSetAreaCoherence(cliffWestID, 0.60);
		
		rmSetAreaLocation(cliffWestID, 0.225, 0.775);

		rmBuildArea(cliffWestID);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ****************************************** SET UP THE PLAYER AREAS: ****************************************** //	
/*================================================================================================================*/

	    float playerFraction=rmAreaTilesToFraction(1750);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
	    rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint);
      
	    // SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA ELEVATION TYPE:
		rmSetAreaElevationType(id, cElevTurbulence);
	    
		// SET AREA ELEVATION VARIATION:
		rmSetAreaElevationVariation(id, 4.0);
	    
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
				
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");
		
		// SET AREA BASE HEIGHT:
		rmSetAreaBaseHeight(id, 4.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

	    // BUILD THE AREAS:
	    rmBuildAllAreas();
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************** //
/*================================================================================================================*/
 
        if ( whichVariation == 1 )
{	
		
		if (subCiv0 == rmGetCivID("aztecs"))
	{  
		int aztecsVillageID = -1;
		aztecsVillageID = rmCreateGrouping("aztecs village 1", "native aztec village 1");
		rmSetGroupingMinDistance(aztecsVillageID, 0.0);
		rmSetGroupingMaxDistance(aztecsVillageID, 0.0);
		rmAddGroupingToClass(aztecsVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecsVillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecsVillageID, 0, 0.335, 0.925);
	}
}
        else
{	
        if (subCiv0 == rmGetCivID("incas"))
	{  
		int incasVillageID = -1;
		incasVillageID = rmCreateGrouping("incas village 1", "native inca village 1");
		rmSetGroupingMinDistance(incasVillageID, 0.0);
		rmSetGroupingMaxDistance(incasVillageID, 0.0);
		rmAddGroupingToClass(incasVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(incasVillageID, avoidNatives);
		rmPlaceGroupingAtLoc(incasVillageID, 0, 0.335, 0.925);
	} 
}	
	
/*---------------------------------------------------------------------------------------------------------------*/
        
		if ( whichVariation == 1 )
{		
		if (subCiv1 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs village 2", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.925, 0.335);
	} 
}	
    else
{	
        if (subCiv1 == rmGetCivID("incas"))
	{  
		int incas2VillageID = -1;
		incas2VillageID = rmCreateGrouping("incas village 2", "native inca village 1");
		rmSetGroupingMinDistance(incas2VillageID, 0.0);
		rmSetGroupingMaxDistance(incas2VillageID, 0.0);
		rmAddGroupingToClass(incas2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(incas2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(incas2VillageID, 0, 0.925, 0.335);
	} 
}	
	
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
{		
		if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecs3VillageID = -1;
		aztecs3VillageID = rmCreateGrouping("aztecs village 3", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs3VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs3VillageID, 0.0);
		rmAddGroupingToClass(aztecs3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs3VillageID, 0, 0.075, 0.65);
	} 
}
    	else
{	
        if (subCiv1 == rmGetCivID("incas"))
	{  
		int incas3VillageID = -1;
		incas3VillageID = rmCreateGrouping("incas village 3", "native inca village 1");
		rmSetGroupingMinDistance(incas3VillageID, 0.0);
		rmSetGroupingMaxDistance(incas3VillageID, 0.0);
		rmAddGroupingToClass(incas3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(incas3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(incas3VillageID, 0, 0.075, 0.65);
	} 
}	

/*----------------------------------------------------------------------------------------------------------------*/
        
		if ( whichVariation == 1 )
{		
		if (subCiv3 == rmGetCivID("aztecs"))
	{  
		int aztecs4VillageID = -1;
		aztecs4VillageID = rmCreateGrouping("aztecs village 4", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs4VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs4VillageID, 0.0);
		rmAddGroupingToClass(aztecs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs4VillageID, 0, 0.65, 0.075);
	} 
}
	    else
{	
        if (subCiv3 == rmGetCivID("incas"))
	{  
		int incas4VillageID = -1;
		incas4VillageID = rmCreateGrouping("incas village 4", "native inca village 1");
		rmSetGroupingMinDistance(incas4VillageID, 0.0);
		rmSetGroupingMaxDistance(incas4VillageID, 0.0);
		rmAddGroupingToClass(incas4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(incas4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(incas4VillageID, 0, 0.65, 0.075);
	} 
}	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/

	int failCount = -1;
	int numTries=cNumberNonGaiaPlayers+2;

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// *********************** DEFINE THE TCID AND THE STARTING UNITS AND THE PLAYER RESOURCES: ********************* //
/*================================================================================================================*/
 
	    // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
		{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
		}
	    else
		{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
		}

	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);
		rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(TCID, avoidAll);
	    		
/*----------------------------------------------------------------------------------------------------------------*/

       	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
		rmAddObjectDefConstraint(startingUnits, avoidCloseStartingUnits);
	    	    		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player mine");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(playerSilverID, "minegold", 1, 0.0);
	}	
        else
	{	
		rmAddObjectDefItem(playerSilverID, "mine", 1, 0.0);
	}
	    
	    rmSetObjectDefMinDistance(playerSilverID, 15.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 20.0);
        rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
		
		// DEFINE THE PLAYER BERRIES:
		int playerBerriesID=rmCreateObjectDef("The Player Berries");
	    rmAddObjectDefItem(playerBerriesID, "BerryBush", 3, 4.0);
	    rmSetObjectDefMinDistance(playerBerriesID, 15.0);
	    rmSetObjectDefMaxDistance(playerBerriesID, 18.0);
	    rmAddObjectDefConstraint(playerBerriesID, avoidFruits);
		rmAddObjectDefConstraint(playerBerriesID, avoidAll);
        
		// DEFINE THE PLAYER CAPYBARA:
	    int playerCapybaraID=rmCreateObjectDef("player Capybara");
        rmAddObjectDefItem(playerCapybaraID, "capybara", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(playerCapybaraID, 10);
        rmSetObjectDefMaxDistance(playerCapybaraID, 18);
	    rmAddObjectDefConstraint(playerCapybaraID, avoidAll);
        rmAddObjectDefConstraint(playerCapybaraID, avoidImpassableLand);
	    rmAddObjectDefConstraint(playerCapybaraID, avoidCliff);
        rmSetObjectDefCreateHerd(playerCapybaraID, true);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidAll);
	    rmAddObjectDefConstraint(playerNuggetID, avoidCliff);
	    rmAddObjectDefConstraint(playerNuggetID, playerEdgeConstraint);
	    rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 30.0);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(playerTreeID, "TreeAmazon", rmRandInt(5,10), 8.0);
	}
        else
    {		
		rmAddObjectDefItem(playerTreeID, "TreeYucatan", rmRandInt(5,10), 8.0);
	}
	
        rmSetObjectDefMinDistance(playerTreeID, 19);
        rmSetObjectDefMaxDistance(playerTreeID, 24);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
		
		int waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        rmAddClosestPointConstraint(flagVsFlag);
        rmAddClosestPointConstraint(flagLand);   
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************ PLACE THE TCID AND THE STARTING UNITS AND THE PLAYER RESOURCES: ********************* //
/*================================================================================================================*/	

	    for(i=1; <cNumberPlayers)
   {
	    // PLACE THE TCID:
		
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
	    vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	    		
		//rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    //vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
		//vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	    
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER BERRIES:
		rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	  		
		// PLACE THE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER TREE:
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	   
		// PLACE THE PLAYER CAPYBARA:
		rmPlaceObjectDefAtLoc(playerCapybaraID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER NUGGET:
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

        rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
	}
        // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*================================================================================================================*/

	    // THE NORTHERN NUGGET EASY:
		int nuggetnorthID= rmCreateObjectDef("The Northern Nugget Easy"); 
	    rmAddObjectDefItem(nuggetnorthID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggetnorthID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetnorthID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggetnorthID, avoidVeryFarNugget);
  	    rmAddObjectDefConstraint(nuggetnorthID, playerCloseConstraint);
	    rmAddObjectDefConstraint(nuggetnorthID, avoidCloseSocket);
  	    rmAddObjectDefConstraint(nuggetnorthID, avoidAll);
		rmAddObjectDefConstraint(nuggetnorthID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggetnorthID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggetnorthID, northIslandConstraint);
  	    rmAddObjectDefConstraint(nuggetnorthID, avoidImpassableLand);
	    rmAddObjectDefConstraint(nuggetnorthID, playerEdgeConstraint);
	    
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);	

/*----------------------------------------------------------------------------------------------------------------*/

	    // THE SOUTHERN NUGGET EASY:
		int nuggetsouthID= rmCreateObjectDef("The Southern Nugget Easy"); 
	    rmAddObjectDefItem(nuggetsouthID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggetsouthID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetsouthID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggetsouthID, avoidVeryFarNugget);
  	    rmAddObjectDefConstraint(nuggetsouthID, playerCloseConstraint);
	    rmAddObjectDefConstraint(nuggetsouthID, avoidCloseSocket);
  	    rmAddObjectDefConstraint(nuggetsouthID, avoidAll);
		rmAddObjectDefConstraint(nuggetsouthID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggetsouthID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggetsouthID, southIslandConstraint);
  	    rmAddObjectDefConstraint(nuggetsouthID, avoidImpassableLand);
	    rmAddObjectDefConstraint(nuggetsouthID, playerEdgeConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggetsouthID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(nuggetsouthID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);	

/*----------------------------------------------------------------------------------------------------------------*/		

	    // THE NUGGET MEDIUM EAST:
		int nuggeteastID= rmCreateObjectDef("The Eastern Nugget Easy"); 
	    rmAddObjectDefItem(nuggeteastID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nuggeteastID, 0.0);
	    rmSetObjectDefMaxDistance(nuggeteastID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggeteastID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nuggeteastID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggeteastID, avoidAll);
		rmAddObjectDefConstraint(nuggeteastID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggeteastID, eastIslandConstraint);
  	    rmAddObjectDefConstraint(nuggeteastID, avoidImpassableLand);
	    rmAddObjectDefConstraint(nuggeteastID, playerCloseEdgeConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggeteastID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(nuggeteastID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);	
	    
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGET MEDIUM WEST:
		int nuggetwestID= rmCreateObjectDef("The Western Nugget Easy"); 
	    rmAddObjectDefItem(nuggetwestID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nuggetwestID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetwestID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggetwestID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nuggetwestID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggetwestID, avoidAll);
		rmAddObjectDefConstraint(nuggetwestID, avoidCloseLake);
		rmAddObjectDefConstraint(nuggetwestID, westIslandConstraint);
  	    rmAddObjectDefConstraint(nuggetwestID, avoidImpassableLand);
	    rmAddObjectDefConstraint(nuggetwestID, playerCloseEdgeConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggetwestID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(nuggetwestID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);	
		
/*----------------------------------------------------------------------------------------------------------------*/
/*		
        // THE NUGGET HARD:
	    int nuggethardID= rmCreateObjectDef("nugget hard"); 
	    rmAddObjectDefItem(nuggethardID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 3);
	    rmSetObjectDefMinDistance(nuggethardID, 0.0);
	    rmSetObjectDefMaxDistance(nuggethardID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggethardID, avoidNugget);
  	    rmAddObjectDefConstraint(nuggethardID, avoidCliff);
  	    rmAddObjectDefConstraint(nuggethardID, avoidAll);
	    rmAddObjectDefConstraint(nuggethardID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggethardID, avoidImpassableLand);
	    rmPlaceObjectDefAtLoc(nuggethardID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
*/		
/*----------------------------------------------------------------------------------------------------------------*/
/*
	    if(rmRandFloat(0,1) < 0.50) // ONLY PLACES MORE HARD NUGGETS 50% OF THE TIME:
	{
		// THE NUGGET HARD 2:
		int nuggethard2ID= rmCreateObjectDef("nugget hard 2"); 
		rmAddObjectDefItem(nuggethard2ID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(3, 3);
		rmSetObjectDefMinDistance(nuggethard2ID, 0.0);
		rmSetObjectDefMaxDistance(nuggethard2ID, rmXFractionToMeters(0.5));
  		rmAddObjectDefConstraint(nuggethard2ID, avoidNugget);
  		rmAddObjectDefConstraint(nuggethard2ID, avoidCliff);
  		rmAddObjectDefConstraint(nuggethard2ID, avoidAll);
  		rmAddObjectDefConstraint(nuggethard2ID, avoidImpassableLand);
		rmPlaceObjectDefAtLoc(nuggethard2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
	}
	    else if (rmRandFloat(0,1) < 0.25)  // ONLY TRY TO PLACE NUTS 25% OF THE TIME:
	{
		// THE NUGGET NUTS:
		int nuggetnutsID= rmCreateObjectDef("nugget nuts"); 
		rmAddObjectDefItem(nuggetnutsID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nuggetnutsID, 0.0);
		rmSetObjectDefMaxDistance(nuggetnutsID, rmXFractionToMeters(0.5));
  		rmAddObjectDefConstraint(nuggetnutsID, avoidNugget);
  		rmAddObjectDefConstraint(nuggetnutsID, avoidCliff);
  		rmAddObjectDefConstraint(nuggetnutsID, avoidAll);
  		rmAddObjectDefConstraint(nuggetnutsID, avoidImpassableLand);
		rmPlaceObjectDefAtLoc(nuggetnutsID, 0, 0.5, 0.5, 2);
	}
*/	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SILVER MINES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // THE NORTHERN GOLD OR SILVER MINES:
		int silvernorthID = rmCreateObjectDef("The Northern Coin Mines");
	    
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silvernorthID, "minegold", 1, 0.0);
	}	
        else
	{	
		rmAddObjectDefItem(silvernorthID, "mine", 1, 0.0);
	}
	
		rmSetObjectDefMinDistance(silvernorthID, 0.0);
        rmSetObjectDefMaxDistance(silvernorthID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(silvernorthID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(silvernorthID, avoidAll);
		rmAddObjectDefConstraint(silvernorthID, avoidCloseLake);
		rmAddObjectDefConstraint(silvernorthID, avoidCloseCliff);
        rmAddObjectDefConstraint(silvernorthID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silvernorthID, avoidSocket);
        rmAddObjectDefConstraint(silvernorthID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(silvernorthID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(silvernorthID, avoidNugget);
	    rmAddObjectDefConstraint(silvernorthID, northIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(silvernorthID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(silvernorthID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
        // THE SOUTHERN GOLD OR SILVER MINES:
		int silversouthID = rmCreateObjectDef("The Southern Coin Mines");
	    
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silversouthID, "minegold", 1, 0.0);
	}	
        else
	{	
		rmAddObjectDefItem(silversouthID, "mine", 1, 0.0);
	}
	
		rmSetObjectDefMinDistance(silversouthID, 0.0);
        rmSetObjectDefMaxDistance(silversouthID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(silversouthID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(silversouthID, avoidAll);
		rmAddObjectDefConstraint(silversouthID, avoidCloseLake);
		rmAddObjectDefConstraint(silversouthID, avoidCloseCliff);
        rmAddObjectDefConstraint(silversouthID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silversouthID, avoidSocket);
        rmAddObjectDefConstraint(silversouthID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(silversouthID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(silversouthID, avoidNugget);
	    rmAddObjectDefConstraint(silversouthID, southIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(silversouthID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(silversouthID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);		
	      
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN GOLD OR SILVER MINES:
		int silvereastID = rmCreateObjectDef("The Eastern Coin Mines");
	    
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silvereastID, "minegold", 1, 0.0);
	}	
        else
	{	
		rmAddObjectDefItem(silvereastID, "mine", 1, 0.0);
	}
	
		rmSetObjectDefMinDistance(silvereastID, 0.0);
        rmSetObjectDefMaxDistance(silvereastID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(silvereastID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(silvereastID, avoidAll);
		rmAddObjectDefConstraint(silvereastID, avoidCloseLake);
        rmAddObjectDefConstraint(silvereastID, avoidCloseCliff);
		rmAddObjectDefConstraint(silvereastID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(silvereastID, playerCloseEdgeConstraint);
	    rmAddObjectDefConstraint(silvereastID, avoidNugget);
	    rmAddObjectDefConstraint(silvereastID, eastIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(silvereastID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(silvereastID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);

/*----------------------------------------------------------------------------------------------------------------*/	
        
		// THE EASTERN GOLD OR SILVER MINES:
		int silverwestID = rmCreateObjectDef("The Western Coin Mines");
	    
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silverwestID, "minegold", 1, 0.0);
	}	
        else
	{	
		rmAddObjectDefItem(silverwestID, "mine", 1, 0.0);
	}
	
		rmSetObjectDefMinDistance(silverwestID, 0.0);
        rmSetObjectDefMaxDistance(silverwestID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(silverwestID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(silverwestID, avoidAll);
		rmAddObjectDefConstraint(silverwestID, avoidCloseLake);
        rmAddObjectDefConstraint(silverwestID, avoidCloseCliff);
		rmAddObjectDefConstraint(silverwestID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(silverwestID, playerCloseEdgeConstraint);
	    rmAddObjectDefConstraint(silverwestID, avoidNugget);
	    rmAddObjectDefConstraint(silverwestID, westIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FOREST AREAS: ************************************ //
/*================================================================================================================*/

        if (cNumberNonGaiaPlayers <=2)
		numTries=6*cNumberNonGaiaPlayers;
	    else
		numTries=4*cNumberNonGaiaPlayers;
	    failCount=0;
	    for (i=0; <numTries)
{   
		int forestnorthID=rmCreateArea("forestnorthID"+i, northIslandID);
		rmSetAreaWarnFailure(forestnorthID, false);
		rmSetAreaSize(forestnorthID, rmAreaTilesToFraction(160), rmAreaTilesToFraction(200));
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaForestType(forestnorthID, "amazon rain forest");
	}
        else
    {		
		rmSetAreaForestType(forestnorthID, "Yucatan forest");
	}
	
		rmSetAreaForestDensity(forestnorthID, 0.6);
		rmSetAreaForestClumpiness(forestnorthID, 0.4);		
		rmSetAreaForestUnderbrush(forestnorthID, 0.6);
		rmSetAreaMinBlobs(forestnorthID, 4);
		rmSetAreaMaxBlobs(forestnorthID, 10);						
		rmSetAreaMinBlobDistance(forestnorthID, 5.0);
		rmSetAreaMaxBlobDistance(forestnorthID, 20.0);
		rmSetAreaCoherence(forestnorthID, 0.4);
		rmSetAreaSmoothDistance(forestnorthID, 10);
		rmAddAreaToClass(forestnorthID, rmClassID("classForest"));
		
		rmAddAreaConstraint(forestnorthID, avoidMediumForest);  
		rmAddAreaConstraint(forestnorthID, avoidCloseImportantItem);
		rmAddAreaConstraint(forestnorthID, avoidImpassableLand);
		rmAddAreaConstraint(forestnorthID, playerConstraint);
		rmAddAreaConstraint(forestnorthID, avoidCliff);
		rmAddAreaConstraint(forestnorthID, avoidLake);
		rmAddAreaConstraint(forestnorthID, avoidSocket);
		rmAddAreaConstraint(forestnorthID, avoidCloseTradeRoute);
		rmAddAreaConstraint(forestnorthID, playerEdgeConstraint);
		rmAddAreaConstraint(forestnorthID, avoidNugget);
		rmAddAreaConstraint(forestnorthID, avoidCoin);
		rmAddAreaConstraint(forestnorthID, avoidAll);
		
		if(rmBuildArea(forestnorthID)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
		else
		failCount=0; 
}
/*----------------------------------------------------------------------------------------------------------------*/

        if (cNumberNonGaiaPlayers <=2)
		numTries=6*cNumberNonGaiaPlayers;
	    else
		numTries=4*cNumberNonGaiaPlayers;
	    failCount=0;
	    for (i=0; <numTries)
{   
		int forestsouthID=rmCreateArea("forestsouthID"+i, southIslandID);
		rmSetAreaWarnFailure(forestsouthID, false);
		rmSetAreaSize(forestsouthID, rmAreaTilesToFraction(160), rmAreaTilesToFraction(200));
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaForestType(forestsouthID, "amazon rain forest");
	}
        else
    {		
		rmSetAreaForestType(forestsouthID, "Yucatan forest");
	}
	
		rmSetAreaForestDensity(forestsouthID, 0.6);
		rmSetAreaForestClumpiness(forestsouthID, 0.4);		
		rmSetAreaForestUnderbrush(forestsouthID, 0.6);
		rmSetAreaMinBlobs(forestsouthID, 4);
		rmSetAreaMaxBlobs(forestsouthID, 10);						
		rmSetAreaMinBlobDistance(forestsouthID, 5.0);
		rmSetAreaMaxBlobDistance(forestsouthID, 20.0);
		rmSetAreaCoherence(forestsouthID, 0.4);
		rmSetAreaSmoothDistance(forestsouthID, 10);
		rmAddAreaToClass(forestsouthID, rmClassID("classForest"));
		
		rmAddAreaConstraint(forestsouthID, avoidMediumForest);  
		rmAddAreaConstraint(forestsouthID, avoidCloseImportantItem);
		rmAddAreaConstraint(forestsouthID, avoidImpassableLand);
		rmAddAreaConstraint(forestsouthID, playerConstraint);
		rmAddAreaConstraint(forestsouthID, avoidCliff);
		rmAddAreaConstraint(forestsouthID, avoidLake);
		rmAddAreaConstraint(forestsouthID, avoidSocket);
		rmAddAreaConstraint(forestsouthID, avoidCloseTradeRoute);
		rmAddAreaConstraint(forestsouthID, playerEdgeConstraint);
		rmAddAreaConstraint(forestsouthID, avoidNugget);
		rmAddAreaConstraint(forestsouthID, avoidCoin);
		rmAddAreaConstraint(forestsouthID, avoidAll);
		
		if(rmBuildArea(forestsouthID)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
		else
		failCount=0; 
}

/*----------------------------------------------------------------------------------------------------------------*/

        if (cNumberNonGaiaPlayers <=2)
		numTries=4*cNumberNonGaiaPlayers;
	    else
		numTries=2*cNumberNonGaiaPlayers;
	    failCount=0;
	    for (i=0; <numTries)
{   
		int foresteastID=rmCreateArea("foresteastID"+i, eastIslandID);
		rmSetAreaWarnFailure(foresteastID, false);
		rmSetAreaSize(foresteastID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaForestType(foresteastID, "amazon rain forest");
	}
        else
    {		
		rmSetAreaForestType(foresteastID, "Yucatan forest");
	}
	
		rmSetAreaForestDensity(foresteastID, 0.6);
		rmSetAreaForestClumpiness(foresteastID, 0.4);		
		rmSetAreaForestUnderbrush(foresteastID, 0.6);
		rmSetAreaMinBlobs(foresteastID, 4);
		rmSetAreaMaxBlobs(foresteastID, 10);						
		rmSetAreaMinBlobDistance(foresteastID, 5.0);
		rmSetAreaMaxBlobDistance(foresteastID, 20.0);
		rmSetAreaCoherence(foresteastID, 0.4);
		rmSetAreaSmoothDistance(foresteastID, 10);
		rmAddAreaToClass(foresteastID, rmClassID("classForest"));
		
		rmAddAreaConstraint(foresteastID, avoidMediumForest);  
		rmAddAreaConstraint(foresteastID, avoidCloseImportantItem);
		rmAddAreaConstraint(foresteastID, avoidImpassableLand);
		rmAddAreaConstraint(foresteastID, playerConstraint);
		rmAddAreaConstraint(foresteastID, avoidCliff);
		rmAddAreaConstraint(foresteastID, avoidLake);
		rmAddAreaConstraint(foresteastID, avoidSocket);
		rmAddAreaConstraint(foresteastID, avoidCloseTradeRoute);
		rmAddAreaConstraint(foresteastID, playerEdgeConstraint);
		rmAddAreaConstraint(foresteastID, avoidNugget);
		rmAddAreaConstraint(foresteastID, avoidCoin);
		rmAddAreaConstraint(foresteastID, avoidAll);
		
		if(rmBuildArea(foresteastID)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
		else
		failCount=0; 
}

/*----------------------------------------------------------------------------------------------------------------*/

        if (cNumberNonGaiaPlayers <=2)
		numTries=4*cNumberNonGaiaPlayers;
	    else
		numTries=2*cNumberNonGaiaPlayers;
	    failCount=0;
	    for (i=0; <numTries)
{   
		int forestwestID=rmCreateArea("forestwestID"+i, westIslandID);
		rmSetAreaWarnFailure(forestwestID, false);
		rmSetAreaSize(forestwestID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaForestType(forestwestID, "amazon rain forest");
	}
        else
    {		
		rmSetAreaForestType(forestwestID, "Yucatan forest");
	}
	
		rmSetAreaForestDensity(forestwestID, 0.6);
		rmSetAreaForestClumpiness(forestwestID, 0.4);		
		rmSetAreaForestUnderbrush(forestwestID, 0.6);
		rmSetAreaMinBlobs(forestwestID, 4);
		rmSetAreaMaxBlobs(forestwestID, 10);						
		rmSetAreaMinBlobDistance(forestwestID, 5.0);
		rmSetAreaMaxBlobDistance(forestwestID, 20.0);
		rmSetAreaCoherence(forestwestID, 0.4);
		rmSetAreaSmoothDistance(forestwestID, 10);
		rmAddAreaToClass(forestwestID, rmClassID("classForest"));
		
		rmAddAreaConstraint(forestwestID, avoidMediumForest);  
		rmAddAreaConstraint(forestwestID, avoidCloseImportantItem);
		rmAddAreaConstraint(forestwestID, avoidImpassableLand);
		rmAddAreaConstraint(forestwestID, playerConstraint);
		rmAddAreaConstraint(forestwestID, avoidCliff);
		rmAddAreaConstraint(forestwestID, avoidLake);
		rmAddAreaConstraint(forestwestID, avoidSocket);
		rmAddAreaConstraint(forestwestID, avoidCloseTradeRoute);
		rmAddAreaConstraint(forestwestID, playerEdgeConstraint);
		rmAddAreaConstraint(forestwestID, avoidNugget);
		rmAddAreaConstraint(forestwestID, avoidCoin);
		rmAddAreaConstraint(forestwestID, avoidAll);
		
		if(rmBuildArea(forestwestID)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
		else
		failCount=0; 
}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/

	// TEXT:
	
	// RESOURCES THAT CAN BE PLACED AFTER FORESTS:

	// TEXT:
	
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //		
/*================================================================================================================*/

        // THE NORTHERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Berries 1");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
				
		rmAddObjectDefConstraint(BerriesID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(BerriesID, avoidAll);
		rmAddObjectDefConstraint(BerriesID, avoidLake);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCliff);
		rmAddObjectDefConstraint(BerriesID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidNugget);
		rmAddObjectDefConstraint(BerriesID, avoidForest);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, northIslandConstraint);
        rmAddObjectDefConstraint(BerriesID, avoidImpassableLand);
	    rmAddObjectDefConstraint(BerriesID, avoidTradeRoute);
	    rmAddObjectDefConstraint(BerriesID, avoidSocket);
	    		
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Berries 2");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
				
		rmAddObjectDefConstraint(Berries2ID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(Berries2ID, avoidAll);
		rmAddObjectDefConstraint(Berries2ID, avoidLake);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(Berries2ID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidNugget);
		rmAddObjectDefConstraint(Berries2ID, avoidForest);
		rmAddObjectDefConstraint(Berries2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, southIslandConstraint);
        rmAddObjectDefConstraint(Berries2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Berries2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(Berries2ID, avoidSocket);
	    		
		rmSetObjectDefCreateHerd(Berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);		
	    
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN:
		int Berries3ID=rmCreateObjectDef("The Berries 3");
        rmAddObjectDefItem(Berries3ID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(Berries3ID, 0.0);
        rmSetObjectDefMaxDistance(Berries3ID, rmXFractionToMeters(0.5));
				
		rmAddObjectDefConstraint(Berries3ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries3ID, avoidAll);
		rmAddObjectDefConstraint(Berries3ID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(Berries3ID, avoidForest);
		rmAddObjectDefConstraint(Berries3ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries3ID, eastIslandConstraint);
        rmAddObjectDefConstraint(Berries3ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Berries3ID, avoidCloseCliff);
		rmAddObjectDefConstraint(Berries3ID, avoidLake);
	    		
		rmSetObjectDefCreateHerd(Berries3ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);	
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE WESTERN:
		int Berries4ID=rmCreateObjectDef("The Berries 4");
        rmAddObjectDefItem(Berries4ID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(Berries4ID, 0.0);
        rmSetObjectDefMaxDistance(Berries4ID, rmXFractionToMeters(0.5));
				
		rmAddObjectDefConstraint(Berries4ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries4ID, avoidAll);
		rmAddObjectDefConstraint(Berries4ID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(Berries4ID, avoidForest);
		rmAddObjectDefConstraint(Berries4ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries4ID, westIslandConstraint);
        rmAddObjectDefConstraint(Berries4ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Berries4ID, avoidCloseCliff);
		rmAddObjectDefConstraint(Berries4ID, avoidLake);
	    		
		rmSetObjectDefCreateHerd(Berries4ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(Berries4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);			
	
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE TAPIRS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NORTHERN TAPIR: 
		int tapirNorthID = rmCreateObjectDef("tapir North herd ");
	    rmAddObjectDefItem(tapirNorthID, "tapir", rmRandInt(8,10), 8);
	    rmSetObjectDefMinDistance(tapirNorthID, 0.0);
	    rmSetObjectDefMaxDistance(tapirNorthID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(tapirNorthID, avoidFarTapir);
	    rmAddObjectDefConstraint(tapirNorthID, avoidAll);
		rmAddObjectDefConstraint(tapirNorthID, avoidCloseCliff);
		rmAddObjectDefConstraint(tapirNorthID, avoidLake);
		rmAddObjectDefConstraint(tapirNorthID, avoidForest);
		rmAddObjectDefConstraint(tapirNorthID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(tapirNorthID, avoidSocket);
		rmAddObjectDefConstraint(tapirNorthID, avoidCloseImpassableLand);
		rmAddObjectDefConstraint(tapirNorthID, playerCloseConstraint);
	    rmAddObjectDefConstraint(tapirNorthID, avoidNatives);
	    rmAddObjectDefConstraint(tapirNorthID, avoidNugget);
		rmAddObjectDefConstraint(tapirNorthID, avoidMediumFruits);
	    rmAddObjectDefConstraint(tapirNorthID, northIslandConstraint);
	    rmSetObjectDefCreateHerd(tapirNorthID, true);
	    rmPlaceObjectDefAtLoc(tapirNorthID, 0, 0.5, 0.5, 2);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN TAPIR:
		int tapirSouthID = rmCreateObjectDef("tapir South herd ");
	    rmAddObjectDefItem(tapirSouthID, "tapir", rmRandInt(8,10), 8);
	    rmSetObjectDefMinDistance(tapirSouthID, 0.0);
	    rmSetObjectDefMaxDistance(tapirSouthID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(tapirSouthID, avoidFarTapir);
	    rmAddObjectDefConstraint(tapirSouthID, avoidAll);
		rmAddObjectDefConstraint(tapirSouthID, avoidCloseCliff);
		rmAddObjectDefConstraint(tapirSouthID, avoidLake);
		rmAddObjectDefConstraint(tapirSouthID, avoidForest);
		rmAddObjectDefConstraint(tapirSouthID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(tapirSouthID, avoidSocket);
		rmAddObjectDefConstraint(tapirSouthID, avoidNugget);
		rmAddObjectDefConstraint(tapirSouthID, avoidCloseImpassableLand);
		rmAddObjectDefConstraint(tapirSouthID, playerCloseConstraint);
	    rmAddObjectDefConstraint(tapirSouthID, avoidNatives);
	    rmAddObjectDefConstraint(tapirSouthID, avoidMediumFruits);
	    rmAddObjectDefConstraint(tapirSouthID, southIslandConstraint);
	    rmSetObjectDefCreateHerd(tapirSouthID, true);
	    rmPlaceObjectDefAtLoc(tapirSouthID, 0, 0.5, 0.5, 2);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN TAPIR: 
		int tapirEastID = rmCreateObjectDef("tapir East herd ");
	    rmAddObjectDefItem(tapirEastID, "tapir", rmRandInt(8,10), 8);
	    rmSetObjectDefMinDistance(tapirEastID, 0.0);
	    rmSetObjectDefMaxDistance(tapirEastID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(tapirEastID, avoidFarTapir);
	    rmAddObjectDefConstraint(tapirEastID, avoidAll);
		rmAddObjectDefConstraint(tapirEastID, avoidLake);
		rmAddObjectDefConstraint(tapirEastID, avoidForest);
		rmAddObjectDefConstraint(tapirEastID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(tapirEastID, avoidCloseSocket);
		rmAddObjectDefConstraint(tapirEastID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(tapirEastID, avoidNatives);
	    rmAddObjectDefConstraint(tapirEastID, avoidCloseCliff);
		rmAddObjectDefConstraint(tapirEastID, avoidMediumFruits);
	    rmAddObjectDefConstraint(tapirEastID, eastIslandConstraint);
	    rmSetObjectDefCreateHerd(tapirEastID, true);
	    rmPlaceObjectDefAtLoc(tapirEastID, 0, 0.5, 0.5, 2);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE WESTERN TAPIR: 
		int tapirWestID = rmCreateObjectDef("tapir West herd ");
	    rmAddObjectDefItem(tapirWestID, "tapir", rmRandInt(8,10), 8);
	    rmSetObjectDefMinDistance(tapirWestID, 0.0);
	    rmSetObjectDefMaxDistance(tapirWestID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(tapirWestID, avoidFarTapir);
	    rmAddObjectDefConstraint(tapirWestID, avoidAll);
		rmAddObjectDefConstraint(tapirWestID, avoidLake);
		rmAddObjectDefConstraint(tapirWestID, avoidForest);
		rmAddObjectDefConstraint(tapirWestID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(tapirWestID, avoidCloseSocket);
		rmAddObjectDefConstraint(tapirWestID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(tapirWestID, avoidNatives);
	    rmAddObjectDefConstraint(tapirWestID, avoidCloseCliff);
		rmAddObjectDefConstraint(tapirWestID, avoidMediumFruits);
	    rmAddObjectDefConstraint(tapirWestID, westIslandConstraint);
	    rmSetObjectDefCreateHerd(tapirWestID, true);
	    rmPlaceObjectDefAtLoc(tapirWestID, 0, 0.5, 0.5, 2); 

/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SHEEP HERDS: **************************************** //
/*================================================================================================================*/

        int sheep1ID=rmCreateObjectDef("The Sheep herds 1");
			    
		int bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(2,3), 4.0);
	    else
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(4,6), 6.0);
	    
		rmSetObjectDefMinDistance(sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep1ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(sheep1ID, avoidAll);
		rmAddObjectDefConstraint(sheep1ID, northIslandConstraint);
		rmAddObjectDefConstraint(sheep1ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(sheep1ID, avoidForest);
		rmAddObjectDefConstraint(sheep1ID, avoidSocket);
		rmAddObjectDefConstraint(sheep1ID, avoidNugget);
		rmAddObjectDefConstraint(sheep1ID, avoidCoin);
		rmAddObjectDefConstraint(sheep1ID, avoidFruits);
		rmAddObjectDefConstraint(sheep1ID, playerConstraint);
	    rmAddObjectDefConstraint(sheep1ID, avoidVeryFarSheep);
	    rmAddObjectDefConstraint(sheep1ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sheep1ID, avoidLake);
		rmAddObjectDefConstraint(sheep1ID, avoidCloseCliff);
	    
	    rmSetObjectDefCreateHerd(sheep1ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);

/*----------------------------------------------------------------------------------------------------------------*/

        int sheep2ID=rmCreateObjectDef("The Sheep herds 2");
			    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(2,3), 4.0);
	    else
		rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(4,6), 6.0);
	    
		rmSetObjectDefMinDistance(sheep2ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(sheep2ID, avoidAll);
		rmAddObjectDefConstraint(sheep2ID, southIslandConstraint);
		rmAddObjectDefConstraint(sheep2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(sheep2ID, avoidForest);
		rmAddObjectDefConstraint(sheep2ID, avoidSocket);
		rmAddObjectDefConstraint(sheep2ID, avoidNugget);
		rmAddObjectDefConstraint(sheep2ID, avoidCoin);
		rmAddObjectDefConstraint(sheep2ID, avoidFruits);
		rmAddObjectDefConstraint(sheep2ID, playerConstraint);
	    rmAddObjectDefConstraint(sheep2ID, avoidVeryFarSheep);
	    rmAddObjectDefConstraint(sheep2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sheep2ID, avoidLake);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseCliff);
	    
	    rmSetObjectDefCreateHerd(sheep2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);

/*----------------------------------------------------------------------------------------------------------------*/

        int sheep3ID=rmCreateObjectDef("The Sheep herds 3");
			    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(sheep3ID, "sheep", rmRandInt(2,3), 4.0);
	    else
		rmAddObjectDefItem(sheep3ID, "sheep", rmRandInt(4,6), 6.0);
	    
		rmSetObjectDefMinDistance(sheep3ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep3ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(sheep3ID, avoidAll);
		rmAddObjectDefConstraint(sheep3ID, eastIslandConstraint);
		rmAddObjectDefConstraint(sheep3ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(sheep3ID, avoidForest);
		rmAddObjectDefConstraint(sheep3ID, avoidCloseCliff);
		rmAddObjectDefConstraint(sheep3ID, avoidNugget);
		rmAddObjectDefConstraint(sheep3ID, avoidCoin);
		rmAddObjectDefConstraint(sheep3ID, avoidFruits);
		rmAddObjectDefConstraint(sheep3ID, playerConstraint);
	    rmAddObjectDefConstraint(sheep3ID, avoidVeryFarSheep);
	    rmAddObjectDefConstraint(sheep3ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sheep3ID, avoidLake);
	    
	    rmSetObjectDefCreateHerd(sheep3ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(sheep3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);

/*----------------------------------------------------------------------------------------------------------------*/

        int sheep4ID=rmCreateObjectDef("The Sheep herds 4");
			    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(sheep4ID, "sheep", rmRandInt(2,3), 4.0);
	    else
		rmAddObjectDefItem(sheep4ID, "sheep", rmRandInt(4,6), 6.0);
	    
		rmSetObjectDefMinDistance(sheep4ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep4ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(sheep4ID, avoidAll);
		rmAddObjectDefConstraint(sheep4ID, westIslandConstraint);
		rmAddObjectDefConstraint(sheep4ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(sheep4ID, avoidForest);
		rmAddObjectDefConstraint(sheep4ID, avoidCloseCliff);
		rmAddObjectDefConstraint(sheep4ID, avoidNugget);
		rmAddObjectDefConstraint(sheep4ID, avoidCoin);
		rmAddObjectDefConstraint(sheep4ID, avoidFruits);
		rmAddObjectDefConstraint(sheep4ID, playerConstraint);
	    rmAddObjectDefConstraint(sheep4ID, avoidVeryFarSheep);
	    rmAddObjectDefConstraint(sheep4ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sheep4ID, avoidLake);
	    
	    rmSetObjectDefCreateHerd(sheep4ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(sheep4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE 4 ISLANDS:
		int randomTreeID=rmCreateObjectDef("North Random Trees");
				
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(randomTreeID, "TreeAmazon", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(randomTreeID, "TreeYucatan", 1, 0.0);
	}	
		
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint); 
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCliff);
		rmAddObjectDefConstraint(randomTreeID, avoidLake);
		rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomTreeID, playerConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 80*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
// ************************** DEFINE AND PLACE SOME RANDOM NORTHERN AND SOUTHERN CLIFFS: ************************ //
/*================================================================================================================*/
				
		if (cNumberNonGaiaPlayers<=2)
		numTries=cNumberNonGaiaPlayers*6;
		else
		numTries=cNumberNonGaiaPlayers*3;
	    failCount=0;
		
/*----------------------------------------------------------------------------------------------------------------*/		
	    
		for(i=0; <numTries)
{	
		int Cliff1ID=rmCreateArea("The Cliff 1"+i);
	    rmSetAreaSize(Cliff1ID, 0.0008, 0.0008);
		rmSetAreaWarnFailure(Cliff1ID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(Cliff1ID, "Amazon");
	}	
		else
	{	
		rmSetAreaCliffType(Cliff1ID, "Bayou");
	}	
		
		rmAddAreaToClass(Cliff1ID, rmClassID("classCliff"));		
		//rmSetAreaCliffEdge(Cliff1ID, 1, 0.6, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(Cliff1ID, 1, 1.0, 0.1, 1.0, 0);		
		rmSetAreaCliffPainting(Cliff1ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(Cliff1ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(Cliff1ID, 1.0);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(Cliff1ID, "amazon\ground4_ama", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(Cliff1ID, "bayou\ground2_bay", 0, 2);
	}	
		
        rmSetAreaSmoothDistance(Cliff1ID, 15);
		rmSetAreaCoherence(Cliff1ID, 0.85);
		
		rmAddAreaConstraint(Cliff1ID, avoidCloseTradeRoute);
		rmAddAreaConstraint(Cliff1ID, avoidCloseSocket);
		rmAddAreaConstraint(Cliff1ID, playerEdgeConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidAll);
		rmAddAreaConstraint(Cliff1ID, northIslandConstraint);
		rmAddAreaConstraint(Cliff1ID, playerMediumConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidCloseForest);
		rmAddAreaConstraint(Cliff1ID, avoidCloseLake);
		rmAddAreaConstraint(Cliff1ID, avoidCloseTrees);
		rmAddAreaConstraint(Cliff1ID, avoidCloseCoin);
		rmAddAreaConstraint(Cliff1ID, avoidCloseNugget);
		rmAddAreaConstraint(Cliff1ID, avoidCloseFruits);
		rmAddAreaConstraint(Cliff1ID, avoidVeryFarCliff);
						  	    		
		if(rmBuildArea(Cliff1ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
}	

/*----------------------------------------------------------------------------------------------------------------*/		

		for(i=0; <numTries)
	{	
		int Cliff2ID=rmCreateArea("The Cliff 2"+i);
	    rmSetAreaSize(Cliff2ID, 0.0008, 0.0008);
		rmSetAreaWarnFailure(Cliff2ID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(Cliff2ID, "Amazon");
	}	
		else
	{	
		rmSetAreaCliffType(Cliff2ID, "Bayou");
	}	
		
		rmAddAreaToClass(Cliff2ID, rmClassID("classCliff"));		
		//rmSetAreaCliffEdge(Cliff2ID, 1, 0.6, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(Cliff2ID, 1, 1.0, 0.1, 1.0, 0);			
		rmSetAreaCliffPainting(Cliff2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(Cliff2ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(Cliff2ID, 1.0);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(Cliff2ID, "amazon\ground4_ama", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(Cliff2ID, "bayou\ground2_bay", 0, 2);
	}	
		
        rmSetAreaSmoothDistance(Cliff2ID, 15);
		rmSetAreaCoherence(Cliff2ID, 0.85);
		
		rmAddAreaConstraint(Cliff2ID, avoidCloseTradeRoute);
		rmAddAreaConstraint(Cliff2ID, avoidCloseSocket);
		rmAddAreaConstraint(Cliff2ID, playerEdgeConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidAll);
		rmAddAreaConstraint(Cliff2ID, southIslandConstraint);
		rmAddAreaConstraint(Cliff2ID, playerMediumConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidCloseForest);
		rmAddAreaConstraint(Cliff2ID, avoidCloseLake);
		rmAddAreaConstraint(Cliff2ID, avoidCloseTrees);
		rmAddAreaConstraint(Cliff2ID, avoidCloseCoin);
		rmAddAreaConstraint(Cliff2ID, avoidCloseNugget);
		rmAddAreaConstraint(Cliff2ID, avoidCloseFruits);
		rmAddAreaConstraint(Cliff2ID, avoidVeryFarCliff);
					
		if(rmBuildArea(Cliff2ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
		
	}	
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE FISHBASS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
        		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		

	