/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// THE 6 NATIONS:
// JANUARY 2007:
// CREATED BY DANY:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int subCiv0=-1;
      int subCiv1=-1;
      int subCiv2=-1;
      int subCiv3=-1; 
	  int subCiv4=-1;
      int subCiv5=-1; 
	  
	  if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Iroquois");
   		 

		subCiv1=rmGetCivID("Iroquois");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Iroquois");
		 
	    subCiv4=rmGetCivID("Iroquois");
      if (subCiv4 >= 0)
         rmSetSubCiv(4, "Iroquois");

        subCiv5=rmGetCivID("Iroquois");
      if (subCiv5 >= 0)
         rmSetSubCiv(5, "Iroquois");		 
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
      int playerTiles=25000;
      
	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
      rmEchoInfo("Map size="+size+"m x "+size+"m");
      rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
      // PICKS A DEFAULT WATER HEIGHT:
      rmSetSeaLevel(1.0);

	  // SET THE MAP ELEVATION PARAMETERS:
	  // rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	  rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0);
	
	  // PICKS THE DEFAULT WATER:
	  rmSetSeaType("hudson bay");
	  rmEnableLocalWater(false);
	
	  // PICKS THE DEFAULT TERRAIN:
	  rmSetBaseTerrainMix("saguenay tundra");
	  
	  // PICKS THE TERRAIN INITIALIZATION:
	  rmTerrainInitialize("saguenay\ground1_sag",10);
	
	  // SET THE LIGHTING:
	  rmSetLightingSet("saguenay");
	
	  // SET THE MAP TYPE:
	  rmSetMapType("saguenay");
	  rmSetMapType("water");
	  rmSetMapType("grass");
	
	  // rmSetGlobalSnow( 0.7 );
	
	  // SET THE WORLD CIRCLE CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
      int classPlayer=rmDefineClass("player");
      rmDefineClass("startingUnit");
	  rmDefineClass("importantItem");
	  rmDefineClass("nuggets");
	  rmDefineClass("classSocket");
	  rmDefineClass("classForest");
	  rmDefineClass("secrets");
	  rmDefineClass("natives");
	  rmDefineClass("canyon");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHERS: ************************* //
/*================================================================================================================*/
      // MAP EDGE CONSTRAINTS:
      int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
      //int playerEdgeConstraint=rmCreatePieConstraint("player Avoid Edge of map",0.5,0.5,0,rmXTilesToFraction(5),rmDegreesToRadians(0),rmDegreesToRadians(360));	  
	  
	  // PLAYER CONSTRAINTS:
      int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 15.0);
	  
	  // RESOURCE AVOIDANCE:
      int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
      int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
      int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 15.0);
      int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 50.0);
      int avoidElk=rmCreateTypeDistanceConstraint("elk avoids elk", "Elk", 15.0);
      int avoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "Moose", 15.0);
      int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
      int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 15.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 15.0);
      int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 15.0);
	  int avoidBerries=rmCreateTypeDistanceConstraint("stuff avoid berries", "berryBush", 6.0);
	  
	  // GOLD AVOIDANCE:
	  int avoidGold=rmCreateTypeDistanceConstraint("stuff avoids gold", "minegold", 4.0);
	  int goldAvoidGold=rmCreateTypeDistanceConstraint("gold avoids gold", "minegold", 8.0);
      
	  // NATIVES AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 8.0);
	  
	   // CANYON AVOIDANCE:
      int avoidCanyon=rmCreateClassDistanceConstraint("avoid canyon", rmClassID("Canyon"), 8.0);

	  
	  // UNIT AVOIDANCE:
	  int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
	  int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
	  
	  // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
	  
	  // AVOID IMPASSABLE LAND:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
      int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
    
	  
	  // TRADE ROUTE AVOIDANCE:
      // VP AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
      int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route long", 20.0);
      int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
      int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
      int secretsAvoidSecrets = rmCreateClassDistanceConstraint("secrets avoid secrets", rmClassID("secrets"), 60.0);

	  // CONSTRAINT TO AVOID WATER:
      int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 8.0);
      int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water 16", "Land", false, 16.0);
	  
	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));


/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// ***************************************** DEFINE AND CREATE THE AREAS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// **************************************** DEFINE THE TRADE ROUTE HACK: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** //
/*================================================================================================================*/
   // Player placement - only if you're playing two teams do you get the funkiness.
   // DAL TAKING OUT MADNESS
   /*
   	if ( cNumberTeams == 2 )
	{

		rmSetPlacementTeam(0);
		// rmSetPlacementSection(0.3, 0.9);
		if ( cNumberNonGaiaPlayers < 5 )
		{
			rmSetPlacementSection(0.95, 0.3);
			rmPlacePlayersCircular(0.38, 0.45, 0.4);
		}
		else
		{
			rmSetPlacementSection(0.9, 0.35);
			rmPlacePlayersCircular(0.38, 0.42, 0.3);
		}
		
		// rmSetPlayerPlacementArea(0.5, 0.5, 0.9, 0.9); 
		// Map variation variable - which side does the water team land on
		int whichLandingSide=-1;
		whichLandingSide = rmRandInt(1,2);

		// rmPlacePlayersCircular(0.45, 0.45, rmDegreesToRadians(5.0));
		rmSetPlacementTeam(1);
		rmSetPlayerPlacementArea(0.08, 0.08, 0.32, 0.32);
		rmPlacePlayersCircular(0.40, 0.45, 0.0);
	}
	else	// FFA placement
	{
		rmSetPlacementSection(0.3, 0.95);
		rmPlacePlayersCircular(0.4, 0.4, 0.1);
	}
	*/

	rmSetPlacementSection(0.3, 0.95);
	rmPlacePlayersCircular(0.4, 0.4, 0.1);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(50);
/*----------------------------------------------------------------------------------------------------------------*/
	  for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD THE AREA CONSTRAINT:
	  // rmAddAreaConstraint(id, avoidWater16); 
	  rmAddAreaConstraint(id, avoidTradeRouteFar); 
	  rmAddAreaConstraint(id, avoidSocket); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      
	  // SET THE AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
      
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
   }
/*----------------------------------------------------------------------------------------------------------------*/
      // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE 2 SMALLMESA: **************************************** //
/*================================================================================================================*/
        int numTries = 1;
	  
	    for(i=0; <numTries)
	{
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa 1"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(800), rmAreaTilesToFraction(800));  
		rmSetAreaWarnFailure(smallMesaID, false);
		// rmSetAreaCliffType(smallMesaID, "Bayou");
		   rmSetAreaCliffType(smallMesaID, "New England");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	
		// rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesaID, 2, 0.4, 0.1, 1.0, 0);
		// rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0);
           rmSetAreaCliffHeight(smallMesaID, -8, 1.0, 1.0); 		
		rmSetAreaCoherence(smallMesaID, 0.88);
		rmSetAreaMix(smallMesaID, "saguenay tundra");
		rmSetAreaLocation(smallMesaID, 0.325, 0.675); 
		rmBuildArea(smallMesaID);
	}
/*----------------------------------------------------------------------------------------------------------------*/
        int gold1ID= rmCreateObjectDef("Gold Mines 1"); 
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
		rmAddObjectDefConstraint(gold1ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.325, 0.675);
/*----------------------------------------------------------------------------------------------------------------*/		
	// SPECIAL AREA CONSTRAINT AND USE IT TO MAKE RESOURCES AVOID THE BIG MTN IN THE CENTER:
		int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);
		
		 for(i=0; <numTries)
	{
		int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2"+i);
		rmSetAreaSize(smallMesa2ID, rmAreaTilesToFraction(800), rmAreaTilesToFraction(800));  
		rmSetAreaWarnFailure(smallMesa2ID, false);
		// rmSetAreaCliffType(smallMesa2ID, "Bayou");
		   rmSetAreaCliffType(smallMesa2ID, "New England");
		rmAddAreaToClass(smallMesa2ID, rmClassID("canyon"));	
		// rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesa2ID, 2, 0.4, 0.1, 1.0, 0);
		// rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6, 8), 1.0, 1.0); 
		   rmSetAreaCliffHeight(smallMesa2ID, -8, 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa2ID, 0.88);
		rmSetAreaMix(smallMesa2ID, "saguenay tundra");
		rmSetAreaLocation(smallMesa2ID, 0.675, 0.325); 
		rmBuildArea(smallMesa2ID);
	}	
/*----------------------------------------------------------------------------------------------------------------*/
        int gold2ID= rmCreateObjectDef("Gold Mines 2"); 
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
		rmAddObjectDefConstraint(gold2ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.675, 0.325);
/*================================================================================================================*/   
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// **************************************** DEFINE THE PLACEMENT ORDER: ***************************************** //
/*================================================================================================================*/
// Trade route -> River (none on this map) -> Natives -> Cliffs -> Nuggets
// Trade route has 5 poles across map, or 3 (depending on whichVariation roll)
// 4 natives (typically)
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
// ********************** DEFINE AND PLACE THE NATIVE VILLAGES AND SECRETS OF THE NEW WORLD: ******************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.5, 0.15);
	} 
	
	    if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.2, 0.8);
	} 
	
	    if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.8, 0.2);
	} 
	
	    if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.15, 0.5);
	} 
	
	    if (subCiv4 == rmGetCivID("iroquois"))
	{  
		int iroquois5VillageID = -1;
		iroquois5VillageID = rmCreateGrouping("iroquois village 5", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois5VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois5VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois5VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois5VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois5VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.55, 0.90);
	} 
	
	    if (subCiv5 == rmGetCivID("iroquois"))
	{  
		int iroquois6VillageID = -1;
		iroquois6VillageID = rmCreateGrouping("iroquois village 6", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois6VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois6VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois6VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois6VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois6VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.90, 0.55);
	} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ******************************** DEFINE THE STARTING TCID AND STARTING UNITS: ******************************** //
/*================================================================================================================*/
    // NEW Starting Unit placement
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	rmSetObjectDefMinDistance(startingUnits, 5.0);
	rmSetObjectDefMaxDistance(startingUnits, 10.0);
	rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startingUnits, avoidAll);
	rmAddObjectDefConstraint(startingUnits, avoidSocket);

	int startingTCID= rmCreateObjectDef("startingTC");
	if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	rmSetObjectDefMinDistance(startingTCID, 0.0);
	if ( cNumberTeams == 2 )
	{
		rmSetObjectDefMaxDistance(startingTCID, 5.0); // DAL - was 60
	}
	else	// FFA
	{
		rmSetObjectDefMaxDistance(startingTCID, 5.0);
	}
	rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	rmAddObjectDefConstraint(startingTCID, avoidSocket);
	rmAddObjectDefConstraint(startingTCID, avoidWater8);
	rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
	  // DEFINE THE STARTING TREES:
	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  rmAddObjectDefItem(StartAreaTreeID, "TreeSaguenay", 1, 0.0);
	  rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	  // DEFINE THE STARTING DEERS:
	  int StartDeerID=rmCreateObjectDef("starting deer");
	  rmAddObjectDefItem(StartDeerID, "deer", 3, 4.0);
	  rmSetObjectDefMinDistance(StartDeerID, 12.0);
	  rmSetObjectDefMaxDistance(StartDeerID, 18.0);
	  rmSetObjectDefCreateHerd(StartDeerID, true);
	  rmAddObjectDefConstraint(StartDeerID, avoidStartingUnitsSmall);

	  // DEFINE THE STARTING RESOURCE BUILDING:
	  // DALTEMP:
	  int startResourceBuildingID=rmCreateObjectDef("starting resource building");
	  int whichBuilding = rmRandInt(1,4);
	  if ( whichBuilding == 1 )
	  {
		   rmAddObjectDefItem(startResourceBuildingID, "Mill", 1, 0.0);
	  }
	       else if ( whichBuilding == 2 )
	  {
		   rmAddObjectDefItem(startResourceBuildingID, "Plantation", 1, 0.0);
	  }
	       else if ( whichBuilding == 3 )
	  {
		   rmAddObjectDefItem(startResourceBuildingID, "Market", 1, 0.0);
	  }
	       else
	  {
		   rmAddObjectDefItem(startResourceBuildingID, "LivestockPen", 1, 0.0);
	  }
	  rmSetObjectDefMinDistance(startResourceBuildingID, 16.0);
	  rmSetObjectDefMaxDistance(startResourceBuildingID, 20.0);
	  rmAddObjectDefConstraint(startResourceBuildingID, avoidStartingUnitsSmall);
	  rmAddObjectDefConstraint(startResourceBuildingID, playerEdgeConstraint);
	  rmAddObjectDefToClass(startResourceBuildingID, rmClassID("startingUnit"));

      // DEFINE THE STARTING SILVER:
      int silverID = -1;
	  int silverType = rmRandInt(1,10);
	  int playerGoldID = -1;

	  // EVERYONE GETS TWO ORE MINES, ONE PRETTY CLOSE,THE OTHER A LITTLE FURTHER AWAY:
	  silverType = rmRandInt(1,10);
	  playerGoldID = rmCreateObjectDef("player silver "+i);
	  rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
	  // rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
	  rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
	  rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
	  rmSetObjectDefMinDistance(playerGoldID, 15.0);
	  rmSetObjectDefMaxDistance(playerGoldID, 20.0);
	
	  // EXTRA CRATES FOR THE STARTING GUYS (IF NOT FFA)
	  int extraCrate=rmCreateObjectDef("extra crate");
	  rmAddObjectDefItem(extraCrate, "CrateofFood", 1, 0.0);
	  rmSetObjectDefMinDistance(extraCrate, 6.0);
	  rmSetObjectDefMaxDistance(extraCrate, 9.0);

	  // DEFINE THE PLAYER NUGGET:
	  int playerNuggetID=rmCreateObjectDef("player nugget");
	  rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
      rmSetObjectDefMinDistance(playerNuggetID, 30.0);
      rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	  rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	  rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	  // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);
	  
	  //DEFINE THE PLAYER BERRIES:
	  int playerBerriesID=rmCreateObjectDef("player berries");
	  rmAddObjectDefItem(playerBerriesID, "berryBush", rmRandInt(4,6), 4.0);	//(X,X) - number of objects.  The last # is the range of distance around the center point that the objects will place.  Low means tight, higher means more widely scattered.
      rmSetObjectDefMinDistance(playerBerriesID, 21);
      rmSetObjectDefMaxDistance(playerBerriesID, 26);		
	  rmAddObjectDefConstraint(playerBerriesID, avoidAll);
	  rmAddObjectDefConstraint(playerBerriesID, avoidStartingUnitsSmall);
	  rmAddObjectDefConstraint(playerBerriesID, avoidNugget);
      rmAddObjectDefConstraint(playerBerriesID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(playerBerriesID, true);
/*================================================================================================================*/
// *************************** JOHN'S SWEET SOLUTION TO PLACING STUFF AROUND THE TC: **************************** //
// *************************** REGARDLESS OF WHERE THE PLAYER START AREA ACTUALLY IS: *************************** //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
		
		if ( rmGetNomadStart() == false )
		{
			rmPlaceObjectDefAtLoc(startResourceBuildingID, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		}
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation))); 
				
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		// Player nuggets
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// ************************************ LET'S TRY PONDS INSTEAD OF CLIFFS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	  int pondClass=rmDefineClass("pond");
      int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 20.0);

      int numPonds=cNumberNonGaiaPlayers;
	  for(i=0; <numPonds)
   {
      int smallPondID=rmCreateArea("small pond"+i);
      // rmSetAreaSize(smallPondID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(400));
	     rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1250), rmAreaTilesToFraction(1400));
      rmSetAreaWaterType(smallPondID, "saguenay lake");
      rmSetAreaBaseHeight(smallPondID, 4);
      rmAddAreaToClass(smallPondID, pondClass);
      rmSetAreaCoherence(smallPondID, 0.4);
      rmSetAreaSmoothDistance(smallPondID, 5);
      rmAddAreaConstraint(smallPondID, pondConstraint);
      rmAddAreaConstraint(smallPondID, avoidTradeRoute);
      rmAddAreaConstraint(smallPondID, avoidImportantItem);
      rmAddAreaConstraint(smallPondID, avoidImpassableLand);
      //rmAddAreaConstraint(smallPondID, avoidCliffs);
	  rmAddAreaConstraint(smallPondID, avoidSocket);
	  //rmAddAreaConstraint(smallPondID, avoidStartingUnitsBay);
	  //rmAddAreaConstraint(smallPondID, Southward);
      rmSetAreaWarnFailure(smallPondID, false);
	  rmSetAreaLocation(smallPondID, 0.7, 0.7);
      rmBuildArea(smallPondID);
   }
   
      for(i=0; <numPonds)
   {
      int smallPond2ID=rmCreateArea("small pond 2"+i);
      // rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(400));
	     rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(1250), rmAreaTilesToFraction(1400));
      rmSetAreaWaterType(smallPond2ID, "saguenay lake");
      rmSetAreaBaseHeight(smallPond2ID, 4);
      rmAddAreaToClass(smallPond2ID, pondClass);
      rmSetAreaCoherence(smallPond2ID, 0.4);
      rmSetAreaSmoothDistance(smallPond2ID, 5);
      rmAddAreaConstraint(smallPond2ID, pondConstraint);
      rmAddAreaConstraint(smallPond2ID, avoidTradeRoute);
      rmAddAreaConstraint(smallPond2ID, avoidImportantItem);
      rmAddAreaConstraint(smallPond2ID, avoidImpassableLand);
      //rmAddAreaConstraint(smallPond2ID, avoidCliffs);
	  rmAddAreaConstraint(smallPond2ID, avoidSocket);
	  //rmAddAreaConstraint(smallPond2ID, avoidStartingUnitsBay);
	  //rmAddAreaConstraint(smallPond2ID, Southward);
      rmSetAreaWarnFailure(smallPond2ID, false);
	  rmSetAreaLocation(smallPond2ID, 0.3, 0.3);
      rmBuildArea(smallPond2ID);
   }
   
     for(i=0; <numPonds)
   {
      int smallPond3ID=rmCreateArea("small pond 3"+i);
      // rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(400));
	     rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
      rmSetAreaWaterType(smallPond3ID, "saguenay lake");
      rmSetAreaBaseHeight(smallPond3ID, 4);
      rmAddAreaToClass(smallPond3ID, pondClass);
      rmSetAreaCoherence(smallPond3ID, 0.4);
      rmSetAreaSmoothDistance(smallPond3ID, 5);
      rmAddAreaConstraint(smallPond3ID, pondConstraint);
      rmAddAreaConstraint(smallPond3ID, avoidTradeRoute);
      rmAddAreaConstraint(smallPond3ID, avoidImportantItem);
      rmAddAreaConstraint(smallPond3ID, avoidImpassableLand);
      //rmAddAreaConstraint(smallPond3ID, avoidCliffs);
	  rmAddAreaConstraint(smallPond3ID, avoidSocket);
	  //rmAddAreaConstraint(smallPond3ID, avoidStartingUnitsBay);
	  //rmAddAreaConstraint(smallPond3ID, Southward);
      rmSetAreaWarnFailure(smallPond3ID, false);
	  rmSetAreaLocation(smallPond3ID, 0.5, 0.5);
      rmBuildArea(smallPond3ID);
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ****************************************** DEFINE AND PLACE THE NUGGETS: ************************************* //
/*================================================================================================================*/
 // NONE FOR NOW:
 /*---------------------------------------------------------------------------------------------------------------*/
      int nuggetID= rmCreateObjectDef("nugget"); 
	  rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	  rmSetObjectDefMinDistance(nuggetID, 0.0);
	  rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
  	  rmAddObjectDefConstraint(nuggetID, avoidNugget);
  	  rmAddObjectDefConstraint(nuggetID, avoidAll);
	  rmAddObjectDefConstraint(nuggetID, avoidCanyon);
	  rmAddObjectDefConstraint(nuggetID, avoidNatives);
  	  rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
	  rmAddObjectDefConstraint(nuggetID, avoidStartingUnits);
	  rmAddObjectDefConstraint(nuggetID, circleConstraint);
	  rmSetNuggetDifficulty(1, 3);
	  rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5);
 /*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE FISHES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE FISHSALMON: ************************************** //
/*================================================================================================================*/   
      int fishID=rmCreateObjectDef("fish");
      rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
      rmSetObjectDefMinDistance(fishID, 0.0);
      rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fishID, fishVsFishID);
      rmAddObjectDefConstraint(fishID, fishLand);
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);
/*================================================================================================================*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ******************************* PLACE RESOURCES THAT WE WANT FORESTS TO AVOID: ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // FAST COIN -- Ore Mines
	    silverType = -1;
	    silverID = -1;
	    int silverCount = cNumberNonGaiaPlayers*5;
	    rmEchoInfo("silver count 1 = "+silverCount);

	    // Five per player.
	    for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("silver "+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, avoidCoin);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidCanyon);
		rmAddObjectDefConstraint(silverID, avoidNatives);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidSocket);
		rmAddObjectDefConstraint(silverID, avoidStartingUnits);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// ***************************************** DEFINE AND PLACE FORESTS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
 int forestTreeID = 0;
         numTries=6*cNumberNonGaiaPlayers;
         int failCount=0;
         for (i=0; <numTries)
      {   
         int forest=rmCreateArea("forest "+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(400));
         rmSetAreaForestType(forest, "saguenay forest");
			// rmSetAreaForestType(forest, "dunes");
         rmSetAreaForestDensity(forest, 0.9);
         rmSetAreaForestClumpiness(forest, 0.8);
         rmSetAreaForestUnderbrush(forest, 0.0);
         rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 5);
         rmSetAreaMinBlobDistance(forest, 10.0);
         rmSetAreaMaxBlobDistance(forest, 30.0);
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
         rmAddAreaConstraint(forest, forestConstraint);
         rmAddAreaConstraint(forest, avoidAll);
         rmAddAreaConstraint(forest, avoidBerries);
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidTradeRoute); 
			rmAddAreaConstraint(forest, avoidSocket);
			rmAddAreaConstraint(forest, avoidCanyon);
			rmAddAreaConstraint(forest, avoidNatives);
			rmAddAreaConstraint(forest, avoidStartingUnits); 
         if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE ANIMALS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/   
// ***************************************** DEFINE AND PLACE YHE ELKS: ***************************************** //
/*================================================================================================================*/
      int elkID=rmCreateObjectDef("elk herd");
	  rmAddObjectDefItem(elkID, "elk", rmRandInt(7,8), 6.0);
      rmSetObjectDefMinDistance(elkID, 0.0);
      rmSetObjectDefMaxDistance(elkID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(elkID, avoidElk);
      rmAddObjectDefConstraint(elkID, avoidMoose);
	  rmAddObjectDefConstraint(elkID, avoidAll);
	  rmAddObjectDefConstraint(elkID, avoidCanyon);
	  rmAddObjectDefConstraint(elkID, avoidNatives);
      rmAddObjectDefConstraint(elkID, avoidImpassableLand);
	  rmAddObjectDefConstraint(elkID, avoidSocket);
	  rmAddObjectDefConstraint(elkID, avoidTradeRoute);
	  rmAddObjectDefConstraint(elkID, avoidStartingUnits);

      rmSetObjectDefCreateHerd(elkID, true);
	  rmPlaceObjectDefAtLoc(elkID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE MOOSES: **************************************** //
/*================================================================================================================*/
      int mooseID=rmCreateObjectDef("moose herd");
	  rmAddObjectDefItem(mooseID, "moose", rmRandInt(4,5), 8.0);
      rmSetObjectDefMinDistance(mooseID, 0.0);
      rmSetObjectDefMaxDistance(mooseID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(mooseID, avoidElk);
      rmAddObjectDefConstraint(mooseID, avoidMoose);
	  rmAddObjectDefConstraint(mooseID, avoidAll);
	  rmAddObjectDefConstraint(mooseID, avoidCanyon);
	  rmAddObjectDefConstraint(mooseID, avoidNatives);
      rmAddObjectDefConstraint(mooseID, avoidImpassableLand);
	  rmAddObjectDefConstraint(mooseID, avoidSocket);
	  rmAddObjectDefConstraint(mooseID, avoidTradeRoute);
	  rmAddObjectDefConstraint(mooseID, avoidStartingUnits);

      rmSetObjectDefCreateHerd(mooseID, true);
	  rmPlaceObjectDefAtLoc(mooseID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE DOMESTICS ANIMALS: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE SHEEP: ***************************************** //
/*================================================================================================================*/
      int sheepID=rmCreateObjectDef("sheep");
      rmAddObjectDefItem(sheepID, "sheep", 2, 3.0);
      rmSetObjectDefMinDistance(sheepID, 0.0);
      rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(sheepID, avoidSheep);
      rmAddObjectDefConstraint(sheepID, avoidElk);
      rmAddObjectDefConstraint(sheepID, avoidMoose);
	  rmAddObjectDefConstraint(sheepID, avoidAll);
	  rmAddObjectDefConstraint(sheepID, avoidCanyon);
	  rmAddObjectDefConstraint(sheepID, avoidNatives);
      rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
	  rmAddObjectDefConstraint(sheepID, avoidSocket);
	  rmAddObjectDefConstraint(sheepID, avoidTradeRoute);
	  rmAddObjectDefConstraint(sheepID, avoidStartingUnits);
      rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRYBUSH: **************************************** //	  
/*================================================================================================================*/
	  int berriesID= rmCreateObjectDef("The Berries"); 
	  rmAddObjectDefItem(berriesID, "berryBush", rmRandInt(3,5), 8.0);
	  rmSetObjectDefMinDistance(berriesID, 0.0);
      rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	  rmAddObjectDefConstraint(berriesID, avoidBerries);
	  rmAddObjectDefConstraint(berriesID, avoidSheep);
      rmAddObjectDefConstraint(berriesID, avoidElk);
      rmAddObjectDefConstraint(berriesID, avoidMoose);
	  rmAddObjectDefConstraint(berriesID, avoidAll);
	  rmAddObjectDefConstraint(berriesID, avoidCanyon);
	  rmAddObjectDefConstraint(berriesID, avoidNatives);
      rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
	  rmAddObjectDefConstraint(berriesID, avoidSocket);
	  rmAddObjectDefConstraint(berriesID, avoidTradeRoute);
	  rmAddObjectDefConstraint(berriesID, avoidStartingUnits);
	  rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE FLAGS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //  
/*================================================================================================================*/
  
  
  
  


	  