/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/

// THE BIG WAR:
// CREATED BY DANY:
// AUGUST 2007:
// A RANDOM MAP FOR AGE OF EMPIRES III: MY 59TH RMS:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/
// **************************************** DEFINE THE 10 VARIATIONS: ******************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	
	    // DEFINE WHICHVARIATION:
		// ONLY 2 VARIATIONS:
		int whichVariation=rmRandInt(1,2);	
		
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

     if (rmAllocateSubCivs(4) == true)
		
{
		if ( whichVariation == 1 )
	{	
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");
		
		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee");
		
		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");
		
		subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cherokee");
	}
	
        else
		
	{	
		subCiv0=rmGetCivID("Comanche");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Comanche");
				
		subCiv1=rmGetCivID("Comanche");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Comanche");
		
		subCiv2=rmGetCivID("Comanche");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Comanche");

		subCiv3=rmGetCivID("Comanche");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Comanche");
	}	
} 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // PICKS THE MAP SIZE:
	    int playerTiles=22500;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(600, 600);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	
     	// SET MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	    rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
	
	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(4.0);
	    
        // SET SEA TYPE:
	    rmSetSeaType("Amazon River");
		
/*----------------------------------------------------------------------------------------------------------------*/
		
		if ( whichVariation == 1 )
	
    {	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("texas_grass");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("texas\ground5_tex", 5.0);
		
	}
        else
		
	{
    	// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("texas_dirt");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("texas\ground6_tex", 5.0);

    }

/*----------------------------------------------------------------------------------------------------------------*/
		
		// SET LIGHTING:
		rmSetLightingSet("Texas");
	    
		// SET MAP TYPE:
		rmSetMapType("texas");
	    rmSetMapType("grass");
	    rmSetMapType("land");

	    // CORNER CONSTRAINT:
	    rmSetWorldCircleConstraint(true);
		
		// CHOOSE THE MERCS:
	    chooseMercs();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classHill");
        rmDefineClass("classPatch");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("secrets");
	    rmDefineClass("nuggets");
	    rmDefineClass("center");
	    rmDefineClass("classCotton");

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
	    int bisonEdgeConstraint=rmCreateBoxConstraint("bison edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
        int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  //DAL - was 24
	    // int goldCenterConstraint=rmCreateBoxConstraint("gold keeps away from middle", 0.2, 0.2, 0.8, 0.8, 0.01);
	    int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 30.0);
	    int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), 60.0);

        // CARDINAL DIRECTIONS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

        // PLAYER CONSTRAINTS:
        int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 20.0);
	    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);

	    // NATURE AVOIDANCE:
	    // int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
	    // int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
	    int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
	    int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
	    
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// TURKEYS AVOIDANCE:
		int avoidTurkeys=rmCreateTypeDistanceConstraint("stuffs avoids turkeys", "turkey", 10.0);
		int avoidCloseTurkeys=rmCreateTypeDistanceConstraint("close avoids turkeys", "turkey", 2.0);
						
		// SILVER AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "mine", 10.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "mine", 5.0);

	    // COIN CONSTRAINT DROPS ON SMALLER MAPS:
	    int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "mine", 35.0);
	    if ( cNumberNonGaiaPlayers < 4 )
	{
		coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin small maps", "gold", 25.0);
	}

	    int cottonConstraint=rmCreateClassDistanceConstraint("cotton constraint", rmClassID("classCotton"), 30.0);
	    int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   
        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
        int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 10.0);
        int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
        int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	    
		// CLIFFS AVOIDANCE:
		int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 14.0);
		int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 8.0);
	    int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);

        // UNIT AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
        int avoidStartingUnitsLarge=rmCreateClassDistanceConstraint("objects avoid starting units large", rmClassID("startingUnit"), 50.0);
        int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
        int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 10.0);
        int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 30.0);
	    int avoidSecrets=rmCreateClassDistanceConstraint("stuff avoids secrets", rmClassID("secrets"), 20.0);
	    int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 35.0);
	    int forestsAvoidBison=rmCreateTypeDistanceConstraint("forest avoids bison", "bison", 20.0);
		
		// COWS AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
		
		// SHEEPS AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 2.0);
			
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// BISON AVOIDANCE:
		int avoidBison=rmCreateTypeDistanceConstraint("stuff avoids bison", "bison", 10.0);
		int avoidCloseBison=rmCreateTypeDistanceConstraint("close avoids bison", "bison", 2.0);
		

	    // DECORATION AVOIDANCE:
	    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	    // TRADE ROUTE AVOIDANCE:
	    int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	    int avoidTradeRouteCliff = rmCreateTradeRouteDistanceConstraint("trade route cliff", 10.0);
	    int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
        
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// *********************************** DEFINE THE SET UP STARTING LOCATIONS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if ( whichVariation == 1 )
							
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.7,0.7);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.3,0.3);
	}  
		else
    {		
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.3,0.3);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.7,0.7);
	} 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// *************************************** DEFINE THE SET UP PLAYER AREAS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        float playerFraction=rmAreaTilesToFraction(100);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "texas\ground2");
      
	    // SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
   
        // Build the areas.
        rmBuildAllAreas();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// *************************************** DEFINE THE PLACEMENT ORDER: ****************************************** //   
/*================================================================================================================*/   
 	
	    // Placement order
	    // Trade Route -> Players and player stuff -> Natives -> Secrets -> Cliffs -> Nuggets
	    // Place other objects that were defined earlier
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/	
// *********************************** DEFINE AND PLACE THE 2 TRADES ROUTE: ************************************* //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// ************************************** DEFINE AND PLACE 4 TRADE ROUTES: ************************************** //
/*================================================================================================================*/
    
        // DEFINE THE TRADE SOCKETS:
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 6.0);

/*----------------------------------------------------------------------------------------------------------------*/		

        if ( whichVariation == 1 )
		
	{	
        
		int tradeRouteID = rmCreateTradeRoute();
		
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.60, 1.00);
	    rmAddTradeRouteWaypoint(tradeRouteID, 1.00, 0.60);
	
	    bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
	    rmEchoError("Failed to place trade route #1");
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	    int tradeRouteID2 = rmCreateTradeRoute();
	
	    rmAddTradeRouteWaypoint(tradeRouteID2, 0.00, 0.40);
	    rmAddTradeRouteWaypoint(tradeRouteID2, 0.40, 0.00);
		
	    bool placedTradeRoute2 = rmBuildTradeRoute(tradeRouteID2, "carolinas\trade_route");
	    if(placedTradeRoute2 == false)
	    rmEchoError("Failed to place trade route #2");
	
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** add the meeting poles along the trade route. ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   
        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   
        rmClearClosestPointConstraints();
   
/*----------------------------------------------------------------------------------------------------------------*/

        // change the trade route for the new sockets
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID2);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.50);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints();
	
}	

/*----------------------------------------------------------------------------------------------------------------*/
       
	   else
	   
/*----------------------------------------------------------------------------------------------------------------*/	   
    {
	
	    int tradeRouteID3 = rmCreateTradeRoute();
	
	    rmAddTradeRouteWaypoint(tradeRouteID3, 0.16, 0.84);
	    rmAddTradeRouteWaypoint(tradeRouteID3, 0.40, 0.60);
		
	    bool placedTradeRoute3 = rmBuildTradeRoute(tradeRouteID3, "carolinas\trade_route");
	    if(placedTradeRoute3 == false)
	    rmEchoError("Failed to place trade route #3");

/*----------------------------------------------------------------------------------------------------------------*/

        int tradeRouteID4 = rmCreateTradeRoute();
	
	    rmAddTradeRouteWaypoint(tradeRouteID4, 0.84, 0.16);
	    rmAddTradeRouteWaypoint(tradeRouteID4, 0.60, 0.40);
		
	    bool placedTradeRoute4 = rmBuildTradeRoute(tradeRouteID4, "carolinas\trade_route");
	    if(placedTradeRoute4 == false)
	    rmEchoError("Failed to place trade route #4");	
	
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** add the meeting poles along the trade route. ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

        // change the trade route for the new sockets
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID3);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints(); 

/*----------------------------------------------------------------------------------------------------------------*/

        // change the trade route for the new sockets
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID4);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints(); 

}		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ***************************** DEFINE THE STARTING UNITS AND TCID AND RESOURCES: ****************************** //
/*================================================================================================================*/
   
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
		// Give it a little wiggle room for maps with greater than four players
		if ( cNumberNonGaiaPlayers > 4 )
		{
			rmSetObjectDefMinDistance(startingTCID, 0.0);
			rmSetObjectDefMaxDistance(startingTCID, 6.0);
		}
	}

/*----------------------------------------------------------------------------------------------------------------*/	
	
	    int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 12.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
		
		int StartFarBerryBushID=rmCreateObjectDef("starting far berry bush");
	    rmAddObjectDefItem(StartFarBerryBushID, "BerryBush", 3, 5.0);
	    rmSetObjectDefMinDistance(StartFarBerryBushID, 24.0);
	    rmSetObjectDefMaxDistance(StartFarBerryBushID, 28.0);
	    rmAddObjectDefConstraint(StartFarBerryBushID, avoidStartingUnitsSmall);
	
        int playerBisonID=rmCreateObjectDef("player bison herd");
        rmAddObjectDefItem(playerBisonID, "bison", rmRandInt(6,8), 6.0);
        rmSetObjectDefMinDistance(playerBisonID, 20.0);
        rmSetObjectDefMaxDistance(playerBisonID, 25.0);
	    rmAddObjectDefConstraint(playerBisonID, avoidTradeRoute);
	    rmAddObjectDefConstraint(playerBisonID, avoidImportantItem);
	    rmSetObjectDefCreateHerd(playerBisonID, true);
		
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 8);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	    rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);

	    int StartPronghornID=rmCreateObjectDef("starting pronghorn");
	    rmAddObjectDefItem(StartPronghornID, "pronghorn", 4, 4.0);
	    rmSetObjectDefMinDistance(StartPronghornID, 5);
	    rmSetObjectDefMaxDistance(StartPronghornID, 12);
	    rmAddObjectDefConstraint(StartPronghornID, avoidStartResource);
	    rmAddObjectDefConstraint(StartPronghornID, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(StartPronghornID, avoidNatives);
	    rmSetObjectDefCreateHerd(StartPronghornID, true);

	    int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 25.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteCliff);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	    int playerGoldID=rmCreateObjectDef("player silver ore");
	    int silverType = rmRandInt(1,10);
		
/*================================================================================================================*/
// ****************************** PLACE THE STARTING UNITS AND TCID AND RESOURCES: ****************************** //
/*================================================================================================================*/		
	
		for(i=1; <cNumberPlayers)
	{
		// PLACE STARTING UNITS AND A TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartFarBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Place starting resources - DAL
		rmPlaceObjectDefAtLoc(StartPronghornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// Everyone gets two ore groupings, one pretty close, the other a little further away.
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidCliffs);
		rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		rmSetObjectDefMinDistance(playerGoldID, 20.0);
		rmSetObjectDefMaxDistance(playerGoldID, 25.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver further "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidCliffs);
		rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
		rmSetObjectDefMinDistance(playerGoldID, 25.0);
		rmSetObjectDefMaxDistance(playerGoldID, 30.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Everyone gets two bison herds..
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Player nuggets.
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
	}	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	    
		// VARIABLES NEEDED LATER:
		// TEXT:
	    int numTries = -1;
	    int failCount = -1;
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE CENTRAL POND: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if ( whichVariation == 1 )
	
    {
		// THE CENTRAL POND:
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        
		int smallPondID=rmCreateArea("small pond");
	    rmSetAreaSize(smallPondID, rmAreaTilesToFraction(3500), rmAreaTilesToFraction(3500));
		rmSetAreaWaterType(smallPondID, "texas pond");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 1.0);
		rmSetAreaSmoothDistance(smallPondID, 5);
		rmAddAreaConstraint(smallPondID, playerConstraint);
		rmAddAreaConstraint(smallPondID, avoidTradeRoute);
		rmAddAreaConstraint(smallPondID, avoidImportantItem);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.5, 0.5); 
		rmBuildArea(smallPondID);
	}	
	
/*----------------------------------------------------------------------------------------------------------------*/
	    
		else
		
/*----------------------------------------------------------------------------------------------------------------*/		
	
	{    
		// THE CENTRAL CLIFF:
		int cliffID=rmCreateArea("cliff");
		rmSetAreaSize(cliffID, rmAreaTilesToFraction(3500), rmAreaTilesToFraction(3500));
        rmSetAreaWarnFailure(cliffID, false);
	    rmSetAreaCliffType(cliffID, "Texas");
	    // rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffID, 1);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffID, avoidCliffs);
	    rmSetAreaMinBlobs(cliffID, 1);
        rmSetAreaMaxBlobs(cliffID, 1);
        rmSetAreaMinBlobDistance(cliffID, 1);
        rmSetAreaMaxBlobDistance(cliffID, 1);
        rmSetAreaSmoothDistance(cliffID, 10);
        rmSetAreaCoherence(cliffID, 0.95);
		rmSetAreaLocation(cliffID, 0.5, 0.5);
		rmBuildArea(cliffID);
	
    }
	
/*================================================================================================================*/
// **************************** DEFINE AND PLACE 4 SMALL PONDS OE 4 SMALL CLIFFS: ******************************* //
/*================================================================================================================*/
        
		if ( whichVariation == 1 )
		
	{    
		int cliff1ID=rmCreateArea("cliff 1");
		rmSetAreaSize(cliff1ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
        rmSetAreaWarnFailure(cliff1ID, false);
	    rmSetAreaCliffType(cliff1ID, "Texas");
	    // rmSetAreaCliffEdge(cliff1ID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff1ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff1ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff1ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff1ID, 1);
        rmAddAreaToClass(cliff1ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff1ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff1ID, 1);
        rmSetAreaMaxBlobs(cliff1ID, 1);
        rmSetAreaMinBlobDistance(cliff1ID, 1);
        rmSetAreaMaxBlobDistance(cliff1ID, 1);
        rmSetAreaSmoothDistance(cliff1ID, 10);
        rmSetAreaCoherence(cliff1ID, 0.95);
		rmSetAreaLocation(cliff1ID, 0.625, 0.825);
		rmBuildArea(cliff1ID);
	
    }	
	
/*----------------------------------------------------------------------------------------------------------------*/
	    
		else
		
/*----------------------------------------------------------------------------------------------------------------*/

{
		
		int smallPond1ID=rmCreateArea("small pond 1");
	    rmSetAreaSize(smallPond1ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
		rmSetAreaWaterType(smallPond1ID, "texas pond");
		rmSetAreaBaseHeight(smallPond1ID, 4);
		rmSetAreaMinBlobs(smallPond1ID, 1);
		rmSetAreaMaxBlobs(smallPond1ID, 1);
		rmSetAreaMinBlobDistance(smallPond1ID, 1.0);
		rmSetAreaMaxBlobDistance(smallPond1ID, 1.0);
		rmAddAreaToClass(smallPond1ID, pondClass);
		rmSetAreaCoherence(smallPond1ID, 1.0);
		rmSetAreaSmoothDistance(smallPond1ID, 5);
		rmSetAreaWarnFailure(smallPond1ID, false);
		rmSetAreaLocation(smallPond1ID, 0.625, 0.825); 
		rmBuildArea(smallPond1ID);
		
	}		

/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
	{    
		int cliff6ID=rmCreateArea("cliff 6");
		rmSetAreaSize(cliff6ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
        rmSetAreaWarnFailure(cliff6ID, false);
	    rmSetAreaCliffType(cliff6ID, "Texas");
	    // rmSetAreaCliffEdge(cliff6ID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff6ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff6ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff6ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff6ID, 1);
        rmAddAreaToClass(cliff6ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff6ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff6ID, 1);
        rmSetAreaMaxBlobs(cliff6ID, 1);
        rmSetAreaMinBlobDistance(cliff6ID, 1);
        rmSetAreaMaxBlobDistance(cliff6ID, 1);
        rmSetAreaSmoothDistance(cliff6ID, 10);
        rmSetAreaCoherence(cliff6ID, 0.95);
		rmSetAreaLocation(cliff6ID, 0.825, 0.625);
		rmBuildArea(cliff6ID);
	
    }	
	
/*----------------------------------------------------------------------------------------------------------------*/
	    
		else
		
/*----------------------------------------------------------------------------------------------------------------*/

{
		
		int smallPond2ID=rmCreateArea("small pond 2");
	    rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
		rmSetAreaWaterType(smallPond2ID, "texas pond");
		rmSetAreaBaseHeight(smallPond2ID, 4);
		rmSetAreaMinBlobs(smallPond2ID, 1);
		rmSetAreaMaxBlobs(smallPond2ID, 1);
		rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
		rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
		rmAddAreaToClass(smallPond2ID, pondClass);
		rmSetAreaCoherence(smallPond2ID, 1.0);
		rmSetAreaSmoothDistance(smallPond2ID, 5);
		rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.825, 0.625); 
		rmBuildArea(smallPond2ID);
		
}	

/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
	{    
		int cliff7ID=rmCreateArea("cliff 7");
		rmSetAreaSize(cliff7ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
        rmSetAreaWarnFailure(cliff7ID, false);
	    rmSetAreaCliffType(cliff7ID, "Texas");
	    // rmSetAreaCliffEdge(cliff7ID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff7ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff7ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff7ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff7ID, 1);
        rmAddAreaToClass(cliff7ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff7ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff7ID, 1);
        rmSetAreaMaxBlobs(cliff7ID, 1);
        rmSetAreaMinBlobDistance(cliff7ID, 1);
        rmSetAreaMaxBlobDistance(cliff7ID, 1);
        rmSetAreaSmoothDistance(cliff7ID, 10);
        rmSetAreaCoherence(cliff7ID, 0.95);
		rmSetAreaLocation(cliff7ID, 0.175, 0.375);
		rmBuildArea(cliff7ID);
	
    }	
	
/*----------------------------------------------------------------------------------------------------------------*/
	    
		else
		
/*----------------------------------------------------------------------------------------------------------------*/

{
		
		int smallPond3ID=rmCreateArea("small pond 3");
	    rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
		rmSetAreaWaterType(smallPond3ID, "texas pond");
		rmSetAreaBaseHeight(smallPond3ID, 4);
		rmSetAreaMinBlobs(smallPond3ID, 1);
		rmSetAreaMaxBlobs(smallPond3ID, 1);
		rmSetAreaMinBlobDistance(smallPond3ID, 1.0);
		rmSetAreaMaxBlobDistance(smallPond3ID, 1.0);
		rmAddAreaToClass(smallPond3ID, pondClass);
		rmSetAreaCoherence(smallPond3ID, 1.0);
		rmSetAreaSmoothDistance(smallPond3ID, 5);
		rmSetAreaWarnFailure(smallPond3ID, false);
		rmSetAreaLocation(smallPond3ID, 0.175, 0.375); 
		rmBuildArea(smallPond3ID);
		
}	

/*----------------------------------------------------------------------------------------------------------------*/


        if ( whichVariation == 1 )
		
	{    
		int cliff8ID=rmCreateArea("cliff 8");
		rmSetAreaSize(cliff8ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
        rmSetAreaWarnFailure(cliff8ID, false);
	    rmSetAreaCliffType(cliff8ID, "Texas");
	    // rmSetAreaCliffEdge(cliff8ID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff8ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff8ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff8ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff8ID, 1);
        rmAddAreaToClass(cliff8ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff8ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff8ID, 1);
        rmSetAreaMaxBlobs(cliff8ID, 1);
        rmSetAreaMinBlobDistance(cliff8ID, 1);
        rmSetAreaMaxBlobDistance(cliff8ID, 1);
        rmSetAreaSmoothDistance(cliff8ID, 10);
        rmSetAreaCoherence(cliff8ID, 0.95);
		rmSetAreaLocation(cliff8ID, 0.375, 0.175);
		rmBuildArea(cliff8ID);
	
    }	
	
/*----------------------------------------------------------------------------------------------------------------*/
	    
		else
		
/*----------------------------------------------------------------------------------------------------------------*/

{
		
		int smallPond4ID=rmCreateArea("small pond 4");
	    rmSetAreaSize(smallPond4ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
		rmSetAreaWaterType(smallPond4ID, "texas pond");
		rmSetAreaBaseHeight(smallPond4ID, 4);
		rmSetAreaMinBlobs(smallPond4ID, 1);
		rmSetAreaMaxBlobs(smallPond4ID, 1);
		rmSetAreaMinBlobDistance(smallPond4ID, 1.0);
		rmSetAreaMaxBlobDistance(smallPond4ID, 1.0);
		rmAddAreaToClass(smallPond4ID, pondClass);
		rmSetAreaCoherence(smallPond4ID, 1.0);
		rmSetAreaSmoothDistance(smallPond4ID, 5);
		rmSetAreaWarnFailure(smallPond4ID, false);
		rmSetAreaLocation(smallPond4ID, 0.375, 0.175); 
		rmBuildArea(smallPond4ID);
		
}	
	
/*================================================================================================================*/
// **************************** DEFINE AND PLACE THE WEST CLIFF AND THE EAST CLIFT: ***************************** //        
/*================================================================================================================*/
        if ( whichVariation == 1 )
		
	{	
		// THE WEST CLIFF:
		int cliff2ID=rmCreateArea("cliff 2");
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
        rmSetAreaWarnFailure(cliff2ID, false);
	    rmSetAreaCliffType(cliff2ID, "Texas");
	    // rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff2ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff2ID, 1);
        rmAddAreaToClass(cliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff2ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff2ID, 1);
        rmSetAreaMaxBlobs(cliff2ID, 1);
        rmSetAreaMinBlobDistance(cliff2ID, 1);
        rmSetAreaMaxBlobDistance(cliff2ID, 1);
        rmSetAreaSmoothDistance(cliff2ID, 10);
        rmSetAreaCoherence(cliff2ID, 0.95);
		rmSetAreaLocation(cliff2ID, 0.225, 0.775);
		rmBuildArea(cliff2ID);
	}		

/*----------------------------------------------------------------------------------------------------------------*/
	
		if ( whichVariation == 1 )
		
	{	
		// THE WEST CLIFF:
		int cliff3ID=rmCreateArea("cliff 3");
        rmSetAreaSize(cliff3ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
        rmSetAreaWarnFailure(cliff3ID, false);
	    rmSetAreaCliffType(cliff3ID, "Texas");
	    // rmSetAreaCliffEdge(cliff3ID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff3ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff3ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff3ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff3ID, 1);
        rmAddAreaToClass(cliff3ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff3ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff3ID, 1);
        rmSetAreaMaxBlobs(cliff3ID, 1);
        rmSetAreaMinBlobDistance(cliff3ID, 1);
        rmSetAreaMaxBlobDistance(cliff3ID, 1);
        rmSetAreaSmoothDistance(cliff3ID, 10);
        rmSetAreaCoherence(cliff3ID, 0.95);
		rmSetAreaLocation(cliff3ID, 0.35, 0.65);
		rmBuildArea(cliff3ID);
	}	

/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
    {    
		// THE EAST CLIFF:
		int cliff4ID=rmCreateArea("cliff 4");
        rmSetAreaSize(cliff4ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
        rmSetAreaWarnFailure(cliff4ID, false);
	    rmSetAreaCliffType(cliff4ID, "Texas");
	    // rmSetAreaCliffEdge(cliff4ID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff4ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff4ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff4ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff4ID, 1);
        rmAddAreaToClass(cliff4ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff4ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff4ID, 1);
        rmSetAreaMaxBlobs(cliff4ID, 1);
        rmSetAreaMinBlobDistance(cliff4ID, 1);
        rmSetAreaMaxBlobDistance(cliff4ID, 1);
        rmSetAreaSmoothDistance(cliff4ID, 10);
        rmSetAreaCoherence(cliff4ID, 0.95);
		rmSetAreaLocation(cliff4ID, 0.775, 0.225);
		rmBuildArea(cliff4ID);
		
	}

/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
    {    
		// THE EAST CLIFF:
		int cliff5ID=rmCreateArea("cliff 5");
        rmSetAreaSize(cliff5ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
        rmSetAreaWarnFailure(cliff5ID, false);
	    rmSetAreaCliffType(cliff5ID, "Texas");
	    // rmSetAreaCliffEdge(cliff5ID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff5ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff5ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff5ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff5ID, 1);
        rmAddAreaToClass(cliff5ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff5ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff5ID, 1);
        rmSetAreaMaxBlobs(cliff5ID, 1);
        rmSetAreaMinBlobDistance(cliff5ID, 1);
        rmSetAreaMaxBlobDistance(cliff5ID, 1);
        rmSetAreaSmoothDistance(cliff5ID, 10);
        rmSetAreaCoherence(cliff5ID, 0.95);
		rmSetAreaLocation(cliff5ID, 0.65, 0.35);
		rmBuildArea(cliff5ID);
		
	}			
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ******************** DEFINE AND PLACE THE NATIVE VILLAGES AND SECRETS OF THE NEW WORLD: ********************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
	
{	    
        if (subCiv0 == rmGetCivID("cherokee"))
	{	
	    int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.20, 0.50);
	} 
}        
		else
{		
    	if (subCiv0 == rmGetCivID("Comanche"))
	{  
		int comanche1VillageID = -1;
		comanche1VillageID = rmCreateGrouping("comanche village 1", "native comanche village 1");
		rmSetGroupingMinDistance(comanche1VillageID, 0.0);
		rmSetGroupingMaxDistance(comanche1VillageID, 0.0);
		rmAddGroupingToClass(comanche1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comanche1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(comanche1VillageID, 0, 0.20, 0.50);
	} 
}	
	
/*----------------------------------------------------------------------------------------------------------------*/	
	    
		if ( whichVariation == 1 )
	
{	    
        if (subCiv1 == rmGetCivID("cherokee"))
		
	{	
	    int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.50, 0.80);
	} 
}        
		else
		
{  
	    if (subCiv1 == rmGetCivID("Comanche"))
		
	{	
	    int comanche2VillageID = -1;
		comanche2VillageID = rmCreateGrouping("comanche village 2", "native comanche village 1");
		rmSetGroupingMinDistance(comanche2VillageID, 0.0);
		rmSetGroupingMaxDistance(comanche2VillageID, 0.0);
		rmAddGroupingToClass(comanche2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comanche2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(comanche2VillageID, 0, 0.50, 0.80);
	}	
} 	
/*----------------------------------------------------------------------------------------------------------------*/
	   
	    if ( whichVariation == 1 )
		
{		
	    if (subCiv2 == rmGetCivID("cherokee"))
	{	
	    int cherokee3VillageID = -1;
		cherokee3VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee3VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee3VillageID, 0.0);
		rmAddGroupingToClass(cherokee3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee3VillageID, 0, 0.80, 0.50);
	} 
}	
		
		else
		
{		
		if (subCiv2 == rmGetCivID("Comanche"))
	{  
		int comanche3VillageID = -1;
		comanche3VillageID = rmCreateGrouping("comanche village 3", "native comanche village 1");
		rmSetGroupingMinDistance(comanche3VillageID, 0.0);
		rmSetGroupingMaxDistance(comanche3VillageID, 0.0);
		rmAddGroupingToClass(comanche3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comanche3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(comanche3VillageID, 0, 0.80, 0.50);
	} 
}
	
/*----------------------------------------------------------------------------------------------------------------*/	
    
        if ( whichVariation == 1 )

{		
	    if (subCiv3 == rmGetCivID("cherokee"))
	{	
	    int cherokee4VillageID = -1;
		cherokee4VillageID = rmCreateGrouping("cherokee village 4", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee4VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee4VillageID, 0.0);
		rmAddGroupingToClass(cherokee4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee4VillageID, 0, 0.50, 0.20);
	} 
}	
		
		else
		
{		
		if (subCiv3 == rmGetCivID("Comanche"))
	{  
		int comanche4VillageID = -1;
		comanche4VillageID = rmCreateGrouping("comanche village 4", "native comanche village 1");
		rmSetGroupingMinDistance(comanche4VillageID, 0.0);
		rmSetGroupingMaxDistance(comanche4VillageID, 0.0);
		rmAddGroupingToClass(comanche4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comanche4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(comanche4VillageID, 0, 0.50, 0.20);
	} 
}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE GOLD MINES: ************************************** //
// ************************************* DEFINE AND PLACE THE SILVER MINES: ************************************* //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.30, 0.50);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.50, 0.30);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.50, 0.70);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.70, 0.50); 
		
	}

    else

	{
	     // THE SILVER MINE NUMBER 1:
		int silver1ID = rmCreateObjectDef("silver 1");
		rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver1ID, 0.0);
		rmSetObjectDefMaxDistance(silver1ID, 0.0);
		rmAddObjectDefConstraint(silver1ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.30, 0.50);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.50, 0.30);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.50, 0.70);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.70, 0.50);
	}	
	
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 2:
		int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.1, 0.5);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.1);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.9);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.9, 0.5); 
		
	}

    else

	{
	     // THE SILVER MINE NUMBER 2:
		int silver2ID = rmCreateObjectDef("silver 2");
		rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver2ID, 0.0);
		rmSetObjectDefMaxDistance(silver2ID, 0.0);
		rmAddObjectDefConstraint(silver2ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.1, 0.5);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.1);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.9);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.9, 0.5);
	}	

/*----------------------------------------------------------------------------------------------------------------*/


        if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 3:
		int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.835, 0.835);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.325, 0.675);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.675, 0.325); 
		
	}

    else

	{
	     // THE SILVER MINE NUMBER 3:
		int silver3ID = rmCreateObjectDef("silver 3");
		rmAddObjectDefItem(silver3ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver3ID, 0.0);
		rmSetObjectDefMaxDistance(silver3ID, 0.0);
		rmAddObjectDefConstraint(silver3ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.835, 0.835);
		//rmPlaceObjectDefAtLoc(silver3ID, 0, 0.325, 0.675);
		//rmPlaceObjectDefAtLoc(silver3ID, 0, 0.325, 0.675);
	}

/*----------------------------------------------------------------------------------------------------------------*/
        if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 4:
		int gold4ID = rmCreateObjectDef("gold 4");
		rmAddObjectDefItem(gold4ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold4ID, 0.0);
		rmSetObjectDefMaxDistance(gold4ID, 0.0);
		rmAddObjectDefConstraint(gold4ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.15, 0.65);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.65, 0.15);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.35, 0.85);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.85, 0.35); 
		
	}
	
	   else

	{
	     // THE BERRIES NUMBER 1:
		int Berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(Berries1ID, "berrybush", rmRandInt(5,7), 8.0);
		rmSetObjectDefMinDistance(Berries1ID, 0.0);
		rmSetObjectDefMaxDistance(Berries1ID, 0.0);
		rmAddObjectDefConstraint(Berries1ID, avoidFruits);
				
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.15, 0.65);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.65, 0.15);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.35, 0.85);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.85, 0.35);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/
        if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 5:
		int gold5ID = rmCreateObjectDef("gold 5");
		rmAddObjectDefItem(gold5ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold5ID, 0.0);
		rmSetObjectDefMaxDistance(gold5ID, 0.0);
		rmAddObjectDefConstraint(gold5ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.125, 0.775);
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.775, 0.125);
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.225, 0.875);
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.875, 0.225); 
		
	}

        else

	{
	    // THE SILVER MINE NUMBER 5:
		int silver5ID = rmCreateObjectDef("silver 5");
		rmAddObjectDefItem(silver5ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver5ID, 0.0);
		rmSetObjectDefMaxDistance(silver5ID, 0.0);
		rmAddObjectDefConstraint(silver5ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver5ID, 0, 0.125, 0.775);
		rmPlaceObjectDefAtLoc(silver5ID, 0, 0.775, 0.125);
		rmPlaceObjectDefAtLoc(silver5ID, 0, 0.225, 0.875);
		rmPlaceObjectDefAtLoc(silver5ID, 0, 0.875, 0.225);
	}	
		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE TREASURES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.10, 0.70);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.70, 0.10);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.20, 0.60);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.60, 0.20);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.30, 0.90);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.90, 0.30);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.80, 0.40);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.40, 0.80);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.05, 0.45);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.45, 0.05);
		
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.55, 0.95);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.95, 0.55);
		
/*----------------------------------------------------------------------------------------------------------------*/

		// THE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.35, 0.50);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.50, 0.35);
		
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.50, 0.65);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.65, 0.50);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE SAUVAGE FOOD: ************************************** //	
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
	
	{	
		int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmAddObjectDefConstraint(deer1ID, avoidCloseCliffs);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.20, 0.70);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.70, 0.20);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.30, 0.80);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.80, 0.30);
		
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.385, 0.385);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.615, 0.615);
		
	}

        else
		
	{
    	int bison1ID=rmCreateObjectDef("The Bison Herds 1");
        rmAddObjectDefItem(bison1ID, "bison", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(bison1ID, 0.0);
        rmSetObjectDefMaxDistance(bison1ID, 0.0);
	    rmAddObjectDefConstraint(bison1ID, avoidBison);
		rmSetObjectDefCreateHerd(bison1ID, true);
	    
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.20, 0.70);
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.70, 0.20);
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.30, 0.80);
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.80, 0.30);
		
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.385, 0.385);
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.615, 0.615);
		
    }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.72);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE COWS: ********************************************* //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
	{	
		int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmSetObjectDefCreateHerd(cow1ID, true);
	    
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.10, 0.60);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.60, 0.10);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.40, 0.90);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.90, 0.40);
	}
        else
		
	{	
		int sheep1ID=rmCreateObjectDef("The Sheeps 1");
        rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(sheep1ID, 0.0);
        rmSetObjectDefMaxDistance(sheep1ID, 0.0);
	    rmAddObjectDefConstraint(sheep1ID, avoidSheep);
		rmSetObjectDefCreateHerd(sheep1ID, true);
	    
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.10, 0.60);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.60, 0.10);
        
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.40, 0.90);
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.90, 0.40);
	}	
	
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM BERRIES: ************************************* //
// *********************************** DEFINE AND PLACE THE RANDOM TURKEYS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if ( whichVariation == 1 )
		
	{	
		int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.125, 0.325);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.325, 0.125);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.675, 0.875);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.875, 0.675);
				
	}
        else
		
	{
        int turkey1ID = rmCreateObjectDef("The Turkeys 1");
		rmAddObjectDefItem(turkey1ID, "turkey", rmRandInt(5,7), 4.0);
		rmSetObjectDefMinDistance(turkey1ID, 0.0);
		rmSetObjectDefMaxDistance(turkey1ID, 0.0);
		rmAddObjectDefConstraint(turkey1ID, avoidTurkeys);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.125, 0.325);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.325, 0.125);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.675, 0.875);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.875, 0.675);
				
    }
	
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
	{	
		int berries3ID = rmCreateObjectDef("The Berries 3");
		rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.25, 0.55);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.55, 0.25);
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.45, 0.75);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.75, 0.45);
				
	}
        else
		
	{
        int turkey2ID = rmCreateObjectDef("The Turkeys 2");
		rmAddObjectDefItem(turkey2ID, "turkey", rmRandInt(5,7), 4.0);
		rmSetObjectDefMinDistance(turkey2ID, 0.0);
		rmSetObjectDefMaxDistance(turkey2ID, 0.0);
		rmAddObjectDefConstraint(turkey2ID, avoidTurkeys);
		
		rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.25, 0.55);
		rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.55, 0.25);
		
		rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.45, 0.75);
		rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.75, 0.45);
				
    }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.74);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DECORATIONS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    if ( whichVariation == 1 )
		
	{	
		
		// BIG DECORATIVE THINGS:
	    int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	    int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "BigPropTexas", 25.0);
	    rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
	    rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	    rmSetObjectDefMaxDistance(bigDecorationID, 0.0);
	    rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
	    
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.25, 0.65);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.65, 0.25);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.75, 0.35);
		
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.25, 0.45);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.45, 0.25);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.55, 0.75);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.75, 0.55);
		
    }
	    else
	{	
		
		// PERCHING VULTURES - ADD FOUR SOMEWHERE:
	    int vultureID=rmCreateObjectDef("perching vultures");
	    int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
	    
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.25, 0.65);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.65, 0.25);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.75, 0.35);
		
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.25, 0.45);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.45, 0.25);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.55, 0.75);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.75, 0.55);
		
	}		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/   
// ***************************** DEFINE AND PLACE THE FORESTS: - NORTH AND SOUTH: ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	        
			int forestTreeID = 0;
	
	        numTries=15*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int westForest=rmCreateArea("westForest"+i);
			rmSetAreaWarnFailure(westForest, false);
			rmSetAreaSize(westForest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
			
			if ( whichVariation == 1 )
		{	
			rmSetAreaForestType(westForest, "texas forest");
		}	
			else
		{	
			rmSetAreaForestType(westForest, "texas forest dirt");
		}	
			rmSetAreaForestDensity(westForest, 0.7);
			rmSetAreaForestClumpiness(westForest, 0.4);
			rmSetAreaForestUnderbrush(westForest, 0.0);
			rmSetAreaMinBlobs(westForest, 1);
			rmSetAreaMaxBlobs(westForest, 3);
			rmSetAreaMinBlobDistance(westForest, 5.0);
			rmSetAreaMaxBlobDistance(westForest, 20.0);
			rmSetAreaCoherence(westForest, 0.4);
			rmSetAreaSmoothDistance(westForest, 10);
			rmAddAreaConstraint(westForest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			rmAddAreaConstraint(westForest, avoidCoin);
			rmAddAreaConstraint(westForest, avoidNatives);
			rmAddAreaConstraint(westForest, avoidAll);
			rmAddAreaConstraint(westForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(westForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			rmAddAreaConstraint(westForest, Northward);						// DAL adeed, to keep these forests in the west.
			rmAddAreaConstraint(westForest, avoidTradeRoute);
			rmAddAreaConstraint(westForest, avoidCliffs);
			rmAddAreaConstraint(westForest, forestsAvoidBison);
			if(rmBuildArea(westForest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
		
/*----------------------------------------------------------------------------------------------------------------*/		

	        numTries=15*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int eastForest=rmCreateArea("eastForest"+i);
			rmSetAreaWarnFailure(eastForest, false);
			rmSetAreaSize(eastForest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
			
			if ( whichVariation == 1 )
		{	
			rmSetAreaForestType(eastForest, "texas forest");
		}	
			else
		{	
			rmSetAreaForestType(eastForest, "texas forest dirt");
		}	
			rmSetAreaForestDensity(eastForest, 0.7);
			rmSetAreaForestClumpiness(eastForest, 0.4);
			rmSetAreaForestUnderbrush(eastForest, 0.0);
			rmSetAreaMinBlobs(eastForest, 1);
			rmSetAreaMaxBlobs(eastForest, 3);
			rmSetAreaMinBlobDistance(eastForest, 5.0);
			rmSetAreaMaxBlobDistance(eastForest, 20.0);
			rmSetAreaCoherence(eastForest, 0.4);
			rmSetAreaSmoothDistance(eastForest, 10);
			rmAddAreaConstraint(eastForest, avoidImportantItem);			// DAL added, to try and make sure natives got on the map w/o override.
			rmAddAreaConstraint(eastForest, avoidCoin);
			rmAddAreaConstraint(eastForest, avoidNatives);
			rmAddAreaConstraint(eastForest, avoidAll);
			rmAddAreaConstraint(eastForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(eastForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			rmAddAreaConstraint(eastForest, Southward);						// DAL adeed, to keep these forests in the east.
			rmAddAreaConstraint(eastForest, avoidTradeRoute);
			rmAddAreaConstraint(eastForest, avoidCliffs);
			rmAddAreaConstraint(eastForest, forestsAvoidBison);
			if(rmBuildArea(eastForest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ************************* DEFINE AND PLACE THE SILVER MINES IN THE MIDDLE OF THE MAP: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*================================================================================================================*/
/* 
	    // DEFINE AND PLACE NUGGETS:
	    int nuggetID = 0;
	    rmSetNuggetDifficulty(1, 3);
	    for(i=0; <cNumberNonGaiaPlayers*2)
	{
		nuggetID= rmCreateObjectDef("nugget "+i); 
		rmAddObjectDefItem(nuggetID, "nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nuggetID, 0.0);
		rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(nuggetID, playerConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
		rmAddObjectDefToClass(nuggetID, rmClassID("importantItem"));
		rmAddObjectDefToClass(nuggetID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nuggetID, avoidResource);
		rmAddObjectDefConstraint(nuggetID, avoidImportantItem);
		rmAddObjectDefConstraint(nuggetID, avoidNugget);
		rmAddObjectDefConstraint(nuggetID, avoidStartingUnitsLarge);
		rmAddObjectDefConstraint(nuggetID, avoidCoin);
		rmAddObjectDefConstraint(nuggetID, pondConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
		rmAddObjectDefConstraint(nuggetID, circleConstraint);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5);
	}
*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE DOMESTIC FOOD: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE FISH AND THE WHALES: ********************************* //
/*================================================================================================================*/

        // DEFINE THE FISH AND WHALES CONSTRAINTS:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 10.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        //int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 25.0);
        //int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	
/*----------------------------------------------------------------------------------------------------------------*/		

        // FISHBASS -- FOOD:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*10);
		
/*----------------------------------------------------------------------------------------------------------------*/		

/*
	    // FAST COIN -- WHALES:
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);
*/

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE DECORATIONS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*
	    if ( whichVariation == 1 )
		
	{	
		
		// BIG DECORATIVE THINGS:
	    int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	    int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "BigPropTexas", 25.0);
	    rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
	    rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	    rmSetObjectDefMaxDistance(bigDecorationID, 0.0);
	    rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
	    
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.25, 0.65);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.65, 0.25);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.75, 0.35);
		
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.25, 0.45);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.45, 0.25);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.55, 0.75);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.75, 0.55);
		
    }
	    else
	{	
		
		// PERCHING VULTURES - ADD FOUR SOMEWHERE:
	    int vultureID=rmCreateObjectDef("perching vultures");
	    int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
	    
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.25, 0.65);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.65, 0.25);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.75, 0.35);
		
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.25, 0.45);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.45, 0.25);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.55, 0.75);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.75, 0.55);
		
	}
*/	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*================================================================================================================*/  
   