/*================================================================================================================*/
// ******************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// THE CARIB ISLANDS:
// CREATED BY DANY:
// SEPTEMBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
		int subCiv2=-1;
		int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Caribs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Caribs");

		subCiv1=rmGetCivID("Caribs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Caribs");
		
		subCiv2=rmGetCivID("Caribs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Caribs");
		
		subCiv3=rmGetCivID("Caribs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Caribs");
   } 		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	
        int playerTiles=25000;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(638, 638);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/

       // SET SEA LEVEL:
       rmSetSeaLevel(2.0);
       
	   // SET SEA TYPE:
	   rmSetSeaType("caribbean coast");
 	   
	   // SET BASE TERRAIN MIX:
	   rmSetBaseTerrainMix("caribbean grass");
	   
	   // SET MAP TYPE:
	   rmSetMapType("caribbean");
	   rmSetMapType("grass");
	   rmSetMapType("water");
       
	   // SET LIGHTING:
	   rmSetLightingSet("caribbean");

       // TERRAIN INITIALIZATION:
       rmTerrainInitialize("water");
	   
	   // CHOOSE THE MERCS:
	   chooseMercs();
	   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/

        int classPlayer=rmDefineClass("player");
        int classIsland=rmDefineClass("island");
        int classBonusIsland=rmDefineClass("bonusIsland");
        int classTeamIsland=rmDefineClass("teamIsland");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classSocket");
		rmDefineClass("nuggets");
		rmDefineClass("startingUnit");

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
   
        // CREATE A EDGE OF MAP CONSTRAINT:
        int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.45), rmDegreesToRadians(0), rmDegreesToRadians(360));
        int playerCloseEdgeConstraint=rmCreatePieConstraint("close player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
        int playerNativesEdgeConstraint=rmCreatePieConstraint("natives player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));

        // PLAYER AREA CONSTRAINT:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 25.0);
		int playerCloseConstraint=rmCreateClassDistanceConstraint("close stay away from players", classPlayer, 10.0);
        int playerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stay away from players", classPlayer, 5.0);
        int playerVeryFarConstraint=rmCreateClassDistanceConstraint("very far stay away from players", classPlayer, 75.0);
       		
        int longPlayerConstraint=rmCreateClassDistanceConstraint("long stay away from players", classPlayer, 60.0);
                
		// NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	   		
		int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
        int nearWaterDock = rmCreateTerrainDistanceConstraint("near water for Dock", "Water", true, 0.0);
	    int avoidTC=rmCreateTypeDistanceConstraint("stay away from TC", "TownCenter", 20.0);
	    int avoidCW=rmCreateTypeDistanceConstraint("stay away from CW", "CoveredWagon", 15.0);

        // ADD ISLAND CONSTRAINTS:
        //int bigIslandConstraint=rmCreateAreaConstraint("north Island", bigIslandID);
        //int bigIsland2Constraint=rmCreateAreaConstraint("south Island", bigIsland2ID); 
		
		// UNIT AVOIDANCE - FOR THINGS THAT AREN'T IN THE STARTING RESOURCES:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 10.0);
        int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close objects avoid starting units", rmClassID("startingUnit"), 5.0);
        int avoidVeryCloseStartingUnits=rmCreateClassDistanceConstraint("very close objects avoid starting units", rmClassID("startingUnit"), 2.0);
        int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium objects avoid starting units", rmClassID("startingUnit"), 25.0);
        int avoidFarStartingUnits=rmCreateClassDistanceConstraint("far objects avoid starting units", rmClassID("startingUnit"), 50.0);
        int avoidVeryFarStartingUnits=rmCreateClassDistanceConstraint("very far objects avoid starting units", rmClassID("startingUnit"), 75.0);
        
		//int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 10.0);

        // BONUS AREA CONSTRAINT:
        int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 55.0);
        //int bonusIslandConstraint=rmCreateClassDistanceConstraint("bonus islands avoid islands", classIsland, 30.0);
        int avoidBonusIslands=rmCreateClassDistanceConstraint("stuff avoids bonus islands", classBonusIsland, 30.0);
        int avoidTeamIslands=rmCreateClassDistanceConstraint("stuff avoids team islands", classTeamIsland, 30.0);
 
	    // RESOURCE CONSTRAINT:
	    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fishSalmon", 20.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 100.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 25.0);
        
		// FOREST AVOIDANCE:
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 40.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close forest vs. forest", rmClassID("classForest"), 5.0);
       
		int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
        
		// COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "mine", 15.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "mine", 5.0);
		int avoidVeryCloseCoin=rmCreateTypeDistanceConstraint("very close avoid coin", "mine", 2.0);
		int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "mine", 25.0);
		int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "mine", 50.0);
		int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoid coin", "mine", 75.0);
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoid Trees", "treeCaribbean", 10.0);
		int avoidVeryCloseTrees=rmCreateTypeDistanceConstraint("very close stuff avoid Trees", "treeCaribbean", 2.0);
		int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoid Trees", "treeCaribbean", 5.0);
		int avoidMediumTrees=rmCreateTypeDistanceConstraint("medium avoid Trees", "treeCaribbean", 25.0);
		int avoidFarTrees=rmCreateTypeDistanceConstraint("far avoid Trees", "treeCaribbean", 50.0);
		int avoidVeryFarTrees=rmCreateTypeDistanceConstraint("very far avoid Trees", "treeCaribbean", 75.0);
			
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("avoid deer", "deer", 15.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoid deer", "deer", 5.0);
		int avoidVeryCloseDeer=rmCreateTypeDistanceConstraint("very close avoid deer", "deer", 2.0);
		int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoid deer", "deer", 25.0);
		int avoidFarDeer=rmCreateTypeDistanceConstraint("far avoid deer", "deer", 50.0);
		int avoidVeryFarDeer=rmCreateTypeDistanceConstraint("very far avoid deer", "deer", 75.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("avoid berries", "berrybush", 15.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid berries", "berrybush", 5.0);
		int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoid berries", "berrybush", 2.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid berries", "berrybush", 25.0);
		int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid berries", "berrybush", 50.0);
		int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoid berries", "berrybush", 75.0);
		        
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 15.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close nugget avoid nugget", "abstractNugget", 5.0);
		int avoidVeryCloseCNugget=rmCreateTypeDistanceConstraint("very close nugget avoid nugget", "abstractNugget", 2.0);
		int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium nugget avoid nugget", "abstractNugget", 25.0);
		int avoidFarNugget=rmCreateTypeDistanceConstraint("far nugget avoid nugget", "abstractNugget", 50.0);
		int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far nugget avoid nugget", "abstractNugget", 75.0);
		
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close stuff avoids natives", rmClassID("natives"), 5.0);
        int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close stuff avoids natives", rmClassID("natives"), 2.0);
        int avoidMediumNatives=rmCreateClassDistanceConstraint("medium stuff avoids natives", rmClassID("natives"), 25.0);
		int avoidFarNatives=rmCreateClassDistanceConstraint("far stuff avoids natives", rmClassID("natives"), 50.0);
		int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far stuff avoids natives", rmClassID("natives"), 75.0);


        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close avoid impassable land", "Land", false, 5.0);
        int avoidVeryCloseImpassableLand=rmCreateTerrainDistanceConstraint("very close avoid impassable land", "Land", false, 2.0);
        int avoidMediumImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 25.0);
        int avoidFarImpassableLand=rmCreateTerrainDistanceConstraint("far avoid impassable land", "Land", false, 50.0);
        int avoidVeryFarImpassableLand=rmCreateTerrainDistanceConstraint("very far avoid impassable land", "Land", false, 75.0);
       
		//int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);

	    // CONSTRAINT TO AVOID WATER:
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);
	    int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);

        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
        int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
        int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE NORTHERN ISLAND: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
            
    		// THE NORTHERN ISLAND:
            int bigIslandID=rmCreateArea("The Northern Island");
            rmSetAreaSize(bigIslandID, 0.235, 0.235);
            rmSetAreaMinBlobs(bigIslandID, 1);
            rmSetAreaMaxBlobs(bigIslandID, 1);
            rmSetAreaMinBlobDistance(bigIslandID, 1.0);
            rmSetAreaMaxBlobDistance(bigIslandID, 1.0);
			rmSetAreaCoherence(bigIslandID, 0.775);
            rmSetAreaBaseHeight(bigIslandID, 2.0);
			rmSetAreaSmoothDistance(bigIslandID, 20);
			rmSetAreaEdgeFilling(bigIslandID, 1);
		    rmSetAreaMix(bigIslandID, "caribbean grass");
            rmAddAreaToClass(bigIslandID, classIsland);
            rmAddAreaConstraint(bigIslandID, islandConstraint);
			rmSetAreaObeyWorldCircleConstraint(bigIslandID, false);
            rmSetAreaElevationType(bigIslandID, cElevTurbulence);
            rmSetAreaElevationVariation(bigIslandID, 4.0);
            rmSetAreaElevationMinFrequency(bigIslandID, 0.09);
            rmSetAreaElevationOctaves(bigIslandID, 3);
            rmSetAreaElevationPersistence(bigIslandID, 0.2);
		    rmSetAreaElevationNoiseBias(bigIslandID, 1);
			rmSetAreaWarnFailure(bigIslandID, false);
			
			rmSetAreaLocation(bigIslandID, 0.80, 0.80);
		    rmBuildArea(bigIslandID);

/*----------------------------------------------------------------------------------------------------------------*/			
		
            // THE SOUTHERN ISLAND:
            int bigIsland2ID=rmCreateArea("The Southern Island");
            rmSetAreaSize(bigIsland2ID, 0.235, 0.235);
            rmSetAreaMinBlobs(bigIsland2ID, 1);
            rmSetAreaMaxBlobs(bigIsland2ID, 1);
            rmSetAreaMinBlobDistance(bigIsland2ID, 1.0);
            rmSetAreaMaxBlobDistance(bigIsland2ID, 1.0);
            rmSetAreaCoherence(bigIsland2ID, 0.775);
            rmSetAreaBaseHeight(bigIsland2ID, 2.0);
            rmSetAreaSmoothDistance(bigIsland2ID, 20);
		    rmSetAreaMix(bigIsland2ID, "caribbean grass");
            rmAddAreaToClass(bigIsland2ID, classIsland);
            rmAddAreaConstraint(bigIsland2ID, islandConstraint);
			//rmAddAreaConstraint(bigIsland2ID, playerCloseConstraint);
            rmSetAreaObeyWorldCircleConstraint(bigIsland2ID, false);
            rmSetAreaElevationType(bigIsland2ID, cElevTurbulence);
            rmSetAreaElevationVariation(bigIsland2ID, 4.0);
            rmSetAreaElevationMinFrequency(bigIsland2ID, 0.09);
            rmSetAreaElevationOctaves(bigIsland2ID, 3);
            rmSetAreaElevationPersistence(bigIsland2ID, 0.2);
		    rmSetAreaElevationNoiseBias(bigIsland2ID, 1);
            rmSetAreaWarnFailure(bigIsland2ID, false);
			
			rmSetAreaLocation(bigIsland2ID, 0.20, 0.20);
		    rmBuildArea(bigIsland2ID);
			
/*----------------------------------------------------------------------------------------------------------------*/

            // THE WESTERN ISLAND:
            int bigIsland3ID=rmCreateArea("The Western Island");
            rmSetAreaSize(bigIsland3ID, 0.025, 0.025);
            rmSetAreaMinBlobs(bigIsland3ID, 1);
            rmSetAreaMaxBlobs(bigIsland3ID, 1);
            rmSetAreaMinBlobDistance(bigIsland3ID, 1.0);
            rmSetAreaMaxBlobDistance(bigIsland3ID, 1.0);
            rmSetAreaCoherence(bigIsland3ID, 0.775);
            rmSetAreaBaseHeight(bigIsland3ID, 2.0);
            rmSetAreaSmoothDistance(bigIsland3ID, 20);
		    rmSetAreaMix(bigIsland3ID, "caribbean grass");
            rmAddAreaToClass(bigIsland3ID, classIsland);
            rmAddAreaConstraint(bigIsland3ID, islandConstraint);
            rmSetAreaObeyWorldCircleConstraint(bigIsland3ID, false);
            rmSetAreaElevationType(bigIsland3ID, cElevTurbulence);
            rmSetAreaElevationVariation(bigIsland3ID, 4.0);
            rmSetAreaElevationMinFrequency(bigIsland3ID, 0.09);
            rmSetAreaElevationOctaves(bigIsland2ID, 3);
            rmSetAreaElevationPersistence(bigIsland3ID, 0.2);
		    rmSetAreaElevationNoiseBias(bigIsland3ID, 1);
            rmSetAreaWarnFailure(bigIsland3ID, false);
			
			rmSetAreaLocation(bigIsland3ID, 0.25, 0.75);
		    rmBuildArea(bigIsland3ID);

/*----------------------------------------------------------------------------------------------------------------*/

            // THE EASTERN ISLAND:
            int bigIsland4ID=rmCreateArea("The Eastern Island");
            rmSetAreaSize(bigIsland4ID, 0.025, 0.025);
            rmSetAreaMinBlobs(bigIsland4ID, 1);
            rmSetAreaMaxBlobs(bigIsland4ID, 1);
            rmSetAreaMinBlobDistance(bigIsland4ID, 1.0);
            rmSetAreaMaxBlobDistance(bigIsland4ID, 1.0);
            rmSetAreaCoherence(bigIsland4ID, 0.775);
            rmSetAreaBaseHeight(bigIsland4ID, 2.0);
            rmSetAreaSmoothDistance(bigIsland4ID, 20);
		    rmSetAreaMix(bigIsland4ID, "caribbean grass");
            rmAddAreaToClass(bigIsland4ID, classIsland);
            rmAddAreaConstraint(bigIsland4ID, islandConstraint);
            rmSetAreaObeyWorldCircleConstraint(bigIsland4ID, false);
            rmSetAreaElevationType(bigIsland4ID, cElevTurbulence);
            rmSetAreaElevationVariation(bigIsland4ID, 4.0);
            rmSetAreaElevationMinFrequency(bigIsland4ID, 0.09);
            rmSetAreaElevationOctaves(bigIsland4ID, 3);
            rmSetAreaElevationPersistence(bigIsland4ID, 0.2);
		    rmSetAreaElevationNoiseBias(bigIsland4ID, 1);
            rmSetAreaWarnFailure(bigIsland4ID, false);
			
			rmSetAreaLocation(bigIsland4ID, 0.75, 0.25);
		    rmBuildArea(bigIsland4ID); 			
		
/*================================================================================================================*/			
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** //
/*================================================================================================================*/

        rmSetPlacementTeam(0);
		rmSetPlacementSection(0.075, 0.175);
		rmPlacePlayersCircular(0.38, 0.38, 0);
		
		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.575, 0.675);
		rmPlacePlayersCircular(0.38, 0.38, 0);

/*================================================================================================================*/
// ******************************************* SET UP PLAYER AREAS: ********************************************* //
/*================================================================================================================*/
	
        float playerFraction=rmAreaTilesToFraction(1750);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "great plains drygrass");
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint); 
	    //rmAddAreaConstraint(id, avoidTradeRoute); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
   }
        // Build the areas.
        rmBuildAllAreas();
	
/*================================================================================================================*/			
// ************************************ DEFINE AND PLACE THE TRADE ROUTE: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE LONELY CARIBS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("caribs"))
	{  
		int caribsVillageID = -1;
		caribsVillageID = rmCreateGrouping("caribs village 1", "native carib village 1");
		rmSetGroupingMinDistance(caribsVillageID, 0.0);
		rmSetGroupingMaxDistance(caribsVillageID, 0.0);
		rmAddGroupingToClass(caribsVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribsVillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribsVillageID, 0, 0.25, 0.75);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("caribs"))
	{  
		int caribs2VillageID = -1;
		caribs2VillageID = rmCreateGrouping("caribs village 2", "native carib village 1");
		rmSetGroupingMinDistance(caribs2VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs2VillageID, 0.0);
		rmAddGroupingToClass(caribs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribs2VillageID, 0, 0.75, 0.25);
	} 	
	
/*----------------------------------------------------------------------------------------------------------------*/
/*
        // ADD ISLAND CONSTRAINTS:
        //int bigIslandConstraint=rmCreateGroupingConstraint("north Caribs", bigIslandID);
        //int bigIsland2Constraint=rmCreateGroupingConstraint("south Caribs", bigIsland2ID); 
		
		if (subCiv2 == rmGetCivID("caribs"))
	{  
		int caribs3VillageID = -1;
		caribs3VillageID = rmCreateGrouping("caribs village 3", "native carib village 1");
		rmSetGroupingMinDistance(caribs3VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs3VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(caribs3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(caribs3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs3VillageID, avoidCloseDeer);
		rmAddGroupingConstraint(caribs3VillageID, avoidCloseCoin);
		rmAddGroupingConstraint(caribs3VillageID, bigIslandConstraint);
		//rmAddGroupingConstraint(caribs3VillageID, playerNativesEdgeconstraint);
		//rmAddGroupingConstraint(caribs3VillageID, forestCloseConstraint);
		//rmAddGroupingConstraint(caribs3VillageID, playerVeryFarConstraint);
		rmPlaceGroupingAtLoc(caribs3VillageID, 0, 0.5, 0.5);
	} 
*/	
/*----------------------------------------------------------------------------------------------------------------*/	
/*		
		if (subCiv3 == rmGetCivID("caribs"))
	{  
		int caribs4VillageID = -1;
		caribs4VillageID = rmCreateGrouping("caribs village 4", "native carib village 1");
		rmSetGroupingMinDistance(caribs4VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs4VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(caribs4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(caribs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs4VillageID, avoidCloseDeer);
		rmAddGroupingConstraint(caribs4VillageID, avoidCloseCoin);
		rmAddGroupingConstraint(caribs4VillageID, bigIsland2Constraint);
		//rmAddGroupingConstraint(caribs4VillageID, playerNativesEdgeconstraint);
		//rmAddGroupingConstraint(caribs4VillageID, forestCloseConstraint);
		//rmAddGroupingConstraint(caribs4VillageID, playerVeryFarConstraint);
		rmPlaceGroupingAtLoc(caribs4VillageID, 0, 0.5, 0.5);
	} 
*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************* DEFINE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //
/*================================================================================================================*/
   
        // DEFINE THE STARTING STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 7.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);

	    // DEFINE THE STARTING TCID:
		int startingTCID = rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 0.0);
	    //rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSmall);
	    // rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
		
/*----------------------------------------------------------------------------------------------------------------*/

	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeCaribbean", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 16.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
		
		// DEFINE THE STARTING BERRIES:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", rmRandInt(3,5), 4.0);
	    rmSetObjectDefMinDistance(StartBerriesID, 20.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 30.0);
	    rmSetObjectDefCreateHerd(StartBerriesID, true);
	    rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnits);
		rmAddObjectDefConstraint(StartBerriesID, avoidMediumFruits);

	    // DEFINE THE STARTING BISON:
		int StartDeerID=rmCreateObjectDef("starting deers");
	    rmAddObjectDefItem(StartDeerID, "deer", 5, 6.0);
	    rmSetObjectDefMinDistance(StartDeerID, 18.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 20.0);
	    rmSetObjectDefCreateHerd(StartDeerID, true);
	    rmAddObjectDefConstraint(StartDeerID, avoidStartingUnits);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 28.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
		rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnits);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidNativesNuggets);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidMediumFruits);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	
	    // DEFINE THE VARIABLES FOR THE PLAYER GOLD:
	    int silverType = -1;
	    int playerGoldID = -1;
		
		// DEFINE THE WATER FLAG ID:		
		int waterFlagID=-1;
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ********************** PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

 	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));	
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// DEFINE THE PLAYER GOLD:
		// EVERYONE GETS TWO ORE OBJECTDEFS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		//rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		//rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnits);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE THE BERRY BUSHES:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER GOLD: ( TWO GOLD MINES: )
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING BISONS:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();	
	}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SILVER MINES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
	    int silverID = rmCreateObjectDef("random silver");
	    rmAddObjectDefItem(silverID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silverID, 0.0);
	    rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silverID, playerCloseEdgeConstraint);
	    rmAddObjectDefConstraint(silverID, avoidAll);
	    rmAddObjectDefConstraint(silverID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(silverID, avoidImpassableLand);
	    rmPlaceObjectDefInArea(silverID, 0, bigIslandID, cNumberNonGaiaPlayers*1.5);
	    rmPlaceObjectDefInArea(silverID, 0, bigIsland2ID, cNumberNonGaiaPlayers*1.5);
			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: *************************************** //
/*================================================================================================================*/
        
		// ADD ISLAND CONSTRAINTS:
        int bigIslandConstraint=rmCreateAreaConstraint("north Island", bigIslandID);
        int bigIsland2Constraint=rmCreateAreaConstraint("south Island", bigIsland2ID); 
        
		int forestTreeID = 0;
        int numTries=8*cNumberNonGaiaPlayers;
        int failCount=0;
        for (i=0; <numTries)
{   
        int forest=rmCreateArea("forest "+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
        rmSetAreaForestType(forest, "caribbean palm forest");
        rmSetAreaForestDensity(forest, 0.6);
        rmSetAreaForestClumpiness(forest, 0.4);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 5);
        rmSetAreaMinBlobDistance(forest, 16.0);
        rmSetAreaMaxBlobDistance(forest, 40.0);
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidCloseCoin);
		rmAddAreaConstraint(forest, playerCloseConstraint);
		rmAddAreaConstraint(forest, playerCloseEdgeConstraint);
		rmAddAreaConstraint(forest, avoidCloseImpassableLand); 
        //rmAddAreaConstraint(forest, avoidTradeRoute);
		rmAddAreaConstraint(forest, bigIslandConstraint);
        if(rmBuildArea(forest)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
    }
        else
        failCount=0; 
} 

/*----------------------------------------------------------------------------------------------------------------*/
        
		for (i=0; <numTries)
{   
        int forest2=rmCreateArea("forest2 "+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
        rmSetAreaForestType(forest2, "caribbean palm forest");
        rmSetAreaForestDensity(forest2, 0.6);
        rmSetAreaForestClumpiness(forest2, 0.4);
        rmSetAreaForestUnderbrush(forest2, 0.0);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 5);
        rmSetAreaMinBlobDistance(forest2, 16.0);
        rmSetAreaMaxBlobDistance(forest2, 40.0);
        rmSetAreaCoherence(forest2, 0.4);
        rmSetAreaSmoothDistance(forest2, 10);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, avoidCloseCoin);
		rmAddAreaConstraint(forest2, playerCloseEdgeConstraint);
		rmAddAreaConstraint(forest2, playerCloseConstraint);
		rmAddAreaConstraint(forest2, avoidCloseImpassableLand); 
        //rmAddAreaConstraint(forest2, avoidTradeRoute);
		rmAddAreaConstraint(forest2, bigIsland2Constraint);
        if(rmBuildArea(forest2)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
    }
        else
        failCount=0; 
} 
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("caribs"))
	{  
		int caribs3VillageID = -1;
		caribs3VillageID = rmCreateGrouping("caribs village 3", "native carib village 1");
		rmSetGroupingMinDistance(caribs3VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs3VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(caribs3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(caribs3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs3VillageID, avoidCoin);
		rmAddGroupingConstraint(caribs3VillageID, bigIslandConstraint);
		rmAddGroupingConstraint(caribs3VillageID, playerNativesEdgeConstraint);
		rmAddGroupingConstraint(caribs3VillageID, forestCloseConstraint);
		rmAddGroupingConstraint(caribs3VillageID, playerVeryFarConstraint);
		rmPlaceGroupingAtLoc(caribs3VillageID, 0, 0.5, 0.5);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/	
		
		if (subCiv3 == rmGetCivID("caribs"))
	{  
		int caribs4VillageID = -1;
		caribs4VillageID = rmCreateGrouping("caribs village 4", "native carib village 1");
		rmSetGroupingMinDistance(caribs4VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs4VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(caribs4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(caribs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs4VillageID, avoidCoin);
		rmAddGroupingConstraint(caribs4VillageID, bigIsland2Constraint);
		rmAddGroupingConstraint(caribs4VillageID, playerNativesEdgeConstraint);
		rmAddGroupingConstraint(caribs4VillageID, forestCloseConstraint);
		rmAddGroupingConstraint(caribs4VillageID, playerVeryFarConstraint);
		rmPlaceGroupingAtLoc(caribs4VillageID, 0, 0.5, 0.5);
	} 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE NUGGETS: *************************************** //
/*================================================================================================================*/

	    // THE NUGGET EASY:
		int nugget1= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMaxDistance(nugget1, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget1, avoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget1, avoidFarNugget);
		rmAddObjectDefConstraint(nugget1, avoidCoin);
  	    rmAddObjectDefConstraint(nugget1, playerCloseConstraint);
  	    rmAddObjectDefConstraint(nugget1, avoidAll);
		rmAddObjectDefConstraint(nugget1, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget1, forestCloseConstraint);
  	    rmAddObjectDefConstraint(nugget1, playerEdgeConstraint);
	    rmPlaceObjectDefInArea(nugget1, 0, bigIslandID, cNumberNonGaiaPlayers*1);//rmRandInt(1,2));
		rmPlaceObjectDefInArea(nugget1, 0, bigIsland2ID, cNumberNonGaiaPlayers*1);//rmRandInt(1,2));

/*----------------------------------------------------------------------------------------------------------------*/	
	    
		// THE NUGGET 2:
		int nugget2= rmCreateObjectDef("nugget hard"); 
	    rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2, 0.0);
	    rmSetNuggetDifficulty(3, 3);
	    rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget2, avoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget2, avoidFarNugget);
  	    rmAddObjectDefConstraint(nugget2, playerCloseConstraint);
  	    rmAddObjectDefConstraint(nugget2, avoidAll);
		rmAddObjectDefConstraint(nugget2, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget2, avoidCoin);
		rmAddObjectDefConstraint(nugget2, forestCloseConstraint);
  	    rmAddObjectDefConstraint(nugget2, playerEdgeConstraint);
	    rmPlaceObjectDefInArea(nugget2, 0, bigIslandID, cNumberNonGaiaPlayers);
		rmPlaceObjectDefInArea(nugget2, 0, bigIsland2ID, cNumberNonGaiaPlayers);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE DEERS: **************************************** //	
/*================================================================================================================*/

        int deerID=rmCreateObjectDef("deer herd");
	    int bonusChance=rmRandFloat(0, 1);
        
		if(bonusChance<0.5)   
        rmAddObjectDefItem(deerID, "deer", rmRandInt(4,6), 10.0);
        else
        rmAddObjectDefItem(deerID, "deer", rmRandInt(8,10), 10.0);
        
		rmSetObjectDefMinDistance(deerID, 0.0);
        rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(deerID, avoidAll);
		rmAddObjectDefConstraint(deerID, avoidCloseNatives);
		rmAddObjectDefConstraint(deerID, avoidFarDeer);
		rmAddObjectDefConstraint(deerID, avoidCloseNugget);
		rmAddObjectDefConstraint(deerID, playerCloseConstraint);
		rmAddObjectDefConstraint(deerID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(deerID, avoidCloseCoin);
		rmAddObjectDefConstraint(deerID, forestCloseConstraint);
        rmAddObjectDefConstraint(deerID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(deerID, true);
        rmPlaceObjectDefInArea(deerID, 0, bigIslandID, 1.0*cNumberNonGaiaPlayers);
	    rmPlaceObjectDefInArea(deerID, 0,bigIsland2ID , 1.0*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE BERRIES: **************************************** //	
/*================================================================================================================*/

        int BerriesID=rmCreateObjectDef("The Berries");
	    bonusChance=rmRandFloat(0, 1);
        
		if(bonusChance<0.5)   
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(4,6), 8.0);
        else
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(2,4), 6.0);
        
		rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(BerriesID, avoidAll);
		rmAddObjectDefConstraint(BerriesID, avoidCloseNatives);
		rmAddObjectDefConstraint(BerriesID, avoidFarFruits);
		rmAddObjectDefConstraint(BerriesID, avoidMediumDeer);
		rmAddObjectDefConstraint(BerriesID, avoidCloseNugget);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, playerCloseEdgeConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCoin);
		rmAddObjectDefConstraint(BerriesID, forestCloseConstraint);
        rmAddObjectDefConstraint(BerriesID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(BerriesID, true);
        rmPlaceObjectDefInArea(BerriesID, 0, bigIslandID, 1.0*cNumberNonGaiaPlayers);
	    rmPlaceObjectDefInArea(BerriesID, 0,bigIsland2ID , 1.0*cNumberNonGaiaPlayers);		
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE FISHES AND WHALES: ************************************ //
/*================================================================================================================*/
   
        // THE FISH MAHI:
		int fishID=rmCreateObjectDef("fish Mahi");
        rmAddObjectDefItem(fishID, "FishMahi", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2)
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 24*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);
		
        // FISH TARPON:
		int fish2ID=rmCreateObjectDef("fish Tarpon");
        rmAddObjectDefItem(fish2ID, "FishTarpon", 3, 9.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFishID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2)
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 24*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);
		
        // THE WHALES:
		int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
		
		if (cNumberNonGaiaPlayers<=2)
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2.0*cNumberNonGaiaPlayers);
				
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM TREES: *************************************** //
/*================================================================================================================*/

        int randomTreeID=rmCreateObjectDef("random tree 1");
        rmAddObjectDefItem(randomTreeID, "treeCaribbean", rmRandInt(3,7), 9.0);//1, 0.0);
        rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
        rmAddObjectDefConstraint(randomTreeID, avoidMediumTrees);
        rmAddObjectDefConstraint(randomTreeID, avoidAll); 
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);

        if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(randomTreeID, 0, bigIsland3ID, cNumberNonGaiaPlayers*2.5);
	    else
		rmPlaceObjectDefInArea(randomTreeID, 0, bigIsland3ID, cNumberNonGaiaPlayers*1.25);
	    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(randomTreeID, 0, bigIsland4ID, cNumberNonGaiaPlayers*2.5);
		else
		rmPlaceObjectDefInArea(randomTreeID, 0, bigIsland4ID, cNumberNonGaiaPlayers*1.25);
		
/*================================================================================================================*/

        int randomTree2ID=rmCreateObjectDef("random tree 2");
        rmAddObjectDefItem(randomTree2ID, "treeCaribbean", rmRandInt(1,5), 3.0);
        rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseImpassableLand);
        rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseTrees);
        rmAddObjectDefConstraint(randomTree2ID, avoidAll); 
		rmAddObjectDefConstraint(randomTree2ID, forestCloseConstraint); 
		rmAddObjectDefConstraint(randomTree2ID, playerCloseEdgeConstraint); 
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseDeer); 
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseNatives); 
		rmAddObjectDefConstraint(randomTree2ID, playerVeryCloseConstraint); 
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseCoin);

        if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(randomTree2ID, 0, bigIslandID, cNumberNonGaiaPlayers*15);
	    else
		rmPlaceObjectDefInArea(randomTree2ID, 0, bigIslandID, cNumberNonGaiaPlayers*15);
	    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(randomTree2ID, 0, bigIsland2ID, cNumberNonGaiaPlayers*15);
		else
		rmPlaceObjectDefInArea(randomTree2ID, 0, bigIsland2ID, cNumberNonGaiaPlayers*15);		

/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SILVER MINES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
	    int silver2ID = rmCreateObjectDef("random silver 2");
	    rmAddObjectDefItem(silver2ID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(silver2ID, 0.0);
	    rmSetObjectDefMaxDistance(silver2ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silver2ID, avoidAll);
		rmAddObjectDefConstraint(silver2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(silver2ID, avoidTrees);
	    rmAddObjectDefConstraint(silver2ID, avoidCoin);
        rmAddObjectDefConstraint(silver2ID, avoidImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
	    rmPlaceObjectDefInArea(silver2ID, 0, bigIsland3ID, cNumberNonGaiaPlayers*0.5);
	    else
		rmPlaceObjectDefInArea(silver2ID, 0, bigIsland3ID, cNumberNonGaiaPlayers*0.25);
			    		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(silver2ID, 0, bigIsland4ID, cNumberNonGaiaPlayers*0.5);
		else
		rmPlaceObjectDefInArea(silver2ID, 0, bigIsland4ID, cNumberNonGaiaPlayers*0.25);
		
			
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE BERRIES: **************************************** //	
/*================================================================================================================*/

        int Berries2ID=rmCreateObjectDef("The Berries 2");
	    bonusChance=rmRandFloat(0, 1);
        
		if(bonusChance<0.5)   
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(4,6), 8.0);
        else
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(2,4), 6.0);
        
		rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(Berries2ID, avoidAll);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(Berries2ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Berries2ID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(Berries2ID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(Berries2ID, 0, bigIsland3ID, 0.5*cNumberNonGaiaPlayers);
	    else
		rmPlaceObjectDefInArea(Berries2ID, 0,bigIsland3ID , 0.25*cNumberNonGaiaPlayers);	
		   		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(Berries2ID, 0, bigIsland4ID, 0.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(Berries2ID, 0,bigIsland4ID , 0.25*cNumberNonGaiaPlayers);	

/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE NUGGETS: *************************************** //
/*================================================================================================================*/

	    // THE NUGGET EASY 2:
		int nugget3= rmCreateObjectDef("nugget easy 2"); 
	    rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget3, avoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget3, avoidNugget);
		rmAddObjectDefConstraint(nugget3, avoidCloseCoin);
  	    rmAddObjectDefConstraint(nugget3, avoidFruits);
  	    rmAddObjectDefConstraint(nugget3, avoidAll);
		rmAddObjectDefConstraint(nugget3, avoidCloseTrees);
		
		if (cNumberNonGaiaPlayers<=2)
  	    rmPlaceObjectDefInArea(nugget3, 0, bigIsland3ID, cNumberNonGaiaPlayers*0.5);
		else
		rmPlaceObjectDefInArea(nugget3, 0, bigIsland3ID, cNumberNonGaiaPlayers*0.25);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefInArea(nugget3, 0, bigIsland4ID, cNumberNonGaiaPlayers*0.5);
        else
        rmPlaceObjectDefInArea(nugget3, 0, bigIsland4ID, cNumberNonGaiaPlayers*0.25);		
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/
