/*===============================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

// TEST_0002:
// CREATED BY DANY:
// SEPTEMBER 2007:

/*===============================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		int subCiv4=-1;
        int subCiv5=-1;
		
/*---------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Cree");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cree");

		subCiv1=rmGetCivID("Cree");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cree"); 

		subCiv2=rmGetCivID("Cree");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cree");

		subCiv3=rmGetCivID("Cree");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cree");
		
		subCiv4=rmGetCivID("Cree");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Cree");

		subCiv5=rmGetCivID("Cree");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Cree");
   }		

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
   
        int playerTiles=25000;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(638, 638);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(0.0);
		
        // SET MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
		rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0);
		
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("great plains drygrass");
	    		
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("yukon\ground1_yuk", 5);
			    
		// SET LIGHTING:
		rmSetLightingSet("great plains");
		
		// SET MAP TYPE:
		rmSetMapType("greatPlains");
	    rmSetMapType("land");
		rmSetMapType("grass");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	    
		// CHOOSE THE MERCS:
		chooseMercs();

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================*/
// *********************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    int classPlayer=rmDefineClass("player");
		rmDefineClass("classCliff");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");	
	    rmDefineClass("socketClass");
	    rmDefineClass("nuggets");
		rmDefineClass("center");
		rmDefineClass("region");
		rmDefineClass("classTrees");
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ****************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
// ********************************* DEFINE THE CONSTRAINTS FOR THE MAP EDGE: *********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
   
        // MAP EDGE CONSTRAINTS:
        int edgeConstraint=rmCreatePieConstraint("edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
		int edgeCloseConstraint=rmCreatePieConstraint("close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
		int edgeVeryCloseConstraint=rmCreatePieConstraint("very close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.495), rmDegreesToRadians(0), rmDegreesToRadians(360));
		int edgeMediumCloseConstraint=rmCreatePieConstraint("medium edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.465), rmDegreesToRadians(0), rmDegreesToRadians(360));
		int edgeFarConstraint=rmCreatePieConstraint("far edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.455), rmDegreesToRadians(0), rmDegreesToRadians(360));
		int edgeVeryFarConstraint=rmCreatePieConstraint("very far edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.445), rmDegreesToRadians(0), rmDegreesToRadians(360));
		
/*----------------------------------------------------------------------------------------------------------------*/
// *************************** DEFINE THE CONSTRAINTS FOR THE PLAYER STARTING BASE: ***************************** //
/*----------------------------------------------------------------------------------------------------------------*/
		
        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stuff vs. player", classPlayer, 15.0);
		int playerCloseConstraint=rmCreateClassDistanceConstraint("close stuff vs. player", classPlayer, 5.0);
        int playerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff vs. player", classPlayer, 2.0);
        int playerMediumConstraint=rmCreateClassDistanceConstraint("medium stuff vs. player", classPlayer, 25.0);
        int playerFarConstraint=rmCreateClassDistanceConstraint("far stuff vs. player", classPlayer, 50.0);
        int playerVeryFarConstraint=rmCreateClassDistanceConstraint("very far stuff vs. player", classPlayer, 75.0);
        
/*----------------------------------------------------------------------------------------------------------------*/
// **************************** DEFINE THE CONSTRAINTS FOR THE CARDINAL DIRECTIONS: ***************************** //		
/*----------------------------------------------------------------------------------------------------------------*/

        // CARDINAL DIRECTIONS CONSTRAINTS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE CLIFFS: *********************************** //
/*----------------------------------------------------------------------------------------------------------------*/

        int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 15.0);
	    int avoidCloseCliffs=rmCreateClassDistanceConstraint("close stuff vs. cliff", rmClassID("classCliff"), 5.0);
	    int avoidVeryCloseCliffs=rmCreateClassDistanceConstraint("very close stuff vs. cliff", rmClassID("classCliff"), 2.0);
		int avoidMediumCliffs=rmCreateClassDistanceConstraint("medium stuff vs. cliff", rmClassID("classCliff"), 25.0);
	    int avoidFarCliffs=rmCreateClassDistanceConstraint("far stuff vs. cliff", rmClassID("classCliff"), 50.0);
	    int avoidVeryFarCliffs=rmCreateClassDistanceConstraint("very far stuff vs. cliff", rmClassID("classCliff"), 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* DEFINE THE CONSTRAINTS FOR THE CENTER AREA: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/
		
        // CENTER AVOIDANCE:
		int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 15.0);
	    int centerCloseConstraint=rmCreateClassDistanceConstraint("close stay away from center", rmClassID("center"), 5.0);
		int centerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stay away from center", rmClassID("center"), 2.0);
		int centerMediumConstraint=rmCreateClassDistanceConstraint("medium stay away from center", rmClassID("center"), 25.0);
	    int centerFarConstraint=rmCreateClassDistanceConstraint("far stay away from center", rmClassID("center"), 50.0);
        int centerVeryFarConstraint=rmCreateClassDistanceConstraint("very far stay away from center", rmClassID("center"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE THE CONSTRAINTS FOR THE REGION AREAS: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	    
        // REGION AVOIDANCE:
		int regionConstraint=rmCreateClassDistanceConstraint("stay away from region", rmClassID("region"), 15.0);
	    int regionCloseConstraint=rmCreateClassDistanceConstraint("close stay away from region", rmClassID("region"), 5.0);
		int regionVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stay away from region", rmClassID("region"), 2.0);
		int regionMediumConstraint=rmCreateClassDistanceConstraint("medium stay away from region", rmClassID("region"), 25.0);
	    int regionFarConstraint=rmCreateClassDistanceConstraint("far stay away from region", rmClassID("region"), 50.0);
        int regionVeryFarConstraint=rmCreateClassDistanceConstraint("very far stay away from region", rmClassID("region"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE FORESTS: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
		
		// FOREST AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("stuff vs. forest", rmClassID("classForest"), 15.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 5.0);
        int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs. forest", rmClassID("classForest"), 2.0);
        int forestMediumConstraint=rmCreateClassDistanceConstraint("medium vs. forest", rmClassID("classForest"), 25.0);
        int forestFarConstraint=rmCreateClassDistanceConstraint("far vs. forest", rmClassID("classForest"), 50.0);
        int forestVeryFarConstraint=rmCreateClassDistanceConstraint("very far vs. forest", rmClassID("classForest"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE TREES: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 10.0);
		int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 5.0);
		int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 2.0);
		int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
		int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
		int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// FISH AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 15.0);
		int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE THE CONSTRAINTS FOR THE LIVESTOCKS: ********************************** //		
/*----------------------------------------------------------------------------------------------------------------*/
        		        
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 15.0);
        int avoidCloseSheep=rmCreateTypeDistanceConstraint("close stuff avoids sheep", "sheep", 5.0);
		int avoidMediumSheep=rmCreateTypeDistanceConstraint("medium stuff avoids sheep", "sheep", 25.0);
		int avoidveryCloseSheep=rmCreateTypeDistanceConstraint("very close stuff avoids sheep", "sheep", 2.0);
		int avoidFarSheep=rmCreateTypeDistanceConstraint("far stuff avoids sheep", "sheep", 50.0);
        int avoidVeryFarSheep=rmCreateTypeDistanceConstraint("very far stuff avoids sheep", "sheep", 75.0);
       
/*----------------------------------------------------------------------------------------------------------------*/
// **************************** DEFINE THE CONSTRAINTS FOR THE NORTH AMERICAN FOOD: ***************************** //
/*----------------------------------------------------------------------------------------------------------------*/		
				
		// BISON AVOIDANCE:
		int avoidBison=rmCreateTypeDistanceConstraint("stuff avoids bison", "bison", 15.0);
        int avoidCloseBison=rmCreateTypeDistanceConstraint("close stuff avoids bison", "bison", 5.0);
		int avoidVeryCloseBison=rmCreateTypeDistanceConstraint("very close stuff avoids bison", "bison", 2.0);
		int avoidMediumBison=rmCreateTypeDistanceConstraint("medium stuff avoids bison", "bison", 25.0);
		int avoidFarBison=rmCreateTypeDistanceConstraint("far stuff avoids bison", "bison", 50.0);
		int avoidVeryFarBison=rmCreateTypeDistanceConstraint("very Far stuff avoids bison", "bison", 75.0);
		        
		// PRONGHORN AVOIDANCE:
		int avoidPronghorn=rmCreateTypeDistanceConstraint("stuff avoids pronghorn", "pronghorn", 35.0);
	    int avoidClosePronghorn=rmCreateTypeDistanceConstraint("close stuff avoids pronghorn", "pronghorn", 5.0);
	    int avoidVeryClosePronghorn=rmCreateTypeDistanceConstraint("very close stuff avoids pronghorn", "pronghorn", 2.0);
	    int avoidMediumPronghorn=rmCreateTypeDistanceConstraint("medium avoids pronghorn", "pronghorn", 25.0);
	    int avoidFarPronghorn=rmCreateTypeDistanceConstraint("far avoids pronghorn", "pronghorn", 50.0);
	    int avoidVeryFarPronghorn=rmCreateTypeDistanceConstraint("very far avoids pronghorn", "pronghorn", 75.0);
	    		
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE MONEY: ************************************ //		
/*----------------------------------------------------------------------------------------------------------------*/
	    		
		// SILVER COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoids coin", "mine", 15.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close stuff avoids coin", "mine", 5.0);
		int avoidVeryCloseCoin=rmCreateTypeDistanceConstraint("very close stuff avoids coin", "mine", 2.0);
		int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium stuff avoids coin", "mine", 25.0);
		int avoidFarCoin=rmCreateTypeDistanceConstraint("far stuff avoids coin", "mine", 50.0);
		int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far stuff avoids coin", "mine", 75.0);
	
		// STARTING COIN AVOIDANCE:
		int avoidStartingCoin=rmCreateTypeDistanceConstraint("starting coin avoids coin", "gold", 22.0);
  		
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** DEFINE THE CONSTRAINTS FOR THE FRUITS: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/		
				
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 15.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 5.0);
		int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoid fruits", "berrybush", 2.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid fruits", "berrybush", 25.0);
		int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid fruits", "berrybush", 50.0);
		int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoid fruits", "berrybush", 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* DEFINE THE CONSTRAINTS FOR THE TREASURES: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
        
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 15.0);
        int avoidCloseNugget=rmCreateTypeDistanceConstraint("close stuff avoid nugget", "AbstractNugget", 5.0);
        int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close stuff avoid nugget", "AbstractNugget", 2.0);
        int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium stuff avoid nugget", "AbstractNugget", 25.0);
        int avoidFarNugget=rmCreateTypeDistanceConstraint("far stuff avoid nugget", "AbstractNugget", 50.0);
        int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far stuff avoid nugget", "AbstractNugget", 75.0);
        		
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE THE CONSTRAINTS FOR THE IMPASSABLE LAND: ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

		// AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("stuff avoid impassable land", "Land", false, 15.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close stuff avoid impassable land", "Land", false, 5.0);
        int avoidVeryCloseImpassableLand=rmCreateTerrainDistanceConstraint("very close stuff avoid impassable land", "Land", false, 2.0);
        int avoidMediumImpassableLand=rmCreateTerrainDistanceConstraint("medium stuff avoid impassable land", "Land", false, 25.0);
        int avoidFarImpassableLand=rmCreateTerrainDistanceConstraint("far stuff avoid impassable land", "Land", false, 50.0);
        int avoidVeryFarImpassableLand=rmCreateTerrainDistanceConstraint("very far stuff avoid impassable land", "Land", false, 75.0);

/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE THE CONSTRAINTS FOR THE STARTING UNITS: ******************************* //		
/*----------------------------------------------------------------------------------------------------------------*/

        // UNIT AVOIDANCE - FOR THINGS THAT AREN'T IN THE STARTING RESOURCES:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 15.0);
        int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close objects avoid starting units", rmClassID("startingUnit"), 5.0);
        int avoidVeryCloseStartingUnits=rmCreateClassDistanceConstraint("very close objects avoid starting units", rmClassID("startingUnit"), 2.0);
        int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium objects avoid starting units", rmClassID("startingUnit"), 25.0);
        int avoidFarStartingUnits=rmCreateClassDistanceConstraint("far objects avoid starting units", rmClassID("startingUnit"), 50.0);
        int avoidVeryFarStartingUnits=rmCreateClassDistanceConstraint("very far objects avoid starting units", rmClassID("startingUnit"), 75.0);
      
/*----------------------------------------------------------------------------------------------------------------*/		
// ********************************* DEFINE THE CONSTRAINTS FOR THE DECORATIONS: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("stuff avoid all", "all", 10.0);
		int avoidCloseAll=rmCreateTypeDistanceConstraint("close stuff avoid all", "all", 5.0);
		int avoidVeryCloseAll=rmCreateTypeDistanceConstraint("very close stuff avoid all", "all", 2.0);
		int avoidMediumAll=rmCreateTypeDistanceConstraint("medium stuff avoid all", "all", 25.0);
		int avoidFarAll=rmCreateTypeDistanceConstraint("far stuff avoid all", "all", 50.0);
		int avoidVeryFarAll=rmCreateTypeDistanceConstraint("very far stuff avoid all", "all", 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
// ***************************** DEFINE THE CONSTRAINTS FOR THE IMPORTANT ITEMS: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/
        
        // IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("stuff avoids important item", rmClassID("importantItem"), 15.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close stuff avoids important item", rmClassID("importantItem"), 5.0);
        int avoidVeryCloseImportantItem=rmCreateClassDistanceConstraint("very close stuff avoids important item", rmClassID("importantItem"), 2.0);
        int avoidMediumImportantItem=rmCreateClassDistanceConstraint("medium stuff avoids important item", rmClassID("importantItem"), 25.0);
        int avoidFarImportantItem=rmCreateClassDistanceConstraint("far stuff avoids important item", rmClassID("importantItem"), 50.0);
        int avoidVeryFarImportantItem=rmCreateClassDistanceConstraint("very far stuff avoids important item", rmClassID("importantItem"), 75.0);
        
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE THE CONSTRAINTS FOR THE TRADE ROUTE: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/		
       
        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("stuff avoid trade route", 15.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close stuff avoid trade route", 5.0);
        int avoidVeryCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("very close stuff avoid trade route", 2.0);
        int avoidMediumTradeRoute = rmCreateTradeRouteDistanceConstraint("medium stuff avoid trade route", 25.0);
        int avoidFarTradeRoute = rmCreateTradeRouteDistanceConstraint("far stuff avoid trade route", 50.0);
        int avoidVeryFarTradeRoute = rmCreateTradeRouteDistanceConstraint("very far stuff avoid trade route", 75.0);
       
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE SOCKET: *********************************** //        		
/*----------------------------------------------------------------------------------------------------------------*/

	    // SOCKET AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("stuff avoid socket", rmClassID("socketClass"), 15.0);
	    int avoidCloseSocket=rmCreateClassDistanceConstraint("close stuff avoid socket", rmClassID("socketClass"), 5.0);
	    int avoidVeryCloseSocket=rmCreateClassDistanceConstraint("very close avoid socket", rmClassID("socketClass"), 2.0);
	    int avoidMediumSocket=rmCreateClassDistanceConstraint("medium avoid socket", rmClassID("socketClass"), 25.0);
	    int avoidFarSocket=rmCreateClassDistanceConstraint("far stuff avoid socket", rmClassID("socketClass"), 50.0);
	    int avoidVeryFarSocket=rmCreateClassDistanceConstraint("very far stuff avoid socket", rmClassID("socketClass"), 75.0);
	   
/*----------------------------------------------------------------------------------------------------------------*/		
// ********************************** DEFINE THE CONSTRAINT FOR THE NATIVES: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
	
	    // NATIVES AVOIDANCE:
	    int avoidNatives = rmCreateClassDistanceConstraint("stuff avoid Natives", rmClassID("natives"), 15.0);
	    int avoidCloseNatives = rmCreateClassDistanceConstraint("close stuff avoid Natives", rmClassID("natives"), 5.0);
	   	int avoidVeryCloseNatives = rmCreateClassDistanceConstraint("very close stuff avoid Natives", rmClassID("natives"), 2.0);
	   	int avoidMediumNatives = rmCreateClassDistanceConstraint("medium stuff avoid Natives", rmClassID("natives"), 25.0);
	   	int avoidFarNatives = rmCreateClassDistanceConstraint("far stuff avoid Natives", rmClassID("natives"), 50.0);
	   	int avoidVeryFarNatives = rmCreateClassDistanceConstraint("very far stuff avoid Natives", rmClassID("natives"), 75.0);
	   	
/*----------------------------------------------------------------------------------------------------------------*/
// ****************************** DEFINE THE CONSTRAINT FOR THE CIRCLE CONSTRAINT: ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE TRADE ROUTE 1:
		int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 12.0);

	    rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.50);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.30);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.10);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.10);
	    
        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
		
		rmPlaceObjectDefAtLoc(socketID, 0, 0.90, 0.50);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.90, 0.30);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.70, 0.10);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.50, 0.10);
    
/*----------------------------------------------------------------------------------------------------------------*/
 
	   // DEFINE AND PLACE TRADE ROUTE 2:
		int tradeRoute2ID = rmCreateTradeRoute();
        socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
        rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 12.0);

	    rmAddTradeRouteWaypoint(tradeRoute2ID, 0.10, 0.50);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.10, 0.70);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.30, 0.90);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.50, 0.90);
	    
        placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
		
		rmPlaceObjectDefAtLoc(socketID, 0, 0.10, 0.50);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.10, 0.70);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.30, 0.90);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.50, 0.90);
    
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/
// **************************************** DEFINE AND PLACE THE AREAS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE A CENTER AREA: 		
		int centerID=rmCreateArea("The Center Area");
        rmSetAreaSize(centerID, 0.105, 0.105);
        rmSetAreaLocation(centerID, 0.5, 0.5);
		rmSetAreaCoherence(centerID, 1.0);
        rmAddAreaToClass(centerID, rmClassID("center"));
		//rmSetAreaMix(centerID, "rockies_snow");
        rmBuildArea(centerID); 
	
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE REGION AREA 1: 		
		int region1ID=rmCreateArea("Region Area 1");
        rmSetAreaSize(region1ID, 0.003, 0.003);
        rmSetAreaLocation(region1ID, 0.325, 0.325);
		rmSetAreaCoherence(region1ID, 1.0);
        rmAddAreaToClass(region1ID, rmClassID("region"));
		//rmSetAreaMix(region1ID, "rockies_snow");
        rmBuildArea(region1ID); 
		
/*---------------------------------------------------------------------------------------------------------------*/

		// DEFINE AND PLACE REGION AREA 2: 		
		int region2ID=rmCreateArea("Region Area 2");
        rmSetAreaSize(region2ID, 0.003, 0.003);
        rmSetAreaLocation(region2ID, 0.675, 0.675);
		rmSetAreaCoherence(region2ID, 1.0);
        rmAddAreaToClass(region2ID, rmClassID("region"));
		//rmSetAreaMix(region2ID, "rockies_snow");
        rmBuildArea(region2ID); 

/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE REGION AREA 3: 		
		int region3ID=rmCreateArea("Region Area 3");
        rmSetAreaSize(region3ID, 0.003, 0.003);
        rmSetAreaLocation(region3ID, 0.20, 0.60);
		rmSetAreaCoherence(region3ID, 1.0);
        rmAddAreaToClass(region3ID, rmClassID("region"));
		//rmSetAreaMix(region3ID, "rockies_snow");
        rmBuildArea(region3ID); 

/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE REGION AREA 4: 		
		int region4ID=rmCreateArea("Region Area 4");
        rmSetAreaSize(region4ID, 0.003, 0.003);
        rmSetAreaLocation(region4ID, 0.60, 0.20);
		rmSetAreaCoherence(region4ID, 1.0);
        rmAddAreaToClass(region4ID, rmClassID("region"));
		//rmSetAreaMix(region4ID, "rockies_snow");
        rmBuildArea(region4ID); 

/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE REGION AREA 5: 		
		int region5ID=rmCreateArea("Region Area 5");
        rmSetAreaSize(region5ID, 0.003, 0.003);
        rmSetAreaLocation(region5ID, 0.40, 0.80);
		rmSetAreaCoherence(region5ID, 1.0);
        rmAddAreaToClass(region5ID, rmClassID("region"));
		//rmSetAreaMix(region5ID, "rockies_snow");
        rmBuildArea(region5ID); 

/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE REGION AREA 6: 		
		int region6ID=rmCreateArea("Region Area 6");
        rmSetAreaSize(region6ID, 0.003, 0.003);
        rmSetAreaLocation(region6ID, 0.80, 0.40);
		rmSetAreaCoherence(region6ID, 1.0);
        rmAddAreaToClass(region6ID, rmClassID("region"));
		//rmSetAreaMix(region6ID, "rockies_snow");
        rmBuildArea(region6ID); 		

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/
// **************************************** SET UP THE PLAYER LOCATIONS: *************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        rmSetPlacementTeam(0);
		rmSetPlacementSection(0.075, 0.175);
		rmPlacePlayersCircular(0.38, 0.38, 0);
		
		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.575, 0.675);
		rmPlacePlayersCircular(0.38, 0.38, 0); 

/*===============================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ****************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        float playerFraction=rmAreaTilesToFraction(1750);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "great plains drygrass");
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
                
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
   }
        // Build the areas.
        rmBuildAllAreas();

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE SOME OTHER AREAS: ************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/
// ****************** DEFINE THE STARTING TCID AND THE STARTING UNITS AND STARTING RESOURCES: ****************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE STARTING STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 7.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);

	    // DEFINE THE STARTING TCID:
		int startingTCID = rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 0.0);
	    //rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/
// ********************* PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
	}
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
	    for(i=1; <cNumberPlayers)
	{	
		// DEFINE TWO PLAYER SILVER MINES:
		// EVERYONE GETS TWO ORE OBJECTDEF, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		int silverType = -1;
	    int playerGoldID = -1;
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefToClass(playerGoldID, rmClassID("startingUnit"));
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		//rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidCloseStartingUnits);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE TWO PLAYER SILVER MINES:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}	
	
/*----------------------------------------------------------------------------------------------------------------*/

        for(i=1; <cNumberPlayers)
	{	
		// DEFINING THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees"+i);
	    rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 1, 0.0);
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseStartingUnits);

        // PLACING THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}

/*----------------------------------------------------------------------------------------------------------------*/	
	
        for(i=1; <cNumberPlayers)
	{	
		// DEFINING THE STARTING BISONS:
		int StartBisonID=rmCreateObjectDef("starting bison"+i);
	    rmAddObjectDefItem(StartBisonID, "Bison", 4, 4.0);
		rmAddObjectDefToClass(StartBisonID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartBisonID, 10.0);
	    rmSetObjectDefMaxDistance(StartBisonID, 12.0);
	    rmSetObjectDefCreateHerd(StartBisonID, true);
	    rmAddObjectDefConstraint(StartBisonID, avoidCloseStartingUnits);

        // PLACING THE STARTING BISONS:
		rmPlaceObjectDefAtLoc(StartBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}	
	
/*----------------------------------------------------------------------------------------------------------------*/

        for(i=1; <cNumberPlayers)
	{	
		// DEFINING THE STARTING BERRIES:
		int StartBerriesID=rmCreateObjectDef("starting berries"+i);
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 4, 4.0);
		rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartBerriesID, 15.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 17.0);
	    rmSetObjectDefCreateHerd(StartBerriesID, true);
	    rmAddObjectDefConstraint(StartBerriesID, avoidCloseStartingUnits);

        // PLACING THE STARTING BERRIES:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}		
    
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/
// ******************************* DEFINE AND PLACE THE NATIVE AMERICAN TRIBES: ******************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("Cree"))
	{  
		int cree1VillageID = -1;
		cree1VillageID = rmCreateGrouping("cree village 1", "native cree village 1");
		rmSetGroupingMinDistance(cree1VillageID, 0.0);
		rmSetGroupingMaxDistance(cree1VillageID, 0.0);
		rmAddGroupingToClass(cree1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree1VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(cree1VillageID, 0, 0.20, 0.60);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("Cree"))
	{  
		int cree2VillageID = -1;
		cree2VillageID = rmCreateGrouping("cree village 2", "native cree village 1");
		rmSetGroupingMinDistance(cree2VillageID, 0.0);
		rmSetGroupingMaxDistance(cree2VillageID, 0.0);
		rmAddGroupingToClass(cree2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree2VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(cree2VillageID, 0, 0.60, 0.20);
	} 	
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("Cree"))
	{  
		int cree3VillageID = -1;
		cree3VillageID = rmCreateGrouping("cree village 3", "native cree village 1");
		rmSetGroupingMinDistance(cree3VillageID, 0.0);
		rmSetGroupingMaxDistance(cree3VillageID, 0.0);
		rmAddGroupingToClass(cree3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree3VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(cree3VillageID, 0, 0.40, 0.80);
	} 

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("Cree"))
	{  
		int cree4VillageID = -1;
		cree4VillageID = rmCreateGrouping("cree village 4", "native cree village 1");
		rmSetGroupingMinDistance(cree4VillageID, 0.0);
		rmSetGroupingMaxDistance(cree4VillageID, 0.0);
		rmAddGroupingToClass(cree4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree4VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(cree4VillageID, 0, 0.80, 0.40);
	} 

/*----------------------------------------------------------------------------------------------------------------*/
		
		if (subCiv4 == rmGetCivID("Cree"))
	{  
		int cree5VillageID = -1;
		cree5VillageID = rmCreateGrouping("cree village 5", "native cree village 1");
		rmSetGroupingMinDistance(cree5VillageID, 0.0);
		rmSetGroupingMaxDistance(cree5VillageID, 0.0);
		rmAddGroupingToClass(cree5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree5VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(cree5VillageID, 0, 0.325, 0.325);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv5 == rmGetCivID("Cree"))
	{  
		int cree6VillageID = -1;
		cree6VillageID = rmCreateGrouping("cree village 6", "native cree village 1");
		rmSetGroupingMinDistance(cree6VillageID, 0.0);
		rmSetGroupingMaxDistance(cree6VillageID, 0.0);
		rmAddGroupingToClass(cree6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree6VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(cree6VillageID, 0, 0.675, 0.675);
	} 
	

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/
// ********************************** DEFINE AND PLACE THE CENTER POND: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // POND NUMBER 1:
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 15.0);
        int pondCloseConstraint=rmCreateClassDistanceConstraint("close ponds avoid ponds", rmClassID("pond"), 5.0);
		
/*----------------------------------------------------------------------------------------------------------------*/        
		
		int smallPondID=rmCreateArea("small pond 1");
        rmSetAreaSize(smallPondID, rmAreaTilesToFraction(3750), rmAreaTilesToFraction(4750));
        rmSetAreaWaterType(smallPondID, "saguenay lake");
		rmSetAreaBaseHeight(smallPondID, 3);
        rmSetAreaMinBlobs(smallPondID, 15);
        rmSetAreaMaxBlobs(smallPondID, 35);
        rmSetAreaMinBlobDistance(smallPondID, 15.0);
        rmSetAreaMaxBlobDistance(smallPondID, 35.0);
        rmAddAreaToClass(smallPondID, pondClass);
        rmSetAreaCoherence(smallPondID, 0.65);
        rmSetAreaSmoothDistance(smallPondID, 5);
        rmAddAreaConstraint(smallPondID, pondConstraint);
        rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.50, 0.50); 
        rmBuildArea(smallPondID);

/*================================================================================================================*/
// ************************** DEFINE AND PLACE SOME RANDOM NORTHERN AND SOUTHERN CLIFFS: ************************ //
/*================================================================================================================*/

		int numTries = -1;
	    int failCount = -1;
		
		if (cNumberNonGaiaPlayers<=2)
		numTries=cNumberNonGaiaPlayers*4;
		else
		numTries=cNumberNonGaiaPlayers*2;
	    failCount=0;
	    
		for(i=0; <numTries)
{	
		int Cliff1ID=rmCreateArea("The Cliff 1"+i);
	    rmSetAreaSize(Cliff1ID, 0.0015, 0.0015);
		rmSetAreaWarnFailure(Cliff1ID, false);
		rmSetAreaCliffType(Cliff1ID, "Great Plains");
		rmAddAreaToClass(Cliff1ID, rmClassID("classCliff"));		
		//rmSetAreaCliffEdge(Cliff1ID, 1, 0.6, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(Cliff1ID, 1, 1.0, 0.1, 1.0, 0);		
		rmSetAreaCliffPainting(Cliff1ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(Cliff1ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(Cliff1ID, 1.0);
		//rmAddAreaTerrainLayer(Cliff1ID, "texas\ground2_tex", 0, 2);
        rmSetAreaSmoothDistance(Cliff1ID, 15);
		rmSetAreaCoherence(Cliff1ID, 0.85);
		
		rmAddAreaConstraint(Cliff1ID, avoidImportantItem);
		rmAddAreaConstraint(Cliff1ID, avoidTradeRoute);
		rmAddAreaConstraint(Cliff1ID, avoidSocket);
		rmAddAreaConstraint(Cliff1ID, edgeConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidImpassableLand);
		rmAddAreaConstraint(Cliff1ID, centerConstraint);
		rmAddAreaConstraint(Cliff1ID, regionConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidAll);
		rmAddAreaConstraint(Cliff1ID, avoidVeryFarCliffs);
		rmAddAreaConstraint(Cliff1ID, Northward);
		rmAddAreaConstraint(Cliff1ID, playerCloseConstraint);
				  	    		
		if(rmBuildArea(Cliff1ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}

        		
/*----------------------------------------------------------------------------------------------------------------*/		

		for(i=0; <numTries)
	{	
		int Cliff2ID=rmCreateArea("The Cliff 2"+i);
	    rmSetAreaSize(Cliff2ID, 0.0015, 0.0015);
		rmSetAreaWarnFailure(Cliff2ID, false);
		rmSetAreaCliffType(Cliff2ID, "Great Plains");
		rmAddAreaToClass(Cliff2ID, rmClassID("classCliff"));		
		//rmSetAreaCliffEdge(Cliff2ID, 1, 0.6, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(Cliff2ID, 1, 1.0, 0.1, 1.0, 0);			
		rmSetAreaCliffPainting(Cliff2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(Cliff2ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(Cliff2ID, 1.0);
		//rmAddAreaTerrainLayer(Cliff2ID, "texas\ground2_tex", 0, 2);
        rmSetAreaSmoothDistance(Cliff2ID, 15);
		rmSetAreaCoherence(Cliff2ID, 0.85);
		
		rmAddAreaConstraint(Cliff2ID, avoidImportantItem);
		rmAddAreaConstraint(Cliff2ID, avoidTradeRoute);
		rmAddAreaConstraint(Cliff2ID, avoidSocket);
		rmAddAreaConstraint(Cliff2ID, edgeConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidImpassableLand);
		rmAddAreaConstraint(Cliff2ID, centerConstraint);
		rmAddAreaConstraint(Cliff2ID, regionConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidAll);
		rmAddAreaConstraint(Cliff2ID, avoidVeryFarCliffs);
		rmAddAreaConstraint(Cliff2ID, Southward);
		rmAddAreaConstraint(Cliff2ID, playerCloseConstraint);
		
		if(rmBuildArea(Cliff2ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
		
	}		

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE FASTCOIN MINES: ************************************* //   
/*================================================================================================================*/

        // THE NORTHERN MINES:
		int CoinsID= rmCreateObjectDef("The Coins 1"); 
	    rmAddObjectDefItem(CoinsID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(CoinsID, 0.0);
	    rmSetObjectDefMaxDistance(CoinsID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(CoinsID, avoidImpassableLand);
		rmAddObjectDefConstraint(CoinsID, avoidVeryFarCoin);
		rmAddObjectDefConstraint(CoinsID, playerCloseConstraint);
  	    rmAddObjectDefConstraint(CoinsID, centerCloseConstraint);
		rmAddObjectDefConstraint(CoinsID, regionConstraint);
		rmAddObjectDefConstraint(CoinsID, avoidTradeRoute);
	    rmAddObjectDefConstraint(CoinsID, avoidSocket);
	    rmAddObjectDefConstraint(CoinsID, avoidCloseCliffs);
	    rmAddObjectDefConstraint(CoinsID, circleConstraint);
		rmAddObjectDefConstraint(CoinsID, Northward);
  	    rmAddObjectDefConstraint(CoinsID, avoidAll);
	    
		rmSetNuggetDifficulty(1, 4);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(CoinsID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(CoinsID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE SOUTHERN MINES:
		int Coins2ID= rmCreateObjectDef("The Coins 2"); 
	    rmAddObjectDefItem(Coins2ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(Coins2ID, 0.0);
	    rmSetObjectDefMaxDistance(Coins2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Coins2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(Coins2ID, avoidVeryFarCoin);
		rmAddObjectDefConstraint(Coins2ID, playerCloseConstraint);
  	    rmAddObjectDefConstraint(Coins2ID, centerCloseConstraint);
		rmAddObjectDefConstraint(Coins2ID, regionConstraint);
		rmAddObjectDefConstraint(Coins2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(Coins2ID, avoidSocket);
	    rmAddObjectDefConstraint(Coins2ID, avoidCloseCliffs);
	    rmAddObjectDefConstraint(Coins2ID, circleConstraint);
		rmAddObjectDefConstraint(Coins2ID, Southward);
  	    rmAddObjectDefConstraint(Coins2ID, avoidAll);
	    
		rmSetNuggetDifficulty(1, 4);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(Coins2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/

	    // THE NORTHERN NUGGETS:
		int nuggetID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(nuggetID, avoidVeryFarNugget);
		rmAddObjectDefConstraint(nuggetID, avoidCloseCoin);
		rmAddObjectDefConstraint(nuggetID, playerCloseConstraint);
  	    rmAddObjectDefConstraint(nuggetID, centerCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, regionConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
	    rmAddObjectDefConstraint(nuggetID, avoidSocket);
	    rmAddObjectDefConstraint(nuggetID, avoidCloseCliffs);
	    rmAddObjectDefConstraint(nuggetID, circleConstraint);
		rmAddObjectDefConstraint(nuggetID, Northward);
  	    rmAddObjectDefConstraint(nuggetID, avoidAll);
	    
		rmSetNuggetDifficulty(1, 4);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE SOUTHERN NUGGETS:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nugget2ID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget2ID, avoidVeryFarNugget);
		rmAddObjectDefConstraint(nugget2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(nugget2ID, playerCloseConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, centerCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, regionConstraint);
		rmAddObjectDefConstraint(nugget2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(nugget2ID, avoidSocket);
	    rmAddObjectDefConstraint(nugget2ID, avoidCloseCliffs);
	    rmAddObjectDefConstraint(nugget2ID, circleConstraint);
		rmAddObjectDefConstraint(nugget2ID, Southward);
  	    rmAddObjectDefConstraint(nugget2ID, avoidAll);
	    
		rmSetNuggetDifficulty(1, 4);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //		
/*================================================================================================================*/

        // THE NORTHERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Berries 1");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(BerriesID, regionConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCoin);
		rmAddObjectDefConstraint(BerriesID, centerCloseConstraint);
        rmAddObjectDefConstraint(BerriesID, avoidAll);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCliffs);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, Northward);
        rmAddObjectDefConstraint(BerriesID, avoidImpassableLand);
	    rmAddObjectDefConstraint(BerriesID, avoidTradeRoute);
	    rmAddObjectDefConstraint(BerriesID, avoidSocket);
	    rmAddObjectDefConstraint(BerriesID, avoidCloseNugget);
        
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
	    
/*----------------------------------------------------------------------------------------------------------------*/
		
		// THE SOUTHERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Berries 2");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(Berries2ID, regionConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidVeryFarFruits);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Berries2ID, centerCloseConstraint);
        rmAddObjectDefConstraint(Berries2ID, avoidAll);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(Berries2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, Southward);
        rmAddObjectDefConstraint(Berries2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Berries2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(Berries2ID, avoidSocket);
	    rmAddObjectDefConstraint(Berries2ID, avoidCloseNugget);
        
		rmSetObjectDefCreateHerd(Berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
	       
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE PRONGHORN: ***************************************** //
/*================================================================================================================*/

        // THE NORTHERN PRONGHORNS:
		int pronghornID=rmCreateObjectDef("pronghorn herd 1");
        rmAddObjectDefItem(pronghornID, "pronghorn", rmRandInt(6,9), 10.0);
        rmSetObjectDefMinDistance(pronghornID, 0.0);
        rmSetObjectDefMaxDistance(pronghornID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(pronghornID, regionConstraint);
		rmAddObjectDefConstraint(pronghornID, centerCloseConstraint);
        rmAddObjectDefConstraint(pronghornID, avoidPronghorn);
	    rmAddObjectDefConstraint(pronghornID, avoidAll);
		rmAddObjectDefConstraint(pronghornID, avoidCloseCliffs);
		rmAddObjectDefConstraint(pronghornID, avoidCloseFruits);
		rmAddObjectDefConstraint(pronghornID, avoidCloseCoin);
		rmAddObjectDefConstraint(pronghornID, playerCloseConstraint);
		rmAddObjectDefConstraint(pronghornID, Northward);
        rmAddObjectDefConstraint(pronghornID, avoidImpassableLand);
	    rmAddObjectDefConstraint(pronghornID, avoidTradeRoute);
	    rmAddObjectDefConstraint(pronghornID, avoidSocket);
	    rmAddObjectDefConstraint(pronghornID, avoidCloseNugget);
        rmSetObjectDefCreateHerd(pronghornID, true);
	    rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);
		
		// THE SOUTHTHERN PRONGHORNS:
		int pronghorn2ID=rmCreateObjectDef("pronghorn herd 2");
        rmAddObjectDefItem(pronghorn2ID, "pronghorn", rmRandInt(6,9), 10.0);
        rmSetObjectDefMinDistance(pronghorn2ID, 0.0);
        rmSetObjectDefMaxDistance(pronghorn2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(pronghorn2ID, regionConstraint);
		rmAddObjectDefConstraint(pronghorn2ID, centerCloseConstraint);
		rmAddObjectDefConstraint(pronghorn2ID, avoidPronghorn);
	    rmAddObjectDefConstraint(pronghorn2ID, avoidAll);
		rmAddObjectDefConstraint(pronghorn2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(pronghorn2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(pronghorn2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(pronghorn2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(pronghorn2ID, Southward);
        rmAddObjectDefConstraint(pronghorn2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(pronghorn2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(pronghorn2ID, avoidSocket);
	    rmAddObjectDefConstraint(pronghorn2ID, avoidCloseNugget);
        rmSetObjectDefCreateHerd(pronghorn2ID, true);
	    rmPlaceObjectDefAtLoc(pronghorn2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE BISONS: ***************************************** //
/*================================================================================================================*/
	
        // THE NORTH BISON HERD:
		int bison1ID=rmCreateObjectDef("bison herd 1");
        rmAddObjectDefItem(bison1ID, "bison", rmRandInt(12,16), 12.0);
        rmSetObjectDefMinDistance(bison1ID, 0.0);
        rmSetObjectDefMaxDistance(bison1ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(bison1ID, avoidVeryFarBison);
		rmAddObjectDefConstraint(bison1ID, avoidFarPronghorn);
	    rmAddObjectDefConstraint(bison1ID, avoidAll);
		rmAddObjectDefConstraint(bison1ID, avoidCloseFruits);
		rmAddObjectDefConstraint(bison1ID, avoidCloseCoin);
		rmAddObjectDefConstraint(bison1ID, edgeCloseConstraint);
		rmAddObjectDefConstraint(bison1ID, playerCloseConstraint);
		rmAddObjectDefConstraint(bison1ID, regionConstraint);
		rmAddObjectDefConstraint(bison1ID, centerCloseConstraint);
		rmAddObjectDefConstraint(bison1ID, Northward);
		rmAddObjectDefConstraint(bison1ID, avoidCloseCliffs);
        rmAddObjectDefConstraint(bison1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(bison1ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(bison1ID, avoidSocket);
	    rmAddObjectDefConstraint(bison1ID, avoidCloseNugget);
        rmSetObjectDefCreateHerd(bison1ID, true);
	    rmPlaceObjectDefAtLoc(bison1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);
		
		// THE SOUTH BISON HERD:
		int bison2ID=rmCreateObjectDef("bison herd 2");
        rmAddObjectDefItem(bison2ID, "bison", rmRandInt(12,16), 12.0);
        rmSetObjectDefMinDistance(bison2ID, 0.0);
        rmSetObjectDefMaxDistance(bison2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(bison2ID, avoidVeryFarBison);
		rmAddObjectDefConstraint(bison2ID, avoidFarPronghorn);
	    rmAddObjectDefConstraint(bison2ID, avoidAll);
		rmAddObjectDefConstraint(bison2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(bison2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(bison2ID, edgeCloseConstraint);
		rmAddObjectDefConstraint(bison2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(bison2ID, regionConstraint);
		rmAddObjectDefConstraint(bison2ID, centerCloseConstraint);
		rmAddObjectDefConstraint(bison2ID, Southward);
		rmAddObjectDefConstraint(bison2ID, avoidCloseCliffs);
        rmAddObjectDefConstraint(bison2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(bison2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(bison2ID, avoidSocket);
	    rmAddObjectDefConstraint(bison2ID, avoidCloseNugget);
        rmSetObjectDefCreateHerd(bison2ID, true);
	    rmPlaceObjectDefAtLoc(bison2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);
		
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SHEEPS ON THE MAP: *********************************** //
/*================================================================================================================*/

        // THE NORTHERN SHEEP HERD:
		int sheep1ID=rmCreateObjectDef("sheep herd 1");
        rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(5,7), 7.0);
        rmSetObjectDefMinDistance(sheep1ID, 0.0);
        rmSetObjectDefMaxDistance(sheep1ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(sheep1ID, avoidVeryFarSheep);
        rmAddObjectDefConstraint(sheep1ID, avoidFarBison);
		rmAddObjectDefConstraint(sheep1ID, avoidFarPronghorn);
	    rmAddObjectDefConstraint(sheep1ID, avoidAll);
		rmAddObjectDefConstraint(sheep1ID, avoidCloseFruits);
		rmAddObjectDefConstraint(sheep1ID, avoidCloseCoin);
		rmAddObjectDefConstraint(sheep1ID, edgeCloseConstraint);
		rmAddObjectDefConstraint(sheep1ID, playerCloseConstraint);
		rmAddObjectDefConstraint(sheep1ID, regionConstraint);
		rmAddObjectDefConstraint(sheep1ID, centerCloseConstraint);
		rmAddObjectDefConstraint(sheep1ID, Northward);
		rmAddObjectDefConstraint(sheep1ID, avoidCloseCliffs);
        rmAddObjectDefConstraint(sheep1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(sheep1ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(sheep1ID, avoidSocket);
	    rmAddObjectDefConstraint(sheep1ID, avoidCloseNugget);
        
		rmSetObjectDefCreateHerd(sheep1ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
	    		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN SHEEP HERD:
		int sheep2ID=rmCreateObjectDef("sheep herd 2");
        rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(5,9), 7.0);
        rmSetObjectDefMinDistance(sheep2ID, 0.0);
        rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(sheep2ID, avoidVeryFarSheep);
        rmAddObjectDefConstraint(sheep2ID, avoidFarBison);
		rmAddObjectDefConstraint(sheep2ID, avoidFarPronghorn);
	    rmAddObjectDefConstraint(sheep2ID, avoidAll);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(sheep2ID, edgeCloseConstraint);
		rmAddObjectDefConstraint(sheep2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(sheep2ID, regionConstraint);
		rmAddObjectDefConstraint(sheep2ID, centerCloseConstraint);
		rmAddObjectDefConstraint(sheep2ID, Southward);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseCliffs);
        rmAddObjectDefConstraint(sheep2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(sheep2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(sheep2ID, avoidSocket);
	    rmAddObjectDefConstraint(sheep2ID, avoidCloseNugget);
        
		rmSetObjectDefCreateHerd(sheep2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
	    		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE SOME GEYSERS: *************************************** //
/*================================================================================================================*/
        
	    // THE NORTH GEYSERS:
		int geyserID=rmCreateGrouping("Geysers 1", "prop_geyser");
		rmSetGroupingMinDistance(geyserID, 0.0);
	    rmSetGroupingMaxDistance(geyserID, rmXFractionToMeters(0.5));
	    rmAddGroupingConstraint(geyserID, Northward);
		rmAddObjectDefConstraint(geyserID, regionConstraint);
		rmAddObjectDefConstraint(geyserID, centerCloseConstraint);
	    rmAddGroupingConstraint(geyserID, edgeConstraint);
	    rmAddGroupingConstraint(geyserID, avoidBison);
		rmAddGroupingConstraint(geyserID, avoidPronghorn);
	    rmAddGroupingConstraint(geyserID, avoidAll);
		rmAddObjectDefConstraint(geyserID, avoidCloseFruits);
		rmAddObjectDefConstraint(geyserID, avoidCloseCoin);
		rmAddGroupingConstraint(geyserID, avoidImpassableLand);
	    rmAddGroupingConstraint(geyserID, avoidTradeRoute);
	    rmAddGroupingConstraint(geyserID, avoidSocket);
		rmAddGroupingConstraint(geyserID, avoidCloseCliffs);
	    rmAddGroupingConstraint(geyserID, avoidCloseNugget);
	    rmAddGroupingConstraint(geyserID, playerCloseConstraint);
	    rmPlaceGroupingAtLoc(geyserID, 0, 0.5, 0.5, 2);	

        // THE SOUTH GEYSERS:
		int geyser2ID=rmCreateGrouping("Geysers 2", "prop_geyser");
		rmSetGroupingMinDistance(geyser2ID, 0.0);
	    rmSetGroupingMaxDistance(geyser2ID, rmXFractionToMeters(0.5));
	    rmAddGroupingConstraint(geyser2ID, Southward);
		rmAddObjectDefConstraint(geyser2ID, regionConstraint);
		rmAddObjectDefConstraint(geyser2ID, centerCloseConstraint);
	    rmAddGroupingConstraint(geyser2ID, edgeConstraint);
	    rmAddGroupingConstraint(geyser2ID, avoidBison);
		rmAddGroupingConstraint(geyser2ID, avoidPronghorn);
	    rmAddGroupingConstraint(geyser2ID, avoidAll);
		rmAddObjectDefConstraint(geyser2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(geyser2ID, avoidCloseCoin);
		rmAddGroupingConstraint(geyser2ID, avoidCloseCliffs);
	    rmAddGroupingConstraint(geyser2ID, avoidImpassableLand);
	    rmAddGroupingConstraint(geyser2ID, avoidTradeRoute);
	    rmAddGroupingConstraint(geyser2ID, avoidSocket);
	    rmAddGroupingConstraint(geyser2ID, avoidCloseNugget);
	    rmAddGroupingConstraint(geyser2ID, playerCloseConstraint);
	    rmPlaceGroupingAtLoc(geyser2ID, 0, 0.5, 0.5, 2);
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE SOME PERCHING VULTURES: *********************************** //
/*================================================================================================================*/

	    // THE NORTH VULTURE:
		int vultureID=rmCreateObjectDef("perching vultures 1");
		int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	    
		rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(vultureID, Southward);
	    rmAddObjectDefConstraint(vultureID, regionConstraint);
	    rmAddObjectDefConstraint(vultureID, centerCloseConstraint);
	    rmAddObjectDefConstraint(vultureID, avoidAll);
		rmAddObjectDefConstraint(vultureID, avoidCloseFruits);
		rmAddObjectDefConstraint(vultureID, avoidCloseCoin);
		rmAddObjectDefConstraint(vultureID, avoidVultures);
		rmAddObjectDefConstraint(vultureID, avoidCloseCliffs);
		rmAddObjectDefConstraint(vultureID, playerCloseConstraint);
		rmAddObjectDefConstraint(vultureID, avoidBison);
		rmAddObjectDefConstraint(vultureID, avoidPronghorn);
	    rmAddObjectDefConstraint(vultureID, avoidCloseNugget);
	    rmAddObjectDefConstraint(vultureID, avoidImpassableLand);
	    rmAddObjectDefConstraint(vultureID, avoidTradeRoute);
	    rmAddObjectDefConstraint(vultureID, avoidSocket);
	    rmAddObjectDefConstraint(vultureID, edgeConstraint);
	    rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 2);
		
		// THE SOUTH VULTURE:
		int vulture2ID=rmCreateObjectDef("perching vultures 2");
	    rmAddObjectDefItem(vulture2ID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vulture2ID, 0.0);
	    rmSetObjectDefMaxDistance(vulture2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(vulture2ID, Southward);
	    rmAddObjectDefConstraint(vulture2ID, regionConstraint);
	    rmAddObjectDefConstraint(vulture2ID, centerCloseConstraint);
	    rmAddObjectDefConstraint(vulture2ID, avoidAll);
		rmAddObjectDefConstraint(vulture2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(vulture2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(vulture2ID, avoidVultures);
		rmAddObjectDefConstraint(vulture2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(vulture2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(vulture2ID, avoidBison);
		rmAddObjectDefConstraint(vulture2ID, avoidPronghorn);
	    rmAddObjectDefConstraint(vulture2ID, avoidCloseNugget);
	    rmAddObjectDefConstraint(vulture2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(vulture2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(vulture2ID, avoidSocket);
	    rmAddObjectDefConstraint(vulture2ID, edgeConstraint);
	    rmPlaceObjectDefAtLoc(vulture2ID, 0, 0.5, 0.5, 2);
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE BISON CARCASS: ************************************** // 		
/*================================================================================================================*/

        // THE NORTHERN:
		// 50% chance of buffalo carcasses - either one or two if they're there.
	    int areThereBuffalo=rmRandInt(1, 2);
	    int howManyBuffalo=rmRandInt(1, 2);
	    if ( areThereBuffalo == 1 )
	{
		int bisonCarcass=rmCreateGrouping("Bison Carcass 1", "gp_carcass_bison");
		rmSetGroupingMinDistance(bisonCarcass, 0.0);
		rmSetGroupingMaxDistance(bisonCarcass, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(bisonCarcass, Northward);
		rmAddGroupingConstraint(bisonCarcass, edgeConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidImpassableLand);
		rmAddGroupingConstraint(bisonCarcass, playerCloseConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidTradeRoute);
		rmAddGroupingConstraint(bisonCarcass, avoidSocket);
		rmAddGroupingConstraint(bisonCarcass, centerCloseConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidBison);
		rmAddGroupingConstraint(bisonCarcass, avoidPronghorn);
		rmAddGroupingConstraint(bisonCarcass, regionConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidAll);
		rmAddObjectDefConstraint(bisonCarcass, avoidCloseFruits);
		rmAddObjectDefConstraint(bisonCarcass, avoidCloseCoin);
		rmAddGroupingConstraint(bisonCarcass, avoidVultures);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseCliffs);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseNugget);
		rmPlaceGroupingAtLoc(bisonCarcass, 0, 0.5, 0.5, howManyBuffalo);
	} 
	
	    // THE SOUTHERN:
		// 50% chance of buffalo carcasses - either one or two if they're there.
	    areThereBuffalo=rmRandInt(1, 2);
	    howManyBuffalo=rmRandInt(1, 2);
	    if ( areThereBuffalo == 1 )
	{
		int bisonCarcass2=rmCreateGrouping("Bison Carcass 2", "gp_carcass_bison");
		rmSetGroupingMinDistance(bisonCarcass2, 0.0);
		rmSetGroupingMaxDistance(bisonCarcass2, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(bisonCarcass2, Southward);
		rmAddGroupingConstraint(bisonCarcass2, edgeConstraint);
		rmAddGroupingConstraint(bisonCarcass2, avoidImpassableLand);
		rmAddGroupingConstraint(bisonCarcass2, playerCloseConstraint);
		rmAddGroupingConstraint(bisonCarcass2, avoidTradeRoute);
		rmAddGroupingConstraint(bisonCarcass2, avoidSocket);
		rmAddGroupingConstraint(bisonCarcass2, centerCloseConstraint);
		rmAddGroupingConstraint(bisonCarcass2, regionConstraint);
		rmAddGroupingConstraint(bisonCarcass2, avoidAll);
		rmAddObjectDefConstraint(bisonCarcass2, avoidCloseFruits);
		rmAddObjectDefConstraint(bisonCarcass2, avoidCloseCoin);
		rmAddGroupingConstraint(bisonCarcass2, avoidVultures);
		rmAddGroupingConstraint(bisonCarcass2, avoidCloseCliffs);
		rmAddGroupingConstraint(bisonCarcass2, avoidPronghorn);
		rmAddGroupingConstraint(bisonCarcass2, avoidBison);
		rmAddGroupingConstraint(bisonCarcass2, avoidCloseNugget);
		rmPlaceGroupingAtLoc(bisonCarcass2, 0, 0.5, 0.5, howManyBuffalo);
	} 
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //		
/*================================================================================================================*/
        	
         int forestID = 0;
		 
		 if (cNumberNonGaiaPlayers<=2)
		 numTries= 12*cNumberNonGaiaPlayers;
		 else
		 numTries= 8*cNumberNonGaiaPlayers;
		 
         failCount=0;
         
		 for (i=0; <numTries)
      {   
         int forest=rmCreateArea("forest "+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(225), rmAreaTilesToFraction(425));
         rmSetAreaForestType(forest, "great plains forest");
		 rmSetAreaForestDensity(forest, 1.0);
         rmSetAreaForestClumpiness(forest, 0.0);
         rmSetAreaForestUnderbrush(forest, 0.0);
         rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 1);
         rmSetAreaMinBlobDistance(forest, 1.0);
         rmSetAreaMaxBlobDistance(forest, 1.0);
         rmSetAreaCoherence(forest, 0.85);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest"));
         rmAddAreaConstraint(forest, edgeConstraint);		 
         rmAddAreaConstraint(forest, forestFarConstraint);
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidVultures);
		 rmAddAreaConstraint(forest, avoidCloseBison);
		 rmAddAreaConstraint(forest, avoidClosePronghorn);
		 rmAddAreaConstraint(forest, avoidCloseSheep);
		 rmAddAreaConstraint(forest, avoidCloseFruits);
		 rmAddAreaConstraint(forest, avoidCloseNugget);
		 rmAddAreaConstraint(forest, avoidCoin);
		 rmAddAreaConstraint(forest, centerCloseConstraint);
		 rmAddAreaConstraint(forest, regionConstraint);
		 rmAddAreaConstraint(forest, avoidCloseCliffs);
		 rmAddAreaConstraint(forest, playerCloseConstraint);
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidTradeRoute); 
		 rmAddAreaConstraint(forest, avoidSocket); 
		 if(rmBuildArea(forest)==false)
    {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
    }
         else
         failCount=0; 
}  

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE NORTH REGION:
		int randomTreeID=rmCreateObjectDef("random tree 1");
		rmAddObjectDefItem(randomTreeID, "TreeGreatPlains", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, regionConstraint);
 		rmAddObjectDefConstraint(randomTreeID, edgeConstraint); 
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseImportantItem);
	    rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, centerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidClosePronghorn);
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseBison);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCliffs);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFruits);
	    rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 48*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FISHBASS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);		
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		
