/*================================================================================================================*/
// ********************************* THESE ARE THE INFORMATIONS OF THE MAP: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// THE DRY LAND WAR:
// CREATED BY DANY:
// SEPTEMBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        		
/*----------------------------------------------------------------------------------------------------------------*/		
	    
		// DEFINE THE WHICHVARIATION:
		int whichVariation=-1;
	    whichVariation = rmRandInt(1,2);

/*----------------------------------------------------------------------------------------------------------------*/	
	
        if (rmAllocateSubCivs(2) == true)
   {
		// ALL COMANCHE, ALL THE TIME:
		subCiv0=rmGetCivID("Comanche");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Comanche");

		subCiv1=rmGetCivID("Comanche");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Comanche");
   }
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ******************************************** PICKS THE MAP SIZE: ********************************************* //	
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

		int playerTiles=25000;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(638, 638);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // SET MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	    rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
	
	    // SET THE SEA LEVEL:
	    rmSetSeaLevel(4.0);
	
        // SET SEA TYPE:
	    rmSetSeaType("Amazon River");
	    
		// SET BASE TERRAIN MIX:
		if ( whichVariation == 1 )
	{	
		rmSetBaseTerrainMix("texas_grass");
	}	
		else
	{	
		rmSetBaseTerrainMix("texas_dirt");
	}	
	    
		// TERRAIN INITIALIZATION:
		if ( whichVariation == 1 )
	{	
		rmTerrainInitialize("texas\ground1_tex", 5.0);
	}
        else
	{	
		rmTerrainInitialize("texas\ground5_tex", 5.0);
	}	
	    
		// SET LIGHTING:
		rmSetLightingSet("Texas");
	    
		// SET MAP TYPE:
		rmSetMapType("texas");
	    rmSetMapType("grass");
	    rmSetMapType("land");

	    // CORNER CONSTRAINT:
	    rmSetWorldCircleConstraint(true);
		
		// CHOOSE THE MERCS:
		chooseMercs();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classHill");
        rmDefineClass("classPatch");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("secrets");
	    rmDefineClass("nuggets");
	    rmDefineClass("center");
	    rmDefineClass("classCotton");
		rmDefineClass("socketClass");
		rmDefineClass("region");
		rmDefineClass("water");
		rmDefineClass("mountain");
		rmDefineClass("Huntable");
		rmDefineClass("Herdable");
		rmDefineClass("Food");
		rmDefineClass("classTrees");
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(15), rmZTilesToFraction(15), 1.0-rmXTilesToFraction(15), 1.0-rmZTilesToFraction(15), 0.01);
	    
/*----------------------------------------------------------------------------------------------------------------*/
// ***************************** DEFINE THE CONSTRAINTS FOR THE CARDINAL DIRECTIONS: **************************** //
/*----------------------------------------------------------------------------------------------------------------*/		
		
        // CARDINAL DIRECTIONS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

/*----------------------------------------------------------------------------------------------------------------*/
// *************************** DEFINE THE CONSTRAINTS FOR THE PLAYER STARTING BASE: ***************************** //
/*----------------------------------------------------------------------------------------------------------------*/
		
        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stuff vs. player", classPlayer, 15.0);
		int playerCloseConstraint=rmCreateClassDistanceConstraint("close stuff vs. player", classPlayer, 5.0);
        int playerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff vs. player", classPlayer, 2.0);
        int playerMediumConstraint=rmCreateClassDistanceConstraint("medium stuff vs. player", classPlayer, 25.0);
        int playerFarConstraint=rmCreateClassDistanceConstraint("far stuff vs. player", classPlayer, 50.0);
        int playerVeryFarConstraint=rmCreateClassDistanceConstraint("very far stuff vs. player", classPlayer, 75.0);
 		        
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE THE CONSTRAINTS FOR THE REGION AREAS: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	    
        // REGION AVOIDANCE:
		int regionConstraint=rmCreateClassDistanceConstraint("stay away from region", rmClassID("region"), 15.0);
	    int regionCloseConstraint=rmCreateClassDistanceConstraint("close stay away from region", rmClassID("region"), 5.0);
		int regionVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stay away from region", rmClassID("region"), 2.0);
		int regionMediumConstraint=rmCreateClassDistanceConstraint("medium stay away from region", rmClassID("region"), 25.0);
	    int regionFarConstraint=rmCreateClassDistanceConstraint("far stay away from region", rmClassID("region"), 50.0);
        int regionVeryFarConstraint=rmCreateClassDistanceConstraint("very far stay away from region", rmClassID("region"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE THE CONSTRAINTS FOR THE WATER AREAS: ********************************* //
/*----------------------------------------------------------------------------------------------------------------*/
	    
        // WATER AREA AVOIDANCE:
		int waterConstraint=rmCreateClassDistanceConstraint("stay away from water", rmClassID("water"), 15.0);
	    int waterCloseConstraint=rmCreateClassDistanceConstraint("close stay away from water", rmClassID("water"), 5.0);
		int waterVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stay away from water", rmClassID("water"), 2.0);
		int waterMediumConstraint=rmCreateClassDistanceConstraint("medium stay away from water", rmClassID("water"), 25.0);
	    int waterFarConstraint=rmCreateClassDistanceConstraint("far stay away from water", rmClassID("water"), 50.0);
        int waterVeryFarConstraint=rmCreateClassDistanceConstraint("very far stay away from water", rmClassID("water"), 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE THE CONSTRAINTS FOR THE MOUNTAIN AREAS: ******************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	    
        // REGION AVOIDANCE:
		int mountainConstraint=rmCreateClassDistanceConstraint("stay away from mountain", rmClassID("mountain"), 15.0);
	    int mountainCloseConstraint=rmCreateClassDistanceConstraint("close stay away from mountain", rmClassID("mountain"), 5.0);
		int mountainVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stay away from mountain", rmClassID("mountain"), 2.0);
		int mountainMediumConstraint=rmCreateClassDistanceConstraint("medium stay away from mountain", rmClassID("mountain"), 25.0);
	    int mountainFarConstraint=rmCreateClassDistanceConstraint("far stay away from mountain", rmClassID("mountain"), 50.0);
        int mountainVeryFarConstraint=rmCreateClassDistanceConstraint("very far stay away from mountain", rmClassID("mountain"), 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************ DEFINE THE CONSTRAINTS OF THE FISHES: *********************************** //		
/*----------------------------------------------------------------------------------------------------------------*/

		// FISHES AVOIDANCE:
	     int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 8.0);
	     int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
	    
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE FORESTS: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
		
		// FOREST AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("stuff vs. forest", rmClassID("classForest"), 15.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 5.0);
        int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs. forest", rmClassID("classForest"), 2.0);
        int forestMediumConstraint=rmCreateClassDistanceConstraint("medium vs. forest", rmClassID("classForest"), 25.0);
        int forestFarConstraint=rmCreateClassDistanceConstraint("far vs. forest", rmClassID("classForest"), 50.0);
        int forestVeryFarConstraint=rmCreateClassDistanceConstraint("very far vs. forest", rmClassID("classForest"), 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE TREES: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 10.0);
		int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 5.0);
		int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 2.0);
		int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
		int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
		int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// **************************** DEFINE THE CONSTRAINTS FOR THE SILVER AND GOLD MINES: *************************** //
/*----------------------------------------------------------------------------------------------------------------*/		
	    		
		// SILVER COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoids coin", "gold", 15.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close stuff avoids coin", "gold", 5.0);
		int avoidVeryCloseCoin=rmCreateTypeDistanceConstraint("very close stuff avoids coin", "gold", 2.0);
		int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium stuff avoids coin", "gold", 25.0);
		int avoidFarCoin=rmCreateTypeDistanceConstraint("far stuff avoids coin", "gold", 50.0);
		int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far stuff avoids coin", "gold", 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/	
// ******************************* DEFINE THE CONSTRAINTS FOR THE START RESOURCE: ******************************* //
/*----------------------------------------------------------------------------------------------------------------*/
	    
	    int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ****************************** DEFINE THE CONSTRAINTS FOR THE IMPASSABLE LAND: ******************************* //
/*----------------------------------------------------------------------------------------------------------------*/
   
        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("stuff avoid impassable land", "Land", false, 15.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close stuff avoid impassable land", "Land", false, 5.0);
        int avoidVeryCloseImpassableLand=rmCreateTerrainDistanceConstraint("very close stuff avoid impassable land", "Land", false, 2.0);
        int avoidMediumImpassableLand=rmCreateTerrainDistanceConstraint("medium stuff avoid impassable land", "Land", false, 25.0);
        int avoidFarImpassableLand=rmCreateTerrainDistanceConstraint("far stuff avoid impassable land", "Land", false, 50.0);
        int avoidVeryFarImpassableLand=rmCreateTerrainDistanceConstraint("very far stuff avoid impassable land", "Land", false, 75.0);
	 
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE THE CONSTRAINTS OF THE RANDOM CLIFFS: ******************************** //		
/*----------------------------------------------------------------------------------------------------------------*/
		
		int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 15.0);
	    int avoidCloseCliffs=rmCreateClassDistanceConstraint("close stuff vs. cliff", rmClassID("classCliff"), 5.0);
	    int avoidVeryCloseCliffs=rmCreateClassDistanceConstraint("very close stuff vs. cliff", rmClassID("classCliff"), 2.0);
		int avoidMediumCliffs=rmCreateClassDistanceConstraint("medium stuff vs. cliff", rmClassID("classCliff"), 25.0);
	    int avoidFarCliffs=rmCreateClassDistanceConstraint("far stuff vs. cliff", rmClassID("classCliff"), 50.0);
	    int avoidVeryFarCliffs=rmCreateClassDistanceConstraint("very far stuff vs. cliff", rmClassID("classCliff"), 75.0);

		
		int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);

/*----------------------------------------------------------------------------------------------------------------*/		
		
        // STARTING UNITS AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 15.0);
        int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close objects avoid starting units", rmClassID("startingUnit"), 5.0);
        int avoidVeryCloseStartingUnits=rmCreateClassDistanceConstraint("very close objects avoid starting units", rmClassID("startingUnit"), 2.0);
        int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium objects avoid starting units", rmClassID("startingUnit"), 25.0);
        int avoidFarStartingUnits=rmCreateClassDistanceConstraint("far objects avoid starting units", rmClassID("startingUnit"), 50.0);
       	int avoidVeryFarStartingUnits=rmCreateClassDistanceConstraint("very far objects avoid starting units", rmClassID("startingUnit"), 75.0);
        
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* DEFINE THE CONSTRAINTS FOR IMPORTANT ITEM: ********************************* //		
/*----------------------------------------------------------------------------------------------------------------*/

		int avoidImportantItem=rmCreateClassDistanceConstraint("stuff avoid important item", rmClassID("importantItem"), 15.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close avoid important item", rmClassID("importantItem"), 5.0);
        int avoidVeryCloseImportantItem=rmCreateClassDistanceConstraint("very close avoid important item", rmClassID("importantItem"), 2.0);
        int avoidMediumImportantItem=rmCreateClassDistanceConstraint("medium avoid important item", rmClassID("importantItem"), 25.0);
        int avoidFarImportantItem=rmCreateClassDistanceConstraint("far avoid important item", rmClassID("importantItem"), 50.0);
        int avoidVeryFarImportantItem=rmCreateClassDistanceConstraint("very far avoid important item", rmClassID("importantItem"), 75.0);
        
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE THE CONSTRAINTS FOR THE NATIVE TRIBES: ******************************* //
/*----------------------------------------------------------------------------------------------------------------*/

		// NATIVES AVOIDANCES:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
	    int avoidCloseNatives=rmCreateClassDistanceConstraint("close stuff avoids natives", rmClassID("natives"), 5.0);
	    int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close stuff avoids natives", rmClassID("natives"), 2.0);
	    int avoidMediumNatives=rmCreateClassDistanceConstraint("medium stuff avoids natives", rmClassID("natives"), 25.0);
	    int avoidFarNatives=rmCreateClassDistanceConstraint("far stuff avoids natives", rmClassID("natives"), 50.0);
	    int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far stuff avoids natives", rmClassID("natives"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/
		
		int avoidSecrets=rmCreateClassDistanceConstraint("stuff avoids secrets", rmClassID("secrets"), 20.0);
	    
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** DEFINE THE CONSTRAINTS FOR THE FRUITS: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/		
				
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 15.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 5.0);
		int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoid fruits", "berrybush", 2.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid fruits", "berrybush", 25.0);
		int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid fruits", "berrybush", 50.0);
		int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoid fruits", "berrybush", 75.0);
				
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* DEFINE THE CONSTRAINTS FOR THE TREASURES: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
        
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 15.0);
		int avoidCloseNugget=rmCreateClassDistanceConstraint("close stuff avoids nuggets", rmClassID("nuggets"), 5.0);
		int avoidVeryNugget=rmCreateClassDistanceConstraint("very stuff avoids nuggets", rmClassID("nuggets"), 2.0);
		int avoidMediumNugget=rmCreateClassDistanceConstraint("medium stuff avoids nuggets", rmClassID("nuggets"), 25.0);
		int avoidFarNugget=rmCreateClassDistanceConstraint("far stuff avoids nuggets", rmClassID("nuggets"), 50.0);
		int avoidVeryFarNugget=rmCreateClassDistanceConstraint("very far stuff avoids nuggets", rmClassID("nuggets"), 75.0);
	    
/*----------------------------------------------------------------------------------------------------------------*/		
// ******************************* DEFINE THE CONSTRAINTS FOR THE HUNTABLE FOOD: ******************************** //		
/*----------------------------------------------------------------------------------------------------------------*/
		
		int avoidHuntable=rmCreateClassDistanceConstraint("stuff avoids huntable", rmClassID("Huntable"), 15.0);
		int avoidCloseHuntable=rmCreateClassDistanceConstraint("close stuff avoids huntable", rmClassID("Huntable"), 5.0);
		int avoidVeryCloseHuntable=rmCreateClassDistanceConstraint("very close stuff avoids huntable", rmClassID("Huntable"), 2.0);
		int avoidMediumHuntable=rmCreateClassDistanceConstraint("medium stuff avoids huntable", rmClassID("Huntable"), 25.0);
		int avoidFarHuntable=rmCreateClassDistanceConstraint("far stuff avoids huntable", rmClassID("Huntable"), 50.0);
		int avoidVeryFarHuntable=rmCreateClassDistanceConstraint("very far stuff avoids huntable", rmClassID("Huntable"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/		
// ******************************* DEFINE THE CONSTRAINTS FOR THE HERDABLE FOOD: ******************************** //		
/*----------------------------------------------------------------------------------------------------------------*/
		
		int avoidHerdable=rmCreateClassDistanceConstraint("stuff avoids herdable", rmClassID("Herdable"), 15.0);
		int avoidCloseHerdable=rmCreateClassDistanceConstraint("close stuff avoids herdable", rmClassID("Herdable"), 5.0);
		int avoidVeryCloseHerdable=rmCreateClassDistanceConstraint("very close stuff avoids herdable", rmClassID("Herdable"), 2.0);
		int avoidMediumHerdable=rmCreateClassDistanceConstraint("medium stuff avoids herdable", rmClassID("Herdable"), 25.0);
		int avoidFarHerdable=rmCreateClassDistanceConstraint("far stuff avoids herdable", rmClassID("Herdable"), 50.0);
		int avoidVeryFarHerdable=rmCreateClassDistanceConstraint("very far stuff avoids herdable", rmClassID("Herdable"), 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
// *********************************** DEFINE THE CONSTRAINTS FOR THE FOOD: ************************************* //		
/*----------------------------------------------------------------------------------------------------------------*/
		
		int avoidFood=rmCreateClassDistanceConstraint("stuff avoids food", rmClassID("Food"), 15.0);
		int avoidCloseFood=rmCreateClassDistanceConstraint("close stuff avoids food", rmClassID("Food"), 5.0);
		int avoidVeryCloseFood=rmCreateClassDistanceConstraint("very close stuff avoids food", rmClassID("Food"), 2.0);
		int avoidMediumFood=rmCreateClassDistanceConstraint("medium stuff avoids food", rmClassID("Food"), 25.0);
		int avoidFarFood=rmCreateClassDistanceConstraint("far stuff avoids food", rmClassID("Food"), 50.0);
		int avoidVeryFarFood=rmCreateClassDistanceConstraint("very far stuff avoids food", rmClassID("Food"), 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE COWS: ************************************* //
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// COW AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 15.0);
        int avoidCloseCow=rmCreateTypeDistanceConstraint("close stuff avoids cow", "cow", 5.0);
		int avoidMediumCow=rmCreateTypeDistanceConstraint("medium stuff avoids cow", "cow", 25.0);
		int avoidveryCloseCow=rmCreateTypeDistanceConstraint("very close stuff avoids cow", "cow", 2.0);
		int avoidFarCow=rmCreateTypeDistanceConstraint("far stuff avoids cow", "cow", 50.0);
        int avoidVeryFarCow=rmCreateTypeDistanceConstraint("very far stuff avoids cow", "cow", 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
// ******************************* DEFINE THE CONSTRAINTS FOR THE ADDED BUILDING: ******************************* //		
/*----------------------------------------------------------------------------------------------------------------*/
		
	    int avoidOutpost=rmCreateTypeDistanceConstraint("outposts avoid outposts", "Outpost", 24.0);
	    int avoidOutpostBarracks=rmCreateTypeDistanceConstraint("barracks avoid outposts", "Outpost", 24.0);
	    int avoidBlockhouse=rmCreateTypeDistanceConstraint("blockhouses avoid blockhouses", "Blockhouse", 35.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE THE CONSTRAINTS FOR THE DECORATIONS: ********************************* //
/*----------------------------------------------------------------------------------------------------------------*/

	    // DECORATION AVOIDANCE:
	    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* DEFINE THE CONSTRAINTS FOR THE TRADE ROUTE: ******************************** //		
/*----------------------------------------------------------------------------------------------------------------*/

	    // TRADE ROUTE AVOIDANCE:
		int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("stuff avoid trade route", 15.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close stuff avoid trade route", 5.0);
        int avoidVeryCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("very close stuff avoid trade route", 2.0);
        int avoidMediumTradeRoute = rmCreateTradeRouteDistanceConstraint("medium stuff avoid trade route", 25.0);
        int avoidFarTradeRoute = rmCreateTradeRouteDistanceConstraint("far stuff avoid trade route", 50.0);
        int avoidVeryFarTradeRoute = rmCreateTradeRouteDistanceConstraint("very far stuff avoid trade route", 75.0);
       		
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* DEFINE THE CONSTRAINTS FOR THE SOCKETS: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
   		
		// SOCKET AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("stuff avoid socket", rmClassID("socketClass"), 15.0);
	    int avoidCloseSocket=rmCreateClassDistanceConstraint("close stuff avoid socket", rmClassID("socketClass"), 5.0);
	    int avoidVeryCloseSocket=rmCreateClassDistanceConstraint("very close avoid socket", rmClassID("socketClass"), 2.0);
	    int avoidMediumSocket=rmCreateClassDistanceConstraint("medium avoid socket", rmClassID("socketClass"), 25.0);
	    int avoidFarSocket=rmCreateClassDistanceConstraint("far stuff avoid socket", rmClassID("socketClass"), 50.0);
	    int avoidVeryFarSocket=rmCreateClassDistanceConstraint("very far stuff avoid socket", rmClassID("socketClass"), 75.0);
	
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************** DEFINE THE CIRCLE CONSTRAINT: ***************************************** //    
/*----------------------------------------------------------------------------------------------------------------*/

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************ SET UP PLAYER STARTING LOCATIONS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        		
	    if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.15, 0.35);
		rmPlacePlayersCircular(0.35, 0.40, 0.0);

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.65, 0.85);
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
	}
	    else
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE REGIONS FOR THE NATIVES TRIBES: *************************** //
/*================================================================================================================*/

        // DEFINE AND PLACE REGION AREA 1: 		
		int region1ID=rmCreateArea("Region Area 1");
        rmSetAreaSize(region1ID, 0.005, 0.005);
        rmSetAreaLocation(region1ID, 0.50, 0.75);
		rmSetAreaCoherence(region1ID, 1.0);
        rmAddAreaToClass(region1ID, rmClassID("region"));
		//rmSetAreaMix(region1ID, "rockies_snow");
        rmBuildArea(region1ID); 
		
/*---------------------------------------------------------------------------------------------------------------*/

		// DEFINE AND PLACE REGION AREA 2: 		
		int region2ID=rmCreateArea("Region Area 2");
        rmSetAreaSize(region2ID, 0.005, 0.005);
        rmSetAreaLocation(region2ID, 0.50, 0.25);
		rmSetAreaCoherence(region2ID, 1.0);
        rmAddAreaToClass(region2ID, rmClassID("region"));
		//rmSetAreaMix(region2ID, "rockies_snow");
        rmBuildArea(region2ID);

/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE WATER AREA: *************************************** //
/*================================================================================================================*/		

        // DEFINE AND PLACE WATER AREA 1: 		
		int water1ID=rmCreateArea("Water Area 1");
        rmSetAreaSize(water1ID, 0.020, 0.020);
        rmSetAreaLocation(water1ID, 0.10, 0.50);
		rmSetAreaCoherence(water1ID, 1.0);
        rmAddAreaToClass(water1ID, rmClassID("water"));
		//rmSetAreaMix(water1ID, "rockies_snow");
        rmBuildArea(water1ID); 
		
/*---------------------------------------------------------------------------------------------------------------*/

		// DEFINE AND PLACE WATER AREA 2: 		
		int water2ID=rmCreateArea("Water Area 2");
        rmSetAreaSize(water2ID, 0.020, 0.020);
        rmSetAreaLocation(water2ID, 0.90, 0.50);
		rmSetAreaCoherence(water2ID, 1.0);
        rmAddAreaToClass(water2ID, rmClassID("water"));
		//rmSetAreaMix(water2ID, "rockies_snow");
        rmBuildArea(water2ID);

/*================================================================================================================*/
// ************************** DEFINE AND PLACE THE MOUNTAINS: -- SMALL AND MEDIUM -- **************************** //		
/*================================================================================================================*/

        // DEFINE AND PLACE SMALL MOUNTAIN 1: 		
		int mountain1ID=rmCreateArea("Small Mountain 1");
        rmSetAreaSize(mountain1ID, 0.0185, 0.0185);
        rmSetAreaLocation(mountain1ID, 0.30, 0.15);
		rmSetAreaCoherence(mountain1ID, 1.0);
        rmAddAreaToClass(mountain1ID, rmClassID("mountain"));
		//rmSetAreaMix(mountain1ID, "rockies_snow");
        rmBuildArea(mountain1ID); 
		
/*---------------------------------------------------------------------------------------------------------------*/

		// DEFINE AND PLACE SMALL MOUNTAIN 2: 		
		int mountain2ID=rmCreateArea("Small Mountain 2");
        rmSetAreaSize(mountain2ID, 0.0185, 0.0185);
        rmSetAreaLocation(mountain2ID, 0.70, 0.85);
		rmSetAreaCoherence(mountain2ID, 1.0);
        rmAddAreaToClass(mountain2ID, rmClassID("mountain"));
		//rmSetAreaMix(mountain2ID, "rockies_snow");
        rmBuildArea(mountain2ID);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
        // DEFINE AND PLACE MEDIUM MOUNTAIN 1: 		
		int mountain3ID=rmCreateArea("Medium Mountain 1");
        rmSetAreaSize(mountain3ID, 0.0285, 0.0285);
        rmSetAreaLocation(mountain3ID, 0.70, 0.50);
		rmSetAreaCoherence(mountain3ID, 1.0);
        rmAddAreaToClass(mountain3ID, rmClassID("mountain"));
		//rmSetAreaMix(mountain3ID, "rockies_snow");
        rmBuildArea(mountain3ID); 
		
/*---------------------------------------------------------------------------------------------------------------*/

		// DEFINE AND PLACE MEDIUM MOUNTAIN 2: 		
		int mountain4ID=rmCreateArea("Medium Mountain 2");
        rmSetAreaSize(mountain4ID, 0.0285, 0.0285);
        rmSetAreaLocation(mountain4ID, 0.30, 0.50);
		rmSetAreaCoherence(mountain4ID, 1.0);
        rmAddAreaToClass(mountain4ID, rmClassID("mountain"));
		//rmSetAreaMix(mountain4ID, "rockies_snow");
        rmBuildArea(mountain4ID);		
 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(1750);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
				
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // Build the areas.
        rmBuildAllAreas();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   

 	    // DEFINE THE PLACEMENT ORDER:
	    // Trade Route -> Players and player stuff -> Natives -> Secrets -> Cliffs -> Nuggets
	    // Place other objects that were defined earlier
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE 1 TRADE ROUTES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // THE TRADE ROUTE NUMBER 1:
		int tradeRouteID = rmCreateTradeRoute();
	    	
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.975);
		
		if ( whichVariation == 1 )
	{	
		rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 0.75);
	}	
		else
	{	
		rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.75);
	}	
	    
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.50);
	    
		if ( whichVariation == 1 )
	{	
		rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.25);
	}	
		else
	{	
		rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 0.25);
	}	
		
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.030);
	    
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
	    if(placedTradeRoute == false)
		rmEchoError("Failed to place trade route #1");

/*----------------------------------------------------------------------------------------------------------------*/		

	    // THE TRADE SOCKETS: ( FOR BOTH TRADE ROUTE: )
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
		rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // ADD THE MEETING POLES ALONG THE TRADE ROUTE NUMBER 1:
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.025);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.25);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.75);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.975);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ******************* DEFINE THE STARTING UNITS AND THE STARTING TCID AND STARTING RESOURCES: ****************** //
/*================================================================================================================*/
	
	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    
		// DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 0.0);
	    //rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);

/*----------------------------------------------------------------------------------------------------------------*/	
	
	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 8);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	    
		rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseImpassableLand);
	    
	    // DEFINE THE STARTING PRONGHORN:
		int StartPronghornID=rmCreateObjectDef("starting pronghorn");
	    rmAddObjectDefItem(StartPronghornID, "pronghorn", 4, 4.0);
	    rmSetObjectDefMinDistance(StartPronghornID, 5);
	    rmSetObjectDefMaxDistance(StartPronghornID, 12);
		rmSetObjectDefCreateHerd(StartPronghornID, true);
	    
		rmAddObjectDefConstraint(StartPronghornID, avoidStartResource);
	    rmAddObjectDefConstraint(StartPronghornID, avoidCloseImpassableLand);
	    				
		// DEFINE THE STARTING BERRYBUSH:
		int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 4.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 12.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	    
		rmAddObjectDefConstraint(StartBerryBushID, avoidCloseStartingUnits);
	
        // DEFINE THE PLAYER BISON:
		int playerBisonID=rmCreateObjectDef("player bison herd");
        rmAddObjectDefItem(playerBisonID, "bison", rmRandInt(6,8), 6.0);
        rmSetObjectDefMinDistance(playerBisonID, 40.0);
        rmSetObjectDefMaxDistance(playerBisonID, 45.0);
		rmSetObjectDefCreateHerd(playerBisonID, true);
	    //rmAddObjectDefConstraint(playerBisonID, avoidImportantItem);
	    
	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    
		rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    	    
	    // DEFINE THE STARTING OUTPOST OR MILL:
		int startingOutpostID=rmCreateObjectDef("Starting Outpost");
        
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(startingOutpostID, "Outpost", 1, 0.0);
	}
    	else
	{	
		rmAddObjectDefItem(startingOutpostID, "Mill", 1, 0.0);
	}	
		
        rmSetObjectDefMinDistance(startingOutpostID, 20.0);
        rmSetObjectDefMaxDistance(startingOutpostID, 22.0);
        rmAddObjectDefToClass(startingOutpostID, rmClassID("importantItem"));
        
		rmAddObjectDefConstraint(startingOutpostID, avoidOutpost);
	    rmAddObjectDefConstraint(startingOutpostID, avoidImportantItem);
        
	    // DEFINE THE STARTING BARRACKS OR LIVESTOCKPEN:
		int startingBarracksID=rmCreateObjectDef("Starting Barracks");
        
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(startingBarracksID, "barracks", 1, 0.0);
	}	
		else
	{	
        rmAddObjectDefItem(startingBarracksID, "LivestockPen", 1, 0.0);
	}	
        
		rmSetObjectDefMinDistance(startingBarracksID, 18.0);
        rmSetObjectDefMaxDistance(startingBarracksID, 24.0);
        rmAddObjectDefToClass(startingBarracksID, rmClassID("importantItem"));
        
		rmAddObjectDefConstraint(startingBarracksID, avoidOutpostBarracks);
	    rmAddObjectDefConstraint(startingBarracksID, avoidImportantItem);
        
	    // DEFINE THE STARTING BLOCKHOUSE OR STABLE:
		int startingBlockhouseID=rmCreateObjectDef("Starting Blockhouse");
        
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(startingBlockhouseID, "Blockhouse", 1, 0.0);
	}	
		else
	{	
		rmAddObjectDefItem(startingBlockhouseID, "Stable", 1, 0.0);
	}	
        
		rmSetObjectDefMinDistance(startingBlockhouseID, 20.0);
        rmSetObjectDefMaxDistance(startingBlockhouseID, 22.0);
        rmAddObjectDefToClass(startingBlockhouseID, rmClassID("importantItem"));
        rmAddObjectDefConstraint(startingBlockhouseID, avoidBlockhouse);
	    rmAddObjectDefConstraint(startingBlockhouseID, avoidImportantItem);

        // DEFINE THE PLAYER GOLD:
		int playerGoldID=rmCreateObjectDef("player silver ore");
	    int silverType = rmRandInt(1,10);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ***************** PLACE THE STARTING UNITS AND THE STARTING TCID AND THE STARTING RESOURCES: ***************** //
/*================================================================================================================*/
	
		for(i=1; <cNumberPlayers)
	{

/*----------------------------------------------------------------------------------------------------------------*/
		
		// PLACE THE STARTING TCID AND THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE EXTRA BUILDINGS, UNLESS NOMAD START:
		if ( rmGetNomadStart() == false )
		{
			if ( whichVariation == 1 )
			{
				rmPlaceObjectDefAtLoc(startingOutpostID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				rmPlaceObjectDefAtLoc(startingOutpostID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				rmPlaceObjectDefAtLoc(startingBlockhouseID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
			}
			else
			{
				rmPlaceObjectDefAtLoc(startingOutpostID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				rmPlaceObjectDefAtLoc(startingOutpostID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				rmPlaceObjectDefAtLoc(startingBarracksID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
			}
		}
		
/*----------------------------------------------------------------------------------------------------------------*/		

		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING PRONGHORN:
		rmPlaceObjectDefAtLoc(StartPronghornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// NOTES:
		// EVERYONE GETS TWO ORE GROUPINGS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		
		// DEFINE AND PLACE THE PLAYER GOLD CLOSER:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
	}
        else
    {
	    rmAddObjectDefItem(playerGoldID, "minegold", 1, 0.0);
    } 	
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidMediumCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidCliffs);
		rmAddObjectDefConstraint(playerGoldID, avoidCloseImportantItem);
		rmSetObjectDefMinDistance(playerGoldID, 25.0);
		rmSetObjectDefMaxDistance(playerGoldID, 30.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// DEFINE AND PLACE THE PLAYER GOLD FURTHER:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver further "+i);
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
	}
        else
    {
	    rmAddObjectDefItem(playerGoldID, "minegold", 1, 0.0);
    } 	
		
		rmAddObjectDefConstraint(playerGoldID, avoidMediumCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidCloseImportantItem);
		rmSetObjectDefMinDistance(playerGoldID, 32.0);
		rmSetObjectDefMaxDistance(playerGoldID, 40.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER BISONS: ( Everyone gets two bison herds..)
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// VECTOR CLOSEST POINT:
		vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
	
	    // Text
	    int numTries = -1;
	    int failCount = -1;
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE CENTRAL POND: ************************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        
		int smallPondID=rmCreateArea("small pond 1");
	    	
		//rmSetAreaSize(smallPondID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(700));
		rmSetAreaSize(smallPondID, 0.0125, 0.0125);
		rmSetAreaWaterType(smallPondID, "texas pond");
		rmSetAreaBaseHeight(smallPondID, 4);
		
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1);
		rmSetAreaMaxBlobDistance(smallPondID, 1);
		
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.85);
		rmSetAreaSmoothDistance(smallPondID, 5);
		
		//rmAddAreaConstraint(smallPondID, playerConstraint);
		//rmAddAreaConstraint(smallPondID, avoidTradeRoute);
		//rmAddAreaConstraint(smallPondID, avoidImportantItem);
		
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.10, 0.50); 
		rmBuildArea(smallPondID);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int smallPond2ID=rmCreateArea("small pond 2");
	    	
		//rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(700));
		rmSetAreaSize(smallPond2ID, 0.0125, 0.0125);
		rmSetAreaWaterType(smallPond2ID, "texas pond");
		rmSetAreaBaseHeight(smallPond2ID, 4);
		
		rmSetAreaMinBlobs(smallPond2ID, 1);
		rmSetAreaMaxBlobs(smallPond2ID, 1);
		rmSetAreaMinBlobDistance(smallPond2ID, 1);
		rmSetAreaMaxBlobDistance(smallPond2ID, 1);
		
		rmAddAreaToClass(smallPond2ID, pondClass);
		rmSetAreaCoherence(smallPond2ID, 0.85);
		rmSetAreaSmoothDistance(smallPond2ID, 5);
		
		//rmAddAreaConstraint(smallPond2ID, playerConstraint);
		//rmAddAreaConstraint(smallPond2ID, avoidTradeRoute);
		//rmAddAreaConstraint(smallPond2ID, avoidImportantItem);
		
		rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.90, 0.50); 
		rmBuildArea(smallPond2ID);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ********************* DEFINE AND PLACE THE NATIVE VILLAGES AND SECRETS OF THE NEW WORLD: ********************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("Comanche"))
	{  
		int comanche1VillageID = -1;
		comanche1VillageID = rmCreateGrouping("comanche village 1", "native comanche village 1");
		rmSetGroupingMinDistance(comanche1VillageID, 0.0);
		rmSetGroupingMaxDistance(comanche1VillageID, 0.0);
		rmAddGroupingToClass(comanche1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comanche1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(comanche1VillageID, 0, 0.50, 0.75);
	} 

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("Comanche"))
	{  
		int comanche2VillageID = -1;
		comanche2VillageID = rmCreateGrouping("comanche village 2", "native comanche village 1");
		rmSetGroupingMinDistance(comanche2VillageID, 0.0);
		rmSetGroupingMaxDistance(comanche2VillageID, 0.0);
		rmAddGroupingToClass(comanche2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comanche2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(comanche2VillageID, 0, 0.50, 0.25);
	} 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE CLIFFS: **************************************** //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int cliffEastID=rmCreateArea("cliff east");
		
	    //rmSetAreaSize(cliffEastID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));
        rmSetAreaSize(cliffEastID, 0.0125, 0.0125);		
		rmSetAreaWarnFailure(cliffEastID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(cliffEastID, "Texas Grass");
	}	
		else
	{	
		rmSetAreaCliffType(cliffEastID, "Texas");
	}	
		
		rmAddAreaToClass(cliffEastID, rmClassID("classCliff"));	
		//rmSetAreaCliffEdge(cliffEastID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliffEastID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffEastID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffEastID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffEastID, 1);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(cliffEastID, "texas\ground2_tex", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(cliffEastID, "texas\ground5_tex", 0, 2);
	}	
		
		rmSetAreaObeyWorldCircleConstraint(cliffEastID, false);
		//rmAddAreaConstraint(cliffEastID, cliffsAvoidCliffs);				
						
		rmSetAreaMinBlobs(cliffEastID, 1);
		rmSetAreaMaxBlobs(cliffEastID, 1);
		rmSetAreaMinBlobDistance(cliffEastID, 1);
		rmSetAreaMaxBlobDistance(cliffEastID, 1);
		rmSetAreaCoherence(cliffEastID, 0.45);
		rmSetAreaSmoothDistance(cliffEastID, 30);						
		rmSetAreaCoherence(cliffEastID, 0.45);
		
		rmSetAreaLocation(cliffEastID, 0.70, 0.50);

		rmBuildArea(cliffEastID);
			
/*----------------------------------------------------------------------------------------------------------------*/	

	    int cliffWestID=rmCreateArea("cliff west");
	    //rmSetAreaSize(cliffWestID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));
		rmSetAreaSize(cliffWestID, 0.0125, 0.0125);
        rmSetAreaWarnFailure(cliffWestID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(cliffWestID, "Texas Grass");
	}	
		else
	{	
		rmSetAreaCliffType(cliffWestID, "Texas");
	}	
		rmAddAreaToClass(cliffWestID, rmClassID("classCliff"));
        rmSetAreaCliffEdge(cliffWestID, 1, 1.0, 0.1, 1.0, 0);		
		//rmSetAreaCliffEdge(cliffWestID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffWestID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffWestID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffWestID, 1);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(cliffWestID, "texas\ground2_tex", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(cliffWestID, "texas\ground5_tex", 0, 2);
	}	

		rmSetAreaObeyWorldCircleConstraint(cliffWestID, false);
		//rmAddAreaConstraint(cliffWestID, cliffsAvoidCliffs);			
				
		rmSetAreaMinBlobs(cliffWestID, 1);
		rmSetAreaMaxBlobs(cliffWestID, 1);
		rmSetAreaMinBlobDistance(cliffWestID, 1);
		rmSetAreaMaxBlobDistance(cliffWestID, 1);
		
		rmSetAreaCoherence(cliffWestID, 0.45);
		rmSetAreaSmoothDistance(cliffWestID, 30);	
		rmSetAreaCoherence(cliffWestID, 0.45);
		
		rmSetAreaLocation(cliffWestID, 0.30, 0.50);

		rmBuildArea(cliffWestID);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int cliffEast2ID=rmCreateArea("cliff east 2");
		
	    //rmSetAreaSize(cliffEast2ID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));
        rmSetAreaSize(cliffEast2ID, 0.0065, 0.0065);		
		rmSetAreaWarnFailure(cliffEast2ID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(cliffEast2ID, "Texas Grass");
	}	
		else
	{	
		rmSetAreaCliffType(cliffEast2ID, "Texas");
	}	
		
		rmAddAreaToClass(cliffEast2ID, rmClassID("classCliff"));	
		//rmSetAreaCliffEdge(cliffEast2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliffEast2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffEast2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffEast2ID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffEast2ID, 1);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(cliffEast2ID, "texas\ground2_tex", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(cliffEast2ID, "texas\ground5_tex", 0, 2);
	}	
		
		rmSetAreaObeyWorldCircleConstraint(cliffEast2ID, false);
		//rmAddAreaConstraint(cliffEast2ID, cliffsAvoidCliffs);				
							
		rmSetAreaMinBlobs(cliffEast2ID, 1);
		rmSetAreaMaxBlobs(cliffEast2ID, 1);
		rmSetAreaMinBlobDistance(cliffEast2ID, 1);
		rmSetAreaMaxBlobDistance(cliffEast2ID, 1);
		rmSetAreaCoherence(cliffEast2ID, 0.45);
		rmSetAreaSmoothDistance(cliffEast2ID, 30);						
		rmSetAreaCoherence(cliffEast2ID, 0.45);
		
		rmSetAreaLocation(cliffEast2ID, 0.30, 0.15);

		rmBuildArea(cliffEast2ID);
			
/*----------------------------------------------------------------------------------------------------------------*/	

	    int cliffWest2ID=rmCreateArea("cliff west 2");
	    //rmSetAreaSize(cliffWest2ID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));
		rmSetAreaSize(cliffWest2ID, 0.0065, 0.0065);
        rmSetAreaWarnFailure(cliffWest2ID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(cliffWest2ID, "Texas Grass");
	}	
		else
	{	
		rmSetAreaCliffType(cliffWest2ID, "Texas");
	}	
		rmAddAreaToClass(cliffWest2ID, rmClassID("classCliff"));
        rmSetAreaCliffEdge(cliffWest2ID, 1, 1.0, 0.1, 1.0, 0);		
		//rmSetAreaCliffEdge(cliffWest2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffWest2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffWest2ID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffWest2ID, 1);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(cliffWest2ID, "texas\ground2_tex", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(cliffWest2ID, "texas\ground5_tex", 0, 2);
	}	

		rmSetAreaObeyWorldCircleConstraint(cliffWest2ID, false);
		//rmAddAreaConstraint(cliffWest2ID, cliffsAvoidCliffs);			
				
		rmSetAreaMinBlobs(cliffWest2ID, 1);
		rmSetAreaMaxBlobs(cliffWest2ID, 1);
		rmSetAreaMinBlobDistance(cliffWest2ID, 1);
		rmSetAreaMaxBlobDistance(cliffWest2ID, 1);
		
		rmSetAreaCoherence(cliffWest2ID, 0.45);
		rmSetAreaSmoothDistance(cliffWest2ID, 30);	
		rmSetAreaCoherence(cliffWest2ID, 0.45);
		
		rmSetAreaLocation(cliffWest2ID, 0.70, 0.85);

		rmBuildArea(cliffWest2ID);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE FORESTS - NORTH AND SOUTH: ********************************* //
/*================================================================================================================*/
	
	        int forestTreeID = 0;
	
	        if (cNumberNonGaiaPlayers<=2)
		    numTries= 8*cNumberNonGaiaPlayers;
		    else
		    numTries= 6*cNumberNonGaiaPlayers;
	        
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int westForest=rmCreateArea("westForest"+i);
			rmSetAreaWarnFailure(westForest, false);
			rmSetAreaSize(westForest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
			
			if ( whichVariation == 1 )
		{	
			rmSetAreaForestType(westForest, "texas forest");
		}
            else
        {
            rmSetAreaForestType(westForest, "texas forest dirt");
        }			
			rmSetAreaForestDensity(westForest, 1.0);
			rmSetAreaForestClumpiness(westForest, 0.0);
			rmSetAreaForestUnderbrush(westForest, 0.0);
			rmSetAreaMinBlobs(westForest, 1);
			rmSetAreaMaxBlobs(westForest, 1);
			rmSetAreaMinBlobDistance(westForest, 1.0);
			rmSetAreaMaxBlobDistance(westForest, 1.0);
			rmSetAreaCoherence(westForest, 0.85);
			rmSetAreaSmoothDistance(westForest, 10);
			rmAddAreaToClass(westForest, rmClassID("classForest"));
			
			rmAddAreaConstraint(westForest, playerEdgeConstraint);
			rmAddAreaConstraint(westForest, regionCloseConstraint);
			rmAddAreaConstraint(westForest, mountainCloseConstraint);
			rmAddAreaConstraint(westForest, waterCloseConstraint);
			rmAddAreaConstraint(westForest, playerCloseConstraint);	
			rmAddAreaConstraint(westForest, forestMediumConstraint);			
			rmAddAreaConstraint(westForest, Westward);					
			rmAddAreaConstraint(westForest, avoidTradeRoute);
			rmAddAreaConstraint(westForest, avoidSocket);
			
			if(rmBuildArea(westForest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}

/*----------------------------------------------------------------------------------------------------------------*/		
		    if (cNumberNonGaiaPlayers<=2)
		    numTries= 8*cNumberNonGaiaPlayers;
		    else
		    numTries= 6*cNumberNonGaiaPlayers;
	        
			failCount=0;
	        for (i=0; <numTries)
		{   
			int eastForest=rmCreateArea("eastForest"+i);
			rmSetAreaWarnFailure(eastForest, false);
			rmSetAreaSize(eastForest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
			
			if ( whichVariation == 1 )
		{	
			rmSetAreaForestType(eastForest, "texas forest");
		}
            else
        {
            rmSetAreaForestType(eastForest, "texas forest dirt");
        }		
			
			rmSetAreaForestDensity(eastForest, 1.0);
			rmSetAreaForestClumpiness(eastForest, 0.0);
			rmSetAreaForestUnderbrush(eastForest, 0.0);
			rmSetAreaMinBlobs(eastForest, 1);
			rmSetAreaMaxBlobs(eastForest, 1);
			rmSetAreaMinBlobDistance(eastForest, 1.0);
			rmSetAreaMaxBlobDistance(eastForest, 1.0);
			rmSetAreaCoherence(eastForest, 0.85);
			rmSetAreaSmoothDistance(eastForest, 10);
			rmAddAreaToClass(eastForest, rmClassID("classForest"));
			
			rmAddAreaConstraint(eastForest, playerEdgeConstraint);
			rmAddAreaConstraint(eastForest, regionCloseConstraint);
			rmAddAreaConstraint(eastForest, mountainCloseConstraint);
			rmAddAreaConstraint(eastForest, waterCloseConstraint);
			rmAddAreaConstraint(eastForest, playerCloseConstraint);	
			rmAddAreaConstraint(eastForest, forestMediumConstraint);			
			rmAddAreaConstraint(eastForest, Eastward);					
			rmAddAreaConstraint(eastForest, avoidTradeRoute);
			rmAddAreaConstraint(eastForest, avoidSocket);
						
			if(rmBuildArea(eastForest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);

/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //		
/*================================================================================================================*/

        // THE NORTHERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Berries 1");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(BerriesID, rmClassID("Food"));
		
		rmAddObjectDefConstraint(BerriesID, regionCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidVeryFarFood);
		rmAddObjectDefConstraint(BerriesID, waterCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, mountainCloseConstraint);
        rmAddObjectDefConstraint(BerriesID, avoidAll);
		rmAddObjectDefConstraint(BerriesID, forestConstraint);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, Northward);
        rmAddObjectDefConstraint(BerriesID, avoidImpassableLand);
	    rmAddObjectDefConstraint(BerriesID, avoidTradeRoute);
	    rmAddObjectDefConstraint(BerriesID, avoidSocket);
	    		
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
	    
/*----------------------------------------------------------------------------------------------------------------*/
		
		// THE SOUTHERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Berries 2");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(Berries2ID, rmClassID("Food"));
		
		rmAddObjectDefConstraint(Berries2ID, regionCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidVeryFarFood);
		rmAddObjectDefConstraint(Berries2ID, waterCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, mountainCloseConstraint);
        rmAddObjectDefConstraint(Berries2ID, avoidAll);
		rmAddObjectDefConstraint(Berries2ID, forestConstraint);
		rmAddObjectDefConstraint(Berries2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, Southward);
        rmAddObjectDefConstraint(Berries2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Berries2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(Berries2ID, avoidSocket);
	            
		rmSetObjectDefCreateHerd(Berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*================================================================================================================*/
// ************************************* DEFINE AND PLACE SOME DEER HERDS: ************************************** //
/*================================================================================================================*/

        // DEFINE THE NORTHERN DEER HERDS:
		int deer1ID=rmCreateObjectDef("Northern Deer Herds");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 8.0);
        rmSetObjectDefMinDistance(deer1ID, 0.5);
        rmSetObjectDefMaxDistance(deer1ID, rmXFractionToMeters(0.9));
		rmAddObjectDefToClass(deer1ID, rmClassID("Huntable"));
	    
		rmAddObjectDefConstraint(deer1ID, avoidVeryFarHuntable);
	    rmAddObjectDefConstraint(deer1ID, playerCloseConstraint);
		rmAddObjectDefConstraint(deer1ID, regionCloseConstraint);
		rmAddObjectDefConstraint(deer1ID, avoidFood);
		rmAddObjectDefConstraint(deer1ID, waterCloseConstraint);
		rmAddObjectDefConstraint(deer1ID, mountainCloseConstraint);
        rmAddObjectDefConstraint(deer1ID, avoidAll);
		rmAddObjectDefConstraint(deer1ID, forestConstraint);
		rmAddObjectDefConstraint(deer1ID, Northward);
        rmAddObjectDefConstraint(deer1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(deer1ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(deer1ID, avoidSocket);
	    
		rmSetObjectDefCreateHerd(deer1ID, true);
	    if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE SOUTHERN DEER HERDS:
		int deer2ID=rmCreateObjectDef("Southern Deer Herds");
        rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,12), 8.0);
        rmSetObjectDefMinDistance(deer2ID, 0.5);
        rmSetObjectDefMaxDistance(deer2ID, rmXFractionToMeters(0.9));
		rmAddObjectDefToClass(deer2ID, rmClassID("Huntable"));
	    
		rmAddObjectDefConstraint(deer2ID, avoidVeryFarHuntable);
	    rmAddObjectDefConstraint(deer2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(deer2ID, regionCloseConstraint);
		rmAddObjectDefConstraint(deer2ID, avoidFood);
		rmAddObjectDefConstraint(deer2ID, waterCloseConstraint);
		rmAddObjectDefConstraint(deer2ID, mountainCloseConstraint);
        rmAddObjectDefConstraint(deer2ID, avoidAll);
		rmAddObjectDefConstraint(deer2ID, forestConstraint);
		rmAddObjectDefConstraint(deer2ID, Southward);
        rmAddObjectDefConstraint(deer2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(deer2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(deer2ID, avoidSocket);
	    
		rmSetObjectDefCreateHerd(deer2ID, true);
	    if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*================================================================================================================*/
// ************************************* DEFINE AND PLACE SOME BISON HERDS: ************************************** //
/*================================================================================================================*/

        // DEFINE THE NORTHERN BISON HERDS:
		int bison1ID=rmCreateObjectDef("Northern Bison Herds");
        rmAddObjectDefItem(bison1ID, "bison", rmRandInt(7,12), 8.0);
        rmSetObjectDefMinDistance(bison1ID, 0.5);
        rmSetObjectDefMaxDistance(bison1ID, rmXFractionToMeters(0.9));
		rmAddObjectDefToClass(bison1ID, rmClassID("Huntable"));
	    
		rmAddObjectDefConstraint(bison1ID, avoidVeryFarHuntable);
	    rmAddObjectDefConstraint(bison1ID, playerCloseConstraint);
		rmAddObjectDefConstraint(bison1ID, regionCloseConstraint);
		rmAddObjectDefConstraint(bison1ID, avoidFood);
		rmAddObjectDefConstraint(bison1ID, waterCloseConstraint);
		rmAddObjectDefConstraint(bison1ID, mountainCloseConstraint);
        rmAddObjectDefConstraint(bison1ID, avoidAll);
		rmAddObjectDefConstraint(bison1ID, forestConstraint);
		rmAddObjectDefConstraint(bison1ID, Northward);
        rmAddObjectDefConstraint(bison1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(bison1ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(bison1ID, avoidSocket);
	    
		rmSetObjectDefCreateHerd(bison1ID, true);
	    if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(bison1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE SOUTHERN BISON HERDS:
		int bison2ID=rmCreateObjectDef("Southern Bison Herds");
        rmAddObjectDefItem(bison2ID, "bison", rmRandInt(7,12), 8.0);
        rmSetObjectDefMinDistance(bison2ID, 0.5);
        rmSetObjectDefMaxDistance(bison2ID, rmXFractionToMeters(0.9));
		rmAddObjectDefToClass(bison2ID, rmClassID("Huntable"));
	    
		rmAddObjectDefConstraint(bison2ID, avoidVeryFarHuntable);
	    rmAddObjectDefConstraint(bison2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(bison2ID, regionCloseConstraint);
		rmAddObjectDefConstraint(bison2ID, avoidFood);
		rmAddObjectDefConstraint(bison2ID, waterCloseConstraint);
		rmAddObjectDefConstraint(bison2ID, mountainCloseConstraint);
        rmAddObjectDefConstraint(bison2ID, avoidAll);
		rmAddObjectDefConstraint(bison2ID, forestConstraint);
		rmAddObjectDefConstraint(bison2ID, Southward);
        rmAddObjectDefConstraint(bison2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(bison2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(bison2ID, avoidSocket);
	    
		rmSetObjectDefCreateHerd(bison2ID, true);
	    if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);		
 
/*================================================================================================================*/		
 
/*================================================================================================================*/  
// ******************************* DEFINE AND PLACE SOME SILVER AND GOLD MINES: ********************************* //
/*================================================================================================================*/

        int mineType = -1;
        int mineID = -1;
		if (cNumberNonGaiaPlayers<=2)
		int silverTries=4*cNumberNonGaiaPlayers;
		else
		silverTries=2*cNumberNonGaiaPlayers;
   
	    int silverMineID = rmCreateObjectDef("silver mines");
	    
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silverMineID, "mine", rmRandInt(1,1), 5.0);
	}
        else
	{	
	    rmAddObjectDefItem(silverMineID, "minegold", rmRandInt(1,1), 5.0);
	}
    
		rmSetObjectDefMinDistance(silverMineID, 0.0);
	    rmSetObjectDefMaxDistance(silverMineID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(silverMineID, avoidImpassableLand);
	    rmAddObjectDefConstraint(silverMineID, regionCloseConstraint);
	    rmAddObjectDefConstraint(silverMineID, avoidVeryFarCoin);
	    rmAddObjectDefConstraint(silverMineID, playerConstraint);
		rmAddObjectDefConstraint(silverMineID, mountainCloseConstraint);
	    rmAddObjectDefConstraint(silverMineID, avoidAll);
		rmAddObjectDefConstraint(silverMineID, avoidCloseFood);
		rmAddObjectDefConstraint(silverMineID, forestConstraint);
		rmAddObjectDefConstraint(silverMineID, avoidCloseNugget);
		rmAddObjectDefConstraint(silverMineID, waterCloseConstraint);
		rmAddObjectDefConstraint(silverMineID, Northward);
	    rmAddObjectDefConstraint(silverMineID, avoidTradeRoute);
	    rmAddObjectDefConstraint(silverMineID, avoidSocket);
        
		for(i=0; <silverTries)
   {
		
		rmPlaceObjectDefAtLoc(silverMineID, 0, 0.5, 0.5);
   }		
/*----------------------------------------------------------------------------------------------------------------*/

        mineType = -1;
        mineID = -1;
		if (cNumberNonGaiaPlayers<=2)
		silverTries=4*cNumberNonGaiaPlayers;
		else
		silverTries=2*cNumberNonGaiaPlayers;
	    
   
	    int silverMine2ID = rmCreateObjectDef("silver mines 2");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silverMine2ID, "mine", rmRandInt(1,1), 5.0);
	}
        else
	{	
	    rmAddObjectDefItem(silverMine2ID, "minegold", rmRandInt(1,1), 5.0);
	}  
	
	    rmSetObjectDefMinDistance(silverMine2ID, 0.0);
	    rmSetObjectDefMaxDistance(silverMine2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(silverMine2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(silverMine2ID, regionCloseConstraint);
	    rmAddObjectDefConstraint(silverMine2ID, avoidVeryFarCoin);
	    rmAddObjectDefConstraint(silverMine2ID, playerConstraint);
		rmAddObjectDefConstraint(silverMine2ID, mountainCloseConstraint);
	    rmAddObjectDefConstraint(silverMine2ID, avoidAll);
		rmAddObjectDefConstraint(silverMine2ID, avoidCloseFood);
		rmAddObjectDefConstraint(silverMine2ID, forestConstraint);
		rmAddObjectDefConstraint(silverMine2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(silverMine2ID, waterCloseConstraint);
		rmAddObjectDefConstraint(silverMine2ID, Southward);
	    rmAddObjectDefConstraint(silverMine2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(silverMine2ID, avoidSocket);
        
		for(i=0; <silverTries)
   {
		
		rmPlaceObjectDefAtLoc(silverMine2ID, 0, 0.5, 0.5);
   } 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*================================================================================================================*/  
	
	    // THE NORTHERN NUGGETS:
		int nuggetID = 0;
	    rmSetNuggetDifficulty(1, 3);
		
		nuggetID= rmCreateObjectDef("The Northern Nugget "+i); 
		rmAddObjectDefItem(nuggetID, "nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nuggetID, 0.0);
		rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
		//rmAddObjectDefToClass(nuggetID, rmClassID("importantItem"));
		rmAddObjectDefToClass(nuggetID, rmClassID("nuggets"));
		
		rmAddObjectDefConstraint(nuggetID, mountainCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
		rmAddObjectDefConstraint(nuggetID, regionCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidImportantItem);
		rmAddObjectDefConstraint(nuggetID, avoidVeryFarNugget);
		rmAddObjectDefConstraint(nuggetID, forestConstraint);
		rmAddObjectDefConstraint(nuggetID, playerCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidCoin);
		rmAddObjectDefConstraint(nuggetID, avoidAll);
		rmAddObjectDefConstraint(nuggetID, Northward);
		rmAddObjectDefConstraint(nuggetID, avoidFood);
		rmAddObjectDefConstraint(nuggetID, waterCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
		rmAddObjectDefConstraint(nuggetID, circleConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
	
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN NUGGETS:
		int nugget2ID = 0;
	    rmSetNuggetDifficulty(1, 3);
	    	
		nugget2ID= rmCreateObjectDef("The Southern Nugget "+i); 
		rmAddObjectDefItem(nugget2ID, "nugget", 1, 0.0);
		rmSetObjectDefMinDistance(nugget2ID, 0.0);
		rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
		//rmAddObjectDefToClass(nugget2ID, rmClassID("importantItem"));
		rmAddObjectDefToClass(nugget2ID, rmClassID("nuggets"));
		
		rmAddObjectDefConstraint(nugget2ID, mountainCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget2ID, regionCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, avoidImportantItem);
		rmAddObjectDefConstraint(nugget2ID, avoidVeryFarNugget);
		rmAddObjectDefConstraint(nugget2ID, forestConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, avoidCoin);
		rmAddObjectDefConstraint(nugget2ID, avoidAll);
		rmAddObjectDefConstraint(nugget2ID, Southward);
		rmAddObjectDefConstraint(nugget2ID, avoidFood);
		rmAddObjectDefConstraint(nugget2ID, waterCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget2ID, circleConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE COWS: ****************************************** //
/*================================================================================================================*/

        // THE NORTHERN COWS:
		int cowID=rmCreateObjectDef("The Northern Cows");
        rmAddObjectDefItem(cowID, "cow", 5, 4.0);
        rmSetObjectDefMinDistance(cowID, 0.0);
        rmSetObjectDefMaxDistance(cowID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(cowID, avoidVeryFarCow);
		rmAddObjectDefConstraint(cowID, avoidCloseNugget);
	    rmAddObjectDefConstraint(cowID, avoidAll);
		rmAddObjectDefConstraint(cowID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(cowID, avoidCloseSocket);
		rmAddObjectDefConstraint(cowID, Northward);
		rmAddObjectDefConstraint(cowID, avoidCloseFood);
		rmAddObjectDefConstraint(cowID, avoidCloseCoin);
		rmAddObjectDefConstraint(cowID, forestCloseConstraint);
	    rmAddObjectDefConstraint(cowID, playerCloseConstraint);
	    rmAddObjectDefConstraint(cowID, regionCloseConstraint);
		rmAddObjectDefConstraint(cowID, waterCloseConstraint);
		rmAddObjectDefConstraint(cowID, mountainCloseConstraint);
        rmAddObjectDefConstraint(cowID, avoidImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN COWS:
		int cow2ID=rmCreateObjectDef("The Southern Cows");
        rmAddObjectDefItem(cow2ID, "cow", 5, 4.0);
        rmSetObjectDefMinDistance(cow2ID, 0.0);
        rmSetObjectDefMaxDistance(cow2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(cow2ID, avoidVeryFarCow);
		rmAddObjectDefConstraint(cow2ID, avoidCloseNugget);
	    rmAddObjectDefConstraint(cow2ID, avoidAll);
		rmAddObjectDefConstraint(cow2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(cow2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(cow2ID, Southward);
		rmAddObjectDefConstraint(cow2ID, avoidCloseFood);
		rmAddObjectDefConstraint(cow2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(cow2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(cow2ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(cow2ID, regionCloseConstraint);
		rmAddObjectDefConstraint(cow2ID, waterCloseConstraint);
		rmAddObjectDefConstraint(cow2ID, mountainCloseConstraint);
        rmAddObjectDefConstraint(cow2ID, avoidImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
	    		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.96);
/*================================================================================================================*/   
// ******************************** DEFINE AND PLACE THE BIG DECORATIVE THINGS: ********************************* //
/*================================================================================================================*/

	    int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	    
		int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "BigPropTexas", 25.0);
		 
		rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
			   
	    rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	    rmSetObjectDefMaxDistance(bigDecorationID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(bigDecorationID, avoidAll);
		rmAddObjectDefConstraint(bigDecorationID, forestConstraint);
	    rmAddObjectDefConstraint(bigDecorationID, avoidImportantItem);
	    rmAddObjectDefConstraint(bigDecorationID, avoidCoin);
		rmAddObjectDefConstraint(bigDecorationID, avoidFood);
	    rmAddObjectDefConstraint(bigDecorationID, avoidImpassableLand);
	    rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
	    rmAddObjectDefConstraint(bigDecorationID, mountainCloseConstraint);
	    rmAddObjectDefConstraint(bigDecorationID, playerMediumConstraint);
	    rmAddObjectDefConstraint(bigDecorationID, regionCloseConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
	    	
/*================================================================================================================*/
// ************************ DEFINE AND PLACE THE PERCHING VULTURES - ADD FOUR SOMEWHERE: ************************ //
/*================================================================================================================*/

	    int vultureID=rmCreateObjectDef("perching vultures");
	    
		int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	    
		rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(vultureID, avoidAll);
		rmAddObjectDefConstraint(vultureID, forestConstraint);
	    rmAddObjectDefConstraint(vultureID, avoidImportantItem);
	    rmAddObjectDefConstraint(vultureID, avoidCoin);
		rmAddObjectDefConstraint(vultureID, avoidFood);
	    rmAddObjectDefConstraint(vultureID, avoidImpassableLand);
	    rmAddObjectDefConstraint(vultureID, avoidTradeRoute);
		rmAddObjectDefConstraint(vultureID, avoidCloseSocket);
	    rmAddObjectDefConstraint(vultureID, mountainCloseConstraint);
	    rmAddObjectDefConstraint(vultureID, avoidBigDecoration);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
	    rmAddObjectDefConstraint(vultureID, playerMediumConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.98);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE NORTH REGION:
		int randomTreeID=rmCreateObjectDef("North Random Trees");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(randomTreeID, "TreeTexas", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(randomTreeID, "TreeTexasDirt", 1, 0.0);
	}	
		
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, regionCloseConstraint);
 		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint); 
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, Northward);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseHerdable);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, waterCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseHuntable);
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTreeID, mountainCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFood);
	    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);	

/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE SOUTH REGION:
		int randomTree2ID=rmCreateObjectDef("South Random Trees");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(randomTree2ID, "TreeTexas", 1, 0.0);
	}
        else
    {		
		rmAddObjectDefItem(randomTree2ID, "TreeTexasDirt", 1, 0.0);
	}	
		
		rmAddObjectDefToClass(randomTree2ID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTree2ID, regionCloseConstraint);
 		rmAddObjectDefConstraint(randomTree2ID, playerEdgeConstraint); 
	    rmAddObjectDefConstraint(randomTree2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTree2ID, avoidAll);
		rmAddObjectDefConstraint(randomTree2ID, Southward);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseHerdable);
		rmAddObjectDefConstraint(randomTree2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, waterCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseHuntable);
	    rmAddObjectDefConstraint(randomTree2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTree2ID, mountainCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseFood);
				
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
// ************************** DEFINE AND PLACE SOME RANDOM NORTHERN AND SOUTHERN CLIFFS: ************************ //
/*================================================================================================================*/
				
		if (cNumberNonGaiaPlayers<=2)
		numTries=cNumberNonGaiaPlayers*6;
		else
		numTries=cNumberNonGaiaPlayers*3;
	    failCount=0;
		
/*----------------------------------------------------------------------------------------------------------------*/		
	    
		for(i=0; <numTries)
{	
		int Cliff1ID=rmCreateArea("The Cliff 1"+i);
	    rmSetAreaSize(Cliff1ID, 0.0008, 0.0008);
		rmSetAreaWarnFailure(Cliff1ID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(Cliff1ID, "Texas Grass");
	}	
		else
	{	
		rmSetAreaCliffType(Cliff1ID, "Texas");
	}	
		
		rmAddAreaToClass(Cliff1ID, rmClassID("classCliff"));		
		//rmSetAreaCliffEdge(Cliff1ID, 1, 0.6, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(Cliff1ID, 1, 1.0, 0.1, 1.0, 0);		
		rmSetAreaCliffPainting(Cliff1ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(Cliff1ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(Cliff1ID, 1.0);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(Cliff1ID, "texas\ground2_tex", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(Cliff1ID, "texas\ground5_tex", 0, 2);
	}	
		
        rmSetAreaSmoothDistance(Cliff1ID, 15);
		rmSetAreaCoherence(Cliff1ID, 0.85);
		
		rmAddAreaConstraint(Cliff1ID, regionConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidCloseTradeRoute);
		rmAddAreaConstraint(Cliff1ID, avoidCloseSocket);
		rmAddAreaConstraint(Cliff1ID, playerEdgeConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidAll);
		rmAddAreaConstraint(Cliff1ID, avoidBigDecoration);
	    rmAddAreaConstraint(Cliff1ID, avoidVultures);
		rmAddAreaConstraint(Cliff1ID, Northward);
		rmAddAreaConstraint(Cliff1ID, playerMediumConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidHerdable);
		rmAddAreaConstraint(Cliff1ID, forestConstraint);
		rmAddAreaConstraint(Cliff1ID, waterConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidHuntable);
		rmAddAreaConstraint(Cliff1ID, avoidTrees);
		rmAddAreaConstraint(Cliff1ID, avoidCloseCoin);
		rmAddAreaConstraint(Cliff1ID, avoidNugget);
		rmAddAreaConstraint(Cliff1ID, mountainFarConstraint);
		rmAddAreaConstraint(Cliff1ID, avoidFood);
		rmAddAreaConstraint(Cliff1ID, avoidVeryFarCliffs);
				  	    		
		if(rmBuildArea(Cliff1ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
}
        		
/*----------------------------------------------------------------------------------------------------------------*/		

		for(i=0; <numTries)
	{	
		int Cliff2ID=rmCreateArea("The Cliff 2"+i);
	    rmSetAreaSize(Cliff2ID, 0.0008, 0.0008);
		rmSetAreaWarnFailure(Cliff2ID, false);
		
		if ( whichVariation == 1 )
	{	
		rmSetAreaCliffType(Cliff2ID, "Texas Grass");
	}	
		else
	{	
		rmSetAreaCliffType(Cliff2ID, "Texas");
	}	
		
		rmAddAreaToClass(Cliff2ID, rmClassID("classCliff"));		
		//rmSetAreaCliffEdge(Cliff2ID, 1, 0.6, 0.1, 1.0, 0);
        rmSetAreaCliffEdge(Cliff2ID, 1, 1.0, 0.1, 1.0, 0);			
		rmSetAreaCliffPainting(Cliff2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(Cliff2ID, 6, 1.0, 1.0);
		rmSetAreaHeightBlend(Cliff2ID, 1.0);
		
		if ( whichVariation == 1 )
	{	
		rmAddAreaTerrainLayer(Cliff2ID, "texas\ground2_tex", 0, 2);
	}
        else
	{	
		rmAddAreaTerrainLayer(Cliff2ID, "texas\ground5_tex", 0, 2);
	}	
		
        rmSetAreaSmoothDistance(Cliff2ID, 15);
		rmSetAreaCoherence(Cliff2ID, 0.85);
		
		rmAddAreaConstraint(Cliff2ID, regionConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidCloseTradeRoute);
		rmAddAreaConstraint(Cliff2ID, avoidCloseSocket);
		rmAddAreaConstraint(Cliff2ID, playerEdgeConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidAll);
		rmAddAreaConstraint(Cliff2ID, avoidBigDecoration);
	    rmAddAreaConstraint(Cliff2ID, avoidVultures);
		rmAddAreaConstraint(Cliff2ID, Southward);
		rmAddAreaConstraint(Cliff2ID, playerMediumConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidHerdable);
		rmAddAreaConstraint(Cliff2ID, forestConstraint);
		rmAddAreaConstraint(Cliff2ID, waterConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidHuntable);
		rmAddAreaConstraint(Cliff2ID, avoidTrees);
		rmAddAreaConstraint(Cliff2ID, avoidCloseCoin);
		rmAddAreaConstraint(Cliff2ID, avoidNugget);
		rmAddAreaConstraint(Cliff2ID, mountainFarConstraint);
		rmAddAreaConstraint(Cliff2ID, avoidFood);
		rmAddAreaConstraint(Cliff2ID, avoidVeryFarCliffs);
				
		if(rmBuildArea(Cliff2ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
		
	}			
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE FISHBASS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);			
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		















