/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// THE FREEDOM TRAIL:
// CREATED BY DANY:
// OCTOBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.01);
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DETERMINES MAP ORIENTATION: - 1 IS E/W, 2 IS N/S:
        int whichVersion = rmRandInt(1,2);
  
        // version switcher for testing
        // whichVersion = 2;
  
/*================================================================================================================*/  
// ******************************** CHOOSE WHICH NATIVE TRIBES APPEAR ON THE MAP: ******************************* //
/*================================================================================================================*/  
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
  
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(3) == true) 
	
	{
		
		subCiv0=rmGetCivID("cherokee");
		rmEchoInfo("subCiv0 is cherokee "+subCiv0);
		if (subCiv0 >= 0)
		rmSetSubCiv(0, "cherokee");

		subCiv1=rmGetCivID("cree");
		rmEchoInfo("subCiv1 is cree "+subCiv1);
		if (subCiv1 >= 0)
		rmSetSubCiv(1, "cree");
    
        subCiv2=rmGetCivID("iroquois");
		rmEchoInfo("subCiv1 is iroquois "+subCiv2);
		if (subCiv2 >= 0)
		rmSetSubCiv(2, "iroquois");
			
	}
	
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int playerTiles = 22500;
	    
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(600, 600);

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // SET WIND MAGNITUDE:
		//rmSetWindMagnitude(2);

        // PICKS A DEFAULT WATER HEIGHT:
		//rmSetSeaLevel(6.0); // FROM GREAT LAKES:
        rmSetSeaLevel(4.0);

      	// SET MAP ELEVATION PARAMETERS:
		//	rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    rmSetMapElevationParameters(cElevTurbulence, 0.06, 1, 0.4, 3.0);
		//rmSetMapElevationParameters(cElevTurbulence, 0.04, 4, 0.4, 6.0);
		//rmSetMapElevationParameters(cElevTurbulence, 0.05, 6, 0.7, 8.0); // FROM GREAT LAKES:
        
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(0.6);
		//rmSetMapElevationHeightBlend(1); // FROM GREAT LAKES:
		
		// SET SEA TYPE:
		rmSetSeaType("new england coast");
		
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	
	    // SET MAP TYPE:
		rmSetMapType("newEngland");
	    rmSetMapType("grass");
		rmSetMapType("water");
	    	
        //SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("newengland_grass");
                
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("new_england\ground1_ne", 5);
		  
        // SET LIGHTING:
		rmSetLightingSet("new england");
		
	    // CHOOSE MERCS:
		chooseMercs();

	    // MAKE IT RAIN:
        //rmSetGlobalRain( 0.3 );
  
        // SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
  
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
		rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        //rmDefineClass("importantItem");
        rmDefineClass("classSocket");
		rmDefineClass("natives");
        int foodClass = rmDefineClass("FoodClass");
		rmDefineClass("classTrees");
		rmDefineClass("classCliff");
		  
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.20);
/*================================================================================================================*/
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
// *************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: *********************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
    // MAP EDGE CONSTRAINTS:
    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
    int playerCloseEdgeConstraint=rmCreatePieConstraint("close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
    
    // PLAYER CONSTRAINTS:
    int playerConstraint=rmCreateClassDistanceConstraint("stuff avoid players", classPlayer, 20.0);
    int playerCloseConstraint=rmCreateClassDistanceConstraint("close avoid players", classPlayer, 10.0);
    int playerMediumConstraint=rmCreateClassDistanceConstraint("medium avoid players", classPlayer, 35.0);
       
    // UNIT AVOIDANCE:
    int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 10.0);
	
	// CARDINAL DIRECTIONS:
	int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
 		
	// CLIFF AVOIDANCE:
	int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 20.0);
	int avoidCloseCliff=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 10.0);
    int avoidVeryCloseCliff=rmCreateClassDistanceConstraint("very close vs. cliff", rmClassID("classCliff"), 5.0);
    int avoidMediumCliff=rmCreateClassDistanceConstraint("medium vs. cliff", rmClassID("classCliff"), 30.0);
	
	// TREES AVOIDANCE:
	int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 15.0);
	int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 8.0);
	int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 3.0);
	int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
	int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
	int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
			
	// SILVER COIN AVOIDANCE:
	int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "mine", 20.0);
	int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "mine", 10.0);
	int avoidVeryCloseCoin=rmCreateTypeDistanceConstraint("very close avoid coin", "mine", 5.0);
	int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "mine", 30.0);
	int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "mine", 60.0);
	int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoid coin", "mine", 90.0);
	int avoidSuperFarCoin=rmCreateTypeDistanceConstraint("super far avoid coin", "mine", 120.0);
	
	// GOLD COIN AVOIDANCE:
	int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "minegold", 15.0);
	int avoidMediumGold=rmCreateTypeDistanceConstraint("medium avoid gold", "minegold", 30.0);
	
	// BERRYBUSH AVOIDANCE:
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids berrybush", "BerryBush", 25.0);
	int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids berrybush", "BerryBush", 15.0);
	int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoids berrybush", "BerryBush", 8.0);
	int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoids berrybush", "BerryBush", 35.0);
	int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoids berrybush", "BerryBush", 60.0);
	int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoids berrybush", "BerryBush", 90.0);
	
	// BERRYBUSH AVOIDANCE:
	int avoidBerries = rmCreateTypeDistanceConstraint("stuff avoid berries", "berrybush", 20.0);
	int avoidCloseBerries = rmCreateTypeDistanceConstraint("close avoid berries", "berrybush", 10.0);
    int avoidVeryCloseBerries = rmCreateTypeDistanceConstraint("very close avoid berries", "berrybush", 5.0);
    int avoidMediumBerries = rmCreateTypeDistanceConstraint("medium avoid berries", "berrybush", 30.0);
    int avoidFarBerries = rmCreateTypeDistanceConstraint("far avoid berries", "berrybush", 60.0);
    int avoidVeryFarBerries = rmCreateTypeDistanceConstraint("very far avoid berries", "berrybush", 90.0);
    int avoidsuperFarBerries = rmCreateTypeDistanceConstraint("super far avoid berries", "berrybush", 120.0);
 	
	// FOREST AVOIDANCE:
	int forestConstraint=rmCreateClassDistanceConstraint("stuff vs. forest", rmClassID("classForest"), 20.0);
	int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 10.0);
    int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs. forest", rmClassID("classForest"), 5.0);
    int forestMediumConstraint=rmCreateClassDistanceConstraint("medium vs. forest", rmClassID("classForest"), 30.0);
    int forestFarConstraint=rmCreateClassDistanceConstraint("far vs. forest", rmClassID("classForest"), 60.0);
    int forestVeryFarConstraint=rmCreateClassDistanceConstraint("very far vs. forest", rmClassID("classForest"), 90.0);
    int forestSuperFarConstraint=rmCreateClassDistanceConstraint("super far vs. forest", rmClassID("classForest"), 120.0);
   
   			
	// STARTING UNITS AVOIDANCE:
	int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 15.0);
	int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close avoid starting units", rmClassID("startingUnit"), 8.0);
	int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium avoid starting units", rmClassID("startingUnit"), 25.0);
		
	// FOOD AVOIDANCE:
	int avoidFood = rmCreateClassDistanceConstraint("avoid foods", rmClassID("FoodClass"), 15.0);
	int avoidCloseFood = rmCreateClassDistanceConstraint("close avoid foods", rmClassID("FoodClass"), 8.0);
	int avoidVeryCloseFood = rmCreateClassDistanceConstraint("very close avoid foods", rmClassID("FoodClass"), 3.0);
	int avoidMediumFood = rmCreateClassDistanceConstraint("medium avoid foods", rmClassID("FoodClass"), 30.0);
	int avoidFarFood = rmCreateClassDistanceConstraint("far avoid foods", rmClassID("FoodClass"), 60.0);
	int avoidVeryFarFood = rmCreateClassDistanceConstraint("very far avoid foods", rmClassID("FoodClass"), 90.0);
	int avoidSuperFarFood = rmCreateClassDistanceConstraint("super far avoid foods", rmClassID("FoodClass"), 120.0);
	
	// MOOSE AVOIDANCE:
	int avoidMoose = rmCreateTypeDistanceConstraint("stuff avoid moose far", "moose", 20.0);
    int avoidCloseMoose = rmCreateTypeDistanceConstraint("close avoid moose far", "moose", 10.0);
    int avoidVeryCloseMoose = rmCreateTypeDistanceConstraint("very close avoid moose far", "moose", 5.0);
    int avoidMediumMoose = rmCreateTypeDistanceConstraint("medium avoid moose far", "moose", 30.0);
    int avoidFarMoose = rmCreateTypeDistanceConstraint("far avoid moose far", "moose", 60.0);
    int avoidVeryFarMoose = rmCreateTypeDistanceConstraint("very far avoid moose far", "moose", 90.0);
    int avoidSuperFarMoose = rmCreateTypeDistanceConstraint("super far avoid moose far", "moose", 120.0);
   
	// SHEEP AVOIDANCE:
	int avoidSheep = rmCreateTypeDistanceConstraint("stuff avoid sheep far", "sheep", 20.0);
    int avoidCloseSheep = rmCreateTypeDistanceConstraint("close avoid sheep far", "sheep", 10.0);
    int avoidVeryCloseSheep = rmCreateTypeDistanceConstraint("very close avoid sheep far", "sheep", 5.0);
    int avoidMediumSheep = rmCreateTypeDistanceConstraint("medium avoid sheep far", "sheep", 30.0);
    int avoidFarSheep = rmCreateTypeDistanceConstraint("far avoid sheep far", "sheep", 60.0);
    int avoidVeryFarSheep = rmCreateTypeDistanceConstraint("very far avoid sheep far", "sheep", 90.0);
    int avoidSuperFarSheep = rmCreateTypeDistanceConstraint("super far avoid sheep far", "sheep", 120.0);
   
	
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
	int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 8.0);
	int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 30.0);
	
	// NUGGET AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 15.0);
   	int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 8.0);
   	int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close avoid nugget", "AbstractNugget", 5.0);
   	int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium avoid nugget", "AbstractNugget", 30.0);
	int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 60.0);
	int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far avoid nugget", "AbstractNugget", 90.0);
	int avoidSuperFarNugget=rmCreateTypeDistanceConstraint("super far avoid nugget", "AbstractNugget", 120.0);
	
	// GENERAL AVOIDANCE:
    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
	
	// CONSTRAINT TO AVOID WATER:
    int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water 4", "Land", false, 4.0);
    int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water 10", "Land", false, 10.0);
	int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water 15", "Land", false, 15.0);
		
	// TRADE ROUTE AVOIDANCE:
    int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 15.0);
	int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 8.0);
	int avoidVeryCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("very close trade route", 3.0);
    
	// SOCKET AVOIDANCE:
	int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 15.0);
    int avoidCloseSocket = rmCreateClassDistanceConstraint("close avoid socket", rmClassID("classSocket"), 8.0);
    int avoidVeryCloseSocket = rmCreateClassDistanceConstraint("very close avoid socket", rmClassID("classSocket"), 3.0);
    
    // FLAG AVOIDANCE:
	int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 10.0);
    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
	
	// FISHES AVOIDANCE:
	int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
    
    	
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.25);
/*================================================================================================================*/
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** // 
/*================================================================================================================*/
  
        if(rmRandFloat(0,1) > 0.50)
	    {
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.45, 0.85, 0.85, 0.45, 0, 0.0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.55, 0.15, 0.15, 0.55, 0, 0.0);
		}
		    else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.15, 0.55, 0.55, 0.15, 0, 0.0);
	
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.85, 0.45, 0.45, 0.85, 0, 0.0);
		}
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.30);
/*================================================================================================================*/
// ****************************************** SET UP THE PLAYER AREAS: ****************************************** // 
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(2125);
        
		for(i=1; <cNumberPlayers)
{
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);

        // SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);		
        
		// ADD AREA CONSTRAINT: 
		//rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint);

        // SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);		
        
        // SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");

		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "texas_dirt");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_grass");
	    
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
}
  
        // BUILD THE AREAS:
        rmBuildAllAreas();
  
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NORTH RIVER: *************************************** //
/*================================================================================================================*/

        //int northRiver = rmRiverCreate(-1, "Amazon River", 5, 5, 10, 10);
		int northRiver = rmRiverCreate(-1, "new england lake", 2, 2, 9, 9);
		//rmRiverSetConnections(northRiver, 0.5, 1.0, 1.0, 0.5);
		
		float riverXLoc = 0;
        float riverYLoc = 0;
		
		rmRiverAddWaypoint(northRiver, 0.50, 1.0);
        rmRiverAddWaypoint(northRiver, .75, .75);
        riverXLoc = .75;
        riverYLoc = .75;
        rmRiverAddWaypoint(northRiver, 1.0, 0.50);
		
		rmRiverSetShallowRadius(northRiver, 7.5);
        //rmRiverAddShallow(northRiver, rmRandFloat(0.15, 0.25));
        //rmRiverAddShallow(northRiver, rmRandFloat(0.45, 0.55));
		rmRiverAddShallow(northRiver, rmRandFloat(0.5, 0.5));
        //rmRiverAddShallow(northRiver, rmRandFloat(0.75, 0.85));
        rmRiverSetBankNoiseParams(northRiver, 0.07, 2, 15.0, 15.0, 0.667, 1.8);
        rmRiverBuild(northRiver);
		//rmRiverReveal(northRiver, 2); 
		
		
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE SOUTH RIVER: ************************************* //
/*================================================================================================================*/

        //int southRiver = rmRiverCreate(-1, "Amazon River", 5, 5, 10, 10);
		int southRiver = rmRiverCreate(-1, "new england lake", 2, 2, 9, 9);
		//rmRiverSetConnections(southRiver, 0.0, 0.5, 0.5, 0.0);
		
		float river2XLoc = 0;
        float river2YLoc = 0;
		
		rmRiverAddWaypoint(southRiver, 0.00, 0.5);
        rmRiverAddWaypoint(southRiver, .25, .25);
        river2XLoc = .25;
        river2YLoc = .25;
        rmRiverAddWaypoint(southRiver, 0.5, 0.0);
		
		rmRiverSetShallowRadius(southRiver, 7.5);
        //rmRiverAddShallow(southRiver, rmRandFloat(0.15, 0.25));
        //rmRiverAddShallow(southRiver, rmRandFloat(0.45, 0.55));
		rmRiverAddShallow(southRiver, rmRandFloat(0.5, 0.5));
        //rmRiverAddShallow(southRiver, rmRandFloat(0.75, 0.85));
        rmRiverSetBankNoiseParams(southRiver, 0.07, 2, 15.0, 15.0, 0.667, 1.8);
        rmRiverBuild(southRiver);
		//rmRiverReveal(southRiver, 2); 
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE CENTRAL POND: ************************************* //
/*================================================================================================================*/		

        int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 30.0);
        int pondCloseConstraint=rmCreateClassDistanceConstraint("close avoid ponds", rmClassID("pond"), 15.0);
		int pondVeryCloseConstraint=rmCreateClassDistanceConstraint("very close avoid ponds", rmClassID("pond"), 8.0);
       	int pondFarConstraint=rmCreateClassDistanceConstraint("far avoid ponds", rmClassID("pond"), 80.0);
        int pondVeryFarConstraint=rmCreateClassDistanceConstraint("super far avoid ponds", rmClassID("pond"), 100.0);
   
        int smallPondID=rmCreateArea("small pond");
        //rmSetAreaSize(smallPondID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(750));
		rmSetAreaSize(smallPondID, 0.045, 0.045);
        rmSetAreaWaterType(smallPondID, "new england lake");
        rmSetAreaBaseHeight(smallPondID, 1);
        rmAddAreaToClass(smallPondID, pondClass);
        rmSetAreaCoherence(smallPondID, 0.65);
        rmSetAreaSmoothDistance(smallPondID, 5);
        //rmAddAreaConstraint(smallPondID, pondVeryFarConstraint);
        rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.5, 0.5); 
        rmBuildArea(smallPondID);
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE WEST CLIFF: *************************************** //
/*================================================================================================================*/

        int startingCliff1=rmCreateArea("Plateau 1");
        rmSetAreaSize(startingCliff1, .0175, .0175);
        rmSetAreaLocation(startingCliff1, .275, .725);
        rmSetAreaWarnFailure(startingCliff1, false);
        rmSetAreaSmoothDistance(startingCliff1, 10);
        rmSetAreaCoherence(startingCliff1, .6);
        rmSetAreaCliffType(startingCliff1, "New England");
		rmAddAreaToClass(startingCliff1, rmClassID("classCliff"));
        rmSetAreaCliffEdge(startingCliff1, 6, .14, 0, 1.0, 0);
  		
        if(cNumberTeams == 2) 
        rmSetAreaCliffHeight(startingCliff1, 8, 2.0, 0.5);

        else
        rmSetAreaCliffHeight(startingCliff1, 2.0, 8, 0.5);
    
        rmSetAreaTerrainType(startingCliff1, "new_england\ground1_ne");
        rmSetAreaMix(startingCliff1, "newengland_grass");
        //rmAddAreaConstraint(startingCliff1, avoidWater10);
        rmBuildArea(startingCliff1);  		
		
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE EAST CLIFF: **************************************** //
/*================================================================================================================*/

        int startingCliff2=rmCreateArea("Plateau 2");
        rmSetAreaSize(startingCliff2, .0175, .0175);
        rmSetAreaLocation(startingCliff2, .725, .275);
        rmSetAreaWarnFailure(startingCliff2, false);
        rmSetAreaSmoothDistance(startingCliff2, 10);
        rmSetAreaCoherence(startingCliff2, .6);
        rmSetAreaCliffType(startingCliff2, "New England");
		rmAddAreaToClass(startingCliff2, rmClassID("classCliff"));
        rmSetAreaCliffEdge(startingCliff2, 6, .14, 0, 1.0, 0);
  		
        if(cNumberTeams == 2) 
        rmSetAreaCliffHeight(startingCliff2, 8, 2.0, 0.5);

        else
        rmSetAreaCliffHeight(startingCliff2, 2.0, 8, 0.5);
    
        rmSetAreaTerrainType(startingCliff2, "new_england\ground1_ne");
        rmSetAreaMix(startingCliff2, "newengland_grass");
		//rmAddAreaConstraint(startingCliff2, avoidWater10);
        rmBuildArea(startingCliff2);
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.50);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE NORTH TRADE ROUTE: *********************************** //
/*================================================================================================================*/

        // SOCKET DEFINITION 1:
	    int socketID=rmCreateObjectDef("sockets 1");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 1:
		int tradeRoute1ID = rmCreateTradeRoute();
	    
		//rmAddTradeRouteWaypoint(tradeRoute1ID, 0.525, 0.775);
		//rmAddTradeRouteWaypoint(tradeRoute1ID, 0.775, 0.525);
		
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.675, 0.925);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.925, 0.675);
	
	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

/*----------------------------------------------------------------------------------------------------------------*/		

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.975);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
/*===============================================================================================================*/
// ********************************* DEFINE AND PLACE THE SOUTH TRADE ROUTE: ************************************ //
/*================================================================================================================*/

        // SOCKET DEFINITION 2:
	    int socket2ID=rmCreateObjectDef("sockets 2");
	    rmAddObjectDefItem(socket2ID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socket2ID, true);
		rmAddObjectDefToClass(socket2ID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socket2ID, 0.0);
	    rmSetObjectDefMaxDistance(socket2ID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// TRADE ROUTE 2:
		int tradeRoute2ID = rmCreateTradeRoute();
	    
		//rmAddTradeRouteWaypoint(tradeRoute2ID, 0.225, 0.475);
		//rmAddTradeRouteWaypoint(tradeRoute2ID, 0.475, 0.225);
		
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.075, 0.325);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.325, 0.075);
	
	    bool placedTradeRoute2 = rmBuildTradeRoute(tradeRoute2ID, "dirt");
	    if(placedTradeRoute2 == false)
		rmEchoError("Failed to place trade route one");

/*----------------------------------------------------------------------------------------------------------------*/		

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);
	    vector socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);

	    socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.975);
	    rmPlaceObjectDefAtPoint(socket2ID, 0, socketLoc2);

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.55);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************** //		
/*================================================================================================================*/

        int randomNative1 = rmRandInt(1,3);
        int randomNative2 = rmRandInt(1,3);
  
        string nativeString1 = "native cherokee village ";
        string nativeString2 = "native cree village ";
        string nativeString3 = "native iroquois village ";
  
        string stringNative1 = "";
        string stringNative2 = "";
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        if(randomNative1 == 1)
        stringNative1 = nativeString1;
  
        else if (randomNative1 == 2)
        stringNative1 = nativeString2;
  
        else
        stringNative1 = nativeString3;
		
/*----------------------------------------------------------------------------------------------------------------*/		
    
        if(randomNative2 == 1)
        stringNative2 = nativeString1;
  
        else if (randomNative2 == 2)
        stringNative2 = nativeString2;
  
        else
        stringNative2 = nativeString3;
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
  
        if (subCiv0 == rmGetCivID("cherokee"))
{  
        int cherokeeVillageAID = -1;
        int cherokeeVillageType = rmRandInt(1,5);
        cherokeeVillageAID = rmCreateGrouping("cherokee village A", stringNative1+cherokeeVillageType);
        rmSetGroupingMinDistance(cherokeeVillageAID, 0.0);
        rmSetGroupingMaxDistance(cherokeeVillageAID, 10.0);
		rmAddGroupingToClass(cherokeeVillageAID, rmClassID("natives"));
        //rmAddGroupingConstraint(cherokeeVillageAID, avoidNatives);
            
        if(cNumberTeams <= 2) 
	{
        if(whichVersion == 1)
        rmPlaceGroupingAtLoc(cherokeeVillageAID, 0, 0.275, 0.725); 
    
        else
        rmPlaceGroupingAtLoc(cherokeeVillageAID, 0, 0.725, 0.275);
    }
    
        else
	{
        rmPlaceGroupingAtLoc(cherokeeVillageAID, 0, 0.275, 0.725);
    }
}
/*----------------------------------------------------------------------------------------------------------------*/
    
        if (subCiv1 == rmGetCivID("cree")) 
{   
        int creeVillageAID = -1;
        int creeVillageType = rmRandInt(1,5);
        creeVillageAID = rmCreateGrouping("cree village A", stringNative2+creeVillageType);
        rmSetGroupingMinDistance(creeVillageAID, 0.0);
        rmSetGroupingMaxDistance(creeVillageAID, 10.0);
        rmAddGroupingToClass(creeVillageAID, rmClassID("natives"));
        //rmAddGroupingConstraint(creeVillageAID, avoidNatives);
      
        if(cNumberTeams <= 2) 
	{
        if(whichVersion == 1)
        rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.725, 0.275);  
      
        else
        rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.275, 0.725);
	} 
    
        else 
	{
        rmPlaceGroupingAtLoc(creeVillageAID, 0, 0.725, 0.275);
    } 
}	
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************** DEFINE THE TCID AND THE STARTING UNITS AND THE PLAYER RESOURCES: ********************** //
/*================================================================================================================*/

	    rmClearClosestPointConstraints();
		
/*----------------------------------------------------------------------------------------------------------------*/
	
	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
		rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefConstraint(startingUnits, avoidCloseStartingUnits);
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
	    // DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
}
	    else 
{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
}

        
		rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 5.0);
		rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));

	    //rmAddObjectDefConstraint(TCID, playerEdgeConstraint);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player mine");
	    rmAddObjectDefItem(playerSilverID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(playerSilverID, 12.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 16.0);
		rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(playerSilverID, avoidGold);
		rmAddObjectDefConstraint(playerSilverID, avoidCloseStartingUnits);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", 4, 4.0);
        rmSetObjectDefMinDistance(playerBerryID, 14);
        rmSetObjectDefMaxDistance(playerBerryID, 18);
		rmAddObjectDefToClass(playerBerryID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(playerBerryID, avoidFruits);
        rmAddObjectDefConstraint(playerBerryID, avoidCloseStartingUnits);

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE PLAYER CRATE:
		int playerCrateID=rmCreateObjectDef("bonus starting crates");
        rmAddObjectDefItem(playerCrateID, "crateOfFood", 3, 7.0);
        rmAddObjectDefItem(playerCrateID, "crateOfWood", 2, 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfCoin", 2, 4.0);
        rmSetObjectDefMinDistance(playerCrateID, 16);
        rmSetObjectDefMaxDistance(playerCrateID, 20);
		rmAddObjectDefToClass(playerCrateID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(playerCrateID, avoidCloseStartingUnits);

/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE PLAYER FOOD:
		int playerFoodID=rmCreateObjectDef("player deer");
        rmAddObjectDefItem(playerFoodID, "deer", 8, 6.0);
        rmAddObjectDefToClass(playerFoodID, rmClassID("FoodClass"));
		rmAddObjectDefToClass(playerFoodID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerFoodID, 18);
        rmSetObjectDefMaxDistance(playerFoodID, 22);
		rmSetObjectDefCreateHerd(playerFoodID, false);
	    rmAddObjectDefConstraint(playerFoodID, avoidAll);
        rmAddObjectDefConstraint(playerFoodID, avoidFood);
        rmAddObjectDefConstraint(playerFoodID, avoidCloseStartingUnits);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int playerNuggetID=rmCreateObjectDef("player nugget");
        rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
        rmSetObjectDefMinDistance(playerNuggetID, 16.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 22.0);
		rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmAddObjectDefConstraint(playerNuggetID, avoidMediumNugget);
        rmAddObjectDefConstraint(playerNuggetID, avoidCloseStartingUnits);

/*----------------------------------------------------------------------------------------------------------------*/

        int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeNewEngland", 7, 9);
		rmAddObjectDefToClass(playerTreeID, rmClassID("classTrees"));
        rmSetObjectDefMinDistance(playerTreeID, 26);
        rmSetObjectDefMaxDistance(playerTreeID, 36);
	    rmAddObjectDefConstraint(playerTreeID, avoidMediumTrees);
        rmAddObjectDefConstraint(playerTreeID, avoidCloseStartingUnits);
		        	
/*----------------------------------------------------------------------------------------------------------------*/

        //WATER HC ARRIVAL POINT:
        int waterFlagID = 0;
        for(i=1; <cNumberPlayers)
    {
        waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
	}			
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/
// ********************* PLACE THE TCID AND THE STARTING UNITS AND THE PLAYER RESOURCES: *********************** //
/*================================================================================================================*/

	    for(i=1; <cNumberPlayers)

{
	    // PLACE THE TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
				
	    // PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	  
	    // PLACE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	 	rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	 		
		// PLACE PLAYER BERRY:
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// PLACE PLAYER CRATE:
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
   		
		// PLACE PLAYER FOOD:
		rmPlaceObjectDefAtLoc(playerFoodID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		// PLACE PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
    		
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
   	
		// PLACE THE WATER FLAG:
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	    rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
 
 }
  
        rmClearClosestPointConstraints();
  
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.65);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NORTHERN FOREST: ************************************ //
/*================================================================================================================*/

        if (cNumberNonGaiaPlayers <=2)
		int numTries=6*cNumberNonGaiaPlayers;
	    else
		numTries=4*cNumberNonGaiaPlayers;
		
        int failCount=0;
  
        for (i=0; <numTries)

{   
        int forest=rmCreateArea("foresta"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(275), rmAreaTilesToFraction(350));
        rmSetAreaForestType(forest, "new england forest");
        rmSetAreaForestDensity(forest, 0.75);
        rmSetAreaForestClumpiness(forest, 0.4);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaCoherence(forest, 0.7);
        rmAddAreaToClass(forest, rmClassID("classForest"));
        
		rmAddAreaConstraint(forest, forestMediumConstraint);
        rmAddAreaConstraint(forest, playerCloseConstraint);
		rmAddAreaConstraint(forest, playerCloseEdgeConstraint); 
        rmAddAreaConstraint(forest, avoidCloseCliff);
        rmAddAreaConstraint(forest, avoidWater10);
		rmAddAreaConstraint(forest, Northward);
        rmAddAreaConstraint(forest, avoidCloseSocket); 
        rmAddAreaConstraint(forest, avoidVeryCloseTradeRoute);

        if(rmBuildArea(forest)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==3)
        break;
    }
        else
        failCount=0; 
} 

/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE SOUTHERN FOREST: ************************************** //
/*================================================================================================================*/

        if (cNumberNonGaiaPlayers <=2)
		numTries=8*cNumberNonGaiaPlayers;
	    else
		numTries=4*cNumberNonGaiaPlayers;
		
		failCount=0;
  
        for (i=0; <numTries)
{   
        int outerForest=rmCreateArea("forestb"+i);
        rmSetAreaWarnFailure(outerForest, false);
        rmSetAreaSize(outerForest, rmAreaTilesToFraction(275), rmAreaTilesToFraction(350));
        rmSetAreaForestType(outerForest, "new england forest");
        rmSetAreaForestDensity(outerForest, 0.75);
        rmSetAreaForestClumpiness(outerForest, 0.45);
        rmSetAreaForestUnderbrush(outerForest, 0.0);
        rmSetAreaCoherence(outerForest, 0.5);
        rmAddAreaToClass(outerForest, rmClassID("classForest"));
        
		rmAddAreaConstraint(outerForest, forestMediumConstraint);
        rmAddAreaConstraint(outerForest, playerCloseConstraint);
        rmAddAreaConstraint(outerForest, avoidCloseCliff);
        rmAddAreaConstraint(outerForest, avoidWater10); 
		rmAddAreaConstraint(outerForest, Southward); 
        rmAddAreaConstraint(outerForest, playerCloseEdgeConstraint); 
        rmAddAreaConstraint(outerForest, avoidVeryCloseTradeRoute);
        rmAddAreaConstraint(outerForest, avoidCloseSocket);

        if(rmBuildArea(outerForest)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==3)
        break;
    }
        else
        failCount=0; 
} 
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.65);
/*================================================================================================================*/
        
		int nuggetID= rmCreateObjectDef("The Northern Nugget" ); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggetID, avoidCloseCliff);
		rmAddObjectDefConstraint(nuggetID, avoidWater10);
  	    rmAddObjectDefConstraint(nuggetID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nuggetID, playerCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggetID, Northward);
		rmAddObjectDefConstraint(nuggetID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(nuggetID, avoidCloseSocket);
				
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);

/*----------------------------------------------------------------------------------------------------------------*/

        int nugget2ID= rmCreateObjectDef("The Southern Nugget" ); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nugget2ID, avoidFarNugget);
		rmAddObjectDefConstraint(nugget2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nugget2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(nugget2ID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(nugget2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(nugget2ID, Southward);
		rmAddObjectDefConstraint(nugget2ID, avoidWater10);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.70);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NORTHERN SILVER: ************************************ //
/*================================================================================================================*/
 
	    // THE NORTHERN SILVER:
		int silverType = rmRandInt(1,10);   
	    int silverID = -1;
		
		if (cNumberNonGaiaPlayers <= 2)
        int silverCount = cNumberNonGaiaPlayers*4;	
		else
		silverCount = cNumberNonGaiaPlayers*2;	
	    
		rmEchoInfo("silver count = "+silverCount);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
        for(i=0; < silverCount)
		
	{	
	    int SilverID = rmCreateObjectDef("silver "+i);
        rmAddObjectDefItem(SilverID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(SilverID, 0.0);
        rmSetObjectDefMaxDistance(SilverID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(SilverID, forestCloseConstraint);
        rmAddObjectDefConstraint(SilverID, avoidFarCoin);    
        rmAddObjectDefConstraint(SilverID, avoidNugget);
        rmAddObjectDefConstraint(SilverID, playerEdgeConstraint);
        rmAddObjectDefConstraint(SilverID, avoidWater10);
        rmAddObjectDefConstraint(SilverID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(SilverID, avoidCloseSocket);
		rmAddObjectDefConstraint(SilverID, avoidCloseCliff);
		rmAddObjectDefConstraint(SilverID, Northward);
        rmAddObjectDefConstraint(SilverID, playerCloseConstraint);
		
		rmPlaceObjectDefAtLoc(SilverID, 0, 0.5, 0.5);
    }  

/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SOUTHERN SILVER: ************************************* //
/*================================================================================================================*/	
	
        // THE SOUTHERN SILVER:
		for(i=0; < silverCount)
	{
		int Silver2ID = rmCreateObjectDef("silver 2"+i);
		rmAddObjectDefItem(Silver2ID, "mine", 1, 0);
		rmSetObjectDefMinDistance(Silver2ID, 0.0);
		rmSetObjectDefMaxDistance(Silver2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Silver2ID, forestCloseConstraint);
        rmAddObjectDefConstraint(Silver2ID, avoidFarCoin);    
        rmAddObjectDefConstraint(Silver2ID, avoidNugget);
        rmAddObjectDefConstraint(Silver2ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(Silver2ID, avoidWater10);
        rmAddObjectDefConstraint(Silver2ID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(Silver2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(Silver2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(Silver2ID, Southward);
        rmAddObjectDefConstraint(Silver2ID, playerCloseConstraint);     
		
		rmPlaceObjectDefAtLoc(Silver2ID, 0, 0.5, 0.5);
	}		
  
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.75);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NORTHERN DEER HERDS: ********************************** //
/*================================================================================================================*/

        int foodCount = rmRandInt(6,8);

        int foodID=rmCreateObjectDef("deer 1");
        rmAddObjectDefItem(foodID, "deer", foodCount, 6.0);
        rmAddObjectDefToClass(foodID, foodClass);
        rmSetObjectDefMinDistance(foodID, 0.0);
        rmSetObjectDefMaxDistance(foodID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(foodID, forestCloseConstraint);
        rmAddObjectDefConstraint(foodID, playerCloseConstraint);
        rmAddObjectDefConstraint(foodID, avoidFarFood);
        rmAddObjectDefConstraint(foodID, avoidCloseCoin);
        rmAddObjectDefConstraint(foodID, avoidNugget);
        rmAddObjectDefConstraint(foodID, playerEdgeConstraint);
        rmAddObjectDefConstraint(foodID, avoidWater10);
        rmAddObjectDefConstraint(foodID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(foodID, avoidCloseSocket);
		rmAddObjectDefConstraint(foodID, avoidCloseCliff);
		rmAddObjectDefConstraint(foodID, Northward);
         		
        
		rmSetObjectDefCreateHerd(foodID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(foodID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
		else
		rmPlaceObjectDefAtLoc(foodID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SOUTHERN DEER HERDS: ********************************* //
/*================================================================================================================*/

	    foodCount = rmRandInt(6,8);

        int food2ID=rmCreateObjectDef("deer 2");
        rmAddObjectDefItem(food2ID, "deer", foodCount, 6.0);
        rmAddObjectDefToClass(food2ID, foodClass);
        rmSetObjectDefMinDistance(food2ID, 0.0);
        rmSetObjectDefMaxDistance(food2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(food2ID, forestCloseConstraint);
        rmAddObjectDefConstraint(food2ID, playerCloseConstraint);
        rmAddObjectDefConstraint(food2ID, avoidFarFood);
        rmAddObjectDefConstraint(food2ID, avoidCloseCoin);
        rmAddObjectDefConstraint(food2ID, avoidNugget);
        rmAddObjectDefConstraint(food2ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(food2ID, avoidWater10);
        rmAddObjectDefConstraint(food2ID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(food2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(food2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(food2ID, Southward);
         		
        
		rmSetObjectDefCreateHerd(food2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(food2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
		else
		rmPlaceObjectDefAtLoc(food2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);	
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NORTHERN MOOSE HERDS: ********************************* //
/*================================================================================================================*/

        foodCount = rmRandInt(2,2);
  
        int food3ID=rmCreateObjectDef("moose 1");
        rmAddObjectDefItem(food3ID, "moose", foodCount, 3.0);
        rmAddObjectDefToClass(food3ID, foodClass);
        rmSetObjectDefMinDistance(food3ID, 0.0);
        rmSetObjectDefMaxDistance(food3ID, rmXFractionToMeters(0.5));
        
		
        rmAddObjectDefConstraint(food3ID, avoidFarMoose);
		rmAddObjectDefConstraint(food3ID, forestCloseConstraint);
        rmAddObjectDefConstraint(food3ID, playerCloseConstraint);
        rmAddObjectDefConstraint(food3ID, avoidFarFood);
        rmAddObjectDefConstraint(food3ID, avoidCloseCoin);
        rmAddObjectDefConstraint(food3ID, avoidNugget);
        rmAddObjectDefConstraint(food3ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(food3ID, avoidWater10);
        rmAddObjectDefConstraint(food3ID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(food3ID, avoidCloseSocket);
		rmAddObjectDefConstraint(food3ID, avoidCloseCliff);
		rmAddObjectDefConstraint(food3ID, Northward);
        
		rmSetObjectDefCreateHerd(food3ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(food3ID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(food3ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);

/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE SOUTHERN MOOSE HERDS: ********************************** //
/*================================================================================================================*/

        foodCount = rmRandInt(2,2);
  
        int food4ID=rmCreateObjectDef("moose 2");
        rmAddObjectDefItem(food4ID, "moose", foodCount, 3.0);
        rmAddObjectDefToClass(food4ID, foodClass);
        rmSetObjectDefMinDistance(food4ID, 0.0);
        rmSetObjectDefMaxDistance(food4ID, rmXFractionToMeters(0.5));
        
		
        rmAddObjectDefConstraint(food4ID, avoidFarMoose);
		rmAddObjectDefConstraint(food4ID, forestCloseConstraint);
        rmAddObjectDefConstraint(food4ID, playerCloseConstraint);
        rmAddObjectDefConstraint(food4ID, avoidFarFood);
        rmAddObjectDefConstraint(food4ID, avoidCloseCoin);
        rmAddObjectDefConstraint(food4ID, avoidNugget);
        rmAddObjectDefConstraint(food4ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(food4ID, avoidWater10);
        rmAddObjectDefConstraint(food4ID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(food4ID, avoidCloseSocket);
		rmAddObjectDefConstraint(food4ID, avoidCloseCliff);
		rmAddObjectDefConstraint(food4ID, Southward);
        
		rmSetObjectDefCreateHerd(food4ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(food4ID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(food4ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.85);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NORTHERN BERRYBUSH: *********************************** //		
/*================================================================================================================*/

        int berriesID=rmCreateObjectDef("berries 1");
	    rmAddObjectDefItem(berriesID, "berrybush", 4, 3.0);
	    rmSetObjectDefMinDistance(berriesID, 0);
	    rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(berriesID, avoidFarBerries);
		rmAddObjectDefConstraint(berriesID, avoidCloseMoose);
		rmAddObjectDefConstraint(berriesID, forestCloseConstraint);
        rmAddObjectDefConstraint(berriesID, playerCloseConstraint);
        rmAddObjectDefConstraint(berriesID, avoidCloseFood);
        rmAddObjectDefConstraint(berriesID, avoidCoin);
        rmAddObjectDefConstraint(berriesID, avoidNugget);
        rmAddObjectDefConstraint(berriesID, playerEdgeConstraint);
        rmAddObjectDefConstraint(berriesID, avoidWater10);
        rmAddObjectDefConstraint(berriesID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(berriesID, avoidCloseSocket);
		rmAddObjectDefConstraint(berriesID, avoidCloseCliff);
		rmAddObjectDefConstraint(berriesID, Northward);
        
		rmSetObjectDefCreateHerd(berriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);   
		else
		rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2); 

/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE SOUTHERN BERRYBUSH: *********************************** //		
/*================================================================================================================*/

        int berries2ID=rmCreateObjectDef("berries 2");
	    rmAddObjectDefItem(berries2ID, "berrybush", 4, 3.0);
	    rmSetObjectDefMinDistance(berries2ID, 0);
	    rmSetObjectDefMaxDistance(berries2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(berries2ID, avoidFarBerries);
		rmAddObjectDefConstraint(berries2ID, avoidCloseMoose);
		rmAddObjectDefConstraint(berries2ID, forestCloseConstraint);
        rmAddObjectDefConstraint(berries2ID, playerCloseConstraint);
        rmAddObjectDefConstraint(berries2ID, avoidCloseFood);
        rmAddObjectDefConstraint(berries2ID, avoidCoin);
        rmAddObjectDefConstraint(berries2ID, avoidNugget);
        rmAddObjectDefConstraint(berries2ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(berries2ID, avoidWater10);
        rmAddObjectDefConstraint(berries2ID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(berries2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(berries2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(berries2ID, Southward);
        
		rmSetObjectDefCreateHerd(berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);   
		else
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.90);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE NORTHERN SHEEP HERDS: ********************************** //
/*================================================================================================================*/

        int sheepID=rmCreateObjectDef("sheep herds 1");
	    rmAddObjectDefItem(sheepID, "sheep", 4, 3.0);
	    rmSetObjectDefMinDistance(sheepID, 0);
	    rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(sheepID, avoidFarSheep);
		rmAddObjectDefConstraint(sheepID, avoidBerries);
		rmAddObjectDefConstraint(sheepID, avoidCloseMoose);
		rmAddObjectDefConstraint(sheepID, forestCloseConstraint);
        rmAddObjectDefConstraint(sheepID, playerCloseConstraint);
        rmAddObjectDefConstraint(sheepID, avoidCloseFood);
        rmAddObjectDefConstraint(sheepID, avoidCoin);
        rmAddObjectDefConstraint(sheepID, avoidNugget);
        rmAddObjectDefConstraint(sheepID, playerEdgeConstraint);
        rmAddObjectDefConstraint(sheepID, avoidWater10);
        rmAddObjectDefConstraint(sheepID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(sheepID, avoidCloseSocket);
		rmAddObjectDefConstraint(sheepID, avoidCloseCliff);
		rmAddObjectDefConstraint(sheepID, Northward);
        
		rmSetObjectDefCreateHerd(sheepID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);   
		else
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5); 

/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE SOUTHERN SHEEP HERDS: ********************************* //
/*================================================================================================================*/

        int sheep2ID=rmCreateObjectDef("sheep herds 2");
	    rmAddObjectDefItem(sheep2ID, "sheep", 4, 3.0);
	    rmSetObjectDefMinDistance(sheep2ID, 0);
	    rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(sheep2ID, avoidFarSheep);
		rmAddObjectDefConstraint(sheep2ID, avoidBerries);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseMoose);
		rmAddObjectDefConstraint(sheep2ID, forestCloseConstraint);
        rmAddObjectDefConstraint(sheep2ID, playerCloseConstraint);
        rmAddObjectDefConstraint(sheep2ID, avoidCloseFood);
        rmAddObjectDefConstraint(sheep2ID, avoidCoin);
        rmAddObjectDefConstraint(sheep2ID, avoidNugget);
        rmAddObjectDefConstraint(sheep2ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(sheep2ID, avoidWater10);
        rmAddObjectDefConstraint(sheep2ID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(sheep2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(sheep2ID, Southward);
        
		rmSetObjectDefCreateHerd(sheep2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);   
		else
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);		
        
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE RANDOM NORTHERN TREES:
		int randomTreeID=rmCreateObjectDef("The Random Northern Trees");
		rmAddObjectDefItem(randomTreeID, "TreeNewEngland", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseSheep);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseBerries);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseMoose);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
        rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
        rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseFood);
        rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseCoin);
        rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseNugget);
        rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint);
        rmAddObjectDefConstraint(randomTreeID, avoidWater10);
        rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseTradeRoute);
        rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCliff);
		rmAddObjectDefConstraint(randomTreeID, Northward);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.96);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FISHSALMON: *************************************** //
/*================================================================================================================*/
   
        // THE NORTHERN FISHES:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        //rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.20));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
				
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*15.0);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*7.5);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/

















