/*===============================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: ********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

// THE LOST COUNTRY:
// CREATED BY DANY:
// SEPTEMBER 2007:
// THIS IS MY 71TH RMS MAP FOR AGE OF EMPIRE III: 

/*===============================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/
// *********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ******************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
		
/*---------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(5) == true)
   {
		subCiv0=rmGetCivID("Cree");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cree");

		subCiv1=rmGetCivID("Cree");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cree"); 

		subCiv2=rmGetCivID("Cree");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cree");

		subCiv3=rmGetCivID("Cree");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cree");

		subCiv4=rmGetCivID("Cree");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Cree");
		
   }	
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************* //  
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int playerTiles=17500;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/
// ***************************************** PICKS THE MAP PARAMETERS: ***************************************** //   
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(0.0);
		
		// SET SEA TYPE:
		rmSetSeaType("Amazon River");

        // SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.02, 3, 0.5, 8.0);
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("sonora_dirt");
		    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("sonora\ground2_son", 12.0);
			    
		// SET LIGHTING:
		rmSetLightingSet("Sonora");
			    
		// SET MAP TYPE:
		rmSetMapType("sonora");
	    rmSetMapType("grass");
	    rmSetMapType("land");
				
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
		chooseMercs();
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classPatch");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("classCotton");
        rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("nuggets");
	    rmDefineClass("classHillArea");
	    rmDefineClass("classSmallHillArea");
	    rmDefineClass("socketClass");
	    rmDefineClass("classCliff");
		rmDefineClass("bay");
		int canyon=rmDefineClass("canyon");
		rmDefineClass("natives");
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/
// ******************************************* DEFINE THE CONSTRAINTS: ***************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*===============================================================================================================*/
   
        // MAP EDGE CONSTRAINTS:
	    int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	    int silverEdgeConstraint=rmCreateBoxConstraint("silver edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
	    // int forestEdgeConstraint=rmCreateBoxConstraint("forest edge of map", rmXTilesToFraction(30), rmZTilesToFraction(30), 1.0-rmXTilesToFraction(30), 1.0-rmZTilesToFraction(30), 0.01);
	    // int forestEdgeConstraint=rmCreatePieConstraint("forest edge of map", 0.5, 0.5, 0, 50, 0, 360, 0.01);
	    int forestEdgeConstraint=rmCreatePieConstraint("forest edge of map", 0.5, 0.5, 0, rmGetMapXSize()-30, 0, 0, 0);
	
	    // New extra stuff for water spawn point avoidance.
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

		// CANYONS AVOIDANCE:
		int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 35.0);
	    int avoidCloseCanyons=rmCreateClassDistanceConstraint("close avoid canyons", rmClassID("canyon"), 2.0);
	    int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
	    int veryShortAvoidCanyons=rmCreateClassDistanceConstraint("very short avoid canyons", rmClassID("canyon"), 4.0);
		
		// PLAYER CONSTRAINTS:
	    int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 20.0);
		int playerCloseConstraint=rmCreateClassDistanceConstraint("close player vs. player", classPlayer, 10.0);
		
		// FISH AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 15.0);
		int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        
        // RESOURCE AVOIDANCE:
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. things", rmClassID("classForest"), 2.0);
        int forestVsForestConstraint=rmCreateClassDistanceConstraint("forest vs. other forests", rmClassID("classForest"), 20.0);
	    if ( cNumberNonGaiaPlayers < 3 )
	{
		forestVsForestConstraint=rmCreateClassDistanceConstraint("forest vs. other forests smaller", rmClassID("classForest"), 10.0);
	}
	    int cottonConstraint=rmCreateClassDistanceConstraint("cotton vs. cotton", rmClassID("classCotton"), 40.0);
	    int otherCottonConstraint=rmCreateClassDistanceConstraint("other things vs. cotton", rmClassID("classCotton"), 5.0);
	    int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 15.0);
	    int avoidBison=rmCreateTypeDistanceConstraint("bison avoids food", "bison", 70.0);
	    int avoidBighorn=rmCreateTypeDistanceConstraint("bighorn avoids food", "bighornsheep", 40.0);
	    int avoidPronghorn=rmCreateTypeDistanceConstraint("pronghorn avoids food", "pronghorn", 32.0);
	    int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.10));
	    
		// COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoids coin", "gold", 15.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close stuff avoids coin", "gold", 2.0);
		int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium stuff avoids coin", "gold", 25.0);
	    int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 60.0);
		
		int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoid Trees", "TreeSonora", 10.0);
		int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoid Trees", "TreeSonora", 2.0);
		int avoidMediumTrees=rmCreateTypeDistanceConstraint("medium avoid Trees", "TreeSonora", 25.0);
		int avoidFarTrees=rmCreateTypeDistanceConstraint("far avoid Trees", "TreeSonora", 50.0);
		int avoidVeryFarTrees=rmCreateTypeDistanceConstraint("very far avoid Trees", "TreeSonora", 75.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 2.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid fruits", "berrybush", 25.0);
		int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid fruits", "berrybush", 50.0);
		int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoid fruits", "berrybush", 75.0);
			    
		// NUGGET AVOIDANCE:
		//int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 10.0);
        //int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 5.0);
        //int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium avoid nugget", "AbstractNugget", 25.0);
        //int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 50.0);
        //int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far avoid nugget", "AbstractNugget", 75.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 15.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoids deer", "deer", 25.0);
		int avoidFarDeer=rmCreateTypeDistanceConstraint("far avoids deer", "deer", 50.0);
		int avoidVeryFarDeer=rmCreateTypeDistanceConstraint("very far avoids deer", "deer", 75.0);
		
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 15.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 2.0);
		int avoidMediumSheep=rmCreateTypeDistanceConstraint("medium avoids sheep", "sheep", 25.0);
		int avoidFarSheep=rmCreateTypeDistanceConstraint("far avoids sheep", "sheep", 50.0);
		int avoidVeryFarSheep=rmCreateTypeDistanceConstraint("very far avoids sheep", "sheep", 75.0);
	
        		
		// NUGGETS AVOIDANCE:
		int avoidNuggets=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 10.0);
		int avoidCloseNuggets=rmCreateClassDistanceConstraint("close avoids nuggets", rmClassID("nuggets"), 2.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 2.0);
		int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close avoids natives", rmClassID("natives"), 2.0);
		int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 25.0);
		int avoidFarNatives=rmCreateClassDistanceConstraint("far avoids natives", rmClassID("natives"), 50.0);
		int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far avoids natives", rmClassID("natives"), 75.0);
		
        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 5.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

        // UNIT AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 15.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 2.0);

        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
        
		// IMPORTANTITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 25.0);
	    int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close important stuff avoids each other", rmClassID("importantItem"), 2.0);
	    int avoidImportantItemForest=rmCreateClassDistanceConstraint("important stuff avoids each forest", rmClassID("importantItem"), 10.0);

	    // SOCKET AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 10.0);
		int avoidCloseSocket=rmCreateClassDistanceConstraint("close socket avoidance", rmClassID("socketClass"), 2.0);

        // CONSTRAINT TO AVOID WATER:
        int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
        int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

	    // AVOID THE HILLY AREAS:
	    int avoidHills = rmCreateClassDistanceConstraint("avoid Hills", rmClassID("classHillArea"), 5.0);
	    int avoidHillsLarge = rmCreateClassDistanceConstraint("avoid Hills by a lot", rmClassID("classHillArea"), 20.0);
	    int avoidSmallHills = rmCreateClassDistanceConstraint("avoid Small Hills", rmClassID("classSmallHillArea"), 20.0);
	    int avoidSmallHillsSmall = rmCreateClassDistanceConstraint("avoid Small Hills by a little", rmClassID("classSmallHillArea"), 2.0);

	    // CLIFFS AVOIDANCE:
		int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 15.0);
        int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 2.0);
		int avoidMediumCliffs=rmCreateClassDistanceConstraint("medium vs. cliff", rmClassID("classCliff"), 25.0);
		int avoidFarCliffs=rmCreateClassDistanceConstraint("far vs. cliff", rmClassID("classCliff"), 50.0);
        int avoidVeryFarCliffs=rmCreateClassDistanceConstraint("very far vs. cliff", rmClassID("classCliff"), 75.0);
		
		
		// CARDINAL DIRECTIONS: - "HALVES" OF THE MAP:
	    int NWConstraint = rmCreateBoxConstraint("stay in NW portion", 0, 0.5, 1, 1);
	    int SEConstraint = rmCreateBoxConstraint("stay in SE portion", 0, 0, 1, 0.5);
	    int NEConstraint = rmCreateBoxConstraint("stay in NE portion", 0.5, 0, 1, 1);
	    int SWConstraint = rmCreateBoxConstraint("stay in SW portion", 0, 0, 0.5, 1);

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/
// *************************************** DEFINE SOME AREAS OF THE MAP: *************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // DEFINE AND PLACE THE BIG CONTINENT 1:
		// DAL TEMP: Big invisible continent, size 0.95, 0.95
        // Build up big continent called "big continent"
        int bigContinentID=rmCreateArea("big continent");
        //rmSetAreaSize(bigContinentID, 0.9, 0.9); // 3 35
		rmSetAreaSize(bigContinentID, 0.995, 0.995); // 3 35
        rmSetAreaWarnFailure(bigContinentID, false);
        // rmSetAreaSmoothDistance(bigContinentID, 10);
	        rmSetAreaMix(bigContinentID, "sonora_dirt");
        rmSetAreaCoherence(bigContinentID, 0.95);
        rmSetAreaLocation(bigContinentID, 0.5, 0.5);
		rmSetAreaCliffType(bigContinentID, "Sonora");
	    //rmSetAreaCliffType(bigContinentID, "rocky mountain edge");
	    rmSetAreaCliffEdge(bigContinentID, 1, 1.0, 0.0, 0.0, 0);
	    rmSetAreaCliffHeight(bigContinentID, -4, 1.0, 0.3);
	    rmSetAreaCliffPainting(bigContinentID, false, false, true);
	    rmAddAreaToClass(bigContinentID, rmClassID("classCliff"));
	    rmBuildArea(bigContinentID);

/*---------------------------------------------------------------------------------------------------------------*/		
        
		// DEFINE AND PLACE THE BIG CONTINENT 2:
		int bigContinent2ID=rmCreateArea("big continent 2");
        //rmSetAreaSize(bigContinent2ID, 0.64, 0.64); // 3 35
		rmSetAreaSize(bigContinent2ID, 0.275, 0.275); // 3 35
        rmSetAreaWarnFailure(bigContinent2ID, false);
        // rmSetAreaSmoothDistance(bigContinent2ID, 10);
	    rmSetAreaMix(bigContinent2ID, "rockies_snow");
        rmSetAreaCoherence(bigContinent2ID, 0.95);
        rmSetAreaLocation(bigContinent2ID, 0.5, 0.5);
		rmSetAreaCliffType(bigContinent2ID, "Sonora");
	    //rmSetAreaCliffType(bigContinent2ID, "rocky mountain edge");
	    //rmSetAreaCliffEdge(bigContinent2ID, 1, 1.0, 0.0, 0.0, 0);
		  rmSetAreaCliffEdge(bigContinent2ID, 2, 0.485, 0.1, 1.0, 0);
	    rmSetAreaCliffHeight(bigContinent2ID, -8, 1.0, 0.3);
	    rmSetAreaCliffPainting(bigContinent2ID, false, false, true);
	    rmAddAreaToClass(bigContinent2ID, rmClassID("classCliff"));
	    rmBuildArea(bigContinent2ID);
		
/*===============================================================================================================*/
// ***************************** DEFINE THE FUNCTION - ( rmSetAreaCliffEdge... ) ******************************* //
/*===============================================================================================================*/
/*        
		
		rmSetAreaCliffEdge(int areaID,     int count, float size, float variance, float spacing, int mapEdge);
        rmSetAreaCliffEdge(bigContinent2ID,    2,       0.4,        0.1,          1.0,                   0);
		
		// DEFINE THE INT COUNT:
		Count - Number of cliff edges to create. 
		
		// DEFINE THE FLOAT SIZE:
		The count times the size should not be more than 1.0. Defaults to 1. size - 
		This specifies how much of the area's outline should be turned into cliff edges. 
		It should be between 0.0 and 0.5. Set to 0.5 to make the whole area surrounded. 
		
		// DEFINE THE FLOAT VARIANCE:
		Defaults to 0.5. Variance - The variance to use for the size. Defaults to 0.0. 
		
		// DEFINE THE FLOAT SPACING:
		Spacing - Spacing modifier. 
		This should be between 0.0 and 1.0. 
		The smaller this is, the closer together the cliff edges will be. 
		
		// DEFINE THE INT MAPEDGE:
		Defaults to 1.0. MapEdge - Specifies where the cliff edge should be in relation to the map edge. 
		Set to 0 for any, 1 to be away from the map edge, or 2 to be close to the map edge. Defaults to 0.
		
*/	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/
// ************************************* SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.075, 0.175);
		rmPlacePlayersCircular(0.40, 0.40, 0);
		
		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.575, 0.675);
		rmPlacePlayersCircular(0.40, 0.40, 0);
	    	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/
// ******************************************* SET UP PLAYER AREAS:	******************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        float playerFraction=rmAreaTilesToFraction(100);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINTS:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
	    rmAddAreaConstraint(id, avoidTradeRoute);

        // SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, -4);		
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // REMOVED BY ENSEMBLE:
		// BUILD THE AREAS:
        //rmBuildAllAreas();
        
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/
// *********************************** DEFINE THE VARIABLES TO BE USED LATER: ********************************** //   
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    int numTries = -1;
	    int failCount = -1;
		
/*---------------------------------------------------------------------------------------------------------------*/
/*
        int whichMap=rmRandInt(1,2);
        if ( whichMap == 1 )
        {
        }
        else
        {
        }		
*/		
/*===============================================================================================================*/
        int whichMap=rmRandInt(1,2);
/*---------------------------------------------------------------------------------------------------------------*/
/*		
		if ( whichMap == 1 )  

    {            
		int bay1ID=rmCreateArea("Bay 1");
		rmSetAreaSize(bay1ID, rmAreaTilesToFraction(5750), rmAreaTilesToFraction(5750));
        //rmSetAreaSize(bay1ID, 0.25, 0.25);
	    rmSetAreaLocation(bay1ID, 0.5, 0.5);
	    rmSetAreaWaterType(bay1ID, "hudson bay");
        rmSetAreaBaseHeight(bay1ID, -4.0); 
        rmSetAreaMinBlobs(bay1ID, 1);
        rmSetAreaMaxBlobs(bay1ID, 1);
        rmSetAreaMinBlobDistance(bay1ID, 1);
        rmSetAreaMaxBlobDistance(bay1ID, 1);
        rmSetAreaSmoothDistance(bay1ID, 50);
        rmSetAreaCoherence(bay1ID, 0.85);
	    rmAddAreaToClass(bay1ID, rmClassID("bay"));
        rmSetAreaObeyWorldCircleConstraint(bay1ID, false);
	    rmBuildArea(bay1ID);
    }
*/		
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE THE CENTRAL POND: ************************************** //
/*===============================================================================================================*/
        
		if ( whichMap == 1 )  
	{    
		int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int smallPondID=rmCreateArea("small pond");
	
	
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(5750), rmAreaTilesToFraction(5750));
		rmSetAreaWaterType(smallPondID, "texas pond");
		rmSetAreaBaseHeight(smallPondID, -4.0);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.85);
		rmSetAreaSmoothDistance(smallPondID, 5);
		rmAddAreaConstraint(smallPondID, playerConstraint);
		rmAddAreaConstraint(smallPondID, avoidTradeRoute);
		rmAddAreaConstraint(smallPondID, avoidImportantItem);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.5, 0.5); 
		rmBuildArea(smallPondID);
	}	

/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE SMALL MESA: ************************************** //
/*===============================================================================================================*/

	    if ( whichMap == 2 )  
   {	
	           
        int smallMesaID=rmCreateArea("The Small Mesa");
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(4750), rmAreaTilesToFraction(4750));
        //rmSetAreaSize(smallMesaID, 0.05, 0.05);
		rmSetAreaLocation(smallMesaID, 0.5, 0.5); 
        rmSetAreaWarnFailure(smallMesaID, false);
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	
		
        		
		//rmSetAreaCliffType(smallMesaID, "Amazon");
		rmSetAreaCliffType(smallMesaID, "Texas");
		        
		//rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(smallMesaID, 2, 0.475, 0.1, 1.0, 0);
        rmSetAreaCliffPainting(smallMesaID, false, true, true, 1.5, true);
        //rmSetAreaHeightBlend(smallMesaID, 1);
		//rmAddAreaTerrainLayer(smallMesaID, "texas\ground2_tex", 0, 2);
		rmSetAreaObeyWorldCircleConstraint(smallMesaID, false);
        
        rmSetAreaCliffHeight(smallMesaID, 8, 2.0, 0.3);		
	    		        
		//rmAddAreaConstraint(smallMesaID, avoidCliffs);
		//rmAddAreaConstraint(smallMesaID, avoidCloseCanyons);
	    rmSetAreaMinBlobs(smallMesaID, 1);
        rmSetAreaMaxBlobs(smallMesaID, 1);
        rmSetAreaMinBlobDistance(smallMesaID, 1.0);
        rmSetAreaMaxBlobDistance(smallMesaID, 1.0);
        rmSetAreaSmoothDistance(smallMesaID, 12);
        rmSetAreaCoherence(smallMesaID, 0.85);		// higher = tries to make round
		//rmAddAreaInfluenceSegment(smallMesaID, 0.4, 0.6, 0.6, 0.4);
        rmBuildArea(smallMesaID);
	}


/*===============================================================================================================*/

        if ( whichMap == 2 )
	
    { 	
		// THE GOLD MINES 1:
		int Gold1ID= rmCreateObjectDef("The Center Gold Mines 1"); 
		rmAddObjectDefItem(Gold1ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(Gold1ID, 0.0);
	    rmSetObjectDefMaxDistance(Gold1ID, 0.0);
	    rmAddObjectDefConstraint(Gold1ID, avoidCoin);
  	    
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.45, 0.45);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.45, 0.55);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.55, 0.55);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.55, 0.45);
	}	
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/
// *********************************** HILL 2 IS THE CENTRAL "CLIFFY" HILL: ************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/
// *********************************** DEFINE THE PLACEMENT ORDER OF THE MAP: ********************************** //   
/*===============================================================================================================*/

        // THE PLACEMENT ORDER:
        // TRADE ROUTE -> NATIVES -> SECRETS -> NUGGETS -> ??
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE THE 2 TRADE ROUTES: ************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/
// ******************************* DEFINE AND PLACE THE NATIVE AMERICAN TRIBES: ******************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 2 )
		
{		
		if (subCiv0 == rmGetCivID("Cree"))
	{  
		int cree1VillageID = -1;
		cree1VillageID = rmCreateGrouping("cree village 1", "native cree village 1");
		rmSetGroupingMinDistance(cree1VillageID, 0.0);
		rmSetGroupingMaxDistance(cree1VillageID, 0.0);
		rmAddGroupingToClass(cree1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cree1VillageID, 0, 0.5, 0.5);
	} 
}
	
/*---------------------------------------------------------------------------------------------------------------*/
        
		if (subCiv1 == rmGetCivID("Cree"))
	{  
		int cree2VillageID = -1;
		cree2VillageID = rmCreateGrouping("cree village 2", "native cree village 1");
		rmSetGroupingMinDistance(cree2VillageID, 0.0);
		rmSetGroupingMaxDistance(cree2VillageID, 0.0);
		rmAddGroupingToClass(cree2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cree2VillageID, 0, 0.35, 0.35);
	} 	
	
/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("Cree"))
	{  
		int cree3VillageID = -1;
		cree3VillageID = rmCreateGrouping("cree village 3", "native cree village 1");
		rmSetGroupingMinDistance(cree3VillageID, 0.0);
		rmSetGroupingMaxDistance(cree3VillageID, 0.0);
		rmAddGroupingToClass(cree3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cree3VillageID, 0, 0.35, 0.65);
	} 

/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("Cree"))
	{  
		int cree4VillageID = -1;
		cree4VillageID = rmCreateGrouping("cree village 4", "native cree village 1");
		rmSetGroupingMinDistance(cree4VillageID, 0.0);
		rmSetGroupingMaxDistance(cree4VillageID, 0.0);
		rmAddGroupingToClass(cree4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cree4VillageID, 0, 0.65, 0.65);
	} 

/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv4 == rmGetCivID("Cree"))
	{  
		int cree5VillageID = -1;
		cree5VillageID = rmCreateGrouping("cree village 5", "native cree village 1");
		rmSetGroupingMinDistance(cree5VillageID, 0.0);
		rmSetGroupingMaxDistance(cree5VillageID, 0.0);
		rmAddGroupingToClass(cree5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cree5VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cree5VillageID, 0, 0.65, 0.35);
	} 	

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*===============================================================================================================*/
// ******************** DEFINE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //	
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE STARTING TCID:
   	    int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 0.0);

        // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 8.0);
	    rmAddObjectDefConstraint(startingUnits, avoidStartingUnitsSmall);
		
/*---------------------------------------------------------------------------------------------------------------*/		
	
	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
		rmAddObjectDefItem(StartAreaTreeID, "TreeSonora", 1, 0.0);
	    rmAddObjectDefItem(StartAreaTreeID, "UnderbrushDesert", 1, 0.0);
	    //rmAddObjectDefItem(StartAreaTreeID, "TreeRockiesSnow", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 20.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
		
		// DEFINE THE STARTING BERRYBUSH:
	    int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 4.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
		rmAddObjectDefConstraint(StartBerryBushID, avoidMediumFruits);

	    // DEFINE THE STARTING BIGHORNS:
		int StartBighornID=rmCreateObjectDef("starting bighorn");
	    rmAddObjectDefItem(StartBighornID, "bighornsheep", 5, 4.0);
	    rmSetObjectDefMinDistance(StartBighornID, 9.0);
	    rmSetObjectDefMaxDistance(StartBighornID, 13.0);
	    rmSetObjectDefCreateHerd(StartBighornID, true);
	    rmAddObjectDefConstraint(StartBighornID, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGETS:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNuggets);
	    rmAddObjectDefConstraint(playerNuggetID, forestEdgeConstraint);	// Pushing the nuggets away from the cliffs at the edge.
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);

	    // DEFINE THE VARIABLES FOR THE PLAYER GOLD:
		int playerGoldID=rmCreateObjectDef("player silver ore");
	    int silverType = rmRandInt(1,10);
		
		
		// DEFINE THE WATER FLAG:
		int waterFlagID=-1;
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/
// ********************* PLACE THE STARTING TCID AND THE STARTING UNITS AND STARTING RESOURCES: **************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        rmClearClosestPointConstraints();
		
 	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// REMOVED BY ENSEMBLE:
		// vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		// rmSetHomeCityGatherPoint(i, closestPoint);
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));	
		
/*---------------------------------------------------------------------------------------------------------------*/		

		// PLACE THE PLAYER GOLD:
		// EVERYONE GETS TWO ORE GROUPINGS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidMediumCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		
		// PLACE THE BERRY BUSHES:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING BIGHORN:
		rmPlaceObjectDefAtLoc(StartBighornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// rmPlaceObjectDefAtLoc(StartBighornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// rmPlaceObjectDefAtLoc(StartBighornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// rmPlaceObjectDefAtLoc(StartBighornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	
     // Water flag
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		//rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
		rmClearClosestPointConstraints();	
		
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/
// *************************************** DEFINE AND PLACE RESOURCESS: **************************************** // 
// ************************ - SILVER MINES - IN THE EAST - IN THE WEST - IN THE CENTER - *********************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINES NUMBER 2:
		int Gold2ID= rmCreateObjectDef("The Center Gold Mines 2"); 
		rmAddObjectDefItem(Gold2ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(Gold2ID, 0.0);
	    rmSetObjectDefMaxDistance(Gold2ID, 0.0);
	    rmAddObjectDefConstraint(Gold2ID, avoidCoin);
  	    
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.1, 0.4);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.4, 0.1);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.6, 0.9);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.9, 0.6);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINES NUMBER 3:
		int Gold3ID= rmCreateObjectDef("The Center Gold Mines 3"); 
		rmAddObjectDefItem(Gold3ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(Gold3ID, 0.0);
	    rmSetObjectDefMaxDistance(Gold3ID, 0.0);
	    rmAddObjectDefConstraint(Gold3ID, avoidCoin);
  	    
		rmPlaceObjectDefAtLoc(Gold3ID, 0, 0.15, 0.75);
		rmPlaceObjectDefAtLoc(Gold3ID, 0, 0.75, 0.15);
		rmPlaceObjectDefAtLoc(Gold3ID, 0, 0.25, 0.85);
		rmPlaceObjectDefAtLoc(Gold3ID, 0, 0.85, 0.25);

/*---------------------------------------------------------------------------------------------------------------*/

        // THE DEER HERDS 1:
        int Deer1ID=rmCreateObjectDef("The Deer Herds 1");
	    rmAddObjectDefItem(Deer1ID, "deer", rmRandInt(9,15), 8.0);
        rmSetObjectDefMinDistance(Deer1ID, 0.0);
        rmSetObjectDefMaxDistance(Deer1ID, 0.0);
        rmAddObjectDefConstraint(Deer1ID, avoidDeer);
        rmSetObjectDefCreateHerd(Deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.1, 0.6);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.6, 0.1);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.4, 0.9);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.9, 0.4);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE DEER HERDS 2:
        int Deer2ID=rmCreateObjectDef("The Deer Herds 2");
	    rmAddObjectDefItem(Deer2ID, "deer", rmRandInt(7,10), 7.0);
        rmSetObjectDefMinDistance(Deer2ID, 0.0);
        rmSetObjectDefMaxDistance(Deer2ID, 0.0);
        rmAddObjectDefConstraint(Deer2ID, avoidDeer);
        rmSetObjectDefCreateHerd(Deer2ID, true);
	    
		rmPlaceObjectDefAtLoc(Deer2ID, 0, 0.175, 0.825);
		rmPlaceObjectDefAtLoc(Deer2ID, 0, 0.825, 0.175);

/*---------------------------------------------------------------------------------------------------------------*/

        // THE DEER HERDS 3:
        int Deer3ID=rmCreateObjectDef("The Deer Herds 3");
	    rmAddObjectDefItem(Deer3ID, "deer", rmRandInt(9,15), 8.0);
        rmSetObjectDefMinDistance(Deer3ID, 0.0);
        rmSetObjectDefMaxDistance(Deer3ID, 0.0);
        rmAddObjectDefConstraint(Deer3ID, avoidDeer);
        rmSetObjectDefCreateHerd(Deer3ID, true);
	    
		rmPlaceObjectDefAtLoc(Deer3ID, 0, 0.15, 0.45);
		rmPlaceObjectDefAtLoc(Deer3ID, 0, 0.45, 0.15);
		rmPlaceObjectDefAtLoc(Deer3ID, 0, 0.55, 0.85);
		rmPlaceObjectDefAtLoc(Deer3ID, 0, 0.85, 0.55);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*===============================================================================================================*/
// ******************************** DEFINE AND PLACE THE FORESTS - WEST AND EAST: ****************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/
// **************************** BIGHORN - TWO GROUPS (ONE ON EACH SIDE PER PLAYER) ***************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.86);
/*===============================================================================================================*/
// **************************************** DEFINE AND PLACE THE BERRIES: ************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // THE BERRIES NUMBER 1:
		int BerriesID=rmCreateObjectDef("The Berries 1");
	    rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(5,9), 5.0);
	    rmSetObjectDefMinDistance(BerriesID, 0.0);
	    rmSetObjectDefMaxDistance(BerriesID, 0.0);
	    rmAddObjectDefConstraint(BerriesID, avoidFruits);
		rmSetObjectDefCreateHerd(BerriesID, true);
	    
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.35, 0.285);
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.65, 0.285);
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.65, 0.70);
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.285, 0.65);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE BERRIES NUMBER 2:
		int Berries2ID=rmCreateObjectDef("The Berries 2");
	    rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(5,9), 5.0);
	    rmSetObjectDefMinDistance(Berries2ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries2ID, 0.0);
	    rmAddObjectDefConstraint(Berries2ID, avoidFruits);
		rmSetObjectDefCreateHerd(Berries2ID, true);
	    
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.365, 0.935);
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.935, 0.365);
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.065, 0.635);
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.635, 0.065);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE BERRIES NUMBER 3:
		int Berries3ID=rmCreateObjectDef("The Berries 3");
	    rmAddObjectDefItem(Berries3ID, "berrybush", rmRandInt(5,9), 5.0);
	    rmSetObjectDefMinDistance(Berries3ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries3ID, 0.0);
	    rmAddObjectDefConstraint(Berries3ID, avoidFruits);
		rmSetObjectDefCreateHerd(Berries3ID, true);
	    
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.065, 0.35);
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.35, 0.065);
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.65, 0.925);
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.925, 0.65);		
				
		
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE SHEEP HERDS: ************************************** //
/*===============================================================================================================*/

        // THE SHEEP HERDS NUMBER 1:
		int Sheep1ID=rmCreateObjectDef("The Sheep Herds 1");
	    rmAddObjectDefItem(Sheep1ID, "sheep", rmRandInt(5,9), 4.0);
	    rmSetObjectDefMinDistance(Sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(Sheep1ID, 0.0);
	    rmAddObjectDefConstraint(Sheep1ID, avoidSheep);
		rmSetObjectDefCreateHerd(Sheep1ID, true);
	    
		rmPlaceObjectDefAtLoc(Sheep1ID, 0, 0.965, 0.50);
		rmPlaceObjectDefAtLoc(Sheep1ID, 0, 0.50, 0.965);
		rmPlaceObjectDefAtLoc(Sheep1ID, 0, 0.425, 0.055);
		rmPlaceObjectDefAtLoc(Sheep1ID, 0, 0.055, 0.425);

/*---------------------------------------------------------------------------------------------------------------*/

        // THE SHEEP HERDS NUMBER 2:
		int Sheep2ID=rmCreateObjectDef("The Sheep Herds 2");
	    rmAddObjectDefItem(Sheep2ID, "sheep", rmRandInt(5,9), 4.0);
	    rmSetObjectDefMinDistance(Sheep2ID, 0.0);
	    rmSetObjectDefMaxDistance(Sheep2ID, 0.0);
	    rmAddObjectDefConstraint(Sheep2ID, avoidSheep);
		rmSetObjectDefCreateHerd(Sheep2ID, true);
	    
		rmPlaceObjectDefAtLoc(Sheep2ID, 0, 0.25, 0.55);
		rmPlaceObjectDefAtLoc(Sheep2ID, 0, 0.55, 0.25);
		rmPlaceObjectDefAtLoc(Sheep2ID, 0, 0.45, 0.75);
		rmPlaceObjectDefAtLoc(Sheep2ID, 0, 0.75, 0.45);				
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/
// ************************** DEFINE AND PLACE NUGGETS - MOSTLY IN THE MIDDLE SECTION: ************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int Nugget1ID = rmCreateObjectDef("The Nuggets 1"); 
	    rmAddObjectDefItem(Nugget1ID, "nugget", 1, 0.0);
		rmSetObjectDefMinDistance(Nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(Nugget1ID, 0.0);
		rmAddObjectDefToClass(Nugget1ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(Nugget1ID, avoidNuggets);
  	    rmSetNuggetDifficulty(1, 3);
				
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.3, 0.4);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.4, 0.3);
		
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.3, 0.6);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.4, 0.7);
		
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.6, 0.7);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.7, 0.6);
		
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.7, 0.4);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.6, 0.3);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 2:
		int Nugget2ID = rmCreateObjectDef("The Nuggets 2"); 
	    rmAddObjectDefItem(Nugget2ID, "nugget", 1, 0.0);
		rmSetObjectDefMinDistance(Nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(Nugget2ID, 0.0);
		rmAddObjectDefToClass(Nugget2ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(Nugget2ID, avoidNuggets);
  	    rmSetNuggetDifficulty(1, 3);
				
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.175, 0.725);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.275, 0.825);
		
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.725, 0.175);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.825, 0.275);		
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/
// ************************************* THESE WERE REMOVED BY ENSEMBLE: *************************************** //	 
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 1:
		int Forest1ID=rmCreateArea("The Forest 1");
		rmSetAreaWarnFailure(Forest1ID, false);
		rmSetAreaSize(Forest1ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest1ID, "sonora forest");
		rmSetAreaForestDensity(Forest1ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest1ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest1ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest1ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest1ID, 1);
		rmSetAreaMaxBlobs(Forest1ID, 1);					
		rmSetAreaMinBlobDistance(Forest1ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest1ID, 1.0);
		rmSetAreaCoherence(Forest1ID, 0.85);
		rmSetAreaSmoothDistance(Forest1ID, 10);
		rmAddAreaConstraint(Forest1ID, forestConstraint);
        rmSetAreaLocation(Forest1ID, 0.5, 0.725); 
        		
		rmBuildArea(Forest1ID);
		
/*---------------------------------------------------------------------------------------------------------------*/		
        
        // THE FOREST NUMBER 2:
		int Forest2ID=rmCreateArea("The Forest 2");
		rmSetAreaWarnFailure(Forest2ID, false);
		rmSetAreaSize(Forest2ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest2ID, "sonora forest");
		rmSetAreaForestDensity(Forest2ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest2ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest2ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest2ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest2ID, 1);
		rmSetAreaMaxBlobs(Forest2ID, 1);					
		rmSetAreaMinBlobDistance(Forest2ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest2ID, 1.0);
		rmSetAreaCoherence(Forest2ID, 0.85);
		rmSetAreaSmoothDistance(Forest2ID, 10);
		rmAddAreaConstraint(Forest2ID, forestConstraint);
        rmSetAreaLocation(Forest2ID, 0.725, 0.5); 
        		
		rmBuildArea(Forest2ID);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 3:
		int Forest3ID=rmCreateArea("The Forest 3");
		rmSetAreaWarnFailure(Forest3ID, false);
		rmSetAreaSize(Forest3ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest3ID, "sonora forest");
		rmSetAreaForestDensity(Forest3ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest3ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest3ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest3ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest3ID, 1);
		rmSetAreaMaxBlobs(Forest3ID, 1);					
		rmSetAreaMinBlobDistance(Forest3ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest3ID, 1.0);
		rmSetAreaCoherence(Forest3ID, 0.85);
		rmSetAreaSmoothDistance(Forest3ID, 10);
		rmAddAreaConstraint(Forest3ID, forestConstraint);
        rmSetAreaLocation(Forest3ID, 0.275, 0.5); 
        		
		rmBuildArea(Forest3ID);	

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 4:
		int Forest4ID=rmCreateArea("The Forest 4");
		rmSetAreaWarnFailure(Forest4ID, false);
		rmSetAreaSize(Forest4ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest4ID, "sonora forest");
		rmSetAreaForestDensity(Forest4ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest4ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest4ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest4ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest4ID, 1);
		rmSetAreaMaxBlobs(Forest4ID, 1);					
		rmSetAreaMinBlobDistance(Forest4ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest4ID, 1.0);
		rmSetAreaCoherence(Forest4ID, 0.85);
		rmSetAreaSmoothDistance(Forest4ID, 10);
		rmAddAreaConstraint(Forest4ID, forestConstraint);
        rmSetAreaLocation(Forest4ID, 0.5, 0.275); 
        		
		rmBuildArea(Forest4ID);		
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 5:
		int Forest5ID=rmCreateArea("The Forest 5");
		rmSetAreaWarnFailure(Forest5ID, false);
		rmSetAreaSize(Forest5ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
		rmSetAreaForestType(Forest5ID, "sonora forest");
		rmSetAreaForestDensity(Forest5ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest5ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest5ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest5ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest5ID, 1);
		rmSetAreaMaxBlobs(Forest5ID, 1);					
		rmSetAreaMinBlobDistance(Forest5ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest5ID, 1.0);
		rmSetAreaCoherence(Forest5ID, 0.85);
		rmSetAreaSmoothDistance(Forest5ID, 10);
		rmAddAreaConstraint(Forest5ID, forestConstraint);
        rmSetAreaLocation(Forest5ID, 0.2, 0.2); 
        		
		rmBuildArea(Forest5ID);		

/*---------------------------------------------------------------------------------------------------------------*/
 
        // THE FOREST NUMBER 6:
		int Forest6ID=rmCreateArea("The Forest 6");
		rmSetAreaWarnFailure(Forest6ID, false);
		rmSetAreaSize(Forest6ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
		rmSetAreaForestType(Forest6ID, "sonora forest");
		rmSetAreaForestDensity(Forest6ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest6ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest6ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest6ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest6ID, 1);
		rmSetAreaMaxBlobs(Forest6ID, 1);					
		rmSetAreaMinBlobDistance(Forest6ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest6ID, 1.0);
		rmSetAreaCoherence(Forest6ID, 0.85);
		rmSetAreaSmoothDistance(Forest6ID, 10);
		rmAddAreaConstraint(Forest6ID, forestConstraint);
        rmSetAreaLocation(Forest6ID, 0.8, 0.8); 
        		
		rmBuildArea(Forest6ID);	

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 7:
		int Forest7ID=rmCreateArea("The Forest 7");
		rmSetAreaWarnFailure(Forest7ID, false);
		rmSetAreaSize(Forest7ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest7ID, "sonora forest");
		rmSetAreaForestDensity(Forest7ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest7ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest7ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest7ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest7ID, 1);
		rmSetAreaMaxBlobs(Forest7ID, 1);					
		rmSetAreaMinBlobDistance(Forest7ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest7ID, 1.0);
		rmSetAreaCoherence(Forest7ID, 0.85);
		rmSetAreaSmoothDistance(Forest7ID, 10);
		rmAddAreaConstraint(Forest7ID, forestConstraint);
        rmSetAreaLocation(Forest7ID, 0.1, 0.5); 
        		
		rmBuildArea(Forest7ID);		

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 8:
		int Forest8ID=rmCreateArea("The Forest 8");
		rmSetAreaWarnFailure(Forest8ID, false);
		rmSetAreaSize(Forest8ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest8ID, "sonora forest");
		rmSetAreaForestDensity(Forest8ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest8ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest8ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest8ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest8ID, 1);
		rmSetAreaMaxBlobs(Forest8ID, 1);					
		rmSetAreaMinBlobDistance(Forest8ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest8ID, 1.0);
		rmSetAreaCoherence(Forest8ID, 0.85);
		rmSetAreaSmoothDistance(Forest8ID, 10);
		rmAddAreaConstraint(Forest8ID, forestConstraint);
        rmSetAreaLocation(Forest8ID, 0.5, 0.1); 
        		
		rmBuildArea(Forest8ID);		

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 9:
		int Forest9ID=rmCreateArea("The Forest 9");
		rmSetAreaWarnFailure(Forest9ID, false);
		rmSetAreaSize(Forest9ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest9ID, "sonora forest");
		rmSetAreaForestDensity(Forest9ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest9ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest9ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest9ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest9ID, 1);
		rmSetAreaMaxBlobs(Forest9ID, 1);					
		rmSetAreaMinBlobDistance(Forest9ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest9ID, 1.0);
		rmSetAreaCoherence(Forest9ID, 0.85);
		rmSetAreaSmoothDistance(Forest9ID, 10);
		rmAddAreaConstraint(Forest9ID, forestConstraint);
        rmSetAreaLocation(Forest9ID, 0.5, 0.9); 
        		
		rmBuildArea(Forest9ID);		

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 10:
		int Forest10ID=rmCreateArea("The Forest 10");
		rmSetAreaWarnFailure(Forest10ID, false);
		rmSetAreaSize(Forest10ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest10ID, "sonora forest");
		rmSetAreaForestDensity(Forest10ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest10ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest10ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest10ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest10ID, 1);
		rmSetAreaMaxBlobs(Forest10ID, 1);					
		rmSetAreaMinBlobDistance(Forest10ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest10ID, 1.0);
		rmSetAreaCoherence(Forest10ID, 0.85);
		rmSetAreaSmoothDistance(Forest10ID, 10);
		rmAddAreaConstraint(Forest10ID, forestConstraint);
        rmSetAreaLocation(Forest10ID, 0.9, 0.5); 
        		
		rmBuildArea(Forest10ID);

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 11:
		int Forest11ID=rmCreateArea("The Forest 11");
		rmSetAreaWarnFailure(Forest11ID, false);
		rmSetAreaSize(Forest11ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest11ID, "sonora forest");
		rmSetAreaForestDensity(Forest11ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest11ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest11ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest11ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest11ID, 1);
		rmSetAreaMaxBlobs(Forest11ID, 1);					
		rmSetAreaMinBlobDistance(Forest11ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest11ID, 1.0);
		rmSetAreaCoherence(Forest11ID, 0.85);
		rmSetAreaSmoothDistance(Forest11ID, 10);
		rmAddAreaConstraint(Forest11ID, forestConstraint);
        rmSetAreaLocation(Forest11ID, 0.125, 0.675); 
        		
		rmBuildArea(Forest11ID);		

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 12:
		int Forest12ID=rmCreateArea("The Forest 12");
		rmSetAreaWarnFailure(Forest12ID, false);
		rmSetAreaSize(Forest12ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest12ID, "sonora forest");
		rmSetAreaForestDensity(Forest12ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest12ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest12ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest12ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest12ID, 1);
		rmSetAreaMaxBlobs(Forest12ID, 1);					
		rmSetAreaMinBlobDistance(Forest12ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest12ID, 1.0);
		rmSetAreaCoherence(Forest12ID, 0.85);
		rmSetAreaSmoothDistance(Forest12ID, 10);
		rmAddAreaConstraint(Forest12ID, forestConstraint);
        rmSetAreaLocation(Forest12ID, 0.675, 0.125); 
        		
		rmBuildArea(Forest12ID);		

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 13:
		int Forest13ID=rmCreateArea("The Forest 13");
		rmSetAreaWarnFailure(Forest13ID, false);
		rmSetAreaSize(Forest13ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest13ID, "sonora forest");
		rmSetAreaForestDensity(Forest13ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest13ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest13ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest13ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest13ID, 1);
		rmSetAreaMaxBlobs(Forest13ID, 1);					
		rmSetAreaMinBlobDistance(Forest13ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest13ID, 1.0);
		rmSetAreaCoherence(Forest13ID, 0.85);
		rmSetAreaSmoothDistance(Forest13ID, 10);
		rmAddAreaConstraint(Forest13ID, forestConstraint);
        rmSetAreaLocation(Forest13ID, 0.325, 0.875); 
        		
		rmBuildArea(Forest13ID);		

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 14:
		int Forest14ID=rmCreateArea("The Forest 14");
		rmSetAreaWarnFailure(Forest14ID, false);
		rmSetAreaSize(Forest14ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest14ID, "sonora forest");
		rmSetAreaForestDensity(Forest14ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest14ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest14ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest14ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest14ID, 1);
		rmSetAreaMaxBlobs(Forest14ID, 1);					
		rmSetAreaMinBlobDistance(Forest14ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest14ID, 1.0);
		rmSetAreaCoherence(Forest14ID, 0.85);
		rmSetAreaSmoothDistance(Forest14ID, 10);
		rmAddAreaConstraint(Forest14ID, forestConstraint);
        rmSetAreaLocation(Forest14ID, 0.875, 0.325); 
        		
		rmBuildArea(Forest14ID);		

/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 15:
		int Forest15ID=rmCreateArea("The Forest 15");
		rmSetAreaWarnFailure(Forest15ID, false);
		rmSetAreaSize(Forest15ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest15ID, "sonora forest");
		rmSetAreaForestDensity(Forest15ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest15ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest15ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest15ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest15ID, 1);
		rmSetAreaMaxBlobs(Forest15ID, 1);					
		rmSetAreaMinBlobDistance(Forest15ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest15ID, 1.0);
		rmSetAreaCoherence(Forest15ID, 0.85);
		rmSetAreaSmoothDistance(Forest15ID, 10);
		rmAddAreaConstraint(Forest15ID, forestConstraint);
        rmSetAreaLocation(Forest15ID, 0.225, 0.775); 
        		
		rmBuildArea(Forest15ID);		
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE FOREST NUMBER 16:
		int Forest16ID=rmCreateArea("The Forest 16");
		rmSetAreaWarnFailure(Forest16ID, false);
		rmSetAreaSize(Forest16ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
		rmSetAreaForestType(Forest16ID, "sonora forest");
		rmSetAreaForestDensity(Forest16ID, 1.0); // HIGHER NUMBER EQUAL MORE TREES:
		rmSetAreaForestClumpiness(Forest16ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:		
		rmSetAreaForestUnderbrush(Forest16ID, 0.0); // LOWER NUMBER EQUAL CLOSER THE TREES:
		rmAddAreaToClass(Forest16ID, rmClassID("classForest"));
		rmSetAreaMinBlobs(Forest16ID, 1);
		rmSetAreaMaxBlobs(Forest16ID, 1);					
		rmSetAreaMinBlobDistance(Forest16ID, 1.0);
		rmSetAreaMaxBlobDistance(Forest16ID, 1.0);
		rmSetAreaCoherence(Forest16ID, 0.85);
		rmSetAreaSmoothDistance(Forest16ID, 10);
		rmAddAreaConstraint(Forest16ID, forestConstraint);
        rmSetAreaLocation(Forest16ID, 0.775, 0.225); 
        		
		rmBuildArea(Forest16ID);
	
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE RANDOM TREES: ************************************* //
/*===============================================================================================================*/

        // RANDOM TREES FOR THE NORTH REGION:
		int randomTreeID=rmCreateObjectDef("random tree 1");
		rmAddObjectDefItem(randomTreeID, "TreeSonora", rmRandInt(1,3), 3.0);//1, 0.0);
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
	    //rmAddObjectDefConstraint(randomTreeID, avoidCloseCliffs);   
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(randomTreeID, forestConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSheep);
	    rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCanyons);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNuggets);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFruits);
	    rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 48*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 36*cNumberNonGaiaPlayers);	
 		
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*===============================================================================================================*/
// ************************************** DEFINE AND PLACE THE FISHBASS: *************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		





















