/*----------------------------------------------------------------------------------------------------------------*/
// THE CHEROKEE WAR:
// CREATED BY DANY:
// JANUARY 2007:
/*----------------------------------------------------------------------------------------------------------------*/
include "mercenaries.xs";
// Main entry point for random map script
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
	    int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/
	    // ALL INCAS ALL THE TIME:
        if (rmAllocateSubCivs(4) == true)
/*----------------------------------------------------------------------------------------------------------------*/		
   {
/*----------------------------------------------------------------------------------------------------------------*/   
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");

		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee");

		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");

		subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cherokee");
/*----------------------------------------------------------------------------------------------------------------*/		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ****************************************** PICKS THE MAP SIZE: *********************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	  int playerTiles=25000;
      
	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
      rmEchoInfo("Map size="+size+"m x "+size+"m");
      rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ************************************* DEFINE THE MAP PARAMETERS: ********************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
	  // PICKS A DEFAULT WATER HEIGHT:
	  rmSetSeaLevel(0.0); // FROM GREAT PLAINS:

	  
      // SET THE MAP ELEVATION PARAMETERS:	  
	  rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0); // FROM GREAT PLAINS:
	  
	  // SET THE WIND MAGNITUDE:
	  rmSetWindMagnitude(2);

	  // PICKS THE DEFAULT TERRAIN:
	  rmSetBaseTerrainMix("great plains drygrass"); // FROM GREAT PLAINS:
      
	  // PICKS THE TERRAIN INITIALIZATION:
	  rmTerrainInitialize("yukon\ground1_yuk", 5); // FROM GREAT PLAINS:
	  
	  // SET THE MAP TYPE:
	  rmSetMapType("greatPlains"); // FROM GREAT PLAINS:
	  rmSetMapType("grass");
	  rmSetMapType("land");
      
	  // SET THE LIGHTING:
	  rmSetLightingSet("great plains"); // FROM GREAT PLAINS:

	  // MAKE THE CORNERS:
	  rmSetWorldCircleConstraint(true);

	  // CHOOSE THE MERCS:
	  chooseMercs();

	  // MAKE IT SNOW:
      //rmSetGlobalSnow( 0.7 );
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES. THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*----------------------------------------------------------------------------------------------------------------*/
      int classPlayer=rmDefineClass("player");
      rmDefineClass("classHill");
      rmDefineClass("classPatch");
      rmDefineClass("starting settlement");
      rmDefineClass("startingUnit");
      rmDefineClass("classForest");
      rmDefineClass("importantItem");
      rmDefineClass("natives");
	  rmDefineClass("classCliff");
	  rmDefineClass("classMountain");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*----------------------------------------------------------------------------------------------------------------*/   
      // MAP EDGE CONSTRAINTS:
      //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	  //int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.43), rmDegreesToRadians(0), rmDegreesToRadians(360));
	  int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(7), rmZTilesToFraction(7), 1.0-rmXTilesToFraction(7), 1.0-rmZTilesToFraction(7), 0.01);
	  int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.01);

      // CARDINAL DIRECTIONS:
	  int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	  int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	  int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.75, 0.75, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	  int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	  // CREATE BOX CONSTRAINT:
	  int NWconstraint = rmCreateBoxConstraint("stay in NW portion", 0, 0.5, 1, 1);
	  int SEconstraint = rmCreateBoxConstraint("stay in SE portion", 0, 0, 1, 0.5);
	  int NEconstraint = rmCreateBoxConstraint("stay in NE portion", 0.65, 0.0, 1, 1);
	  int SWconstraint = rmCreateBoxConstraint("stay in SW portion", 0, 0.0, 0.5, 1);
	  int extremeNEconstraint = rmCreateBoxConstraint("stay deep into NE portion", 0.6, 0.0, 1.0, 1.0);
   
	  // PLAYER CONSTRAINTS:
	  int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20.0);
	  int longPlayerConstraint=rmCreateClassDistanceConstraint("stay far away from players", classPlayer, 50.0);
 
      // SEA FOOD AVOIDANCE:
	  int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
      int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 15.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 15.0);
       
      // NATURE AVOIDANCE:
	  int southForestConstraint=rmCreateClassDistanceConstraint("forest avoids forest", rmClassID("classForest"), 30.0);
	  int avoidLlama=rmCreateTypeDistanceConstraint("llama avoids llama", "Llama", 60.0);
	  int avoidRhea=rmCreateTypeDistanceConstraint("stuff avoids rhea", "rhea", 10.0);
	  int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "Deer", 20.0);
	  int avoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "Moose", 10.0);
	  int avoidBison=rmCreateTypeDistanceConstraint("stuffs avoids bisons", "bison", 20.0);
	  
	  // COIN AVOIDANCE:
	  int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "gold", 40.0);
	  int avoidCoinFar=rmCreateTypeDistanceConstraint("avoid coin far", "gold", 55.0);
	  
	  // GOLD AVOIDANCE:
	  int avoidGold=rmCreateTypeDistanceConstraint("stuff avoids gold", "minegold", 4.0);
	  int goldAvoidGold=rmCreateTypeDistanceConstraint("gold avoids gold", "minegold", 8.0);
	  
	  // BERRYBUSH AVOIDANCE:
	  int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids berries", "berrybush", 4.0);
	  int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("berries avoids berries", "berrybush", 8.0);
   
      // AVOID IMPASSABLE LAND:
	  int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	  int avoidRiver = rmCreateTerrainDistanceConstraint("avoid river", "Land", false, 5.0);
	  int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 12.0);
	  int avoidCliffFar=rmCreateClassDistanceConstraint("stuff vs. cliff far", rmClassID("classCliff"), 22.0);
	  int cliffAvoidCliff=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);
	  int mediumShortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("mediumshort avoid impassable land", "Land", false, 8.0);
	  int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 10.0);
	  int mediumAvoidImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 12.0);

      // UNIT AVOIDANCE:
	  int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 20.0);
	  int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 42.0);
	  int avoidTownCenterSupaFar=rmCreateTypeDistanceConstraint("avoid Town Center Supa Far", "townCenter", 80.0);
	  //int avoidHuari=rmCreateTypeDistanceConstraint("avoid Huari", "HuariStrongholdAndes", 80.0);
	  int avoidCinematicBlock=rmCreateTypeDistanceConstraint("avoid Block", "CinematicBlock", 5.0);
	  int avoidCinematicBlockFar=rmCreateTypeDistanceConstraint("avoid Block Far", "CinematicBlock", 60.0);
	  int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 60.0);
	  int shortAvoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other by a bit", rmClassID("importantItem"), 10.0);
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
	  int avoidNativesFar=rmCreateClassDistanceConstraint("stuff avoids natives far", rmClassID("natives"), 55.0);
	  int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "Nugget", 30.0);
	  int avoidNuggetFar=rmCreateTypeDistanceConstraint("nugget avoid nugget far", "Nugget", 45.0);
	  int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid Trade Socket", "sockettraderoute", 10);
	  int avoidTradeRouteSocketsTC=rmCreateTypeDistanceConstraint("avoid Trade Socket from TC", "sockettraderoute", 60);
	  int avoidIncaSocketsTC=rmCreateTypeDistanceConstraint("avoid Inca Socket from TC", "socketinca", 85);
	  
	  // Unit avoidance - for things that aren't in the starting resources.
      int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

	
      // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);

      // TRADE ROUTE AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
      int avoidTradeRouteForest = rmCreateTradeRouteDistanceConstraint("trade route forest", 8.0);
      int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 50.0);
      int avoidTradeRouteTC = rmCreateTradeRouteDistanceConstraint("TC avoid trade route", 20.0);
/*================================================================================================================*/
// ********************************************** DEFINE OBJECTS: *********************************************** //
// ************************* THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************* //
// NONE FOR NOW:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// *************************************** DEFINE THE STARTING UNITS: ******************************************* //
/*----------------------------------------------------------------------------------------------------------------*/	
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
/*----------------------------------------------------------------------------------------------------------------*/	
// ***************************** DEFINE THE STARTING POSITION OF THE PLAYERS: *********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	if(cNumberTeams > 2) //ffa
/*----------------------------------------------------------------------------------------------------------------*/	
	{
		rmSetPlacementSection(0.52, 0.90);
		rmSetTeamSpacingModifier(0.75);
		rmPlacePlayersCircular(0.40, 0.40, 0);
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	else
/*----------------------------------------------------------------------------------------------------------------*/	
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		// *** Set up player starting locations. Circular around the outside of the map.  

	if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		// rmSetPlacementSection(0.15, 0.35);
		   rmSetPlacementSection(0.95, 0.00);
	
		rmPlacePlayersCircular(0.35, 0.40, 0.0);

		rmSetPlacementTeam(1);
		// rmSetPlacementSection(0.65, 0.85);
		   rmSetPlacementSection(0.51, 0.56);
	
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
	}
	else
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}			
/*----------------------------------------------------------------------------------------------------------------*/		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// ************************************* DEFINE AND BUILD A NORTH AREA: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	  int northIslandID = rmCreateArea("north island");
	  rmSetAreaLocation(northIslandID, 0.75, 0.50); 
	  rmSetAreaWarnFailure(northIslandID, false);
	  rmSetAreaSize(northIslandID, 0.5, 0.5);
	  rmSetAreaCoherence(northIslandID, 0.5);
	  rmSetAreaElevationType(northIslandID, cElevTurbulence);
	  rmSetAreaElevationVariation(northIslandID, 3.0);
	  rmSetAreaBaseHeight(northIslandID, 4.0);
	  rmSetAreaElevationMinFrequency(northIslandID, 0.07);
	  rmSetAreaElevationOctaves(northIslandID, 4);
	  rmSetAreaElevationPersistence(northIslandID, 0.5);
	  rmSetAreaElevationNoiseBias(northIslandID, 1);
	  rmSetAreaObeyWorldCircleConstraint(northIslandID, false);
	  rmSetAreaMix(northIslandID, "great plains drygrass"); // FROM GREAT PLAINS:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ************************************* DEFINE AND BUILD A SOUTH AREA: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
      int southIslandID = rmCreateArea("south island");
      rmSetAreaLocation(southIslandID, 0, 0.5); 
      rmSetAreaWarnFailure(southIslandID, false);
      rmSetAreaSize(southIslandID, 0.5, 0.5);
      rmSetAreaCoherence(southIslandID, 0.5);
	  rmSetAreaElevationType(southIslandID, cElevTurbulence);
      rmSetAreaElevationVariation(southIslandID, 5.0);
      rmSetAreaBaseHeight(southIslandID, 3.0);
      rmSetAreaElevationMinFrequency(southIslandID, 0.07);
      rmSetAreaElevationOctaves(southIslandID, 4);
      rmSetAreaElevationPersistence(southIslandID, 0.5);
	  rmSetAreaElevationNoiseBias(southIslandID, 1); 
      rmSetAreaObeyWorldCircleConstraint(southIslandID, false);
	  rmSetAreaMix(southIslandID, "great plains drygrass"); // FROM GREAT PLAINS:
/*----------------------------------------------------------------------------------------------------------------*/
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ************************************* DEFINE THE SET UP PLAYER AREAS: **************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
      float playerFraction=rmAreaTilesToFraction(100);
/*----------------------------------------------------------------------------------------------------------------*/   
      for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/   
   {
/*----------------------------------------------------------------------------------------------------------------*/   
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
     
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
	  
	  // ADD AREA CONSTRAINTS:
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint);
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA TERRAIN TYPE:
	  // NONE...rmSetAreaTerrainType(id, "patagonia\ground_dirt1_pat");
		  
	  // SET AREA BASE HEIGHT:
	  //rmSetAreaBaseHeight(id, 18.0);
     
      // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
/*----------------------------------------------------------------------------------------------------------------*/	 
   }
/*----------------------------------------------------------------------------------------------------------------*/
      // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE TRADE ROUTES: *************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ******************************************** DEFINE THE RIVER: *********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
            int riverID = rmRiverCreate(-1, "Amazon River", 10, 10, 6, 5);
			rmRiverAddWaypoint(riverID, 0.9, 1.0);
			rmRiverAddWaypoint(riverID, 0.5, 0.65);
			rmRiverAddWaypoint(riverID, 0.0, 0.75);
			rmRiverSetShallowRadius(riverID, 10);
			rmRiverAddShallow(riverID, rmRandFloat(0.45, 0.65));
			rmRiverSetBankNoiseParams(riverID, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
			rmRiverBuild(riverID);

			int river2ID = rmRiverCreate(-1, "Amazon River", 10, 10, 6, 5);
			rmRiverAddWaypoint(river2ID, 0.9, 0.0);
			rmRiverAddWaypoint(river2ID, 0.5, 0.35);
			rmRiverAddWaypoint(river2ID, 0.0, 0.16);
			rmRiverSetShallowRadius(river2ID, 10);
			rmRiverAddShallow(river2ID, rmRandFloat(0.45, 0.65));
			rmRiverSetBankNoiseParams(river2ID, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
			rmRiverBuild(river2ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE NATIVES TRIBES: ************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	if (subCiv0 == rmGetCivID("cherokee"))
	{  
		int cherokeeVillageAID = -1;
		cherokeeVillageAID = rmCreateGrouping("back cherokee village", "native cherokee village "+1);
		rmSetGroupingMinDistance(cherokeeVillageAID, 0.0);
		rmSetGroupingMaxDistance(cherokeeVillageAID, 0.0);
		rmAddGroupingToClass(cherokeeVillageAID, rmClassID("natives"));
		rmAddGroupingToClass(cherokeeVillageAID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(cherokeeVillageAID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokeeVillageAID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokeeVillageAID, 0, 0.83, 0.75);
	}
/*----------------------------------------------------------------------------------------------------------------*/
	if (subCiv1 == rmGetCivID("cherokee"))
	{  
		int cherokeevillageBID = -1;
		cherokeevillageBID = rmCreateGrouping("left city", "native cherokee village "+2);
		rmSetGroupingMinDistance(cherokeevillageBID, 0.0);
		rmSetGroupingMaxDistance(cherokeevillageBID, 0.0);
		rmAddGroupingToClass(cherokeevillageBID, rmClassID("natives"));
		rmAddGroupingToClass(cherokeevillageBID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(cherokeevillageBID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokeevillageBID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokeevillageBID, 0, 0.20, 0.825);
	}
/*----------------------------------------------------------------------------------------------------------------*/
	if (subCiv2 == rmGetCivID("cherokee"))
	{  
		int cherokeevillageCID = -1;
		cherokeevillageCID = rmCreateGrouping("right city", "native cherokee village "+3);
		rmSetGroupingMinDistance(cherokeevillageCID, 0.0);
		rmSetGroupingMaxDistance(cherokeevillageCID, 0.0);
		rmAddGroupingToClass(cherokeevillageCID, rmClassID("natives"));
		rmAddGroupingToClass(cherokeevillageCID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(cherokeevillageCID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokeevillageCID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokeevillageCID, 0, 0.85, 0.25);
	}
/*----------------------------------------------------------------------------------------------------------------*/
	if (subCiv3 == rmGetCivID("cherokee"))
	{  
		int cherokeevillageDID = -1;
		cherokeevillageDID = rmCreateGrouping("front city", "native cherokee village "+4);
		rmSetGroupingMinDistance(cherokeevillageDID, 0.0);
		rmSetGroupingMaxDistance(cherokeevillageDID, 20.0);
		rmAddGroupingToClass(cherokeevillageDID, rmClassID("natives"));
		rmAddGroupingToClass(cherokeevillageDID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(cherokeevillageDID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokeevillageDID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokeevillageDID, 0, 0.275, 0.115);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
	// VARIABLES NEEDED:
	int failCount = -1;

	int numTries=cNumberNonGaiaPlayers+2;
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** DEFINE THE PLAYER STARTING RESOURCES: ************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
	rmClearClosestPointConstraints();
/*----------------------------------------------------------------------------------------------------------------*/
    //STARTING UNITS and RESOURCES DEFS
	
	int TCID = rmCreateObjectDef("player TC");
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	}

	rmAddObjectDefConstraint(TCID, playerEdgeConstraint);
	
	
	rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 9.0);
	//rmAddObjectDefConstraint(TCID, avoidTradeRouteSmall);

	// rmAddObjectDefConstraint(TCID, avoidTradeRoute);
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************** DEFINE THE PLAYER RESOURCES: ****************************************** //	
/*----------------------------------------------------------------------------------------------------------------*/	
	// DEFINE THE PLAYER SILVER MINES:
	int playerSilverID = rmCreateObjectDef("player mine");
	rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerSilverID, avoidTownCenter);
	rmSetObjectDefMinDistance(playerSilverID, 15.0);
	rmSetObjectDefMaxDistance(playerSilverID, 20.0);
    rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);

/*	// DEFINE THE PLAYER BIGHORN:
	int playerbighornID=rmCreateObjectDef("player bighorn");
    // rmAddObjectDefItem(playerbighornID, "bighornsheep", rmRandInt(14,20), 18.0);
	   rmAddObjectDefItem(playerbighornID, "bighornsheep", rmRandInt(14,20), 18.0);
    rmSetObjectDefMinDistance(playerbighornID, 10);
    rmSetObjectDefMaxDistance(playerbighornID, 18);
	rmAddObjectDefConstraint(playerbighornID, avoidAll);
    rmAddObjectDefConstraint(playerbighornID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerbighornID, avoidCliff);
    rmSetObjectDefCreateHerd(playerbighornID, true);
*/	
	
	// DEFINE THE PLAYER COWS:
	int playercowID=rmCreateObjectDef("player cow");
    rmAddObjectDefItem(playercowID, "cow", rmRandInt(8,12), 10.0);
    rmSetObjectDefMinDistance(playercowID, 15);
    rmSetObjectDefMaxDistance(playercowID, 20);
	rmAddObjectDefConstraint(playercowID, avoidAll);
	rmAddObjectDefConstraint(playercowID, avoidImpassableLand);
	rmAddObjectDefConstraint(playercowID, avoidCliff);
    rmSetObjectDefCreateHerd(playercowID, true);
	
	// DEFINE THE PLAYER BERRYBUSH:
	int playerberriesID=rmCreateObjectDef("player berries");
    rmAddObjectDefItem(playerberriesID, "berrybush", rmRandInt(3,5), 4.0);
    rmSetObjectDefMinDistance(playerberriesID, 25);
    rmSetObjectDefMaxDistance(playerberriesID, 30);
	rmAddObjectDefConstraint(playerberriesID, avoidAll);
	rmAddObjectDefConstraint(playerberriesID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerberriesID, avoidCliff);
    rmSetObjectDefCreateHerd(playerberriesID, true);

	// DEFINE THE PLAYER NUGGET:
	int playerNuggetID= rmCreateObjectDef("player nugget"); 
	rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
  	rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
  	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
  	rmAddObjectDefConstraint(playerNuggetID, avoidAll);
	rmAddObjectDefConstraint(playerNuggetID, avoidCliff);
	rmAddObjectDefConstraint(playerNuggetID, playerEdgeConstraint);
	rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	rmSetObjectDefMaxDistance(playerNuggetID, 30.0);

	// DEFINE THE PLAYER TREE:
	int playerTreeID=rmCreateObjectDef("player trees");
    rmAddObjectDefItem(playerTreeID, "TreeGreatPlains", rmRandInt(5,10), 8.0); // FROM GREAT PLAINS:
    rmSetObjectDefMinDistance(playerTreeID, 10);
    rmSetObjectDefMaxDistance(playerTreeID, 25);
	rmAddObjectDefConstraint(playerTreeID, avoidAll);
    rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ********************************* PLACE THE PLAYERS STARTING RESOURCES: ************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
	    for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
/*----------------------------------------------------------------------------------------------------------------*/		
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
/*----------------------------------------------------------------------------------------------------------------*/		
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		// rmPlaceObjectDefAtLoc(playerbighornID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		   rmPlaceObjectDefAtLoc(playercowID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerberriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
/*----------------------------------------------------------------------------------------------------------------*/
		rmClearClosestPointConstraints();
/*----------------------------------------------------------------------------------------------------------------*/		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE CLIFF AREA: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	// Central Pond
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int smallPondID=rmCreateArea("small pond");
	
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(2250), rmAreaTilesToFraction(2250));
		rmSetAreaWaterType(smallPondID, "great lakes");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1);
		rmSetAreaMaxBlobDistance(smallPondID, 1);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.5);
		rmSetAreaSmoothDistance(smallPondID, 5);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.80, 0.5); 
		rmBuildArea(smallPondID);
		
		int smallPond2ID=rmCreateArea("small pond 2");
		rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
		rmSetAreaWaterType(smallPond2ID, "great lakes");
		rmSetAreaBaseHeight(smallPond2ID, 4);
		//rmSetAreaMinBlobs(smallPond2ID, 1);
		//rmSetAreaMaxBlobs(smallPond2ID, 4);
		//rmSetAreaMinBlobDistance(smallPond2ID, 5.0);
		//rmSetAreaMaxBlobDistance(smallPond2ID, 30.0);
		rmAddAreaToClass(smallPond2ID, pondClass);
		rmSetAreaCoherence(smallPond2ID, 0.5);
		rmSetAreaSmoothDistance(smallPond2ID, 5);
		rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.175, 0.475); 
		rmBuildArea(smallPond2ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE NUGGETS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int nuggetID= rmCreateObjectDef("nugget 1"); 
	  rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nuggetID, 0.0);
	  rmSetObjectDefMaxDistance(nuggetID, 0.0);
	  rmAddObjectDefConstraint(nuggetID, avoidNugget);
	  rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nuggetID, 0, 0.36, 0.5, 1.0);
	  	  
      int nugget2ID= rmCreateObjectDef("nugget 2"); 
	  rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(2, 2);
	  rmSetObjectDefMinDistance(nugget2ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget2ID, 0.0);
  	  rmAddObjectDefConstraint(nugget2ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget2ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.36, 0.45, 1.0);
	  
	  int nugget3ID= rmCreateObjectDef("nugget 3"); 
	  rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nugget3ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget3ID, 0.0);
  	  rmAddObjectDefConstraint(nugget3ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget3ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.6, 0.45, 1.0);
      
      int nugget4ID= rmCreateObjectDef("nugget 4"); 
	  rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(2, 2);
	  rmSetObjectDefMinDistance(nugget4ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget4ID, 0.0);
  	  rmAddObjectDefConstraint(nugget4ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget4ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.6, 0.5, 1.0);	

      int nugget5ID= rmCreateObjectDef("nugget 5"); 
	  rmAddObjectDefItem(nugget5ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(2, 2);
	  rmSetObjectDefMinDistance(nugget5ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget5ID, 0.0);
  	  rmAddObjectDefConstraint(nugget5ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget5ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.95, 0.6, 1.0);
      //rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.96, 0.65, 1.0); // became berries:	 
      //rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.88, 0.76, 1.0); // became nugget 6:

      int nugget6ID= rmCreateObjectDef("nugget 6"); 
	  rmAddObjectDefItem(nugget6ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nugget6ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget6ID, 0.0);
  	  rmAddObjectDefConstraint(nugget6ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget6ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.88, 0.76, 1.0);  
	  
	  int nugget7ID= rmCreateObjectDef("nugget 7"); 
	  rmAddObjectDefItem(nugget7ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nugget7ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget7ID, 0.0);
  	  rmAddObjectDefConstraint(nugget7ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget7ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget7ID, 0, 0.96, 0.4, 1.0); 
	  // rmPlaceObjectDefAtLoc(nugget7ID, 0, 0.94, 0.32, 1.0); // became nugget 8:
	  // rmPlaceObjectDefAtLoc(nugget7ID, 0, 0.83, 0.17, 1.0); // became berries:
	  // rmPlaceObjectDefAtLoc(nugget7ID, 0, 0.78, 0.20, 1.0); // became nugget 9
	  
	  int nugget8ID= rmCreateObjectDef("nugget 8"); 
	  rmAddObjectDefItem(nugget8ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nugget8ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget8ID, 0.0);
  	  rmAddObjectDefConstraint(nugget8ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget8ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget8ID, 0, 0.93, 0.32, 1.0);
	  // rmPlaceObjectDefAtLoc(nugget8ID, 0, 0.83, 0.17, 1.0); // became berries:
	  // rmPlaceObjectDefAtLoc(nugget8ID, 0, 0.78, 0.20, 1.0); // became nugget 9
	  
	  int nugget9ID= rmCreateObjectDef("nugget 9"); 
	  rmAddObjectDefItem(nugget9ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nugget9ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget9ID, 0.0);
  	  rmAddObjectDefConstraint(nugget9ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget9ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget9ID, 0, 0.78, 0.22, 1.0); // became nugget 9
	  
	  int nugget10ID= rmCreateObjectDef("nugget 10"); 
	  rmAddObjectDefItem(nugget10ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nugget10ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget10ID, 0.0);
  	  rmAddObjectDefConstraint(nugget10ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget10ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget10ID, 0, 0.65, 0.95, 1.0); 
	  
	  int nugget11ID= rmCreateObjectDef("nugget 11"); 
	  rmAddObjectDefItem(nugget11ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nugget11ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget11ID, 0.0);
  	  rmAddObjectDefConstraint(nugget11ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget11ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget11ID, 0, 0.55, 0.96, 1.0); 
	  
	  int nugget12ID= rmCreateObjectDef("nugget 12"); 
	  rmAddObjectDefItem(nugget12ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nugget12ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget12ID, 0.0);
  	  rmAddObjectDefConstraint(nugget12ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget12ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget12ID, 0, 0.5, 0.03, 1.0); 
	  
	  int nugget13ID= rmCreateObjectDef("nugget 13"); 
	  rmAddObjectDefItem(nugget13ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmSetObjectDefMinDistance(nugget13ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget13ID, 0.0);
  	  rmAddObjectDefConstraint(nugget13ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget13ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget13ID, 0, 0.65, 0.05, 1.0);
	  
	  int nugget14ID= rmCreateObjectDef("nugget 14"); 
	  rmAddObjectDefItem(nugget14ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(2, 2);
	  rmSetObjectDefMinDistance(nugget14ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget14ID, 0.0);
  	  rmAddObjectDefConstraint(nugget14ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget14ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget14ID, 0, 0.45, 0.50, 1.0);
	  
	  int nugget15ID= rmCreateObjectDef("nugget 15"); 
	  rmAddObjectDefItem(nugget15ID, "Nugget", 1, 0.0);
	  rmSetNuggetDifficulty(3, 3);
	  rmSetObjectDefMinDistance(nugget15ID, 0.0);
	  rmSetObjectDefMaxDistance(nugget15ID, 0.0);
  	  rmAddObjectDefConstraint(nugget15ID, avoidNugget);
  	  rmAddObjectDefConstraint(nugget15ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(nugget15ID, 0, 0.55, 0.56, 1.0);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FISHBASS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int fishID=rmCreateObjectDef("fish");
      rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
      rmSetObjectDefMinDistance(fishID, 0.0);
      rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fishID, fishVsFishID);
      rmAddObjectDefConstraint(fishID, fishLand);
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);
/*================================================================================================================*/   
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE GOLD MINES: *************************************** //
/*================================================================================================================*/
      int gold1ID= rmCreateObjectDef("Gold Mines 1"); 
	  rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
	  rmSetObjectDefMinDistance(gold1ID, 0.0);
	  rmSetObjectDefMaxDistance(gold1ID, 0.0);
	  rmAddObjectDefConstraint(gold1ID, avoidGold);
	  rmAddObjectDefConstraint(gold1ID, goldAvoidGold);
	  rmPlaceObjectDefAtLoc(gold1ID, 0, 0.07, 0.32);
	  
	  int gold2ID= rmCreateObjectDef("Gold Mines 2"); 
	  rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
	  rmSetObjectDefMinDistance(gold2ID, 0.0);
	  rmSetObjectDefMaxDistance(gold2ID, 0.0);
	  rmAddObjectDefConstraint(gold2ID, avoidGold);
	  rmAddObjectDefConstraint(gold2ID, goldAvoidGold);
	  rmPlaceObjectDefAtLoc(gold2ID, 0, 0.04, 0.60);
	  
      int gold3ID= rmCreateObjectDef("Gold Mines 3"); 
	  rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
	  rmSetObjectDefMinDistance(gold3ID, 0.0);
	  rmSetObjectDefMaxDistance(gold3ID, 0.0);
	  rmAddObjectDefConstraint(gold3ID, avoidGold);
	  rmAddObjectDefConstraint(gold3ID, goldAvoidGold);
	  rmAddObjectDefConstraint(gold3ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(gold3ID, 0, 0.35, 0.55); 
      rmPlaceObjectDefAtLoc(gold3ID, 0, 0.35, 0.40);

      int gold4ID= rmCreateObjectDef("Gold Mines 4"); 
	  rmAddObjectDefItem(gold4ID, "minegold", 1, 0.0);
	  rmSetObjectDefMinDistance(gold4ID, 0.0);
	  rmSetObjectDefMaxDistance(gold4ID, 0.0);
	  rmAddObjectDefConstraint(gold4ID, avoidGold);
	  rmAddObjectDefConstraint(gold4ID, goldAvoidGold);
	  rmAddObjectDefConstraint(gold4ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(gold4ID, 0, 0.90, 0.70); 

      int gold5ID= rmCreateObjectDef("Gold Mines 5"); 
	  rmAddObjectDefItem(gold5ID, "minegold", 1, 0.0);
	  rmSetObjectDefMinDistance(gold5ID, 0.0);
	  rmSetObjectDefMaxDistance(gold5ID, 0.0);
	  rmAddObjectDefConstraint(gold5ID, avoidGold);
	  rmAddObjectDefConstraint(gold5ID, goldAvoidGold);
	  rmAddObjectDefConstraint(gold5ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(gold5ID, 0, 0.8, 0.30); 
	  rmPlaceObjectDefAtLoc(gold5ID, 0, 0.6, 0.4);
	  rmPlaceObjectDefAtLoc(gold5ID, 0, 0.6, 0.6);
      rmPlaceObjectDefAtLoc(gold5ID, 0, 0.94, 0.35); 
	  
	  int gold6ID= rmCreateObjectDef("Gold Mines 6"); 
	  rmAddObjectDefItem(gold6ID, "minegold", 1, 0.0);
	  rmSetObjectDefMinDistance(gold6ID, 0.0);
	  rmSetObjectDefMaxDistance(gold6ID, 0.0);
	  rmAddObjectDefConstraint(gold6ID, avoidGold);
	  rmAddObjectDefConstraint(gold6ID, goldAvoidGold);
	  rmAddObjectDefConstraint(gold6ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(gold6ID, 0, 0.60, 0.95); 
	  
	  int gold7ID= rmCreateObjectDef("Gold Mines 7"); 
	  rmAddObjectDefItem(gold7ID, "minegold", 1, 0.0);
	  rmSetObjectDefMinDistance(gold7ID, 0.0);
	  rmSetObjectDefMaxDistance(gold7ID, 0.0);
	  rmAddObjectDefConstraint(gold7ID, avoidGold);
	  rmAddObjectDefConstraint(gold7ID, goldAvoidGold);
	  rmAddObjectDefConstraint(gold7ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(gold7ID, 0, 0.55, 0.03); 
	  
	  int gold8ID= rmCreateObjectDef("Gold Mines 8"); 
	  rmAddObjectDefItem(gold8ID, "minegold", 1, 0.0);
	  rmSetObjectDefMinDistance(gold8ID, 0.0);
	  rmSetObjectDefMaxDistance(gold8ID, 0.0);
	  rmAddObjectDefConstraint(gold8ID, avoidGold);
	  rmAddObjectDefConstraint(gold8ID, goldAvoidGold);
	  rmAddObjectDefConstraint(gold8ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(gold8ID, 0, 0.50, 0.50); 
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
      int berriesID= rmCreateObjectDef("The Berries 1"); 
	  rmAddObjectDefItem(berriesID, "berrybush", 3, 4.0);
	  rmSetObjectDefMinDistance(berriesID, 0.0);
	  rmSetObjectDefMaxDistance(berriesID, 0.0);
	  rmAddObjectDefConstraint(berriesID, avoidFruits);
	  rmAddObjectDefConstraint(berriesID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berriesID, 0, 0.75, 0.75); 
	  
	  int berries2ID= rmCreateObjectDef("The Berries 2"); 
	  rmAddObjectDefItem(berries2ID, "berrybush", 3, 4.0);
	  rmSetObjectDefMinDistance(berries2ID, 0.0);
	  rmSetObjectDefMaxDistance(berries2ID, 0.0);
	  rmAddObjectDefConstraint(berries2ID, avoidFruits);
	  rmAddObjectDefConstraint(berries2ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries2ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries2ID, 0, 0.70, 0.3);
	  
	  int berries3ID= rmCreateObjectDef("The Berries 3"); 
	  rmAddObjectDefItem(berries3ID, "berrybush", 3, 4.0);
	  rmSetObjectDefMinDistance(berries3ID, 0.0);
	  rmSetObjectDefMaxDistance(berries3ID, 0.0);
	  rmAddObjectDefConstraint(berries3ID, avoidFruits);
	  rmAddObjectDefConstraint(berries3ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries3ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries3ID, 0, 0.95, 0.65);
	  
	  int berries4ID= rmCreateObjectDef("The Berries 4"); 
	  rmAddObjectDefItem(berries4ID, "berrybush", 3, 4.0);
	  rmSetObjectDefMinDistance(berries4ID, 0.0);
	  rmSetObjectDefMaxDistance(berries4ID, 0.0);
	  rmAddObjectDefConstraint(berries4ID, avoidFruits);
	  rmAddObjectDefConstraint(berries4ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries4ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries4ID, 0, 0.83, 0.17);
	  
	  int berries5ID= rmCreateObjectDef("The Berries 5"); 
	  rmAddObjectDefItem(berries5ID, "berrybush", 3, 4.0);
	  rmSetObjectDefMinDistance(berries5ID, 0.0);
	  rmSetObjectDefMaxDistance(berries5ID, 0.0);
	  rmAddObjectDefConstraint(berries5ID, avoidFruits);
	  rmAddObjectDefConstraint(berries5ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries5ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries5ID, 0, 0.90, 0.29);
	  
	  int berries6ID= rmCreateObjectDef("The Berries 6"); 
	  rmAddObjectDefItem(berries6ID, "berrybush", 3, 4.0);
	  rmSetObjectDefMinDistance(berries6ID, 0.0);
	  rmSetObjectDefMaxDistance(berries6ID, 0.0);
	  rmAddObjectDefConstraint(berries6ID, avoidFruits);
	  rmAddObjectDefConstraint(berries6ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries6ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries6ID, 0, 0.97, 0.48);
	  
	  int berries7ID= rmCreateObjectDef("The Berries 7"); 
	  rmAddObjectDefItem(berries7ID, "berrybush", 3, 4.0);
	  rmSetObjectDefMinDistance(berries7ID, 0.0);
	  rmSetObjectDefMaxDistance(berries7ID, 0.0);
	  rmAddObjectDefConstraint(berries7ID, avoidFruits);
	  rmAddObjectDefConstraint(berries7ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries7ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries7ID, 0, 0.1, 0.3);
	  
	  int berries8ID= rmCreateObjectDef("The Berries 8"); 
	  rmAddObjectDefItem(berries8ID, "nugget", 3, 3.0);
	  rmSetObjectDefMinDistance(berries8ID, 0.0);
	  rmSetObjectDefMaxDistance(berries8ID, 0.0);
	  rmAddObjectDefConstraint(berries8ID, avoidFruits);
	  rmAddObjectDefConstraint(berries8ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries8ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries8ID, 0, 0.035, 0.375);
	  
	  int berries9ID= rmCreateObjectDef("The Berries 9"); 
	  rmAddObjectDefItem(berries9ID, "berrybush", 3, 3.0);
	  rmSetObjectDefMinDistance(berries9ID, 0.0);
	  rmSetObjectDefMaxDistance(berries9ID, 0.0);
	  rmAddObjectDefConstraint(berries9ID, avoidFruits);
	  rmAddObjectDefConstraint(berries9ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries9ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries9ID, 0, 0.028, 0.425);
	  
	  int berries10ID= rmCreateObjectDef("The Berries 10"); 
	  rmAddObjectDefItem(berries10ID, "nugget", 3, 3.0);
	  rmSetObjectDefMinDistance(berries10ID, 0.0);
	  rmSetObjectDefMaxDistance(berries10ID, 0.0);
	  rmAddObjectDefConstraint(berries10ID, avoidFruits);
	  rmAddObjectDefConstraint(berries10ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries10ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries10ID, 0, 0.025, 0.47);
	  
	  int berries11ID= rmCreateObjectDef("The Berries 11"); 
	  rmAddObjectDefItem(berries11ID, "berrybush", 3, 3.0);
	  rmSetObjectDefMinDistance(berries11ID, 0.0);
	  rmSetObjectDefMaxDistance(berries11ID, 0.0);
	  rmAddObjectDefConstraint(berries11ID, avoidFruits);
	  rmAddObjectDefConstraint(berries11ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries11ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries11ID, 0, 0.028, 0.52);
	  
	  int berries12ID= rmCreateObjectDef("The Berries 12"); 
	  rmAddObjectDefItem(berries12ID, "nugget", 3, 3.0);
	  rmSetObjectDefMinDistance(berries12ID, 0.0);
	  rmSetObjectDefMaxDistance(berries12ID, 0.0);
	  rmAddObjectDefConstraint(berries12ID, avoidFruits);
	  rmAddObjectDefConstraint(berries12ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries12ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries12ID, 0, 0.028, 0.57);
	  
	  int berries13ID= rmCreateObjectDef("The Berries 13"); 
	  rmAddObjectDefItem(berries13ID, "berrybush", 3, 3.0);
	  rmSetObjectDefMinDistance(berries13ID, 0.0);
	  rmSetObjectDefMaxDistance(berries13ID, 0.0);
	  rmAddObjectDefConstraint(berries13ID, avoidFruits);
	  rmAddObjectDefConstraint(berries13ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries13ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries13ID, 0, 0.04, 0.64);
	  
	  int berries14ID= rmCreateObjectDef("The Berries 14"); 
	  rmAddObjectDefItem(berries14ID, "berrybush", 3, 3.0);
	  rmSetObjectDefMinDistance(berries14ID, 0.0);
	  rmSetObjectDefMaxDistance(berries14ID, 0.0);
	  rmAddObjectDefConstraint(berries14ID, avoidFruits);
	  rmAddObjectDefConstraint(berries14ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries14ID, avoidImpassableLand);
	  //rmPlaceObjectDefAtLoc(berries14ID, 0, 0.55, 0.56);
	  rmPlaceObjectDefAtLoc(berries14ID, 0, 0.55, 0.50);
	  //rmPlaceObjectDefAtLoc(berries14ID, 0, 0.50, 0.50);
	  //rmPlaceObjectDefAtLoc(berries14ID, 0, 0.45, 0.50);
	  rmPlaceObjectDefAtLoc(berries14ID, 0, 0.40, 0.50);
	  rmPlaceObjectDefAtLoc(berries14ID, 0, 0.33, 0.50);
	  
	  int berries20ID= rmCreateObjectDef("The Berries 20"); 
	  rmAddObjectDefItem(berries20ID, "berrybush", 3, 3.0);
	  rmSetObjectDefMinDistance(berries20ID, 0.0);
	  rmSetObjectDefMaxDistance(berries20ID, 0.0);
	  rmAddObjectDefConstraint(berries20ID, avoidFruits);
	  rmAddObjectDefConstraint(berries20ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries20ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries20ID, 0, 0.70, 0.93);
	  
	  int berries21ID= rmCreateObjectDef("The Berries 21"); 
	  rmAddObjectDefItem(berries21ID, "berrybush", 3, 3.0);
	  rmSetObjectDefMinDistance(berries21ID, 0.0);
	  rmSetObjectDefMaxDistance(berries21ID, 0.0);
	  rmAddObjectDefConstraint(berries21ID, avoidFruits);
	  rmAddObjectDefConstraint(berries21ID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(berries21ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(berries21ID, 0, 0.60, 0.04);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE FORESTS AREAS: ************************************** //
/*================================================================================================================*/

	        // DEFINE AND PLACE THE FOREST TREE SOUTH:
			int forestTreeID = 0;

	        if (cNumberNonGaiaPlayers < 4)
		                numTries=10*cNumberNonGaiaPlayers;
	        else
		                numTries=6*cNumberNonGaiaPlayers;
	        failCount=0;
	
	        for (i=0; <numTries)
	
		{ 
		
			int forestID=rmCreateArea("forestID"+i, southIslandID);
			rmSetAreaWarnFailure(forestID, false);
			rmSetAreaSize(forestID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			// rmSetAreaForestType(forestID, "andes forest");
			   // rmSetAreaForestType(forestID, "patagonia forest");
			      rmSetAreaForestType(forestID, "great plains forest");
			rmSetAreaForestDensity(forestID, 0.9);
			rmSetAreaForestClumpiness(forestID, 0.7);		
			rmSetAreaForestUnderbrush(forestID, 0.6);
			//rmSetAreaMinBlobs(forestID, 1);
			//rmSetAreaMaxBlobs(forestID, 4);						
			//rmSetAreaMinBlobDistance(forestID, 5.0);
			//rmSetAreaMaxBlobDistance(forestID, 20.0);
			rmSetAreaCoherence(forestID, 0.4);
			rmSetAreaSmoothDistance(forestID, 10);
			rmAddAreaToClass(forestID, rmClassID("classForest"));
			//rmAddAreaConstraint(forestID, southForestConstraint);  
			rmAddAreaConstraint(forestID, avoidNatives);
			rmAddAreaConstraint(forestID, avoidCinematicBlock);
			rmAddAreaConstraint(forestID, shortAvoidImportantItem);
			rmAddAreaConstraint(forestID, playerConstraint);
			rmAddAreaConstraint(forestID, avoidGold);
			rmAddAreaConstraint(forestID, avoidAll);
			rmAddAreaConstraint(forestID, avoidImpassableLand);
			
			if(rmBuildArea(forestID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==10)
					break;
			}
			else
				failCount=0;
				
		}
		
/*----------------------------------------------------------------------------------------------------------------*/		
	        
            // DEFINE AND PLACE THE FOREST TREE NORTH:
			int forestTreeNorthID = 0;
	        numTries=8*cNumberNonGaiaPlayers;  
	        failCount=0;
			
	        for (i=0; <numTries)
			
		{  
		
			int forestnorthID=rmCreateArea("forestNorthID"+i, northIslandID);
			rmSetAreaWarnFailure(forestnorthID, false);
			rmSetAreaSize(forestnorthID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			// rmSetAreaForestType(forestnorthID, "andes forest");
			   // rmSetAreaForestType(forestnorthID, "patagonia forest"); // FROM PATAGONIA:
			      rmSetAreaForestType(forestnorthID, "great plains forest");
			rmSetAreaForestDensity(forestnorthID, 0.5);
			rmSetAreaForestClumpiness(forestnorthID, 0.4);		
			rmSetAreaForestUnderbrush(forestnorthID, 0.7);
			//rmSetAreaMinBlobs(forestnorthID, 1);
			//rmSetAreaMaxBlobs(forestnorthID, 4);						
			//rmSetAreaMinBlobDistance(forestnorthID, 5.0);
			//rmSetAreaMaxBlobDistance(forestnorthID, 20.0);
			rmSetAreaCoherence(forestnorthID, 0.4);
			rmSetAreaSmoothDistance(forestnorthID, 10);
			rmAddAreaToClass(forestnorthID, rmClassID("classForest"));
			//rmAddAreaConstraint(forestID, northForestConstraint);  
			rmAddAreaConstraint(forestnorthID, avoidNatives);
			rmAddAreaConstraint(forestnorthID, avoidCinematicBlock);
			rmAddAreaConstraint(forestnorthID, shortAvoidImportantItem);
			rmAddAreaConstraint(forestnorthID, playerConstraint);
			rmAddAreaConstraint(forestnorthID, avoidGold);
			rmAddAreaConstraint(forestnorthID, avoidAll);
			rmAddAreaConstraint(forestnorthID, avoidImpassableLand);
			
			if(rmBuildArea(forestnorthID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==10)
					break;
			}
			else
				failCount=0; 

		}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ******************************* RESOURCES THAT CAN BE PLACED AFTER FORESTS: ********************************** //
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE BISONS: ****************************************** //
/*================================================================================================================*/
      int bisonID=rmCreateObjectDef("bison herd");
      rmAddObjectDefItem(bisonID, "bison", rmRandInt(12,16), 10.0);
      rmSetObjectDefMinDistance(bisonID, 0.0);
	  rmSetObjectDefMaxDistance(bisonID, 0.0);
      rmAddObjectDefConstraint(bisonID, avoidBison);
	  rmSetObjectDefCreateHerd(bisonID, true);
	  // rmPlaceObjectDefAtLoc(bisonID, 0, 0.8, 0.25, 1.0);
	     rmPlaceObjectDefAtLoc(bisonID, 0, 0.75, 0.25, 1.0);
		 
	  int bison2ID=rmCreateObjectDef("bison herd 2");
      rmAddObjectDefItem(bison2ID, "bison", rmRandInt(12,16), 10.0);
      rmSetObjectDefMinDistance(bison2ID, 0.0);
	  rmSetObjectDefMaxDistance(bison2ID, 0.0);
      rmAddObjectDefConstraint(bison2ID, avoidBison);
	  rmSetObjectDefCreateHerd(bison2ID, true);
	  // rmPlaceObjectDefAtLoc(bison2ID, 0, 0.8, 0.75, 1.0);
         rmPlaceObjectDefAtLoc(bison2ID, 0, 0.75, 0.70, 1.0);		  
	  
	  int bison3ID=rmCreateObjectDef("bison herd 3");
      rmAddObjectDefItem(bison3ID, "bison", rmRandInt(10,12), 8.0);
      rmSetObjectDefMinDistance(bison3ID, 0.0);
	  rmSetObjectDefMaxDistance(bison3ID, 0.0);
      rmAddObjectDefConstraint(bison3ID, avoidBison);
	  rmSetObjectDefCreateHerd(bison3ID, true);
	  rmPlaceObjectDefAtLoc(bison3ID, 0, 0.6, 0.9, 1.0);

      int bison4ID=rmCreateObjectDef("bison herd 4");
      rmAddObjectDefItem(bison4ID, "bison", rmRandInt(10,12), 8.0);
      rmSetObjectDefMinDistance(bison4ID, 0.0);
	  rmSetObjectDefMaxDistance(bison4ID, 0.0);
      rmAddObjectDefConstraint(bison4ID, avoidBison);
	  rmSetObjectDefCreateHerd(bison4ID, true);
	  rmPlaceObjectDefAtLoc(bison4ID, 0, 0.30, 0.80, 1.0);

      int bison5ID=rmCreateObjectDef("bison herd 5");
      rmAddObjectDefItem(bison5ID, "bison", rmRandInt(10,12), 8.0);
      rmSetObjectDefMinDistance(bison5ID, 0.0);
	  rmSetObjectDefMaxDistance(bison5ID, 0.0);
      rmAddObjectDefConstraint(bison5ID, avoidBison);
	  rmSetObjectDefCreateHerd(bison5ID, true);
	  rmPlaceObjectDefAtLoc(bison5ID, 0, 0.6, 0.08, 1.0);

      int bison6ID=rmCreateObjectDef("bison herd 6");
      rmAddObjectDefItem(bison6ID, "bison", rmRandInt(10,12), 8.0);
      rmSetObjectDefMinDistance(bison6ID, 0.0);
	  rmSetObjectDefMaxDistance(bison6ID, 0.0);
      rmAddObjectDefConstraint(bison6ID, avoidBison);
	  rmSetObjectDefCreateHerd(bison6ID, true);
	  rmPlaceObjectDefAtLoc(bison6ID, 0, 0.34, 0.08, 1.0);	  	  

      int bisoncenterID=rmCreateObjectDef("bison center herd ");
      rmAddObjectDefItem(bisoncenterID, "bison", rmRandInt(12,18), 16.0);
      rmSetObjectDefMinDistance(bisoncenterID, 0.0);
	  rmSetObjectDefMaxDistance(bisoncenterID, 0.0);
      rmAddObjectDefConstraint(bisoncenterID, avoidBison);
	  rmAddObjectDefConstraint(bisoncenterID, avoidNugget);
	  rmSetObjectDefCreateHerd(bisoncenterID, true);
	  rmPlaceObjectDefAtLoc(bisoncenterID, 0, 0.5, 0.5, 1.0);			 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
	}  
}  
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************ THIS IS THE END OF THE MAP: ********************************************* //
/*----------------------------------------------------------------------------------------------------------------*/