/*================================================================================================================*/
// ********************************* THESE ARE THE INFORMATIONS OF THE MAP: ************************************* //
/*================================================================================================================*/

// THE SOUTH SEAS:
// CREATED BY DANY:
// AUGUST 2007:
// A RANDOM MAP FOR AGE OF EMPIRES III: MY 60TH RMS:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// *********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE WHICHVARIATION:
		// ONLY 2 VARIATIONS:
		int whichVariation=rmRandInt(1,2);		
		
/*----------------------------------------------------------------------------------------------------------------*/		

        if (rmAllocateSubCivs(4) == true)
		
{
		if ( whichVariation == 1 )
	{	
		subCiv0=rmGetCivID("Incas");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Incas");
		
		subCiv1=rmGetCivID("Tupi");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Tupi");
		
		subCiv2=rmGetCivID("Tupi");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Tupi");
		
		subCiv3=rmGetCivID("Incas");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Incas");
	}
	
        else
		
	{	
		subCiv0=rmGetCivID("Caribs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Caribs");
				
		subCiv1=rmGetCivID("Caribs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Caribs");
		
		subCiv2=rmGetCivID("Caribs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Caribs");

		subCiv3=rmGetCivID("Caribs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Caribs");
	}	
} 		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
        int playerTiles = 17500;
	
	    int size=1.8*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
		
	{	
		// PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(3.0);
   
        // SET SEA TYPE:
		rmSetSeaType("Amazon River Basin");
	    
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    rmSetBaseTerrainMix("amazon grass");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water");
	    
		// SET LIGHTING:
		rmSetLightingSet("amazon");
			    
		// SET MAP TYPE:
		rmSetMapType("amazonia");
	    rmSetMapType("tropical");
		rmSetMapType("water");
	    	    
		// SET WORLD CIRCLE CCONSTRAINT:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
	    chooseMercs();
	}
        else
		
	{
        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(3.0);
             
		// SET SEA TYPE:
		rmSetSeaType("caribbean coast");
			    
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    rmSetBaseTerrainMix("caribbean grass");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water");
	    
		// SET LIGHTING:
		rmSetLightingSet("caribbean");
					    
		// SET MAP TYPE:
		rmSetMapType("caribbean");
	    rmSetMapType("grass");
	    rmSetMapType("water");
			    	    
		// SET WORLD CIRCLE CCONSTRAINT:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
	    chooseMercs();	
    }
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
	    
		rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("startingUnit");
		rmDefineClass("natives");
	    
	    int classIsland=rmDefineClass("island");
	    	    		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// *********************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: *************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// MAP EDGE CONSTRAINTS:
	    int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
	    int islandEdgeConstraint=rmCreateBoxConstraint("islands in center", 0.30, 0.30, 0.70, 0.70, 0.01);
	    int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 24.0);
	    int avoidTC=rmCreateTypeDistanceConstraint("avoid TC", "towncenter", 15.0);
	    int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));


	    // PLAYER CONSTRAINTS:
	    int islandConstraint=rmCreateClassDistanceConstraint("stay away from islands", classIsland, 10.0);
	    int playerConstraint=rmCreateClassDistanceConstraint("bonus Settlement stay away from players", classPlayer, 10);
	    int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
	    
		// FLAG AVOIDANCE:
		int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 20.0);
		int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 10.0);
        int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
        int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-180, rmGetMapXSize()-40, 0, 0, 0);
  		
		int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
	    
		// STARTING UNITS AVOIDANCE:
		int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);

	    // FOREST AVOIDANCE:
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
	    
		// RESOURCES AVOIDANCE:
		int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
		int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);

	    // SILVER MINES AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "mine", 15.0);
	    int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "mine", 45.0);
	    int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "mine", 5.0);
		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 6.0);
				
		// COWS AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
		
		// SHEEPS AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateTypeDistanceConstraint("trees avoids trees", "treeamazon", 10.0);
		int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoids trees", "treeamazon", 2.0);
	    
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 20.0);
	    
		// FOOD AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("food avoids food", "deer", 50.0);
	    int avoidTurkey=rmCreateTypeDistanceConstraint("food avoids turkey", "turkey", 30.0);
	    
		// AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	    int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 3.0);
	    
		// DECORATION AVOIDANCE:
	    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	    // VP AVOIDANCE:
	    int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
	    int shortAvoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other short", rmClassID("importantItem"), 8.0);

	    // CONSTRAINT TO AVOID WATER:
	    int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE AREAS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
  
        // DEFINE AND PLACE THE NORTH ISLAND:
		int NorthIslandID=rmCreateArea("The North Island");
		rmSetAreaSize(NorthIslandID, rmAreaTilesToFraction(6000), rmAreaTilesToFraction(6000));
		rmSetAreaLocation(NorthIslandID, 0.675, 0.675);
		
		if ( whichVariation == 1 )
        rmSetAreaMix(NorthIslandID, "amazon grass");
        else
		rmSetAreaMix(NorthIslandID, "caribbean grass");
		
		rmSetAreaWarnFailure(NorthIslandID, false);
        rmAddAreaToClass(NorthIslandID, classIsland);
        rmSetAreaCoherence(NorthIslandID, 0.85);
        rmSetAreaSmoothDistance(NorthIslandID, 20);
	    rmSetAreaBaseHeight(NorthIslandID, 4.0);
		rmSetAreaElevationType(NorthIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(NorthIslandID, 4.0);
        rmSetAreaElevationMinFrequency(NorthIslandID, 0.09);
        rmSetAreaElevationOctaves(NorthIslandID, 3);
        rmSetAreaElevationPersistence(NorthIslandID, 0.2);
		rmSetAreaElevationNoiseBias(NorthIslandID, 1);
	    rmBuildArea(NorthIslandID);
		
		// DEFINE AND PLACE THE SOUTH ISLAND:
		int SouthIslandID=rmCreateArea("The South Island");
		rmSetAreaSize(SouthIslandID, rmAreaTilesToFraction(6000), rmAreaTilesToFraction(6000));
		rmSetAreaLocation(SouthIslandID, 0.325, 0.325);
		
		if ( whichVariation == 1 )
        rmSetAreaMix(SouthIslandID, "amazon grass");
        else
		rmSetAreaMix(SouthIslandID, "caribbean grass");
        
		rmSetAreaWarnFailure(SouthIslandID, false);
        rmAddAreaToClass(SouthIslandID, classIsland);
        rmSetAreaCoherence(SouthIslandID, 0.85);
        rmSetAreaSmoothDistance(SouthIslandID, 20);
	    rmSetAreaBaseHeight(SouthIslandID, 4.0);
		rmSetAreaElevationType(SouthIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(SouthIslandID, 4.0);
        rmSetAreaElevationMinFrequency(SouthIslandID, 0.09);
        rmSetAreaElevationOctaves(SouthIslandID, 3);
        rmSetAreaElevationPersistence(SouthIslandID, 0.2);
		rmSetAreaElevationNoiseBias(SouthIslandID, 1);
	    rmBuildArea(SouthIslandID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// *********************************** DEFINE AND PLACE THE NATIVES TRIBES: ************************************* //
/*================================================================================================================*/
        
		// DEFINE THE ISLAND NUMBER 1:
		int smallIslandNative1=rmCreateArea("small island native 1");
		rmSetAreaSize(smallIslandNative1, rmAreaTilesToFraction(2000), rmAreaTilesToFraction(2000));
		rmSetAreaLocation(smallIslandNative1, 0.175, 0.625);
		
		if ( whichVariation == 1 )
		rmSetAreaMix(smallIslandNative1, "amazon grass");
		else
		rmSetAreaMix(smallIslandNative1, "caribbean grass");
				
		rmSetAreaWarnFailure(smallIslandNative1, false);
		rmAddAreaToClass(smallIslandNative1, classIsland);
		rmSetAreaCoherence(smallIslandNative1, 0.85);
		rmSetAreaSmoothDistance(smallIslandNative1, 12);
		//rmSetAreaElevationType(smallIslandNative1, cElevTurbulence);
		//rmSetAreaElevationVariation(smallIslandNative1, 2.0);
		rmSetAreaBaseHeight(smallIslandNative1, 4.0);
		rmBuildArea(smallIslandNative1);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		if ( whichVariation == 1 )
	
{	    
        if (subCiv0 == rmGetCivID("Incas"))
	{	
	    int inca1VillageID = -1;
		inca1VillageID = rmCreateGrouping("inca village 1", "native inca village 1");
		rmSetGroupingMinDistance(inca1VillageID, 0.0);
		rmSetGroupingMaxDistance(inca1VillageID, 0.0);
		rmAddGroupingToClass(inca1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(inca1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(inca1VillageID, 0, 0.175, 0.625);
	} 
}        
		else
{		
    	if (subCiv0 == rmGetCivID("Caribs"))
	{  
		int caribs1VillageID = -1;
		caribs1VillageID = rmCreateGrouping("caribs village 1", "native carib village 1");
		rmSetGroupingMinDistance(caribs1VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs1VillageID, 0.0);
		rmAddGroupingToClass(caribs1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribs1VillageID, 0, 0.175, 0.625);
	} 
}
	
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE ISLAND NUMBER 2:
		int smallIslandNative2=rmCreateArea("small island native 2");
		rmSetAreaSize(smallIslandNative2, rmAreaTilesToFraction(2000), rmAreaTilesToFraction(2000));
		rmSetAreaLocation(smallIslandNative2, 0.375, 0.825);
		
		if ( whichVariation == 1 )
		rmSetAreaMix(smallIslandNative2, "amazon grass");
		else
		rmSetAreaMix(smallIslandNative2, "caribbean grass");
		 
		rmSetAreaWarnFailure(smallIslandNative2, false);
		rmAddAreaToClass(smallIslandNative2, classIsland);
		rmSetAreaCoherence(smallIslandNative2, 0.85);
		rmSetAreaSmoothDistance(smallIslandNative2, 12);
		//rmSetAreaElevationType(smallIslandNative2, cElevTurbulence);
		//rmSetAreaElevationVariation(smallIslandNative2, 2.0);
		rmSetAreaBaseHeight(smallIslandNative2, 4.0);
		rmBuildArea(smallIslandNative2);
		
/*----------------------------------------------------------------------------------------------------------------*/
	    if ( whichVariation == 1 )
	
{	    
        if (subCiv1 == rmGetCivID("Tupi"))
		
	{	
	    int tupi2VillageID = -1;
		tupi2VillageID = rmCreateGrouping("tupi village 2", "native tupi village 1");
		rmSetGroupingMinDistance(tupi2VillageID, 0.0);
		rmSetGroupingMaxDistance(tupi2VillageID, 0.0);
		rmAddGroupingToClass(tupi2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(tupi2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(tupi2VillageID, 0, 0.375, 0.825);
	} 
}        
		else
		
{  
	    if (subCiv1 == rmGetCivID("Caribs"))
		
	{	
	    int caribs2VillageID = -1;
		caribs2VillageID = rmCreateGrouping("caribs village 2", "native carib village 1");
		rmSetGroupingMinDistance(caribs2VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs2VillageID, 0.0);
		rmAddGroupingToClass(caribs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribs2VillageID, 0, 0.375, 0.825);
	}	
} 			
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE ISLAND NUMBER 3:
		int smallIslandNative3=rmCreateArea("small island native 3");
		rmSetAreaSize(smallIslandNative3, rmAreaTilesToFraction(2000), rmAreaTilesToFraction(2000));
		rmSetAreaLocation(smallIslandNative3, 0.825, 0.375);
		
		if ( whichVariation == 1 )
		rmSetAreaMix(smallIslandNative3, "amazon grass");
		else
		rmSetAreaMix(smallIslandNative3, "caribbean grass");
		
		rmSetAreaWarnFailure(smallIslandNative3, false);
		rmAddAreaToClass(smallIslandNative3, classIsland);
		rmSetAreaCoherence(smallIslandNative3, 0.85);
		rmSetAreaSmoothDistance(smallIslandNative3, 12);
		rmSetAreaBaseHeight(smallIslandNative3, 4.0);
		rmBuildArea(smallIslandNative3);

/*----------------------------------------------------------------------------------------------------------------*/

	    if ( whichVariation == 1 )
{		
	    if (subCiv2 == rmGetCivID("Tupi"))
	{	
	    int tupi3VillageID = -1;
		tupi3VillageID = rmCreateGrouping("tupi village 3", "native tupi village 1");
		rmSetGroupingMinDistance(tupi3VillageID, 0.0);
		rmSetGroupingMaxDistance(tupi3VillageID, 0.0);
		rmAddGroupingToClass(tupi3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(tupi3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(tupi3VillageID, 0, 0.825, 0.375);
	} 
}	
		
		else
		
{		
		if (subCiv2 == rmGetCivID("Caribs"))
	{  
		int caribs3VillageID = -1;
		caribs3VillageID = rmCreateGrouping("caribs village 3", "native carib village 1");
		rmSetGroupingMinDistance(caribs3VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs3VillageID, 0.0);
		rmAddGroupingToClass(caribs3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribs3VillageID, 0, 0.825, 0.375);
	} 
}

/*----------------------------------------------------------------------------------------------------------------*/	
		
		// DEFINE THE ISLAND NUMBER 4:
		int smallIslandNative4=rmCreateArea("small island native 4");
		rmSetAreaSize(smallIslandNative4, rmAreaTilesToFraction(2000), rmAreaTilesToFraction(2000));
		rmSetAreaLocation(smallIslandNative4, 0.625, 0.175);
		
		if ( whichVariation == 1 )
		rmSetAreaMix(smallIslandNative4, "amazon grass");
		else
		rmSetAreaMix(smallIslandNative4, "caribbean grass");
		
		rmSetAreaWarnFailure(smallIslandNative4, false);
		rmAddAreaToClass(smallIslandNative4, classIsland);
		rmSetAreaCoherence(smallIslandNative4, 0.85);
		rmSetAreaSmoothDistance(smallIslandNative4, 12);
		//rmSetAreaElevationType(smallIslandNative4, cElevTurbulence);
		//rmSetAreaElevationVariation(smallIslandNative4, 2.0);
		rmSetAreaBaseHeight(smallIslandNative4, 4.0);
		rmBuildArea(smallIslandNative4);
		
/*----------------------------------------------------------------------------------------------------------------*/		
       
	    if ( whichVariation == 1 )

{		
	    if (subCiv3 == rmGetCivID("Incas"))
	{	
	    int inca4VillageID = -1;
		inca4VillageID = rmCreateGrouping("inca village 4", "native inca village 1");
		rmSetGroupingMinDistance(inca4VillageID, 0.0);
		rmSetGroupingMaxDistance(inca4VillageID, 0.0);
		rmAddGroupingToClass(inca4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(inca4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(inca4VillageID, 0, 0.625, 0.175);
	} 
}	
		
		else
		
{		
		if (subCiv3 == rmGetCivID("Caribs"))
	{  
		int caribs4VillageID = -1;
		caribs4VillageID = rmCreateGrouping("caribs village 4", "native carib village 1");
		rmSetGroupingMinDistance(caribs4VillageID, 0.0);
		rmSetGroupingMaxDistance(caribs4VillageID, 0.0);
		rmAddGroupingToClass(caribs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribs4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribs4VillageID, 0, 0.625, 0.175);
	} 
}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ******************** DEFINE THE STARTING UNITS AND STARTING TCID AND STARTING RESOURCES: ********************* //
/*================================================================================================================*/
	    
        rmClearClosestPointConstraints();
		
		// DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 2.0);
	    rmSetObjectDefMaxDistance(startingUnits, 4.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefToClass(startingUnits, rmClassID("player"));

	    // DEFINE THE STARTING TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
		{
			rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
		}
		else
		{
            rmAddObjectDefItem(TCID, "townCenter", 1, 0);
		}
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);
	    rmAddObjectDefToClass(TCID, rmClassID("player"));
	    rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));
		
/*----------------------------------------------------------------------------------------------------------------*/
		
		
/*----------------------------------------------------------------------------------------------------------------*/

        // WATER HC ARRIVAL POINT:

        int waterFlagID = 0;
        for(i=1; <cNumberPlayers)
    {
        waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
	}  		
		
/*---------------------------------------------------------------------------------------------------------------*/		
        
		if ( whichVariation == 1 )
	{    
		// DEFINE THE PLAYER GOLD:
		int playerGoldID = rmCreateObjectDef("player gold");
	    rmAddObjectDefItem(playerGoldID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(playerGoldID, 0.0);
	    rmSetObjectDefMaxDistance(playerGoldID, 0.0);
	    rmAddObjectDefToClass(playerGoldID, rmClassID("startingUnit"));
	    		
		rmPlaceObjectDefAtLoc(playerGoldID, 0, 0.675, 0.725);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, 0.675, 0.625);
		
		rmPlaceObjectDefAtLoc(playerGoldID, 0, 0.325, 0.375);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, 0.325, 0.275);
	}
        else
    {
	    // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmSetObjectDefMinDistance(playerSilverID, 0.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 0.0);
	    rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	    		
		rmPlaceObjectDefAtLoc(playerSilverID, 0, 0.675, 0.725);
		rmPlaceObjectDefAtLoc(playerSilverID, 0, 0.675, 0.625);
		
		rmPlaceObjectDefAtLoc(playerSilverID, 0, 0.325, 0.375);
		rmPlaceObjectDefAtLoc(playerSilverID, 0, 0.325, 0.275);
    }    	
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
		
		if ( whichVariation == 1 )
		rmAddObjectDefItem(StartAreaTreeID, "treeamazon", rmRandInt(15,20), 9.0);
		else
		rmAddObjectDefItem(StartAreaTreeID, "treeCaribbean", rmRandInt(15,20), 9.0);
	    	    
		rmSetObjectDefMinDistance(StartAreaTreeID, 0.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 0.0);
	    rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.675, 0.785);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.675, 0.565);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.565, 0.675);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.785, 0.675);
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.625, 0.785);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.625, 0.565);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.725, 0.785);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.725, 0.565);
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.565, 0.725);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.565, 0.625);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.785, 0.725);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.785, 0.625);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.215, 0.325);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.435, 0.325);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.325, 0.215);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.325, 0.435);
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.275, 0.435);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.375, 0.435);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.275, 0.215);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.375, 0.215);
		
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.215, 0.375);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.435, 0.375);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.215, 0.275);
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, 0.435, 0.275);
		
/*----------------------------------------------------------------------------------------------------------------*/

	    // DEFINE THE STARTING BERRIES:
		int startBerryID=rmCreateObjectDef("starting Berries");
	    rmAddObjectDefItem(startBerryID, "berrybush", rmRandInt(3,5), 4.0);
	    rmSetObjectDefCreateHerd(startBerryID, true);
	    rmSetObjectDefMinDistance(startBerryID, 0.0);
	    rmSetObjectDefMaxDistance(startBerryID, 0.0);
	    rmAddObjectDefToClass(startBerryID, rmClassID("startingUnit"));
	    
		rmPlaceObjectDefAtLoc(startBerryID, 0, 0.625, 0.675);
		rmPlaceObjectDefAtLoc(startBerryID, 0, 0.725, 0.675);
		
		rmPlaceObjectDefAtLoc(startBerryID, 0, 0.275, 0.325);
		rmPlaceObjectDefAtLoc(startBerryID, 0, 0.375, 0.325);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		if ( whichVariation == 1 )
	{	
		// DEFINE THE STARTING SHEEPS:
		int startSheepID=rmCreateObjectDef("starting Sheeps");
	    rmAddObjectDefItem(startSheepID, "sheep", rmRandInt(5,7), 5.0);
	    rmSetObjectDefCreateHerd(startSheepID, true);
	    rmSetObjectDefMinDistance(startSheepID, 0.0);
	    rmSetObjectDefMaxDistance(startSheepID, 0.0);
	    rmAddObjectDefToClass(startSheepID, rmClassID("startingUnit"));
	    
		rmPlaceObjectDefAtLoc(startSheepID, 0, 0.275, 0.275);
		rmPlaceObjectDefAtLoc(startSheepID, 0, 0.375, 0.375);
		
		rmPlaceObjectDefAtLoc(startSheepID, 0, 0.625, 0.625);
		rmPlaceObjectDefAtLoc(startSheepID, 0, 0.725, 0.725);
		
	}
        else
    {
	    // DEFINE THE STARTING COWS:
		int startCowID=rmCreateObjectDef("starting Cows");
	    rmAddObjectDefItem(startCowID, "cow", rmRandInt(5,7), 5.0);
	    rmSetObjectDefCreateHerd(startCowID, true);
	    rmSetObjectDefMinDistance(startCowID, 0.0);
	    rmSetObjectDefMaxDistance(startCowID, 0.0);
	    rmAddObjectDefToClass(startCowID, rmClassID("startingUnit"));
	    
		rmPlaceObjectDefAtLoc(startCowID, 0, 0.275, 0.275);
		rmPlaceObjectDefAtLoc(startCowID, 0, 0.375, 0.375);
		
		rmPlaceObjectDefAtLoc(startCowID, 0, 0.625, 0.625);
		rmPlaceObjectDefAtLoc(startCowID, 0, 0.725, 0.725);
	}    
		
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE STARTING DEERS:
		int startDeerID=rmCreateObjectDef("starting Deers");
	    rmAddObjectDefItem(startDeerID, "deer", rmRandInt(7,9), 5.0);
	    rmSetObjectDefCreateHerd(startDeerID, true);
	    rmSetObjectDefMinDistance(startDeerID, 0.0);
	    rmSetObjectDefMaxDistance(startDeerID, 0.0);
	    rmAddObjectDefToClass(startDeerID, rmClassID("startingUnit"));
	    
		rmPlaceObjectDefAtLoc(startDeerID, 0, 0.275, 0.375);
		rmPlaceObjectDefAtLoc(startDeerID, 0, 0.375, 0.275);
		
		rmPlaceObjectDefAtLoc(startDeerID, 0, 0.625, 0.725);
		rmPlaceObjectDefAtLoc(startDeerID, 0, 0.725, 0.625);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *********************************** DEFINE THE SET UP STARTING LOCATIONS: ************************************ //
/*================================================================================================================*/
        
		if ( whichVariation == 1 )
									
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.675,0.675);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.325,0.325);
	}  
		else
    {		
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.325,0.325);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.675,0.675);
	} 	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ************************************* DEFINE THE SET UP PLAYER AREAS: **************************************** //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(6000);
        for(i=1; <cNumberPlayers)
   {
		// CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
		
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
		
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint); 
		
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA BASE HEIGHT:
		rmSetAreaBaseHeight(id, 4);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 0.85);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "andes\ground2_and");
		
		// SET AREA MIX:
		if ( whichVariation == 1 )
        rmSetAreaMix(id, "amazon grass");
        else
		rmSetAreaMix(id, "caribbean grass");
				
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
	    // Build the areas.
        rmBuildAllAreas(); 
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// ****************** PLACE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: **************** // 
/*================================================================================================================*/

        for(i=1; <cNumberPlayers)
		
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		//rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		//rmPlaceObjectDefAtLoc(startBerryID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		//rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	    rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	}
	    rmClearClosestPointConstraints(); 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE SILVER MINES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
	{	
		// THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.175, 0.675);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.675, 0.175);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.375, 0.875);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.875, 0.375);
	}
        else
    {
       
	     // THE SILVER MINE NUMBER 1:
		int silver1ID = rmCreateObjectDef("silver 1");
		rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver1ID, 0.0);
		rmSetObjectDefMaxDistance(silver1ID, 0.0);
		rmAddObjectDefConstraint(silver1ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.175, 0.675);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.675, 0.175);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.375, 0.875);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.875, 0.375);
	}		
		 	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE FOODS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE BERRIES NUMBER 1:
		int Berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(Berries1ID, "berrybush", rmRandInt(5,7), 4.0);
		rmSetObjectDefMinDistance(Berries1ID, 0.0);
		rmSetObjectDefMaxDistance(Berries1ID, 0.0);
		rmAddObjectDefConstraint(Berries1ID, avoidFruits);
				
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.175, 0.575);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.575, 0.175);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.375, 0.775);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.775, 0.375);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE TREES: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE TREES NUMBER 1:
		int Trees1ID = rmCreateObjectDef("The Trees 1");
		
		if ( whichVariation == 1 )
		rmAddObjectDefItem(Trees1ID, "treeamazon", rmRandInt(9,12), 6.0);
		else
		rmAddObjectDefItem(Trees1ID, "treeCaribbean", rmRandInt(9,12), 6.0);
		
		rmSetObjectDefMinDistance(Trees1ID, 0.0);
		rmSetObjectDefMaxDistance(Trees1ID, 0.0);
		rmAddObjectDefConstraint(Trees1ID, avoidTrees);
		
/*----------------------------------------------------------------------------------------------------------------*/		
				
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.125, 0.625);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.625, 0.125);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.225, 0.625);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.625, 0.225);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.125, 0.675);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.675, 0.125);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.125, 0.575);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.575, 0.125);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.225, 0.675);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.675, 0.225);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.225, 0.575);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.575, 0.225);
		
/*----------------------------------------------------------------------------------------------------------------*/		

		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.325, 0.825);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.825, 0.325);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.425, 0.825);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.825, 0.425);
        
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.325, 0.875);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.875, 0.325);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.325, 0.775);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.775, 0.325);

        rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.425, 0.875);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.875, 0.425);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.425, 0.775);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.775, 0.425);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*================================================================================================================*/

	    int nugget1= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMaxDistance(nugget1, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget1, avoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget1, avoidNugget);
  	    rmAddObjectDefConstraint(nugget1, avoidAll);
  	    rmAddObjectDefConstraint(nugget1, avoidWater8);
	    rmAddObjectDefConstraint(nugget1, avoidTC);
	    
		rmPlaceObjectDefInArea(nugget1, 0, NorthIslandID, 2*cNumberNonGaiaPlayers);
	    rmPlaceObjectDefInArea(nugget1, 0, SouthIslandID, 2*cNumberNonGaiaPlayers);
		
		rmPlaceObjectDefInArea(nugget1, 0, smallIslandNative1, cNumberNonGaiaPlayers);
		rmPlaceObjectDefInArea(nugget1, 0, smallIslandNative2, cNumberNonGaiaPlayers);
		rmPlaceObjectDefInArea(nugget1, 0, smallIslandNative3, cNumberNonGaiaPlayers);
		rmPlaceObjectDefInArea(nugget1, 0, smallIslandNative4, cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //
/*================================================================================================================*/
        
		int forestTreeID = 0;
        int numTries=15*cNumberNonGaiaPlayers;
        int failCount=0;
        for (i=0; <numTries)
      {   
        int forest=rmCreateArea("forest "+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));
        
		if ( whichVariation == 1 )
		rmSetAreaForestType(forest, "amazon rain forest");
		else
		rmSetAreaForestType(forest, "caribbean palm forest");
        
		rmSetAreaForestDensity(forest, 0.8);
        rmSetAreaForestClumpiness(forest, 0.0);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 1);
        rmSetAreaMinBlobDistance(forest, 1.0);
        rmSetAreaMaxBlobDistance(forest, 1.0);
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidCoin);
		rmAddAreaConstraint(forest, avoidGold);
		rmAddAreaConstraint(forest, avoidNugget);
		rmAddAreaConstraint(forest, avoidNatives);
        rmAddAreaConstraint(forest, avoidCloseImpassableLand); 
		rmAddAreaConstraint(forest, avoidTC); 
        if(rmBuildArea(forest)==false)
         {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
         }
        else
        failCount=0; 
      } 
	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FISH AND THE WHALES: ********************************* //
/*================================================================================================================*/

        // DEFINE THE FISH AND WHALES CONSTRAINTS:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 16.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 80.0);
		int whale2VsWhale2ID=rmCreateTypeDistanceConstraint("whale2 v whale2", "HumpbackWhale", 80.0);
		int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 30.0);
	
/*----------------------------------------------------------------------------------------------------------------*/		

        // FISHBASS -- FOOD:
		int fishID=rmCreateObjectDef("fish");
        
		if ( whichVariation == 1 )
		rmAddObjectDefItem(fishID, "FishBass", 5, 10.0);
        else
		rmAddObjectDefItem(fishID, "FishMahi", 5, 10.0);
		
		rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*25);
		
/*----------------------------------------------------------------------------------------------------------------*/		


	    // FAST COIN -- WHALES:
		
		if ( whichVariation == 1 )
	{	
	    int whaleID=rmCreateObjectDef("whale 1");
        rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
		rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
	}	
	    else
	{
        int whale2ID=rmCreateObjectDef("whale 2");
        rmAddObjectDefItem(whale2ID, "HumpbackWhale", 1, 9.0);
		rmSetObjectDefMinDistance(whale2ID, 0.0);
        rmSetObjectDefMaxDistance(whale2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whale2ID, whale2VsWhale2ID);
        rmAddObjectDefConstraint(whale2ID, whaleLand);
        rmPlaceObjectDefAtLoc(whale2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
    }		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*================================================================================================================*/  
