/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// THE VIRGIN ISLAND:
// CREATED BY DANY:
// OCTOBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ******************************** CHOOSE WHICH NATIVE TRIBES APPEAR ON THE MAP: ******************************* //
/*================================================================================================================*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(4) == true)
		
  {
		subCiv0=rmGetCivID("Caribs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Caribs");
		
		subCiv1=rmGetCivID("Caribs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Caribs");
		
		subCiv2=rmGetCivID("Caribs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Caribs");
		
		subCiv3=rmGetCivID("Caribs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Caribs");
  }
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //	
/*================================================================================================================*/
        
		int playerTiles = 22500;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(600, 600);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** PICKS THE MAPS PARAMETERS: ****************************************** //	
/*================================================================================================================*/
        
		// SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.05, 10, 0.4, 7.0);
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
	
	    // SET SEA LEVEL:
		rmSetSeaLevel(2.0);
	    
		// SET SEA TYPE:
		rmSetSeaType("Atlantic Coast");
		
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("caribbean grass");
		
		// TERRAIN INITIALIZATION:
	    rmTerrainInitialize("water");
		
		// SET LIGHTING:
		rmSetLightingSet("caribbean");
	    
		// SET MAP TYPE:
		rmSetMapType("caribbean");
	    rmSetMapType("grass");
		rmSetMapType("water");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(3.0);

	    // CHOOSE MERCS:
		chooseMercs();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/

        int classPlayer=rmDefineClass("player");
		rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
        int classIsland=rmDefineClass("island");
        rmDefineClass("natives");
        rmDefineClass("classSocket");
        rmDefineClass("classTrees");		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

    // MAP EDGE CONSTRAINTS:
	int playerEdgeConstraint=rmCreatePieConstraint("stuff edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
   	int playerCloseEdgeConstraint=rmCreatePieConstraint("close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
   
	//int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(12), rmZTilesToFraction(12), 1.0-rmXTilesToFraction(12), 1.0-rmZTilesToFraction(12), 0.01);

	// PLAYER CONSTRAINTS:
	int playerConstraint=rmCreateClassDistanceConstraint("stuff avoid players", classPlayer, 20.0);
	int playerCloseConstraint=rmCreateClassDistanceConstraint("close avoid players", classPlayer, 5.0);
	
	// ISLAND AVOIDANCE:
	int islandConstraint=rmCreateClassDistanceConstraint("islands avoid each other", classIsland, 15.0);
  	
	// STARTING UNITS AVOIDANCE:
	int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
	int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close avoid starting units", rmClassID("startingUnit"), 10.0);
	int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium avoid starting units", rmClassID("startingUnit"), 25.0);
	
    // FOREST AVOIDANCE:
	int forestConstraint=rmCreateClassDistanceConstraint("stuff avoid avoid forest", rmClassID("classForest"), 15.0);
	int forestCloseConstraint=rmCreateClassDistanceConstraint("close avoid forest", rmClassID("classForest"), 10.0);
    int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close avoid forest", rmClassID("classForest"), 5.0);
	int forestCloseMediumConstraint=rmCreateClassDistanceConstraint("close medium avoid forest", rmClassID("classForest"), 25.0);
    int forestMediumConstraint=rmCreateClassDistanceConstraint("medium avoid forest", rmClassID("classForest"), 35.0);

	// TREES AVOIDANCE:
	int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 15.0);
	int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 8.0);
	int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 3.0);
	int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
	int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
	int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
		
	// DEER AVOIDANCE:
	int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoid deer", "deer", 20.0);
	int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoid deer", "deer", 10.0);
	int avoidVerycloseDeer=rmCreateTypeDistanceConstraint("very close avoid deer", "deer", 5.0);
	int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoid deer", "deer", 30.0);
	int avoidFarDeer=rmCreateTypeDistanceConstraint("far avoid deer", "deer", 45.0);
	int avoidVeryFarDeer=rmCreateTypeDistanceConstraint("very far avoid deer", "deer", 60.0);
	int avoidsuperFarDeer=rmCreateTypeDistanceConstraint("super far avoid deer", "deer", 75.0);
	
	// SILVER AVOIDANCE:
	int avoidSilver=rmCreateTypeDistanceConstraint("avoid silver", "minegold", 15.0);
	
	// SILVER COIN AVOIDANCE:
	int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "mine", 20.0);
	int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "mine", 10.0);
	int avoidVeryCloseCoin=rmCreateTypeDistanceConstraint("very close avoid coin", "mine", 5.0);
	int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "mine", 30.0);
	int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "mine", 60.0);
	int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoid coin", "mine", 90.0);
	int avoidSuperFarCoin=rmCreateTypeDistanceConstraint("super far avoid coin", "mine", 120.0);
       
    // NUGGET AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("stuff vs. nugget", "AbstractNugget", 20.0);
	int avoidCloseNugget=rmCreateTypeDistanceConstraint("close vs. nugget", "AbstractNugget", 10.0);
	int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close vs. nugget", "AbstractNugget", 5.0);
	int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium vs. nugget", "AbstractNugget", 30.0);
	int avoidFarNugget=rmCreateTypeDistanceConstraint("far vs. nugget", "AbstractNugget", 45.0);
	int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far vs. nugget", "AbstractNugget", 60.0);
	int avoidSuperFarNugget=rmCreateTypeDistanceConstraint("super far vs. nugget", "AbstractNugget", 75.0);
	
	// BERRYBUSH AVOIDANCE:
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids berrybush", "BerryBush", 25.0);
	int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids berrybush", "BerryBush", 15.0);
	int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoids berrybush", "BerryBush", 8.0);
	int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoids berrybush", "BerryBush", 35.0);
	int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoids berrybush", "BerryBush", 60.0);
	int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoids berrybush", "BerryBush", 90.0);
	
	// BERRYBUSH AVOIDANCE:
	//int avoidBerries=rmCreateTypeDistanceConstraint("avoid berries", "berrybush", 15.0);
	
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 20.0);
	int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 10.0);
	int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close avoids natives", rmClassID("natives"), 5.0);
	int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 30.0);
	int avoidFarNatives=rmCreateClassDistanceConstraint("far avoids natives", rmClassID("natives"), 45.0);
	int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far avoids natives", rmClassID("natives"), 60.0);
	int avoidSuperFarNatives=rmCreateClassDistanceConstraint("super far avoids natives", rmClassID("natives"), 75.0);
	
	// CIRCLE CONSTRAINT:
	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.48), rmDegreesToRadians(0), rmDegreesToRadians(360));

	// UNIT AVOIDANCE:
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 90.0);
	
	// GENERAL AVOIDANCE:
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 7.0);
    int avoidLand = rmCreateTerrainDistanceConstraint("ship avoid land", "land", true, 15.0);
	
	// AVOID IMPASSABLE LAND:
    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 1.0);
   
	
	// CONSTRAINT TO AVOID WATER:
	int avoidWater1 = rmCreateTerrainDistanceConstraint("avoid water 1", "Land", false, 1.0);
    int avoidWater5 = rmCreateTerrainDistanceConstraint("avoid water 5", "Land", false, 5.0);
    int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water 10", "Land", false, 10.0);
	int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water 15", "Land", false, 15.0);
	
	// FISH AND WHALE CONSTRAINTS:
    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "Abstractfish", 15.0);	
	int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
  
    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "Abstractwhale", 60.0);
	int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 20.0);
    int whaleEdgeConstraint=rmCreatePieConstraint("whale edge of map", 0.5, 0.5, 0, rmGetMapXSize()-20, 0, 0, 0);

    // FLAG CONSTRAINTS:
    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 18.0);
    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 25.0);
	int flagEdgeConstraint=rmCreatePieConstraint("flag edge of map", 0.5, 0.5, rmGetMapXSize()-25, rmGetMapXSize()-10, 0, rmDegreesToRadians(0), rmDegreesToRadians(180));
	
	// TRADE ROUTE AVOIDANCE:
    int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 15.0);
	int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 8.0);
	int avoidVeryCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("very close trade route", 3.0);
	int avoidMediumTradeRoute = rmCreateTradeRouteDistanceConstraint("medium trade route", 30.0);
	int avoidFarTradeRoute = rmCreateTradeRouteDistanceConstraint("far trade route", 45.0);
	int avoidVeryFarTradeRoute = rmCreateTradeRouteDistanceConstraint("very far trade route", 60.0);
	int avoidSuperFarTradeRoute = rmCreateTradeRouteDistanceConstraint("super far trade route", 75.0);
    
	// SOCKET AVOIDANCE:
	int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 15.0);
    int avoidCloseSocket = rmCreateClassDistanceConstraint("close avoid socket", rmClassID("classSocket"), 8.0);
    int avoidVeryCloseSocket = rmCreateClassDistanceConstraint("very close avoid socket", rmClassID("classSocket"), 3.0);
	int avoidMediumSocket = rmCreateClassDistanceConstraint("Medium avoid socket", rmClassID("classSocket"), 30.0);
	int avoidFarSocket = rmCreateClassDistanceConstraint("far avoid socket", rmClassID("classSocket"), 45.0);
	int avoidVeryFarSocket = rmCreateClassDistanceConstraint("very far avoid socket", rmClassID("classSocket"), 60.0);
	int avoidSuperFarSocket = rmCreateClassDistanceConstraint("super far avoid socket", rmClassID("classSocket"), 75.0);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ********************************** DEFINE SOME OBJECTS TO BE PLACED LATER: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// DONE DEFINING SOME OBJECTS TO BE PLACED LATER: 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ********************************************** MAKE THE ISLAND: ********************************************** //	
/*================================================================================================================*/
        
		int mainIslandID=rmCreateArea("indochina");
  	    rmSetAreaSize(mainIslandID, 0.7, 0.7);
		rmSetAreaCoherence(mainIslandID, 0.85);
	    rmSetAreaBaseHeight(mainIslandID, 2.0);
        //rmSetAreaLocation(mainIslandID, .5, .75);
		rmSetAreaLocation(mainIslandID, .715, .715);
	    rmSetAreaSmoothDistance(mainIslandID, 20);
		rmSetAreaMix(mainIslandID, "caribbean grass");
	    //rmSetAreaMix(mainIslandID, "saguenay grass");
        //rmAddAreaTerrainLayer(mainIslandID, "borneo\ground_sand1_borneo", 0, 4);
        //rmAddAreaTerrainLayer(mainIslandID, "borneo\ground_sand2_borneo", 4, 6);
        //rmAddAreaTerrainLayer(mainIslandID, "borneo\ground_sand3_borneo", 6, 9);
        //rmAddAreaTerrainLayer(mainIslandID, "borneo\ground_grass4_borneo", 9, 12);
	    rmSetAreaObeyWorldCircleConstraint(mainIslandID, false);
	    rmSetAreaElevationType(mainIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(mainIslandID, 3.0);
	    rmSetAreaElevationMinFrequency(mainIslandID, 0.09);
	    rmSetAreaElevationOctaves(mainIslandID, 3);
	    rmSetAreaElevationPersistence(mainIslandID, 0.2);
	    rmSetAreaElevationNoiseBias(mainIslandID, 1);

        // LENGHT OF PENINSULA:
        //rmAddAreaInfluenceSegment(mainIslandID, 0.5, 1.0, 0.5, 0.3);
		rmAddAreaInfluenceSegment(mainIslandID, 0.75, 0.95, 0.3, 0.5);
        //rmAddAreaInfluenceSegment(mainIslandID, 0.4, 1.0, 0.4, 0.3);
		rmAddAreaInfluenceSegment(mainIslandID, 0.80, 0.90, 0.35, 0.45);
        //rmAddAreaInfluenceSegment(mainIslandID, 0.3, 1.0, 0.3, 0.35);
		rmAddAreaInfluenceSegment(mainIslandID, 0.85, 0.85, 0.4, 0.4);
        //rmAddAreaInfluenceSegment(mainIslandID, 0.6, 1.0, 0.6, 0.3);
		rmAddAreaInfluenceSegment(mainIslandID, 0.90, 0.80, 0.45, 0.35);
        //rmAddAreaInfluenceSegment(mainIslandID, 0.7, 1.0, 0.7, 0.35);
		rmAddAreaInfluenceSegment(mainIslandID, 0.95, 0.75, 0.5, 0.3);
  
        // POINT OF PENINSULA:
        //rmAddAreaInfluenceSegment(mainIslandID, 0.0, 0.7, 0.5, 0.35);
		rmAddAreaInfluenceSegment(mainIslandID, 0.275, 1.0, 0.4, 0.4);
        //rmAddAreaInfluenceSegment(mainIslandID, 1.0, 0.7, 0.5, 0.35);
		rmAddAreaInfluenceSegment(mainIslandID, 1.0, 0.275, 0.4, 0.4);
  
        // BACK OF ISLAND:
        //rmAddAreaInfluenceSegment(mainIslandID, 1.0, 0.85, 0.0, 0.85);
		rmAddAreaInfluenceSegment(mainIslandID, 0.995, 0.475, 0.475, 0.995);
				
		rmAddAreaConstraint(mainIslandID, islandConstraint);

	    rmSetAreaWarnFailure(mainIslandID, false);
	    rmBuildArea(mainIslandID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.29);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE MAIN RIVER: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// *************************** DEFINE AND PLACE SOME INVISIBLE ISLAND FOR NATIVES: ****************************** //
/*================================================================================================================*/

  	    int westIslandID=rmCreateArea("invisible west island");

	    rmSetAreaSize(westIslandID, 0.22, 0.22);
		rmAddAreaToClass(westIslandID, classIsland);
	    rmSetAreaCoherence(westIslandID, 1.0);
        //rmSetAreaLocation(westIslandID, .3, .7);
		rmSetAreaLocation(westIslandID, .3, .875);
        //rmAddAreaConstraint(westIslandID, avoidImpassableLand);
		rmAddAreaConstraint(westIslandID, avoidWater1);
	    rmSetAreaWarnFailure(westIslandID, false);
		//rmSetAreaMix(westIslandID, "rockies_grass");
	    rmBuildArea(westIslandID);
		
		// ADD ISLAND CONSTRAINTS:
        int westIslandConstraint=rmCreateAreaConstraint("invisible west Island", westIslandID);
        		
/*----------------------------------------------------------------------------------------------------------------*/
  
        int eastIslandID=rmCreateArea("invisible east island");
		rmAddAreaToClass(eastIslandID, classIsland);
	    rmSetAreaSize(eastIslandID, 0.22, 0.22);
	    rmSetAreaCoherence(eastIslandID, 1.0);
        //rmSetAreaLocation(eastIslandID, .7, .7);
		rmSetAreaLocation(eastIslandID, .875, .3);
        //rmAddAreaConstraint(eastIslandID, avoidImpassableLand);
		rmAddAreaConstraint(eastIslandID, avoidWater1);
	    rmSetAreaWarnFailure(eastIslandID, false);
		//rmSetAreaMix(eastIslandID, "texas_dirt");
	    rmBuildArea(eastIslandID);
		
		// ADD ISLAND CONSTRAINTS:
        int eastIslandConstraint=rmCreateAreaConstraint("invisible east Island", eastIslandID);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		  
        // SET OCEAN REVEAL:
		rmSetOceanReveal(true);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************* PAINT SOME GRASS NEAR THE RIVER: *************************************** //
/*================================================================================================================*/  
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** // 
/*================================================================================================================*/
    
        int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	    int teamOneCount = rmGetNumberPlayersOnTeam(1);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		float teamStartLoc = rmRandFloat(0, 1);
		
/*----------------------------------------------------------------------------------------------------------------*/  
  
        if (teamStartLoc > 0.5)
	{
        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.475, 0.875, 0.325, 0.725, 0.0, 0.0);
          
        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.875, 0.475, 0.725, 0.325, 0.0, 0.0);                
    }
        else
	{
        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.875, 0.475, 0.725, 0.325, 0.0, 0.0);
          
        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.475, 0.875, 0.325, 0.725, 0.0, 0.0);                   
    }
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
  
        float playerFraction=rmAreaTilesToFraction(2250);
  
        for(i=1; <cNumberPlayers) 
  {
        // CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, shortAvoidImportantItem); 
        //rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");

		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "texas_dirt");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_grass");
	    
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
                
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, true);
  }

	    // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.50);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE NORTH TRADE ROUTE: *********************************** //
/*================================================================================================================*/
        
		// SOCKET DEFINITION 1:
	    int socketID=rmCreateObjectDef("sockets 1");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 1:
		int tradeRoute1ID = rmCreateTradeRoute();
	    
		//rmAddTradeRouteWaypoint(tradeRoute1ID, 0.525, 0.775);
		//rmAddTradeRouteWaypoint(tradeRoute1ID, 0.775, 0.525);
		
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.845, 0.845);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.330, 0.330);
	
	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

/*----------------------------------------------------------------------------------------------------------------*/		

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.325);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.725);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.975);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		rmClearClosestPointConstraints();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/  	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("caribs"))
	{  
		int caribsVillageID = -1;
		caribsVillageID = rmCreateGrouping("caribs village 1", "native carib village 1");
		rmSetGroupingMinDistance(caribsVillageID, 0.0);
		rmSetGroupingMaxDistance(caribsVillageID, 0.0);
		rmAddGroupingToClass(caribsVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(caribsVillageID, avoidNatives);
		rmPlaceGroupingAtLoc(caribsVillageID, 0, 0.725, 0.875);
	} 

/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("caribs"))
	{  
		int caribsVillage2ID = -1;
		caribsVillage2ID = rmCreateGrouping("caribs village 2", "native carib village 1");
		rmSetGroupingMinDistance(caribsVillage2ID, 0.0);
		rmSetGroupingMaxDistance(caribsVillage2ID, 0.0);
		rmAddGroupingToClass(caribsVillage2ID, rmClassID("natives"));
		rmAddGroupingConstraint(caribsVillage2ID, avoidNatives);
		rmPlaceGroupingAtLoc(caribsVillage2ID, 0, 0.875, 0.725);
	} 

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("caribs"))
	{  
		int caribsVillage3ID = -1;
		caribsVillage3ID = rmCreateGrouping("caribs village 3", "native carib village 1");
		rmSetGroupingMinDistance(caribsVillage3ID, 0.0);
		rmSetGroupingMaxDistance(caribsVillage3ID, 0.0);
		rmAddGroupingToClass(caribsVillage3ID, rmClassID("natives"));
		rmAddGroupingConstraint(caribsVillage3ID, avoidNatives);
		rmPlaceGroupingAtLoc(caribsVillage3ID, 0, 0.275, 0.435);
	} 

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("caribs"))
	{  
		int caribsVillage4ID = -1;
		caribsVillage4ID = rmCreateGrouping("caribs village 4", "native carib village 1");
		rmSetGroupingMinDistance(caribsVillage4ID, 0.0);
		rmSetGroupingMaxDistance(caribsVillage4ID, 0.0);
		rmAddGroupingToClass(caribsVillage4ID, rmClassID("natives"));
		rmAddGroupingConstraint(caribsVillage4ID, avoidNatives);
		rmPlaceGroupingAtLoc(caribsVillage4ID, 0, 0.435, 0.275);
	} 

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.55);
/*================================================================================================================*/
// ****************************************** DEFINE THE STARTING TCID: ***************************************** //
/*================================================================================================================*/
		
		rmClearClosestPointConstraints();
		
		// DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    
		if (rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
    }
		
        else 
	{
        rmAddObjectDefItem(startingTCID, "townCenter", 1, 0.0);
    }

        rmSetObjectDefMinDistance(startingTCID, 0);
	    rmSetObjectDefMaxDistance(startingTCID, 0);
	    rmAddObjectDefToClass(startingTCID, rmClassID("player"));
		//rmAddObjectDefConstraint(startingTCID, playerEdgeConstraint);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
		rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidCloseStartingUnits);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE STARTING DEER:
		int startDeerID=rmCreateObjectDef("starting Deer Herd");
	    rmAddObjectDefItem(startDeerID, "deer", 6, 4.0);
	    rmSetObjectDefMinDistance(startDeerID, 10.0);
	    rmSetObjectDefMaxDistance(startDeerID, 15.0);
		rmAddObjectDefToClass(startDeerID, rmClassID("startingUnit"));
	    rmSetObjectDefCreateHerd(startDeerID, false);
	    rmAddObjectDefConstraint(startDeerID, avoidDeer);    
	    rmAddObjectDefConstraint(startDeerID, avoidCloseStartingUnits); 

/*----------------------------------------------------------------------------------------------------------------*/		
  
        // THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "treeCaribbean", 10, 7.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 30);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 35);
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // THE STARTING BERRIES:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 4, 5.0);
	    rmSetObjectDefMinDistance(StartBerriesID, 15);
	    rmSetObjectDefMaxDistance(StartBerriesID, 20);
		rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(StartBerriesID, avoidFruits);
	    rmAddObjectDefConstraint(StartBerriesID, avoidCloseStartingUnits);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // THE STARTING SILVER:
		int startSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(startSilverID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(startSilverID, 20.0);
	    rmSetObjectDefMaxDistance(startSilverID, 25.0);
		rmAddObjectDefToClass(startSilverID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startSilverID, avoidSilver);
	    rmAddObjectDefConstraint(startSilverID, avoidCloseStartingUnits);
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        // THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
        rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
        rmSetObjectDefMinDistance(playerNuggetID, 25.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
		rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    rmAddObjectDefConstraint(playerNuggetID, avoidCloseStartingUnits);

       
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.60);
/*================================================================================================================*/
  		
	    for(i=1; < cNumberPlayers)
{
		// PLACE THE TCID:
		int placedTC = rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE STARTING DEER:
		rmPlaceObjectDefAtLoc(startDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE STARTING SILVER:
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE STARTING TREE:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
        // PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
               
		
        // PLACE A NUGGET FOR THE PLAYER:
        rmSetNuggetDifficulty(1, 1);
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		// PLACE THE WATER SPAWN POINT:
		int waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
		rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		rmAddClosestPointConstraint(flagEdgeConstraint);
        
		vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
 		
		// CLEAR CLOSEST POINT CONSTRAINT:
		rmClearClosestPointConstraints();
 }

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.65);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE BERRIES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.70);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NORTHERN FOREST: ************************************ //
/*================================================================================================================*/

        if (cNumberNonGaiaPlayers <=2)
		int numTries=7.0*cNumberNonGaiaPlayers;
	    else
		numTries=3.5*cNumberNonGaiaPlayers;
		
        int failCount=0;
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        for (i=0; <numTries)

{   
        //int forest=rmCreateArea("foresta"+i);
		int forest=rmCreateArea("forest "+i, rmAreaID("invisible west island"));
		rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forest, "caribbean palm forest");
        rmSetAreaForestDensity(forest, 0.6);
        rmSetAreaForestClumpiness(forest, 0.5);
        rmSetAreaForestUnderbrush(forest, 0.2);
        rmSetAreaCoherence(forest, 0.7);
        rmAddAreaToClass(forest, rmClassID("classForest"));
        
		rmAddAreaConstraint(forest, forestMediumConstraint);
        rmAddAreaConstraint(forest, playerCloseConstraint);
		rmAddAreaConstraint(forest, playerCloseEdgeConstraint); 
        rmAddAreaConstraint(forest, avoidWater10);
		
        if(rmBuildArea(forest)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==3)
        break;
    }
        else
        failCount=0; 
} 

/*----------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries)

{   
        int forest2=rmCreateArea("forest 2 "+i, rmAreaID("invisible east island"));
		rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forest2, "caribbean palm forest");
        rmSetAreaForestDensity(forest2, 0.6);
        rmSetAreaForestClumpiness(forest2, 0.5);
        rmSetAreaForestUnderbrush(forest2, 0.2);
        rmSetAreaCoherence(forest2, 0.7);
        rmAddAreaToClass(forest2, rmClassID("classForest"));
        
		rmAddAreaConstraint(forest2, forestMediumConstraint);
        rmAddAreaConstraint(forest2, playerCloseConstraint);
		rmAddAreaConstraint(forest2, playerCloseEdgeConstraint); 
        rmAddAreaConstraint(forest2, avoidWater10);
		
        if(rmBuildArea(forest2)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==3)
        break;
    }
        else
        failCount=0; 
}  

/*================================================================================================================*/

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.75);
/*================================================================================================================*/
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NORTHERN SILVER: ************************************ //
/*================================================================================================================*/
 
	    // THE NORTHERN SILVER:
		int silverType = rmRandInt(1,10);   
	    int silverID = -1;
		
		if (cNumberNonGaiaPlayers <= 2)
        int silverCount = cNumberNonGaiaPlayers*4;	
		else
		silverCount = cNumberNonGaiaPlayers*2;	
	    
		rmEchoInfo("silver count = "+silverCount);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
        for(i=0; < silverCount)
		
	{	
	    int SilverID = rmCreateObjectDef("silver "+i);
        rmAddObjectDefItem(SilverID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(SilverID, 0.0);
        rmSetObjectDefMaxDistance(SilverID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(SilverID, forestCloseConstraint);
        rmAddObjectDefConstraint(SilverID, avoidFarCoin);    
        rmAddObjectDefConstraint(SilverID, playerEdgeConstraint);
        rmAddObjectDefConstraint(SilverID, avoidWater10);
        rmAddObjectDefConstraint(SilverID, westIslandConstraint);
        rmAddObjectDefConstraint(SilverID, playerCloseConstraint);
						
		rmPlaceObjectDefAtLoc(SilverID, 0, 0.5, 0.5);
    }  

/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SOUTHERN SILVER: ************************************* //
/*================================================================================================================*/	
	
        // THE SOUTHERN SILVER:
		for(i=0; < silverCount)
	{
		int Silver2ID = rmCreateObjectDef("silver 2"+i);
		rmAddObjectDefItem(Silver2ID, "mine", 1, 0);
		rmSetObjectDefMinDistance(Silver2ID, 0.0);
		rmSetObjectDefMaxDistance(Silver2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Silver2ID, forestCloseConstraint);
        rmAddObjectDefConstraint(Silver2ID, avoidFarCoin);    
        rmAddObjectDefConstraint(Silver2ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(Silver2ID, avoidWater10);
        rmAddObjectDefConstraint(Silver2ID, eastIslandConstraint);
        rmAddObjectDefConstraint(Silver2ID, playerCloseConstraint);     
		
		rmPlaceObjectDefAtLoc(Silver2ID, 0, 0.5, 0.5);
	}		

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //  
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NORTHERN NUGGETS:
		int nuggetID= rmCreateObjectDef("The Northern Nugget" ); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggetID, avoidCoin);
		rmAddObjectDefConstraint(nuggetID, avoidWater10);
  	    rmAddObjectDefConstraint(nuggetID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nuggetID, playerCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggetID, westIslandConstraint);
	
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 4.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 2.0*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN NUGGETS:
		int nugget2ID= rmCreateObjectDef("The Southern Nugget" ); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nugget2ID, avoidFarNugget);
		rmAddObjectDefConstraint(nugget2ID, avoidCoin);
		rmAddObjectDefConstraint(nugget2ID, avoidWater10);
  	    rmAddObjectDefConstraint(nugget2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nugget2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, eastIslandConstraint);
	
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, 4.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, 2.0*cNumberNonGaiaPlayers);		

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
        
		float Random = rmRandFloat(0, 1);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NORTHERN DEER HERDS:
		
		if (Random > 0.5)
		int deerCount = rmRandInt(6,8);
		else
		deerCount = rmRandInt(8,12);

        int deerID=rmCreateObjectDef("deer 1");
        rmAddObjectDefItem(deerID, "deer", deerCount, 6.0);
        rmSetObjectDefMinDistance(deerID, 0.0);
        rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(deerID, forestCloseConstraint);
        rmAddObjectDefConstraint(deerID, playerCloseConstraint);
        rmAddObjectDefConstraint(deerID, avoidFarDeer);
        rmAddObjectDefConstraint(deerID, avoidCloseCoin);
        rmAddObjectDefConstraint(deerID, avoidCloseNugget);
        rmAddObjectDefConstraint(deerID, playerEdgeConstraint);
        rmAddObjectDefConstraint(deerID, avoidWater10);
        rmAddObjectDefConstraint(deerID, westIslandConstraint);
         		
        
		rmSetObjectDefCreateHerd(deerID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
		else
		rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN DEER HERDS:
		
		if (Random > 0.5)
		int deer2Count = rmRandInt(6,8);
		else
		deer2Count = rmRandInt(8,12);
		
		int deer2ID=rmCreateObjectDef("deer 2");
        rmAddObjectDefItem(deer2ID, "deer", deerCount, 6.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(deer2ID, forestCloseConstraint);
        rmAddObjectDefConstraint(deer2ID, playerCloseConstraint);
        rmAddObjectDefConstraint(deer2ID, avoidFarDeer);
        rmAddObjectDefConstraint(deer2ID, avoidCloseCoin);
        rmAddObjectDefConstraint(deer2ID, avoidCloseNugget);
        rmAddObjectDefConstraint(deer2ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(deer2ID, avoidWater10);
        rmAddObjectDefConstraint(deer2ID, eastIslandConstraint);
         		
        
		rmSetObjectDefCreateHerd(deer2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
		else
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);		
		
/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE RANDOM TREES:
		int randomTreeID=rmCreateObjectDef("The Random Trees");
		rmAddObjectDefItem(randomTreeID, "treeCaribbean", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, islandConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidWater10);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerCloseEdgeConstraint); 
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
   	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 50*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers); 
		
/*================================================================================================================*/

        // THE RANDOM BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Random Berrybush");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(BerriesID, avoidFarFruits);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidSocket);
		rmAddObjectDefConstraint(BerriesID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(BerriesID, avoidCloseNatives);
		rmAddObjectDefConstraint(BerriesID, avoidWater10);
		rmAddObjectDefConstraint(BerriesID, playerEdgeConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidCloseTrees);
		rmAddObjectDefConstraint(BerriesID, islandConstraint);
		    
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);		

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.95);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE FISHES AND THE WHALES: ********************************** //
/*================================================================================================================*/        
		
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*15.0);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*7.5);

/*----------------------------------------------------------------------------------------------------------------*/

        int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
		rmAddObjectDefConstraint(whaleID, whaleEdgeConstraint);
	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4.0);
		else
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/






