/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// CARO ISLAND:
// CREATED BY DANY:
// SEPTEMBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE VARIABLE FLOAT HANDEDNESS: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/

        float handedness = rmRandFloat(0.0, 1.0);
	    
		// > 0.5 is ocean to SE
	    // < 0.5 is ocean to NE
		
/*----------------------------------------------------------------------------------------------------------------*/

        
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    if (rmAllocateSubCivs(4) == true)
{
        subCiv0=rmGetCivID("Seminoles");
        rmEchoInfo("subCiv0 is Seminoles "+subCiv0);
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Seminoles");
	
		// SEMINOLES ONLY HALF THE TIME:
		if(rmRandFloat(0,1) < 0.5)
	{
		subCiv1=rmGetCivID("Seminoles");
		rmEchoInfo("subCiv1 is Seminoles "+subCiv1);
		if (subCiv1 >= 0)
		rmSetSubCiv(1, "Seminoles");
	}

		// CHEROKEES ONLY HALF THE TIME:
		if(rmRandFloat(0,1) < 0.5)
	{	
	    subCiv2=rmGetCivID("Cherokee");
		rmEchoInfo("subCiv2 is Cherokee "+subCiv2);
		if (subCiv2 >= 0)
			rmSetSubCiv(2, "Cherokee");
	}				
		subCiv3=rmGetCivID("Cherokee");
		rmEchoInfo("subCiv3 is Cherokee "+subCiv3);
		if (subCiv3 >= 0)
			rmSetSubCiv(3, "Cherokee");
}		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int playerTiles = 25000;
	    		
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(638, 638);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.075);
/*================================================================================================================*/
// **************************************** PICKS THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(3);

        // SET SEA TYPE:
        rmSetSeaType("atlantic coast");
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water");
	    
		// SET MAP TYPE:
		rmSetMapType("carolina");
	    rmSetMapType("water");
	    rmSetMapType("grass");
		
		// SET LIGHTING:
		rmSetLightingSet("carolina");
		
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
        
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ******************************************* DEFINE SOME CLASSES: ********************************************* // 
// *********************************** THESE ARE USED LATER FOR CONSTRAINTS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classCliff");
        int classbigIsland=rmDefineClass("big island");
        rmDefineClass("corner");
        rmDefineClass("startingUnit");
		rmDefineClass("natives");
		rmDefineClass("deerHerd");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("flag");
	    rmDefineClass("classHillArea");
			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // MAP EDGE CONSTRAINTS:
	    int forestEdgeConstraint=rmCreatePieConstraint("forest edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
		int edgeConstraint=rmCreatePieConstraint("edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
		int edgeCloseConstraint=rmCreatePieConstraint("close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
			
		// CARDINAL DIRECTIONS:
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
		
        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 20.0);
        int playerCloseConstraint=rmCreateClassDistanceConstraint("close player vs. player", classPlayer, 5.0);
   
   
	    int TCvsTC=rmCreateTypeDistanceConstraint("TC avoid same", "TownCenter", 50.0);
        int CWvsCW=rmCreateTypeDistanceConstraint("CW avoid same", "CoveredWagon", 50.0);
	    int forestvsTC=rmCreateTypeDistanceConstraint("forest vs. TC", "TownCenter", 20.0);
	    int forestvsCW=rmCreateTypeDistanceConstraint("forest vs. CW", "CoveredWagon", 20.0);
	    int avoidTC=rmCreateTypeDistanceConstraint("stuff vs TC", "TownCenter", 60.0);
	    int shortAvoidTC=rmCreateTypeDistanceConstraint("stuff less vs TC", "TownCenter", 20.0);
	    int avoidCW=rmCreateTypeDistanceConstraint("stuff vs CW", "CoveredWagon", 60.0);

        int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
        int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
        
        // BONUS AREA CONSTRAINT:
        int bigIslandConstraint=rmCreateClassDistanceConstraint("stuff avoid bonus island", classbigIsland, 20.0);
		
		int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoid Trees", "TreeCarolinaGrass", 10.0);
		int avoidVeryCloseTrees=rmCreateTypeDistanceConstraint("very close avoid Trees", "TreeCarolinaGrass", 2.0);
		int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoid Trees", "TreeCarolinaGrass", 5.0);
		int avoidMediumTrees=rmCreateTypeDistanceConstraint("medium avoid Trees", "TreeCarolinaGrass", 25.0);
		int avoidFarTrees=rmCreateTypeDistanceConstraint("far avoid Trees", "TreeCarolinaGrass", 50.0);
		int avoidVeryFarTrees=rmCreateTypeDistanceConstraint("very far avoid Trees", "TreeCarolinaGrass", 75.0);

		// AVOID THE HILLY AREAS:
	    int avoidHills = rmCreateClassDistanceConstraint("avoid Hills", rmClassID("classHillArea"), 15.0);
		int avoidMediumHills = rmCreateClassDistanceConstraint("medium avoid Hills", rmClassID("classHillArea"), 25.0);
			
        // FOREST AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close forest vs. forest", rmClassID("classForest"), 10.0);
  		int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close forest vs. forest", rmClassID("classForest"), 5.0);
  		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 15.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close deer avoids deer", "deer", 5.0);
		int avoidVeryCloseDeer=rmCreateTypeDistanceConstraint("very close deer avoids deer", "deer", 2.0);
		int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium deer avoids deer", "deer", 25.0);
		int avoidFarDeer=rmCreateTypeDistanceConstraint("far deer avoids deer", "deer", 50.0);
		int avoidVeryFarDeer=rmCreateTypeDistanceConstraint("very far deer avoids deer", "deer", 75.0);
		
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 15.0);
		int avoidVeryCloseSheep=rmCreateTypeDistanceConstraint("very close sheep avoids sheep", "sheep", 2.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close sheep avoids sheep", "sheep", 5.0);
		int avoidMediumSheep=rmCreateTypeDistanceConstraint("medium sheep avoids sheep", "sheep", 25.0);
		int avoidFarSheep=rmCreateTypeDistanceConstraint("far sheep avoids sheep", "sheep", 50.0);
		int avoidVeryFarSheep=rmCreateTypeDistanceConstraint("very far sheep avoids sheep", "sheep", 75.0);
        
		// BERRIES AVOIDANCE:
		int avoidBerries=rmCreateTypeDistanceConstraint("berry vs berry", "berryBush", 15.0);
		int avoidCloseBerries=rmCreateTypeDistanceConstraint("close berry vs berry", "berryBush", 5.0);
		int avoidMediumBerries=rmCreateTypeDistanceConstraint("medium berry vs berry", "berryBush", 25.0);
		int avoidFarBerries=rmCreateTypeDistanceConstraint("far berry vs berry", "berryBush", 75.0);
	    
		// SHEEP AVOIDANCE:
		//int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);
	    
		// SILVER MINE AVOIDANCE:
		int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 40.0);
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoids coin", "gold", 15.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close coin avoids coin", "gold", 5.0);
		int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoids coin", "gold", 50.0);
        
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 15.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close nugget avoid nugget", "abstractNugget", 5.0);
		int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close nugget avoid nugget", "abstractNugget", 2.0);
		int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium nugget avoid nugget", "abstractNugget", 25.0);
		int avoidFarNugget=rmCreateTypeDistanceConstraint("far nugget avoid nugget", "abstractNugget", 50.0);
		int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far nugget avoid nugget", "abstractNugget", 75.0);

        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 12.0);
        int avoidMediumImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 16.0);
	    int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close avoid impassable land", "Land", false, 8.0);
        
		// FISHES AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 10.0);
		int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        
		// WHALES AVOIDANCE:
		int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "humpbackWhale", 160.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	    
		// FLAG AVOIDANCE:
		int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

        // DECORATIONS AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);
		
		// DEERHERD AVOIDANCE:
		int avoidDeerHerd=rmCreateClassDistanceConstraint("stuff avoids deerHerd", rmClassID("deerHerd"), 15.0);
		
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 2.0);
		int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close avoids natives", rmClassID("natives"), 2.0);
		int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 25.0);
		int avoidFarNatives=rmCreateClassDistanceConstraint("far avoids natives", rmClassID("natives"), 50.0);
		int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far avoids natives", rmClassID("natives"), 75.0);
	
        // IMPORTANT OBJECT AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
	    int nativeAvoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 20.0);
        
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("stuff avoid each other", rmClassID("importantItem"), 15.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close avoid each other", rmClassID("importantItem"), 5.0);
        int avoidVeryCloseImportantItem=rmCreateClassDistanceConstraint("very close avoid each other", rmClassID("importantItem"), 2.0);
        int avoidMediumImportantItem=rmCreateClassDistanceConstraint("medium avoid each other", rmClassID("importantItem"), 25.0);
        int avoidFarImportantItem=rmCreateClassDistanceConstraint("far avoid each other", rmClassID("importantItem"), 50.0);
        int avoidVeryFarImportantItem=rmCreateClassDistanceConstraint("very far avoid each other", rmClassID("importantItem"), 75.0);
        		
		// CONSTRAINT TO AVOID WATER:
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 8.0);
		int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water more short", "Land", false, 12.0);
        int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 16.0);
	    int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************** BUILD UP THE BIG CONTINENT CALLED "BIG ISLAND:" ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int bigIslandID = -1;
		bigIslandID=rmCreateArea("big island");
		rmSetAreaSize(bigIslandID, 0.45, 0.45); 
		rmSetAreaWarnFailure(bigIslandID, false);
        rmAddAreaToClass(bigIslandID, classbigIsland);

        rmSetAreaMinBlobs(bigIslandID, 1);
        rmSetAreaMaxBlobs(bigIslandID, 1);
        rmSetAreaMinBlobDistance(bigIslandID, 1);
        rmSetAreaMaxBlobDistance(bigIslandID, 1);

        rmSetAreaSmoothDistance(bigIslandID, 20);
		rmSetAreaMix(bigIslandID, "carolina_grass");
        rmSetAreaElevationType(bigIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(bigIslandID, 4.0);
        rmSetAreaBaseHeight(bigIslandID, 3.5);
        rmSetAreaElevationMinFrequency(bigIslandID, 0.09);
        rmSetAreaElevationOctaves(bigIslandID, 3);
        rmSetAreaElevationPersistence(bigIslandID, 0.2);
		rmSetAreaElevationNoiseBias(bigIslandID, 1);
		
     	rmSetAreaCoherence(bigIslandID, 0.85);

        rmSetAreaLocation(bigIslandID, 0.5, 0.5);
		
		//rmAddAreaInfluenceSegment(bigIslandID, 0.5, 0.0, 0.5, 1.0); 
		//rmAddAreaInfluenceSegment(bigIslandID, 0.0, 0.5, 0.4, 0.5);
		
		//rmSetAreaEdgeFilling(bigIslandID, 10);
		//rmAddAreaConstraint(bigIslandID, islandConstraint);
		rmSetAreaObeyWorldCircleConstraint(bigIslandID, false);

		rmBuildArea(bigIslandID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************************** DEFINE THE AREAS: *********************************************** //
// ************************** COMPLEX PLACEMENT TO AVOID WATER AND ENEMY PLAYERS: ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	    int teamOneCount = rmGetNumberPlayersOnTeam(1);

	    if ( cNumberTeams <= 2 && teamZeroCount <= 2 && teamOneCount <= 2)
	{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.05, 0.20); // 0.5
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersCircular(0.31, 0.33, 0);
			
		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.55, 0.70); // 0.5
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersCircular(0.31, 0.33, 0);
	}
	    else
	{
		rmSetTeamSpacingModifier(0.7);
		rmPlacePlayersCircular(0.33, 0.35, 0.0);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ******************************************* SET UP PLAYER AREAS: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    
        float playerFraction=rmAreaTilesToFraction(500);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
		
		// SET AREA SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint);
		rmAddAreaConstraint(id, avoidWater12);
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
	    
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
   }
        // BUILD THE AREAS:
		rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE SOME HILLS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
                
		// HILL NUMBER 1:
        int hillNorthwestID=rmCreateArea("northwest hills");
        int avoidNW = rmCreateAreaDistanceConstraint("avoid nw", hillNorthwestID, 3.0);

        rmSetAreaSize(hillNorthwestID, 0.02, 0.02);
        rmSetAreaWarnFailure(hillNorthwestID, false);
        rmSetAreaSmoothDistance(hillNorthwestID, 10);
	    //rmSetAreaMix(hillNorthwestID, "great plains grass");
		rmSetAreaMix(hillNorthwestID, "sonora_dirt");
		//rmSetAreaTerrainType(hillNorthwestID, "sonora_dirt");
	    //rmAddAreaTerrainLayer(hillNorthwestID, "great_plains\ground8_gp", 8, 12);
        //rmAddAreaTerrainLayer(hillNorthwestID, "great_plains\ground1_gp", 12, 16);
		rmAddAreaTerrainLayer(hillNorthwestID, "sonora\ground1_son", 0, 4);
        rmAddAreaTerrainLayer(hillNorthwestID, "sonora\ground1_son", 4, 16);
        rmSetAreaElevationType(hillNorthwestID, cElevTurbulence);
        rmSetAreaElevationVariation(hillNorthwestID, 6.0);
        rmSetAreaBaseHeight(hillNorthwestID, 16);
        rmSetAreaElevationMinFrequency(hillNorthwestID, 0.05);
        rmSetAreaElevationOctaves(hillNorthwestID, 3);
        rmSetAreaElevationPersistence(hillNorthwestID, 0.3);      
        rmSetAreaElevationNoiseBias(hillNorthwestID, 0.5);
        rmSetAreaElevationEdgeFalloffDist(hillNorthwestID, 20.0);
	    rmSetAreaCoherence(hillNorthwestID, 0.9);
	    rmSetAreaLocation(hillNorthwestID, 0.35, 0.65);
        //rmSetAreaEdgeFilling(hillNorthwestID, 5);
	    rmAddAreaInfluenceSegment(hillNorthwestID, 0.3, 0.7, 0.425, 0.575);
	    rmSetAreaHeightBlend(hillNorthwestID, 1);
	    //rmSetAreaObeyWorldCircleConstraint(hillNorthwestID, false);
	    rmAddAreaToClass(hillNorthwestID, rmClassID("classHillArea"));
	    rmBuildArea(hillNorthwestID);
		
/*---------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/		

            // HILL NUMBER 2:
			int hillSoutheastID=rmCreateArea("southeast hills");
            int avoidSE = rmCreateAreaDistanceConstraint("avoid se", hillSoutheastID, 3.0);

            rmSetAreaSize(hillSoutheastID, 0.02, 0.02);
            rmSetAreaWarnFailure(hillSoutheastID, false);
            rmSetAreaSmoothDistance(hillSoutheastID, 10);
	        //rmSetAreaMix(hillSoutheastID, "great plains grass");
			rmSetAreaMix(hillSoutheastID, "sonora_dirt");
	        rmAddAreaTerrainLayer(hillSoutheastID, "sonora\ground1_son", 0, 4);
            rmAddAreaTerrainLayer(hillSoutheastID, "sonora\ground1_son", 4, 16);
            rmSetAreaElevationType(hillSoutheastID, cElevTurbulence);
            rmSetAreaElevationVariation(hillSoutheastID, 6.0);
            rmSetAreaBaseHeight(hillSoutheastID, 16);
            rmSetAreaElevationMinFrequency(hillSoutheastID, 0.05);
            rmSetAreaElevationOctaves(hillSoutheastID, 3);
            rmSetAreaElevationPersistence(hillSoutheastID, 0.3);
            rmSetAreaElevationNoiseBias(hillSoutheastID, 0.5);
            rmSetAreaElevationEdgeFalloffDist(hillSoutheastID, 20.0);
	        rmSetAreaCoherence(hillSoutheastID, 0.9);
	        rmSetAreaLocation(hillSoutheastID, 0.65, 0.35);
            //rmSetAreaEdgeFilling(hillSoutheastID, 5);
	        rmAddAreaInfluenceSegment(hillSoutheastID, 0.575, 0.425, 0.7, 0.3);
	        rmSetAreaHeightBlend(hillSoutheastID, 1);
	        //rmSetAreaObeyWorldCircleConstraint(hillSoutheastID, false);
	        rmAddAreaToClass(hillSoutheastID, rmClassID("classHillArea"));
	        rmBuildArea(hillSoutheastID);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE TRADE ROUTES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ******************* DEFINE THE STARTING TCID AND THE STARTING UNITS AND STARTING RESOURCES: ****************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // PLACE TC OR CW NOW: 
		// FIND LOCATION LATER TO PLACE OTHER RESOURCES:
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if ( rmGetNomadStart())
		rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	    else
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);
	    rmAddObjectDefConstraint(TCID, avoidTradeRoute);
        rmAddObjectDefConstraint(TCID, TCvsTC);
        rmAddObjectDefConstraint(TCID, CWvsCW);
        rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	    for(i=1; <cNumberPlayers)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

	}

	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 6.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
        rmAddObjectDefConstraint(startingUnits, avoidCloseImpassableLand);
		
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(playerSilverID, 18.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 22.0);
	    rmAddObjectDefConstraint(playerSilverID, avoidAll);
        rmAddObjectDefConstraint(playerSilverID, avoidCloseImpassableLand);

	    // DEFINE THE PLAYER CRATE:
		int playerCrateID=rmCreateObjectDef("bonus starting crates");
        rmAddObjectDefItem(playerCrateID, "crateOfFood", rmRandInt(2,3), 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfWood", rmRandInt(1,3), 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 4.0);
        rmSetObjectDefMinDistance(playerCrateID, 6);
        rmSetObjectDefMaxDistance(playerCrateID, 10);
	    rmAddObjectDefConstraint(playerCrateID, avoidAll);
        rmAddObjectDefConstraint(playerCrateID, avoidCloseImpassableLand);

	    // DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(2,3), 2.0);
        rmSetObjectDefMinDistance(playerBerryID, 10);
        rmSetObjectDefMaxDistance(playerBerryID, 15);
	    rmAddObjectDefConstraint(playerBerryID, avoidAll);
        rmAddObjectDefConstraint(playerBerryID, avoidCloseImpassableLand);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeCarolinaGrass", 1, 0.0);
        rmSetObjectDefMinDistance(playerTreeID, 8);
        rmSetObjectDefMaxDistance(playerTreeID, 12);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, avoidCloseImpassableLand);

	    // DEFINE THE WATER FLAG:
		int waterFlagID=rmCreateObjectDef("HC water flag "+i);
	    rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        rmAddClosestPointConstraint(flagEdgeConstraint);
	    rmAddClosestPointConstraint(flagVsFlag);
	    rmAddClosestPointConstraint(bigIslandConstraint);
	    rmAddClosestPointConstraint(fishLand);

	    // THE NUGGET EASY:
		int nugget1= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(nugget1, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nugget1, avoidNugget);
  	    rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget1, avoidAll);
	    rmSetObjectDefMinDistance(nugget1, 38.0);
	    rmSetObjectDefMaxDistance(nugget1, 40.0);
	    
		// DEFINE THE NEAR DEER:
        int nearDeerID=rmCreateObjectDef("deer herds near town");
        rmAddObjectDefItem(nearDeerID, "deer", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(nearDeerID, 29);
        rmSetObjectDefMaxDistance(nearDeerID, 30);
        rmAddObjectDefConstraint(nearDeerID, avoidDeer);
	    rmAddObjectDefConstraint(nearDeerID, avoidAll);
        rmAddObjectDefConstraint(nearDeerID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(nearDeerID, true);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE AMERICANS: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

           
        if (subCiv0 == rmGetCivID("Seminoles")) // THE CENTER:
   {  
        int seminoleVillageID = -1;
        int seminoleVillageType = rmRandInt(1,5);
        seminoleVillageID = rmCreateGrouping("Seminole village 1", "native Seminole village "+seminoleVillageType);
        rmSetGroupingMinDistance(seminoleVillageID, 0.0);
        rmSetGroupingMaxDistance(seminoleVillageID, 0.0);
        rmAddGroupingToClass(seminoleVillageID, rmClassID("natives"));
        rmAddGroupingConstraint(seminoleVillageID, avoidNatives);
		//rmAddGroupingConstraint(seminoleVillageID, avoidAll);
				
		if (handedness < 0.5)
		rmPlaceGroupingAtLoc(seminoleVillageID, 0, 0.25, 0.55);
		else //handedness > 0.5
		rmPlaceGroupingAtLoc(seminoleVillageID, 0, 0.25, 0.55);
	}

/*----------------------------------------------------------------------------------------------------------------*/	

        if (subCiv1 == rmGetCivID("Seminoles")) // THE BEACH:
   {       
        int seminole2VillageID = -1;
        int seminole2VillageType = rmRandInt(1,5);
        seminole2VillageID = rmCreateGrouping("Seminole village", "native Seminole village "+seminole2VillageType);
        rmSetGroupingMinDistance(seminole2VillageID, 0.0);
        rmSetGroupingMaxDistance(seminole2VillageID, 0.0);
        rmAddGroupingToClass(seminole2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(seminole2VillageID, avoidNatives);
		//rmAddGroupingConstraint(seminole2VillageID, avoidAll);
            	
		if (handedness < 0.5)
		rmPlaceGroupingAtLoc(seminole2VillageID, 0, 0.45, 0.75); 
		else //handedness > 0.5
		rmPlaceGroupingAtLoc(seminole2VillageID, 0, 0.45, 0.75); 
	}
	
/*----------------------------------------------------------------------------------------------------------------*/	

	    if (subCiv2 == rmGetCivID("Cherokee")) // THE EDGE:
   {   
        int cherokeeVillageID = -1;
        int cherokeeVillageType = rmRandInt(1,5);
        cherokeeVillageID = rmCreateGrouping("cherokee village 2", "native cherokee village "+cherokeeVillageType);
        rmSetGroupingMinDistance(cherokeeVillageID, 0.0);
        rmSetGroupingMaxDistance(cherokeeVillageID, 0.0);
        rmAddGroupingToClass(cherokeeVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokeeVillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokeeVillageID, avoidAll);
        
		if (handedness < 0.5)
	{
		rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.55, 0.25); // NE
	}
		else
	{
	    rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.55, 0.25); // SE
	}
}

/*----------------------------------------------------------------------------------------------------------------*/

	    if(subCiv3 == rmGetCivID("Cherokee")) // THE EDGE:
{
        int cherokee2VillageID = -1;
        int cherokee2VillageType = rmRandInt(1,5);
        cherokee2VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village "+cherokee2VillageType);
        rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
        rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
        rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		//rmAddGroupingConstraint(cherokee2VillageID, avoidAll);
        
		if (handedness < 0.5)

	{
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.75, 0.45); // NE
	}
		else
	{
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.75, 0.45); //SE
	}
}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ******************************************* PLACE THE FAR SILVER: ******************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int silverID = -1;
	    int silverCount = (cNumberNonGaiaPlayers*3 + rmRandInt(2,3));
	    rmEchoInfo("silver count = "+silverCount);

	    for(i=0; < silverCount)
	{
        silverID = rmCreateObjectDef("silver "+i);
	    rmAddObjectDefItem(silverID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silverID, 0.0);
        rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, avoidFarCoin);
        rmAddObjectDefConstraint(silverID, avoidAll);
        rmAddObjectDefConstraint(silverID, playerCloseConstraint);
		//rmAddObjectDefConstraint(silverID, avoidCW);
		rmAddObjectDefConstraint(silverID, avoidCloseNatives);
        rmAddObjectDefConstraint(silverID, avoidImpassableLand);
        rmAddObjectDefConstraint(silverID, avoidHills);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }
     
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE FISHES AND THE WHALES: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE FISH SARDINE:
		int fishID=rmCreateObjectDef("sardine");
        rmAddObjectDefItem(fishID, "FishSardine", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		rmAddObjectDefConstraint(fishID, edgeCloseConstraint);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);

        // THE FISH TARPON:
		int fish2ID=rmCreateObjectDef("tarpon");
        rmAddObjectDefItem(fish2ID, "FishTarpon", 3, 9.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFishID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
		rmAddObjectDefConstraint(fish2ID, edgeCloseConstraint);
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);

	    // THE HUMPBACKWHALE:
		int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "humpbackWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
		rmAddObjectDefConstraint(whaleID, edgeCloseConstraint);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ********************* PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ********************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    for(i=1; <cNumberPlayers)
	{
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		if (rmGetNomadStart() == false)
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
				
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(nearDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	}

	    rmClearClosestPointConstraints();
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int forestTreeID = 0;
		if (cNumberNonGaiaPlayers<=2)
        int numTries=8*cNumberNonGaiaPlayers;
		else
		numTries=6*cNumberNonGaiaPlayers;
        int failCount=0;
        for (i=0; <numTries)
{   
        //int forest=rmCreateArea("forest "+i, rmAreaID("big island"));
		int forest=rmCreateArea("forest "+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forest, "carolina pine forest");
        rmSetAreaForestDensity(forest, 0.8);
        rmSetAreaForestClumpiness(forest, 0.6);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 5);
        rmSetAreaMinBlobDistance(forest, 16.0);
        rmSetAreaMaxBlobDistance(forest, 70.0);
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 0);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidCloseNatives);
		rmAddAreaConstraint(forest, avoidHills);
        rmAddAreaConstraint(forest, playerCloseConstraint);
        rmAddAreaConstraint(forest, avoidCloseCoin); 
        rmAddAreaConstraint(forest, avoidMediumImpassableLand); 
        
        if(rmBuildArea(forest)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
    }
        else
        failCount=0; 
} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE FAR DEER: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

		int farDeerID=rmCreateObjectDef("deer herds far away");
	    int bonusChance=rmRandFloat(0, 1);
        if(bonusChance<0.5)   
        rmAddObjectDefItem(farDeerID, "deer", rmRandInt(8,10), 10.0);
        else
        rmAddObjectDefItem(farDeerID, "deer", rmRandInt(12,16), 10.0);
        rmSetObjectDefMinDistance(farDeerID, 0.0);
        rmSetObjectDefMaxDistance(farDeerID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(farDeerID, avoidVeryFarDeer);
	    rmAddObjectDefConstraint(farDeerID, avoidAll);
		rmAddObjectDefConstraint(farDeerID, avoidCloseNatives);
		rmAddObjectDefConstraint(farDeerID, forestCloseConstraint);
	    rmAddObjectDefConstraint(farDeerID, playerCloseConstraint);
	    rmAddObjectDefConstraint(farDeerID, avoidMediumHills);
        rmAddObjectDefConstraint(farDeerID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(farDeerID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(farDeerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		else
		rmPlaceObjectDefAtLoc(farDeerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FAR BERRIES: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

		int farBerriesID=rmCreateObjectDef("far berries");
        rmAddObjectDefItem(farBerriesID, "berryBush", rmRandInt(5,8), 4.0);
        rmSetObjectDefMinDistance(farBerriesID, 0.0);
        rmSetObjectDefMaxDistance(farBerriesID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(farBerriesID, playerCloseConstraint);
	    rmAddObjectDefConstraint(farBerriesID, forestCloseConstraint);
	    rmAddObjectDefConstraint(farBerriesID, avoidFarBerries);
		rmAddObjectDefConstraint(farBerriesID, avoidAll);
		rmAddObjectDefConstraint(farBerriesID, avoidImportantItem);
		rmAddObjectDefConstraint(farBerriesID, avoidMediumHills);
		rmAddObjectDefConstraint(farBerriesID, avoidMediumDeer);
        rmAddObjectDefConstraint(farBerriesID, avoidCloseNatives);
		rmAddObjectDefConstraint(farBerriesID, avoidCloseImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
        rmPlaceObjectDefAtLoc(farBerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		else
		rmPlaceObjectDefAtLoc(farBerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE THE NUGGET MEDIUM: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
		
		int nugget2= rmCreateObjectDef("nugget medium"); 
	    rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget2, 0.0);
	    rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget2, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nugget2, avoidVeryFarNugget);
  	    rmAddObjectDefConstraint(nugget2, playerCloseConstraint);
  	    rmAddObjectDefConstraint(nugget2, forestCloseConstraint);
  	    rmAddObjectDefConstraint(nugget2, avoidMediumDeer);
		rmAddObjectDefConstraint(nugget2, avoidMediumBerries);
		rmAddObjectDefConstraint(nugget2, avoidMediumHills);
  	    rmAddObjectDefConstraint(nugget2, avoidAll);
		rmAddObjectDefConstraint(nugget2, avoidCloseNatives);
  	    rmAddObjectDefConstraint(nugget2, avoidWater20);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		else
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE SHEEPS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int sheepID=rmCreateObjectDef("sheep");
	    rmAddObjectDefItem(sheepID, "sheep", rmRandInt(5,7), 6.0);
	    rmSetObjectDefMinDistance(sheepID, 0.0);
	    rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(sheepID, avoidFarSheep);
	    rmAddObjectDefConstraint(sheepID, avoidAll);
		rmAddObjectDefConstraint(sheepID, avoidMediumBerries);
		rmAddObjectDefConstraint(sheepID, avoidHills);
		rmAddObjectDefConstraint(sheepID, avoidCloseNugget);
		rmAddObjectDefConstraint(sheepID, avoidCloseCoin);
		rmAddObjectDefConstraint(sheepID, forestCloseConstraint);
		rmAddObjectDefConstraint(sheepID, avoidMediumDeer);
		rmAddObjectDefConstraint(sheepID, avoidCloseNatives);
		rmAddObjectDefConstraint(sheepID, playerCloseConstraint);
        rmAddObjectDefConstraint(sheepID, avoidCloseImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
		numTries=3*cNumberNonGaiaPlayers;
		else
		numTries=1.5*cNumberNonGaiaPlayers;
		
		for (i=0; <numTries)
	{
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5);
	} 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE NORTH AND SOUTH REGION:
		int randomTreeID=rmCreateObjectDef("random tree 1");
		rmAddObjectDefItem(randomTreeID, "TreeCarolinaGrass", rmRandInt(1,5), 9.0);
	    
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
				
	    rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidHills);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseBerries);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseDeer);
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseImpassableLand);
			
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 60*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);		
			  
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/
