/*===============================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

// SPANISH CONQUEST II:
// CREATED BY DANY:
// SEPTEMBER 2007:
// THIS IS MY 70TH RMS MAP FOR AGE OF EMPIRE III:

/*===============================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*---------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(12) == true)
   {
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");

		subCiv1=rmGetCivID("Maya");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Maya"); 

		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Maya");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Maya");
    }		 

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*--------------------------------------------------------------------------------------------------------------*/

        int playerTiles=17500;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/
// **************************** DEFINE "THE WHICH VARIATION" VARIABLE OF THE MAP: ****************************** //		
/*===============================================================================================================*/

	    int whichVariation=-1;
	    whichVariation = rmRandInt(1,2);
/*		
		EX: if ( whichVariation == 1 )
		    {
			}
			else
			{
			}
*/		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        if ( whichVariation == 1 )
	
    { 	
		// PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(2);

        // SET SEA TYPE: 
        rmSetSeaType("yucatan Coast");
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
		
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("yucatan_grass");
		
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("pampas\ground5_pam", 4);
    	   
	    // SET MAP TYPE:
		rmSetMapType("yucatan");
	    rmSetMapType("tropical");
	    rmSetMapType("water");
	    
		// MAP LIGHTING:
        rmSetLightingSet("yucatan");

	    // SET WIND MAGNITUDE:
	    rmSetWindMagnitude(2);
	    
		// DEFINE THE CORNERS:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
		chooseMercs();
		
	}	
	    else
	{
        // PICKS A DEFAULT WATER HEIGHT:
		rmSetSeaLevel(2.0);
        
        // SET SEA TYPE:
		rmSetSeaType("hudson bay");
        //rmSetSeaType("new england coast");
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
		
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("patagonia_grass");
		
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("patagonia\ground_dirt1_pat", 4.0);
		   
	    // SET MAP TYPE:
		rmSetMapType("patagonia");
	    rmSetMapType("water");
	    rmSetMapType("grass");
			    
		// MAP LIGHTING:
		rmSetLightingSet("patagonia");
        
	    // SET WIND MAGNITUDE:
	    rmSetWindMagnitude(2);
	    
		// DEFINE THE CORNERS:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
		chooseMercs();
    }	

/*---------------------------------------------------------------------------------------------------------------*/
/*
        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(1.0);

        // SET MAP ELEVATION PARAMETERS:
	    // rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.2, 3.0);
	    
		// SET SEA TYPE:
		rmSetSeaType("new england coast");
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("patagonia_grass");
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("patagonia\ground_dirt1_pat", 4.0);
	    
		// SET MAP TYPE:
		rmSetMapType("patagonia");
	    rmSetMapType("water");
	    rmSetMapType("grass");
        
		// SET LIGHTING:
		rmSetLightingSet("patagonia");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);

	    // CHOOSE THE MERCS:
	    chooseMercs();
*/		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classCliff");
        rmDefineClass("classPatch");
        int classbigContinent=rmDefineClass("big continent");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
		 rmDefineClass("classWestForest");
        rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("bay");
		rmDefineClass("money");
	    rmDefineClass("nuggets");
	    rmDefineClass("socketClass");
	    int lakeClass=rmDefineClass("lake");
		rmDefineClass("natives");
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/
// *************************************** DEFINE THE CONSTRAINTS: ********************************************* //
// *********************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		// MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
        int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 24.0);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
        int playerCloseConstraint=rmCreateClassDistanceConstraint("close away from players", classPlayer, 20.0);

		int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
        int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 30.0);
        int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);

        // BONUS AREA CONSTRAINT:
        int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 20.0);

        int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
        
		// RESOURCE AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 5.0);
        
		int westForestConstraint=rmCreateClassDistanceConstraint("west forest vs. forest", rmClassID("classWestForest"), 35.0);
       
		
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
		int avoidForest=rmCreateClassDistanceConstraint("stuff avoids forest", rmClassID("classForest"), 6.0);
				
		// COIN AVOIDANCE:
		if ( whichVariation == 1 )
	{	
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "minegold", 10.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "minegold", 5.0);
		int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "minegold", 25.0);
		int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "minegold", 50.0);
		int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoid coin", "minegold", 75.0);
	}	
		else
	{	
		avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "mine", 10.0);
		avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "mine", 5.0);
		avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "mine", 25.0);
		avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "mine", 50.0);
		avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoid coin", "mine", 75.0);
	}	
		// FAST COIN AVOIDANCE:
		int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "minegold", 6.0);
	    int avoidFastCoinForest=rmCreateTypeDistanceConstraint("forests avoid fast coin", "minegold", 5.0);

		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 5.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid fruits", "berrybush", 25.0);
		int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid fruits", "berrybush", 50.0);
		int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoid fruits", "berrybush", 75.0);
		
		// TREES AVOIDANCE:
		if ( whichVariation == 1 )
	{	
		int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoid Trees", "TreeYucatan", 10.0);
		int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoid Trees", "TreeYucatan", 5.0);
		int avoidMediumTrees=rmCreateTypeDistanceConstraint("medium avoid Trees", "TreeYucatan", 25.0);
		int avoidFarTrees=rmCreateTypeDistanceConstraint("far avoid Trees", "TreeYucatan", 50.0);
		int avoidVeryFarTrees=rmCreateTypeDistanceConstraint("very far avoid Trees", "TreeYucatan", 75.0);
	}
        else
    {		
        avoidTrees=rmCreateTypeDistanceConstraint("stuff avoid Trees", "TreePatagoniaDirt", 10.0);
		avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoid Trees", "TreePatagoniaDirt", 5.0);
		avoidMediumTrees=rmCreateTypeDistanceConstraint("medium avoid Trees", "TreePatagoniaDirt", 25.0);
		avoidFarTrees=rmCreateTypeDistanceConstraint("far avoid Trees", "TreePatagoniaDirt", 50.0);
		avoidVeryFarTrees=rmCreateTypeDistanceConstraint("very far avoid Trees", "TreePatagoniaDirt", 75.0);
    }    
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 10.0);
        int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 5.0);
        int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium avoid nugget", "AbstractNugget", 25.0);
        int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 50.0);
        int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far avoid nugget", "AbstractNugget", 75.0);
        
		
		int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 25.0);
        
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 15.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 5.0);
		int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoids deer", "deer", 25.0);
		int avoidFarDeer=rmCreateTypeDistanceConstraint("far avoids deer", "deer", 50.0);
		int avoidVeryFarDeer=rmCreateTypeDistanceConstraint("very far avoids deer", "deer", 75.0);
		
		// RHEA AVOIDANCE:
		int avoidRhea=rmCreateTypeDistanceConstraint("stuff avoids rhea", "rhea", 15.0);
		int avoidCloseRhea=rmCreateTypeDistanceConstraint("close avoids rhea", "rhea", 5.0);
		int avoidMediumRhea=rmCreateTypeDistanceConstraint("medium avoids rhea", "rhea", 25.0);
		int avoidFarRhea=rmCreateTypeDistanceConstraint("far avoids rhea", "rhea", 50.0);
		int avoidVeryFarRhea=rmCreateTypeDistanceConstraint("very far avoids rhea", "rhea", 75.0);
		
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 15.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 5.0);
		int avoidMediumSheep=rmCreateTypeDistanceConstraint("medium avoids sheep", "sheep", 25.0);
		int avoidFarSheep=rmCreateTypeDistanceConstraint("far avoids sheep", "sheep", 50.0);
		int avoidVeryFarSheep=rmCreateTypeDistanceConstraint("very far avoids sheep", "sheep", 75.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 5.0);
        int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 25.0);
        int avoidFarNatives=rmCreateClassDistanceConstraint("far avoids natives", rmClassID("natives"), 50.0);
    	int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far avoids natives", rmClassID("natives"), 75.0);
        
		// FISH AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 15.0);
		int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        
		// WHALES AVOIDANCE:
		int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
		if (cNumberNonGaiaPlayers<=2)
		int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 60.0);
		else
		whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 40.0);
		        
		//int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 60.0);
	    int avoidCoinForest=rmCreateTypeDistanceConstraint("forests avoid coin", "minegold", 6.0);

        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close avoid impassable land", "Land", false, 5.0);
               
		// CLIFFS AVOIDANCE:
		int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 15.0);
        int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 5.0);
		int avoidMediumCliffs=rmCreateClassDistanceConstraint("medium vs. cliff", rmClassID("classCliff"), 25.0);
		int avoidFarCliffs=rmCreateClassDistanceConstraint("far vs. cliff", rmClassID("classCliff"), 50.0);
        int avoidVeryFarCliffs=rmCreateClassDistanceConstraint("very far vs. cliff", rmClassID("classCliff"), 75.0);
		
		// MONEY AVOIDANCE:
		//int avoidMoney=rmCreateClassDistanceConstraint("stuff vs. money", rmClassID("money"), 15.0);
        //int avoidCloseMoney=rmCreateClassDistanceConstraint("close vs. money", rmClassID("money"), 5.0);
		//int avoidMediumMoney=rmCreateClassDistanceConstraint("medium vs. money", rmClassID("money"), 25.0);
		//int avoidFarMoney=rmCreateClassDistanceConstraint("far vs. money", rmClassID("money"), 50.0);
        //int avoidVeryFarMoney=rmCreateClassDistanceConstraint("very far vs. money", rmClassID("money"), 75.0);

        // MONEY AVOIDANCE:
		//int moneyConstraint=rmCreateClassDistanceConstraint("stuff vs. money", rmClassID("money"), 5.0);
        //int moneyCloseConstraint=rmCreateClassDistanceConstraint("close vs. money", rmClassID("money"), 5.0);
		//int moneyMediumConstraint=rmCreateClassDistanceConstraint("medium vs. money", rmClassID("money"), 25.0);
		//int moneyFarConstraint=rmCreateClassDistanceConstraint("far vs. money", rmClassID("money"), 50.0);
        //int moneyVeryFarConstraint=rmCreateClassDistanceConstraint("very far vs. money", rmClassID("money"), 75.0);

		
		int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

	    int avoidLake=rmCreateClassDistanceConstraint("lake vs stuff", lakeClass, 30.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // STARTING UNITS AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // TRADE ROUTE AVOIDANCE:
        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 5.0);
	    
	    int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 15.0);
	    int avoidCloseSocket=rmCreateClassDistanceConstraint("close avoid sockets", rmClassID("socketClass"), 5.0);
		
		int avoidSocketCliff=rmCreateClassDistanceConstraint("cliffs avoid sockets by a lot", rmClassID("socketClass"), 10.0);
	    int avoidSocketPlayer=rmCreateClassDistanceConstraint("cliffs avoid sockets by a lot more", rmClassID("socketClass"), 15.0);
        
		int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
        int avoidCloseImportantItem = rmCreateClassDistanceConstraint("close vs importantItem", rmClassID("importantItem"), 5.0);
       		
		int secretsAvoidSecrets = rmCreateClassDistanceConstraint("secrets avoid secrets", rmClassID("secrets"), 60.0);
        
        // CONSTRAINT TO AVOID WATER:
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 8.0);

        // CARDINAL DIRECTIONS CONSTRAINTS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

        // SHIPS VS SHIPS:
        int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 15.0);

        // NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

	    // BEACH AVOIDANCE:
		// int avoidBeach = rmCreateAreaDistanceConstraint("stay away from InnerLandID", InnerLandID, 4);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE TWO BAY AREAS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // DEFINE AND PLACE THE BAY NUMBER 1:
        int bay1ID=rmCreateArea("Bay 1");
        rmSetAreaSize(bay1ID, 0.05, 0.05);
	    //rmSetAreaLocation(bay1ID, 1.0, 0.45);
		rmSetAreaLocation(bay1ID, 0.30, 1.0);
	    
		if ( whichVariation == 1 )
		rmSetAreaWaterType(bay1ID, "Yucatan Coast");
		else
		rmSetAreaWaterType(bay1ID, "hudson bay");
        
		rmSetAreaBaseHeight(bay1ID, 2.0); // Was 10
        rmSetAreaMinBlobs(bay1ID, 4);
        rmSetAreaMaxBlobs(bay1ID, 6);
        rmSetAreaMinBlobDistance(bay1ID, 5);
        rmSetAreaMaxBlobDistance(bay1ID, 30);
        rmSetAreaSmoothDistance(bay1ID, 50);
        rmSetAreaCoherence(bay1ID, 0.75);
	    rmAddAreaToClass(bay1ID, rmClassID("bay"));
        rmSetAreaObeyWorldCircleConstraint(bay1ID, false);
		rmBuildArea(bay1ID);

        // DEFINE BAY NUMBER 2:
		int bay2ID=rmCreateArea("Bay 2");
        rmSetAreaSize(bay2ID, 0.05, 0.05);
	    //rmSetAreaLocation(bay2ID, 0.55, 0.0);
		rmSetAreaLocation(bay2ID, 0.0, 0.70);
		
		if ( whichVariation == 1 )
		rmSetAreaWaterType(bay2ID, "Yucatan Coast");
		else
		rmSetAreaWaterType(bay2ID, "hudson bay");
		
	    //rmSetAreaWaterType(bay2ID, "hudson bay");
        rmSetAreaBaseHeight(bay2ID, 2.0); // Was 10
        rmSetAreaMinBlobs(bay2ID, 4);
        rmSetAreaMaxBlobs(bay2ID, 6);
        rmSetAreaMinBlobDistance(bay2ID, 5);
        rmSetAreaMaxBlobDistance(bay2ID, 30);
        rmSetAreaSmoothDistance(bay2ID, 50);
        rmSetAreaCoherence(bay2ID, 0.75);
	    rmAddAreaToClass(bay2ID, rmClassID("bay"));
        rmSetAreaObeyWorldCircleConstraint(bay2ID, false);
		rmBuildArea(bay2ID);

        // DEFINE BAY NUMBER 3:
		int bay3ID=rmCreateArea("Bay 3");
        rmSetAreaSize(bay3ID, 0.14, 0.14);
        //rmSetAreaLocation(bay3ID, 1.0, 0.0);
		rmSetAreaLocation(bay3ID, 0.0, 1.0);
		
		if ( whichVariation == 1 )
		rmSetAreaWaterType(bay3ID, "Yucatan Coast");
		else
		rmSetAreaWaterType(bay3ID, "hudson bay");
		
	    //rmSetAreaWaterType(bay3ID, "hudson bay");
        rmSetAreaBaseHeight(bay3ID, 2.0); // Was 10
        rmSetAreaMinBlobs(bay3ID, 4);
        rmSetAreaMaxBlobs(bay3ID, 6);
        rmSetAreaMinBlobDistance(bay3ID, 5);
        rmSetAreaMaxBlobDistance(bay3ID, 30);
        rmSetAreaSmoothDistance(bay3ID, 50);
        rmSetAreaCoherence(bay3ID, 0.75);
	    rmAddAreaToClass(bay3ID, rmClassID("bay"));
        rmSetAreaObeyWorldCircleConstraint(bay3ID, false);
		rmBuildArea(bay3ID);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/
// *************************************** DEFINE THE PLACEMENT ORDER: ***************************************** //
/*===============================================================================================================*/
	
        // THE PLACEMENT ORDER:
        // TRADE ROUTE -> PLAYER AREAS -> LAKE -> CLIFFS -> NUGGETS:
	    // TWO GLORIOUS TRADE ROUTES:
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE TRADE SOCKETS:
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 6.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
        
		// DEFINE THE TRADE ROUTE 1:
		int tradeRouteID = rmCreateTradeRoute();
		
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.325, 0.475);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.625, 0.175);
	
	    bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
	    rmEchoError("Failed to place trade route #1");
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	    // DEFINE THE TRADE ROUTE 2:
		int tradeRouteID2 = rmCreateTradeRoute();
	
	    rmAddTradeRouteWaypoint(tradeRouteID2, 0.525, 0.675);
		rmAddTradeRouteWaypoint(tradeRouteID2, 0.825, 0.375);
		
	    bool placedTradeRoute2 = rmBuildTradeRoute(tradeRouteID2, "carolinas\trade_route");
	    if(placedTradeRoute2 == false)
	    rmEchoError("Failed to place trade route #2");
		
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* ADD THE MEETING POLES ALONG THE 2 TRADE ROUTES: ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

        // PUT THE SOCKETS ON THE TRADE ROUTE 1:
		rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.025);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.975);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   
        rmClearClosestPointConstraints();
   
/*----------------------------------------------------------------------------------------------------------------*/

        // PUT THE SOCKETS ON THE TRADE ROUTE 2:
		// CHANGE THE TRADE ROUTE NUMBER FOR THE NEW SOCKETS:
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID2);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.025);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.975);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints();
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/
// ********************************** SET UP THE PLAYER STARTING LOCATIONS: ************************************ //
/*===============================================================================================================*/
     
	  if ( whichVariation == 1 )
		
    {
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.15, 0.35, 0.35, 0.15, 0.0, 0.1);

		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.85, 0.65, 0.65, 0.85, 0.0, 0.1);
	}
	    else
	{
   		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.85, 0.65, 0.65, 0.85, 0.0, 0.1);		
		
		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.15, 0.35, 0.35, 0.15, 0.0, 0.1);	
    }

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ****************************************** //
/*===============================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
	    
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(i, avoidSocketPlayer);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINTS:
		// rmAddAreaConstraint(id, playerConstraint); 
        // rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/
// ********************************* DEFINE AND PLACE THE TRADE ROUTE HACK: ************************************ //
/*===============================================================================================================*/
// NONE FPR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/
// ********************************* DEFINE AND PLACE A LAKE IN THE MIDDLE: ************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*===============================================================================================================*/
// ****************** DEFINE THE STARTING TCID AND THE STARTING UNITS AND STARTING RESOURCES: ****************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
		
/*---------------------------------------------------------------------------------------------------------------*/

	    // VARIABLES FOR THE PLAYER GOLD:
		int silverType = -1;
	    int playerSilverID = -1;

	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
		
		if ( whichVariation == 1 )
        rmAddObjectDefItem(StartAreaTreeID, "TreeYucatan", 1, 0.0);
		else
		rmAddObjectDefItem(StartAreaTreeID, "TreePatagoniaDirt", 1, 0.0);
	    
		//rmAddObjectDefItem(StartAreaTreeID, "TreePatagoniaDirt", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING DEERS:
		int StartDeerID=rmCreateObjectDef("starting deer");
	    rmAddObjectDefItem(StartDeerID, "deer", 1, 0.0);
	    rmSetObjectDefMinDistance(StartDeerID, 10.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 15.0);
	    rmAddObjectDefConstraint(StartDeerID, avoidStartingUnitsSmall);

		// DEFINE THE STARTING BERRYBUSH:
	    int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 2, 4.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	    // VARIABLE OF THE WATER FLAG:
		int waterFlagID=-1;
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/
// ********************* PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    for(i=1; <cNumberPlayers)
	{
		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
		
		// PLACE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// EVERYONE GETS ONE ORE MINE CLOSE BY:
		silverType = rmRandInt(1,10);
		playerSilverID = rmCreateObjectDef("player Silver closer "+i);
		rmAddObjectDefItem(playerSilverID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerSilverID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerSilverID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerSilverID, 15.0);
		rmSetObjectDefMaxDistance(playerSilverID, 20.0);
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE BERRY BUSHES:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE STARTING PRONGHORNS:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// DEFINE THE WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		//rmAddClosestPointConstraint(Eastward);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		// PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
	}
	
/*===============================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************** //
/*===============================================================================================================*/

        if (subCiv0 == rmGetCivID("aztecs"))
	{  
		int aztecs1VillageID = -1;
		aztecs1VillageID = rmCreateGrouping("aztecs village 1", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs1VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs1VillageID, 0.0);
		rmAddGroupingToClass(aztecs1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs1VillageID, 0, 0.275, 0.375);
	}	
	
/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("maya"))
	{  
		int maya1VillageID = -1;
		maya1VillageID = rmCreateGrouping("maya village 1", "native maya village 1");
		rmSetGroupingMinDistance(maya1VillageID, 0.0);
		rmSetGroupingMaxDistance(maya1VillageID, 0.0);
		rmAddGroupingToClass(maya1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(maya1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya1VillageID, 0, 0.475, 0.175);
	} 

/*---------------------------------------------------------------------------------------------------------------*/

       if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs village 2", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.625, 0.725);
	}
	
/*---------------------------------------------------------------------------------------------------------------*/	

	    if (subCiv3 == rmGetCivID("maya"))
	{  
		int maya2VillageID = -1;
		maya2VillageID = rmCreateGrouping("maya village 2", "native maya village 1");
		rmSetGroupingMinDistance(maya2VillageID, 0.0);
		rmSetGroupingMaxDistance(maya2VillageID, 0.0);
		rmAddGroupingToClass(maya2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(maya2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya2VillageID, 0, 0.825, 0.525);
	} 	
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE CLIFFS: ****************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int cliffID=rmCreateArea("cliff"+i);
        rmSetAreaSize(cliffID, 0.05, 0.05);
		rmSetAreaLocation(cliffID, 0.575, 0.425); 
        rmSetAreaWarnFailure(cliffID, false);
        
		if ( whichVariation == 1 )
		rmSetAreaCliffType(cliffID, "Amazon");
		else
		rmSetAreaCliffType(cliffID, "Patagonia");
        
		rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
        rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, 8, 2.0, 0.5);
        rmSetAreaHeightBlend(cliffID, 1);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
	    
		if ( whichVariation == 1 )
		rmSetAreaMix(cliffID, "yucatan_grass");
		else
		rmSetAreaMix(cliffID, "patagonia_dirt");
        
		rmAddAreaConstraint(cliffID, avoidCliffs);
	    rmSetAreaMinBlobs(cliffID, 1);
        rmSetAreaMaxBlobs(cliffID, 1);
        rmSetAreaMinBlobDistance(cliffID, 1.0);
        rmSetAreaMaxBlobDistance(cliffID, 1.0);
        rmSetAreaSmoothDistance(cliffID, 5);
        rmSetAreaCoherence(cliffID, 0.85);		// higher = tries to make round
		rmAddAreaInfluenceSegment(cliffID, 0.425, 0.575, 0.725, 0.275);
        rmBuildArea(cliffID);
  
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*===============================================================================================================*/

        // THE NORTHERN NUGGETS:
		int nuggetID= rmCreateObjectDef("The Northern nuggets"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    
		rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nuggetID, avoidAll);
		rmAddObjectDefConstraint(nuggetID, Northward);
		rmAddObjectDefConstraint(nuggetID, avoidCloseNatives);
		rmAddObjectDefConstraint(nuggetID, avoidCloseCliffs);
  	    rmAddObjectDefConstraint(nuggetID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(nuggetID, avoidStartingUnits);
	    rmAddObjectDefConstraint(nuggetID, avoidCloseSocket);
	    rmAddObjectDefConstraint(nuggetID, avoidWater8);
	    rmAddObjectDefConstraint(nuggetID, circleConstraint);
		rmSetNuggetDifficulty(1, 3);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
		
/*---------------------------------------------------------------------------------------------------------------*/
	
        // THE SOUTHERN NUGGETS:
		int nugget2ID= rmCreateObjectDef("The Southern Nuggets"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    
		rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nugget2ID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget2ID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nugget2ID, avoidAll);
		rmAddObjectDefConstraint(nugget2ID, Southward);
		rmAddObjectDefConstraint(nugget2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget2ID, avoidCloseCliffs);
  	    rmAddObjectDefConstraint(nugget2ID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(nugget2ID, avoidStartingUnits);
	    rmAddObjectDefConstraint(nugget2ID, avoidCloseSocket);
	    rmAddObjectDefConstraint(nugget2ID, avoidWater8);
	    rmAddObjectDefConstraint(nugget2ID, circleConstraint);
		rmSetNuggetDifficulty(1, 3);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
			
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/
// ******************************** DEFINE AND PLACE THE FISHES AND THE WHALES: ******************************** //
/*===============================================================================================================*/
   
        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);

	    // FAST COIN -- WHALES (reasonable in Patagonia, right?)
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "beluga", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 1.0*cNumberNonGaiaPlayers);		

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE GOLD MINES: ************************************** //
/*===============================================================================================================*/

        // THE NORTHERN GOLD MINES:
		int GoldID= rmCreateObjectDef("The Northern Gold Mines"); 
		
		if ( whichVariation == 1 )
		rmAddObjectDefItem(GoldID, "minegold", 1, 0.0);
		else
		rmAddObjectDefItem(GoldID, "mine", 1, 0.0);
	    	    
		rmSetObjectDefMinDistance(GoldID, 0.0);
	    rmSetObjectDefMaxDistance(GoldID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(GoldID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(GoldID, avoidFarNugget);
		rmAddObjectDefConstraint(GoldID, avoidFarCoin);
  	    rmAddObjectDefConstraint(GoldID, avoidAll);
		rmAddObjectDefConstraint(GoldID, Northward);
		rmAddObjectDefConstraint(GoldID, avoidCloseNatives);
		rmAddObjectDefConstraint(GoldID, avoidCloseCliffs);
  	    rmAddObjectDefConstraint(GoldID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(GoldID, avoidStartingUnits);
	    rmAddObjectDefConstraint(GoldID, avoidCloseSocket);
	    rmAddObjectDefConstraint(GoldID, avoidWater8);
	    rmAddObjectDefConstraint(GoldID, circleConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(GoldID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(GoldID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN GOLD MINES:
		int Gold2ID= rmCreateObjectDef("The Southern Gold Mines"); 
	    
		if ( whichVariation == 1 )
		rmAddObjectDefItem(Gold2ID, "minegold", 1, 0.0);
		else
		rmAddObjectDefItem(Gold2ID, "mine", 1, 0.0);
	    
		rmSetObjectDefMinDistance(Gold2ID, 0.0);
	    rmSetObjectDefMaxDistance(Gold2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(Gold2ID, avoidImpassableLand);
  	    rmAddObjectDefConstraint(Gold2ID, avoidFarNugget);
		rmAddObjectDefConstraint(Gold2ID, avoidFarCoin);
  	    rmAddObjectDefConstraint(Gold2ID, avoidAll);
		rmAddObjectDefConstraint(Gold2ID, Southward);
		rmAddObjectDefConstraint(Gold2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(Gold2ID, avoidCloseCliffs);
  	    rmAddObjectDefConstraint(Gold2ID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(Gold2ID, avoidStartingUnits);
	    rmAddObjectDefConstraint(Gold2ID, avoidCloseSocket);
	    rmAddObjectDefConstraint(Gold2ID, avoidWater8);
	    rmAddObjectDefConstraint(Gold2ID, circleConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.91);
/*===============================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: *************************************** //
/*===============================================================================================================*/

          // THE FOREST:
          int forestTreeID = 0;
		  if (cNumberNonGaiaPlayers<=2)
		  int numTries = cNumberNonGaiaPlayers*12;
	      else
		  numTries = cNumberNonGaiaPlayers*6;
         
         int failCount=0;
         for (i=0; <numTries)
      {   
         int forest=rmCreateArea("forest "+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(250));
		 
		 if ( whichVariation == 1 )
		rmSetAreaForestType(forest, "Yucatan forest");
		else
		rmSetAreaForestType(forest, "patagonia forest");
		 
         //rmSetAreaForestType(forest, "patagonia forest");
			// rmSetAreaForestType(forest, "dunes");
         rmSetAreaForestDensity(forest, 1.0);
         rmSetAreaForestClumpiness(forest, 0.2);
         rmSetAreaForestUnderbrush(forest, 0.0);
         /*
			rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 4);
         rmSetAreaMinBlobDistance(forest, 4.0);
         rmSetAreaMaxBlobDistance(forest, 12.0);
			*/
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
         rmAddAreaConstraint(forest, forestConstraint);
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidCloseNatives);
			rmAddAreaConstraint(forest, avoidCloseCoin);
		rmAddAreaConstraint(forest, avoidCloseCliffs);	
         // rmAddAreaConstraint(forest, avoidBeach);
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidCloseTradeRoute); 
		  rmAddAreaConstraint(forest, avoidStartingUnits); 
			rmAddAreaConstraint(forest, avoidCloseSocket); 
			rmAddAreaConstraint(forest, Northward); 
         if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      } 
	  
/*---------------------------------------------------------------------------------------------------------------*/
	  

         // THE WEST FOREST:
		 if (cNumberNonGaiaPlayers<=2)
		 numTries = cNumberNonGaiaPlayers*12;
	     else
		 numTries = cNumberNonGaiaPlayers*6;		
         
         failCount=0;
         for (i=0; <numTries)
      {   
         forest=rmCreateArea("west forest "+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(100), rmAreaTilesToFraction(150));
		 
		 if ( whichVariation == 1 )
		rmSetAreaForestType(forest, "Yucatan forest");
		else
		rmSetAreaForestType(forest, "patagonia forest");
		 
         //rmSetAreaForestType(forest, "patagonia forest");
			// rmSetAreaForestType(forest, "dunes");
         rmSetAreaForestDensity(forest, 1.0);
         rmSetAreaForestClumpiness(forest, 0.2);
         rmSetAreaForestUnderbrush(forest, 0.0);
         /*
			rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 4);
         rmSetAreaMinBlobDistance(forest, 4.0);
         rmSetAreaMaxBlobDistance(forest, 12.0);
			*/
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
		 rmAddAreaToClass(forest, rmClassID("classWestForest")); 
         rmAddAreaConstraint(forest, forestConstraint);
		 rmAddAreaConstraint(forest, westForestConstraint);
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidCloseNatives);
			rmAddAreaConstraint(forest, avoidCloseCoin);
         rmAddAreaConstraint(forest, avoidCloseCliffs);
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidCloseTradeRoute); 
		  // rmAddAreaConstraint(forest, avoidStartingUnits); 
			rmAddAreaConstraint(forest, avoidCloseSocket); 
			rmAddAreaConstraint(forest, Southward); 
         if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      } 

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.92);
/*===============================================================================================================*/		
// ************************************* DEFINE AND PLACE THE HACK BIGHORN ************************************* //
/*===============================================================================================================*/
    
	    // THE NORTHERN DEER HERDS:
        int DeerID=rmCreateObjectDef("The Northern Deer Herds");
	    rmAddObjectDefItem(DeerID, "deer", rmRandInt(5,7), 6.0);
        rmSetObjectDefMinDistance(DeerID, 0.0);
        rmSetObjectDefMaxDistance(DeerID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(DeerID, avoidFarDeer);
        rmAddObjectDefConstraint(DeerID, avoidAll);
		rmAddObjectDefConstraint(DeerID, avoidCloseCoin);
		rmAddObjectDefConstraint(DeerID, avoidCloseCliffs);
		rmAddObjectDefConstraint(DeerID, avoidCloseNatives);
        rmAddObjectDefConstraint(DeerID, avoidImpassableLand);
	    rmAddObjectDefConstraint(DeerID, Northward);
	    rmAddObjectDefConstraint(DeerID, avoidStartingUnits);
	    rmAddObjectDefConstraint(DeerID, avoidCloseSocket);
	    rmAddObjectDefConstraint(DeerID, avoidCloseTradeRoute);
        rmSetObjectDefCreateHerd(DeerID, true);
	   
        if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(DeerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		else
		rmPlaceObjectDefAtLoc(DeerID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	   		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN DEER HERDS:
        int Deer2ID=rmCreateObjectDef("The Southern Deer Herds");
	    rmAddObjectDefItem(Deer2ID, "deer", rmRandInt(5,7), 6.0);
        rmSetObjectDefMinDistance(Deer2ID, 0.0);
        rmSetObjectDefMaxDistance(Deer2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(Deer2ID, avoidFarDeer);
        rmAddObjectDefConstraint(Deer2ID, avoidAll);
		rmAddObjectDefConstraint(Deer2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Deer2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(Deer2ID, avoidCloseNatives);
        rmAddObjectDefConstraint(Deer2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Deer2ID, Southward);
	    rmAddObjectDefConstraint(Deer2ID, avoidStartingUnits);
	    rmAddObjectDefConstraint(Deer2ID, avoidCloseSocket);
	    rmAddObjectDefConstraint(Deer2ID, avoidCloseTradeRoute);
        rmSetObjectDefCreateHerd(Deer2ID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		else
		rmPlaceObjectDefAtLoc(Deer2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	   	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE RHEA FLOCK: ************************************** //
/*===============================================================================================================*/
 
		// THE NORTHERN RHEA FLOCK:
		int rheaID=rmCreateObjectDef("The Northern Rhea Flock");
        rmAddObjectDefItem(rheaID, "rhea", rmRandInt(5,7), 6.0);
        rmSetObjectDefMinDistance(rheaID, 0.0);
        rmSetObjectDefMaxDistance(rheaID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(rheaID, avoidFarRhea);
		rmAddObjectDefConstraint(rheaID, avoidMediumDeer);
	    rmAddObjectDefConstraint(rheaID, avoidAll);
		rmAddObjectDefConstraint(rheaID, avoidCloseCoin);
		rmAddObjectDefConstraint(rheaID, avoidCloseNatives);
		rmAddObjectDefConstraint(rheaID, avoidCloseCliffs);
		rmAddObjectDefConstraint(rheaID, avoidCloseSocket);
        rmAddObjectDefConstraint(rheaID, avoidImpassableLand);
        rmAddObjectDefConstraint(rheaID, avoidStartingUnits);
	    rmAddObjectDefConstraint(rheaID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(rheaID, Northward);
        rmSetObjectDefCreateHerd(rheaID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(rheaID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		else
		rmPlaceObjectDefAtLoc(rheaID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	    
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN RHEA FLOCK:
		int rhea2ID=rmCreateObjectDef("The Southern Rhea Flock");
        rmAddObjectDefItem(rhea2ID, "rhea", rmRandInt(5,7), 6.0);
        rmSetObjectDefMinDistance(rhea2ID, 0.0);
        rmSetObjectDefMaxDistance(rhea2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(rhea2ID, avoidFarRhea);
		rmAddObjectDefConstraint(rhea2ID, avoidMediumDeer);
	    rmAddObjectDefConstraint(rhea2ID, avoidAll);
		rmAddObjectDefConstraint(rhea2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(rhea2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(rhea2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(rhea2ID, avoidCloseSocket);
        rmAddObjectDefConstraint(rhea2ID, avoidImpassableLand);
        rmAddObjectDefConstraint(rhea2ID, avoidStartingUnits);
	    rmAddObjectDefConstraint(rhea2ID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(rhea2ID, Southward);
        rmSetObjectDefCreateHerd(rhea2ID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(rhea2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		else
		rmPlaceObjectDefAtLoc(rhea2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
	    		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.97);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE SHEEP HERDS: ************************************** //
/*===============================================================================================================*/

	    // THE NORTHERN SHEEP HERDS:
		int sheepID=rmCreateObjectDef("The Northern Sheep Herds");
	    rmAddObjectDefItem(sheepID, "sheep", rmRandInt(3,7), 6.0);
	    rmSetObjectDefMinDistance(sheepID, 0.0);
	    rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(sheepID, avoidFarSheep);
	    rmAddObjectDefConstraint(sheepID, avoidAll);
		rmAddObjectDefConstraint(sheepID, avoidMediumRhea);
		rmAddObjectDefConstraint(sheepID, avoidMediumDeer);
		rmAddObjectDefConstraint(sheepID, avoidCloseNatives);
		rmAddObjectDefConstraint(sheepID, avoidCloseCoin);
		rmAddObjectDefConstraint(sheepID, avoidCloseCliffs);
		rmAddObjectDefConstraint(sheepID, avoidCloseSocket);
        rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
        rmAddObjectDefConstraint(sheepID, avoidStartingUnits);
	    rmAddObjectDefConstraint(sheepID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(sheepID, Northward);
		rmSetObjectDefCreateHerd(sheepID, true);
	    
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
				
/*---------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN SHEEP HERDS:
		int sheep2ID=rmCreateObjectDef("The Southern Sheep Herds");
	    rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(3,7), 6.0);
	    rmSetObjectDefMinDistance(sheep2ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(sheep2ID, avoidFarSheep);
	    rmAddObjectDefConstraint(sheep2ID, avoidAll);
		rmAddObjectDefConstraint(sheep2ID, avoidMediumRhea);
		rmAddObjectDefConstraint(sheep2ID, avoidMediumDeer);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseSocket);
        rmAddObjectDefConstraint(sheep2ID, avoidImpassableLand);
        rmAddObjectDefConstraint(sheep2ID, avoidStartingUnits);
	    rmAddObjectDefConstraint(sheep2ID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(sheep2ID, Southward);
		rmSetObjectDefCreateHerd(sheep2ID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*===============================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: ************************************** //
/*===============================================================================================================*/

	    // THE NORTHERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Northern Berries");
	    rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 6.0);
	    rmSetObjectDefMinDistance(BerriesID, 0.0);
	    rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(BerriesID, avoidMediumSheep);
	    rmAddObjectDefConstraint(BerriesID, avoidAll);
		rmAddObjectDefConstraint(BerriesID, avoidCloseNugget);
		rmAddObjectDefConstraint(BerriesID, avoidFarFruits);
		rmAddObjectDefConstraint(BerriesID, avoidMediumRhea);
		rmAddObjectDefConstraint(BerriesID, avoidMediumDeer);
		rmAddObjectDefConstraint(BerriesID, avoidCloseNatives);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCoin);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCliffs);
		rmAddObjectDefConstraint(BerriesID, avoidCloseSocket);
        rmAddObjectDefConstraint(BerriesID, avoidImpassableLand);
        rmAddObjectDefConstraint(BerriesID, avoidStartingUnits);
	    rmAddObjectDefConstraint(BerriesID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(BerriesID, Northward);
		rmSetObjectDefCreateHerd(BerriesID, true);
	    
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
				
/*---------------------------------------------------------------------------------------------------------------*/

        // THE NORTHERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Southern Berries");
	    rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 6.0);
	    rmSetObjectDefMinDistance(Berries2ID, 0.0);
	    rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(Berries2ID, avoidMediumSheep);
	    rmAddObjectDefConstraint(Berries2ID, avoidAll);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries2ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries2ID, avoidMediumRhea);
		rmAddObjectDefConstraint(Berries2ID, avoidMediumDeer);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseSocket);
        rmAddObjectDefConstraint(Berries2ID, avoidImpassableLand);
        rmAddObjectDefConstraint(Berries2ID, avoidStartingUnits);
	    rmAddObjectDefConstraint(Berries2ID, avoidCloseTradeRoute);
	    rmAddObjectDefConstraint(Berries2ID, Southward);
		rmSetObjectDefCreateHerd(Berries2ID, true);
	    
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);	
		
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE NORTH REGION:
		int randomTreeID=rmCreateObjectDef("random tree 1");
		
		if ( whichVariation == 1 )
        rmAddObjectDefItem(randomTreeID, "TreeYucatan", 1, 0.0);
		else
		rmAddObjectDefItem(randomTreeID, "TreePatagoniaDirt", 1, 0.0);
		
        //rmAddObjectDefItem(randomTreeID, "TreePatagoniaDirt", rmRandInt(1,1), 2.0);
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseCliffs);   
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseImportantItem);
	    rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, Northward);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseRhea);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFruits);
	    rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 36*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);	

/*---------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE SOUTH REGION:
		int randomTree2ID=rmCreateObjectDef("random tree 2");
		
		if ( whichVariation == 1 )
        rmAddObjectDefItem(randomTree2ID, "TreeYucatan", 1, 0.0);
		else
		rmAddObjectDefItem(randomTree2ID, "TreePatagoniaDirt", 1, 0.0);
		
        //rmAddObjectDefItem(randomTree2ID, "TreePatagoniaDirt", rmRandInt(1,1), 2.0);
		rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTree2ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(randomTree2ID, avoidCloseImportantItem);
	    rmAddObjectDefConstraint(randomTree2ID, avoidAll);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(randomTree2ID, Southward);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseRhea);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseFruits);
	    rmAddObjectDefConstraint(randomTree2ID, avoidImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 36*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);		
					
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		
   