/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/

// THE ACADIAN WAR:
// CREATED BY DANY:
// AUGUST 2007:
// A RANDOM MAP FOR AGE OF EMPIRES III: MY 57TH RMS:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// *********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
        int subCiv5=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Iroquois");

		subCiv4=rmGetCivID("Iroquois");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Iroquois");

		subCiv5=rmGetCivID("Iroquois");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Iroquois");
   } 		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ******************************************* PICKS THE MAP SIZE: ********************************************** //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

    	int playerTiles=17500;
   
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.06);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // PICKS DEFAULT TERRAIN AND WATER:
        rmSetSeaType("new england coast");
   
	    // SOME MAP TURBULENCE:
	    rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);  // LIKE TEXAS FOR THE MOMENT:
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1.0);

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(4.0);
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("new_england\ground1_ne", 1.0); // FROM NEW ENGLAND:
	    
		// SET THE MAP TYPE:
		rmSetMapType("newEngland");
	    rmSetMapType("water");
		rmSetMapType("grass");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2.0);
	    
		// SET THE LIGHTING:
		rmSetLightingSet("new england");
		
	    // CHOOSE THE MERCS:
	    chooseMercs();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classCliff");
        rmDefineClass("classWall");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("socketClass");
	    rmDefineClass("nuggets");
        rmDefineClass("natives");

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER ************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
           
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
        int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 12.0);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);

        // CARDINAL DIRECTIONS:
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
				
		// RESOURCE AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
        		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
	    // COIN AVOIDANCE:
		int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 30.0);
        int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35);
		
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 10.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);
		int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 20.0);
        		
		// COW AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// MOOSE AVOIDANCE:
		int avoidMoose=rmCreateTypeDistanceConstraint("stuff avoids moose", "moose", 10.0);
		int avoidCloseMoose=rmCreateTypeDistanceConstraint("close avoids moose", "moose", 2.0);
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoids trees", "TreeNewEngland", 10.0);
		int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoids trees", "TreeNewEngland", 2.0);
        		
		// UNIT AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 5.0);

        // AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	    int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	    
		// CLIFFS AVOIDANCE:
		int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 15.0);
		int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 8.0);
	    		
		// UNIT AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
        
		// IMPORTANT AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 6.0);
	    
		// SOCKETS AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 6.0);
		int avoidCloseSocket=rmCreateClassDistanceConstraint("close avoid sockets", rmClassID("socketClass"), 2.0);

        // WALL CONSTRAINT:
		int wallConstraint=rmCreateClassDistanceConstraint("wall vs. wall", rmClassID("classWall"), 10.0);
	    int avoidCloseWall=rmCreateClassDistanceConstraint("close avoids wall", rmClassID("classWall"), 2.0);
	   		
		// CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
	    
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ********************************************* DEFINE THE AREAS: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// ************************************ SET UP PLAYER STARTING LOCATIONS: *************************************** //
/*================================================================================================================*/
 	    
		if ( cNumberTeams == 2 )
					
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.775,0.775);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.225,0.225);
	}  
		else
    {		
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.225,0.225);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.775,0.775);
	} 	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/		
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(100);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		// rmAddAreaConstraint(id, playerConstraint); 
        // rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// *************************************** DEFINE THE PLACEMENT ORDER: ****************************************** //
/*================================================================================================================*/		

   // Placement order:
   // Trade route -> Lakes -> Natives -> Secrets -> Cliffs -> Nuggets
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE TRADE ROUTES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        		
        // TEXT:
		// THIS TRADE ROUTE IS A SQUARE:
		// THIS IS MY FIRST ONE:
		
		// DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  
	    int tradeRouteID = rmCreateTradeRoute();
      
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts Square");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 8.0);
	    rmAddObjectDefConstraint(socketID, avoidCloseTradeRoute);

	    rmAddTradeRouteWaypoint(tradeRouteID, 0.15, 0.55); // STARTING THE SQUARE TRADE ROUTE:
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.85);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.85, 0.45);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.55, 0.15);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.15, 0.55); // CLOSING THE SQUARE TRADE ROUTE:
	  	  	  
        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
	  
/*================================================================================================================*/
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:

	    rmPlaceObjectDefAtLoc(socketID, 0, 0.15, 0.55);
        rmPlaceObjectDefAtLoc(socketID, 0, 0.30, 0.70); 		
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.45, 0.85); 
		rmPlaceObjectDefAtLoc(socketID, 0, 0.65, 0.65);
        rmPlaceObjectDefAtLoc(socketID, 0, 0.85, 0.45); 		
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.70, 0.30);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.55, 0.15); 
        rmPlaceObjectDefAtLoc(socketID, 0, 0.35, 0.35);
        		
	    	  
	    // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE LAKE IN THE MIDDLE: ********************************** //
/*================================================================================================================*/
        
		int lakeClass=rmDefineClass("lake");
	    int lakeConstraint=rmCreateClassDistanceConstraint("lake vs. lake", rmClassID("lake"), 20.0);

        int smallLakeID=rmCreateArea("small lake");
		rmSetAreaSize(smallLakeID, rmAreaTilesToFraction(3500), rmAreaTilesToFraction(3500));
		rmSetAreaWaterType(smallLakeID, "new england lake");
		rmSetAreaBaseHeight(smallLakeID, 2.0);
		rmAddAreaToClass(smallLakeID, lakeClass);
		rmAddAreaConstraint(smallLakeID, playerConstraint);
		//rmAddAreaConstraint(smallLakeID, avoidTradeRoute);
		rmSetAreaLocation(smallLakeID, 0.50, 0.50);
		rmSetAreaCoherence(smallLakeID, 1.0);
		rmSetAreaWarnFailure(smallLakeID, false);
		rmBuildArea(smallLakeID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE CLIFFS: ***************************************** //
/*================================================================================================================*/

        int cliffID=rmCreateArea("cliff");
        rmSetAreaSize(cliffID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
        rmSetAreaWarnFailure(cliffID, false);
	    rmSetAreaCliffType(cliffID, "New England");
	    rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffID, 1);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffID, avoidCliffs);
	    rmSetAreaMinBlobs(cliffID, 1);
        rmSetAreaMaxBlobs(cliffID, 1);
        rmSetAreaMinBlobDistance(cliffID, 1);
        rmSetAreaMaxBlobDistance(cliffID, 1);
        rmSetAreaSmoothDistance(cliffID, 10);
        rmSetAreaCoherence(cliffID, 0.95);
		rmSetAreaLocation(cliffID, 0.175, 0.425);
		rmBuildArea(cliffID);

/*----------------------------------------------------------------------------------------------------------------*/

        int cliff2ID=rmCreateArea("cliff 2");
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
        rmSetAreaWarnFailure(cliff2ID, false);
	    rmSetAreaCliffType(cliff2ID, "New England");
	    rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff2ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff2ID, 1);
        rmAddAreaToClass(cliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff2ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff2ID, 1);
        rmSetAreaMaxBlobs(cliff2ID, 1);
        rmSetAreaMinBlobDistance(cliff2ID, 1);
        rmSetAreaMaxBlobDistance(cliff2ID, 1);
        rmSetAreaSmoothDistance(cliff2ID, 10);
        rmSetAreaCoherence(cliff2ID, 0.95);
		rmSetAreaLocation(cliff2ID, 0.425, 0.175);
		rmBuildArea(cliff2ID);

/*----------------------------------------------------------------------------------------------------------------*/

        int cliff3ID=rmCreateArea("cliff 3");
        rmSetAreaSize(cliff3ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
        rmSetAreaWarnFailure(cliff3ID, false);
	    rmSetAreaCliffType(cliff3ID, "New England");
	    rmSetAreaCliffEdge(cliff3ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff3ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff3ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff3ID, 1);
        rmAddAreaToClass(cliff3ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff3ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff3ID, 1);
        rmSetAreaMaxBlobs(cliff3ID, 1);
        rmSetAreaMinBlobDistance(cliff3ID, 1);
        rmSetAreaMaxBlobDistance(cliff3ID, 1);
        rmSetAreaSmoothDistance(cliff3ID, 10);
        rmSetAreaCoherence(cliff3ID, 0.95);
		rmSetAreaLocation(cliff3ID, 0.575, 0.825);
		rmBuildArea(cliff3ID);

/*----------------------------------------------------------------------------------------------------------------*/

        int cliff4ID=rmCreateArea("cliff 4");
        rmSetAreaSize(cliff4ID, rmAreaTilesToFraction(425), rmAreaTilesToFraction(425));
        rmSetAreaWarnFailure(cliff4ID, false);
	    rmSetAreaCliffType(cliff4ID, "New England");
	    rmSetAreaCliffEdge(cliff4ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff4ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff4ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff4ID, 1);
        rmAddAreaToClass(cliff4ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff4ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff4ID, 1);
        rmSetAreaMaxBlobs(cliff4ID, 1);
        rmSetAreaMinBlobDistance(cliff4ID, 1);
        rmSetAreaMaxBlobDistance(cliff4ID, 1);
        rmSetAreaSmoothDistance(cliff4ID, 10);
        rmSetAreaCoherence(cliff4ID, 0.95);
		rmSetAreaLocation(cliff4ID, 0.825, 0.575);
		rmBuildArea(cliff4ID);
		
/*================================================================================================================*/
// *************************** DEFINE AND PLACE THE GOLD MINES IN THE SMALL VALLEYS: *************************** //		
/*================================================================================================================*/

        // THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.175, 0.425);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.425, 0.175);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.575, 0.825);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.825, 0.575); 

/*----------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINE NUMBER 2:
		int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.35, 0.65);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.65, 0.35);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SMALL CLIFFS: ************************************** //
/*================================================================================================================*/
		
		int smallCliff1ID=rmCreateArea("small cliff 1");
        rmSetAreaSize(smallCliff1ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
        rmSetAreaWarnFailure(smallCliff1ID, false);
	    rmSetAreaCliffType(smallCliff1ID, "New England");
		rmSetAreaCliffEdge(smallCliff1ID, 1, 1.0, 0.1, 1.0, 0);
	    //rmSetAreaCliffEdge(smallCliff1ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(smallCliff1ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(smallCliff1ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(smallCliff1ID, 1);
        rmAddAreaToClass(smallCliff1ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(smallCliff1ID, avoidCliffs);
	    rmSetAreaMinBlobs(smallCliff1ID, 1);
        rmSetAreaMaxBlobs(smallCliff1ID, 1);
        rmSetAreaMinBlobDistance(smallCliff1ID, 1);
        rmSetAreaMaxBlobDistance(smallCliff1ID, 1);
        rmSetAreaSmoothDistance(smallCliff1ID, 10);
        rmSetAreaCoherence(smallCliff1ID, 0.95);
		rmSetAreaLocation(smallCliff1ID, 0.125, 0.675);
		rmBuildArea(smallCliff1ID);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int smallCliff2ID=rmCreateArea("small cliff 2");
        rmSetAreaSize(smallCliff2ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
        rmSetAreaWarnFailure(smallCliff2ID, false);
	    rmSetAreaCliffType(smallCliff2ID, "New England");
		rmSetAreaCliffEdge(smallCliff2ID, 1, 1.0, 0.1, 1.0, 0);
	    //rmSetAreaCliffEdge(smallCliff2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(smallCliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(smallCliff2ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(smallCliff2ID, 1);
        rmAddAreaToClass(smallCliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(smallCliff2ID, avoidCliffs);
	    rmSetAreaMinBlobs(smallCliff2ID, 1);
        rmSetAreaMaxBlobs(smallCliff2ID, 1);
        rmSetAreaMinBlobDistance(smallCliff2ID, 1);
        rmSetAreaMaxBlobDistance(smallCliff2ID, 1);
        rmSetAreaSmoothDistance(smallCliff2ID, 10);
        rmSetAreaCoherence(smallCliff2ID, 0.95);
		rmSetAreaLocation(smallCliff2ID, 0.675, 0.125);
		rmBuildArea(smallCliff2ID);

/*----------------------------------------------------------------------------------------------------------------*/

        int smallCliff3ID=rmCreateArea("small cliff 3");
        rmSetAreaSize(smallCliff3ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
        rmSetAreaWarnFailure(smallCliff3ID, false);
	    rmSetAreaCliffType(smallCliff3ID, "New England");
		rmSetAreaCliffEdge(smallCliff3ID, 1, 1.0, 0.1, 1.0, 0);
	    //rmSetAreaCliffEdge(smallCliff3ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(smallCliff3ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(smallCliff3ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(smallCliff3ID, 1);
        rmAddAreaToClass(smallCliff3ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(smallCliff3ID, avoidCliffs);
	    rmSetAreaMinBlobs(smallCliff3ID, 1);
        rmSetAreaMaxBlobs(smallCliff3ID, 1);
        rmSetAreaMinBlobDistance(smallCliff3ID, 1);
        rmSetAreaMaxBlobDistance(smallCliff3ID, 1);
        rmSetAreaSmoothDistance(smallCliff3ID, 10);
        rmSetAreaCoherence(smallCliff3ID, 0.95);
		rmSetAreaLocation(smallCliff3ID, 0.325, 0.875);
		rmBuildArea(smallCliff3ID);	

/*----------------------------------------------------------------------------------------------------------------*/

        int smallCliff4ID=rmCreateArea("small cliff 4");
        rmSetAreaSize(smallCliff4ID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
        rmSetAreaWarnFailure(smallCliff4ID, false);
	    rmSetAreaCliffType(smallCliff4ID, "New England");
		rmSetAreaCliffEdge(smallCliff4ID, 1, 1.0, 0.1, 1.0, 0);
	    //rmSetAreaCliffEdge(smallCliff4ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(smallCliff4ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(smallCliff4ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(smallCliff4ID, 1);
        rmAddAreaToClass(smallCliff4ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(smallCliff4ID, avoidCliffs);
	    rmSetAreaMinBlobs(smallCliff4ID, 1);
        rmSetAreaMaxBlobs(smallCliff4ID, 1);
        rmSetAreaMinBlobDistance(smallCliff4ID, 1);
        rmSetAreaMaxBlobDistance(smallCliff4ID, 1);
        rmSetAreaSmoothDistance(smallCliff4ID, 10);
        rmSetAreaCoherence(smallCliff4ID, 0.95);
		rmSetAreaLocation(smallCliff4ID, 0.875, 0.325);
		rmBuildArea(smallCliff4ID);				
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE NATIVE AMERICANS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.30, 0.55);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.45, 0.70);
	} 

/*----------------------------------------------------------------------------------------------------------------*/
	
	    if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.70, 0.45);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.55, 0.30);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv4 == rmGetCivID("iroquois"))
	{  
		int iroquois5VillageID = -1;
		iroquois5VillageID = rmCreateGrouping("iroquois village 5", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois5VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois5VillageID, 0.0);
		rmAddGroupingToClass(iroquois5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois5VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.20, 0.80);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv5 == rmGetCivID("iroquois"))
	{  
		int iroquois6VillageID = -1;
		iroquois6VillageID = rmCreateGrouping("iroquois village 6", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois6VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois6VillageID, 0.0);
		rmAddGroupingToClass(iroquois6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois6VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.80, 0.20);
	} 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// ******************** DEFINE THE STARTING UNITS AND STARTING TCID AND STARTING RESOURCES: ********************* //
/*================================================================================================================*/

        // DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
		
/*----------------------------------------------------------------------------------------------------------------*/		

	int silverType = -1;
	int playerGoldID = -1;

	int StartAreaTreeID=rmCreateObjectDef("starting trees");
	rmAddObjectDefItem(StartAreaTreeID, "TreeNewEngland", 1, 0.0);
	rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	int StartBerriesID=rmCreateObjectDef("starting Berries");
	rmAddObjectDefItem(StartBerriesID, "BerryBush", rmRandInt(3,5), 5.0);
	rmSetObjectDefMinDistance(StartBerriesID, 10.0);
	rmSetObjectDefMaxDistance(StartBerriesID, 15.0);
	rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnitsSmall);
	
	int StartFarBerriesID=rmCreateObjectDef("starting FarBerries");
	rmAddObjectDefItem(StartFarBerriesID, "BerryBush", rmRandInt(3,5), 5.0);
	rmSetObjectDefMinDistance(StartFarBerriesID, 16.0);
	rmSetObjectDefMaxDistance(StartFarBerriesID, 20.0);
	rmAddObjectDefConstraint(StartFarBerriesID, avoidStartingUnitsSmall);

	int playerNuggetID=rmCreateObjectDef("player nugget");
	rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
    rmSetObjectDefMinDistance(playerNuggetID, 30.0);
    rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	// rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);
		
/*================================================================================================================*/
// ************************ PLACE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ********************** //	
/*================================================================================================================*/
	
	    for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();
		
		// Place starting units and a TC!
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Everyone gets one ore grouping close by.
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		rmSetObjectDefMinDistance(playerGoldID, 25.0);
		rmSetObjectDefMaxDistance(playerGoldID, 30.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartFarBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		rmClearClosestPointConstraints();
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM BERRIES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.10, 0.30);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.30, 0.10);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.70, 0.90);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.90, 0.70);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.85, 0.25);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.15, 0.75);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE COWS: ********************************************* //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmSetObjectDefCreateHerd(cow1ID, true);
	    
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.325, 0.45);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.45, 0.325);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.55, 0.675);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.675, 0.55);

/*----------------------------------------------------------------------------------------------------------------*/

        int cow2ID=rmCreateObjectDef("The Cows 2");
        rmAddObjectDefItem(cow2ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow2ID, 0.0);
        rmSetObjectDefMaxDistance(cow2ID, 0.0);
	    rmAddObjectDefConstraint(cow2ID, avoidCow);
		rmSetObjectDefCreateHerd(cow2ID, true);
	    
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.25, 0.85);
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.75, 0.15);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.375, 0.625);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.625, 0.375);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int deer2ID=rmCreateObjectDef("The Deer Herds 2");
        rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, 0.0);
	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer2ID, true);
	    
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.10, 0.60);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.60, 0.10);
        rmPlaceObjectDefAtLoc(deer2ID, 0, 0.40, 0.90);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.90, 0.40);	

/*----------------------------------------------------------------------------------------------------------------*/

        int deer3ID=rmCreateObjectDef("The Deer Herds 3");
        rmAddObjectDefItem(deer3ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer3ID, 0.0);
        rmSetObjectDefMaxDistance(deer3ID, 0.0);
	    rmAddObjectDefConstraint(deer3ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer3ID, true);
	    
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.15, 0.35);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.35, 0.15);
        rmPlaceObjectDefAtLoc(deer3ID, 0, 0.65, 0.85);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.85, 0.65); 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.82);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int Moose1ID=rmCreateObjectDef("The Moose Herds 1");
        rmAddObjectDefItem(Moose1ID, "moose", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(Moose1ID, 0.0);
        rmSetObjectDefMaxDistance(Moose1ID, 0.0);
	    rmAddObjectDefConstraint(Moose1ID, avoidMoose);
		rmSetObjectDefCreateHerd(Moose1ID, true);
	    
		rmPlaceObjectDefAtLoc(Moose1ID, 0, 0.30, 0.30);
		rmPlaceObjectDefAtLoc(Moose1ID, 0, 0.70, 0.70);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.84);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TREASURES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.25, 0.75);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.75, 0.25);
		
		//rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.50, 0.70);
		//rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.70, 0.50);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.05, 0.45);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.45, 0.05);
		
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.55, 0.95);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.95, 0.55);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.40, 0.70);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.70, 0.40);
		
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.30, 0.60);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.60, 0.30);        		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE SOME ROCK WALLS: ************************************** //
/*===============================================================================================================*/

	    int stoneWallType = -1;
	    int stoneWallID = -1;
	    int stoneWallCount = cNumberNonGaiaPlayers*2;
        rmEchoInfo("stoneWall count = "+stoneWallCount);

	    for(i=0; < stoneWallCount)
   {
		stoneWallType = rmRandInt(1,4);
        stoneWallID = rmCreateGrouping("stone wall "+i, "ne_rockwall "+stoneWallType);
		rmAddGroupingToClass(stoneWallID, rmClassID("classWall"));
        rmSetGroupingMinDistance(stoneWallID, 0.0);
        rmSetGroupingMaxDistance(stoneWallID, 0.0);
		rmAddGroupingConstraint(stoneWallID, wallConstraint);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.075, 0.375);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.375, 0.075);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.625, 0.925);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.925, 0.625);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.225, 0.525);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.525, 0.225);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.475, 0.775);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.775, 0.475);
   }
   
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE RANDOM TREES: ************************************** //
/*================================================================================================================*/
	
	int randomTree1ID=rmCreateObjectDef("random tree 1");
	rmAddObjectDefItem(randomTree1ID, "TreeNewEngland", rmRandInt(10,15), 12.0);
	rmSetObjectDefMinDistance(randomTree1ID, 0.0);
	rmSetObjectDefMaxDistance(randomTree1ID, 0.0);
	rmAddObjectDefConstraint(randomTree1ID, avoidTrees);
		
	rmPlaceObjectDefAtLoc(randomTree1ID, 0, 0.25, 0.35);
	rmPlaceObjectDefAtLoc(randomTree1ID, 0, 0.35, 0.25);
		
	rmPlaceObjectDefAtLoc(randomTree1ID, 0, 0.65, 0.75);
	rmPlaceObjectDefAtLoc(randomTree1ID, 0, 0.75, 0.65);  

/*----------------------------------------------------------------------------------------------------------------*/

    int randomTree2ID=rmCreateObjectDef("random tree 2");
	rmAddObjectDefItem(randomTree2ID, "TreeNewEngland", rmRandInt(10,15), 12.0);
	rmSetObjectDefMinDistance(randomTree2ID, 0.0);
	rmSetObjectDefMaxDistance(randomTree2ID, 0.0);
	rmAddObjectDefConstraint(randomTree2ID, avoidTrees);
		
	rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.15, 0.35);
	rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.35, 0.15);
		
	rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.65, 0.85);
	rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.85, 0.65);       
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/

        int forestTreeID = 0;
        int numTries=8*cNumberNonGaiaPlayers;
        int failCount=0;
	    
		for (i=0; <numTries)
    {   
        int forest=rmCreateArea("The Forest 1"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        rmSetAreaForestType(forest, "new england forest");
		rmSetAreaForestDensity(forest, 0.85);
        rmSetAreaForestClumpiness(forest, 0.10);
        rmSetAreaForestUnderbrush(forest, 0.6);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 2);
        rmSetAreaMinBlobDistance(forest, 1);
        rmSetAreaMaxBlobDistance(forest, 2);
        rmSetAreaCoherence(forest, 0.25);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
        rmAddAreaConstraint(forest, avoidCloseCliffs);
        rmAddAreaConstraint(forest, avoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest, avoidCloseSocket);
		rmAddAreaConstraint(forest, Northward);
		 
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  
	
/*----------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries)
    {   
        int forest2=rmCreateArea("The Forest 2"+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        rmSetAreaForestType(forest2, "new england forest");
		rmSetAreaForestDensity(forest2, 0.85);
        rmSetAreaForestClumpiness(forest2, 0.10);
        rmSetAreaForestUnderbrush(forest2, 0.6);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 2);
        rmSetAreaMinBlobDistance(forest2, 1);
        rmSetAreaMaxBlobDistance(forest2, 2);
        rmSetAreaCoherence(forest2, 0.25);
        rmSetAreaSmoothDistance(forest2, 10);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, avoidCloseSocket);
        rmAddAreaConstraint(forest2, avoidCloseCliffs);
        rmAddAreaConstraint(forest2, avoidImpassableLand); 
        rmAddAreaConstraint(forest2, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest2, Southward);
		 
        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  
 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FISH AND THE WHALES: ********************************* //
/*================================================================================================================*/

        // DEFINE THE FISH AND WHALES CONSTRAINTS:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 10.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        //int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 25.0);
        //int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	
/*----------------------------------------------------------------------------------------------------------------*/		

        // FISHBASS -- FOOD:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*10);
		
/*----------------------------------------------------------------------------------------------------------------*/		

/*
	    // FAST COIN -- WHALES:
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);
*/

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*================================================================================================================*/  
