/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAPS: *********************************** //
/*================================================================================================================*/
// THE AMAZONIA WAR:
// CREATED BY DANY:
// MARCH 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ***************************************** CHOOSE THE NATIVE TRIBES: ****************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
		int subCiv2=-1;
		int subCiv3=-1;
		int subCiv4=-1;
		int subCiv5=-1;
		
		if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");

		subCiv1=rmGetCivID("Aztecs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Aztecs"); 
		
		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");
		
		subCiv3=rmGetCivID("Aztecs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Aztecs");
		
		subCiv4=rmGetCivID("Aztecs");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Aztecs");
		
		subCiv5=rmGetCivID("Aztecs");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Aztecs");
   }		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
        int playerTiles = 25000;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/
        // SET THE WIND MAGNITUDE:
	    rmSetWindMagnitude(2);

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(3.0);

        // SET THE MAP ELEVATION PARAMETERS:
		//	rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation);
	    // rmSetMapElevationParameters(cElevTurbulence, 0.04, 4, 0.4, 6.0);
		   //rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0); // FROM GREAT PLAINS:
		   rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0); // from saguenay:
		        
        // PICKS DEFAULT WATER:
        // rmSetSeaType("Amazon River");
	       rmSetSeaType("Amazon River Basin");
 	
	    // SET THE BASE TERRAIN MIX:
	    rmSetBaseTerrainMix("amazon grass");
		
		// SET THE MAP INITIALIZATION:
        // rmTerrainInitialize("water"); // removed by me:
		   rmTerrainInitialize("amazon\ground2_ama",5); // it has becomed a terrain map instead of a water map:
	
	    // SET THE MAP TYPE:
	    rmSetMapType("amazonia");
	    rmSetMapType("tropical");
	    rmSetMapType("water");
		
		// SET THE LIGHTING:
		rmSetLightingSet("amazon");
			
	    // SET THE WORLD CIRCLE CONSTRAINT:
	    rmSetWorldCircleConstraint(true);
        
		// CHOOSE THE MERCS:
		chooseMercs();

	    // MAKE IT RAIN:
        rmSetGlobalRain( 0.7 );
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int classPlayer=rmDefineClass("player");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
		rmDefineClass("SocketClass");
		rmDefineClass("nuggets");
		int canyon=rmDefineClass("canyon");
		int classMine=rmDefineClass("allMines"); 
			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/   
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // CREATE AN EDGE OF MAP CONSTRAINT:
	    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.45), rmDegreesToRadians(0), rmDegreesToRadians(360));

		// PLAYER AREA CONSTRAINT:
	    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 25.0);
		int avoidTC=rmCreateTypeDistanceConstraint("stay away from TC", "TownCenter", 24.0);    //Originally 20.0 -- This adjustment, as well as changing the rmSetObjectDefMaxDistance to 12.0, has corrected the problem of nomad sometimes not placing CW for each player.
	    int avoidTP=rmCreateTypeDistanceConstraint("stay away from Trading Post Sockets", "SocketTradeRoute", 14.0);  // JSB 1-11-05 - Just added, to try to prevent things from stomping on TPs.
	    int avoidCW=rmCreateTypeDistanceConstraint("stay away from CW", "CoveredWagon", 24.0);
				
		// CARDINAL DIRECTIONS
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.55, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.45, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.45, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.55, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
		
		// CANYONS AVOIDANCE:
		int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 10.0);
	    int avoidCloseCanyons=rmCreateClassDistanceConstraint("forest avoid canyons", rmClassID("canyon"), 4.0);
	    int veryShortAvoidCanyons=rmCreateClassDistanceConstraint("very short avoid canyons", rmClassID("canyon"), 4.0);
			
		// AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 5.0);
		int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("forest avoid impassable land", "Land", false, 2.0);
	    int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 14.0);  //This one is used in one place: for helping place FFA TC's better.

        // FOREST AVOIDANCE:
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 2.0);
		int avoidGoldForest=rmCreateTypeDistanceConstraint("forest gold", "minegold", 2.0);
		int avoidNuggetForest=rmCreateTypeDistanceConstraint("forest nugget", "Nugget", 2.0);
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 12.0);
		
		// TOWNCENTER AVOIDANCE:
		int avoidTownCenter=rmCreateTypeDistanceConstraint("forest avoid Town Center", "townCenter", 15.0);
        int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 40.0);
        		
		// UNIT AVOIDANCE:
        int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 5.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("forest avoids natives", rmClassID("natives"), 2.0);
        		
		// GOLD MINES AVOIDANCE:
		int avoidMine = rmCreateClassDistanceConstraint("stuff avoid mines", rmClassID("allMines"), 5.0);
		//int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 5.0);
		//int avoidCloseGold=rmCreateTypeDistanceConstraint("forest avoid gold", "minegold", 2.0); 
		
		// TREES AVOIDANCE:
		int avoidTree=rmCreateTypeDistanceConstraint("stuff avoid tree", "treeCaribbean", 5.0);
		int avoidCloseTree=rmCreateTypeDistanceConstraint("lake avoid tree", "treeCaribbean", 2.0);
		int avoidFarTree=rmCreateTypeDistanceConstraint("forest avoid tree", "treeCaribbean", 15.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoid deer", "deer", 5.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("forest avoid deer", "deer", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 5.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("forest avoid fruits", "berrybush", 2.0);
		
		// NUGGETS AVOIDANCE:
		int avoidNugget=rmCreateClassDistanceConstraint("stuff vs. nugget", rmClassID("nuggets"), 5.0);
		int avoidCloseNugget=rmCreateClassDistanceConstraint("close vs. nugget", rmClassID("nuggets"), 2.0);
				
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoid sheep", "sheep", 5.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("forest avoid sheep", "sheep", 2.0);
		
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("stuff avoid important item", rmClassID("importantItem"), 5.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("secrets avoid each other by a lot", rmClassID("importantItem"), 2.0);
        
						
		// AVOID DECORATIONS:
		int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);
		
		// VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 4.0);
      
	    // SOCKET AVOIDANCE:
	    int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("SocketClass"), 4.0);
		
	   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************************* DEFINE THE OBJECTS: ********************************************** //
// ************************* THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ***************************************** DONE DEFINING THE OBJECTS: ***************************************** //
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** //
/*================================================================================================================*/
         //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(1,0.70,0.70);

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  rmPlacePlayer(2,0.30,0.30); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
        float playerFraction = rmAreaTilesToFraction(100);
        
		for(i = 0; < cNumberNonGaiaPlayers)
   {
        // CREATE THE AREA:
        int id = rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); // removed by me for now:
        //rmAddAreaConstraint(id, playerEdgeConstraint); // removed by me for now:
	   
	    // SET AREA TERRAIN TYPE:
		// rmSetAreaTerrainType(id, "caribbean\ground1_crb");
		   rmSetAreaTerrainType(id, "amazon\ground2_ama");
	    
		// SET AREA MIX:
		//rmSetAreaMix(id, "caribbean grass"); // added by me as a possibility:
		  rmSetAreaMix(id, "amazon grass");
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ********************************** CLEAR OUT CONSTRAINTS FOR GOOD MEASURE: *********************************** //
/*================================================================================================================*/
        rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/	
// ********************************** DEFINE AND PLACE THE 2 TRADE ROUTES: ************************************** //
/*================================================================================================================*/ 
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.98);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.98, 0.6);
	  
      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.10);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.90);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 2:
	  int tradeRoute2ID = rmCreateTradeRoute();
      socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
      rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.02, 0.4);
	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.4, 0.02);
	  
      placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 2:
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.10);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.90);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NATIVES: **************************************** //
/*================================================================================================================*/  
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("aztecs"))
	{  
		int aztecs1VillageID = -1;
		aztecs1VillageID = rmCreateGrouping("aztecs village 1", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs1VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs1VillageID, 0.0);
		rmAddGroupingToClass(aztecs1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs1VillageID, 0, 0.18, 0.81);
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	    if (subCiv1 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs village 2", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.81, 0.18);
	}
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecs3VillageID = -1;
		aztecs3VillageID = rmCreateGrouping("aztecs village 3", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs3VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs3VillageID, 0.0);
		rmAddGroupingToClass(aztecs3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs3VillageID, avoidNatives);
		
		if(rmRandFloat(0.0, 1.0)<0.5)
		rmPlaceGroupingAtLoc(aztecs3VillageID, 0, 0.5, 0.9);
		else
		rmPlaceGroupingAtLoc(aztecs3VillageID, 0, 0.5, 0.9);
	}
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv3 == rmGetCivID("aztecs"))
	{  
		int aztecs4VillageID = -1;
		aztecs4VillageID = rmCreateGrouping("aztecs village 4", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs4VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs4VillageID, 0.0);
		rmAddGroupingToClass(aztecs4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs4VillageID, avoidNatives);
		
		if(rmRandFloat(0.0, 1.0)<0.5)
		rmPlaceGroupingAtLoc(aztecs4VillageID, 0, 0.9, 0.5);
		else
		rmPlaceGroupingAtLoc(aztecs4VillageID, 0, 0.9, 0.5);
	}	
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv4 == rmGetCivID("aztecs"))
	{  
		int aztecs5VillageID = -1;
		aztecs5VillageID = rmCreateGrouping("aztecs village 5", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs5VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs5VillageID, 0.0);
		rmAddGroupingToClass(aztecs5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs5VillageID, avoidNatives);
		
		if(rmRandFloat(0.0, 1.0)<0.5)
		rmPlaceGroupingAtLoc(aztecs5VillageID, 0, 0.1, 0.5);
		else
		rmPlaceGroupingAtLoc(aztecs5VillageID, 0, 0.1, 0.5);
	}
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv5 == rmGetCivID("aztecs"))
	{  
		int aztecs6VillageID = -1;
		aztecs6VillageID = rmCreateGrouping("aztecs village 6", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs6VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs6VillageID, 0.0);
		rmAddGroupingToClass(aztecs6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs6VillageID, avoidNatives);
		
		if(rmRandFloat(0.0, 1.0)<0.5)
		rmPlaceGroupingAtLoc(aztecs6VillageID, 0, 0.5, 0.1);
		else
		rmPlaceGroupingAtLoc(aztecs6VillageID, 0, 0.5, 0.1);
	}		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE MIDDLE REGION: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// ************************************ DEFINE AND PLACE THE 3 SMALL CLIFFS: ************************************ //
/*================================================================================================================*/
        int failCount=0;
	    int numTries=cNumberNonGaiaPlayers*0.5;
		for(i=0; <numTries)
	{
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa"+i);
		
		// rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  // used to be 300
		   rmSetAreaSize(smallMesaID, 0.025, 0.025);
		
		rmSetAreaWarnFailure(smallMesaID, false);
		// rmSetAreaCliffType(smallMesaID, "Sonora");
		   rmSetAreaCliffType(smallMesaID, "Amazon");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		// rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesaID, 2, 0.4, 0.1, 1.0, 0); // FROM TEXAS:
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(6,8), 1.0, 1.0);
		//rmAddAreaConstraint(smallMesaID, shortAvoidCanyons);
		
		// IF YOU WANT A PERFECT ROUND CLIFF REMOVE THE BLOBS:
		//rmSetAreaMinBlobs(smallMesaID, 3);
		//rmSetAreaMaxBlobs(smallMesaID, 5);
		//rmSetAreaMinBlobDistance(smallMesaID, 3.0);
		//rmSetAreaMaxBlobDistance(smallMesaID, 5.0);
		
		// rmSetAreaCoherence(smallMesaID, 0.3);
		   rmSetAreaCoherence(smallMesaID, 1.0); // closer to number 1.0 equal ronder cliff:
		
		//rmAddAreaConstraint(smallMesaID, mediumPlayerConstraint); 
		//rmAddAreaConstraint(smallMesaID, avoidNatives); 
		//rmAddAreaConstraint(smallMesaID, avoidTradeRouteSockets);
		//rmAddAreaConstraint(smallMesaID, avoidTradeRoute);
		//rmAddAreaConstraint(smallMesaID, shortAvoidSilver);
		rmSetAreaLocation(smallMesaID,0.50, 0.50);
		if(rmBuildArea(smallMesaID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	}
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2"+i);
		
		// rmSetAreaSize(smallMesa2ID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  // used to be 300
		   rmSetAreaSize(smallMesa2ID, 0.025, 0.025);
		
		rmSetAreaWarnFailure(smallMesa2ID, false);
		// rmSetAreaCliffType(smallMesa2ID, "Sonora");
		   rmSetAreaCliffType(smallMesa2ID, "Amazon");
		rmAddAreaToClass(smallMesa2ID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		// rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesa2ID, 2, 0.4, 0.1, 1.0, 0); // FROM TEXAS:
		rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6,8), 1.0, 1.0);
		//rmAddAreaConstraint(smallMesa2ID, shortAvoidCanyons);
		
		// IF YOU WANT A PERFECT ROUND CLIFF REMOVE THE BLOBS:
		//rmSetAreaMinBlobs(smallMesa2ID, 3);
		//rmSetAreaMaxBlobs(smallMesa2ID, 5);
		//rmSetAreaMinBlobDistance(smallMesa2ID, 3.0);
		//rmSetAreaMaxBlobDistance(smallMesa2ID, 5.0);
		
		// rmSetAreaCoherence(smallMesa2ID, 0.3);
		   rmSetAreaCoherence(smallMesa2ID, 1.0); // closer to number 1.0 equal ronder cliff:
		
		//rmAddAreaConstraint(smallMesa2ID, mediumPlayerConstraint); 
		//rmAddAreaConstraint(smallMesa2ID, avoidNatives); 
		//rmAddAreaConstraint(smallMesa2ID, avoidTradeRouteSockets);
		//rmAddAreaConstraint(smallMesa2ID, avoidTradeRoute);
		//rmAddAreaConstraint(smallMesa2ID, shortAvoidSilver);
		rmSetAreaLocation(smallMesa2ID,0.30, 0.70);
		if(rmBuildArea(smallMesa2ID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	}
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		int smallCliff3Height=rmRandInt(0,10);
		int smallMesa3ID=rmCreateArea("small mesa 3"+i);
		
		// rmSetAreaSize(smallMesa3ID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  // used to be 300
		   rmSetAreaSize(smallMesa3ID, 0.025, 0.025);
		
		rmSetAreaWarnFailure(smallMesa3ID, false);
		// rmSetAreaCliffType(smallMesa3ID, "Sonora");
		   rmSetAreaCliffType(smallMesa3ID, "Amazon");
		rmAddAreaToClass(smallMesa3ID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		// rmSetAreaCliffEdge(smallMesa3ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesa3ID, 2, 0.4, 0.1, 1.0, 0); // FROM TEXAS:
		rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(6,8), 1.0, 1.0);
		//rmAddAreaConstraint(smallMesa3ID, shortAvoidCanyons);
		
		// IF YOU WANT A PERFECT ROUND CLIFF REMOVE THE BLOBS:
		//rmSetAreaMinBlobs(smallMesa3ID, 3);
		//rmSetAreaMaxBlobs(smallMesa3ID, 5);
		//rmSetAreaMinBlobDistance(smallMesa3ID, 3.0);
		//rmSetAreaMaxBlobDistance(smallMesa3ID, 5.0);
		
		// rmSetAreaCoherence(smallMesa3ID, 0.3);
		   rmSetAreaCoherence(smallMesa3ID, 1.0); // closer to number 1.0 equal ronder cliff:
		
		//rmAddAreaConstraint(smallMesa3ID, mediumPlayerConstraint); 
		//rmAddAreaConstraint(smallMesa3ID, avoidNatives); 
		//rmAddAreaConstraint(smallMesa3ID, avoidTradeRouteSockets);
		//rmAddAreaConstraint(smallMesa3ID, avoidTradeRoute);
		//rmAddAreaConstraint(smallMesa3ID, shortAvoidSilver);
		rmSetAreaLocation(smallMesa3ID,0.70, 0.30);
		if(rmBuildArea(smallMesa3ID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	}	
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		int smallCliff4Height=rmRandInt(0,10);
		int smallMesa4ID=rmCreateArea("small mesa 4"+i);
		
		// rmSetAreaSize(smallMesa4ID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  // used to be 300
		   rmSetAreaSize(smallMesa4ID, 0.008, 0.008);
		
		rmSetAreaWarnFailure(smallMesa4ID, false);
		// rmSetAreaCliffType(smallMesa4ID, "Sonora");
		   rmSetAreaCliffType(smallMesa4ID, "Amazon");
		rmAddAreaToClass(smallMesa4ID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(smallMesa4ID, 1, 1.0, 0.1, 1.0, 0);
		   //rmSetAreaCliffEdge(smallMesa4ID, 2, 0.4, 0.1, 1.0, 0); // FROM TEXAS:
		rmSetAreaCliffHeight(smallMesa4ID, rmRandInt(6,8), 1.0, 1.0);
		//rmAddAreaConstraint(smallMesa4ID, shortAvoidCanyons);
		
		// IF YOU WANT A PERFECT ROUND CLIFF REMOVE THE BLOBS:
		//rmSetAreaMinBlobs(smallMesa4ID, 3);
		//rmSetAreaMaxBlobs(smallMesa4ID, 5);
		//rmSetAreaMinBlobDistance(smallMesa4ID, 3.0);
		//rmSetAreaMaxBlobDistance(smallMesa4ID, 5.0);
		
		// rmSetAreaCoherence(smallMesa4ID, 0.3);
		   rmSetAreaCoherence(smallMesa4ID, 1.0); // closer to number 1.0 equal ronder cliff:
		
		//rmAddAreaConstraint(smallMesa4ID, mediumPlayerConstraint); 
		//rmAddAreaConstraint(smallMesa4ID, avoidNatives); 
		//rmAddAreaConstraint(smallMesa4ID, avoidTradeRouteSockets);
		//rmAddAreaConstraint(smallMesa4ID, avoidTradeRoute);
		//rmAddAreaConstraint(smallMesa4ID, shortAvoidSilver);
		rmSetAreaLocation(smallMesa4ID,0.50, 0.70);
		if(rmBuildArea(smallMesa4ID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	}	
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		int smallCliff5Height=rmRandInt(0,10);
		int smallMesa5ID=rmCreateArea("small mesa 5"+i);
		
		// rmSetAreaSize(smallMesa5ID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  // used to be 300
		   rmSetAreaSize(smallMesa5ID, 0.008, 0.008);
		
		rmSetAreaWarnFailure(smallMesa5ID, false);
		// rmSetAreaCliffType(smallMesa5ID, "Sonora");
		   rmSetAreaCliffType(smallMesa5ID, "Amazon");
		rmAddAreaToClass(smallMesa5ID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(smallMesa5ID, 1, 1.0, 0.1, 1.0, 0);
		   //rmSetAreaCliffEdge(smallMesa5ID, 2, 0.4, 0.1, 1.0, 0); // FROM TEXAS:
		rmSetAreaCliffHeight(smallMesa5ID, rmRandInt(6,8), 1.0, 1.0);
		//rmAddAreaConstraint(smallMesa5ID, shortAvoidCanyons);
		
		// IF YOU WANT A PERFECT ROUND CLIFF REMOVE THE BLOBS:
		//rmSetAreaMinBlobs(smallMesa5ID, 3);
		//rmSetAreaMaxBlobs(smallMesa5ID, 5);
		//rmSetAreaMinBlobDistance(smallMesa5ID, 3.0);
		//rmSetAreaMaxBlobDistance(smallMesa5ID, 5.0);
		
		// rmSetAreaCoherence(smallMesa5ID, 0.3);
		   rmSetAreaCoherence(smallMesa5ID, 1.0); // closer to number 1.0 equal ronder cliff:
		
		//rmAddAreaConstraint(smallMesa5ID, mediumPlayerConstraint); 
		//rmAddAreaConstraint(smallMesa5ID, avoidNatives); 
		//rmAddAreaConstraint(smallMesa5ID, avoidTradeRouteSockets);
		//rmAddAreaConstraint(smallMesa5ID, avoidTradeRoute);
		//rmAddAreaConstraint(smallMesa5ID, shortAvoidSilver);
		rmSetAreaLocation(smallMesa5ID,0.70, 0.50);
		if(rmBuildArea(smallMesa5ID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	} 
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		int smallCliff6Height=rmRandInt(0,10);
		int smallMesa6ID=rmCreateArea("small mesa 6"+i);
		
		// rmSetAreaSize(smallMesa6ID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  // used to be 300
		   rmSetAreaSize(smallMesa6ID, 0.008, 0.008);
		
		rmSetAreaWarnFailure(smallMesa6ID, false);
		// rmSetAreaCliffType(smallMesa6ID, "Sonora");
		   rmSetAreaCliffType(smallMesa6ID, "Amazon");
		rmAddAreaToClass(smallMesa6ID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(smallMesa6ID, 1, 1.0, 0.1, 1.0, 0);
		   //rmSetAreaCliffEdge(smallMesa6ID, 2, 0.4, 0.1, 1.0, 0); // FROM TEXAS:
		rmSetAreaCliffHeight(smallMesa6ID, rmRandInt(6,8), 1.0, 1.0);
		//rmAddAreaConstraint(smallMesa6ID, shortAvoidCanyons);
		
		// IF YOU WANT A PERFECT ROUND CLIFF REMOVE THE BLOBS:
		//rmSetAreaMinBlobs(smallMesa6ID, 3);
		//rmSetAreaMaxBlobs(smallMesa6ID, 5);
		//rmSetAreaMinBlobDistance(smallMesa6ID, 3.0);
		//rmSetAreaMaxBlobDistance(smallMesa6ID, 5.0);
		
		// rmSetAreaCoherence(smallMesa6ID, 0.3);
		   rmSetAreaCoherence(smallMesa6ID, 1.0); // closer to number 1.0 equal ronder cliff:
		
		//rmAddAreaConstraint(smallMesa6ID, mediumPlayerConstraint); 
		//rmAddAreaConstraint(smallMesa6ID, avoidNatives); 
		//rmAddAreaConstraint(smallMesa6ID, avoidTradeRouteSockets);
		//rmAddAreaConstraint(smallMesa6ID, avoidTradeRoute);
		//rmAddAreaConstraint(smallMesa6ID, shortAvoidSilver);
		rmSetAreaLocation(smallMesa6ID,0.30, 0.50);
		if(rmBuildArea(smallMesa6ID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	}  
/*----------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numTries)
	{
		int smallCliff7Height=rmRandInt(0,10);
		int smallMesa7ID=rmCreateArea("small mesa 7"+i);
		
		// rmSetAreaSize(smallMesa7ID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  // used to be 300
		   rmSetAreaSize(smallMesa7ID, 0.008, 0.008);
		
		rmSetAreaWarnFailure(smallMesa7ID, false);
		// rmSetAreaCliffType(smallMesa7ID, "Sonora");
		   rmSetAreaCliffType(smallMesa7ID, "Amazon");
		rmAddAreaToClass(smallMesa7ID, rmClassID("canyon"));	// Attempt to keep cliffs away from each other.
		
		rmSetAreaCliffEdge(smallMesa7ID, 1, 1.0, 0.1, 1.0, 0);
		   //rmSetAreaCliffEdge(smallMesa7ID, 2, 0.4, 0.1, 1.0, 0); // FROM TEXAS:
		
		rmSetAreaCliffHeight(smallMesa7ID, rmRandInt(6,8), 1.0, 1.0);
		//rmAddAreaConstraint(smallMesa7ID, shortAvoidCanyons);
		
		// IF YOU WANT A PERFECT ROUND CLIFF REMOVE THE BLOBS:
		//rmSetAreaMinBlobs(smallMesa7ID, 3);
		//rmSetAreaMaxBlobs(smallMesa7ID, 5);
		//rmSetAreaMinBlobDistance(smallMesa7ID, 3.0);
		//rmSetAreaMaxBlobDistance(smallMesa7ID, 5.0);
		
		// rmSetAreaCoherence(smallMesa7ID, 0.3);
		   rmSetAreaCoherence(smallMesa7ID, 1.0); // closer to number 1.0 equal ronder cliff:
		
		//rmAddAreaConstraint(smallMesa7ID, mediumPlayerConstraint); 
		//rmAddAreaConstraint(smallMesa7ID, avoidNatives); 
		//rmAddAreaConstraint(smallMesa7ID, avoidTradeRouteSockets);
		//rmAddAreaConstraint(smallMesa7ID, avoidTradeRoute);
		//rmAddAreaConstraint(smallMesa7ID, shortAvoidSilver);
		rmSetAreaLocation(smallMesa7ID,0.50, 0.30);
		if(rmBuildArea(smallMesa7ID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	} 	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************** DEFINE THE PLAYER STARTING STUFF ************************************** //
// ********************************** PLACE PLAYER TCS AND STARTING GOLD MINES: ********************************* //
/*================================================================================================================*/
        int TCID = rmCreateObjectDef("player TC");
	    if ( rmGetNomadStart())
		rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	    else
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);

	    // PREPARE TO PLACE TCS:
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    // rmSetObjectDefMaxDistance(TCID, 12.0);  // Originally 10.0 -- JSB -- Allows TC placement spot to float a bit along the lines I tell them to place. 
	       rmSetObjectDefMaxDistance(TCID, 0.0); 
		rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	    rmAddObjectDefConstraint(TCID, avoidTC);
	    rmAddObjectDefConstraint(TCID, avoidCW);
    	
	    // PREPARE TO PLACE EXPLORERS, EXPLORER'S DOG, EXPLORER'S TAUN TAUN, ETC:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 9.0);
	    rmSetObjectDefMaxDistance(startingUnits, 18.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);

	    // PREPARE TO PLACE PLAYER STARTING MINES: 
	    int playerGoldID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerGoldID, "minegold", 1, 0);
		rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
	    rmSetObjectDefMinDistance(playerGoldID, 12.0);
	    rmSetObjectDefMaxDistance(playerGoldID, 20.0);
	    rmAddObjectDefConstraint(playerGoldID, avoidAll);
        rmAddObjectDefConstraint(playerGoldID, avoidImpassableLand);

		// PREPARE TO PLACE PLAYER STARTING CRATES (MOSTLY FOOD)
	    int playerCrateID=rmCreateObjectDef("starting crates");
	    rmAddObjectDefItem(playerCrateID, "crateOfFood", rmRandInt(3,4), 4.0);
	    rmAddObjectDefItem(playerCrateID, "crateOfWood", 1, 6.0);
	    rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 7.0);
	    rmSetObjectDefMinDistance(playerCrateID, 6);
	    rmSetObjectDefMaxDistance(playerCrateID, 10);
	    rmAddObjectDefConstraint(playerCrateID, avoidAll);
	    rmAddObjectDefConstraint(playerCrateID, avoidCloseImpassableLand);

	    // PREPARE TO PLACE PLAYER STARTING BERRIES:
	    int playerBerriesID=rmCreateObjectDef("player berries");
	    rmAddObjectDefItem(playerBerriesID, "berrybush", rmRandInt(4,6), 4.0);	//(X,X) - number of objects.  The last # is the range of distance around the center point that the objects will place.  Low means tight, higher means more widely scattered.
        rmSetObjectDefMinDistance(playerBerriesID, 21);
        rmSetObjectDefMaxDistance(playerBerriesID, 26);		
	    rmAddObjectDefConstraint(playerBerriesID, avoidAll);
        rmAddObjectDefConstraint(playerBerriesID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(playerBerriesID, true);

	    // PREPARE TO PLACE PLLAYER STARTING TURKEYS:
	    int playerTurkeyID=rmCreateObjectDef("player turkeys");
        rmAddObjectDefItem(playerTurkeyID, "turkey", rmRandInt(6,7), 4.0);	//(X,X) - number of objects.  The last # is the range of distance around the center point that the objects will place.  Low means tight, higher means more widely scattered.
        rmSetObjectDefMinDistance(playerTurkeyID, 14);
	    rmSetObjectDefMaxDistance(playerTurkeyID, 19);	
	    rmAddObjectDefConstraint(playerTurkeyID, avoidAll);
        rmAddObjectDefConstraint(playerTurkeyID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(playerTurkeyID, true);

	    // PREPARE TO PLACE PLAYER STARTING TREES:
	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "treeamazon", 1, 0.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);    //This was just added to try to keep these trees from stomping on CW's.
	    rmSetObjectDefMinDistance(StartAreaTreeID, 13.0);	//changed from 12.0 
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 20.0);	//Changed from 19.0

	    // DEFINE WATER SPAWN POINT:
		//int waterSpawnPointID = 0;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************* PLACE HOME CITY WATER SPAWN FLAG: ************************************** //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
   {
	    // PLACE TC AND STARTING UNITS:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));				
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));   
		rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc))); 
		rmPlaceObjectDefAtLoc(playerTurkeyID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));  										
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		// PLACE PLAYER STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

/*		// PLACE WATER SPAWN POINTS FOR THE PLAYERS:
		waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
		rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 10.0);  // ...Flag", 1, 1.0); - the first number is the number of flags.  The next number is the float distance.
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		rmAddClosestPointConstraint(circleConstraint);
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
*/		
		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************** DEFINE AND PLACE THE STUFFS ON TOP OF THE CENTER MOUNTAIN: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int gold1ID= rmCreateObjectDef("The Gold Mine 1"); 
	    rmAddObjectDefItem(gold1ID, "minegold", 1.0, 0.0);
		rmAddObjectDefToClass(gold1ID, rmClassID("allMines"));
		rmAddObjectDefToClass(gold1ID, rmClassID("importantItem"));
		rmSetObjectDefMinDistance(gold1ID, 0.0);
	    rmSetObjectDefMaxDistance(gold1ID, 0.0);
  	    rmAddObjectDefConstraint(gold1ID, avoidMine);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.5, 0.5);
		//rmPlaceObjectDefAtLoc(gold1ID, 0, 0.7, 0.3);
		//rmPlaceObjectDefAtLoc(gold1ID, 0, 0.3, 0.7);
		
		int tree1ID= rmCreateObjectDef("The Trees 1"); 
	    rmAddObjectDefItem(tree1ID, "treeamazon", 1.0, 0.0);
		rmSetObjectDefMinDistance(tree1ID, 0.0);
	    rmSetObjectDefMaxDistance(tree1ID, 0.0);
  	    rmAddObjectDefConstraint(tree1ID, avoidCloseTree);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.5, 0.54);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.5, 0.53);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.51, 0.53);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.49, 0.53);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.5, 0.52);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.5, 0.48);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.49, 0.47);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.5, 0.47);	
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.51, 0.47);	
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.5, 0.46);

        int deer1ID= rmCreateObjectDef("The Deers 1"); 
	    rmAddObjectDefItem(deer1ID, "deer", rmRandInt(5,7), 4.0);
		rmSetObjectDefMinDistance(deer1ID, 0.0);
	    rmSetObjectDefMaxDistance(deer1ID, 0.0);
  	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.46, 0.50);
		
		int berries1ID= rmCreateObjectDef("The Berries 1"); 
	    rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
	    rmSetObjectDefMaxDistance(berries1ID, 0.0);
  	    rmAddObjectDefConstraint(berries1ID, avoidFruits);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.54, 0.50);
		
		int nugget1ID= rmCreateObjectDef("The Nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget1ID, rmClassID("nuggets"));
		rmAddObjectDefToClass(nugget1ID, rmClassID("importantItem"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
  	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.46, 0.47);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.54, 0.47);

/*================================================================================================================*/
// *************************** DEFINE AND PLACE THE STUFFS ON TOP OF THE LEFT MOUNTAIN: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int gold2ID= rmCreateObjectDef("The Gold Mine 2"); 
	    rmAddObjectDefItem(gold2ID, "minegold", 1.0, 0.0);
		rmAddObjectDefToClass(gold2ID, rmClassID("allMines"));
		rmAddObjectDefToClass(gold2ID, rmClassID("importantItem"));
		rmSetObjectDefMinDistance(gold2ID, 0.0);
	    rmSetObjectDefMaxDistance(gold2ID, 0.0);
  	    rmAddObjectDefConstraint(gold2ID, avoidMine);
		//rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.5);
		//rmPlaceObjectDefAtLoc(gold2ID, 0, 0.7, 0.3);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.3, 0.7);
		
		int tree2ID= rmCreateObjectDef("The Trees 2"); 
	    rmAddObjectDefItem(tree2ID, "treeamazon", 1.0, 0.0);
		rmSetObjectDefMinDistance(tree2ID, 0.0);
	    rmSetObjectDefMaxDistance(tree2ID, 0.0);
  	    rmAddObjectDefConstraint(tree2ID, avoidCloseTree);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.3, 0.72);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.3, 0.73);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.29, 0.73);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.31, 0.73);
        rmPlaceObjectDefAtLoc(tree2ID, 0, 0.3, 0.74);
        rmPlaceObjectDefAtLoc(tree2ID, 0, 0.3, 0.68);
        rmPlaceObjectDefAtLoc(tree2ID, 0, 0.3, 0.67);
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.29, 0.67);	
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.31, 0.67);	
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.3, 0.66);

        int deer2ID= rmCreateObjectDef("The Deers 2"); 
	    rmAddObjectDefItem(deer2ID, "deer", rmRandInt(5,7), 4.0);
		rmSetObjectDefMinDistance(deer2ID, 0.0);
	    rmSetObjectDefMaxDistance(deer2ID, 0.0);
  	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.26, 0.70);
		
		int berries2ID= rmCreateObjectDef("The Berries 2"); 
	    rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
	    rmSetObjectDefMaxDistance(berries2ID, 0.0);
  	    rmAddObjectDefConstraint(berries2ID, avoidFruits);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.34, 0.70);
		
		int nugget2ID= rmCreateObjectDef("The Nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget2ID, rmClassID("nuggets"));
		rmAddObjectDefToClass(nugget2ID, rmClassID("importantItem"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
  	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.26, 0.67);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.34, 0.67);
/*================================================================================================================*/
// ************************** DEFINE AND PLACE THE STUFFS ON TOP OF THE RIGHT MOUNTAIN: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int gold3ID= rmCreateObjectDef("The Gold Mine 3"); 
	    rmAddObjectDefItem(gold3ID, "minegold", 1.0, 0.0);
		rmAddObjectDefToClass(gold3ID, rmClassID("allMines"));
		rmAddObjectDefToClass(gold3ID, rmClassID("importantItem"));
		rmSetObjectDefMinDistance(gold3ID, 0.0);
	    rmSetObjectDefMaxDistance(gold3ID, 0.0);
  	    rmAddObjectDefConstraint(gold3ID, avoidMine);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.5, 0.5);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.7, 0.3);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.3, 0.7);
		
		int tree3ID= rmCreateObjectDef("The Trees 3"); 
	    rmAddObjectDefItem(tree3ID, "treeamazon", 1.0, 0.0);
		rmSetObjectDefMinDistance(tree3ID, 0.0);
	    rmSetObjectDefMaxDistance(tree3ID, 0.0);
  	    rmAddObjectDefConstraint(tree3ID, avoidCloseTree);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.7, 0.32);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.7, 0.33);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.69, 0.33);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.71, 0.33);
        rmPlaceObjectDefAtLoc(tree3ID, 0, 0.7, 0.34);
        rmPlaceObjectDefAtLoc(tree3ID, 0, 0.7, 0.28);
        rmPlaceObjectDefAtLoc(tree3ID, 0, 0.7, 0.27);
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.71, 0.27);	
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.69, 0.27);	
		rmPlaceObjectDefAtLoc(tree3ID, 0, 0.7, 0.26);

        int deer3ID= rmCreateObjectDef("The Deers 3"); 
	    rmAddObjectDefItem(deer3ID, "deer", rmRandInt(5,7), 4.0);
		rmSetObjectDefMinDistance(deer3ID, 0.0);
	    rmSetObjectDefMaxDistance(deer3ID, 0.0);
  	    rmAddObjectDefConstraint(deer3ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.66, 0.30);
		
		int berries3ID= rmCreateObjectDef("The Berries 3"); 
	    rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
	    rmSetObjectDefMaxDistance(berries3ID, 0.0);
  	    rmAddObjectDefConstraint(berries3ID, avoidFruits);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.74, 0.30);

        int nugget3ID= rmCreateObjectDef("The Nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget3ID, rmClassID("nuggets"));
		rmAddObjectDefToClass(nugget3ID, rmClassID("importantItem"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
  	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.66, 0.27);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.74, 0.27);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINES 4: ************************************** //
/*================================================================================================================*/		
		int gold4ID= rmCreateObjectDef("The Gold Mine 4"); 
	    rmAddObjectDefItem(gold4ID, "minegold", 1.0, 0.0);
		rmAddObjectDefToClass(gold4ID, rmClassID("allMines"));
		rmAddObjectDefToClass(gold4ID, rmClassID("importantItem"));
		rmSetObjectDefMinDistance(gold4ID, 0.0);
	    rmSetObjectDefMaxDistance(gold4ID, 0.0);
  	    rmAddObjectDefConstraint(gold4ID, avoidMine);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.15, 0.65);
        rmPlaceObjectDefAtLoc(gold4ID, 0, 0.65, 0.15);
        rmPlaceObjectDefAtLoc(gold4ID, 0, 0.35, 0.85);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.85, 0.35);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.6, 0.6);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.4, 0.4);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.83, 0.83);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NUGGETS 4: **************************************** //
/*================================================================================================================*/
        int nugget4ID= rmCreateObjectDef("The Nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1.0, 0.0);
		rmAddObjectDefToClass(nugget4ID, rmClassID("nuggets"));
		rmAddObjectDefToClass(nugget4ID, rmClassID("importantItem"));
		rmSetNuggetDifficulty(1, 4);
		rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
  	    rmAddObjectDefConstraint(nugget4ID, avoidNugget);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.05, 0.55);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.55, 0.05);
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.15, 0.75);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.75, 0.15);	
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.25, 0.85);	
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.85, 0.25);	
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.45, 0.95);	
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.95, 0.45);
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.25, 0.55);
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.55, 0.25);
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.75, 0.45);
        rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.45, 0.75);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.085, 0.275);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.275, 0.085);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.725, 0.91);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.91, 0.735);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE DEERS 4: **************************************** //
/*================================================================================================================*/
        int deer4ID= rmCreateObjectDef("The Deers 4"); 
	    rmAddObjectDefItem(deer4ID, "deer", rmRandInt(7,9), 5.0);
		rmSetObjectDefMinDistance(deer4ID, 0.0);
	    rmSetObjectDefMaxDistance(deer4ID, 0.0);
  	    rmAddObjectDefConstraint(deer4ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer4ID, 0, 0.15, 0.55); 
        rmPlaceObjectDefAtLoc(deer4ID, 0, 0.55, 0.15); 
        rmPlaceObjectDefAtLoc(deer4ID, 0, 0.45, 0.85); 	
        rmPlaceObjectDefAtLoc(deer4ID, 0, 0.85, 0.45);
		rmPlaceObjectDefAtLoc(deer4ID, 0, 0.4, 0.6);
		rmPlaceObjectDefAtLoc(deer4ID, 0, 0.6, 0.4);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BERRIES 4: **************************************** //
/*================================================================================================================*/
        int berries4ID= rmCreateObjectDef("The Berries 4"); 
	    rmAddObjectDefItem(berries4ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries4ID, 0.0);
	    rmSetObjectDefMaxDistance(berries4ID, 0.0);
  	    rmAddObjectDefConstraint(berries4ID, avoidFruits);
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.20, 0.60);
        rmPlaceObjectDefAtLoc(berries4ID, 0, 0.60, 0.20);
        rmPlaceObjectDefAtLoc(berries4ID, 0, 0.40, 0.80);
        rmPlaceObjectDefAtLoc(berries4ID, 0, 0.80, 0.40);	
        rmPlaceObjectDefAtLoc(berries4ID, 0, 0.05, 0.45);	
        rmPlaceObjectDefAtLoc(berries4ID, 0, 0.45, 0.05);	
        rmPlaceObjectDefAtLoc(berries4ID, 0, 0.55, 0.95);	
        rmPlaceObjectDefAtLoc(berries4ID, 0, 0.95, 0.55);			
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE SHEEPS 1: **************************************** //		
/*================================================================================================================*/
        int sheep1ID= rmCreateObjectDef("The Sheeps 1"); 
	    rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(5,9), 4.0);
		rmSetObjectDefMinDistance(sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep1ID, 0.0);
  	    rmAddObjectDefConstraint(sheep1ID, avoidSheep);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.15, 0.45);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.45, 0.15);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.55, 0.85);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.85, 0.55);	
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.10, 0.70);	
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.70, 0.10);	
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.30, 0.90);	
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.90, 0.30);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE TREES: ******************************************* //
/*================================================================================================================*/
        int tree4ID= rmCreateObjectDef("The Trees 4"); 
	    rmAddObjectDefItem(tree4ID, "treeamazon", rmRandInt(5,9), 4.0);
		rmSetObjectDefMinDistance(tree4ID, 0.0);
	    rmSetObjectDefMaxDistance(tree4ID, 0.0);
  	    rmAddObjectDefConstraint(tree4ID, avoidCloseTree);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.35, 0.56);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.56, 0.35);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.45, 0.64);
		rmPlaceObjectDefAtLoc(tree4ID, 0, 0.64, 0.45);
        //rmPlaceObjectDefAtLoc(tree4ID, 0, 0.7, 0.34);
        //rmPlaceObjectDefAtLoc(tree4ID, 0, 0.7, 0.28);
        //rmPlaceObjectDefAtLoc(tree4ID, 0, 0.7, 0.27);
		//rmPlaceObjectDefAtLoc(tree4ID, 0, 0.71, 0.27);	
		//rmPlaceObjectDefAtLoc(tree4ID, 0, 0.69, 0.27);	
		//rmPlaceObjectDefAtLoc(tree4ID, 0, 0.7, 0.26);		
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //		
/*================================================================================================================*/
        // DEFINE AND PLACE FORESTS:
        //ABC NEED TO BE SCATTERED BETWEEN THE TWO RIVERBANKS
        int forestTreeID = 0;
		numTries=8*cNumberNonGaiaPlayers;
        failCount=0;
        for (i=0; <numTries)
    {   
        int forest=rmCreateArea("forest 1"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(125), rmAreaTilesToFraction(125));
        rmSetAreaForestType(forest, "amazon rain forest");
        rmSetAreaForestDensity(forest, 0.8);
        rmSetAreaForestClumpiness(forest, 0.6);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 1);
        rmSetAreaMinBlobDistance(forest, 1.0);
        rmSetAreaMaxBlobDistance(forest, 1.0);
        rmSetAreaCoherence(forest, 0.8);
        rmSetAreaSmoothDistance(forest, 10);
	    rmAddAreaToClass(forest, rmClassID("classForest"));
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidCloseImpassableLand); 
		rmAddAreaConstraint(forest, avoidCloseNatives);
        rmAddAreaConstraint(forest, avoidCloseCanyons); 		
        rmAddAreaConstraint(forest, avoidTradeRoute);
		rmAddAreaConstraint(forest, avoidSocket);
		rmAddAreaConstraint(forest, avoidTownCenter);
		rmAddAreaConstraint(forest, avoidMine);
		rmAddAreaConstraint(forest, avoidNugget);
		rmAddAreaConstraint(forest, avoidImportantItem);
		rmAddAreaConstraint(forest, Northward);
		
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==6)
        break;
      }
        else
        failCount=0; 
    } 
/*================================================================================================================*/
        for (i=0; <numTries)
    {   
        int forest2=rmCreateArea("forest 2"+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(125), rmAreaTilesToFraction(125));
        rmSetAreaForestType(forest2, "amazon rain forest");
        rmSetAreaForestDensity(forest2, 0.8);
        rmSetAreaForestClumpiness(forest2, 0.6);
        rmSetAreaForestUnderbrush(forest2, 0.0);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 1);
        rmSetAreaMinBlobDistance(forest2, 1.0);
        rmSetAreaMaxBlobDistance(forest2, 1.0);
        rmSetAreaCoherence(forest2, 0.8);
        rmSetAreaSmoothDistance(forest2, 10);
	    rmAddAreaToClass(forest2, rmClassID("classForest"));
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidCloseImpassableLand); 
		rmAddAreaConstraint(forest2, avoidCloseNatives);
        rmAddAreaConstraint(forest2, avoidCloseCanyons); 		
        rmAddAreaConstraint(forest2, avoidTradeRoute);
		rmAddAreaConstraint(forest2, avoidSocket);
		rmAddAreaConstraint(forest2, avoidTownCenter);
		rmAddAreaConstraint(forest2, avoidMine);
		rmAddAreaConstraint(forest2, avoidNugget);
		rmAddAreaConstraint(forest2, avoidImportantItem);
		rmAddAreaConstraint(forest2, Southward);
		

        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==6)
        break;
      }
        else
        failCount=0; 
    } 	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}  
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*================================================================================================================*/





















































