/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// THE ANDES WAR:
// CREATED BY DANY:
// AUGUST 2007:
// A RANDOM MAP FOR AGE OF EMPIRES III: MY 62TH RMS:
/*================================================================================================================*/
// *********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ***************************************** CHOOSE THE NATIVES TRIBES: ***************************************** //
/*================================================================================================================*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
		int subCiv3=-1;
	
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE WHICHMAP:
		// ONLY 2 VARIATIONS:
		int whichMap=rmRandInt(0,1);	
		
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(4) == true)
		
{
		if ( whichMap == 1 )
	{	
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");
		
		subCiv1=rmGetCivID("Aztecs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Aztecs");
		
		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");
		
		subCiv3=rmGetCivID("Aztecs");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Aztecs");
	}
	
        else
		
	{	
		subCiv0=rmGetCivID("Maya");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Maya");
				
		subCiv1=rmGetCivID("Maya");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Maya");
		
		subCiv2=rmGetCivID("Maya");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Maya");

		subCiv3=rmGetCivID("Maya");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Maya");
	}	
} 		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// **************************************** PICKS THE SIZE OF THE MAP: ****************************************** //
/*================================================================================================================*/

        int playerTiles = 17500;
		
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
		rmSetMapSize(530, 530);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    if ( whichMap == 1 )
		
	{	
		// SET MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	    rmSetMapElevationParameters(cElevTurbulence, 0.05, 10, 0.4, 7.0);
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
	
	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(5.0);
	
   	    // SET SEA TYPE:
		rmSetSeaType("Pampas River");
		
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	
	    // SET BASE TERRAIN MIX:
	    rmSetBaseTerrainMix("pampas_dirt");
	
	    // TERRAIN INITIALIZATION:
	    rmTerrainInitialize("pampas\ground5_pam", 6.0);
	
	    // SET LIGHTING:
		rmSetLightingSet("Pampas");
	
	    // SET MAP TYPE:
		rmSetMapType("grass");
	    rmSetMapType("land");
	    rmSetMapType("pampas");
	
	    // SET WORLD CIRCLE CONSTRAINT:
	    rmSetWorldCircleConstraint(true);
	
	    // SET WIND MAGNITUDE:
	    rmSetWindMagnitude(2.0);

	    // CHOOSE THE MERCS:
		chooseMercs();
	}	
		else
	{
        // SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.2, 3.0);
		
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
	
	    // PICKS A DEFAULT WATER HEIGHT:
		rmSetSeaLevel(1.0);
	   	
   	    // SET SEA TYPE:
		rmSetSeaType("new england coast");
				
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	
	    // SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("patagonia_grass");
	    	
	    // TERRAIN INITIALIZATION:
		rmTerrainInitialize("patagonia\ground_dirt1_pat", 4.0);
	    	
	    // SET LIGHTING:
		rmSetLightingSet("patagonia");
			
	    // SET MAP TYPE:
		rmSetMapType("patagonia");
	    rmSetMapType("water");
	    rmSetMapType("grass");
			
	    // SET WORLD CIRCLE CONSTRAINT:
	    rmSetWorldCircleConstraint(true);
	
	    // CHOOSE THE MERCS:
		chooseMercs();	
	}	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
       
	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classHill");
	    rmDefineClass("classPatch");
	    rmDefineClass("corner");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    //rmDefineClass("classNugget");
		rmDefineClass("nuggets");
	    rmDefineClass("natives");
	    rmDefineClass("classCliff");
		rmDefineClass("socketClass");
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHERS: ************************* //
/*================================================================================================================*/		
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

    // MAP EDGE CONSTRAINTS:
	int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	int longplayerEdgeConstraint=rmCreateBoxConstraint("long player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
	int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 60.0);

	// CARDINAL DIRECTIONS:
	int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	// PLAYERS CONSTRAINTS:
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
	int mediumPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players medium", classPlayer, 15.0);
	int shortPlayerConstraint=rmCreateClassDistanceConstraint("short stay away from players", classPlayer, 5.0);
	int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
	
	// FOREST AVOIDANCE:
	int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 60.0);
	
	// RESOURCE AVOIDANCE:
	int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	int shortAvoidResource=rmCreateTypeDistanceConstraint("resource avoid resource short", "resource", 5.0);
	
	// GOLD MINES AVOIDANCE:
	int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
	int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
	// COIN AVOIDANCE:
	int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "mine", 30.0);
    int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "mine", 10);
	int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoids coin", "mine", 2.0);
	
	// START RESOURCE AVOIDANCE:
	int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 10.0);
	   
	// AVOID IMPASSABLE LAND:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 3.0);
	int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
	int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close avoid impassable land", "Land", false, 2.0);
	
	
	// HILL AVOIDANCE:
	int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 10.0);
	int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
	
	// PATCH AVOIDANCE:
	int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	
	// CLIFFS AVOIDANCE:
	int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 50.0);
	int shortAvoidCliffs=rmCreateClassDistanceConstraint("short cliff vs. cliff", rmClassID("classCliff"), 5.0);
	int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 2.0);
	
	// SILVER AVOIDANCE:
	int avoidSilver=rmCreateTypeDistanceConstraint("gold avoid gold", "Mine", 50.0);
	int mediumAvoidSilver=rmCreateTypeDistanceConstraint("medium gold avoid gold", "Mine", 30.0);
	
	// TREES 1 AVOIDANCE:
	int avoidTrees1=rmCreateTypeDistanceConstraint("avoid trees1", "TreePampas", 10.0);
	int avoidCloseTrees1=rmCreateTypeDistanceConstraint("short avoid trees1", "TreePampas", 2.0);

    // TREES 2 AVOIDANCE:
	int avoidTrees2=rmCreateTypeDistanceConstraint("avoid trees2", "TreePatagoniaDirt", 10.0);
	int avoidCloseTrees2=rmCreateTypeDistanceConstraint("short avoid trees2", "TreePatagoniaDirt", 2.0);
		
	// RHEA AVOIDANCE:
	int avoidRhea=rmCreateTypeDistanceConstraint("stuff avoid rhea", "rhea", 15.0);
	int avoidCloseRhea=rmCreateTypeDistanceConstraint("close avoid rhea", "rhea", 5.0);
	
	// DEER AVOIDANCE:
	int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoid deer", "deer", 15.0);
	int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoid deer", "deer", 5.0);
	
	// COWS AVOIDANCE:
	int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
	int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
		
	// SHEEPS AVOIDANCE:
	int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
	int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 2.0);
		
	
	// NUGGET AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 10.0);
	int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);
	int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 20.0);
    	
	//// NUGGET AVOIDANCE:
	//int avoidNuggets=rmCreateClassDistanceConstraint("nugget vs. nugget", rmClassID("classNugget"), 20.0);
	//int avoidNuggetFar=rmCreateClassDistanceConstraint("nugget vs. nugget far", rmClassID("classNugget"), 70.0);
	
	// REMOVED BY ENSEMBLE:
	//int avoidTobacco=rmCreateTypeDistanceConstraint("avoid tobacco", "tobacco", 40.0);
	
	// WATER AVOIDANCE:
	int avoidWater = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 10.0);

	// SPECIFY TRUE SO CONSTRAINT STAYS OUTSIDE OF CIRCLE (I.E. INSIDE CORNERS:)
	int cornerConstraint0=rmCreateCornerConstraint("in corner 0", 0, true);
	int cornerConstraint1=rmCreateCornerConstraint("in corner 1", 1, true);
	int cornerConstraint2=rmCreateCornerConstraint("in corner 2", 2, true);
	int cornerConstraint3=rmCreateCornerConstraint("in corner 3", 3, true);
	int insideCircleConstraint=rmCreateCornerConstraint("inside circle", -1, false);
	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

	// STARTING UNITS AVOIDANCE:
	int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 40.0);
	
	// IMPORTANT ITEM AVOIDANCE:
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), rmXFractionToMeters(0.3));
	int shortAvoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other short", rmClassID("importantItem"), 10);
		
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
	int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 2.0);
	int farAvoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives alot", rmClassID("natives"), 80.0);
	
	// LLAMA AVOIDANCE:
	int avoidLlama=rmCreateTypeDistanceConstraint("llama avoids llama", "llama", 50.0);

	// DECORATION AVOIDANCE:
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 2.0);

	// TRADE ROUTE AVOIDANCE:
	int shortAvoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route short", 5.0);
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
	int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
	
	// SOCKETS AVOIDANCE:
	int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid trade route sockets", "sockettraderoute", 15.0);
	int avoidTradeRouteSocketsFar=rmCreateTypeDistanceConstraint("avoid trade route sockets far", "sockettraderoute", 40.0);
	int avoidMineSockets=rmCreateTypeDistanceConstraint("avoid mine sockets", "mine", 10.0);

	// SOCKETS AVOIDANCE:
	int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 6.0);
	int avoidCloseSocket=rmCreateClassDistanceConstraint("close avoid sockets", rmClassID("socketClass"), 2.0);
		
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ********************************** DEFINE THE OBJECTS TO BE PLACE LATER: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// DEFINE THE OBJECTS TO BE PLACED LATER:
// PLACE HERE THE OJECTS DEFINITIONS:
// DONE DEFINING THE OBJECTS TO BE PLACED LATER:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// *************************** DEFINE THE RIVER WIDTH BASED ON THE NUMBER OF PLAYERS: *************************** //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE RIVER WIDTH BASED ON # OF PLAYERS:
	    int rivermin = -1;
	    int rivermax = -1;

	    if (cNumberNonGaiaPlayers <= 3)
	{
		rivermin = 16;
		rivermax = 16;
	}
	    else
	{
		rivermin = 16;
		rivermax = 16;
	}
	
/*================================================================================================================*/
// ********************************************* PLACE THE RIVERS: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*        
		int riverPlacement = -1;
        
		if (cNumberNonGaiaPlayers <= 2) 
		
		riverPlacement = 0;
        
*/		
/*----------------------------------------------------------------------------------------------------------------*/		
/*
        if (riverPlacement == 0)
   
   {
	    // COLORADO RIVER:
	    int coloradoRiver = rmRiverCreate(-1, "Pampas River", 3, 3, rivermin, rivermax); // SINGLE WIDE RIVER:
	    rmRiverSetConnections(coloradoRiver, 0.15, 0.85, 0.85, 0.15);
	
	    rmRiverSetShallowRadius(coloradoRiver, rmRandInt(10, 12));
	    rmRiverAddShallow(coloradoRiver, rmRandFloat(0.25, 0.25)); // BEGIN DEFINING SHALLOWS IN THE RIVER:

	    //rmRiverSetShallowRadius(coloradoRiver, rmRandInt(10, 12));
	    //rmRiverAddShallow(coloradoRiver, 0.5);

	    rmRiverSetShallowRadius(coloradoRiver, rmRandInt(10, 12));
	    rmRiverAddShallow(coloradoRiver, rmRandFloat(0.75, 0.75));
	    rmRiverSetBankNoiseParams(coloradoRiver, 0.07, 2, 1.5, 10.0, 0.667, 3.0);

	    rmRiverBuild(coloradoRiver);
	    //rmRiverReveal(coloradoRiver, 0);
   }
*/
/*----------------------------------------------------------------------------------------------------------------*/
       
	   if ( whichMap == 1 )
	   
	{    
		// COLORADO RIVER:
	    int coloradoRiver = rmRiverCreate(-1, "Pampas River", 3, 3, rivermin, rivermax); // SINGLE WIDE RIVER:
	    rmRiverSetConnections(coloradoRiver, 0.15, 0.85, 0.85, 0.15);
	
	    rmRiverSetShallowRadius(coloradoRiver, rmRandInt(10, 12));
	    rmRiverAddShallow(coloradoRiver, rmRandFloat(0.25, 0.25)); // BEGIN DEFINING SHALLOWS IN THE RIVER:

	    //rmRiverSetShallowRadius(coloradoRiver, rmRandInt(10, 12));
	    //rmRiverAddShallow(coloradoRiver, 0.5);

	    rmRiverSetShallowRadius(coloradoRiver, rmRandInt(10, 12));
	    rmRiverAddShallow(coloradoRiver, rmRandFloat(0.75, 0.75));
	    rmRiverSetBankNoiseParams(coloradoRiver, 0.07, 2, 1.5, 10.0, 0.667, 3.0);

	    rmRiverBuild(coloradoRiver);
	    //rmRiverReveal(coloradoRiver, 0);
    } 
	    else
	{   
        // COLORADO RIVER:
	    int coloradoRiver2 = rmRiverCreate(-1, "Amazon River", 3, 3, rivermin, rivermax); // SINGLE WIDE RIVER:
	    rmRiverSetConnections(coloradoRiver2, 0.15, 0.85, 0.85, 0.15);
	
	    rmRiverSetShallowRadius(coloradoRiver2, rmRandInt(10, 12));
	    rmRiverAddShallow(coloradoRiver2, rmRandFloat(0.25, 0.25)); // BEGIN DEFINING SHALLOWS IN THE RIVER:

	    //rmRiverSetShallowRadius(coloradoRiver2, rmRandInt(10, 12));
	    //rmRiverAddShallow(coloradoRiver2, 0.5);

	    rmRiverSetShallowRadius(coloradoRiver2, rmRandInt(10, 12));
	    rmRiverAddShallow(coloradoRiver2, rmRandFloat(0.75, 0.75));
	    rmRiverSetBankNoiseParams(coloradoRiver2, 0.07, 2, 1.5, 10.0, 0.667, 3.0);

	    rmRiverBuild(coloradoRiver2);
	    //rmRiverReveal(coloradoRiver2, 0);	
	}	
    		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ***************************************** DEFINE THE 4 TRADE ROUTES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE TRADE SOCKETS:
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 6.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
        
		if ( whichMap == 1 )
		
	{	
		
		// DEFINE THE TRADE ROUTE 1:
		int tradeRouteID = rmCreateTradeRoute();
		
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.035, 0.40);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.20, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.40);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.50);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.60, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.80, 0.40);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.965, 0.60);
	
	    bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
	    rmEchoError("Failed to place trade route #1");
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	    // DEFINE THE TRADE ROUTE 2:
		int tradeRouteID2 = rmCreateTradeRoute();
	
	    rmAddTradeRouteWaypoint(tradeRouteID2, 0.40, 0.035);
		rmAddTradeRouteWaypoint(tradeRouteID2, 0.60, 0.20);
		rmAddTradeRouteWaypoint(tradeRouteID2, 0.40, 0.40);
		rmAddTradeRouteWaypoint(tradeRouteID2, 0.50, 0.50);
		rmAddTradeRouteWaypoint(tradeRouteID2, 0.60, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID2, 0.40, 0.80);
	    rmAddTradeRouteWaypoint(tradeRouteID2, 0.60, 0.965);
		
	    bool placedTradeRoute2 = rmBuildTradeRoute(tradeRouteID2, "carolinas\trade_route");
	    if(placedTradeRoute2 == false)
	    rmEchoError("Failed to place trade route #2");
		
/*----------------------------------------------------------------------------------------------------------------*/
/*        
		// DEFINE THE TRADE SOCKETS:
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 6.0);
*/
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* ADD THE MEETING POLES ALONG THE 2 TRADE ROUTES: ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

        // PUT THE SOCKETS ON THE TRADE ROUTE 1:
		rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.025);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.975);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   
        rmClearClosestPointConstraints();
   
/*----------------------------------------------------------------------------------------------------------------*/

        // PUT THE SOCKETS ON THE TRADE ROUTE 2:
		// CHANGE THE TRADE ROUTE NUMBER FOR THE NEW SOCKETS:
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID2);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.025);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.975);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints();
	}
	
/*----------------------------------------------------------------------------------------------------------------*/	

        else
		
/*----------------------------------------------------------------------------------------------------------------*/		

    {
        // DEFINE THE TRADE ROUTE 3:
		int tradeRouteID3 = rmCreateTradeRoute();
		
	    rmAddTradeRouteWaypoint(tradeRouteID3, 0.035, 0.435);
		rmAddTradeRouteWaypoint(tradeRouteID3, 0.20, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID3, 0.40, 0.40);
		//rmAddTradeRouteWaypoint(tradeRouteID3, 0.50, 0.50);
	    //rmAddTradeRouteWaypoint(tradeRouteID3, 0.60, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID3, 0.60, 0.20);
		rmAddTradeRouteWaypoint(tradeRouteID3, 0.435, 0.035);
	
	    bool placedTradeRoute3 = rmBuildTradeRoute(tradeRouteID3, "dirt");
        if(placedTradeRoute3 == false)
	    rmEchoError("Failed to place trade route #3");
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	    // DEFINE THE TRADE ROUTE 4:
		int tradeRouteID4 = rmCreateTradeRoute();
	
	    rmAddTradeRouteWaypoint(tradeRouteID4, 0.565, 0.965);
		rmAddTradeRouteWaypoint(tradeRouteID4, 0.40, 0.80);
		//rmAddTradeRouteWaypoint(tradeRouteID4, 0.40, 0.40);
		//rmAddTradeRouteWaypoint(tradeRouteID4, 0.50, 0.50);
		rmAddTradeRouteWaypoint(tradeRouteID4, 0.60, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID4, 0.80, 0.40);
	    rmAddTradeRouteWaypoint(tradeRouteID4, 0.965, 0.565);
		
	    bool placedTradeRoute4 = rmBuildTradeRoute(tradeRouteID4, "carolinas\trade_route");
	    if(placedTradeRoute4 == false)
	    rmEchoError("Failed to place trade route #4");
		
/*----------------------------------------------------------------------------------------------------------------*/
/*        
		// DEFINE THE TRADE SOCKETS:
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 6.0);
*/
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* ADD THE MEETING POLES ALONG THE 2 TRADE ROUTES: ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

		// PUT THE SOCKETS ON THE TRADE ROUTE 3:
		// CHANGE THE TRADE ROUTE NUMBER FOR THE NEW SOCKETS:
		rmSetObjectDefTradeRouteID(socketID, tradeRouteID3);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.025);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.975);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints(); 
   
/*----------------------------------------------------------------------------------------------------------------*/

        // PUT THE SOCKETS ON THE TRADE ROUTE 4:
		// CHANGE THE TRADE ROUTE NUMBER FOR THE NEW SOCKETS:
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID4);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.025);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.975);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints();

	} 
        
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *********************************** DEFINE THE SET UP STARTING LOCATIONS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
        
		if ( whichMap == 1 )
									
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.75,0.75);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.25,0.25);
	}  
		else
    {		
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.25,0.25);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.75,0.75);
	} 	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
       
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
	    
		// SET AREA MIX:
		if ( whichMap == 1 )
	{	
		rmSetAreaMix(id, "pampas_grass");
	}	
		else
	{	
		rmSetAreaMix(id, "patagonia_grass");
	}	
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
        
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
	    //rmAddAreaConstraint(id, avoidWater);
	    rmAddAreaConstraint(id, longAvoidImpassableLand);
	    
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
	    
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
	    // Build the areas.
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *********************** DEFINE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ********************** //
/*================================================================================================================*/

        // THE TCID FLOATING:
		int TCfloat = -1;
	    if (cNumberNonGaiaPlayers <= 2)
		TCfloat = 0; // zero because i don t want it moving...
	    else 
		TCfloat = 0; // zero because i don t want it moving...
		
/*----------------------------------------------------------------------------------------------------------------*/		
        
		// DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 5.0);
	}
		else
	{
        rmAddObjectDefItem(startingTCID, "townCenter", 1, 5.0);
	}
	    rmSetObjectDefMinDistance(startingTCID, 0);
	    rmSetObjectDefMaxDistance(startingTCID, TCfloat);
	    rmAddObjectDefConstraint(startingTCID, avoidImpassableLand);
	    rmAddObjectDefConstraint(startingTCID, shortAvoidTradeRoute);
	    rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSockets);
	    rmAddObjectDefToClass(startingTCID, rmClassID("player"));
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    //rmAddObjectDefConstraint(startingTCID, avoidWater);
	    //rmPlaceObjectDefPerPlayer(startingTCID, true);
		
/*----------------------------------------------------------------------------------------------------------------*/		
	
	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    rmAddObjectDefConstraint(startingUnits, avoidResource);
	    rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);
	    //rmAddObjectDefConstraint(startingUnits, avoidWater);
	    //rmPlaceObjectDefPerPlayer(startingUnits, true);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    
		if ( whichMap == 1 )
	{	
		rmAddObjectDefItem(StartAreaTreeID, "TreePampas", rmRandInt(3,5), 6.0);
	}	
	    else
	{	
		rmAddObjectDefItem(StartAreaTreeID, "TreePatagoniaDirt", rmRandInt(3,5), 6.0);
	}	
		
		rmSetObjectDefMinDistance(StartAreaTreeID, 10);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	    rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);
        //rmAddObjectDefConstraint(StartAreaTreeID, playerConstraint);
	    //rmPlaceObjectDefPerPlayer(StartAreaTreeID, true);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // DEFINE THE STARTING BERRIES:
	    int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", rmRandInt(3,5), 5.0);
	    //rmSetObjectDefCreateHerd(StartBerriesID, true);
	    rmSetObjectDefMinDistance(StartBerriesID, 10);
	    rmSetObjectDefMaxDistance(StartBerriesID, 20);
	    rmAddObjectDefConstraint(StartBerriesID, avoidStartResource);
	    rmAddObjectDefConstraint(StartBerriesID, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(StartBerriesID, avoidNatives);
	    //rmAddObjectDefConstraint(StartBerriesID, deerAvoidDeer);
	    rmAddObjectDefConstraint(StartBerriesID, shortPlayerConstraint);
	    //rmPlaceObjectDefPerPlayer(StartBerriesID, true);
		
/*----------------------------------------------------------------------------------------------------------------*/		
   
        // DEFINE THE STARTING SILVER:
        int startSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(startSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(startSilverID, shortAvoidTradeRoute);
	    rmSetObjectDefMinDistance(startSilverID, 12.0);
	    rmSetObjectDefMaxDistance(startSilverID, 20.0);
	    rmAddObjectDefConstraint(startSilverID, avoidAll);
	    rmAddObjectDefConstraint(startSilverID, avoidImpassableLand);
	    //rmPlaceObjectDefPerPlayer(startSilverID, true);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ******************** PLACING THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //	
/*================================================================================================================*/ 	

	    // JOHN'S SWEET SOLUTION TO PLACING STUFF:
		// AROUND THE TC REGARDLESS OF WHERE THE PLAYER START AREA ACTUALLY IS:
	    
		for(i=1; <cNumberPlayers)
		
	{
	
		// PLACING THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
		
		// PLACING THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACING THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACING THE STARTING BERRIES:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACING THE STARTING SILVER:
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if ( whichMap == 1 )
	
{	    
        if (subCiv0 == rmGetCivID("Aztecs"))
	{	
	    int aztec1VillageID = -1;
		aztec1VillageID = rmCreateGrouping("aztec village 1", "native aztec village 1");
		rmSetGroupingMinDistance(aztec1VillageID, 0.0);
		rmSetGroupingMaxDistance(aztec1VillageID, 0.0);
		rmAddGroupingToClass(aztec1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztec1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztec1VillageID, 0, 0.15, 0.45);
	} 
}        
		else
{		
    	if (subCiv0 == rmGetCivID("Maya"))
	{  
		int maya1VillageID = -1;
		maya1VillageID = rmCreateGrouping("maya village 1", "native maya village 1");
		rmSetGroupingMinDistance(maya1VillageID, 0.0);
		rmSetGroupingMaxDistance(maya1VillageID, 0.0);
		rmAddGroupingToClass(maya1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(maya1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya1VillageID, 0, 0.15, 0.45);
	} 
}	
	
/*----------------------------------------------------------------------------------------------------------------*/	

	    if ( whichMap == 1 )
	
{	    
        if (subCiv1 == rmGetCivID("Aztecs"))
		
	{	
	    int aztec2VillageID = -1;
		aztec2VillageID = rmCreateGrouping("aztec village 2", "native aztec village 1");
		rmSetGroupingMinDistance(aztec2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztec2VillageID, 0.0);
		rmAddGroupingToClass(aztec2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztec2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztec2VillageID, 0, 0.55, 0.85);
	} 
}        
		else
		
{  
	    if (subCiv1 == rmGetCivID("Maya"))
		
	{	
	    int maya2VillageID = -1;
		maya2VillageID = rmCreateGrouping("maya village 2", "native maya village 1");
		rmSetGroupingMinDistance(maya2VillageID, 0.0);
		rmSetGroupingMaxDistance(maya2VillageID, 0.0);
		rmAddGroupingToClass(maya2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(maya2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya2VillageID, 0, 0.55, 0.85);
	}	
} 
	
/*----------------------------------------------------------------------------------------------------------------*/

	    if ( whichMap == 1 )
{		
	    if (subCiv2 == rmGetCivID("Aztecs"))
	{	
	    int aztec3VillageID = -1;
		aztec3VillageID = rmCreateGrouping("aztec village 3", "native aztec village 1");
		rmSetGroupingMinDistance(aztec3VillageID, 0.0);
		rmSetGroupingMaxDistance(aztec3VillageID, 0.0);
		rmAddGroupingToClass(aztec3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztec3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztec3VillageID, 0, 0.85, 0.55);
	} 
}	
		
		else
		
{		
		if (subCiv2 == rmGetCivID("Maya"))
	{  
		int maya3VillageID = -1;
		maya3VillageID = rmCreateGrouping("maya village 3", "native maya village 1");
		rmSetGroupingMinDistance(maya3VillageID, 0.0);
		rmSetGroupingMaxDistance(maya3VillageID, 0.0);
		rmAddGroupingToClass(maya3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(maya3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya3VillageID, 0, 0.85, 0.55);
	} 
}
	
/*----------------------------------------------------------------------------------------------------------------*/	

        if ( whichMap == 1 )

{		
	    if (subCiv3 == rmGetCivID("Aztecs"))
	{	
	    int aztec4VillageID = -1;
		aztec4VillageID = rmCreateGrouping("aztec village 4", "native aztec village 1");
		rmSetGroupingMinDistance(aztec4VillageID, 0.0);
		rmSetGroupingMaxDistance(aztec4VillageID, 0.0);
		rmAddGroupingToClass(aztec4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztec4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztec4VillageID, 0, 0.45, 0.15);
	} 
}	
		
		else
		
{		
		if (subCiv3 == rmGetCivID("Maya"))
	{  
		int maya4VillageID = -1;
		maya4VillageID = rmCreateGrouping("maya village 4", "native maya village 1");
		rmSetGroupingMinDistance(maya4VillageID, 0.0);
		rmSetGroupingMaxDistance(maya4VillageID, 0.0);
		rmAddGroupingToClass(maya4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(maya4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya4VillageID, 0, 0.45, 0.15);
	} 
}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TREES: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if ( whichMap == 1 )
	{	
		// THE TREES NUMBER 1:
		int Trees1ID = rmCreateObjectDef("The Trees 1");
		rmAddObjectDefItem(Trees1ID, "TreePampas", rmRandInt(12,18), 11.0);
		rmSetObjectDefMinDistance(Trees1ID, 0.0);
		rmSetObjectDefMaxDistance(Trees1ID, 0.0);
		rmAddObjectDefConstraint(Trees1ID, avoidTrees1);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.15, 0.35);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.35, 0.15);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.65, 0.85);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.85, 0.65);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.325, 0.525);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.525, 0.325);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.475, 0.675);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.675, 0.475);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.125, 0.725);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.725, 0.125);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.275, 0.875);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.875, 0.275);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.55, 0.75);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.75, 0.55);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.25, 0.45);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.45, 0.25);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.35, 0.35);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.65, 0.65);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.45, 0.95);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.95, 0.45);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.05, 0.55);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.55, 0.05);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.15, 0.25);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.25, 0.15);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.75, 0.85);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.85, 0.75);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.375, 0.775);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.775, 0.375);
		
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.225, 0.625);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.625, 0.225);
	}
/*----------------------------------------------------------------------------------------------------------------*/	
        else
/*----------------------------------------------------------------------------------------------------------------*/		
    {
        // THE TREES NUMBER 2:
		int Trees2ID = rmCreateObjectDef("The Trees 2");
		rmAddObjectDefItem(Trees2ID, "TreePatagoniaDirt", rmRandInt(12,18), 11.0);
		rmSetObjectDefMinDistance(Trees2ID, 0.0);
		rmSetObjectDefMaxDistance(Trees2ID, 0.0);
		rmAddObjectDefConstraint(Trees2ID, avoidTrees2);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.15, 0.35);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.35, 0.15);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.65, 0.85);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.85, 0.65);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.325, 0.525);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.525, 0.325);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.475, 0.675);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.675, 0.475);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.125, 0.725);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.725, 0.125);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.275, 0.875);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.875, 0.275);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.55, 0.75);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.75, 0.55);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.25, 0.45);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.45, 0.25);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.35, 0.35);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.65, 0.65);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.45, 0.95);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.95, 0.45);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.05, 0.55);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.55, 0.05);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.15, 0.25);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.25, 0.15);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.75, 0.85);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.85, 0.75);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.375, 0.775);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.775, 0.375);
		
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.225, 0.625);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.625, 0.225);	
    }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE GOLD MINES: ************************************** //
// ************************************* DEFINE AND PLACE THE SILVER MINES: ************************************* //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
		
	{		
		// THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.10, 0.60);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.60, 0.10);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.40, 0.90);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.90, 0.40); 
		
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.30, 0.40);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.40, 0.30);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.60, 0.70);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.70, 0.60); 
		
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.835, 0.835); 
		
	}
/*----------------------------------------------------------------------------------------------------------------*/
    else
/*----------------------------------------------------------------------------------------------------------------*/
	{
	     // THE SILVER MINE NUMBER 1:
		int silver1ID = rmCreateObjectDef("silver 1");
		rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver1ID, 0.0);
		rmSetObjectDefMaxDistance(silver1ID, 0.0);
		rmAddObjectDefConstraint(silver1ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.10, 0.60);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.60, 0.10);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.40, 0.90);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.90, 0.40);
		
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.30, 0.40);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.40, 0.30);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.60, 0.70);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.70, 0.60);
		
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.835, 0.835);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE RHEA FLOCK: *************************************** //
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
	
	{	
		int Rhea1ID=rmCreateObjectDef("The Rhea Flock 1");
        rmAddObjectDefItem(Rhea1ID, "rhea", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(Rhea1ID, 0.0);
        rmSetObjectDefMaxDistance(Rhea1ID, 0.0);
	    rmAddObjectDefConstraint(Rhea1ID, avoidRhea);
		rmSetObjectDefCreateHerd(Rhea1ID, true);
	    
		rmPlaceObjectDefAtLoc(Rhea1ID, 0, 0.425, 0.725);
		rmPlaceObjectDefAtLoc(Rhea1ID, 0, 0.725, 0.425);
		rmPlaceObjectDefAtLoc(Rhea1ID, 0, 0.275, 0.575);
		rmPlaceObjectDefAtLoc(Rhea1ID, 0, 0.575, 0.275);
		
		rmPlaceObjectDefAtLoc(Rhea1ID, 0, 0.065, 0.65);
		rmPlaceObjectDefAtLoc(Rhea1ID, 0, 0.65, 0.065);
		rmPlaceObjectDefAtLoc(Rhea1ID, 0, 0.35, 0.935);
		rmPlaceObjectDefAtLoc(Rhea1ID, 0, 0.935, 0.35);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/
        else
/*----------------------------------------------------------------------------------------------------------------*/		
		
	{
    	int Deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(Deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(Deer1ID, 0.0);
        rmSetObjectDefMaxDistance(Deer1ID, 0.0);
	    rmAddObjectDefConstraint(Deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(Deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.425, 0.725);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.725, 0.425);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.275, 0.575);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.575, 0.275);
		
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.065, 0.65);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.65, 0.065);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.35, 0.935);
		rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.935, 0.35);
    }		
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TREASURES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.325, 0.425);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.425, 0.325);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.575, 0.675);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.675, 0.575);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.125, 0.625);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.625, 0.125);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.375, 0.875);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.875, 0.375);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.70, 0.90);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.90, 0.70);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.10, 0.30);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.30, 0.10);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE COWS: ********************************************* //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
		
	{	
		int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmSetObjectDefCreateHerd(cow1ID, true);
	    
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.2, 0.4);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.4, 0.2);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.6, 0.8);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.8, 0.6);
		
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.175, 0.675);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.675, 0.175);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.325, 0.825);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.825, 0.325);
	}
/*----------------------------------------------------------------------------------------------------------------*/	
        else
/*----------------------------------------------------------------------------------------------------------------*/		
	{	
		int sheep1ID=rmCreateObjectDef("The Sheeps 1");
        rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(sheep1ID, 0.0);
        rmSetObjectDefMaxDistance(sheep1ID, 0.0);
	    rmAddObjectDefConstraint(sheep1ID, avoidSheep);
		rmSetObjectDefCreateHerd(sheep1ID, true);
	    
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.2, 0.4);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.4, 0.2);
        
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.6, 0.8);
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.8, 0.6);
		
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.175, 0.675);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.675, 0.175);
        
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.325, 0.825);
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.825, 0.325);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE 4 CLIFFS: **************************************** //
/*================================================================================================================*/

        // CLIFF NUMBER 1:
		int cliffID=rmCreateArea("cliff");
        rmSetAreaSize(cliffID, rmAreaTilesToFraction(70), rmAreaTilesToFraction(70));
        rmSetAreaWarnFailure(cliffID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliffID, "Texas");
		else
		rmSetAreaCliffType(cliffID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffID, 1);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffID, avoidCliffs);
	    rmSetAreaMinBlobs(cliffID, 1);
        rmSetAreaMaxBlobs(cliffID, 1);
        rmSetAreaMinBlobDistance(cliffID, 1);
        rmSetAreaMaxBlobDistance(cliffID, 1);
        rmSetAreaSmoothDistance(cliffID, 10);
        rmSetAreaCoherence(cliffID, 0.95);
		rmSetAreaLocation(cliffID, 0.2, 0.5);
		rmBuildArea(cliffID);

/*----------------------------------------------------------------------------------------------------------------*/
        
		// CLIFF NUMBER 2:
		int cliff2ID=rmCreateArea("cliff 2");
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(70), rmAreaTilesToFraction(70));
        rmSetAreaWarnFailure(cliff2ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff2ID, "Texas");
		else
		rmSetAreaCliffType(cliff2ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff2ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff2ID, 1);
        rmAddAreaToClass(cliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff2ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff2ID, 1);
        rmSetAreaMaxBlobs(cliff2ID, 1);
        rmSetAreaMinBlobDistance(cliff2ID, 1);
        rmSetAreaMaxBlobDistance(cliff2ID, 1);
        rmSetAreaSmoothDistance(cliff2ID, 10);
        rmSetAreaCoherence(cliff2ID, 0.95);
		rmSetAreaLocation(cliff2ID, 0.5, 0.2);
		rmBuildArea(cliff2ID);

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 3:
		int cliff3ID=rmCreateArea("cliff 3");
        rmSetAreaSize(cliff3ID, rmAreaTilesToFraction(70), rmAreaTilesToFraction(70));
        rmSetAreaWarnFailure(cliff3ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff3ID, "Texas");
		else
		rmSetAreaCliffType(cliff3ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff3ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff3ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff3ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff3ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff3ID, 1);
        rmAddAreaToClass(cliff3ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff3ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff3ID, 1);
        rmSetAreaMaxBlobs(cliff3ID, 1);
        rmSetAreaMinBlobDistance(cliff3ID, 1);
        rmSetAreaMaxBlobDistance(cliff3ID, 1);
        rmSetAreaSmoothDistance(cliff3ID, 10);
        rmSetAreaCoherence(cliff3ID, 0.95);
		rmSetAreaLocation(cliff3ID, 0.5, 0.8);
		rmBuildArea(cliff3ID);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // CLIFF NUMBER 4:
		int cliff4ID=rmCreateArea("cliff 4");
        rmSetAreaSize(cliff4ID, rmAreaTilesToFraction(70), rmAreaTilesToFraction(70));
        rmSetAreaWarnFailure(cliff4ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff4ID, "Texas");
		else
		rmSetAreaCliffType(cliff4ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff4ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff4ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff4ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff4ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff4ID, 1);
        rmAddAreaToClass(cliff4ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff4ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff4ID, 1);
        rmSetAreaMaxBlobs(cliff4ID, 1);
        rmSetAreaMinBlobDistance(cliff4ID, 1);
        rmSetAreaMaxBlobDistance(cliff4ID, 1);
        rmSetAreaSmoothDistance(cliff4ID, 10);
        rmSetAreaCoherence(cliff4ID, 0.95);
		rmSetAreaLocation(cliff4ID, 0.8, 0.5);
		rmBuildArea(cliff4ID);	

/*----------------------------------------------------------------------------------------------------------------*/
        
		// CLIFF NUMBER 5:
		int cliff5ID=rmCreateArea("cliff 5");
        rmSetAreaSize(cliff5ID, rmAreaTilesToFraction(70), rmAreaTilesToFraction(70));
        rmSetAreaWarnFailure(cliff5ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff5ID, "Texas");
		else
		rmSetAreaCliffType(cliff5ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff5ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff5ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff5ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff5ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff5ID, 1);
        rmAddAreaToClass(cliff5ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff5ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff5ID, 1);
        rmSetAreaMaxBlobs(cliff5ID, 1);
        rmSetAreaMinBlobDistance(cliff5ID, 1);
        rmSetAreaMaxBlobDistance(cliff5ID, 1);
        rmSetAreaSmoothDistance(cliff5ID, 10);
        rmSetAreaCoherence(cliff5ID, 0.95);
		rmSetAreaLocation(cliff5ID, 0.385, 0.485);
		rmBuildArea(cliff5ID);

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 6:
		int cliff6ID=rmCreateArea("cliff 6");
        rmSetAreaSize(cliff6ID, rmAreaTilesToFraction(70), rmAreaTilesToFraction(70));
        rmSetAreaWarnFailure(cliff6ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff6ID, "Texas");
		else
		rmSetAreaCliffType(cliff6ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff6ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff6ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff6ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff6ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff6ID, 1);
        rmAddAreaToClass(cliff6ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff6ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff6ID, 1);
        rmSetAreaMaxBlobs(cliff6ID, 1);
        rmSetAreaMinBlobDistance(cliff6ID, 1);
        rmSetAreaMaxBlobDistance(cliff6ID, 1);
        rmSetAreaSmoothDistance(cliff6ID, 10);
        rmSetAreaCoherence(cliff6ID, 0.95);
		rmSetAreaLocation(cliff6ID, 0.485, 0.385);
		rmBuildArea(cliff6ID);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// CLIFF NUMBER 7:
		int cliff7ID=rmCreateArea("cliff 7");
        rmSetAreaSize(cliff7ID, rmAreaTilesToFraction(70), rmAreaTilesToFraction(70));
        rmSetAreaWarnFailure(cliff7ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff7ID, "Texas");
		else
		rmSetAreaCliffType(cliff7ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff7ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff7ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff7ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff7ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff7ID, 1);
        rmAddAreaToClass(cliff7ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff7ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff7ID, 1);
        rmSetAreaMaxBlobs(cliff7ID, 1);
        rmSetAreaMinBlobDistance(cliff7ID, 1);
        rmSetAreaMaxBlobDistance(cliff7ID, 1);
        rmSetAreaSmoothDistance(cliff7ID, 10);
        rmSetAreaCoherence(cliff7ID, 0.95);
		rmSetAreaLocation(cliff7ID, 0.515, 0.615);
		rmBuildArea(cliff7ID);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 8:
		int cliff8ID=rmCreateArea("cliff 8");
        rmSetAreaSize(cliff8ID, rmAreaTilesToFraction(70), rmAreaTilesToFraction(70));
        rmSetAreaWarnFailure(cliff8ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff8ID, "Texas");
		else
		rmSetAreaCliffType(cliff8ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff8ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff8ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff8ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff8ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff8ID, 1);
        rmAddAreaToClass(cliff8ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff8ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff8ID, 1);
        rmSetAreaMaxBlobs(cliff8ID, 1);
        rmSetAreaMinBlobDistance(cliff8ID, 1);
        rmSetAreaMaxBlobDistance(cliff8ID, 1);
        rmSetAreaSmoothDistance(cliff8ID, 10);
        rmSetAreaCoherence(cliff8ID, 0.95);
		rmSetAreaLocation(cliff8ID, 0.615, 0.515);
		rmBuildArea(cliff8ID);
		
/*----------------------------------------------------------------------------------------------------------------*/		
	    
		// CLIFF NUMBER 9:
		int cliff9ID=rmCreateArea("cliff 9");
        rmSetAreaSize(cliff9ID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
        rmSetAreaWarnFailure(cliff9ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff9ID, "Texas");
		else
		rmSetAreaCliffType(cliff9ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff9ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff9ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff9ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff9ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff9ID, 1);
        rmAddAreaToClass(cliff9ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff9ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff9ID, 1);
        rmSetAreaMaxBlobs(cliff9ID, 1);
        rmSetAreaMinBlobDistance(cliff9ID, 1);
        rmSetAreaMaxBlobDistance(cliff9ID, 1);
        rmSetAreaSmoothDistance(cliff9ID, 10);
        rmSetAreaCoherence(cliff9ID, 0.95);
		rmSetAreaLocation(cliff9ID, 0.25, 0.35);
		rmBuildArea(cliff9ID);

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 10:
		int cliff10ID=rmCreateArea("cliff 10");
        rmSetAreaSize(cliff10ID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
        rmSetAreaWarnFailure(cliff10ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff10ID, "Texas");
		else
		rmSetAreaCliffType(cliff10ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff10ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff10ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff10ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff10ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff10ID, 1);
        rmAddAreaToClass(cliff10ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff10ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff10ID, 1);
        rmSetAreaMaxBlobs(cliff10ID, 1);
        rmSetAreaMinBlobDistance(cliff10ID, 1);
        rmSetAreaMaxBlobDistance(cliff10ID, 1);
        rmSetAreaSmoothDistance(cliff10ID, 10);
        rmSetAreaCoherence(cliff10ID, 0.95);
		rmSetAreaLocation(cliff10ID, 0.35, 0.25);
		rmBuildArea(cliff10ID);	

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 11:
		int cliff11ID=rmCreateArea("cliff 11");
        rmSetAreaSize(cliff11ID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
        rmSetAreaWarnFailure(cliff11ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff11ID, "Texas");
		else
		rmSetAreaCliffType(cliff11ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff11ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff11ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff11ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff11ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff11ID, 1);
        rmAddAreaToClass(cliff11ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff11ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff11ID, 1);
        rmSetAreaMaxBlobs(cliff11ID, 1);
        rmSetAreaMinBlobDistance(cliff11ID, 1);
        rmSetAreaMaxBlobDistance(cliff11ID, 1);
        rmSetAreaSmoothDistance(cliff11ID, 10);
        rmSetAreaCoherence(cliff11ID, 0.95);
		rmSetAreaLocation(cliff11ID, 0.65, 0.75);
		rmBuildArea(cliff11ID);	

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 12:
		int cliff12ID=rmCreateArea("cliff 12");
        rmSetAreaSize(cliff12ID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
        rmSetAreaWarnFailure(cliff12ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff12ID, "Texas");
		else
		rmSetAreaCliffType(cliff12ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff12ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff12ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff12ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff12ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff12ID, 1);
        rmAddAreaToClass(cliff12ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff12ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff12ID, 1);
        rmSetAreaMaxBlobs(cliff12ID, 1);
        rmSetAreaMinBlobDistance(cliff12ID, 1);
        rmSetAreaMaxBlobDistance(cliff12ID, 1);
        rmSetAreaSmoothDistance(cliff12ID, 10);
        rmSetAreaCoherence(cliff12ID, 0.95);
		rmSetAreaLocation(cliff12ID, 0.75, 0.65);
		rmBuildArea(cliff12ID);	
		
/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 13:
		int cliff13ID=rmCreateArea("cliff 13");
        rmSetAreaSize(cliff13ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));
        rmSetAreaWarnFailure(cliff13ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff13ID, "Texas");
		else
		rmSetAreaCliffType(cliff13ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff13ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff13ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff13ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff13ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff13ID, 1);
        rmAddAreaToClass(cliff13ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff13ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff13ID, 1);
        rmSetAreaMaxBlobs(cliff13ID, 1);
        rmSetAreaMinBlobDistance(cliff13ID, 1);
        rmSetAreaMaxBlobDistance(cliff13ID, 1);
        rmSetAreaSmoothDistance(cliff13ID, 10);
        rmSetAreaCoherence(cliff13ID, 0.95);
		rmSetAreaLocation(cliff13ID, 0.075, 0.375);
		rmBuildArea(cliff13ID);	

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 14:
		int cliff14ID=rmCreateArea("cliff 14");
        rmSetAreaSize(cliff14ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));
        rmSetAreaWarnFailure(cliff14ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff14ID, "Texas");
		else
		rmSetAreaCliffType(cliff14ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff14ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff14ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff14ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff14ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff14ID, 1);
        rmAddAreaToClass(cliff14ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff14ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff14ID, 1);
        rmSetAreaMaxBlobs(cliff14ID, 1);
        rmSetAreaMinBlobDistance(cliff14ID, 1);
        rmSetAreaMaxBlobDistance(cliff14ID, 1);
        rmSetAreaSmoothDistance(cliff14ID, 10);
        rmSetAreaCoherence(cliff14ID, 0.95);
		rmSetAreaLocation(cliff14ID, 0.375, 0.075);
		rmBuildArea(cliff14ID);	

/*---------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 15:
		int cliff15ID=rmCreateArea("cliff 15");
        rmSetAreaSize(cliff15ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));
        rmSetAreaWarnFailure(cliff15ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff15ID, "Texas");
		else
		rmSetAreaCliffType(cliff15ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff15ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff15ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff15ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff15ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff15ID, 1);
        rmAddAreaToClass(cliff15ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff15ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff15ID, 1);
        rmSetAreaMaxBlobs(cliff15ID, 1);
        rmSetAreaMinBlobDistance(cliff15ID, 1);
        rmSetAreaMaxBlobDistance(cliff15ID, 1);
        rmSetAreaSmoothDistance(cliff15ID, 10);
        rmSetAreaCoherence(cliff15ID, 0.95);
		rmSetAreaLocation(cliff15ID, 0.925, 0.625);
		rmBuildArea(cliff15ID);

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 16:
		int cliff16ID=rmCreateArea("cliff 16");
        rmSetAreaSize(cliff16ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));
        rmSetAreaWarnFailure(cliff16ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff16ID, "Texas");
		else
		rmSetAreaCliffType(cliff16ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff16ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff16ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff16ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff16ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff16ID, 1);
        rmAddAreaToClass(cliff16ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff16ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff16ID, 1);
        rmSetAreaMaxBlobs(cliff16ID, 1);
        rmSetAreaMinBlobDistance(cliff16ID, 1);
        rmSetAreaMaxBlobDistance(cliff16ID, 1);
        rmSetAreaSmoothDistance(cliff16ID, 10);
        rmSetAreaCoherence(cliff16ID, 0.95);
		rmSetAreaLocation(cliff16ID, 0.625, 0.925);
		rmBuildArea(cliff16ID);	

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 17:
		int cliff17ID=rmCreateArea("cliff 17");
        rmSetAreaSize(cliff17ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));
        rmSetAreaWarnFailure(cliff17ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff17ID, "Texas");
		else
		rmSetAreaCliffType(cliff17ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff17ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff17ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff17ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff17ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff17ID, 1);
        rmAddAreaToClass(cliff17ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff17ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff17ID, 1);
        rmSetAreaMaxBlobs(cliff17ID, 1);
        rmSetAreaMinBlobDistance(cliff17ID, 1);
        rmSetAreaMaxBlobDistance(cliff17ID, 1);
        rmSetAreaSmoothDistance(cliff17ID, 10);
        rmSetAreaCoherence(cliff17ID, 0.95);
		rmSetAreaLocation(cliff17ID, 0.050, 0.60);
		rmBuildArea(cliff17ID);	

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 18:
		int cliff18ID=rmCreateArea("cliff 18");
        rmSetAreaSize(cliff18ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));
        rmSetAreaWarnFailure(cliff18ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff18ID, "Texas");
		else
		rmSetAreaCliffType(cliff18ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff18ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff18ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff18ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff18ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff18ID, 1);
        rmAddAreaToClass(cliff18ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff18ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff18ID, 1);
        rmSetAreaMaxBlobs(cliff18ID, 1);
        rmSetAreaMinBlobDistance(cliff18ID, 1);
        rmSetAreaMaxBlobDistance(cliff18ID, 1);
        rmSetAreaSmoothDistance(cliff18ID, 10);
        rmSetAreaCoherence(cliff18ID, 0.95);
		rmSetAreaLocation(cliff18ID, 0.60, 0.050);
		rmBuildArea(cliff18ID);

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 19:
		int cliff19ID=rmCreateArea("cliff 19");
        rmSetAreaSize(cliff19ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));
        rmSetAreaWarnFailure(cliff19ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff19ID, "Texas");
		else
		rmSetAreaCliffType(cliff19ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff19ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff19ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff19ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff19ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff19ID, 1);
        rmAddAreaToClass(cliff19ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff19ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff19ID, 1);
        rmSetAreaMaxBlobs(cliff19ID, 1);
        rmSetAreaMinBlobDistance(cliff19ID, 1);
        rmSetAreaMaxBlobDistance(cliff19ID, 1);
        rmSetAreaSmoothDistance(cliff19ID, 10);
        rmSetAreaCoherence(cliff19ID, 0.95);
		rmSetAreaLocation(cliff19ID, 0.40, 0.95);
		rmBuildArea(cliff19ID);			

/*----------------------------------------------------------------------------------------------------------------*/

        // CLIFF NUMBER 20:
		int cliff20ID=rmCreateArea("cliff 20");
        rmSetAreaSize(cliff20ID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(50));
        rmSetAreaWarnFailure(cliff20ID, false);
	    
		if ( whichMap == 1 )
		rmSetAreaCliffType(cliff20ID, "Texas");
		else
		rmSetAreaCliffType(cliff20ID, "Patagonia");
		
	    //rmSetAreaCliffEdge(cliff20ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(cliff20ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff20ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff20ID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff20ID, 1);
        rmAddAreaToClass(cliff20ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff20ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff20ID, 1);
        rmSetAreaMaxBlobs(cliff20ID, 1);
        rmSetAreaMinBlobDistance(cliff20ID, 1);
        rmSetAreaMaxBlobDistance(cliff20ID, 1);
        rmSetAreaSmoothDistance(cliff20ID, 10);
        rmSetAreaCoherence(cliff20ID, 0.95);
		rmSetAreaLocation(cliff20ID, 0.95, 0.40);
		rmBuildArea(cliff20ID);	

/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE RANDOM TREES:
		int RandomTreesID = rmCreateObjectDef("The Random Trees");
		
		if ( whichMap == 1 )
	{	
		rmAddObjectDefItem(RandomTreesID, "TreePampas", 1, 0.0);
	}	
		else
	{	
		rmAddObjectDefItem(RandomTreesID, "TreePatagoniaDirt", 1, 0.0);
	}	
		
		rmSetObjectDefMinDistance(RandomTreesID, 0.0);
		rmSetObjectDefMaxDistance(RandomTreesID, rmXFractionToMeters(0.5));
		
		// DEFINE THE CONSTRAINTS:
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseTrees1);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseTrees2);
		rmAddObjectDefConstraint(RandomTreesID, avoidAll);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseCoin);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseGold);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseNatives);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseImpassableLand);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseCliffs);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseCow);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseSheep);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseRhea);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseDeer);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseNugget);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseSocket);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(RandomTreesID, mediumPlayerConstraint);
				
        rmPlaceObjectDefAtLoc(RandomTreesID, 0, 0.5, 0.5, 50*cNumberNonGaiaPlayers);		
        		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FISH AND THE WHALES: ********************************* //
/*================================================================================================================*/

        // DEFINE THE FISH AND WHALES CONSTRAINTS:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 16.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 20.0);
		int whale2VsWhale2ID=rmCreateTypeDistanceConstraint("whale2 v whale2", "HumpbackWhale", 20.0);
		int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 15.0);
	
/*----------------------------------------------------------------------------------------------------------------*/		

        // FISHBASS -- FOOD:
		int fishID=rmCreateObjectDef("fish");
        
		if ( whichMap == 1 )
		rmAddObjectDefItem(fishID, "FishBass", 5, 10.0);
        else
		rmAddObjectDefItem(fishID, "FishMahi", 5, 10.0);
		
		rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*25);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*================================================================================================================*/  
