/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

// THE EAST COAST II:
// CREATED BY DANY:
// OCTOBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE WHICHVARIATION:
		int whichVariation=-1;
	    whichVariation = rmRandInt(1,2);
		
/*----------------------------------------------------------------------------------------------------------------*/		
        
		if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");
		
		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee");
		
		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");
		
        subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cherokee");
	}	
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int playerTiles = 25000;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(632, 632);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(3);

        // SET SEA TYPE:
        rmSetSeaType("great lakes");
   
        // ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water");
	
	    // SET MAP TYPE:
		rmSetMapType("greatlakes");
	    rmSetMapType("water");
		rmSetMapType("grass");
	
	    // SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	
        // SET LIGHTING:
		rmSetLightingSet("Great Lakes");
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classCliff");
        int classbigContinent=rmDefineClass("big continent");
        rmDefineClass("corner");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("flag");
	    rmDefineClass("classInvis");
		rmDefineClass("classSocket");
		rmDefineClass("natives");
		rmDefineClass("classTrees");
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/	
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreatePieConstraint("edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
		    
/*----------------------------------------------------------------------------------------------------------------*/		
		
        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 20.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
   
	    int TCvsTC=rmCreateTypeDistanceConstraint("TC avoid same", "TownCenter", 50.0);
        int CWvsCW=rmCreateTypeDistanceConstraint("CW avoid same", "CoveredWagon", 50.0);
	    int forestvsTC=rmCreateTypeDistanceConstraint("forest vs. TC", "TownCenter", 20.0);
	    int forestvsCW=rmCreateTypeDistanceConstraint("forest vs. CW", "CoveredWagon", 20.0);
	    int avoidTC=rmCreateTypeDistanceConstraint("stuff vs TC", "TownCenter", 60.0);
	    int shortAvoidTC=rmCreateTypeDistanceConstraint("stuff less vs TC", "TownCenter", 20.0);
	    int avoidCW=rmCreateTypeDistanceConstraint("stuff vs CW", "CoveredWagon", 60.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// *********************************** DEFINE THE CONSTRAINTS FOR THE TREES: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 10.0);
		int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 5.0);
		int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 2.0);
		int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
		int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
		int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);

/*----------------------------------------------------------------------------------------------------------------*/        
		
		// INVIS CONSTRAINT:
		int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
        int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
		
        int invisConstraint=rmCreateClassDistanceConstraint("continent avoid invis continent", rmClassID("classInvis"), rmXFractionToMeters(0.15));
	    //int invisConstraint=rmCreateClassDistanceConstraint("continent avoid invis continent", rmClassID("classInvis"), 75.0);
	    
		
		if (cNumberNonGaiaPlayers <=2)
		invisConstraint=rmCreateClassDistanceConstraint("continent avoid invis continent large map", rmClassID("classInvis"), rmXFractionToMeters(0.15));

/*----------------------------------------------------------------------------------------------------------------*/        
		
		// BONUS AREA CONSTRAINT:
        int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 20.0);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // FOREST AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 5.0);
        
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 15.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
        
		// BERRIES AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff vs berry", "berryBush", 15.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
		
	    // SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 15.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
	    
		// FAST COIN AVOIDANCE:
		int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 15.0);
		int avoidCloseFastCoin=rmCreateTypeDistanceConstraint("close avoids coin", "gold", 5.0);
		
/*----------------------------------------------------------------------------------------------------------------*/	
	
        // NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 15.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "abstractNugget", 15.0);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 8.0);
		
		int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far stuff avoids natives", rmClassID("natives"), 75.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
        int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 20.0);
	    if (cNumberNonGaiaPlayers < 3)
		longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land small map", "Land", false, 12.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// FISH AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 10.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "humpbackWhale", 25.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	    
		// FLAG AVOIDANCE:
		int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

/*----------------------------------------------------------------------------------------------------------------*/		
		
        // DECORATIONS AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // IMPORTANT OBJECT AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 5.0);
	    int nativeAvoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 20.0);
		
        // SOCKETS AVOIDANCE:
        int avoidSocket = rmCreateClassDistanceConstraint("stuff avoid socket", rmClassID("classSocket"), 15.0);
        int avoidCloseSocket = rmCreateClassDistanceConstraint("close stuff avoid socket", rmClassID("classSocket"), 5.0);
        int avoidVeryCloseSocket = rmCreateClassDistanceConstraint("very close stuff avoid socket", rmClassID("classSocket"), 2.0);
        int avoidMediumSocket = rmCreateClassDistanceConstraint("medium stuff avoid socket", rmClassID("classSocket"), 25.0);
        int avoidFarSocket = rmCreateClassDistanceConstraint("far stuff avoid socket", rmClassID("classSocket"), 50.0);
        int avoidVeryFarSocket = rmCreateClassDistanceConstraint("very far stuff avoid socket", rmClassID("classSocket"), 75.0);

        
/*----------------------------------------------------------------------------------------------------------------*/		
		
		int avoidImportantItem=rmCreateClassDistanceConstraint("sockets avoid each other", rmClassID("importantItem"), 40.0);
        int silverAvoidImportantItem=rmCreateClassDistanceConstraint("silver avoids sockets", rmClassID("importantItem"), 12.0);

/*----------------------------------------------------------------------------------------------------------------*/        
		
		// CONSTRAINT TO AVOID WATER:
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 8.0);
        int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 16.0);
	    int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
   
/*================================================================================================================*/
// ************************************* SET UP PLAYER STARTING LOCATIONS: ************************************** //  
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichVariation == 1 )
	{	
		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.50);
		rmPlacePlayersLine(0.60, 0.10, 0.40, 0.10, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.50);
		rmPlacePlayersLine(0.60, 0.90, 0.40, 0.90, 0, 0.0);
	}
        else
    {
	    rmSetPlacementTeam(0);
        rmSetTeamSpacingModifier(0.50);
		rmPlacePlayersLine(0.60, 0.90, 0.40, 0.90, 0, 0.0);

        rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.50);
		rmPlacePlayersLine(0.60, 0.10, 0.40, 0.10, 0, 0.0);
	}	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ******************************************* SET UP PLAYER AREAS: ********************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(1000);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
		
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
        
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint);
		rmAddAreaConstraint(id, avoidWater8);
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 0.9);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
				
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");
   }
        // BUILD THE AREAS:
		rmBuildAllAreas();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ********************* INVISIBLE CONTINENT ADDED TO HAVE BIG CONTINENT AVOID PLAYER AREAS: ******************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int invisContinentID=rmCreateArea("invisible continent for constraint");
	    rmSetAreaSize(invisContinentID, 0.05, 0.05);
        rmSetAreaWarnFailure(invisContinentID, false);
		
		rmSetAreaLocation(invisContinentID, 0.99, 0.5);
		rmAddAreaInfluenceSegment(invisContinentID, 0.95, 0.30, 0.99, 0.5);
		rmAddAreaInfluenceSegment(invisContinentID, 0.99, 0.5, 0.95, 0.70);
		
		rmAddAreaToClass(invisContinentID, rmClassID("classInvis"));
	    rmSetAreaCoherence(invisContinentID, 0.8);
        //rmSetAreaBaseHeight(invisContinentID, 3);
        //rmSetAreaMix(invisContinentID, "carolina_grass");

        // BUILD THE AREAS:
        rmBuildArea(invisContinentID);
		
/*================================================================================================================*/
// ******************************** BUILD UP BIG CONTINENT CALLED "BIG CONTINENT": ****************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

		int bigContinentID = -1;
		bigContinentID=rmCreateArea("big continent");
		rmSetAreaSize(bigContinentID, 0.40, 0.47); // 0.38 0.47
		rmSetAreaWarnFailure(bigContinentID, false);
        rmAddAreaConstraint(bigContinentID, invisConstraint);
		rmAddAreaConstraint(bigContinentID, avoidVeryFarNatives);
        rmAddAreaToClass(bigContinentID, classbigContinent);

        rmSetAreaMinBlobs(bigContinentID, 10);
        rmSetAreaMaxBlobs(bigContinentID, 10);
        rmSetAreaMinBlobDistance(bigContinentID, rmXFractionToMeters(0.1));
        rmSetAreaMaxBlobDistance(bigContinentID, rmXFractionToMeters(0.4));

        rmSetAreaSmoothDistance(bigContinentID, 50);
		rmSetAreaMix(bigContinentID, "greatlakes_grass");
        rmSetAreaElevationType(bigContinentID, cElevTurbulence);
        rmSetAreaElevationVariation(bigContinentID, 4.0);
        rmSetAreaBaseHeight(bigContinentID, 3.5);
        rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
        rmSetAreaElevationOctaves(bigContinentID, 3);
        rmSetAreaElevationPersistence(bigContinentID, 0.2);
		rmSetAreaElevationNoiseBias(bigContinentID, 1);
		
     	rmSetAreaCoherence(bigContinentID, 0.15);
		
        rmSetAreaLocation(bigContinentID, 0.25, 0.5);
		rmAddAreaInfluenceSegment(bigContinentID, 0.5, 0.0, 0.5, 1.0); 
		rmAddAreaInfluenceSegment(bigContinentID, 0.0, 0.5, 0.4, 0.5);

        rmSetAreaEdgeFilling(bigContinentID, 10);
		
        rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);

		rmBuildArea(bigContinentID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE THE TRADE ROUTE AND THE SOCKETS: ***************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // CLEAR OUT CONSTRAINS FOR GOOD MEASURE:
        rmClearClosestPointConstraints();
   
/*----------------------------------------------------------------------------------------------------------------*/   

	    // SOCKET DEFINITION:
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 1:
		int tradeRoute1ID = rmCreateTradeRoute();
	    
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.25, 0.85);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.15, 0.75);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.10, 0.60);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.10, 0.40);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.15, 0.25);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.25, 0.15);
	    

	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.35);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.65);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.95);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// *********************************** DEFINE THE PLAYER STARTING RESOURCES: ************************************ //
/*================================================================================================================*/

	    // PLACE TC OR CW NOW: FIND LOCATION LATER TO PLACE OTHER RESOURCES:

	    // DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if ( rmGetNomadStart())
		rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	    else
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);
	    rmAddObjectDefConstraint(TCID, avoidTradeRoute);
        rmAddObjectDefConstraint(TCID, TCvsTC);
        rmAddObjectDefConstraint(TCID, CWvsCW);
        rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	    
		for(i=1; <cNumberPlayers)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

	}

	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 6.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
        rmAddObjectDefConstraint(startingUnits, shortAvoidImpassableLand);
   
/*----------------------------------------------------------------------------------------------------------------*/   

	    // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(playerSilverID, 18.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 22.0);
	    rmAddObjectDefConstraint(playerSilverID, avoidAll);
        rmAddObjectDefConstraint(playerSilverID, shortAvoidImpassableLand);

	    // DEFINE THE PLAYER CRATE:
		int playerCrateID=rmCreateObjectDef("bonus starting crates");
        rmAddObjectDefItem(playerCrateID, "crateOfFood", rmRandInt(2,3), 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfWood", rmRandInt(1,3), 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 4.0);
        rmSetObjectDefMinDistance(playerCrateID, 6);
        rmSetObjectDefMaxDistance(playerCrateID, 10);
	    rmAddObjectDefConstraint(playerCrateID, avoidAll);
        rmAddObjectDefConstraint(playerCrateID, shortAvoidImpassableLand);

	    // DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(2,3), 2.0);
        rmSetObjectDefMinDistance(playerBerryID, 10);
        rmSetObjectDefMaxDistance(playerBerryID, 15);
	    rmAddObjectDefConstraint(playerBerryID, avoidAll);
        rmAddObjectDefConstraint(playerBerryID, shortAvoidImpassableLand);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeGreatLakes", 1, 0.0);
        rmSetObjectDefMinDistance(playerTreeID, 8);
        rmSetObjectDefMaxDistance(playerTreeID, 12);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, shortAvoidImpassableLand);

	    // DEFINE THE WATER FLAG:
		int waterFlagID=rmCreateObjectDef("HC water flag "+i);
	    rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        rmAddClosestPointConstraint(flagEdgeConstraint);
	    rmAddClosestPointConstraint(flagVsFlag);
	    rmAddClosestPointConstraint(bigContinentConstraint);
	    rmAddClosestPointConstraint(fishLand);
	 
        // NUGGETS PER PLAYER:
	    int nugget1= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget1, avoidNugget);
  	    rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget1, avoidAll);
	    rmSetObjectDefMinDistance(nugget1, 25.0);
	    rmSetObjectDefMaxDistance(nugget1, 35.0);

        // DEFINE THE FOOD:	
        // DEFINE THE NEAR DEER:
		int nearDeerID=rmCreateObjectDef("deer herds near town");
        rmAddObjectDefItem(nearDeerID, "deer", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(nearDeerID, 25);
        rmSetObjectDefMaxDistance(nearDeerID, 35);
        rmAddObjectDefConstraint(nearDeerID, avoidDeer);
	    rmAddObjectDefConstraint(nearDeerID, avoidAll);
        rmAddObjectDefConstraint(nearDeerID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(nearDeerID, true);
	    
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVE AMERICANS: ************************************ //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("Iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.25, 0.35);
	} 
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("cherokee"))
	{  
		int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.40, 0.50);
	} 

/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("Iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.25, 0.65);
	} 

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("cherokee"))
	{  
		int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.60, 0.50);
	} 
	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE FAR SILVER MINES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
                
		// THE EASTERN GOLD OR SILVER MINES:
		int silverwestID = rmCreateObjectDef("The Western Coin Mines");
	    rmAddObjectDefItem(silverwestID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverwestID, 0.0);
        rmSetObjectDefMaxDistance(silverwestID, 0.0);
	 	
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.5, 0.5 );
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.3, 0.5 );
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.4, 0.6 );
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.4, 0.4 );
		
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.35, 0.75 );
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.55, 0.75 );
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.35, 0.25 );
		rmPlaceObjectDefAtLoc(silverwestID, 0, 0.55, 0.25 );
		
/*================================================================================================================*/
// *************************************DEFINE AND PLACE THE BERRYBUSH: ***************************************** //
/*================================================================================================================*/

        // THE NORTHERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Berries");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, 0.0);
		rmSetObjectDefCreateHerd(BerriesID, true);
		
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.25, 0.70 );
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.25, 0.60 );
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.25, 0.40 );
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.25, 0.30 );
		
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.40, 0.75 );
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.50, 0.75 );
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.40, 0.25 );
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.50, 0.25 );
		
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //		
/*================================================================================================================*/
		
        // THE NUGGET EASY:
		int nuggetnorthID= rmCreateObjectDef("The Nugget Easy"); 
	    rmAddObjectDefItem(nuggetnorthID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggetnorthID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetnorthID, 0.0);
  	    
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.20, 0.65 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.20, 0.35 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.30, 0.65 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.30, 0.35 );
		
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.35, 0.80 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.55, 0.80 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.35, 0.20 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.55, 0.20 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.35, 0.70 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.55, 0.70 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.35, 0.30 );
		rmPlaceObjectDefAtLoc(nuggetnorthID, 0, 0.55, 0.30 );
		
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE DEER HERDS: ************************************** //
/*================================================================================================================*/

        int deerID=rmCreateObjectDef("The Deer Herd 0");
	    
		int bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(deerID, "deer", rmRandInt(4,6), 10.0);
	    else
		rmAddObjectDefItem(deerID, "deer", rmRandInt(8,10), 10.0);
	    
		rmSetObjectDefMinDistance(deerID, 0.0);
	    rmSetObjectDefMaxDistance(deerID, 0.0);
	    
		rmSetObjectDefCreateHerd(deerID, true);
	    
		rmPlaceObjectDefAtLoc(deerID, 0, 0.30, 0.75);
		rmPlaceObjectDefAtLoc(deerID, 0, 0.60, 0.75);
		rmPlaceObjectDefAtLoc(deerID, 0, 0.30, 0.25);
		rmPlaceObjectDefAtLoc(deerID, 0, 0.60, 0.25);
		
		rmPlaceObjectDefAtLoc(deerID, 0, 0.20, 0.50);
		rmPlaceObjectDefAtLoc(deerID, 0, 0.45, 0.65);
		rmPlaceObjectDefAtLoc(deerID, 0, 0.45, 0.35);
		
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SHEEP HERDS: **************************************** //
/*================================================================================================================*/

        int sheep1ID=rmCreateObjectDef("The Sheep herds 1");
			    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(2,3), 4.0);
	    else
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(4,6), 6.0);
	    
		rmSetObjectDefMinDistance(sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep1ID, 0.0);
	    rmSetObjectDefCreateHerd(sheep1ID, true);
		
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.35, 0.60);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.55, 0.60);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.35, 0.40);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.55, 0.40);
		
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.30, 0.10);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.50, 0.10);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.30, 0.90);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.50, 0.90);
			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************** CREATE AN ISLAND WITH CRATES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE FISHES AND THE WHALES: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
        // THE SARDINES:
		int fishID=rmCreateObjectDef("sardine");
        rmAddObjectDefItem(fishID, "FishSardine", 1, 0.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
        
        // THE TARPON:
		int fish2ID=rmCreateObjectDef("salmon");
        rmAddObjectDefItem(fish2ID, "FishSalmon", 1, 0.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFishID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
        
	    // THE HUMPBACKWHALE:
		int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "humpbackWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** PLACE PLAYER STARTING RESOURCES: ************************************** //   
/*================================================================================================================*/
 
	    for(i=1; <cNumberPlayers)
	{
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		if (rmGetNomadStart() == false)
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
				
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(nearDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	}

	    rmClearClosestPointConstraints();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE EXTRA NUGGETS NOT PER PLAYER: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ******************************************** DEFINE THE FORESTS: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int forestTreeID = 0;
		
		if (cNumberNonGaiaPlayers<=2)
		int numTries=12*cNumberNonGaiaPlayers;
		else
		numTries=6*cNumberNonGaiaPlayers;
        
		int failCount=0;
        for (i=0; <numTries)
    {   
        int forest=rmCreateArea("forest "+i, rmAreaID("big continent"));
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(200), rmAreaTilesToFraction(500));
        rmSetAreaForestType(forest, "great lakes forest");
        rmSetAreaForestDensity(forest, 0.8);
        rmSetAreaForestClumpiness(forest, 0.6);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 5);
        rmSetAreaMinBlobDistance(forest, 16.0);
        rmSetAreaMaxBlobDistance(forest, 70.0);
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 0);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidWater8);
		rmAddAreaConstraint(forest, avoidCloseNatives);
		rmAddAreaConstraint(forest, playerConstraint);
		rmAddAreaConstraint(forest, playerEdgeConstraint);
		rmAddAreaConstraint(forest, avoidFastCoin);
		rmAddAreaConstraint(forest, avoidFruits);
		rmAddAreaConstraint(forest, avoidNugget);
        rmAddAreaConstraint(forest, forestvsTC);
        rmAddAreaConstraint(forest, forestvsCW); 
        rmAddAreaConstraint(forest, longAvoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidTradeRoute);

        if(rmBuildArea(forest)==false)
    {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
    }
        else
        failCount=0; 
} 

/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE 4 ISLANDS:
		int randomTreeID=rmCreateObjectDef("North Random Trees");
		rmAddObjectDefItem(randomTreeID, "TreeGreatLakes", 1, 0.0);
		
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint);
		rmAddObjectDefConstraint(randomTreeID, forestConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidWater8);
		rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomTreeID, playerConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFastCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 60*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);	
  
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/			























