/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/

// ANALYZED BY DANY:
// AUGUST 2007:
// TEXAS LARGE
// OCTOBER 2003:
// A RANDOM MAP FOR AGE OF EMPIRES III: MY 63TH RMS:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		int subCiv4=-1;
		int subCiv5=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/
// **************************************** DEFINE THE 10 VARIATIONS: ******************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE WHICHVARIATION:
		// ONLY 2 VARIATIONS:
		int whichVariation=rmRandInt(1,2);
		
/*----------------------------------------------------------------------------------------------------------------*/
	
        // DEFINITION OF THE NATIVE CHOOSER:
		float nativeChooser = rmRandFloat(0,1);	
		
/*----------------------------------------------------------------------------------------------------------------*/
  
        if (rmAllocateSubCivs(6) == true)
		
{
   
		// IROQUOIS OR LAKOTA:
		
	    if (nativeChooser <= 0.5)
	{
		subCiv0=rmGetCivID("Iroquois");
		if (subCiv0 >= 0)
		rmSetSubCiv(0, "Iroquois", true);
	}
	    else
	{
		subCiv0=rmGetCivID("Lakota");
		if (subCiv0 >= 0)
		rmSetSubCiv(0, "Lakota", true);
	}
			
			
         // THESE 2 NATIVES TRIBES REMAIN THE SAME:			 
		
		subCiv1=rmGetCivID("Iroquois");
		if (subCiv1 >= 0)
		rmSetSubCiv(1, "Iroquois");
			
		subCiv2=rmGetCivID("Iroquois");
		if (subCiv2 >= 0)
		rmSetSubCiv(2, "Iroquois");
		
		
	  
		// IROQUOIS OR LAKOTA:
		
		if (nativeChooser <= 0.5)
	{
		subCiv3=rmGetCivID("Iroquois");
		if (subCiv3 >= 0)
		rmSetSubCiv(3, "Iroquois");
	}
		else
	{
		subCiv3=rmGetCivID("Lakota");
		if (subCiv3 >= 0)
		rmSetSubCiv(3, "Lakota");
	}
	
	// THESE 2 NATIVES TRIBES REMAIN THE SAME:			 
		
		subCiv4=rmGetCivID("Iroquois");
		if (subCiv4 >= 0)
		rmSetSubCiv(4, "Iroquois");
			
		subCiv5=rmGetCivID("Iroquois");
		if (subCiv5 >= 0)
		rmSetSubCiv(5, "Iroquois");
		
	 
}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // PICKS THE MAP SIZE:
	    int playerTiles=17500;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(530, 530);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // REMOVED BY ENSEMBLE:
		// rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	
	    // SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
	
	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(6.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
   
	    // CHOOSE SUMMER OR WINTER: 
	    float seasonPicker = rmRandFloat(0,1);//rmRandFloat(0,1); //high # is snow, low is spring
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // LIGHT SET:

	    if (seasonPicker < 0.5)
		rmSetLightingSet("Great Lakes");
	    else
		rmSetLightingSet("Great Lakes Winter");
		
/*----------------------------------------------------------------------------------------------------------------*/		

		// THE SEASON PICKER:
		if (seasonPicker < 0.5)
		
	{
	
		// SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.05, 6, 0.7, 8.0);
		
		// SET SEA TYPE:
		rmSetSeaType("great lakes");
		
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
		
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("greatlakes_grass");
		
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("great_lakes\ground_grass1_gl", 1.0);
		
		// SET MAP TYPE:
		rmSetMapType("greatlakes");
		rmSetMapType("grass");
		rmSetMapType("water");
		
	}
	    else
		
	{
	    
		// SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.02, 4, 0.7, 8.0);
		
		// SET SEA TYPE:
		rmSetSeaType("great lakes");
		
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
		
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("greatlakes_snow");
		
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("great_lakes\ground_ice1_gl", 1.0);
		
		// SET MAP TYPE:
		rmSetMapType("greatlakes");
		rmSetMapType("snow");
		rmSetMapType("water");
		
		// SET GLOBAL SNOW:
		rmSetGlobalSnow( 1.0 );
		
	}
	
/*----------------------------------------------------------------------------------------------------------------*/	

	    // CHOOSE THE MERCS:
		chooseMercs();

	    // CORNER CONSTRAINT:
	    rmSetWorldCircleConstraint(true);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classHill");
        rmDefineClass("classPatch");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("secrets");
	    rmDefineClass("nuggets");
	    rmDefineClass("center");
	    rmDefineClass("classCotton");
		int classGreatLake=rmDefineClass("great lake");

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
	    int bisonEdgeConstraint=rmCreateBoxConstraint("bison edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
        int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  //DAL - was 24
	    // int goldCenterConstraint=rmCreateBoxConstraint("gold keeps away from middle", 0.2, 0.2, 0.8, 0.8, 0.01);
	    int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 30.0);
	    int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), 60.0);

        // CARDINAL DIRECTIONS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

        // PLAYER CONSTRAINTS:
        int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 20.0);
	    int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium vs players", classPlayer, 25.0);
		int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
        
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);

	    // NATURE AVOIDANCE:
	    // int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
	    // int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
	    
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
		int forestAvoidDeer=rmCreateTypeDistanceConstraint("forest vs deer", "all", 8.0);
		int forestAvoidBison=rmCreateTypeDistanceConstraint("forest vs bison", "all", 8.0);
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 30.0);
		int closeForestConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 6.0);
		
		// TREES 1 AVOIDANCE:
	    int avoidTrees1=rmCreateTypeDistanceConstraint("avoid trees1", "TreeGreatLakes", 10.0);
	    int avoidCloseTrees1=rmCreateTypeDistanceConstraint("short avoid trees1", "TreeGreatLakes", 2.0);

        // TREES 2 AVOIDANCE:
	    int avoidTrees2=rmCreateTypeDistanceConstraint("avoid trees2", "TreeGreatLakesSnow", 10.0);
	    int avoidCloseTrees2=rmCreateTypeDistanceConstraint("short avoid trees2", "TreeGreatLakesSnow", 2.0);
				    
		// RESOURCE AVOIDANCE:
		int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
		int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 5.0);
   	    
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// TURKEYS AVOIDANCE:
		int avoidTurkeys=rmCreateTypeDistanceConstraint("stuffs avoids turkeys", "turkey", 10.0);
		int avoidCloseTurkeys=rmCreateTypeDistanceConstraint("close avoids turkeys", "turkey", 2.0);
						
		// SILVER AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "mine", 10.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "mine", 2.0);

	    // COIN CONSTRAINT DROPS ON SMALLER MAPS:
	    int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "mine", 35.0);
	    if ( cNumberNonGaiaPlayers < 4 )
	{
		coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin small maps", "gold", 25.0);
	}

	    // COTTON AVOIDANCE:
	    int cottonConstraint=rmCreateClassDistanceConstraint("cotton constraint", rmClassID("classCotton"), 30.0);
	       
        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 3.0);
        int avoidFarImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
        
		// HILL AVOIDANCE:
		int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 10.0);
        int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
        int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	    
		// CLIFFS AVOIDANCE:
		int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 14.0);
		int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 4.0);
	    int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);

        // STARTING UNITS AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
        int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
        int avoidFarStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units large", rmClassID("startingUnit"), 50.0);
        
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close vs important item", rmClassID("importantItem"), 5.0);
        int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 10.0);
        
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 30.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 6.0);
	    
	    int avoidSecrets=rmCreateClassDistanceConstraint("stuff avoids secrets", rmClassID("secrets"), 20.0);
	    
		int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 15.0);
		int avoidCloseNugget=rmCreateClassDistanceConstraint("close avoids nuggets", rmClassID("nuggets"), 5.0);
		int avoidFarNugget=rmCreateClassDistanceConstraint("far avoids nuggets", rmClassID("nuggets"), 35.0);
	    
		
		int forestsAvoidBison=rmCreateTypeDistanceConstraint("forest avoids bison", "bison", 20.0);
		
		// COWS AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
		
		// SHEEPS AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 2.0);
			
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// CARIBOU AVOIDANCE:
		int avoidCaribou=rmCreateTypeDistanceConstraint("stuff avoids caribou", "caribou", 10.0);
		int avoidCloseCaribou=rmCreateTypeDistanceConstraint("close avoids caribou", "caribou", 2.0);
		
		// BISON AVOIDANCE:
		int avoidBison=rmCreateTypeDistanceConstraint("stuff avoids bison", "bison", 10.0);
		int avoidCloseBison=rmCreateTypeDistanceConstraint("close avoids bison", "bison", 2.0);
		
		// ELK AVOIDANCE:
	    int avoidElk=rmCreateTypeDistanceConstraint("stuff avoids elk", "elk", 15.0);
	    int elkAvoidElk=rmCreateTypeDistanceConstraint("elk avoids elk", "elk", 40.0);
	    int avoidCloseElk=rmCreateTypeDistanceConstraint("close avoids elk", "sheep", 5.0);
		
		// MOOSE AVOIDANCE:
		int mooseConstraint=rmCreateTypeDistanceConstraint("avoid the moose", "moose", 35.0);
		int avoiMoose=rmCreateTypeDistanceConstraint("stuff avoids moose", "moose", 15.0);
	    int mooseAvoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "moose", 40.0);
	    int avoidCloseMoose=rmCreateTypeDistanceConstraint("close avoids moose", "moose", 5.0);
		int avoidFarMoose=rmCreateTypeDistanceConstraint("far avoids moose", "moose", 60.0);
	
	    // DECORATION AVOIDANCE:
	    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	    // TRADE ROUTE AVOIDANCE:
	    int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 3.0);
	    int avoidTradeRouteCliff = rmCreateTradeRouteDistanceConstraint("trade route cliff", 10.0);
	    int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
		
		// Lake Constraints
	    int greatLakesConstraint=rmCreateClassDistanceConstraint("avoid the great lakes", classGreatLake, 8.0);
	    int closeGreatLakesConstraint=rmCreateClassDistanceConstraint("close vs the great lakes", classGreatLake, 5.0);
	   	int farGreatLakesConstraint=rmCreateClassDistanceConstraint("far avoid the great lakes", classGreatLake, 20.0);

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
        
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// *********************************** DEFINE THE SET UP STARTING LOCATIONS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if ( whichVariation == 1 )
							
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.75,0.75);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.25,0.25);
	}  
		else
    {		
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.25,0.25);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.75,0.75);
	} 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// *************************************** DEFINE THE SET UP PLAYER AREAS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        float playerFraction=rmAreaTilesToFraction(100);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "texas\ground2");
      
	    // SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
   
        // Build the areas.
        rmBuildAllAreas();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// **************************** DEFINE AND PLACE THE WEST CLIFF AND THE EAST CLIFT: ***************************** //        
/*================================================================================================================*/
	
		// THE WEST CLIFF:
		int cliffWestID=rmCreateArea("The West Cliff");
        rmSetAreaSize(cliffWestID, rmAreaTilesToFraction(725), rmAreaTilesToFraction(725));
        rmSetAreaWarnFailure(cliffWestID, false);
		
		if (seasonPicker < 0.5)
	    rmSetAreaCliffType(cliffWestID, "New England Inland Grass");
		else
		rmSetAreaCliffType(cliffWestID, "rocky mountain edge");
		
	    // rmSetAreaCliffEdge(cliffWestID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliffWestID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffWestID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffWestID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffWestID, 1);
        rmAddAreaToClass(cliffWestID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffWestID, avoidCliffs);
	    rmSetAreaMinBlobs(cliffWestID, 1);
        rmSetAreaMaxBlobs(cliffWestID, 1);
        rmSetAreaMinBlobDistance(cliffWestID, 1);
        rmSetAreaMaxBlobDistance(cliffWestID, 1);
        rmSetAreaSmoothDistance(cliffWestID, 10);
        rmSetAreaCoherence(cliffWestID, 0.95);
		rmSetAreaLocation(cliffWestID, 0.375, 0.625);
		rmBuildArea(cliffWestID);

/*----------------------------------------------------------------------------------------------------------------*/
		
		// THE EAST CLIFF:
		int cliffEastID=rmCreateArea("The East Cliff");
        rmSetAreaSize(cliffEastID, rmAreaTilesToFraction(725), rmAreaTilesToFraction(725));
        rmSetAreaWarnFailure(cliffEastID, false);
		
		if (seasonPicker < 0.5)
		rmSetAreaCliffType(cliffEastID, "New England Inland Grass");
		else
		rmSetAreaCliffType(cliffEastID, "rocky mountain edge");
		
	    // rmSetAreaCliffEdge(cliffEastID, 2, 0.4, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliffEastID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffEastID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffEastID, 6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffEastID, 1);
        rmAddAreaToClass(cliffEastID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffEastID, avoidCliffs);
	    rmSetAreaMinBlobs(cliffEastID, 1);
        rmSetAreaMaxBlobs(cliffEastID, 1);
        rmSetAreaMinBlobDistance(cliffEastID, 1);
        rmSetAreaMaxBlobDistance(cliffEastID, 1);
        rmSetAreaSmoothDistance(cliffEastID, 10);
        rmSetAreaCoherence(cliffEastID, 0.95);
		rmSetAreaLocation(cliffEastID, 0.625, 0.375);
		rmBuildArea(cliffEastID);

/*----------------------------------------------------------------------------------------------------------------*/   
// *************************************** DEFINE THE PLACEMENT ORDER: ****************************************** //   
/*================================================================================================================*/   
 	
	    // Placement order
	    // Trade Route -> Players and player stuff -> Natives -> Secrets -> Cliffs -> Nuggets
	    // Place other objects that were defined earlier
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************** //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
           
		int tradeRouteID = rmCreateTradeRoute();
		
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.005, 0.50);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.25, 0.75);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.50);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.75, 0.25);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.995, 0.50);
	
	    bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
	    rmEchoError("Failed to place trade route #1");
		
/*----------------------------------------------------------------------------------------------------------------*/		
// ************************************ DEFINE THE TRADE ROUTE SOCKETS: ***************************************** //
/*----------------------------------------------------------------------------------------------------------------*/        
		// DEFINE THE TRADE SOCKETS:
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 6.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** ADD THE MEETING POLES ALONG THE TRADE ROUTE: ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.025);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.25);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.75);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   
        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.975);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   
        rmClearClosestPointConstraints();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ***************************** DEFINE THE STARTING UNITS AND TCID AND RESOURCES: ****************************** //
/*================================================================================================================*/
        
		// DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if (rmGetNomadStart())
		{
			rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 5.0);
		}
		else
		{
            rmAddObjectDefItem(startingTCID, "townCenter", 1, 5.0);
		}
	    rmAddObjectDefConstraint(startingTCID, avoidImpassableLand);
	    rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
	    rmAddObjectDefToClass(startingTCID, rmClassID("player"));

	
	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 15.0);
	    rmSetObjectDefMaxDistance(startingUnits, 20.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    
		if (seasonPicker < 0.5)
		rmAddObjectDefItem(StartAreaTreeID, "TreeGreatLakes", rmRandInt(3,5), 10.0);
	    else
		rmAddObjectDefItem(StartAreaTreeID, "TreeGreatLakesSnow", rmRandInt(3,5), 10.0);
	    
		rmSetObjectDefMinDistance(StartAreaTreeID, 15);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 25);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseStartingUnits);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING FOOD 1:
		int StartElkID=rmCreateObjectDef("starting moose");
	    
		if (seasonPicker < 0.5)
		rmAddObjectDefItem(StartElkID, "berrybush", rmRandInt(5,7), 6.0);
	    else
	{
		rmAddObjectDefItem(StartElkID, "moose",  rmRandInt(5,7), 6.0);
		rmSetObjectDefCreateHerd(StartElkID, true);
	}
	    rmSetObjectDefCreateHerd(StartElkID, true);
	    rmSetObjectDefMinDistance(StartElkID, 15);
	    rmSetObjectDefMaxDistance(StartElkID, 20);
	    rmAddObjectDefConstraint(StartElkID, avoidStartResource);
		rmAddObjectDefConstraint(StartElkID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(StartElkID, avoidNatives);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE STARTING FOOD 2:
		int StartElk2ID=rmCreateObjectDef("starting deer");
	    
		if (seasonPicker < 0.5)
		rmAddObjectDefItem(StartElk2ID, "deer", rmRandInt(7,12), 12.0);
	    else
	{
		rmAddObjectDefItem(StartElk2ID, "caribou", rmRandInt(7,12), 12.0);
		rmSetObjectDefCreateHerd(StartElk2ID, true);
	}
	    rmSetObjectDefCreateHerd(StartElk2ID, true);
	    rmSetObjectDefMinDistance(StartElk2ID, 25);
	    rmSetObjectDefMaxDistance(StartElk2ID, 35);
	    rmAddObjectDefConstraint(StartElk2ID, avoidStartResource);
		rmAddObjectDefConstraint(StartElk2ID, avoidCloseImpassableLand);
	    rmAddObjectDefConstraint(StartElk2ID, avoidNatives);		
	    
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING SILVER:
		int startSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(startSilverID, "mine", 1, 5.0);
	    rmAddObjectDefConstraint(startSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(startSilverID, 12.0);
	    rmSetObjectDefMaxDistance(startSilverID, 18.0);
	    rmAddObjectDefConstraint(startSilverID, avoidStartResource);
	    rmAddObjectDefConstraint(startSilverID, avoidImpassableLand);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE STARTING SILVER:
		int startFarSilverID = rmCreateObjectDef("player far silver");
	    rmAddObjectDefItem(startFarSilverID, "mine", 1, 5.0);
	    rmAddObjectDefConstraint(startFarSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(startFarSilverID, 25.0);
	    rmSetObjectDefMaxDistance(startFarSilverID, 30.0);
	    rmAddObjectDefConstraint(startFarSilverID, avoidStartResource);
	    rmAddObjectDefConstraint(startFarSilverID, avoidImpassableLand);

/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 25.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerNuggetID, avoidStartResource);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
		rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
		
/*================================================================================================================*/
// ****************************** PLACE THE STARTING UNITS AND TCID AND RESOURCES: ****************************** //
/*================================================================================================================*/		

	     for(i=1; <cNumberPlayers)
		 
	{
						
		// TEST OF MARCIN'S STARTING UNITS STUFF:
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING ELK:
		rmPlaceObjectDefAtLoc(StartElkID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartElk2ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING SILVER:
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startFarSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
	}
   
        // CLEAR OUT CONSTRAINTS FOR GOOD MEASURE:
        rmClearClosestPointConstraints();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/   
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	    
		// VARIABLES NEEDED LATER:
		// TEXT:
	    int numTries = -1;
	    int failCount = -1;
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE LAKE 1: ***************************************** //
/*================================================================================================================*/

        // DEFINE AND PLACE THE ICE LAKE:
		// PLACE ICE SHEET IF WINTER:

        if (seasonPicker >= 0.5)
		
   {
   
	    int IceArea1ID=rmCreateArea("Ice Area 1");
	    rmSetAreaSize(IceArea1ID, 0.015, 0.015);
	    rmSetAreaLocation(IceArea1ID, 0.525, 0.725);
	    //rmSetAreaTerrainType(IceArea1ID, "great_lakes\ground_ice1_gl");
	    rmSetAreaMix(IceArea1ID, "great_lakes_ice");
	    rmAddAreaToClass(IceArea1ID, classGreatLake);
	    rmSetAreaBaseHeight(IceArea1ID, 0.0);
		//rmAddAreaInfluencePoint(IceArea1ID, 0.55, 0.5);
		rmSetAreaObeyWorldCircleConstraint(IceArea1ID, false);
	    rmSetAreaMinBlobs(IceArea1ID, 1);
	    rmSetAreaMaxBlobs(IceArea1ID, 1);
	    rmSetAreaMinBlobDistance(IceArea1ID, 1);
	    rmSetAreaMaxBlobDistance(IceArea1ID, 1);
	    rmSetAreaSmoothDistance(IceArea1ID, 8);
	    rmSetAreaCoherence(IceArea1ID, 1.0);
	    rmBuildArea(IceArea1ID); 
		
   }
   
/*----------------------------------------------------------------------------------------------------------------*/   

        // DEFINE AND PLACE THE SPRING/FROZEN LAKE:
		int michiganID=rmCreateArea("Lake Michigan 1");
        
	    if (seasonPicker < 0.5)
		
	{
	    rmSetAreaWaterType(michiganID, "great lakes");
	    rmSetAreaSize(michiganID, 0.02, 0.02);
		
		if (cNumberNonGaiaPlayers >= 4)
			rmSetAreaCoherence(michiganID, 1.0);
		else
			rmSetAreaCoherence(michiganID, 1.0);
	    
		rmSetAreaLocation(michiganID, 0.525, 0.725);
	    //rmAddAreaInfluencePoint(michiganID, 0.55, 0.48);
	}
	    else
	{
	    rmSetAreaSize(michiganID, 0.02, 0.02);
	    rmSetAreaWaterType(michiganID, "great lakes ice");
	    rmSetAreaCoherence(michiganID, 1.0);
	    rmSetAreaLocation(michiganID, 0.525, 0.725);
	}
	    rmAddAreaToClass(michiganID, classGreatLake);
	    rmSetAreaBaseHeight(michiganID, 0.0);
	    rmSetAreaObeyWorldCircleConstraint(michiganID, false);
	    rmSetAreaMinBlobs(michiganID, 1);
	    rmSetAreaMaxBlobs(michiganID, 1);
	    rmSetAreaMinBlobDistance(michiganID, 1);
	    rmSetAreaMaxBlobDistance(michiganID, 1);
	    rmSetAreaSmoothDistance(michiganID, 0);
	    rmBuildArea(michiganID); 
		
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE LAKE 2: ***************************************** //
/*================================================================================================================*/

        // DEFINE AND PLACE THE ICE LAKE:
		// PLACE ICE SHEET IF WINTER:

        if (seasonPicker >= 0.5)
		
   {
   
	    int IceArea2ID=rmCreateArea("Ice Area 2");
	    rmSetAreaSize(IceArea2ID, 0.02, 0.02);
	    rmSetAreaLocation(IceArea2ID, 0.725, 0.525);
	    //rmSetAreaTerrainType(IceArea2ID, "great_lakes\ground_ice1_gl");
	    rmSetAreaMix(IceArea2ID, "great_lakes_ice");
	    rmAddAreaToClass(IceArea2ID, classGreatLake);
	    rmSetAreaBaseHeight(IceArea2ID, 0.0);
		//rmAddAreaInfluencePoint(IceArea2ID, 0.55, 0.5);
		rmSetAreaObeyWorldCircleConstraint(IceArea2ID, false);
	    rmSetAreaMinBlobs(IceArea2ID, 1);
	    rmSetAreaMaxBlobs(IceArea2ID, 1);
	    rmSetAreaMinBlobDistance(IceArea2ID, 1);
	    rmSetAreaMaxBlobDistance(IceArea2ID, 1);
	    rmSetAreaSmoothDistance(IceArea2ID, 8);
	    rmSetAreaCoherence(IceArea2ID, 1.0);
	    rmBuildArea(IceArea2ID); 
		
   }
   
/*----------------------------------------------------------------------------------------------------------------*/   

        // DEFINE AND PLACE THE SPRING/FROZEN LAKE:
		int michigan2ID=rmCreateArea("Lake Michigan 2");
        
	    if (seasonPicker < 0.5)
		
	{
	    rmSetAreaWaterType(michigan2ID, "great lakes");
	    rmSetAreaSize(michigan2ID, 0.02, 0.02);
		
		if (cNumberNonGaiaPlayers >= 4)
			rmSetAreaCoherence(michigan2ID, 1.0);
		else
			rmSetAreaCoherence(michigan2ID, 1.0);
	    
		rmSetAreaLocation(michigan2ID, 0.725, 0.525);
	    //rmAddAreaInfluencePoint(michigan2ID, 0.55, 0.48);
	}
	    else
	{
	    rmSetAreaSize(michigan2ID, 0.02, 0.02);
	    rmSetAreaWaterType(michigan2ID, "great lakes ice");
	    rmSetAreaCoherence(michigan2ID, 1.0);
	    rmSetAreaLocation(michigan2ID, 0.725, 0.525);
	}
	    rmAddAreaToClass(michigan2ID, classGreatLake);
	    rmSetAreaBaseHeight(michigan2ID, 0.0);
	    rmSetAreaObeyWorldCircleConstraint(michigan2ID, false);
	    rmSetAreaMinBlobs(michigan2ID, 1);
	    rmSetAreaMaxBlobs(michigan2ID, 1);
	    rmSetAreaMinBlobDistance(michigan2ID, 1);
	    rmSetAreaMaxBlobDistance(michigan2ID, 1);
	    rmSetAreaSmoothDistance(michigan2ID, 0);
	    rmBuildArea(michigan2ID); 

/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE LAKE 3: ***************************************** //
/*================================================================================================================*/

        // DEFINE AND PLACE THE ICE LAKE:
		// PLACE ICE SHEET IF WINTER:

        if (seasonPicker >= 0.5)
		
   {
   
	    int IceArea3ID=rmCreateArea("Ice Area 3");
	    rmSetAreaSize(IceArea3ID, 0.02, 0.02);
	    rmSetAreaLocation(IceArea3ID, 0.275, 0.475);
	    //rmSetAreaTerrainType(IceArea3ID, "great_lakes\ground_ice1_gl");
	    rmSetAreaMix(IceArea3ID, "great_lakes_ice");
	    rmAddAreaToClass(IceArea3ID, classGreatLake);
	    rmSetAreaBaseHeight(IceArea3ID, 0.0);
		//rmAddAreaInfluencePoint(IceArea3ID, 0.55, 0.5);
		rmSetAreaObeyWorldCircleConstraint(IceArea3ID, false);
	    rmSetAreaMinBlobs(IceArea3ID, 1);
	    rmSetAreaMaxBlobs(IceArea3ID, 1);
	    rmSetAreaMinBlobDistance(IceArea3ID, 1);
	    rmSetAreaMaxBlobDistance(IceArea3ID, 1);
	    rmSetAreaSmoothDistance(IceArea3ID, 8);
	    rmSetAreaCoherence(IceArea3ID, 1.0);
	    rmBuildArea(IceArea3ID); 
		
   }
   
/*----------------------------------------------------------------------------------------------------------------*/   

        // DEFINE AND PLACE THE SPRING/FROZEN LAKE:
		int michigan3ID=rmCreateArea("Lake Michigan 3");
        
	    if (seasonPicker < 0.5)
		
	{
	    rmSetAreaWaterType(michigan3ID, "great lakes");
	    rmSetAreaSize(michigan3ID, 0.02, 0.02);
		
		if (cNumberNonGaiaPlayers >= 4)
			rmSetAreaCoherence(michigan3ID, 1.0);
		else
			rmSetAreaCoherence(michigan3ID, 1.0);
	    
		rmSetAreaLocation(michigan3ID, 0.275, 0.475);
	    //rmAddAreaInfluencePoint(michigan3ID, 0.55, 0.48);
	}
	    else
	{
	    rmSetAreaSize(michigan3ID, 0.02, 0.02);
	    rmSetAreaWaterType(michigan3ID, "great lakes ice");
	    rmSetAreaCoherence(michigan3ID, 1.0);
	    rmSetAreaLocation(michigan3ID, 0.275, 0.475);
	}
	    rmAddAreaToClass(michigan3ID, classGreatLake);
	    rmSetAreaBaseHeight(michigan3ID, 0.0);
	    rmSetAreaObeyWorldCircleConstraint(michigan3ID, false);
	    rmSetAreaMinBlobs(michigan3ID, 1);
	    rmSetAreaMaxBlobs(michigan3ID, 1);
	    rmSetAreaMinBlobDistance(michigan3ID, 1);
	    rmSetAreaMaxBlobDistance(michigan3ID, 1);
	    rmSetAreaSmoothDistance(michigan3ID, 0);
	    rmBuildArea(michigan3ID);

/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE LAKE 4: ***************************************** //
/*================================================================================================================*/

        // DEFINE AND PLACE THE ICE LAKE:
		// PLACE ICE SHEET IF WINTER:

        if (seasonPicker >= 0.5)
		
   {
   
	    int IceArea4ID=rmCreateArea("Ice Area 4");
	    rmSetAreaSize(IceArea4ID, 0.02, 0.02);
	    rmSetAreaLocation(IceArea4ID, 0.475, 0.275);
	    //rmSetAreaTerrainType(IceArea4ID, "great_lakes\ground_ice1_gl");
	    rmSetAreaMix(IceArea4ID, "great_lakes_ice");
	    rmAddAreaToClass(IceArea4ID, classGreatLake);
	    rmSetAreaBaseHeight(IceArea4ID, 0.0);
		//rmAddAreaInfluencePoint(IceArea4ID, 0.55, 0.5);
		rmSetAreaObeyWorldCircleConstraint(IceArea4ID, false);
	    rmSetAreaMinBlobs(IceArea4ID, 1);
	    rmSetAreaMaxBlobs(IceArea4ID, 1);
	    rmSetAreaMinBlobDistance(IceArea4ID, 1);
	    rmSetAreaMaxBlobDistance(IceArea4ID, 1);
	    rmSetAreaSmoothDistance(IceArea4ID, 8);
	    rmSetAreaCoherence(IceArea4ID, 1.0);
	    rmBuildArea(IceArea4ID); 
		
   }
   
/*----------------------------------------------------------------------------------------------------------------*/   

        // DEFINE AND PLACE THE SPRING/FROZEN LAKE:
		int michigan4ID=rmCreateArea("Lake Michigan 4");
        
	    if (seasonPicker < 0.5)
		
	{
	    rmSetAreaWaterType(michigan4ID, "great lakes");
	    rmSetAreaSize(michigan4ID, 0.02, 0.02);
		
		if (cNumberNonGaiaPlayers >= 4)
			rmSetAreaCoherence(michigan4ID, 1.0);
		else
			rmSetAreaCoherence(michigan4ID, 1.0);
	    
		rmSetAreaLocation(michigan4ID, 0.475, 0.275);
	    //rmAddAreaInfluencePoint(michigan4ID, 0.55, 0.48);
	}
	    else
	{
	    rmSetAreaSize(michigan4ID, 0.02, 0.02);
	    rmSetAreaWaterType(michigan4ID, "great lakes ice");
	    rmSetAreaCoherence(michigan4ID, 1.0);
	    rmSetAreaLocation(michigan4ID, 0.475, 0.275);
	}
	    rmAddAreaToClass(michigan4ID, classGreatLake);
	    rmSetAreaBaseHeight(michigan4ID, 0.0);
	    rmSetAreaObeyWorldCircleConstraint(michigan4ID, false);
	    rmSetAreaMinBlobs(michigan4ID, 1);
	    rmSetAreaMaxBlobs(michigan4ID, 1);
	    rmSetAreaMinBlobDistance(michigan4ID, 1);
	    rmSetAreaMaxBlobDistance(michigan4ID, 1);
	    rmSetAreaSmoothDistance(michigan4ID, 0);
	    rmBuildArea(michigan4ID); 	 		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// *********************** DEFINE AND PLACE THE NATIVE VILLAGES AND SECRETS OF THE NEW WORLD: ******************* //
/*================================================================================================================*/
	
	    float NativeVillageLoc = rmRandFloat(0,1);
	    float iroquoisVillageLoc = rmRandFloat(0,1);
		
/*===============================================================================================================*/		

	    // IROQUOIS RULES: 
	    if (subCiv0 == rmGetCivID("Iroquois"))
	{  
		int iroquois1VillageID = -1;
		int iroquois1VillageType = rmRandInt(1,5);
		iroquois1VillageID = rmCreateGrouping("iroquois1 village", "native iroquois village "+iroquois1VillageType);
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois1VillageID, greatLakesConstraint);
		//rmAddGroupingConstraint(iroquois1VillageID, nearShore);
		//rmAddGroupingConstraint(iroquois1VillageID, mediumPlayerConstraint);
		//rmAddGroupingConstraint(iroquois1VillageID, avoidTradeRoute);
		//rmAddGroupingConstraint(iroquois1VillageID, avoidTradeSockets);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		//rmAddGroupingToClass(iroquois1VillageID, rmClassID("importantItem"));

		if ( iroquoisVillageLoc < 0.5 )
		{
			rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.125, 0.475);
		}
		else
		{
			rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.125, 0.475);
		}
	}
	    else
	{  
		int lakotaVillageID = -1;
		int lakota1VillageType = rmRandInt(1,5);
		lakotaVillageID = rmCreateGrouping("lakota village", "native lakota village "+lakota1VillageType);
		rmSetGroupingMinDistance(lakotaVillageID, 0.0);
		rmSetGroupingMaxDistance(lakotaVillageID, 0.0);
		//rmAddGroupingConstraint(lakotaVillageID, greatLakesConstraint);
		//rmAddGroupingConstraint(lakotaVillageID, nearShore);
		//rmAddGroupingConstraint(lakotaVillageID, shortAvoidStartingUnits);
		//rmAddGroupingConstraint(lakotaVillageID, avoidTradeRoute);
		//rmAddGroupingConstraint(lakotaVillageID, avoidTradeSockets);
		rmAddGroupingToClass(lakotaVillageID, rmClassID("natives"));
		//rmAddGroupingToClass(lakotaVillageID, rmClassID("importantItem"));

		if ( iroquoisVillageLoc < 0.5 )
		{
			rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.125, 0.475);
		}
		else
		{
			rmPlaceGroupingAtLoc(lakotaVillageID, 0, 0.125, 0.475);
		}
	}

/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv1 == rmGetCivID("Iroquois"))// && cNumberNonGaiaPlayers >= 4)
	
	{
		int iroquois2VillageID = -1;
		int iroquois2VillageType = rmRandInt(1,5);
		iroquois2VillageID = rmCreateGrouping("iroquois2 village", "native iroquois village "+iroquois2VillageType);
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois2VillageID, avoidImpassableLand);
		//rmAddGroupingConstraint(iroquois2VillageID, avoidTradeRoute);
		//rmAddGroupingConstraint(iroquois2VillageID, shortAvoidStartingUnits);
		//rmAddGroupingConstraint(iroquois2VillageID, avoidTradeSockets);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		//rmAddGroupingToClass(iroquois2VillageID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(iroquois2VillageID, avoidImportantItem);
		if (NativeVillageLoc < 0.5)
		{
		  rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.525, 0.875);
		}
		else
		{
		  rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.525, 0.875);
		}
	}
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv2 == rmGetCivID("Iroquois"))// && cNumberNonGaiaPlayers >= 4)
	{
		int iroquois3VillageID = -1;
		int iroquois3VillageType = rmRandInt(1,5);
		iroquois3VillageID = rmCreateGrouping("iroquois3 village", "native iroquois village "+iroquois3VillageType);
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois3VillageID, avoidImpassableLand);
		//rmAddGroupingConstraint(iroquois3VillageID, avoidTradeRoute);
		//rmAddGroupingConstraint(iroquois3VillageID, shortAvoidStartingUnits);
		//rmAddGroupingConstraint(iroquois3VillageID, avoidTradeSockets);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		//rmAddGroupingToClass(iroquois3VillageID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(iroquois3VillageID, avoidImportantItem);
		if (NativeVillageLoc < 0.5)
		{
		  rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.475, 0.125);
		}
		else
		{
		  rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.475, 0.125);
		}
	}

/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv3 == rmGetCivID("Iroquois"))
	{   
		int iroquois4VillageID = -1;
		int iroquois4VillageType = rmRandInt(1,5);
		iroquois4VillageID = rmCreateGrouping("iroquois4 village", "native iroquois village "+iroquois4VillageType);
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois4VillageID, avoidImpassableLand);
		//rmAddGroupingConstraint(iroquois4VillageID, avoidTradeRoute);
		//rmAddGroupingConstraint(iroquois4VillageID, shortAvoidStartingUnits);
		//rmAddGroupingConstraint(iroquois4VillageID, avoidTradeSockets);
		//rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		//rmAddGroupingToClass(iroquois4VillageID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(iroquois4VillageID, avoidImportantItem);
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);

		if (NativeVillageLoc < 0.5)
		{
		  rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.875, 0.525);
		}
		else
		{
		  rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.875, 0.525);
		}
	}
	    else
	{   
		int lakota2VillageID = -1;
		int lakota2VillageType = rmRandInt(1,5);
		lakota2VillageID = rmCreateGrouping("lakota2 village", "native lakota village "+lakota2VillageType);
		rmSetGroupingMinDistance(lakota2VillageID, 0.0);
		rmSetGroupingMaxDistance(lakota2VillageID, 0.0);
		//rmAddGroupingConstraint(lakota2VillageID, avoidImpassableLand);
		//rmAddGroupingConstraint(lakota2VillageID, avoidTradeRoute);
		//rmAddGroupingConstraint(lakota2VillageID, shortAvoidStartingUnits);
		//rmAddGroupingConstraint(lakota2VillageID, avoidTradeSockets);
		//rmAddGroupingToClass(lakota2VillageID, rmClassID("natives"));
		//rmAddGroupingToClass(lakota2VillageID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(lakota2VillageID, avoidImportantItem);
		rmAddGroupingConstraint(lakota2VillageID, avoidNatives);

		if (NativeVillageLoc < 0.5)
		{
		  rmPlaceGroupingAtLoc(lakota2VillageID, 0, 0.875, 0.525);
		}
		else
		{
		  rmPlaceGroupingAtLoc(lakota2VillageID, 0, 0.875, 0.525);
		}
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

	
	    if (subCiv4 == rmGetCivID("Iroquois"))// && cNumberNonGaiaPlayers >= 4)
		
	{
		int iroquois5VillageID = -1;
		int iroquois5VillageType = rmRandInt(1,5);
		iroquois5VillageID = rmCreateGrouping("iroquois5 village", "native iroquois village "+iroquois5VillageType);
		rmSetGroupingMinDistance(iroquois5VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois5VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois5VillageID, avoidImpassableLand);
		//rmAddGroupingConstraint(iroquois5VillageID, avoidTradeRoute);
		//rmAddGroupingConstraint(iroquois5VillageID, shortAvoidStartingUnits);
		//rmAddGroupingConstraint(iroquois5VillageID, avoidTradeSockets);
		rmAddGroupingToClass(iroquois5VillageID, rmClassID("natives"));
		//rmAddGroupingToClass(iroquois5VillageID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(iroquois5VillageID, avoidImportantItem);
		if (NativeVillageLoc < 0.5)
		{
		  rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.20, 0.80);
		}
		else
		{
		  rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.20, 0.80);
		}
		
	}

/*----------------------------------------------------------------------------------------------------------------*/
        
		if (subCiv5 == rmGetCivID("Iroquois"))// && cNumberNonGaiaPlayers >= 4)
		
	{
		int iroquois6VillageID = -1;
		int iroquois6VillageType = rmRandInt(1,5);
		iroquois6VillageID = rmCreateGrouping("iroquois6 village", "native iroquois village "+iroquois5VillageType);
		rmSetGroupingMinDistance(iroquois6VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois6VillageID, 0.0);
		//rmAddGroupingConstraint(iroquois6VillageID, avoidImpassableLand);
		//rmAddGroupingConstraint(iroquois6VillageID, avoidTradeRoute);
		//rmAddGroupingConstraint(iroquois6VillageID, shortAvoidStartingUnits);
		//rmAddGroupingConstraint(iroquois6VillageID, avoidTradeSockets);
		rmAddGroupingToClass(iroquois6VillageID, rmClassID("natives"));
		//rmAddGroupingToClass(iroquois6VillageID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(iroquois6VillageID, avoidImportantItem);
		if (NativeVillageLoc < 0.5)
		{
		  rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.80, 0.20);
		}
		else
		{
		  rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.80, 0.20);
		}
		
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE GOLD MINES: ************************************** //
// ************************************* DEFINE AND PLACE THE SILVER MINES: ************************************* //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (seasonPicker < 0.5)
		//if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.05, 0.35);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.35, 0.05);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.25, 0.85);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.85, 0.25);
        rmPlaceObjectDefAtLoc(gold1ID, 0, 0.65, 0.95);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.95, 0.65);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.55, 0.55);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.45, 0.45); 		
		
	}

    else

	{
	     // THE SILVER MINE NUMBER 1:
		int silver1ID = rmCreateObjectDef("silver 1");
		rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver1ID, 0.0);
		rmSetObjectDefMaxDistance(silver1ID, 0.0);
		rmAddObjectDefConstraint(silver1ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.05, 0.35);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.35, 0.05);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.25, 0.85);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.85, 0.25);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.65, 0.95);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.95, 0.65);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.55, 0.55);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.45, 0.45);
		
	}	
	
/*----------------------------------------------------------------------------------------------------------------*/
/*
        if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 2:
		int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.1, 0.5);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.1);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.9);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.9, 0.5); 
		
	}

    else

	{
	     // THE SILVER MINE NUMBER 2:
		int silver2ID = rmCreateObjectDef("silver 2");
		rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver2ID, 0.0);
		rmSetObjectDefMaxDistance(silver2ID, 0.0);
		rmAddObjectDefConstraint(silver2ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.1, 0.5);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.1);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.9);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.9, 0.5);
	}	
*/
/*----------------------------------------------------------------------------------------------------------------*/
/*

        if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 3:
		int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.835, 0.835);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.325, 0.675);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.675, 0.325); 
		
	}

    else

	{
	     // THE SILVER MINE NUMBER 3:
		int silver3ID = rmCreateObjectDef("silver 3");
		rmAddObjectDefItem(silver3ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver3ID, 0.0);
		rmSetObjectDefMaxDistance(silver3ID, 0.0);
		rmAddObjectDefConstraint(silver3ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.165, 0.165);
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.835, 0.835);
		//rmPlaceObjectDefAtLoc(silver3ID, 0, 0.325, 0.675);
		//rmPlaceObjectDefAtLoc(silver3ID, 0, 0.325, 0.675);
	}
*/
/*----------------------------------------------------------------------------------------------------------------*/
/*
        if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 4:
		int gold4ID = rmCreateObjectDef("gold 4");
		rmAddObjectDefItem(gold4ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold4ID, 0.0);
		rmSetObjectDefMaxDistance(gold4ID, 0.0);
		rmAddObjectDefConstraint(gold4ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.15, 0.65);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.65, 0.15);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.35, 0.85);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.85, 0.35); 
		
	}
	
	   else

	{
	     // THE BERRIES NUMBER 1:
		int Berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(Berries1ID, "berrybush", rmRandInt(5,7), 8.0);
		rmSetObjectDefMinDistance(Berries1ID, 0.0);
		rmSetObjectDefMaxDistance(Berries1ID, 0.0);
		rmAddObjectDefConstraint(Berries1ID, avoidFruits);
				
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.15, 0.65);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.65, 0.15);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.35, 0.85);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.85, 0.35);
	}
*/	
/*----------------------------------------------------------------------------------------------------------------*/
/* 
        if ( whichVariation == 1 )
		
	{		
		// THE GOLD MINE NUMBER 5:
		int gold5ID = rmCreateObjectDef("gold 5");
		rmAddObjectDefItem(gold5ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold5ID, 0.0);
		rmSetObjectDefMaxDistance(gold5ID, 0.0);
		rmAddObjectDefConstraint(gold5ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.125, 0.775);
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.775, 0.125);
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.225, 0.875);
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.875, 0.225); 
		
	}

        else

	{
	    // THE SILVER MINE NUMBER 5:
		int silver5ID = rmCreateObjectDef("silver 5");
		rmAddObjectDefItem(silver5ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver5ID, 0.0);
		rmSetObjectDefMaxDistance(silver5ID, 0.0);
		rmAddObjectDefConstraint(silver5ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver5ID, 0, 0.125, 0.775);
		rmPlaceObjectDefAtLoc(silver5ID, 0, 0.775, 0.125);
		rmPlaceObjectDefAtLoc(silver5ID, 0, 0.225, 0.875);
		rmPlaceObjectDefAtLoc(silver5ID, 0, 0.875, 0.225);
	}	
		
*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.68);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE THE TREASURES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.15, 0.55);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.55, 0.15);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.45, 0.85);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.85, 0.45);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.445, 0.645);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.645, 0.445);
		
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.350, 0.550);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.550, 0.350);
		
/*----------------------------------------------------------------------------------------------------------------*/

		// THE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.35, 0.35);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.65, 0.65);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE NUGGETS NUMBER 4:
		int nugget4ID= rmCreateObjectDef("nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
	    rmAddObjectDefConstraint(nugget4ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.10, 0.70);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.70, 0.10);
		
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.30, 0.90);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.90, 0.30);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE SAUVAGE FOOD: ************************************** //	
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SEASON PICKER:
		if (seasonPicker < 0.5)
	
	{	
		int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmAddObjectDefConstraint(deer1ID, avoidCloseCliffs);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.10, 0.40);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.40, 0.10);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.15, 0.75);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.75, 0.15);
		
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.60, 0.90);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.90, 0.60);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.60, 0.60);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.40, 0.40);
		
	}

        else
		
	{
    	int caribou1ID=rmCreateObjectDef("The Caribou Herds 1");
        rmAddObjectDefItem(caribou1ID, "caribou", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(caribou1ID, 0.0);
        rmSetObjectDefMaxDistance(caribou1ID, 0.0);
	    rmAddObjectDefConstraint(caribou1ID, avoidCaribou);
		rmSetObjectDefCreateHerd(caribou1ID, true);
	    
		rmPlaceObjectDefAtLoc(caribou1ID, 0, 0.10, 0.40);
		rmPlaceObjectDefAtLoc(caribou1ID, 0, 0.40, 0.10);
		rmPlaceObjectDefAtLoc(caribou1ID, 0, 0.15, 0.75);
		rmPlaceObjectDefAtLoc(caribou1ID, 0, 0.75, 0.15);
		
		rmPlaceObjectDefAtLoc(caribou1ID, 0, 0.60, 0.90);
		rmPlaceObjectDefAtLoc(caribou1ID, 0, 0.90, 0.60);
		rmPlaceObjectDefAtLoc(caribou1ID, 0, 0.60, 0.60);
		rmPlaceObjectDefAtLoc(caribou1ID, 0, 0.40, 0.40);
		
    }
	
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SEASON PICKER:
		if (seasonPicker < 0.5)
	
	{	
		int deer2ID=rmCreateObjectDef("The Deer Herds 2");
        rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, 0.0);
	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmAddObjectDefConstraint(deer2ID, avoidCloseCliffs);
		rmSetObjectDefCreateHerd(deer2ID, true);
	    
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.75, 0.35);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.25, 0.65);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.65, 0.25);
		
		//rmPlaceObjectDefAtLoc(deer2ID, 0, 0.60, 0.90);
		//rmPlaceObjectDefAtLoc(deer2ID, 0, 0.90, 0.60);
		//rmPlaceObjectDefAtLoc(deer2ID, 0, 0.60, 0.60);
		//rmPlaceObjectDefAtLoc(deer2ID, 0, 0.40, 0.40);
		
	}

        else
		
	{
    	int caribou2ID=rmCreateObjectDef("The Caribou Herds 2");
        rmAddObjectDefItem(caribou2ID, "caribou", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(caribou2ID, 0.0);
        rmSetObjectDefMaxDistance(caribou2ID, 0.0);
	    rmAddObjectDefConstraint(caribou2ID, avoidCaribou);
		rmSetObjectDefCreateHerd(caribou2ID, true);
	    
		rmPlaceObjectDefAtLoc(caribou2ID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(caribou2ID, 0, 0.75, 0.35);
		rmPlaceObjectDefAtLoc(caribou2ID, 0, 0.25, 0.65);
		rmPlaceObjectDefAtLoc(caribou2ID, 0, 0.65, 0.25);
		
		//rmPlaceObjectDefAtLoc(caribou2ID, 0, 0.60, 0.90);
		//rmPlaceObjectDefAtLoc(caribou2ID, 0, 0.90, 0.60);
		//rmPlaceObjectDefAtLoc(caribou2ID, 0, 0.60, 0.60);
		//rmPlaceObjectDefAtLoc(caribou2ID, 0, 0.40, 0.40);
		
    }	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE COWS: ********************************************* //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // if ( whichVariation == 1 )
		if (seasonPicker < 0.5)
		
	{	
		int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmSetObjectDefCreateHerd(cow1ID, true);
	    
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.175, 0.375);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.375, 0.175);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.20, 0.60);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.60, 0.20);
		
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.40, 0.80);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.80, 0.40);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.625, 0.825);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.825, 0.625);
	}
        else
		
	{	
		int sheep1ID=rmCreateObjectDef("The Sheeps 1");
        rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(sheep1ID, 0.0);
        rmSetObjectDefMaxDistance(sheep1ID, 0.0);
	    rmAddObjectDefConstraint(sheep1ID, avoidSheep);
		rmSetObjectDefCreateHerd(sheep1ID, true);
	    
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.175, 0.375);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.375, 0.175);
        
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.20, 0.60);
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.60, 0.20);
		
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.40, 0.80);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.80, 0.40);
        
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.625, 0.825);
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.825, 0.625);
	}	
	
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM BERRIES: ************************************* //
// *********************************** DEFINE AND PLACE THE RANDOM TURKEYS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if (seasonPicker < 0.5)
		
	{	
		int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.125, 0.225);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.225, 0.125);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.775, 0.875);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.875, 0.775);
				
	}
        else
		
	{
        int turkey1ID = rmCreateObjectDef("The Turkeys 1");
		rmAddObjectDefItem(turkey1ID, "berrybush", rmRandInt(5,7), 4.0);
		rmSetObjectDefMinDistance(turkey1ID, 0.0);
		rmSetObjectDefMaxDistance(turkey1ID, 0.0);
		rmAddObjectDefConstraint(turkey1ID, avoidTurkeys);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.125, 0.225);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.225, 0.125);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.775, 0.875);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.875, 0.775);
				
    }
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (seasonPicker < 0.5)
		
	{	
		int berries3ID = rmCreateObjectDef("The Berries 3");
		rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.45, 0.05);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.55, 0.95);
		
		//rmPlaceObjectDefAtLoc(berries3ID, 0, 0.45, 0.75);
		//rmPlaceObjectDefAtLoc(berries3ID, 0, 0.75, 0.45);
				
	}
        else
		
	{
        int turkey2ID = rmCreateObjectDef("The Turkeys 2");
		rmAddObjectDefItem(turkey2ID, "berrybush", rmRandInt(5,7), 4.0);
		rmSetObjectDefMinDistance(turkey2ID, 0.0);
		rmSetObjectDefMaxDistance(turkey2ID, 0.0);
		rmAddObjectDefConstraint(turkey2ID, avoidTurkeys);
		
		rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.45, 0.05);
		rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.55, 0.95);
		
		//rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.45, 0.75);
		//rmPlaceObjectDefAtLoc(turkey2ID, 0, 0.75, 0.45);
				
    }
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE PERCHING VULTURES: ************************************* //
/*================================================================================================================*/
		
		// PERCHING VULTURES - ADD FOUR SOMEWHERE:
	    int vultureID=rmCreateObjectDef("perching vultures");
	    int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	    int avoidCloseVultures=rmCreateTypeDistanceConstraint("close vs vultures", "PropVulturePerching", 5.0);
	   
		rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
	    
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.075, 0.60);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.60, 0.075);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.40, 0.925);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.925, 0.40);
		
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.15, 0.35);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.35, 0.15);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.65, 0.85);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.85, 0.65);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// ***************************** DEFINE AND PLACE THE FORESTS: - NORTH AND SOUTH: ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	        
			int forestTreeID = 0;
	
	        numTries=12*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int westForest=rmCreateArea("westForest"+i);
			rmSetAreaWarnFailure(westForest, false);
			rmSetAreaSize(westForest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
			
			if (seasonPicker < 0.5)
				
				rmSetAreaForestType(westForest, "great lakes forest");
			else
				rmSetAreaForestType(westForest, "great lakes forest snow");
			
			rmSetAreaForestDensity(westForest, 0.7);
			rmSetAreaForestClumpiness(westForest, 0.4);
			rmSetAreaForestUnderbrush(westForest, 0.0);
			rmSetAreaMinBlobs(westForest, 1);
			rmSetAreaMaxBlobs(westForest, 3);
			rmSetAreaMinBlobDistance(westForest, 5.0);
			rmSetAreaMaxBlobDistance(westForest, 20.0);
			rmSetAreaCoherence(westForest, 0.4);
			rmSetAreaSmoothDistance(westForest, 10);
			rmAddAreaConstraint(westForest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			rmAddAreaConstraint(westForest, avoidCloseCoin);
			rmAddAreaConstraint(westForest, avoidCloseGold);
			rmAddAreaConstraint(westForest, avoidCloseNugget);
			rmAddAreaConstraint(westForest, avoidCloseNatives);
			rmAddAreaConstraint(westForest, avoidAll);
			rmAddAreaConstraint(westForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(westForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			rmAddAreaConstraint(westForest, Northward);						// DAL adeed, to keep these forests in the west.
			rmAddAreaConstraint(westForest, greatLakesConstraint);
			rmAddAreaConstraint(westForest, avoidTradeRoute);
			rmAddAreaConstraint(westForest, avoidCliffs);
			rmAddAreaConstraint(westForest, forestAvoidDeer);
			rmAddAreaConstraint(westForest, forestAvoidBison);
			if(rmBuildArea(westForest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
		
/*----------------------------------------------------------------------------------------------------------------*/		

	        numTries=12*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	        failCount=0;
	        for (i=0; <numTries)
		{   
			int eastForest=rmCreateArea("eastForest"+i);
			rmSetAreaWarnFailure(eastForest, false);
			rmSetAreaSize(eastForest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
			
			if (seasonPicker < 0.5)
				
				rmSetAreaForestType(eastForest, "great lakes forest");
			else
				rmSetAreaForestType(eastForest, "great lakes forest snow");
			
			rmSetAreaForestDensity(eastForest, 0.7);
			rmSetAreaForestClumpiness(eastForest, 0.4);
			rmSetAreaForestUnderbrush(eastForest, 0.0);
			rmSetAreaMinBlobs(eastForest, 1);
			rmSetAreaMaxBlobs(eastForest, 3);
			rmSetAreaMinBlobDistance(eastForest, 5.0);
			rmSetAreaMaxBlobDistance(eastForest, 20.0);
			rmSetAreaCoherence(eastForest, 0.4);
			rmSetAreaSmoothDistance(eastForest, 10);
			rmAddAreaConstraint(eastForest, avoidImportantItem);			// DAL added, to try and make sure natives got on the map w/o override.
			rmAddAreaConstraint(eastForest, avoidCloseCoin);
			rmAddAreaConstraint(eastForest, avoidCloseGold);
			rmAddAreaConstraint(eastForest, avoidCloseNatives);
			rmAddAreaConstraint(eastForest, avoidAll);
			rmAddAreaConstraint(eastForest, avoidCloseNugget);
			rmAddAreaConstraint(eastForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(eastForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			rmAddAreaConstraint(eastForest, Southward);						// DAL adeed, to keep these forests in the east.
			rmAddAreaConstraint(eastForest, greatLakesConstraint);
			rmAddAreaConstraint(eastForest, avoidTradeRoute);
			rmAddAreaConstraint(eastForest, avoidCliffs);
			rmAddAreaConstraint(eastForest, forestAvoidDeer);
			rmAddAreaConstraint(eastForest, forestAvoidBison);
			if(rmBuildArea(eastForest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		} 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ************************************* DEFINE AND PLACE THE RANDOM TREES:	************************************ //
/*===============================================================================================================*/	
        
		// THE RANDOM TREES:
		int RandomTreesID = rmCreateObjectDef("The Random Trees");
		
		if (seasonPicker < 0.5)
	{	
		rmAddObjectDefItem(RandomTreesID, "TreeGreatLakes", 1, 0.0);
	}	
		else
	{	
		rmAddObjectDefItem(RandomTreesID, "TreeGreatLakesSnow", 1, 0.0);
	}	
		
		rmSetObjectDefMinDistance(RandomTreesID, 0.0);
		rmSetObjectDefMaxDistance(RandomTreesID, rmXFractionToMeters(0.5));
		
		// DEFINE THE CONSTRAINTS:
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseTrees1);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseTrees2);
		rmAddObjectDefConstraint(RandomTreesID, avoidAll);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseFruits);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseVultures);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseCoin);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseGold);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseNatives);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseImpassableLand);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseCliffs);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseCow);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseSheep);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseTurkeys);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseDeer);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseCaribou);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseNugget);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(RandomTreesID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(RandomTreesID, mediumPlayerConstraint);
		rmAddObjectDefConstraint(RandomTreesID, closeGreatLakesConstraint);
		rmAddObjectDefConstraint(RandomTreesID, closeForestConstraint);		
				
        rmPlaceObjectDefAtLoc(RandomTreesID, 0, 0.5, 0.5, 50*cNumberNonGaiaPlayers);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ********************************** DEFINE AND PLACE THE FISH AND THE WHALES: ********************************* //
/*================================================================================================================*/

        // DEFINE THE FISH AND WHALES CONSTRAINTS:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 8.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 4.0);
        //int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 25.0);
        //int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	
/*----------------------------------------------------------------------------------------------------------------*/		

        // FISHBASS -- FOOD:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*20);
		
/*----------------------------------------------------------------------------------------------------------------*/		

/*
	    // FAST COIN -- WHALES:
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);
*/

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*================================================================================================================*/  
   