/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// THE GOLDEN PRAIRIES:
// CREATED BY DANY:
// SEPTEMBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// *************************************** DEFINE THE VARIABLE WHICHMAP: **************************************** //
/*================================================================================================================*/

        int whichMap=rmRandInt(1,2); 
		
/*================================================================================================================*/		
// *************************************** DEFINE THE VARIABLE WHICHROUTE: **************************************** //
/*================================================================================================================*/

        int whichRoute=rmRandInt(1,2);   		
   
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		int subCiv4=-1;
        int subCiv5=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Iroquois");
		
		subCiv4=rmGetCivID("Iroquois");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Iroquois");

		subCiv5=rmGetCivID("Iroquois");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Iroquois");
   }		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        int playerTiles=17500;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(530, 530);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(0.0);

        // SET MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
		rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0);
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("great plains drygrass");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("yukon\ground1_yuk", 5);
	    
		// SET LIGHTING:
		rmSetLightingSet("great plains");
	    
		// SET MAP TYPE:
		rmSetMapType("greatPlains");
	    rmSetMapType("land");
		rmSetMapType("grass");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	    
		// CHOOSE THE MERCS:
		chooseMercs();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classPatch");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("natives");	
	    rmDefineClass("classHillArea");
	    rmDefineClass("socketClass");
	    rmDefineClass("nuggets");
		rmDefineClass("center");
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 15.0);
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
        int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("nuggets stay away from players a lot", classPlayer, 40.0);

        // Cardinal Directions Constraints (handy!)
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
		
        // CARDINAL DIRECTIONS OF THE NORTH:
        int North15ward=rmCreatePieConstraint("north15MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(1), rmDegreesToRadians(15));
        int North30ward=rmCreatePieConstraint("north30MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(16), rmDegreesToRadians(30));
        int North45ward=rmCreatePieConstraint("north45MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(31), rmDegreesToRadians(45));
        int North60ward=rmCreatePieConstraint("north60MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(46), rmDegreesToRadians(60));
        int North75ward=rmCreatePieConstraint("north75MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(61), rmDegreesToRadians(75));
        int North90ward=rmCreatePieConstraint("north90MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(76), rmDegreesToRadians(90));
       
		// CARDINAL DIRECTIONS OF THE EAST:
		int East105ward=rmCreatePieConstraint("east105MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(91), rmDegreesToRadians(105));
        int East120ward=rmCreatePieConstraint("east120MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(106), rmDegreesToRadians(120));
        int East135ward=rmCreatePieConstraint("east135MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(121), rmDegreesToRadians(135));
        int East150ward=rmCreatePieConstraint("east150MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(136), rmDegreesToRadians(150));
        int East165ward=rmCreatePieConstraint("east165MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(151), rmDegreesToRadians(165));
        int East180ward=rmCreatePieConstraint("east180MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(166), rmDegreesToRadians(180));
        		
		// CARDINAL DIRECTIONS OF THE SOUTH:
		int South195ward=rmCreatePieConstraint("south195MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(181), rmDegreesToRadians(195));
        int South210ward=rmCreatePieConstraint("south210MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(196), rmDegreesToRadians(210));
        int South225ward=rmCreatePieConstraint("south225MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(211), rmDegreesToRadians(225));
        int South240ward=rmCreatePieConstraint("south240MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(226), rmDegreesToRadians(240));
        int South255ward=rmCreatePieConstraint("south255MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(241), rmDegreesToRadians(255));
        int South270ward=rmCreatePieConstraint("south270MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(256), rmDegreesToRadians(270));
        		
		// CARDINAL DIRECTIONS OF THE WEST:
		int West285ward=rmCreatePieConstraint("west285MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(271), rmDegreesToRadians(285));
		int West300ward=rmCreatePieConstraint("west300MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(286), rmDegreesToRadians(300));
        int West315ward=rmCreatePieConstraint("west315MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(301), rmDegreesToRadians(315));
        int West330ward=rmCreatePieConstraint("west330MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(316), rmDegreesToRadians(330));
        int West345ward=rmCreatePieConstraint("west345MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(331), rmDegreesToRadians(345));
        int West360ward=rmCreatePieConstraint("west360MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(346), rmDegreesToRadians(360));
 	
		// CENTER AVOIDANCE:
		int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 15.0);
	    int centerCloseConstraint=rmCreateClassDistanceConstraint("close stay away from center", rmClassID("center"), 5.0);
		int centerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stay away from center", rmClassID("center"), 2.0);
		int centerMediumConstraint=rmCreateClassDistanceConstraint("medium stay away from center", rmClassID("center"), 25.0);
	    int centerFarConstraint=rmCreateClassDistanceConstraint("far stay away from center", rmClassID("center"), 50.0);
        int centerVeryFarConstraint=rmCreateClassDistanceConstraint("very far stay away from center", rmClassID("center"), 75.0);
	    		
		// FOREST AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 5.0);
        
		int coinForestConstraint=rmCreateClassDistanceConstraint("coin vs. forest", rmClassID("classForest"), 15.0);
		
		int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoid Trees", "TreeYucatan", 10.0);
		int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoid Trees", "TreeYucatan", 5.0);
		int avoidMediumTrees=rmCreateTypeDistanceConstraint("medium avoid Trees", "TreeYucatan", 25.0);
		int avoidFarTrees=rmCreateTypeDistanceConstraint("far avoid Trees", "TreeYucatan", 50.0);
		int avoidVeryFarTrees=rmCreateTypeDistanceConstraint("very far avoid Trees", "TreeYucatan", 75.0);
		
		// FISH AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 15.0);
		int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        		        
		// BISON AVOIDANCE:
		int avoidBison=rmCreateTypeDistanceConstraint("bison avoids food", "bison", 40.0);
        int avoidCloseBison=rmCreateTypeDistanceConstraint("close bison avoids food", "bison", 5.0);
		
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 15.0);
        int avoidCloseSheep=rmCreateTypeDistanceConstraint("close sheep avoids sheep", "sheep", 5.0);
		int avoidMediumSheep=rmCreateTypeDistanceConstraint("medium sheep avoids sheep", "sheep", 25.0);
		int avoidveryCloseSheep=rmCreateTypeDistanceConstraint("very close sheep avoids sheep", "sheep", 2.0);
		int avoidFarSheep=rmCreateTypeDistanceConstraint("far sheep avoids food", "sheep", 50.0);
        int avoidVeryFarSheep=rmCreateTypeDistanceConstraint("very far sheep avoids food", "sheep", 75.0);
       
        
		// PRONGHORN AVOIDANCE:
		int avoidPronghorn=rmCreateTypeDistanceConstraint("pronghorn avoids food", "pronghorn", 35.0);
	    int avoidClosePronghorn=rmCreateTypeDistanceConstraint("close pronghorn avoids food", "pronghorn", 5.0);
	    
		
		// COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 15.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close coin avoids coin", "gold", 5.0);
		
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 2.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid fruits", "berrybush", 35.0);
		int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid fruits", "berrybush", 50.0);
		int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoid fruits", "berrybush", 75.0);
		    
		// STARTING COIN AVOIDANCE:
		int avoidStartingCoin=rmCreateTypeDistanceConstraint("starting coin avoids coin", "gold", 22.0);
        
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 40.0);
        int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 5.0);
        
		int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);

	    // FAST COIN AVOIDANCE:
		int avoidFastCoin=-1;
	    if (cNumberNonGaiaPlayers >6)
	{
		avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.12));
	}
	    else if (cNumberNonGaiaPlayers >4)
	{
		avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.14));
	}
	    else
	{
		avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.16));
	}

        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        
		// PATCH CONSTRAINT:
		int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

        // UNIT AVOIDANCE - FOR THINGS THAT AREN'T IN THE STARTING RESOURCES:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
       
        int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("trade route small", 4.0);
        // int avoidTradeRoutePlayer = rmCreateTradeRouteDistanceConstraint("trade route player", 30.0);
        
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 15.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close important stuff avoids each other", rmClassID("importantItem"), 5.0);
 
		
	    // SOCKET AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
	    int avoidCloseSocket=rmCreateClassDistanceConstraint("close socket avoidance", rmClassID("socketClass"), 2.0);
	   
		int avoidSocketMore=rmCreateClassDistanceConstraint("bigger socket avoidance", rmClassID("socketClass"), 15.0);

        // CONSTRAINT TO AVOID WATER:
        int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
        int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);

	    // AVOID THE HILLY AREAS:
	    int avoidHills = rmCreateClassDistanceConstraint("avoid Hills", rmClassID("classHillArea"), 5.0);
	
	    // NATIVES AVOIDANCE:
	    int avoidNatives = rmCreateClassDistanceConstraint("avoid Natives", rmClassID("natives"), 15.0);
	    int avoidCloseNatives = rmCreateClassDistanceConstraint("close avoid Natives", rmClassID("natives"), 5.0);
	   	int avoidNativesNuggets = rmCreateClassDistanceConstraint("nuggets avoid Natives", rmClassID("natives"), 20.0);

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE TRADE ROUTE: *************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichRoute == 1 )
	{	
		
		// DEFINE AND PLACE TRADE ROUTE 1:
		int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 12.0);

	    rmAddTradeRouteWaypoint(tradeRouteID, 0.175, 0.825);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.450, 0.550);
	    //rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.2, 0.3, 10, 4);

        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	
/*----------------------------------------------------------------------------------------------------------------*/
 
	   // DEFINE AND PLACE TRADE ROUTE 2:
		int tradeRoute2ID = rmCreateTradeRoute();
        socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
        rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 12.0);

	    rmAddTradeRouteWaypoint(tradeRoute2ID, 0.825, 0.175);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.550, 0.450);
	    //rmAddRandomTradeRouteWaypoints(tradeRoute2ID, 0.2, 0.7, 10, 4);

        placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
        socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
}	

/*----------------------------------------------------------------------------------------------------------------*/
        
	    if ( whichRoute == 2 )	
        
   {		
		
		// DEFINE AND PLACE TRADE ROUTE 3:
		int tradeRoute3ID = rmCreateTradeRoute();
        socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
        rmSetObjectDefTradeRouteID(socketID, tradeRoute3ID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 12.0);

	    rmAddTradeRouteWaypoint(tradeRoute3ID, 0.825, 0.175);
		rmAddTradeRouteWaypoint(tradeRoute3ID, 0.175, 0.825);
	    //rmAddRandomTradeRouteWaypoints(tradeRoute3ID, 0.2, 0.7, 10, 4);

        placedTradeRoute = rmBuildTradeRoute(tradeRoute3ID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc); 
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.25);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc); 
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.50);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

		socketLoc = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.75);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc); 
        
        socketLoc = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc); 

   }	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// **************************** IN THIS SECTION - YOU DEFINE THE AREAS OF THE MAP: - **************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*      
        - SET UP PLAYER STARTING LOCATIONS:
		- SET UP PLAYER AREAS:
		- SET ONE CENTER AREAS:
*/		
/*================================================================================================================*/
// ************************************ SET UP PLAYER STARTING LOCATIONS: *************************************** //
/*================================================================================================================*/

        rmSetPlacementTeam(0);
		rmSetPlacementSection(0.075, 0.175);
		rmPlacePlayersCircular(0.38, 0.38, 0);
		
		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.575, 0.675);
		rmPlacePlayersCircular(0.38, 0.38, 0);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ****************************************** SET UP PLAYER AREAS: ********************************************** //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(1750);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "great plains drygrass");
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
	    rmAddAreaConstraint(id, avoidTradeRoute); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
   }
        // Build the areas.
        rmBuildAllAreas();
		
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE A CENTER AREA: **************************************** //
/*================================================================================================================*/

        if ( whichRoute == 1 )
{		
		
			
		int centerID=rmCreateArea("center");
        rmSetAreaSize(centerID, 0.0125, 0.0125);
        rmSetAreaLocation(centerID, 0.5, 0.5);
		rmSetAreaCoherence(centerID, 1.0);
        rmAddAreaToClass(centerID, rmClassID("center"));
		//rmSetAreaMix(centerID, "pampas_grass");
        rmBuildArea(centerID);
    		

/*----------------------------------------------------------------------------------------------------------------*/

        // THE TEST OBJECT:
        int Factory1ID=rmCreateObjectDef("The Factory 1");
	    //rmAddObjectDefItem(Factory1ID, "Outpost", 1.0, 0.0);
		rmAddObjectDefItem(Factory1ID, "Factory", 1.0, 0.0);
        rmSetObjectDefMinDistance(Factory1ID, 0.0);
        rmSetObjectDefMaxDistance(Factory1ID, 0.0);
        //rmAddObjectDefConstraint(Factory1ID, avoidDeer);
        rmSetObjectDefCreateHerd(Factory1ID, true);
	    
		rmPlaceObjectDefAtLoc(Factory1ID, 0, 0.5, 0.5);
		
/*----------------------------------------------------------------------------------------------------------------*/
		
		// THE TEST OBJECT:
        int Outpost1ID=rmCreateObjectDef("The Outpost 1");
	    rmAddObjectDefItem(Outpost1ID, "Outpost", 1.0, 0.0);
		rmSetObjectDefMinDistance(Outpost1ID, 0.0);
        rmSetObjectDefMaxDistance(Outpost1ID, 0.0);
        //rmAddObjectDefConstraint(Outpost1ID, avoidDeer);
        rmSetObjectDefCreateHerd(Outpost1ID, true);
	    
		rmPlaceObjectDefAtLoc(Outpost1ID, 0, 0.535, 0.5);

        // THE TEST OBJECT:
        int Outpost2ID=rmCreateObjectDef("The Outpost 2");
	    rmAddObjectDefItem(Outpost2ID, "Outpost", 1.0, 0.0);
		rmSetObjectDefMinDistance(Outpost2ID, 0.0);
        rmSetObjectDefMaxDistance(Outpost2ID, 0.0);
        //rmAddObjectDefConstraint(Outpost2ID, avoidDeer);
        rmSetObjectDefCreateHerd(Outpost2ID, true);
	    
		rmPlaceObjectDefAtLoc(Outpost2ID, 0, 0.465, 0.5);

        // THE TEST OBJECT:
        int Outpost3ID=rmCreateObjectDef("The Outpost3");
	    rmAddObjectDefItem(Outpost3ID, "Outpost", 1.0, 0.0);
		rmSetObjectDefMinDistance(Outpost3ID, 0.0);
        rmSetObjectDefMaxDistance(Outpost3ID, 0.0);
        //rmAddObjectDefConstraint(Outpost3ID, avoidDeer);
        rmSetObjectDefCreateHerd(Outpost3ID, true);
	    
		rmPlaceObjectDefAtLoc(Outpost3ID, 0, 0.5, 0.535);		

        // THE TEST OBJECT:
        int Outpost4ID=rmCreateObjectDef("The Factory 4");
	    rmAddObjectDefItem(Outpost4ID, "Outpost", 1.0, 0.0);
		rmSetObjectDefMinDistance(Outpost4ID, 0.0);
        rmSetObjectDefMaxDistance(Outpost4ID, 0.0);
        //rmAddObjectDefConstraint(Outpost4ID, avoidDeer);
        rmSetObjectDefCreateHerd(Outpost4ID, true);
	    
		rmPlaceObjectDefAtLoc(Outpost4ID, 0, 0.5, 0.465);
}		
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************ DEFINE SOME VARIABLES NEEDED LATER: ************************************* //
/*================================================================================================================*/   

	    //int numTries = -1;
	    //int failCount = -1;

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE TWO HILLY AREAS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/	

        // Build the areas.
        // rmBuildAllAreas();
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/

   // PLACEMENT ORDER OF NON-TRADE ROUTE STUFF:
   // NATIVES -> SECRETS -> NUGGETS -> SMALL PONDS (WHEE)

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ********************* DEFINE THE STARTING UNITS AND STARTING TCID AND STARTING RESOURCES: ******************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        // DEFINE THE STARTING STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 7.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);

	    // DEFINE THE STARTING TCID:
		int startingTCID = rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 9.0);
	    rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSmall);
	    // rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
		
/*----------------------------------------------------------------------------------------------------------------*/

	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
		
		// DEFINE THE STARTING BERRIES:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", rmRandInt(3,5), 4.0);
	    rmSetObjectDefMinDistance(StartBerriesID, 17.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 19.0);
	    rmSetObjectDefCreateHerd(StartBerriesID, true);
	    rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnitsSmall);
		rmAddObjectDefConstraint(StartBerriesID, avoidMediumFruits);

	    // DEFINE THE STARTING BISON:
		int StartBisonID=rmCreateObjectDef("starting bison");
	    rmAddObjectDefItem(StartBisonID, "Bison", 4, 4.0);
	    rmSetObjectDefMinDistance(StartBisonID, 10.0);
	    rmSetObjectDefMaxDistance(StartBisonID, 12.0);
	    rmSetObjectDefCreateHerd(StartBisonID, true);
	    rmAddObjectDefConstraint(StartBisonID, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 28.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNativesNuggets);
	    rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteSmall);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	
	    // DEFINE THE VARIABLES FOR THE PLAYER GOLD:
	    int silverType = -1;
	    int playerGoldID = -1;
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************** PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

 	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// REMOVED BY ENSEMBLE:
		// vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		// rmSetHomeCityGatherPoint(i, closestPoint);

		// DEFINE THE PLAYER GOLD:
		// EVERYONE GETS TWO ORE OBJECTDEFS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE THE BERRY BUSHES:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER GOLD: ( TWO GOLD MINES: )
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING BISONS:
		rmPlaceObjectDefAtLoc(StartBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 2 )
{		

        if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.425, 0.775);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.775, 0.425);
	} 	
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.225, 0.575);
	} 

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.575, 0.225);
	} 

}	

/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
{	
		
		if (subCiv4 == rmGetCivID("iroquois"))
	{  
		int iroquois5VillageID = -1;
		iroquois5VillageID = rmCreateGrouping("iroquois village 5", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois5VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois5VillageID, 0.0);
		rmAddGroupingToClass(iroquois5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois5VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.40, 0.40);
	} 
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv5 == rmGetCivID("iroquois"))
	{  
		int iroquois6VillageID = -1;
		iroquois6VillageID = rmCreateGrouping("iroquois village 6", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois6VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois6VillageID, 0.0);
		rmAddGroupingToClass(iroquois6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois6VillageID, avoidNatives);
		
		rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.60, 0.60);
	} 
}	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FOUR PONDS : ************************************** //  
/*================================================================================================================*/
        
		if ( whichMap == 1 )
		
	{	
		
	    // POND NUMBER 1:
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 15.0);
        int pondCloseConstraint=rmCreateClassDistanceConstraint("close ponds avoid ponds", rmClassID("pond"), 5.0);
		
/*----------------------------------------------------------------------------------------------------------------*/        
		
		int smallPondID=rmCreateArea("small pond 1");
        rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
        rmSetAreaWaterType(smallPondID, "saguenay lake");
        rmSetAreaBaseHeight(smallPondID, 4);
        rmSetAreaMinBlobs(smallPondID, 1);
        rmSetAreaMaxBlobs(smallPondID, 1);
        rmSetAreaMinBlobDistance(smallPondID, 1.0);
        rmSetAreaMaxBlobDistance(smallPondID, 1.0);
        rmAddAreaToClass(smallPondID, pondClass);
        rmSetAreaCoherence(smallPondID, 0.85);
        rmSetAreaSmoothDistance(smallPondID, 5);
        rmAddAreaConstraint(smallPondID, pondConstraint);
        rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.425, 0.775); 
        rmBuildArea(smallPondID);
		
/*----------------------------------------------------------------------------------------------------------------*/
   
        // POND NUMBER 2:
	    int smallPond2ID=rmCreateArea("small pond 2");
        rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
        rmSetAreaWaterType(smallPond2ID, "saguenay lake");
        rmSetAreaBaseHeight(smallPond2ID, 4);
        rmSetAreaMinBlobs(smallPond2ID, 1);
        rmSetAreaMaxBlobs(smallPond2ID, 1);
        rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
        rmAddAreaToClass(smallPond2ID, pondClass);
        rmSetAreaCoherence(smallPond2ID, 0.85);
        rmSetAreaSmoothDistance(smallPond2ID, 5);
        rmAddAreaConstraint(smallPond2ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.775, 0.425); 
        rmBuildArea(smallPond2ID);
		
/*----------------------------------------------------------------------------------------------------------------*/
		
	    // POND NUMBER 3:
	    int smallPond3ID=rmCreateArea("small pond 3");
        rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
        rmSetAreaWaterType(smallPond3ID, "saguenay lake");
        rmSetAreaBaseHeight(smallPond3ID, 4);
        rmSetAreaMinBlobs(smallPond3ID, 1);
        rmSetAreaMaxBlobs(smallPond3ID, 1);
        rmSetAreaMinBlobDistance(smallPond3ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond3ID, 1.0);
        rmAddAreaToClass(smallPond3ID, pondClass);
        rmSetAreaCoherence(smallPond3ID, 0.85);
        rmSetAreaSmoothDistance(smallPond3ID, 5);
        rmAddAreaConstraint(smallPond3ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond3ID, false);
		rmSetAreaLocation(smallPond3ID, 0.225, 0.575); 
        rmBuildArea(smallPond3ID); 
		
/*----------------------------------------------------------------------------------------------------------------*/

        // POND NUMBER 4:
	    int smallPond4ID=rmCreateArea("small pond 4");
        rmSetAreaSize(smallPond4ID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
        rmSetAreaWaterType(smallPond4ID, "saguenay lake");
        rmSetAreaBaseHeight(smallPond4ID, 4);
        rmSetAreaMinBlobs(smallPond4ID, 1);
        rmSetAreaMaxBlobs(smallPond4ID, 1);
        rmSetAreaMinBlobDistance(smallPond4ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond4ID, 1.0);
        rmAddAreaToClass(smallPond4ID, pondClass);
        rmSetAreaCoherence(smallPond4ID, 0.85);
        rmSetAreaSmoothDistance(smallPond4ID, 5);
        rmAddAreaConstraint(smallPond4ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond4ID, false);
		rmSetAreaLocation(smallPond4ID, 0.575, 0.225); 
        rmBuildArea(smallPond4ID);
}	
	
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE FOUR CLIFFS: *************************************** //
/*================================================================================================================*/		
		
		if ( whichMap == 2 )
		
{		
		
		rmDefineClass("classCliff");
        int avoidCliffs=rmCreateClassDistanceConstraint("stuff avoid cliffs", rmClassID("classCliff"), 15.0);
        int avoidCloseCliffs=rmCreateClassDistanceConstraint("close cliffs avoid cliffs", rmClassID("classCliff"), 5.0);
        int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs avoid cliffs", rmClassID("classCliff"), 50.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// CLIFF NUMBER 1:
		int cliff1ID=rmCreateArea("cliff 1");
	    rmSetAreaSize(cliff1ID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
		rmSetAreaWarnFailure(cliff1ID, false);
		rmSetAreaCliffType(cliff1ID, "Great Plains");
		rmAddAreaToClass(cliff1ID, rmClassID("classCliff"));
        //rmSetAreaCliffEdge(cliff1ID, 1, 1.0, 0.1, 1.0, 0);		
		rmSetAreaCliffEdge(cliff1ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff1ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliff1ID, 8, 1.0, 1.0);
		rmSetAreaHeightBlend(cliff1ID, 1);
		//rmAddAreaTerrainLayer(cliff1ID, "texas\ground2_tex", 0, 2);
		rmSetAreaObeyWorldCircleConstraint(cliff1ID, false);
		rmAddAreaConstraint(cliff1ID, cliffsAvoidCliffs);				
		rmSetAreaMinBlobs(cliff1ID, 1);
		rmSetAreaMaxBlobs(cliff1ID, 1);
		rmSetAreaMinBlobDistance(cliff1ID, 1.0);
		rmSetAreaMaxBlobDistance(cliff1ID, 1.0);
		rmSetAreaCoherence(cliff1ID, 0.85);
		rmSetAreaSmoothDistance(cliff1ID, 30);						
		rmSetAreaCoherence(cliff1ID, 0.85);
        
		rmSetAreaLocation(cliff1ID, 0.425, 0.775); 
		rmBuildArea(cliff1ID);

/*----------------------------------------------------------------------------------------------------------------*/		

	    // CLIFF NUMBER 2:
		int cliff2ID=rmCreateArea("cliff 2");
	    rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
		rmSetAreaWarnFailure(cliff2ID, false);
		rmSetAreaCliffType(cliff2ID, "Great Plains");
		rmAddAreaToClass(cliff2ID, rmClassID("classCliff"));
        //rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);		
		rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliff2ID, 8, 1.0, 1.0);
		rmSetAreaHeightBlend(cliff2ID, 1);
		//rmAddAreaTerrainLayer(cliff2ID, "texas\ground2_tex", 0, 2);
		rmSetAreaObeyWorldCircleConstraint(cliff2ID, false);
		rmAddAreaConstraint(cliff2ID, cliffsAvoidCliffs);				
		rmSetAreaMinBlobs(cliff2ID, 1);
		rmSetAreaMaxBlobs(cliff2ID, 1);
		rmSetAreaMinBlobDistance(cliff2ID, 1.0);
		rmSetAreaMaxBlobDistance(cliff2ID, 1.0);
		rmSetAreaCoherence(cliff2ID, 0.85);
		rmSetAreaSmoothDistance(cliff2ID, 30);						
		rmSetAreaCoherence(cliff2ID, 0.85);
        
		rmSetAreaLocation(cliff2ID, 0.775, 0.425); 
		rmBuildArea(cliff2ID);

/*----------------------------------------------------------------------------------------------------------------*/
		
        // CLIFF NUMBER 3:
		int cliff3ID=rmCreateArea("cliff 3");
	    rmSetAreaSize(cliff3ID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
		rmSetAreaWarnFailure(cliff3ID, false);
		rmSetAreaCliffType(cliff3ID, "Great Plains");
		rmAddAreaToClass(cliff3ID, rmClassID("classCliff"));
        //rmSetAreaCliffEdge(cliff3ID, 1, 1.0, 0.1, 1.0, 0);		
		rmSetAreaCliffEdge(cliff3ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff3ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliff3ID, 8, 1.0, 1.0);
		rmSetAreaHeightBlend(cliff3ID, 1);
		//rmAddAreaTerrainLayer(cliff3ID, "texas\ground2_tex", 0, 2);
		rmSetAreaObeyWorldCircleConstraint(cliff3ID, false);
		rmAddAreaConstraint(cliff3ID, cliffsAvoidCliffs);				
		rmSetAreaMinBlobs(cliff3ID, 1);
		rmSetAreaMaxBlobs(cliff3ID, 1);
		rmSetAreaMinBlobDistance(cliff3ID, 1.0);
		rmSetAreaMaxBlobDistance(cliff3ID, 1.0);
		rmSetAreaCoherence(cliff3ID, 0.85);
		rmSetAreaSmoothDistance(cliff3ID, 30);						
		rmSetAreaCoherence(cliff3ID, 0.85);
        
		rmSetAreaLocation(cliff3ID, 0.225, 0.575); 
		rmBuildArea(cliff3ID);	

/*----------------------------------------------------------------------------------------------------------------*/
		
		// CLIFF NUMBER 4:
		int cliff4ID=rmCreateArea("cliff 4");
	    rmSetAreaSize(cliff4ID, rmAreaTilesToFraction(1750), rmAreaTilesToFraction(1750));
		rmSetAreaWarnFailure(cliff4ID, false);
		rmSetAreaCliffType(cliff4ID, "Great Plains");
		rmAddAreaToClass(cliff4ID, rmClassID("classCliff"));
        //rmSetAreaCliffEdge(cliff4ID, 1, 1.0, 0.1, 1.0, 0);		
		rmSetAreaCliffEdge(cliff4ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff4ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliff4ID, 8, 1.0, 1.0);
		rmSetAreaHeightBlend(cliff4ID, 1);
		//rmAddAreaTerrainLayer(cliff4ID, "texas\ground2_tex", 0, 2);
		rmSetAreaObeyWorldCircleConstraint(cliff4ID, false);
		rmAddAreaConstraint(cliff4ID, cliffsAvoidCliffs);				
		rmSetAreaMinBlobs(cliff4ID, 1);
		rmSetAreaMaxBlobs(cliff4ID, 1);
		rmSetAreaMinBlobDistance(cliff4ID, 1.0);
		rmSetAreaMaxBlobDistance(cliff4ID, 1.0);
		rmSetAreaCoherence(cliff4ID, 0.85);
		rmSetAreaSmoothDistance(cliff4ID, 30);						
		rmSetAreaCoherence(cliff4ID, 0.85);
        
		rmSetAreaLocation(cliff4ID, 0.575, 0.225); 
		rmBuildArea(cliff4ID);
		
}		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int nuggetID= rmCreateObjectDef("nugget"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nuggetID, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nuggetID, avoidNugget);
	    rmAddObjectDefConstraint(nuggetID, pondConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidCloseCliffs);
		rmAddObjectDefConstraint(nuggetID, centerConstraint);
  	    rmAddObjectDefConstraint(nuggetID, playerConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
	    rmAddObjectDefConstraint(nuggetID, avoidSocket);
	    rmAddObjectDefConstraint(nuggetID, avoidNatives);
	    //rmAddObjectDefConstraint(nuggetID, circleConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidAll);
	    rmSetNuggetDifficulty(1, 3);
	    rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4); 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE SILVER MINES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // Place resources
	    // FAST COIN - three extra per player beyond starting resources.
	    int silverID = -1;
	    int silverCount = (cNumberNonGaiaPlayers*3);
	    rmEchoInfo("silver count = "+silverCount);

	    for(i=0; < silverCount)
	{
		silverType = rmRandInt(1,10);
		silverID = rmCreateObjectDef("silver "+i);
		rmAddObjectDefItem(silverID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID, 0.0);
		rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, avoidFastCoin);
		rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidCloseNugget);
		rmAddObjectDefConstraint(silverID, avoidCloseCliffs);
		rmAddObjectDefConstraint(silverID, playerConstraint);
		rmAddObjectDefConstraint(silverID, pondConstraint);
		rmAddObjectDefConstraint(silverID, avoidNatives);
		rmAddObjectDefConstraint(silverID, centerConstraint);
		rmAddObjectDefConstraint(silverID, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidSocket);
		rmAddObjectDefConstraint(silverID, coinForestConstraint);
		rmAddObjectDefConstraint(silverID, avoidStartingUnits);
		rmAddObjectDefConstraint(silverID, avoidNuggetSmall);
		int result = rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
		if(result == 0)
			break;
   }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE BISON HERDS: *************************************** //   
/*================================================================================================================*/

	    int bisonID=rmCreateObjectDef("bison herd");
        rmAddObjectDefItem(bisonID, "bison", rmRandInt(12,16), 12.0);
        rmSetObjectDefMinDistance(bisonID, 0.0);
        rmSetObjectDefMaxDistance(bisonID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(bisonID, avoidBison);
	    rmAddObjectDefConstraint(bisonID, avoidAll);
		rmAddObjectDefConstraint(bisonID, avoidCloseNugget);
		rmAddObjectDefConstraint(bisonID, avoidCloseCliffs);
		rmAddObjectDefConstraint(bisonID, playerConstraint);
		rmAddObjectDefConstraint(bisonID, pondConstraint);
		rmAddObjectDefConstraint(bisonID, avoidNatives);
		rmAddObjectDefConstraint(bisonID, centerConstraint);
		rmAddObjectDefConstraint(bisonID, avoidImpassableLand);
	    rmAddObjectDefConstraint(bisonID, avoidTradeRoute);
	    rmAddObjectDefConstraint(bisonID, avoidSocket);
	    rmAddObjectDefConstraint(bisonID, avoidStartingUnits);
	    rmAddObjectDefConstraint(bisonID, avoidNuggetSmall);
        rmSetObjectDefCreateHerd(bisonID, true);
	    rmPlaceObjectDefAtLoc(bisonID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE PRONGHORN HERDS: ************************************* //
/*================================================================================================================*/
	
        int pronghornID=rmCreateObjectDef("pronghorn herd");
        rmAddObjectDefItem(pronghornID, "pronghorn", rmRandInt(6,9), 10.0);
        rmSetObjectDefMinDistance(pronghornID, 0.0);
        rmSetObjectDefMaxDistance(pronghornID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(pronghornID, avoidBison);
        rmAddObjectDefConstraint(pronghornID, avoidPronghorn);
	    rmAddObjectDefConstraint(pronghornID, avoidAll);
		rmAddObjectDefConstraint(pronghornID, avoidCloseNugget);
		rmAddObjectDefConstraint(pronghornID, avoidCloseCliffs);
		rmAddObjectDefConstraint(pronghornID, playerConstraint);
		rmAddObjectDefConstraint(pronghornID, pondConstraint);
		rmAddObjectDefConstraint(pronghornID, avoidNatives);
		rmAddObjectDefConstraint(pronghornID, centerConstraint);
		rmAddObjectDefConstraint(pronghornID, avoidImpassableLand);
	    rmAddObjectDefConstraint(pronghornID, avoidTradeRoute);
	    rmAddObjectDefConstraint(pronghornID, avoidSocket);
	    rmAddObjectDefConstraint(pronghornID, avoidStartingUnits);
	    rmAddObjectDefConstraint(pronghornID, avoidNuggetSmall);
        rmSetObjectDefCreateHerd(pronghornID, true);
	    rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
		
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRIES: ***************************************** //
/*================================================================================================================*/

        int Berries1ID=rmCreateObjectDef("The Berries 1");
        rmAddObjectDefItem(Berries1ID, "berrybush", rmRandInt(5,7), 8.0);
        rmSetObjectDefMinDistance(Berries1ID, 0.0);
        rmSetObjectDefMaxDistance(Berries1ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(Berries1ID, avoidCloseBison);
		rmAddObjectDefConstraint(Berries1ID, avoidClosePronghorn);
		rmAddObjectDefConstraint(Berries1ID, avoidFarFruits);
	    rmAddObjectDefConstraint(Berries1ID, avoidAll);
		rmAddObjectDefConstraint(Berries1ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries1ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(Berries1ID, playerConstraint);
		rmAddObjectDefConstraint(Berries1ID, pondConstraint);
		rmAddObjectDefConstraint(Berries1ID, avoidNatives);
		rmAddObjectDefConstraint(Berries1ID, centerConstraint);
		rmAddObjectDefConstraint(Berries1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Berries1ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(Berries1ID, avoidSocket);
	    rmAddObjectDefConstraint(Berries1ID, avoidStartingUnits);
	    rmAddObjectDefConstraint(Berries1ID, avoidNuggetSmall);
        rmSetObjectDefCreateHerd(Berries1ID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*8);
		else
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);

/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE SHEEPS: ***************************************** //
/*================================================================================================================*/

        int Sheep1ID=rmCreateObjectDef("The Sheeps 1");
        rmAddObjectDefItem(Sheep1ID, "sheep", rmRandInt(5,7), 8.0);
        rmSetObjectDefMinDistance(Sheep1ID, 0.0);
        rmSetObjectDefMaxDistance(Sheep1ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(Sheep1ID, avoidBison);
		rmAddObjectDefConstraint(Sheep1ID, avoidPronghorn);
		rmAddObjectDefConstraint(Sheep1ID, avoidFarFruits);
	    rmAddObjectDefConstraint(Sheep1ID, avoidAll);
		rmAddObjectDefConstraint(Sheep1ID, avoidFarSheep);
		rmAddObjectDefConstraint(Sheep1ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Sheep1ID, avoidCloseCliffs);
		rmAddObjectDefConstraint(Sheep1ID, playerConstraint);
		rmAddObjectDefConstraint(Sheep1ID, pondConstraint);
		rmAddObjectDefConstraint(Sheep1ID, avoidNatives);
		rmAddObjectDefConstraint(Sheep1ID, centerConstraint);
		rmAddObjectDefConstraint(Sheep1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(Sheep1ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(Sheep1ID, avoidSocket);
	    rmAddObjectDefConstraint(Sheep1ID, avoidStartingUnits);
	    rmAddObjectDefConstraint(Sheep1ID, avoidNuggetSmall);
        rmSetObjectDefCreateHerd(Sheep1ID, true);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);
		else
		rmPlaceObjectDefAtLoc(Sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //		
/*================================================================================================================*/
        	
         int forestID = 0;
		 
		 if (cNumberNonGaiaPlayers<=2)
		 int numTries= 10*cNumberNonGaiaPlayers;
		 else
		 numTries= 6*cNumberNonGaiaPlayers;
		 
         int failCount=0;
         
		 for (i=0; <numTries)
      {   
         int forest=rmCreateArea("forest "+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(250), rmAreaTilesToFraction(400));
         rmSetAreaForestType(forest, "great plains forest");
		 rmSetAreaForestDensity(forest, 0.9);
         rmSetAreaForestClumpiness(forest, 0.8);
         rmSetAreaForestUnderbrush(forest, 0.0);
         rmSetAreaMinBlobs(forest, 1);
         rmSetAreaMaxBlobs(forest, 5);
         rmSetAreaMinBlobDistance(forest, 10.0);
         rmSetAreaMaxBlobDistance(forest, 30.0);
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest"));
         rmAddAreaConstraint(forest, avoidCloseCliffs);		 
         rmAddAreaConstraint(forest, forestConstraint);
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidCloseSheep);
		 rmAddAreaConstraint(forest, avoidCloseFruits);
		 rmAddAreaConstraint(forest, avoidCloseNugget);
		 rmAddAreaConstraint(forest, pondConstraint);
		 rmAddAreaConstraint(forest, avoidCoin);
		 rmAddAreaConstraint(forest, centerConstraint);
		 rmAddAreaConstraint(forest, playerConstraint);
         rmAddAreaConstraint(forest, avoidCloseNatives);
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidTradeRoute); 
		 rmAddAreaConstraint(forest, avoidSocket); 
		 rmAddAreaConstraint(forest, avoidStartingUnits); 
         if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      }  
	  
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE NORTH REGION:
		int randomTreeID=rmCreateObjectDef("random tree 1");
		rmAddObjectDefItem(randomTreeID, "TreeGreatPlains", 1, 0.0);
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseCliffs);   
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseImportantItem);
	    rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, pondConstraint);
		rmAddObjectDefConstraint(randomTreeID, centerConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidClosePronghorn);
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseBison);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFruits);
	    rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 48*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);	
		
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE GRASSY AREAS EVERYWHERE: ******************************* //   
/*================================================================================================================*/
	
	    numTries=6*cNumberNonGaiaPlayers;
	    failCount=0;
	    for (i=0; <numTries)
{   
		int grassyArea=rmCreateArea("grassyArea"+i);
		rmSetAreaWarnFailure(grassyArea, false);
		rmSetAreaSize(grassyArea, rmAreaTilesToFraction(75), rmAreaTilesToFraction(75));
		rmSetAreaForestType(grassyArea, "Great Plains grass");
		rmSetAreaForestDensity(grassyArea, 0.3);
		rmSetAreaForestClumpiness(grassyArea, 0.1);
		rmAddAreaConstraint(grassyArea, avoidClosePronghorn);
		rmAddAreaConstraint(grassyArea, avoidCloseBison);
		rmAddAreaConstraint(grassyArea, avoidCloseSheep);
		rmAddAreaConstraint(grassyArea, avoidCloseFruits);
		rmAddAreaConstraint(grassyArea, avoidCloseTrees);
		rmAddAreaConstraint(grassyArea, pondCloseConstraint);
		rmAddAreaConstraint(grassyArea, forestCloseConstraint);
		rmAddAreaConstraint(grassyArea, centerCloseConstraint);
		rmAddAreaConstraint(grassyArea, playerConstraint);
		rmAddAreaConstraint(grassyArea, avoidCloseImportantItem);
		rmAddAreaConstraint(grassyArea, avoidImpassableLand);
		rmAddAreaConstraint(grassyArea, avoidCloseCoin);
		rmAddAreaConstraint(grassyArea, avoidCloseCliffs);
		rmAddAreaConstraint(grassyArea, avoidTradeRoute);
		rmAddAreaConstraint(grassyArea, avoidSocket);
		rmAddAreaConstraint(grassyArea, avoidCloseNatives);
		rmAddAreaConstraint(grassyArea, avoidStartingUnits);
		rmAddAreaConstraint(grassyArea, avoidCloseNugget);
		if(rmBuildArea(grassyArea)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==5)
		break;
	}
		else
		failCount=0; 
}			

/*================================================================================================================*/
// ********************************* DEFINE AND PLACE A COUPLE OF GEYSERS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int geyserID=rmCreateGrouping("Geysers", "prop_geyser");
	    rmSetGroupingMinDistance(geyserID, 0.0);
	    rmSetGroupingMaxDistance(geyserID, rmXFractionToMeters(0.5));
	    rmAddGroupingConstraint(geyserID, avoidClosePronghorn);
	    rmAddGroupingConstraint(geyserID, avoidCloseSheep);
	    rmAddGroupingConstraint(geyserID, avoidCloseBison);
	    rmAddGroupingConstraint(geyserID, pondCloseConstraint);
		rmAddGroupingConstraint(geyserID, forestCloseConstraint);
		rmAddGroupingConstraint(geyserID, centerCloseConstraint);
		rmAddGroupingConstraint(geyserID, avoidCloseTrees);
		rmAddGroupingConstraint(geyserID, avoidCloseCoin);
		rmAddGroupingConstraint(geyserID, avoidCloseFruits);
	    rmAddGroupingConstraint(geyserID, avoidImpassableLand);
	    rmAddGroupingConstraint(geyserID, avoidTradeRoute);
	    rmAddGroupingConstraint(geyserID, avoidSocket);
		rmAddGroupingConstraint(geyserID, avoidAll);
		rmAddGroupingConstraint(geyserID, avoidCloseCliffs);
		rmAddGroupingConstraint(geyserID, avoidStartingUnits);
	    rmAddGroupingConstraint(geyserID, avoidCloseNugget);
	    rmAddGroupingConstraint(geyserID, playerConstraint);
		rmAddGroupingConstraint(geyserID, avoidCloseImportantItem);
	    //rmAddGroupingConstraint(geyserID, circleConstraint);
	    rmPlaceGroupingAtLoc(geyserID, 0, 0.5, 0.5, 2);
		
/*================================================================================================================*/
// *********************** DEFINE AND PLACE PERCHING VULTURES: - ADD A COUPLE SOMEWHERE: ************************ //
/*================================================================================================================*/
	
	    int vultureID=rmCreateObjectDef("perching vultures");
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(vultureID, avoidClosePronghorn);
	    rmAddObjectDefConstraint(vultureID, avoidCloseBison);
	    rmAddObjectDefConstraint(vultureID, avoidCloseSheep);
	    rmAddObjectDefConstraint(vultureID, pondCloseConstraint);
		rmAddObjectDefConstraint(vultureID, forestCloseConstraint);
		rmAddObjectDefConstraint(vultureID, avoidCloseImportantItem);
		rmAddObjectDefConstraint(vultureID, avoidCloseTrees);
		rmAddObjectDefConstraint(vultureID, avoidCloseFruits);
		rmAddObjectDefConstraint(vultureID, avoidAll);
		rmAddObjectDefConstraint(vultureID, avoidCloseCliffs);
		rmAddObjectDefConstraint(vultureID, avoidCloseCoin);
		rmAddObjectDefConstraint(vultureID, centerCloseConstraint);
		//rmAddObjectDefConstraint(vultureID, forestCloseconstraint);
	    rmAddObjectDefConstraint(vultureID, avoidCloseNugget);
	    rmAddObjectDefConstraint(vultureID, avoidImpassableLand);
	    rmAddObjectDefConstraint(vultureID, avoidTradeRoute);
	    rmAddObjectDefConstraint(vultureID, avoidSocket);
	    rmAddObjectDefConstraint(vultureID, avoidStartingUnits);
	    //rmAddObjectDefConstraint(vultureID, circleConstraint);
	    rmAddObjectDefConstraint(vultureID, playerConstraint);
	    rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 2);

/*================================================================================================================*/
// ******************** 50% CHANCE OF BUFFALO CARCASSES - EITHER ONE OR TWO IF THEY'RE THERE: ******************* //
/*================================================================================================================*/

	    int areThereBuffalo=rmRandInt(1, 2);
	    int howManyBuffalo=rmRandInt(1, 2);
	    if ( areThereBuffalo == 1 )
	{
		int bisonCarcass=rmCreateGrouping("Bison Carcass", "gp_carcass_bison");
		rmSetGroupingMinDistance(bisonCarcass, 0.0);
		rmSetGroupingMaxDistance(bisonCarcass, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(bisonCarcass, avoidClosePronghorn);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseBison);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseSheep);
		rmAddGroupingConstraint(bisonCarcass, pondCloseConstraint);
		rmAddGroupingConstraint(bisonCarcass, forestCloseConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseTrees);
		rmAddGroupingConstraint(bisonCarcass, centerCloseConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseFruits);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseCoin);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseImportantItem);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseCliffs);
		rmAddGroupingConstraint(bisonCarcass, avoidImpassableLand);
		rmAddGroupingConstraint(bisonCarcass, playerConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidTradeRoute);
		rmAddGroupingConstraint(bisonCarcass, avoidSocket);
		rmAddGroupingConstraint(bisonCarcass, avoidStartingUnits);
		rmAddGroupingConstraint(bisonCarcass, avoidAll);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseNugget);
		rmPlaceGroupingAtLoc(bisonCarcass, 0, 0.5, 0.5, howManyBuffalo);
	}
	
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE TWO GRASS PATCHES PER PLAYER: ******************************** //
/*================================================================================================================*/

	    int grassPatchGroupType=-1;
	    int grassPatchGroup=-1;
	
	    for(i=1; <2*cNumberNonGaiaPlayers)
   {
		grassPatchGroupType=rmRandInt(1, 7);
		grassPatchGroup=rmCreateGrouping("Grass Patch Group"+i, "gp_grasspatch0"+grassPatchGroupType);
		rmSetGroupingMinDistance(grassPatchGroup, 0.0);
		rmSetGroupingMaxDistance(grassPatchGroup, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(grassPatchGroup, avoidClosePronghorn);
		rmAddGroupingConstraint(grassPatchGroup, avoidCloseBison);
		rmAddGroupingConstraint(grassPatchGroup, avoidImpassableLand);
		rmAddGroupingConstraint(grassPatchGroup, playerConstraint);
		rmAddGroupingConstraint(grassPatchGroup, avoidTradeRoute);
		rmAddGroupingConstraint(grassPatchGroup, avoidSocket);
		rmAddGroupingConstraint(grassPatchGroup, avoidAll);
		rmAddGroupingConstraint(grassPatchGroup, avoidCloseTrees);
		rmAddGroupingConstraint(grassPatchGroup, forestCloseConstraint);
		rmAddGroupingConstraint(grassPatchGroup, avoidCloseNugget);
		//rmAddGroupingConstraint(grassPatchGroup, avoidCloseFruits);
		rmAddGroupingConstraint(grassPatchGroup, pondCloseConstraint);
		rmAddGroupingConstraint(grassPatchGroup, centerCloseConstraint);
		rmAddGroupingConstraint(grassPatchGroup, avoidCloseCoin);
		rmAddGroupingConstraint(grassPatchGroup, avoidCloseImportantItem);
		rmAddGroupingConstraint(grassPatchGroup, avoidCloseFruits);
		rmAddGroupingConstraint(grassPatchGroup, avoidCloseSheep);
		rmAddGroupingConstraint(grassPatchGroup, avoidStartingUnits);
		rmAddGroupingConstraint(grassPatchGroup, avoidCloseCliffs);
		rmPlaceGroupingAtLoc(grassPatchGroup, 0, 0.5, 0.5, 1);
	}
	
/*================================================================================================================*/
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE TWO FLOWERS PER PLAYER: *********************************** //
/*================================================================================================================*/

	    int flowerPatchGroupType=-1;
	    int flowerPatchGroup=-1;

	    for(i=1; <2*cNumberNonGaiaPlayers)
   {
		flowerPatchGroupType=rmRandInt(1, 8);
		flowerPatchGroup=rmCreateGrouping("Flower Patch Group"+i, "gp_flower0"+flowerPatchGroupType);
		rmSetGroupingMinDistance(flowerPatchGroup, 0.0);
		rmSetGroupingMaxDistance(flowerPatchGroup, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(flowerPatchGroup, avoidClosePronghorn);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCloseBison);
		rmAddGroupingConstraint(flowerPatchGroup, avoidImpassableLand);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCloseImportantItem);
		rmAddGroupingConstraint(flowerPatchGroup, playerConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidTradeRoute);
		rmAddGroupingConstraint(flowerPatchGroup, avoidSocket);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCloseNugget);
		rmAddGroupingConstraint(flowerPatchGroup, avoidAll);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCloseTrees);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCloseFruits);
		rmAddGroupingConstraint(flowerPatchGroup, centerCloseConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, pondCloseConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCloseCoin);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCloseCliffs);
		rmAddGroupingConstraint(flowerPatchGroup, forestCloseConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidStartingUnits);
		//rmAddGroupingConstraint(flowerPatchGroup, playerConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCloseSheep);
		rmPlaceGroupingAtLoc(flowerPatchGroup, 0, 0.5, 0.5, 1);
	}
/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE FISHBASS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		









