/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/

// THE NEW WORLD:
// CREATED BY DANY:
// AUGUST 2007:
// A RANDOM MAP FOR AGE OF EMPIRES III: MY 58TH RMS:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// *********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE VARIATION WHICHMAP:
		// ONLY 2 VARIATIONS:
		
		int whichMap=rmRandInt(1,2);		
		
/*----------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(4) == true)
		
{
		if ( whichMap == 1 )
	{	
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");
		
		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee");
		
		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");
		
		subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cherokee");
	}
	
        else
		
	{	
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");
				
		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois");
		
		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Iroquois");
	}	
} 		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ******************************************* PICKS THE MAP SIZE: ********************************************** //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

    	int playerTiles=17500;
   
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.06);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
	
    {	
		// FIRST TERRAIN: BASED ON THE OF THE RMS OF NEW ENGLAND:
		
		// PICKS DEFAULT TERRAIN AND WATER:
        rmSetSeaType("new england coast");
   
	    // SOME MAP TURBULENCE:
	    rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);  // LIKE TEXAS FOR THE MOMENT:
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1.0);

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(4.0);
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("new_england\ground1_ne", 1.0); // FROM NEW ENGLAND:
	    
		// SET THE MAP TYPE:
		rmSetMapType("newEngland");
	    rmSetMapType("water");
		rmSetMapType("grass");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2.0);
	    
		// SET THE LIGHTING:
		rmSetLightingSet("new england");
		
	    // CHOOSE THE MERCS:
	    chooseMercs();
	}	
	    else

    {	
		// SECOND TERRAIN: BASED ON THE RMS OF SAGUENAY: 
		
		// PICKS DEFAULT TERRAIN AND WATER:
		rmSetSeaType("hudson bay");
           
	    // SOME MAP TURBULENCE:
	    rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0);
			    
		// PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(1.0);
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
		
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("saguenay tundra");
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("saguenay\ground1_sag",10);
			    
		// SET THE MAP TYPE:
		rmSetMapType("saguenay");
		rmSetMapType("water");
		rmSetMapType("grass");
	    
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2.0);
	    
		// SET THE LIGHTING:
		rmSetLightingSet("saguenay");
		
	    // CHOOSE THE MERCS:
	    chooseMercs();
	}			

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("classCliff");
        rmDefineClass("classWall");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("socketClass");
	    rmDefineClass("nuggets");
        rmDefineClass("natives");

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER ************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
           
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
        int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 12.0);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);

        // CARDINAL DIRECTIONS:
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
				
		// FOREST AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
        		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
	    // COIN AVOIDANCE:
		int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "mine", 30.0);
        int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "mine", 10);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoids coin", "mine", 2.0);
				
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 10.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);
		int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 20.0);
        		
		// COWS AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
		
		// SHEEPS AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// TURKEYS AVOIDANCE:
		int avoidTurkeys=rmCreateTypeDistanceConstraint("stuffs avoids turkeys", "turkey", 10.0);
		int avoidCloseTurkeys=rmCreateTypeDistanceConstraint("close avoids turkeys", "turkey", 2.0);
				
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// MOOSE AVOIDANCE:
		int avoidMoose=rmCreateTypeDistanceConstraint("stuff avoids moose", "moose", 10.0);
		int avoidCloseMoose=rmCreateTypeDistanceConstraint("close avoids moose", "moose", 2.0);
		
		// UNIT AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 5.0);

        // AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	    int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	    
		// CLIFFS AVOIDANCE:
		int avoidCliffs=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 15.0);
		int avoidCloseCliffs=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 8.0);
	    		
		// UNIT AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
        
		// IMPORTANT AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 6.0);
	    
		// SOCKETS AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 6.0);
		int avoidCloseSocket=rmCreateClassDistanceConstraint("close avoid sockets", rmClassID("socketClass"), 2.0);

        // WALL CONSTRAINT:
		int wallConstraint=rmCreateClassDistanceConstraint("wall vs. wall", rmClassID("classWall"), 10.0);
	    int avoidCloseWall=rmCreateClassDistanceConstraint("close avoids wall", rmClassID("classWall"), 2.0);
	   		
		// CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
	    
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ********************************************* DEFINE THE AREAS: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// ************************************ SET UP PLAYER STARTING LOCATIONS: *************************************** //
/*================================================================================================================*/
 	    
	    if ( whichMap == 1 )
					
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.775,0.775);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.225,0.225);
	}  
		else
    {		
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.225,0.225);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.775,0.775);
	} 	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/		
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(100);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		// rmAddAreaConstraint(id, playerConstraint); 
        // rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// *************************************** DEFINE THE PLACEMENT ORDER: ****************************************** //
/*================================================================================================================*/		

   // Placement order:
   // Trade route -> Lakes -> Natives -> Secrets -> Cliffs -> Nuggets
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// ************************************** DEFINE AND PLACE 4 TRADE ROUTES: ************************************** //
/*================================================================================================================*/

        int tradeRouteID = rmCreateTradeRoute();
		
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.125, 0.325);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.125, 0.675);
	
	    bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
	    rmEchoError("Failed to place trade route #1");
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	    int tradeRouteID2 = rmCreateTradeRoute();
	
	    rmAddTradeRouteWaypoint(tradeRouteID2, 0.325, 0.875);
	    rmAddTradeRouteWaypoint(tradeRouteID2, 0.675, 0.875);
		
	    bool placedTradeRoute2 = rmBuildTradeRoute(tradeRouteID2, "carolinas\trade_route");
	    if(placedTradeRoute2 == false)
	    rmEchoError("Failed to place trade route #2");
	
/*================================================================================================================*/
    
	    int tradeRouteID3 = rmCreateTradeRoute();
	
	    rmAddTradeRouteWaypoint(tradeRouteID3, 0.875, 0.675);
	    rmAddTradeRouteWaypoint(tradeRouteID3, 0.875, 0.325);
		
	    bool placedTradeRoute3 = rmBuildTradeRoute(tradeRouteID3, "carolinas\trade_route");
	    if(placedTradeRoute3 == false)
	    rmEchoError("Failed to place trade route #3");

/*----------------------------------------------------------------------------------------------------------------*/

        int tradeRouteID4 = rmCreateTradeRoute();
	
	    rmAddTradeRouteWaypoint(tradeRouteID4, 0.675, 0.125);
	    rmAddTradeRouteWaypoint(tradeRouteID4, 0.325, 0.125);
		
	    bool placedTradeRoute4 = rmBuildTradeRoute(tradeRouteID4, "carolinas\trade_route");
	    if(placedTradeRoute4 == false)
	    rmEchoError("Failed to place trade route #4");	
	
/*----------------------------------------------------------------------------------------------------------------*/

	    // DEFINE THE TRADE SOCKETS:
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 6.0);
   
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************** add the meeting poles along the trade route. ****************************** //
/*----------------------------------------------------------------------------------------------------------------*/

        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   
        rmClearClosestPointConstraints();
   
/*----------------------------------------------------------------------------------------------------------------*/

        // change the trade route for the new sockets
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID2);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID2, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints();
   
/*================================================================================================================*/

        // change the trade route for the new sockets
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID3);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID3, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints(); 

/*----------------------------------------------------------------------------------------------------------------*/

        // change the trade route for the new sockets
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID4);
	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID4, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        rmClearClosestPointConstraints();        

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE LAKE IN THE MIDDLE: ********************************** //
// ********************************** DEFINE AND PLACE THE RIVER IN THE MIDDLE: ********************************* //
/*================================================================================================================*/
        
		if ( whichMap == 1 )
					
	{	
		// DEFINE AND PLACE THE LAKE IN THE CENTER OF THE MAP:
		
		int lakeClass=rmDefineClass("lake");
	    int lakeConstraint=rmCreateClassDistanceConstraint("lake vs. lake", rmClassID("lake"), 20.0);

        int smallLakeID=rmCreateArea("small lake");
		rmSetAreaSize(smallLakeID, rmAreaTilesToFraction(3500), rmAreaTilesToFraction(3500));
		rmSetAreaWaterType(smallLakeID, "new england lake");
		rmSetAreaBaseHeight(smallLakeID, 2.0);
		rmAddAreaToClass(smallLakeID, lakeClass);
		rmAddAreaConstraint(smallLakeID, playerConstraint);
		//rmAddAreaConstraint(smallLakeID, avoidTradeRoute);
		rmSetAreaLocation(smallLakeID, 0.50, 0.50);
		rmSetAreaCoherence(smallLakeID, 1.0);
		rmSetAreaWarnFailure(smallLakeID, false);
		rmBuildArea(smallLakeID);
    }
		
    else
	
	
	{
	    // DEFINE AND PLACE THE RIVER IN THE CENTER OF THE MAP:  
		
		int amazonRiver = rmRiverCreate(-1, "saguenay lake", 1, 1, 15, 15);
	
        rmRiverSetConnections(amazonRiver, 0.15, 0.85, 0.85, 0.15);
      
        rmRiverSetShallowRadius(amazonRiver, 10);
   
        rmRiverAddShallow(amazonRiver, rmRandFloat(0.5, 0.5));
        
		rmRiverSetBankNoiseParams(amazonRiver, 0.07, 2, 1.5, 20.0, 0.667, 2.0);
   
        rmRiverBuild(amazonRiver);
	}	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE CLIFFS: ***************************************** //
/*================================================================================================================*/

        int cliffID=rmCreateArea("cliff");
        rmSetAreaSize(cliffID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
        rmSetAreaWarnFailure(cliffID, false);
	    rmSetAreaCliffType(cliffID, "New England");
	    rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffID, 1);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffID, avoidCliffs);
	    rmSetAreaMinBlobs(cliffID, 1);
        rmSetAreaMaxBlobs(cliffID, 1);
        rmSetAreaMinBlobDistance(cliffID, 1);
        rmSetAreaMaxBlobDistance(cliffID, 1);
        rmSetAreaSmoothDistance(cliffID, 10);
        rmSetAreaCoherence(cliffID, 0.95);
		rmSetAreaLocation(cliffID, 0.65, 0.65);
		rmBuildArea(cliffID);

/*----------------------------------------------------------------------------------------------------------------*/

        int cliff2ID=rmCreateArea("cliff 2");
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
        rmSetAreaWarnFailure(cliff2ID, false);
	    rmSetAreaCliffType(cliff2ID, "New England");
	    rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff2ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff2ID, 1);
        rmAddAreaToClass(cliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff2ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff2ID, 1);
        rmSetAreaMaxBlobs(cliff2ID, 1);
        rmSetAreaMinBlobDistance(cliff2ID, 1);
        rmSetAreaMaxBlobDistance(cliff2ID, 1);
        rmSetAreaSmoothDistance(cliff2ID, 10);
        rmSetAreaCoherence(cliff2ID, 0.95);
		rmSetAreaLocation(cliff2ID, 0.35, 0.35);
		rmBuildArea(cliff2ID);

/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
		
	{	
		int cliff3ID=rmCreateArea("cliff 3");
        rmSetAreaSize(cliff3ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
        rmSetAreaWarnFailure(cliff3ID, false);
	    rmSetAreaCliffType(cliff3ID, "New England");
	    rmSetAreaCliffEdge(cliff3ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff3ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff3ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff3ID, 1);
        rmAddAreaToClass(cliff3ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff3ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff3ID, 1);
        rmSetAreaMaxBlobs(cliff3ID, 1);
        rmSetAreaMinBlobDistance(cliff3ID, 1);
        rmSetAreaMaxBlobDistance(cliff3ID, 1);
        rmSetAreaSmoothDistance(cliff3ID, 10);
        rmSetAreaCoherence(cliff3ID, 0.95);
		rmSetAreaLocation(cliff3ID, 0.325, 0.675);
		rmBuildArea(cliff3ID);
	}	

/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
		
    {    
		int cliff4ID=rmCreateArea("cliff 4");
        rmSetAreaSize(cliff4ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
        rmSetAreaWarnFailure(cliff4ID, false);
	    rmSetAreaCliffType(cliff4ID, "New England");
	    rmSetAreaCliffEdge(cliff4ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliff4ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff4ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff4ID, 1);
        rmAddAreaToClass(cliff4ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff4ID, avoidCliffs);
	    rmSetAreaMinBlobs(cliff4ID, 1);
        rmSetAreaMaxBlobs(cliff4ID, 1);
        rmSetAreaMinBlobDistance(cliff4ID, 1);
        rmSetAreaMaxBlobDistance(cliff4ID, 1);
        rmSetAreaSmoothDistance(cliff4ID, 10);
        rmSetAreaCoherence(cliff4ID, 0.95);
		rmSetAreaLocation(cliff4ID, 0.675, 0.325);
		rmBuildArea(cliff4ID);
		
	}	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.51);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE GOLD MINES: ************************************** //
// ************************************* DEFINE AND PLACE THE SILVER MINES: ************************************* //		
/*================================================================================================================*/

        if ( whichMap == 1 )
		
	{		
		// THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.05, 0.50);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.50, 0.05);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.50, 0.95);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.95, 0.50); 
		
	}

    else

	{
	     // THE SILVER MINE NUMBER 1:
		int silver1ID = rmCreateObjectDef("silver 1");
		rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver1ID, 0.0);
		rmSetObjectDefMaxDistance(silver1ID, 0.0);
		rmAddObjectDefConstraint(silver1ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.05, 0.50);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.50, 0.05);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.50, 0.95);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.95, 0.50);
	}	

/*----------------------------------------------------------------------------------------------------------------*/

            if ( whichMap == 1 )
		
	{		
		// THE GOLD MINE NUMBER 2:
		int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.25, 0.45);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.45, 0.25);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.55, 0.75);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.75, 0.55); 
		
	}

    else

	{
	     // THE SILVER MINE NUMBER 2:
		int silver2ID = rmCreateObjectDef("silver 2");
		rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver2ID, 0.0);
		rmSetObjectDefMaxDistance(silver2ID, 0.0);
		rmAddObjectDefConstraint(silver2ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.25, 0.45);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.45, 0.25);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.55, 0.75);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.75, 0.55);
	}	
	
/*----------------------------------------------------------------------------------------------------------------*/

                if ( whichMap == 1 )
		
	{		
		// THE GOLD MINE NUMBER 3:
		int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.65, 0.65);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.35, 0.35);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.325, 0.675);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.675, 0.325); 
		
	}

    else

	{
	     // THE SILVER MINE NUMBER 3:
		int silver3ID = rmCreateObjectDef("silver 3");
		rmAddObjectDefItem(silver3ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silver3ID, 0.0);
		rmSetObjectDefMaxDistance(silver3ID, 0.0);
		rmAddObjectDefConstraint(silver3ID, avoidCoin);
				
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.65, 0.65);
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.35, 0.35);
		//rmPlaceObjectDefAtLoc(silver3ID, 0, 0.325, 0.675);
		//rmPlaceObjectDefAtLoc(silver3ID, 0, 0.325, 0.675);
	}		
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVE AMERICANS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if ( whichMap == 1 )
	
{	    
        if (subCiv0 == rmGetCivID("cherokee"))
	{	
	    int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.20, 0.50);
	} 
}        
		else
{		
    	if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.20, 0.50);
	} 
}	
	
/*----------------------------------------------------------------------------------------------------------------*/	
	    if ( whichMap == 1 )
	
{	    
        if (subCiv1 == rmGetCivID("cherokee"))
		
	{	
	    int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.50, 0.80);
	} 
}        
		else
		
{  
	    if (subCiv1 == rmGetCivID("iroquois"))
		
	{	
	    int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.50, 0.80);
	}	
} 	
/*----------------------------------------------------------------------------------------------------------------*/
	    if ( whichMap == 1 )
{		
	    if (subCiv2 == rmGetCivID("cherokee"))
	{	
	    int cherokee3VillageID = -1;
		cherokee3VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee3VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee3VillageID, 0.0);
		rmAddGroupingToClass(cherokee3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee3VillageID, 0, 0.80, 0.50);
	} 
}	
		
		else
		
{		
		if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.80, 0.50);
	} 
}
	
/*----------------------------------------------------------------------------------------------------------------*/	
        if ( whichMap == 1 )

{		
	    if (subCiv3 == rmGetCivID("cherokee"))
	{	
	    int cherokee4VillageID = -1;
		cherokee4VillageID = rmCreateGrouping("cherokee village 4", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee4VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee4VillageID, 0.0);
		rmAddGroupingToClass(cherokee4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee4VillageID, 0, 0.50, 0.20);
	} 
}	
		
		else
		
{		
		if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.50, 0.20);
	} 
}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/   
// ******************** DEFINE THE STARTING UNITS AND STARTING TCID AND STARTING RESOURCES: ********************* //
/*================================================================================================================*/

        // DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    
		if ( whichMap == 1 )
		rmAddObjectDefItem(StartAreaTreeID, "TreeNewEngland", 1, 0.0);
	    else
		rmAddObjectDefItem(StartAreaTreeID, "TreeSaguenay", 1, 0.0);
		
		rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING BERRIES:
		int StartBerriesID=rmCreateObjectDef("starting Berries");
		
	    if ( whichMap == 1 )
		rmAddObjectDefItem(StartBerriesID, "BerryBush", rmRandInt(3,5), 5.0);
		else
		rmAddObjectDefItem(StartBerriesID, "deer", rmRandInt(3,5), 5.0);
	    
		rmSetObjectDefMinDistance(StartBerriesID, 10.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 15.0);
	    rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnitsSmall);
	
	    // DEFINE THE STARTING FAR BERRIES:
		int StartFarBerriesID=rmCreateObjectDef("starting FarBerries");
	    
		if ( whichMap == 1 )
		rmAddObjectDefItem(StartFarBerriesID, "BerryBush", rmRandInt(3,5), 5.0);
	    else
		rmAddObjectDefItem(StartFarBerriesID, "deer", rmRandInt(3,5), 5.0);
		
		rmSetObjectDefMinDistance(StartFarBerriesID, 16.0);
	    rmSetObjectDefMaxDistance(StartFarBerriesID, 20.0);
	    rmAddObjectDefConstraint(StartFarBerriesID, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
		
		// DEFINE VARIABLES FOR THE PLAYER GOLD:
		int silverType = -1;
	    int playerGoldID = -1;
	
/*================================================================================================================*/
// ************************ PLACE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ********************** //	
/*================================================================================================================*/
	
	    for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();
		
		// PLACE STARTING UNITS AND TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// EVERYONE GETS ONE ORE GROUPING CLOSE BY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		rmSetObjectDefMinDistance(playerGoldID, 25.0);
		rmSetObjectDefMaxDistance(playerGoldID, 30.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartFarBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
					
		rmClearClosestPointConstraints();
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM BERRIES: ************************************* //
// *********************************** DEFINE AND PLACE THE RANDOM TURKEYS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		if ( whichMap == 1 )
		
	{	
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.1, 0.3);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.3, 0.1);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.1, 0.7);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.7, 0.1);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.3, 0.9);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.9, 0.3);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.7, 0.9);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.9, 0.7);
	}
        else
		
	{
        int turkey1ID = rmCreateObjectDef("The Turkeys 1");
		rmAddObjectDefItem(turkey1ID, "turkey", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(turkey1ID, 0.0);
		rmSetObjectDefMaxDistance(turkey1ID, 0.0);
		rmAddObjectDefConstraint(turkey1ID, avoidTurkeys);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.1, 0.3);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.3, 0.1);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.1, 0.7);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.7, 0.1);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.3, 0.9);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.9, 0.3);
		
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.7, 0.9);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.9, 0.7);
    }
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE COWS: ********************************************* //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
		
	{	
		int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmSetObjectDefCreateHerd(cow1ID, true);
	    
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.2, 0.4);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.4, 0.2);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.6, 0.8);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.8, 0.6);
	}
        else
		
	{	
		int sheep1ID=rmCreateObjectDef("The Sheeps 1");
        rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(sheep1ID, 0.0);
        rmSetObjectDefMaxDistance(sheep1ID, 0.0);
	    rmAddObjectDefConstraint(sheep1ID, avoidSheep);
		rmSetObjectDefCreateHerd(sheep1ID, true);
	    
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.2, 0.4);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.4, 0.2);
        
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.6, 0.8);
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.8, 0.6);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/
	
	    if ( whichMap == 1 )
		
	{	
		int cow2ID=rmCreateObjectDef("The Cows 2");
        rmAddObjectDefItem(cow2ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow2ID, 0.0);
        rmSetObjectDefMaxDistance(cow2ID, 0.0);
	    rmAddObjectDefConstraint(cow2ID, avoidCow);
		rmSetObjectDefCreateHerd(cow2ID, true);
	    
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.075, 0.625);
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.625, 0.075);
        
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.375, 0.925);
        rmPlaceObjectDefAtLoc(cow2ID, 0, 0.925, 0.375);
	}
        else
		
	{	
		int sheep2ID=rmCreateObjectDef("The Sheeps 2");
        rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(sheep2ID, 0.0);
        rmSetObjectDefMaxDistance(sheep2ID, 0.0);
	    rmAddObjectDefConstraint(sheep2ID, avoidSheep);
		rmSetObjectDefCreateHerd(sheep2ID, true);
	    
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.075, 0.625);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.625, 0.075);
        
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.375, 0.925);
        rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.925, 0.375);
	}	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
	
	{	
		int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.25, 0.55);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.55, 0.25);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.45, 0.75);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.75, 0.45);
	}

        else
		
	{
    	int moose1ID=rmCreateObjectDef("The Moose Herds 1");
        rmAddObjectDefItem(moose1ID, "moose", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(moose1ID, 0.0);
        rmSetObjectDefMaxDistance(moose1ID, 0.0);
	    rmAddObjectDefConstraint(moose1ID, avoidMoose);
		rmSetObjectDefCreateHerd(moose1ID, true);
	    
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.25, 0.55);
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.55, 0.25);
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.45, 0.75);
		rmPlaceObjectDefAtLoc(moose1ID, 0, 0.75, 0.45);
    }	
		
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
		
	{	
     	int deer2ID=rmCreateObjectDef("The Deer Herds 2");
        rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, 0.0);
	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer2ID, true);
	    
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.10, 0.50);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.50, 0.10);
        rmPlaceObjectDefAtLoc(deer2ID, 0, 0.50, 0.90);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.90, 0.50);
    }		
        else
		
	{   
	    int moose2ID=rmCreateObjectDef("The Moose Herds 2");
        rmAddObjectDefItem(moose2ID, "moose", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(moose2ID, 0.0);
        rmSetObjectDefMaxDistance(moose2ID, 0.0);
	    rmAddObjectDefConstraint(moose2ID, avoidMoose);
		rmSetObjectDefCreateHerd(moose2ID, true);
	    
		rmPlaceObjectDefAtLoc(moose2ID, 0, 0.10, 0.50);
		rmPlaceObjectDefAtLoc(moose2ID, 0, 0.50, 0.10);
		rmPlaceObjectDefAtLoc(moose2ID, 0, 0.50, 0.90);
		rmPlaceObjectDefAtLoc(moose2ID, 0, 0.90, 0.50);
    }
	
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
		
		int deer3ID=rmCreateObjectDef("The Deer Herds 3");
        rmAddObjectDefItem(deer3ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer3ID, 0.0);
        rmSetObjectDefMaxDistance(deer3ID, 0.0);
	    rmAddObjectDefConstraint(deer3ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer3ID, true);
	    
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.25, 0.75);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.75, 0.25);
        //rmPlaceObjectDefAtLoc(deer3ID, 0, 0.65, 0.85);
		//rmPlaceObjectDefAtLoc(deer3ID, 0, 0.85, 0.65); 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TREASURES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.05, 0.45);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.45, 0.05);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.55, 0.95);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.95, 0.55);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.175, 0.625);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.625, 0.175);
		
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.375, 0.825);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.825, 0.375);
		
/*----------------------------------------------------------------------------------------------------------------*/

        if ( whichMap == 1 )
		
	{	
		// THE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.2, 0.8);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.8, 0.2);
		
		//rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.30, 0.60);
		//rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.60, 0.30);
    }	

/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 4:
		int nugget4ID= rmCreateObjectDef("nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
	    rmAddObjectDefConstraint(nugget4ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.275, 0.575);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.575, 0.275);
		
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.725, 0.425);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.425, 0.725);	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE SOME ROCK WALLS: ************************************** //
/*===============================================================================================================*/

	    int stoneWallType = -1;
	    int stoneWallID = -1;
	    int stoneWallCount = cNumberNonGaiaPlayers*2;
        rmEchoInfo("stoneWall count = "+stoneWallCount);

	    for(i=0; < stoneWallCount)
   {
		stoneWallType = rmRandInt(1,4);
        stoneWallID = rmCreateGrouping("stone wall "+i, "ne_rockwall "+stoneWallType);
		rmAddGroupingToClass(stoneWallID, rmClassID("classWall"));
        rmSetGroupingMinDistance(stoneWallID, 0.0);
        rmSetGroupingMaxDistance(stoneWallID, 0.0);
		rmAddGroupingConstraint(stoneWallID, wallConstraint);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.6, 0.9);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.9, 0.6);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.1, 0.4);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.4, 0.1);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.3, 0.5);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.5, 0.3);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.5, 0.7);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.7, 0.5);
   }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/

        int forestTreeID = 0;
        int numTries=8*cNumberNonGaiaPlayers;
        int failCount=0;
	    
		for (i=0; <numTries)
    {   
        int forest=rmCreateArea("The Forest 1"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        
		if ( whichMap == 1 )
		rmSetAreaForestType(forest, "new england forest");
		else
		rmSetAreaForestType(forest, "saguenay forest");
		
		rmSetAreaForestDensity(forest, 0.85);
        rmSetAreaForestClumpiness(forest, 0.10);
        rmSetAreaForestUnderbrush(forest, 0.6);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 2);
        rmSetAreaMinBlobDistance(forest, 1);
        rmSetAreaMaxBlobDistance(forest, 2);
        rmSetAreaCoherence(forest, 0.25);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
        rmAddAreaConstraint(forest, avoidCloseCliffs);
        rmAddAreaConstraint(forest, avoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest, avoidCloseSocket);
		rmAddAreaConstraint(forest, Northward);
		 
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  
	
/*----------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries)
    {   
        int forest2=rmCreateArea("The Forest 2"+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        
		if ( whichMap == 1 )
		rmSetAreaForestType(forest2, "new england forest");
		else
		rmSetAreaForestType(forest2, "saguenay forest");
		
		rmSetAreaForestDensity(forest2, 0.85);
        rmSetAreaForestClumpiness(forest2, 0.10);
        rmSetAreaForestUnderbrush(forest2, 0.6);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 2);
        rmSetAreaMinBlobDistance(forest2, 1);
        rmSetAreaMaxBlobDistance(forest2, 2);
        rmSetAreaCoherence(forest2, 0.25);
        rmSetAreaSmoothDistance(forest2, 10);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, avoidCloseSocket);
        rmAddAreaConstraint(forest2, avoidCloseCliffs);
        rmAddAreaConstraint(forest2, avoidImpassableLand); 
        rmAddAreaConstraint(forest2, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest2, Southward);
		 
        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  
 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FISH AND THE WHALES: ********************************* //
/*================================================================================================================*/

        // DEFINE THE FISH AND WHALES CONSTRAINTS:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 10.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        //int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 25.0);
        //int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	
/*----------------------------------------------------------------------------------------------------------------*/		

        // FISHBASS -- FOOD:
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishBass", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*10);
		
/*----------------------------------------------------------------------------------------------------------------*/		

/*
	    // FAST COIN -- WHALES:
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1);
*/

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ******************************************* //
/*================================================================================================================*/  
