/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
 
// THE PRAIRIES:
// ANALYZED BY DANY:
// OCTOBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
	    int subCiv3=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/		
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // ALL INCAS ALL THE TIME:
        if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");

		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee");

		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");

		subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "cherokee");
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ********************************************* PICKS THE MAP SIZE: ******************************************** //
/*================================================================================================================*/

	    int playerTiles=22500;
	    
		if (cNumberNonGaiaPlayers<=2)
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    else
		size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    
		rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(600, 600);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** PICKS THE MAP PARAMETERS: ******************************************* //		
/*================================================================================================================*/
	
	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(0.0);	
		
		// SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0);
	    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2);

	    // SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("great plains drygrass");
		        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("yukon\ground1_yuk", 5);
			    
		// SET MAP TYPE:
		rmSetMapType("greatPlains");
		rmSetMapType("grass");
	    rmSetMapType("land");
        
		// SET LIGHTING:
		rmSetLightingSet("great plains");
		
	    // Make the corners.
	    rmSetWorldCircleConstraint(true);

	    // CHOOSE MERCS:
	    chooseMercs();
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/

        int classPlayer=rmDefineClass("player");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("classSocket");
		rmDefineClass("classTrees");
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/
   
    // MAP EDGE CONSTRAINTS:
    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
	int playerCloseEdgeConstraint=rmCreatePieConstraint("close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
	int playerVeryCloseEdgeConstraint=rmCreatePieConstraint("very close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.495), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
	// CARDINAL DIRECTIONS:
	int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.75, 0.75, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	// PLAYER CONSTRAINTS:
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 15.0);
	int playerCloseConstraint=rmCreateClassDistanceConstraint("close avoid players", classPlayer, 8.0);
	int playerFarConstraint=rmCreateClassDistanceConstraint("far avoid players", classPlayer, 50.0);
 
    // NATURE AVOIDANCE:
	int forestConstraint=rmCreateClassDistanceConstraint("stuff avoids forest", rmClassID("classForest"), 15.0);
	int forestCloseConstraint=rmCreateClassDistanceConstraint("close avoids forest", rmClassID("classForest"), 8.0);
	int forestMediumConstraint=rmCreateClassDistanceConstraint("medium avoids forest", rmClassID("classForest"), 30.0);
	
	// TREES AVOIDANCE:
	int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 15.0);
	int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 8.0);
	int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 3.0);
	int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
	int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
	int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
		
	// BISON AVOIDANCE:
	int avoidBison=rmCreateTypeDistanceConstraint("stuff avoids bison", "bison", 15.0);
	int avoidCloseBison=rmCreateTypeDistanceConstraint("close avoids bison", "bison", 8.0);
	int avoidVeryCloseBison=rmCreateTypeDistanceConstraint("very close avoids bison", "bison", 3.0);
	int avoidMediumBison=rmCreateTypeDistanceConstraint("medium avoids bison", "bison", 30.0);
	int avoidFarBison=rmCreateTypeDistanceConstraint("far avoids bison", "bison", 60.0);
	int avoidVeryFarBison=rmCreateTypeDistanceConstraint("very far avoids bison", "bison", 90.0);
	int avoidSuperFarBison=rmCreateTypeDistanceConstraint("super far avoids bison", "bison", 120.0);
	
	// COW AVOIDANCE:
	int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 15.0);
	int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 8.0);
	int avoidVeryCloseCow=rmCreateTypeDistanceConstraint("very close avoids cow", "cow", 3.0);
	int avoidMediumCow=rmCreateTypeDistanceConstraint("medium avoids cow", "cow", 30.0);
	int avoidFarCow=rmCreateTypeDistanceConstraint("far avoids cow", "cow", 60.0);
	int avoidVeryFarCow=rmCreateTypeDistanceConstraint("very far avoids cow", "cow", 90.0);
	int avoidSuperFarCow=rmCreateTypeDistanceConstraint("super far avoids cow", "cow", 120.0);
	
	// PRONGHORN AVOIDANCE:
	int avoidPronghorn=rmCreateTypeDistanceConstraint("stuff avoids pronghorn", "pronghorn", 15.0);
	int avoidClosePronghorn=rmCreateTypeDistanceConstraint("close avoids pronghorn", "pronghorn", 8.0);
	int avoidVeryClosePronghorn=rmCreateTypeDistanceConstraint("very close avoids pronghorn", "pronghorn", 3.0);
	int avoidMediumPronghorn=rmCreateTypeDistanceConstraint("medium avoids pronghorn", "pronghorn", 30.0);
	int avoidFarPronghorn=rmCreateTypeDistanceConstraint("far avoids pronghorn", "pronghorn", 60.0);
	int avoidVeryFarPronghorn=rmCreateTypeDistanceConstraint("very far avoids pronghorn", "pronghorn", 90.0);
	int avoidSuperFarPronghorn=rmCreateTypeDistanceConstraint("super far avoids pronghorn", "pronghorn", 120.0);
	
	// COIN AVOIDANCE:
	int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "gold", 15.0);
	int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "gold", 8.0);
	int avoidVeryCloseCoin=rmCreateTypeDistanceConstraint("very close avoid coin", "gold", 3.0);
	int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "gold", 30.0);
	int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "gold", 60.0);
	int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoid coin", "gold", 90.0);
	int avoidSuperFarCoin=rmCreateTypeDistanceConstraint("super far avoid coin", "gold", 120.0);
	
	// BERRYBUSH AVOIDANCE:
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids berrybush", "BerryBush", 25.0);
	int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids berrybush", "BerryBush", 15.0);
	int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoids berrybush", "BerryBush", 8.0);
	int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoids berrybush", "BerryBush", 35.0);
	int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoids berrybush", "BerryBush", 60.0);
	int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoids berrybush", "BerryBush", 90.0);
	 
    // AVOID IMPASSABLE LAND:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
		
	// CLIFF AVOIDANCE:
	int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 12.0);
	int avoidCloseCliff=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 6.0);
	
    // STARTING UNITS AVOIDANCE:
	int avoidStartingUnits=rmCreateClassDistanceConstraint("stuff avoid starting units", rmClassID("startingUnit"), 15.0);
	int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close avoid starting units", rmClassID("startingUnit"), 8.0);
	int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium avoid starting units", rmClassID("startingUnit"), 20.0);
	
	// CINEMATIC BLOCK AVOIDANCE:
	int avoidCinematicBlock=rmCreateTypeDistanceConstraint("avoid Block", "CinematicBlock", 5.0);
	int avoidCinematicBlockFar=rmCreateTypeDistanceConstraint("avoid Block Far", "CinematicBlock", 60.0);
	
	// IMPORTANT AVOIDANCE:
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 15.0);
	int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close avoid important item", rmClassID("importantItem"), 8.0);
	int avoidFarImportantItem=rmCreateClassDistanceConstraint("far avoid important item", rmClassID("importantItem"), 60.0);
	
	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
	int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 8.0);
	
	// NUGGET AVOIDANCE:
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 15.0);
	int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 8.0);
	int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close avoid nugget", "AbstractNugget", 3.0);
	int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium avoid nugget", "AbstractNugget", 30.0);
	int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 60.0);
	int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far avoid nugget", "AbstractNugget", 90.0);
	int avoidSuperFarNugget=rmCreateTypeDistanceConstraint("super far avoid nugget", "AbstractNugget", 120.0);
	
    // DECORATION AVOIDANCE:
    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);

    // TRADE ROUTE AVOIDANCE:
    int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 15.0);
    int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 8.0);
	int avoidVeryCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("very close trade route", 3.0);
	
	int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 15.0);
    int avoidCloseSocket = rmCreateClassDistanceConstraint("close avoid socket", rmClassID("classSocket"), 8.0);
    int avoidVeryCloseSocket = rmCreateClassDistanceConstraint("very close avoid socket", rmClassID("classSocket"), 3.0);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************* SET UP PLAYER STARTING LOCATIONS: ************************************** //
/*================================================================================================================*/
	
			if(rmRandFloat(0,1) > 0.50)
	    {
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.85, 0.65, 0.65, 0.85, 0, 0.0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.15, 0.35, 0.35, 0.15, 0, 0.0);
		}
		    else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.15, 0.35, 0.35, 0.15, 0, 0.0);
	
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.85, 0.65, 0.65, 0.85, 0, 0.0);
		}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ******************************************** BUILD A NORTH AREA: ********************************************* //
/*================================================================================================================*/

	    int northIslandID = rmCreateArea("north island");
	    rmSetAreaLocation(northIslandID, 0.80, 0.80); 
	    rmSetAreaWarnFailure(northIslandID, false);
	    rmSetAreaSize(northIslandID, 0.32, 0.32);
	    rmSetAreaCoherence(northIslandID, 1.0);

	    rmSetAreaElevationType(northIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(northIslandID, 3.0);
	    rmSetAreaBaseHeight(northIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(northIslandID, 0.07);
	    rmSetAreaElevationOctaves(northIslandID, 4);
	    rmSetAreaElevationPersistence(northIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(northIslandID, 1);
   
	    rmSetAreaObeyWorldCircleConstraint(northIslandID, false);
	    //rmSetAreaMix(northIslandID, "rockies_grass");
		rmSetAreaMix(northIslandID, "great plains drygrass");
	    //rmSetAreaMix(northIslandID, "amazon grass");
		
		rmBuildAllAreas();
		
		// ADD ISLAND CONSTRAINTS:
        int northIslandConstraint=rmCreateAreaConstraint("north Island", northIslandID);

/*================================================================================================================*/   
// ******************************************** BUILD A SOUTH AREA: ********************************************* //
/*================================================================================================================*/
   
        int southIslandID = rmCreateArea("south island");
        rmSetAreaLocation(southIslandID, 0.20, 0.20); 
        rmSetAreaWarnFailure(southIslandID, false);
        rmSetAreaSize(southIslandID, 0.34, 0.34);
        rmSetAreaCoherence(southIslandID, 1.0);

	    rmSetAreaElevationType(southIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(southIslandID, 5.0);
        rmSetAreaBaseHeight(southIslandID, 3.0);
        rmSetAreaElevationMinFrequency(southIslandID, 0.07);
        rmSetAreaElevationOctaves(southIslandID, 4);
        rmSetAreaElevationPersistence(southIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(southIslandID, 1); 
        //rmAddAreaTerrainLayer(southIslandID, "andes\ground10_and", 0, 5);
        //rmAddAreaTerrainLayer(southIslandID, "andes\ground07_and", 3, 8);
        //rmAddAreaTerrainLayer(southIslandID, "andes\ground4_and", 6, 8);
   
	    rmSetAreaObeyWorldCircleConstraint(southIslandID, false);
		rmSetAreaMix(southIslandID, "great plains drygrass");
	    //rmSetAreaMix(southIslandID, "rockies_snow");

        rmBuildAllAreas();
		
		// ADD ISLAND CONSTRAINTS:
        int southIslandConstraint=rmCreateAreaConstraint("south Island", southIslandID);
		
/*================================================================================================================*/		
// ********************************************* BUILD A WEST AREA: ********************************************* //
/*================================================================================================================*/

	    int westIslandID = rmCreateArea("west island");
	    rmSetAreaLocation(westIslandID, 0.245, 0.755); 
	    rmSetAreaWarnFailure(westIslandID, false);
	    rmSetAreaSize(westIslandID, 0.0525, 0.0525);
	    rmSetAreaCoherence(westIslandID, 1.0);

	    rmSetAreaElevationType(westIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(westIslandID, 2.0);
	    rmSetAreaBaseHeight(westIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(westIslandID, 0.07);
	    rmSetAreaElevationOctaves(westIslandID, 4);
	    rmSetAreaElevationPersistence(westIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(westIslandID, 1);
   
	    rmSetAreaObeyWorldCircleConstraint(westIslandID, false);
	    //rmSetAreaMix(westIslandID, "rockies_grass");
		rmSetAreaMix(westIslandID, "great plains drygrass");
	    //rmSetAreaMix(westIslandID, "amazon grass");
		
		rmBuildAllAreas();
		
		// ADD ISLAND CONSTRAINTS:
        int westIslandConstraint=rmCreateAreaConstraint("west Island", westIslandID);

/*================================================================================================================*/   
// ********************************************* BUILD A EAST AREA: ********************************************* //
/*================================================================================================================*/
   
        int eastIslandID = rmCreateArea("east island");
        rmSetAreaLocation(eastIslandID, 0.755, 0.245); 
        rmSetAreaWarnFailure(eastIslandID, false);
        rmSetAreaSize(eastIslandID, 0.0525, 0.0525);
        rmSetAreaCoherence(eastIslandID, 1.0);

	    rmSetAreaElevationType(eastIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(eastIslandID, 2.0);
        rmSetAreaBaseHeight(eastIslandID, 3.0);
        rmSetAreaElevationMinFrequency(eastIslandID, 0.07);
        rmSetAreaElevationOctaves(eastIslandID, 4);
        rmSetAreaElevationPersistence(eastIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(eastIslandID, 1); 
        //rmAddAreaTerrainLayer(eastIslandID, "andes\ground10_and", 0, 5);
        //rmAddAreaTerrainLayer(eastIslandID, "andes\ground07_and", 3, 8);
        //rmAddAreaTerrainLayer(eastIslandID, "andes\ground4_and", 6, 8);
   
	    rmSetAreaObeyWorldCircleConstraint(eastIslandID, false);
		rmSetAreaMix(eastIslandID, "great plains drygrass");
	    //rmSetAreaMix(eastIslandID, "rockies_snow");

        rmBuildAllAreas();

        // ADD ISLAND CONSTRAINTS:
        int eastIslandConstraint=rmCreateAreaConstraint("east Island", eastIslandID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ******************************************** SET UP PLAYER AREAS: ******************************************** //
/*================================================================================================================*/
        
		float playerFraction=rmAreaTilesToFraction(2750);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint);
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
	    
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");

		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "texas_dirt");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_grass");
	    
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTE: ************************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // SOCKET DEFINITION:
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 1:
		int tradeRoute1ID = rmCreateTradeRoute();
	    
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.35, 0.65);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.65, 0.35);
	
	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

/*----------------------------------------------------------------------------------------------------------------*/		

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.975);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1); 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE NATIVE INCAS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv0 == rmGetCivID("Cherokee"))
	{  
		int cherokeeVillageAID = -1;
		cherokeeVillageAID = rmCreateGrouping("cherokee village 1", "native cherokee village "+1);
		rmSetGroupingMinDistance(cherokeeVillageAID, 0.0);
		rmSetGroupingMaxDistance(cherokeeVillageAID, 0.0);
		rmAddGroupingToClass(cherokeeVillageAID, rmClassID("natives"));
		rmAddGroupingToClass(cherokeeVillageAID, rmClassID("importantItem"));
		rmAddGroupingConstraint(cherokeeVillageAID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokeeVillageAID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokeeVillageAID, 0, 0.085, 0.665);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/		

	    if (subCiv1 == rmGetCivID("Cherokee"))
	{  
		int cherokeevillageBID = -1;
		cherokeevillageBID = rmCreateGrouping("cherokee village 2", "native cherokee village "+2);
		rmSetGroupingMinDistance(cherokeevillageBID, 0.0);
		rmSetGroupingMaxDistance(cherokeevillageBID, 0.0);
		rmAddGroupingToClass(cherokeevillageBID, rmClassID("natives"));
		rmAddGroupingToClass(cherokeevillageBID, rmClassID("importantItem"));
		rmAddGroupingConstraint(cherokeevillageBID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokeevillageBID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokeevillageBID, 0, 0.665, 0.085);
	}

/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv2 == rmGetCivID("Cherokee"))
	{  
		int cherokeevillageCID = -1;
		cherokeevillageCID = rmCreateGrouping("cherokee village 3", "native cherokee village "+3);
		rmSetGroupingMinDistance(cherokeevillageCID, 0.0);
		rmSetGroupingMaxDistance(cherokeevillageCID, 0.0);
		rmAddGroupingToClass(cherokeevillageCID, rmClassID("natives"));
		rmAddGroupingToClass(cherokeevillageCID, rmClassID("importantItem"));
		rmAddGroupingConstraint(cherokeevillageCID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokeevillageCID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokeevillageCID, 0, 0.33, 0.90);
	}

/*----------------------------------------------------------------------------------------------------------------*/	
	
	    if (subCiv3 == rmGetCivID("Cherokee"))
	{  
		int cherokeevillageDID = -1;
		cherokeevillageDID = rmCreateGrouping("cherokee village 4", "native cherokee village "+4);
		rmSetGroupingMinDistance(cherokeevillageDID, 0.0);
		rmSetGroupingMaxDistance(cherokeevillageDID, 0.0);
		rmAddGroupingToClass(cherokeevillageDID, rmClassID("natives"));
		rmAddGroupingToClass(cherokeevillageDID, rmClassID("importantItem"));
		rmAddGroupingConstraint(cherokeevillageDID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokeevillageDID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokeevillageDID, 0, 0.90, 0.33);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.475);
/*================================================================================================================*/
// ********************** DEFINE AND PLACE THE BERRYBUSH OR THE DEER HERDS NEAR THE NATIVES: ******************** //
/*================================================================================================================*/
       
		// MAP VARIATION VARIABLE:
	    int whichVariation=-1;
	    whichVariation = rmRandInt(1,2);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		int Berries5ID=rmCreateObjectDef("The Berrybush 5");
        
		if ( whichVariation == 1 )
		rmAddObjectDefItem(Berries5ID, "berrybush", rmRandInt(3,5), 4.0);
        else
		rmAddObjectDefItem(Berries5ID, "deer", rmRandInt(3,5), 4.0);
		
		rmSetObjectDefMinDistance(Berries5ID, 0.0);
        rmSetObjectDefMaxDistance(Berries5ID, 0.0);
		rmSetObjectDefCreateHerd(Berries5ID, true);
		
		rmPlaceObjectDefAtLoc(Berries5ID, 0, 0.085, 0.705);
		rmPlaceObjectDefAtLoc(Berries5ID, 0, 0.085, 0.625);
		rmPlaceObjectDefAtLoc(Berries5ID, 0, 0.125, 0.665);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		int Berries6ID=rmCreateObjectDef("The Berrybush 6");
		
		if ( whichVariation == 1 )
		rmAddObjectDefItem(Berries6ID, "berrybush", rmRandInt(3,5), 4.0);
        else
		rmAddObjectDefItem(Berries6ID, "deer", rmRandInt(3,5), 4.0);
        
        rmSetObjectDefMinDistance(Berries6ID, 0.0);
        rmSetObjectDefMaxDistance(Berries6ID, 0.0);
		rmSetObjectDefCreateHerd(Berries6ID, true);
		
		rmPlaceObjectDefAtLoc(Berries6ID, 0, 0.710, 0.085);
		rmPlaceObjectDefAtLoc(Berries6ID, 0, 0.620, 0.085);
		rmPlaceObjectDefAtLoc(Berries6ID, 0, 0.670, 0.125);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		int Berries7ID=rmCreateObjectDef("The Berrybush 7");
		
		if ( whichVariation == 1 )
		rmAddObjectDefItem(Berries7ID, "berrybush", rmRandInt(3,5), 4.0);
        else
		rmAddObjectDefItem(Berries7ID, "deer", rmRandInt(3,5), 4.0);
        
        rmSetObjectDefMinDistance(Berries7ID, 0.0);
        rmSetObjectDefMaxDistance(Berries7ID, 0.0);
		rmSetObjectDefCreateHerd(Berries7ID, true);
		
		rmPlaceObjectDefAtLoc(Berries7ID, 0, 0.33, 0.94);
		rmPlaceObjectDefAtLoc(Berries7ID, 0, 0.28, 0.90);
		rmPlaceObjectDefAtLoc(Berries7ID, 0, 0.38, 0.90);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		int Berries8ID=rmCreateObjectDef("The Berrybush 8");
		
		if ( whichVariation == 1 )
		rmAddObjectDefItem(Berries8ID, "berrybush", rmRandInt(3,5), 4.0);
        else
		rmAddObjectDefItem(Berries8ID, "deer", rmRandInt(3,5), 4.0);
        
        rmSetObjectDefMinDistance(Berries8ID, 0.0);
        rmSetObjectDefMaxDistance(Berries8ID, 0.0);
		rmSetObjectDefCreateHerd(Berries8ID, true);
		
		rmPlaceObjectDefAtLoc(Berries8ID, 0, 0.94, 0.34);
		rmPlaceObjectDefAtLoc(Berries8ID, 0, 0.90, 0.28);
		rmPlaceObjectDefAtLoc(Berries8ID, 0, 0.90, 0.38);
			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *********************************** THESE VARIABLES WILL BE NEEDED LATER: ************************************ //	
/*================================================================================================================*/

	    //int failCount = -1;

	    //int numTries=cNumberNonGaiaPlayers+2;
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.525);
/*================================================================================================================*/
// *********************** DEFINE THE TCID AND THE STARTING UNITS AND THE PLAYER RESOURCES:	********************* //
/*================================================================================================================*/

        // CLEAR CLOSEST POINT CONSTRAINTS:
        rmClearClosestPointConstraints();

	    // DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	}

	    rmAddObjectDefConstraint(TCID, playerEdgeConstraint);
	    int TCfloat = -1;

	    if (cNumberTeams == 2)
	{
		rmAddObjectDefConstraint(TCID, avoidCinematicBlockFar);

		if (cNumberNonGaiaPlayers<3)
			TCfloat = 0.0;
		else if (cNumberNonGaiaPlayers<7)
			TCfloat = 0.0;
		else
			TCfloat = 0.0;
	}
	    else 
	{
		TCfloat = 0.0;

	}

	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, TCfloat);

	    //rmAddObjectDefConstraint(TCID, avoidImpassableLand);
		
		// DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidCloseStartingUnits);

/*----------------------------------------------------------------------------------------------------------------*/	
	
	    // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player mine");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
		rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(playerSilverID, 15.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 20.0);
        rmAddObjectDefConstraint(playerSilverID, avoidStartingUnits);

	    // DEFINE THE PLAYER BERRYBUSH:
		int playerberryID=rmCreateObjectDef("player berrybush");
        rmAddObjectDefItem(playerberryID, "berrybush", rmRandInt(5,7), 5.0);
		rmAddObjectDefToClass(playerberryID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerberryID, 10);
        rmSetObjectDefMaxDistance(playerberryID, 15);
	    rmAddObjectDefConstraint(playerberryID, avoidAll);
        rmAddObjectDefConstraint(playerberryID, avoidFruits);
	    rmAddObjectDefConstraint(playerberryID, avoidCloseStartingUnits);
        rmSetObjectDefCreateHerd(playerberryID, true);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
		rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidCloseStartingUnits);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidAll);
	    rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 26.0);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeGreatPlains", rmRandInt(5,10), 10.0);
		rmAddObjectDefToClass(playerTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(playerTreeID, 26);
        rmSetObjectDefMaxDistance(playerTreeID, 35);
	    rmAddObjectDefConstraint(playerTreeID, avoidFruits);
		rmAddObjectDefConstraint(playerTreeID, avoidTrees);
        rmAddObjectDefConstraint(playerTreeID, avoidAll);
		rmAddObjectDefConstraint(playerTreeID, avoidStartingUnits);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// *********************** PLACE THE TCID AND THE STARTING UNITS AND THE PLAYER RESOURCES: ********************** //
/*================================================================================================================*/
	    
		for(i=1; <cNumberPlayers)
	{
		// PLACE THE TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// PLACE THE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// PLACE THE PLAYER TREE:
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
				
		// PLACE THE PLAYER BERRY:
		rmPlaceObjectDefAtLoc(playerberryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerberryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// PLACE THE PLAYER NUGGET:
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE CLIFF AREA: ************************************** //
/*================================================================================================================*/
                 
		int failCount = -1;
	    int numTries=cNumberNonGaiaPlayers*0.5;
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE WEST CLIFF:
		for(i=0; <numTries)
{
		int cliffID=rmCreateArea("cliff 1"+i);
	    rmSetAreaSize(cliffID, rmAreaTilesToFraction(1200), rmAreaTilesToFraction(1500));
		rmSetAreaWarnFailure(cliffID, false);
		rmSetAreaCliffType(cliffID, "Great Plains");
        //rmSetAreaMix(cliffID, "rockies_grass_snow");
		rmAddAreaToClass(cliffID, rmClassID("classCliff"));
        //rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
		rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
		//rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(cliffID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaCliffHeight(cliffID, -6, 1.0, 1.0);
		rmSetAreaMinBlobs(cliffID, 1);
		rmSetAreaMaxBlobs(cliffID, 1);
		rmSetAreaMinBlobDistance(cliffID, 1.0);
		rmSetAreaMaxBlobDistance(cliffID, 1.0);
		rmSetAreaLocation(cliffID, 0.245, 0.755); 
		rmSetAreaCoherence(cliffID, 0.65);
		rmSetAreaSmoothDistance(cliffID, 10);
		rmAddAreaConstraint(cliffID, playerConstraint);
		rmAddAreaConstraint(cliffID, avoidNatives); 
		//rmAddAreaConstraint(cliffID, northIslandID);
		rmSetAreaObeyWorldCircleConstraint(cliffID, false);
		if(rmBuildArea(cliffID)==false)
	{
		// Stop trying once we fail 3 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
		else
		failCount=0;
}

/*----------------------------------------------------------------------------------------------------------------*/

        int oreID=rmCreateObjectDef("The gold Mine 1");
        rmAddObjectDefItem(oreID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(oreID, 0.0);
        rmSetObjectDefMaxDistance(oreID, 0.0);
        //rmAddObjectDefConstraint(oreID, avoidCoin);
	    
		rmPlaceObjectDefAtLoc(oreID, 0, 0.245, 0.755);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.245, 0.725); 
        rmPlaceObjectDefAtLoc(oreID, 0, 0.245, 0.785);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.215, 0.755); 
        rmPlaceObjectDefAtLoc(oreID, 0, 0.275, 0.755); 

/*----------------------------------------------------------------------------------------------------------------*/

        // THE EAST CLIFF:
		for(i=0; <numTries)
{
		int cliff2ID=rmCreateArea("cliff 2"+i);
	    rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(1200), rmAreaTilesToFraction(1500));
		rmSetAreaWarnFailure(cliff2ID, false);
		rmSetAreaCliffType(cliff2ID, "Great Plains");
        //rmSetAreaMix(cliff2ID, "rockies_grass_snow");
		rmAddAreaToClass(cliff2ID, rmClassID("classCliff"));
        //rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
		rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
		//rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
		//rmSetAreaCliffHeight(cliff2ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaCliffHeight(cliff2ID, -6, 1.0, 1.0);
		rmSetAreaMinBlobs(cliff2ID, 1);
		rmSetAreaMaxBlobs(cliff2ID, 1);
		rmSetAreaMinBlobDistance(cliff2ID, 1.0);
		rmSetAreaMaxBlobDistance(cliff2ID, 1.0);
		rmSetAreaLocation(cliff2ID, 0.755, 0.245); 
		rmSetAreaCoherence(cliff2ID, 0.65);
		rmSetAreaSmoothDistance(cliff2ID, 10);
		rmAddAreaConstraint(cliff2ID, playerConstraint);
		rmAddAreaConstraint(cliff2ID, avoidNatives); 
		//rmAddAreaConstraint(cliff2ID, northIslandID);
		rmSetAreaObeyWorldCircleConstraint(cliff2ID, false);
		if(rmBuildArea(cliff2ID)==false)
	{
		// Stop trying once we fail 3 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
		else
		failCount=0;
} 

/*----------------------------------------------------------------------------------------------------------------*/

        oreID=rmCreateObjectDef("The gold Mine 2");
        rmAddObjectDefItem(oreID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(oreID, 0.0);
        rmSetObjectDefMaxDistance(oreID, 0.0);
        //rmAddObjectDefConstraint(oreID, avoidCoin);
	    rmPlaceObjectDefAtLoc(oreID, 0, 0.755, 0.245);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.755, 0.275);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.755, 0.215);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.785, 0.245);
        rmPlaceObjectDefAtLoc(oreID, 0, 0.725, 0.245);    		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE FOREST AREAS: ************************************** //
/*================================================================================================================*/

	        int forestTreeID = 0;

	        if (cNumberNonGaiaPlayers <=2)
		    numTries=6*cNumberNonGaiaPlayers;
	        else
		    numTries=3*cNumberNonGaiaPlayers;
	        
			failCount=0;
	        
/*----------------------------------------------------------------------------------------------------------------*/			
			
			for (i=0; <numTries)
   {   
			int forestID=rmCreateArea("forestID"+i, southIslandID);
			rmSetAreaWarnFailure(forestID, false);
			rmSetAreaSize(forestID, rmAreaTilesToFraction(300), rmAreaTilesToFraction(350));
			rmSetAreaForestType(forestID, "great plains forest");
			rmSetAreaForestDensity(forestID, 0.75);
			rmSetAreaForestClumpiness(forestID, 0.25);		
			rmSetAreaForestUnderbrush(forestID, 0.25);
			rmSetAreaMinBlobs(forestID, 1);
			rmSetAreaMaxBlobs(forestID, 4);						
			rmSetAreaMinBlobDistance(forestID, 5.0);
			rmSetAreaMaxBlobDistance(forestID, 20.0);
			rmSetAreaCoherence(forestID, 0.4);
			rmSetAreaSmoothDistance(forestID, 10);
			rmAddAreaToClass(forestID, rmClassID("classForest"));
			rmAddAreaConstraint(forestID, forestMediumConstraint);  
			rmAddAreaConstraint(forestID, avoidCloseTradeRoute);
			rmAddAreaConstraint(forestID, avoidCinematicBlock);
			rmAddAreaConstraint(forestID, avoidCloseImportantItem);
			rmAddAreaConstraint(forestID, playerConstraint);
			rmAddAreaConstraint(forestID, playerEdgeConstraint);
			rmAddAreaConstraint(forestID, avoidCliff);
			rmAddAreaConstraint(forestID, avoidAll);
			if(rmBuildArea(forestID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
			else
			failCount=0; 
   }
   
/*----------------------------------------------------------------------------------------------------------------*/
	        
			int forestTreeNorthID = 0;
			
			if (cNumberNonGaiaPlayers <=2)
			numTries=6*cNumberNonGaiaPlayers;
			else
			numTries=3*cNumberNonGaiaPlayers;  
	        
			failCount=0;
			
/*----------------------------------------------------------------------------------------------------------------*/			
			
	        for (i=0; <numTries)
	{   
			int forestnorthID=rmCreateArea("forestNorthID"+i, northIslandID);
			rmSetAreaWarnFailure(forestnorthID, false);
			rmSetAreaSize(forestnorthID, rmAreaTilesToFraction(300), rmAreaTilesToFraction(350));
			rmSetAreaForestType(forestnorthID, "great plains forest");
			rmSetAreaForestDensity(forestnorthID, 0.75);
			rmSetAreaForestClumpiness(forestnorthID, 0.25);		
			rmSetAreaForestUnderbrush(forestnorthID, 0.25);
			rmSetAreaMinBlobs(forestnorthID, 1);
			rmSetAreaMaxBlobs(forestnorthID, 4);						
			rmSetAreaMinBlobDistance(forestnorthID, 5.0);
			rmSetAreaMaxBlobDistance(forestnorthID, 20.0);
			rmSetAreaCoherence(forestnorthID, 0.4);
			rmSetAreaSmoothDistance(forestnorthID, 10);
			rmAddAreaToClass(forestnorthID, rmClassID("classForest"));
			rmAddAreaConstraint(forestnorthID, forestMediumConstraint);  
			rmAddAreaConstraint(forestnorthID, avoidCloseTradeRoute);
			rmAddAreaConstraint(forestnorthID, avoidCinematicBlock);
			rmAddAreaConstraint(forestnorthID, avoidCloseImportantItem);
			rmAddAreaConstraint(forestnorthID, playerConstraint);
			rmAddAreaConstraint(forestnorthID, playerEdgeConstraint);
			rmAddAreaConstraint(forestnorthID, avoidCliff);
			rmAddAreaConstraint(forestnorthID, avoidAll);
			if(rmBuildArea(forestnorthID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
			else
			failCount=0; 
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

        int forestTreeWestID = 0;
			
			if (cNumberNonGaiaPlayers <=2)
			numTries=2.5*cNumberNonGaiaPlayers;
			else
			numTries=1.25*cNumberNonGaiaPlayers;  
	        
			failCount=0;
			
/*----------------------------------------------------------------------------------------------------------------*/			
			
	        for (i=0; <numTries)
	{   
			int forestwestID=rmCreateArea("forestWestID"+i, westIslandID);
			rmSetAreaWarnFailure(forestwestID, false);
			rmSetAreaSize(forestwestID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(175));
			rmSetAreaForestType(forestwestID, "great plains forest");
			rmSetAreaForestDensity(forestwestID, 0.75);
			rmSetAreaForestClumpiness(forestwestID, 0.25);		
			rmSetAreaForestUnderbrush(forestwestID, 0.25);
			rmSetAreaMinBlobs(forestwestID, 1);
			rmSetAreaMaxBlobs(forestwestID, 4);						
			rmSetAreaMinBlobDistance(forestwestID, 5.0);
			rmSetAreaMaxBlobDistance(forestwestID, 20.0);
			rmSetAreaCoherence(forestwestID, 0.4);
			rmSetAreaSmoothDistance(forestwestID, 10);
			rmAddAreaToClass(forestwestID, rmClassID("classForest"));
			rmAddAreaConstraint(forestwestID, forestMediumConstraint);  
			rmAddAreaConstraint(forestwestID, avoidCloseTradeRoute);
			rmAddAreaConstraint(forestwestID, avoidCinematicBlock);
			rmAddAreaConstraint(forestwestID, avoidCloseImportantItem);
			rmAddAreaConstraint(forestwestID, playerConstraint);
			rmAddAreaConstraint(forestwestID, playerEdgeConstraint);
			rmAddAreaConstraint(forestwestID, avoidCliff);
			rmAddAreaConstraint(forestwestID, avoidAll);
			if(rmBuildArea(forestwestID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
			else
			failCount=0; 
	}

/*----------------------------------------------------------------------------------------------------------------*/

            for (i=0; <numTries)
	{   
			int foresteastID=rmCreateArea("forestEastID"+i, eastIslandID);
			rmSetAreaWarnFailure(foresteastID, false);
			rmSetAreaSize(foresteastID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(175));
			rmSetAreaForestType(foresteastID, "great plains forest");
			rmSetAreaForestDensity(foresteastID, 0.75);
			rmSetAreaForestClumpiness(foresteastID, 0.25);		
			rmSetAreaForestUnderbrush(foresteastID, 0.25);
			rmSetAreaMinBlobs(foresteastID, 1);
			rmSetAreaMaxBlobs(foresteastID, 4);						
			rmSetAreaMinBlobDistance(foresteastID, 5.0);
			rmSetAreaMaxBlobDistance(foresteastID, 20.0);
			rmSetAreaCoherence(foresteastID, 0.4);
			rmSetAreaSmoothDistance(foresteastID, 10);
			rmAddAreaToClass(foresteastID, rmClassID("classForest"));
			rmAddAreaConstraint(foresteastID, forestMediumConstraint);  
			rmAddAreaConstraint(foresteastID, avoidCloseTradeRoute);
			rmAddAreaConstraint(foresteastID, avoidCinematicBlock);
			rmAddAreaConstraint(foresteastID, avoidCloseImportantItem);
			rmAddAreaConstraint(foresteastID, playerConstraint);
			rmAddAreaConstraint(foresteastID, playerEdgeConstraint);
			rmAddAreaConstraint(foresteastID, avoidCliff);
			rmAddAreaConstraint(foresteastID, avoidAll);
			if(rmBuildArea(foresteastID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
			else
			failCount=0; 
	}	
		 	
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NORTHERN NUGGET: ************************************ //
/*================================================================================================================*/

	    int nuggeteasyID= rmCreateObjectDef("nugget easy west" ); 
	    rmAddObjectDefItem(nuggeteasyID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggeteasyID, 0.0);
	    rmSetObjectDefMaxDistance(nuggeteasyID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nuggeteasyID, avoidMediumNugget);
  	    rmAddObjectDefConstraint(nuggeteasyID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nuggeteasyID, avoidCliff);
		rmAddObjectDefConstraint(nuggeteasyID, playerVeryCloseEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggeteasyID, westIslandConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nuggeteasyID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggeteasyID, 0, 0.5, 0.5, 1.0*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/		
        
        int nuggeteasy2ID= rmCreateObjectDef("nugget easy east" ); 
	    rmAddObjectDefItem(nuggeteasy2ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggeteasy2ID, 0.0);
	    rmSetObjectDefMaxDistance(nuggeteasy2ID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nuggeteasy2ID, avoidMediumNugget);
  	    rmAddObjectDefConstraint(nuggeteasy2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nuggeteasy2ID, avoidCliff);
		rmAddObjectDefConstraint(nuggeteasy2ID, playerVeryCloseEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggeteasy2ID, eastIslandConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nuggeteasy2ID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggeteasy2ID, 0, 0.5, 0.5, 1.0*cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/

        int nuggeteasy3ID= rmCreateObjectDef("nugget easy north" ); 
	    rmAddObjectDefItem(nuggeteasy3ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggeteasy3ID, 0.0);
	    rmSetObjectDefMaxDistance(nuggeteasy3ID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nuggeteasy3ID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggeteasy3ID, avoidFarCoin);
  	    rmAddObjectDefConstraint(nuggeteasy3ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nuggeteasy3ID, playerCloseConstraint);
		rmAddObjectDefConstraint(nuggeteasy3ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggeteasy3ID, northIslandConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nuggeteasy3ID, 0, 0.5, 0.5, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggeteasy3ID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);

/*----------------------------------------------------------------------------------------------------------------*/

        int nuggeteasy4ID= rmCreateObjectDef("nugget easy south" ); 
	    rmAddObjectDefItem(nuggeteasy4ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggeteasy4ID, 0.0);
	    rmSetObjectDefMaxDistance(nuggeteasy4ID, rmXFractionToMeters(0.5));
  	    
		rmAddObjectDefConstraint(nuggeteasy4ID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggeteasy4ID, avoidFarCoin);
  	    rmAddObjectDefConstraint(nuggeteasy4ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(nuggeteasy4ID, playerCloseConstraint);
		rmAddObjectDefConstraint(nuggeteasy4ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggeteasy4ID, southIslandConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nuggeteasy4ID, 0, 0.5, 0.5, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggeteasy4ID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);			
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //		
/*================================================================================================================*/

        // THE NORTHERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Northern Berrybush");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(BerriesID, avoidFarFruits);
		rmAddObjectDefConstraint(BerriesID, northIslandConstraint);
        rmAddObjectDefConstraint(BerriesID, forestCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidCloseCoin);
		rmAddObjectDefConstraint(BerriesID, avoidCloseNugget);
		rmAddObjectDefConstraint(BerriesID, playerEdgeConstraint);
		    
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Southern Berrybush");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 6.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries2ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries2ID, southIslandConstraint);
        rmAddObjectDefConstraint(Berries2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(Berries2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries2ID, playerEdgeConstraint);
		        
		rmSetObjectDefCreateHerd(Berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE WESTERN BERRYBUSH:
		int Berries3ID=rmCreateObjectDef("The Western Berrybush");
        rmAddObjectDefItem(Berries3ID, "berrybush", rmRandInt(3,7), 5.0);
        rmSetObjectDefMinDistance(Berries3ID, 0.0);
        rmSetObjectDefMaxDistance(Berries3ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries3ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries3ID, westIslandConstraint);
        rmAddObjectDefConstraint(Berries3ID, forestCloseConstraint);
		rmAddObjectDefConstraint(Berries3ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries3ID, avoidCloseCliff);
		rmAddObjectDefConstraint(Berries3ID, playerVeryCloseEdgeConstraint);
						        
		rmSetObjectDefCreateHerd(Berries3ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);

/*----------------------------------------------------------------------------------------------------------------*/		
        
		// THE EASTERN BERRYBUSH:
		int Berries4ID=rmCreateObjectDef("The Eastern Berrybush");
        rmAddObjectDefItem(Berries4ID, "berrybush", rmRandInt(3,7), 5.0);
        rmSetObjectDefMinDistance(Berries4ID, 0.0);
        rmSetObjectDefMaxDistance(Berries4ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries4ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries4ID, eastIslandConstraint);
        rmAddObjectDefConstraint(Berries4ID, forestCloseConstraint);
		rmAddObjectDefConstraint(Berries4ID, avoidCloseNugget);
		rmAddObjectDefConstraint(Berries4ID, avoidCloseCliff);
		rmAddObjectDefConstraint(Berries4ID, playerVeryCloseEdgeConstraint);
						        
		rmSetObjectDefCreateHerd(Berries4ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(Berries4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE BISON HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/

        // THE NORTHERN BISON HERDS:
		int bisonID=rmCreateObjectDef("The Northern Bison Herds");
	    rmAddObjectDefItem(bisonID, "bison", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(bisonID, 0.0);
        rmSetObjectDefMaxDistance(bisonID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(bisonID, avoidFarBison);
		rmAddObjectDefConstraint(bisonID, avoidMediumFruits);
		rmAddObjectDefConstraint(bisonID, forestCloseConstraint);
	    rmAddObjectDefConstraint(bisonID, northIslandConstraint);
		rmAddObjectDefConstraint(bisonID, avoidCloseCoin);
		rmAddObjectDefConstraint(bisonID, avoidCloseNugget);
		rmAddObjectDefConstraint(bisonID, playerCloseConstraint);
		rmAddObjectDefConstraint(bisonID, playerEdgeConstraint);

        rmSetObjectDefCreateHerd(bisonID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(bisonID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(bisonID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BISON HERDS:
		int bison2ID=rmCreateObjectDef("The Southern Bison Herds");
	    rmAddObjectDefItem(bison2ID, "bison", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(bison2ID, 0.0);
        rmSetObjectDefMaxDistance(bison2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(bison2ID, avoidFarBison);
		rmAddObjectDefConstraint(bison2ID, avoidMediumFruits);
		rmAddObjectDefConstraint(bison2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(bison2ID, southIslandConstraint);
		rmAddObjectDefConstraint(bison2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(bison2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(bison2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(bison2ID, playerEdgeConstraint);


        rmSetObjectDefCreateHerd(bison2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(bison2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE COW HERDS: **************************************** //
/*================================================================================================================*/

        // THE NORTHERN COW HERDS:
		int cowID=rmCreateObjectDef("The Northern Cow");
        rmAddObjectDefItem(cowID, "cow", 2, 3.0);
        rmSetObjectDefMinDistance(cowID, 0.0);
        rmSetObjectDefMaxDistance(cowID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(cowID, avoidFarCow);
		rmAddObjectDefConstraint(cowID, avoidCloseCoin);
		rmAddObjectDefConstraint(cowID, avoidCloseNugget);
		rmAddObjectDefConstraint(cowID, avoidMediumBison);
		rmAddObjectDefConstraint(cowID, avoidMediumFruits);
		rmAddObjectDefConstraint(cowID, forestCloseConstraint);
		rmAddObjectDefConstraint(cowID, northIslandConstraint);
		rmAddObjectDefConstraint(cowID, playerCloseConstraint);
		rmAddObjectDefConstraint(cowID, playerEdgeConstraint);
		
		rmSetObjectDefCreateHerd(cowID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);    
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE SOUTHERN COW HERDS:
		int cow2ID=rmCreateObjectDef("The Southern Cow");
        rmAddObjectDefItem(cow2ID, "cow", 2, 3.0);
        rmSetObjectDefMinDistance(cow2ID, 0.0);
        rmSetObjectDefMaxDistance(cow2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(cow2ID, avoidFarCow);
		rmAddObjectDefConstraint(cow2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(cow2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(cow2ID, avoidMediumBison);
		rmAddObjectDefConstraint(cow2ID, avoidMediumFruits);
		rmAddObjectDefConstraint(cow2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(cow2ID, southIslandConstraint);
		rmAddObjectDefConstraint(cow2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(cow2ID, playerEdgeConstraint);
		
		rmSetObjectDefCreateHerd(cow2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE PRONGHORN HERDS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/

        // THE NORTHERN PRONGHORN HERDS:
		int pronghornID=rmCreateObjectDef("The Northern Pronghorn Herds");
	    rmAddObjectDefItem(pronghornID, "pronghorn", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(pronghornID, 0.0);
        rmSetObjectDefMaxDistance(pronghornID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(pronghornID, avoidFarPronghorn);
		rmAddObjectDefConstraint(pronghornID, avoidMediumBison);
		rmAddObjectDefConstraint(pronghornID, avoidMediumCow);
		rmAddObjectDefConstraint(pronghornID, avoidMediumFruits);
        rmAddObjectDefConstraint(pronghornID, forestCloseConstraint);
	    rmAddObjectDefConstraint(pronghornID, northIslandConstraint);
		rmAddObjectDefConstraint(pronghornID, avoidCloseCoin);
		rmAddObjectDefConstraint(pronghornID, avoidCloseNugget);
		rmAddObjectDefConstraint(pronghornID, playerCloseConstraint);
		rmAddObjectDefConstraint(pronghornID, playerEdgeConstraint);

        rmSetObjectDefCreateHerd(pronghornID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(pronghornID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN PRONGHORN HERDS:
		int pronghorn2ID=rmCreateObjectDef("The Southern Pronghorn Herds");
	    rmAddObjectDefItem(pronghorn2ID, "pronghorn", rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(pronghorn2ID, 0.0);
        rmSetObjectDefMaxDistance(pronghorn2ID, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(pronghorn2ID, avoidFarPronghorn);
		rmAddObjectDefConstraint(pronghorn2ID, avoidMediumBison);
		rmAddObjectDefConstraint(pronghorn2ID, avoidMediumCow);
		rmAddObjectDefConstraint(pronghorn2ID, avoidMediumFruits);
        rmAddObjectDefConstraint(pronghorn2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(pronghorn2ID, southIslandConstraint);
		rmAddObjectDefConstraint(pronghorn2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(pronghorn2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(pronghorn2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(pronghorn2ID, playerEdgeConstraint);

        rmSetObjectDefCreateHerd(pronghorn2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(pronghorn2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
		else
		rmPlaceObjectDefAtLoc(pronghorn2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.5);

/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.925);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE COIN RESOURCES: ************************************* //
/*================================================================================================================*/
		
		// COIN RESOURCES:

	    int coinType = rmRandInt(1,10);   
	    int coinID = -1;
		
		if (cNumberNonGaiaPlayers <= 2)
        int coinCount = cNumberNonGaiaPlayers*4;	
		else
		coinCount = cNumberNonGaiaPlayers*2;	
	    
		rmEchoInfo("coin count = "+coinCount);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // THE NORTHERN COIN:
		for(i=0; < coinCount)
	{
		coinID = rmCreateObjectDef("coin 1"+i);
		rmAddObjectDefItem(coinID, "mine", 1, 0);
		rmSetObjectDefMinDistance(coinID, 0.0);
		rmSetObjectDefMaxDistance(coinID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(coinID, avoidClosePronghorn);
		rmAddObjectDefConstraint(coinID, avoidCloseBison);
		rmAddObjectDefConstraint(coinID, avoidCloseCow);
		rmAddObjectDefConstraint(coinID, avoidCloseFruits);
        rmAddObjectDefConstraint(coinID, forestCloseConstraint);
	    rmAddObjectDefConstraint(coinID, northIslandConstraint);
		rmAddObjectDefConstraint(coinID, avoidFarCoin);
		rmAddObjectDefConstraint(coinID, avoidNugget);
		rmAddObjectDefConstraint(coinID, playerCloseConstraint);
		rmAddObjectDefConstraint(coinID, playerEdgeConstraint);
						
		rmPlaceObjectDefAtLoc(coinID, 0, 0.5, 0.5);
	}

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN COIN:
		for(i=0; < coinCount)
	{
		int coin2ID = rmCreateObjectDef("coin 2"+i);
		rmAddObjectDefItem(coin2ID, "mine", 1, 0);
		rmSetObjectDefMinDistance(coin2ID, 0.0);
		rmSetObjectDefMaxDistance(coin2ID, rmXFractionToMeters(0.45));
		
		rmAddObjectDefConstraint(coin2ID, avoidClosePronghorn);
		rmAddObjectDefConstraint(coin2ID, avoidCloseBison);
		rmAddObjectDefConstraint(coin2ID, avoidCloseCow);
		rmAddObjectDefConstraint(coin2ID, avoidCloseFruits);
        rmAddObjectDefConstraint(coin2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(coin2ID, southIslandConstraint);
		rmAddObjectDefConstraint(coin2ID, avoidFarCoin);
		rmAddObjectDefConstraint(coin2ID, avoidNugget);
		rmAddObjectDefConstraint(coin2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(coin2ID, playerEdgeConstraint);        
		
		rmPlaceObjectDefAtLoc(coin2ID, 0, 0.5, 0.5);
	}	
	
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE RANDOM NORTHERN TREES:
		int randomTreeID=rmCreateObjectDef("The Random Northern Trees");
		rmAddObjectDefItem(randomTreeID, "TreeGreatPlains", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, avoidVeryClosePronghorn);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseBison);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseCow);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCliff);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFruits);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, Northward);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint); 
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 50*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);  

/*----------------------------------------------------------------------------------------------------------------*/

        // THE RANDOM SOUTHERN TREES:
		int randomTree2ID=rmCreateObjectDef("The Random Southern Trees");
		rmAddObjectDefItem(randomTree2ID, "TreeGreatPlains", 1, 0.0);
		rmAddObjectDefToClass(randomTree2ID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTree2ID, 0.0);
        rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryClosePronghorn);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseBison);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseCow);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCliff);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseTradeRoute);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTree2ID, Southward);
		rmAddObjectDefConstraint(randomTree2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, playerEdgeConstraint); 
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTree2ID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 50*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/














