/*===============================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

// THE SAGUENAY SEA:
// CREATED BY DANY:
// AUGUST 2007:

/*===============================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/
// ******************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
		
/*---------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(2) == true)
   {

	    if(rmRandFloat(0,1) < 0.65)

	  {
		subCiv0=rmGetCivID("Iroquois");
        rmEchoInfo("subCiv0 is Iroquois "+subCiv0);
	    if (subCiv0 >= 0)
		rmSetSubCiv(0, "Iroquois");
	  }
        else
	  {
		subCiv0=rmGetCivID("Cherokee");
        rmEchoInfo("subCiv0 is Cherokee "+subCiv0);
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");
	  }
	  
	    if (rmRandFloat(0,1) < 0.65)
	  {
		subCiv1=rmGetCivID("Cherokee");
        rmEchoInfo("subCiv1 is Cherokee "+subCiv1);
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee");
      }
	    else
	  {
		subCiv1=rmGetCivID("Iroquois");
        rmEchoInfo("subCiv1 is Iroquois "+subCiv1);
	    if (subCiv1 >= 0)
		rmSetSubCiv(1, "Iroquois");
	  }
   }
 
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/
// ************************************ SETS WHICH WAY THE TRADE ROUTE GOES: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	float handedness = rmRandFloat(0.0, 1.0);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/
// ****************************************** PICKS THE MAP SIZE: ********************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
	
	    if (rmGetNumberPlayersOnTeam(0) == rmGetNumberPlayersOnTeam(1))
		
		int playerTiles=25000;
	    else
		playerTiles=25000;

	    if (cNumberNonGaiaPlayers<3)
		
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    else
		size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    
		rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(632, 632);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE THE BASE TERRAIN: ************************************** //
/*===============================================================================================================*/   
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ****************************************** //		
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // SOME MAP TURBULENCE:
	    rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);  // LIKE TEXAS FOR THE MOMENT:
	    rmSetMapElevationHeightBlend(0.2);

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(2.0);

	    // SET SEA TYPE:
	    rmSetSeaType("hudson bay");
	    
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water");
	    
		// SET MAP TYPE:
		rmSetMapType("saguenay");
		rmSetMapType("water");
		rmSetMapType("grass");
	    
		// DEFINE THE CORNERS:
		rmSetWorldCircleConstraint(true);
	    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2.0);
	    
		// SET LIGHTING:
		rmSetLightingSet("saguenay");
        	    
		// CHOOSE THE MERCS:
		chooseMercs();
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classCliff");
	    rmDefineClass("classPatch");
	    int classbigContinent=rmDefineClass("big continent");
	    rmDefineClass("corner");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("natives");
	    rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("flag");
	    rmDefineClass("classHillArea");
	    int randomClass = rmDefineClass("randomAreaClass");
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.21);
/*===============================================================================================================*/
// *************************************** DEFINE THE PLAYER PLACEMENT: **************************************** //		
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
		
	    // PLAYER PLACEMENT:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
   
	    // MAP EDGE CONSTRAINTSW:
	    //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(28), rmZTilesToFraction(28), 1.0-rmXTilesToFraction(28), 1.0-rmZTilesToFraction(28), 0.01);
	    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.40), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
	    // RANDOM AREA CONSTRAINT:
		int randomAreaConstraint=rmCreateClassDistanceConstraint("continent avoids random areas", randomClass, 20.0);

	    // PLAYER CONSTRAINTS:
	    int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 30.0);
		int playerMediumConstraint=rmCreateClassDistanceConstraint("medium vs. player", classPlayer, 15.0);
	    
		// FORESTS CONSTRAINT:
		int playerForestConstraint=rmCreateClassDistanceConstraint("forest vs. player", rmClassID("classForest"), 8.0);
	    
		// BOX CONSTRAINT:
		//int Northconstraint = rmCreateBoxConstraint("stay in North portion", 0, 0, 1, 0.5);
	    //int Southconstraint = rmCreateBoxConstraint("stay in South portion", 0, 0, 0.5, 1);
	    //int Northconstraint = rmCreateBoxConstraint("stay in Far North portion", 0.55, .95, .95, .55);
	    int EastForestconstraint = rmCreateBoxConstraint("stay in East portion of forest", 0.4, 0.0, 0.8, 1.0);
	    int WestForestconstraint = rmCreateBoxConstraint("stay in West portion of forest", 0, 1, 0.60, 0);
	    //int Centralconstraint = rmCreateBoxConstraint("stay in Central portion", 0.25, 0.25, 0.75, 0.75);
	    int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
	    
		// FLAG AVOIDANCE:
		int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-180, rmGetMapXSize()-40, 0, 0, 0);
	    int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);
	    int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);

	    // BONUS AREA CONSTRAINT:
	    int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 20.0);

	    // FOREST AVOIDANCE:
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
	   
        // CLIFF AVOIDANCE:
        int cliffConstraint=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 20.0);
	    int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 10.0);
	    int shortAvoidCliff=rmCreateClassDistanceConstraint("short stuff vs. cliff", rmClassID("classCliff"), 8.0);
	
	    // DEER AVOIDANCE:
	    int avoidDeer=rmCreateTypeDistanceConstraint("food avoids food", "deer", 15.0);
	    int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids food", "deer", 5.0);
	    int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoids food", "deer", 25.0);
	    int avoidFarDeer=rmCreateTypeDistanceConstraint("far avoids food", "deer", 45.0);
		
		// FRUITS AVOIDANCE:
	    int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids berries", "berrybush", 15.0);
	    int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids berries", "berrybush", 5.0);
	    int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoids berries", "berrybush", 25.0);
	    int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoids berries", "berrybush", 45.0);
		
		// TREES AVOIDANCE:
	    int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoids trees", "TreeNewEngland", 15.0);
	    int avoidCloseTrees=rmCreateTypeDistanceConstraint("close avoids trees", "TreeNewEngland", 5.0);
	    int avoidMediumTrees=rmCreateTypeDistanceConstraint("medium avoids trees", "TreeNewEngland", 25.0);
	    int avoidFarTrees=rmCreateTypeDistanceConstraint("far avoids trees", "TreeNewEngland", 45.0);
		
		// ELK AVOIDANCE:
		int avoidElk=rmCreateTypeDistanceConstraint("elk avoids elk", "elk", 15.0);
		int avoidCloseElk=rmCreateTypeDistanceConstraint("close avoids elk", "elk", 5.0);
		int avoidMediumElk=rmCreateTypeDistanceConstraint("medium avoids elk", "elk", 25.0);
		int avoidFarElk=rmCreateTypeDistanceConstraint("far avoids elk", "elk", 45.0);
		int avoidVeryFarElk=rmCreateTypeDistanceConstraint("very far avoids elk", "elk", 65.0);
		
		// MOOSE AVOIDANCE
		int avoidMoose=rmCreateTypeDistanceConstraint("stuff avoids moose", "moose", 15.0);
		int avoidCloseMoose=rmCreateTypeDistanceConstraint("close avoids moose", "moose", 5.0);
		int avoidMediumMoose=rmCreateTypeDistanceConstraint("medium avoids moose", "moose", 25.0);
		int avoidFarMoose=rmCreateTypeDistanceConstraint("far avoids moose", "moose", 45.0);
		int avoidVeryFarMoose=rmCreateTypeDistanceConstraint("very far avoids moose", "moose", 65.0);
	
	    // COIN AVOIDANCE:
	    int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoids coin", "gold", 15.0);
	    int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoids coin", "gold", 5.0);
	    int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoids coin", "gold", 45.0);
	    int avoidCoinFar=rmCreateTypeDistanceConstraint("coin avoids coin Far", "gold", 75.0);
	
	    // NUGGET AVOIDANCE:
	    int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 50.0);
	    int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 5.0);
	    int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 25.0);
	
	
	    // TOWNCENTER AVOIDANCE:
		int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 28.0);
	    int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 60.0);
	    
		
		int avoidHomeCityWaterSpawnFlag=rmCreateTypeDistanceConstraint("avoid HomeCityWaterSpawnFlag", "HomeCityWaterSpawnFlag", 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 8.0);
	    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
	    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 50.0);
	    int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 25.0);
	
	    // NATIVES AVOIDANCE:
	    int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 5.0);
        int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 25.0);
        int avoidFarNatives=rmCreateClassDistanceConstraint("far avoids natives", rmClassID("natives"), 45.0);

	
	    // AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	    int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 25.0);
	    int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	    int mediumAvoidImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 15.0);
	    int mediumShortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("mediumshort avoid impassable land", "Land", false, 10.0);
	    int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
	    int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);

        // UNIT AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 10.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6);

        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 12.0);
        int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close avoids trade route", 5.0);
        int avoidTradeRouteShort = rmCreateTradeRouteDistanceConstraint("trade route short", 8.0);
        int nativeAvoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 20.0);
        
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 30.0);
        int avoidCloseImportantItem=rmCreateClassDistanceConstraint("close avoids important item", rmClassID("importantItem"), 12.0);
 
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/
// ******************************************** DEFINE THE AREAS: ********************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // SET UP PLAYER STARTING LOCATIONS: 


	    rmSetTeamSpacingModifier(0.4);


	    if(cNumberTeams > 2) //ffa
    {
		rmSetPlacementSection(0.05, 0.95);
		rmSetTeamSpacingModifier(0.70);
		rmPlacePlayersCircular(0.4, 0.4, 0);
   	}
	    else
{
		float teamStartLoc = rmRandFloat(0.0, 1.0);
		// TEAM 0 STARTS ON TOP:
		if (teamStartLoc > 0.5) 
	{
		rmSetPlacementTeam(0);
		//rmPlacePlayersLine(0.90, 0.85, 0.50, 0.90, 0.04, 0.02);
		rmPlacePlayersLine(0.25, 0.65, 0.50, 0.90, 0.00, 0.00);
		rmSetTeamSpacingModifier(0.50);
		rmSetPlacementTeam(1);
		//rmPlacePlayersLine(0.60, 0.10, 0.15, 0.20, 0.04, 0.02);
		rmPlacePlayersLine(0.65, 0.25, 0.90, 0.50, 0.00, 0.00);
		rmSetTeamSpacingModifier(0.50);
	}
		else
	{
		rmSetPlacementTeam(0);
		//rmPlacePlayersLine(0.60, 0.10, 0.15, 0.20, 0.04, 0.02);
		rmPlacePlayersLine(0.25, 0.65, 0.50, 0.90, 0.00, 0.00);
		rmSetTeamSpacingModifier(0.50);
		rmSetPlacementTeam(1);
		//rmPlacePlayersLine(0.90, 0.85, 0.50, 0.90, 0.04, 0.02);
		rmPlacePlayersLine(0.65, 0.25, 0.90, 0.50, 0.00, 0.00);
		rmSetTeamSpacingModifier(0.50);
	}
}

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/
// ******************************************* SET UP PLAYER AREAS: ******************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    float playerFraction=rmAreaTilesToFraction(100);
	    for(i=1; <cNumberPlayers)
	
	{
		
		// CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
		
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
		
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLAss:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 1);
		
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
		rmAddAreaConstraint(id, playerEdgeConstraint); //this is for land only
		
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "california\ground5_cal");
		  rmSetAreaTerrainType(id, "saguenay\ground1_sag");
		
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);

	}

	    // BUILD THE AREAS:
	    rmBuildAllAreas();
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/
// ***************************************** BUILD UP BIG CONTINENT: ******************************************* //
// **************************** - CALLED, UNORIGINALLY ENOUGH, "BIG CONTINENT": - ****************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int bigContinentID=rmCreateArea("big continent");
        rmSetAreaSize(bigContinentID, 0.55, 0.55);		// 0.65, 0.65
        rmSetAreaWarnFailure(bigContinentID, false);
        rmAddAreaToClass(bigContinentID, classbigContinent);
        rmSetAreaSmoothDistance(bigContinentID, 50);
	    rmSetAreaMix(bigContinentID, "saguenay grass");
        rmSetAreaElevationType(bigContinentID, cElevTurbulence);
        rmSetAreaElevationVariation(bigContinentID, 4.0);
        rmSetAreaBaseHeight(bigContinentID, 4.0);
        rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
        rmSetAreaElevationOctaves(bigContinentID, 3);
        rmSetAreaElevationPersistence(bigContinentID, 0.2);      
	    rmSetAreaCoherence(bigContinentID, 0.80);
	    //rmSetAreaLocation(bigContinentID, 0.70, 0.45);
		rmSetAreaLocation(bigContinentID, 0.60, 0.60);
        rmSetAreaEdgeFilling(bigContinentID, 5);
	    rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
	    rmBuildArea(bigContinentID);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/
// ********************* BUILD UP SMALL CONTINENT SPURS CALLED "SMALL CONTINENT SPUR 1 & 2": ******************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // SMALL CONTINENT SPUR 1:
		int smallContinent1ID=rmCreateArea("small continent spur 1");
        rmSetAreaSize(smallContinent1ID, 0.2, 0.2);
		//rmSetAreaSize(smallContinent1ID, 0.125, 0.125);
        rmSetAreaWarnFailure(smallContinent1ID, false);
        rmAddAreaToClass(smallContinent1ID, classbigContinent);
        rmSetAreaSmoothDistance(smallContinent1ID, 50);
	    rmSetAreaMix(smallContinent1ID, "saguenay grass");
		//rmSetAreaMix(smallContinent1ID, "yukon snow");
        rmSetAreaElevationType(smallContinent1ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallContinent1ID, 4.0);
        rmSetAreaBaseHeight(smallContinent1ID, 4.0);
        rmSetAreaElevationMinFrequency(smallContinent1ID, 0.09);
        rmSetAreaElevationOctaves(smallContinent1ID, 3);
        rmSetAreaElevationPersistence(smallContinent1ID, 0.2);      
	    rmSetAreaCoherence(smallContinent1ID, 0.80);
	    //rmSetAreaLocation(smallContinent1ID, 0.64, 0.65);
		rmSetAreaLocation(smallContinent1ID, 0.35, 0.75);
		rmSetAreaEdgeFilling(smallContinent1ID, 5);
        rmSetAreaObeyWorldCircleConstraint(smallContinent1ID, false);
		rmBuildArea(smallContinent1ID);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // SMALL CONTINENT SPUR 2:
		int smallContinent2ID=rmCreateArea("small continent spur 2");
        rmSetAreaSize(smallContinent2ID, 0.2, 0.2);
		//rmSetAreaSize(smallContinent2ID, 0.125, 0.125);
        rmSetAreaWarnFailure(smallContinent2ID, false);
        rmAddAreaToClass(smallContinent2ID, classbigContinent);
        rmSetAreaSmoothDistance(smallContinent2ID, 50);
	    rmSetAreaMix(smallContinent2ID, "saguenay grass");
		//rmSetAreaMix(smallContinent2ID, "texas_dirt");
        rmSetAreaElevationType(smallContinent2ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallContinent2ID, 4.0);
        rmSetAreaBaseHeight(smallContinent2ID, 4.0);
        rmSetAreaElevationMinFrequency(smallContinent2ID, 0.09);
        rmSetAreaElevationOctaves(smallContinent2ID, 3);
        rmSetAreaElevationPersistence(smallContinent2ID, 0.2);      
	    rmSetAreaCoherence(smallContinent2ID, 0.80);
	    rmSetAreaLocation(smallContinent2ID, 0.75, 0.35);
		rmSetAreaEdgeFilling(smallContinent2ID, 5);
        rmSetAreaObeyWorldCircleConstraint(smallContinent2ID, false);
		rmBuildArea(smallContinent2ID);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/
// ********************************** DEFINE AND PLACE THE 3 HILLS AREAS: ************************************** //
/*===============================================================================================================*/	
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // CONSTRAINTS OF THE NORTH HILLS:
		int hillNorthID=rmCreateArea("North hills");
	    int avoidNorth = rmCreateAreaDistanceConstraint("stuff avoid north", hillNorthID, 50.0);
	    int NorthHillConstraint = rmCreateAreaConstraint("North Hill Constraint", hillNorthID);

	    // DEFINE AND PLACE THE NORTH HILLS:
		//rmSetAreaSize(hillNorthID, 0.2, 0.2);
		rmSetAreaSize(hillNorthID, 0.05, 0.05);
	    rmSetAreaWarnFailure(hillNorthID, false);
	    rmSetAreaSmoothDistance(hillNorthID, 20);
	    rmSetAreaMix(hillNorthID, "saguenay grass");
		//  rmSetAreaMix(hillNorthID, "yukon snow");
		 rmAddAreaTerrainLayer(hillNorthID, "saguenay\ground5_sag", 4, 8);
	     rmAddAreaTerrainLayer(hillNorthID, "saguenay\ground3_sag", 8, 12);
         rmAddAreaTerrainLayer(hillNorthID, "saguenay\ground2_sag", 12, 16);
         rmAddAreaTerrainLayer(hillNorthID, "saguenay\ground2_sag", 16, 24);
	    //rmAddAreaTerrainLayer(hillNorthID, "new_england\ground4_ne", 2, 4);
	    //rmAddAreaTerrainLayer(hillNorthID, "new_england\ground4_ne", 4, 8);
	    //rmAddAreaTerrainLayer(hillNorthID, "new_england\ground4_ne", 8, 12);
		//rmAddAreaTerrainLayer(hillNorthID, "new_england\ground4_ne", 12, 16);
		//rmAddAreaTerrainLayer(hillNorthID, "new_england\ground4_ne", 16, 18);
		rmSetAreaElevationType(hillNorthID, cElevTurbulence);
	    rmSetAreaElevationVariation(hillNorthID, 12.0);
	    rmSetAreaBaseHeight(hillNorthID, 6.0);
	    rmSetAreaElevationMinFrequency(hillNorthID, 0.05);
	    rmSetAreaElevationOctaves(hillNorthID, 3);
	    rmSetAreaElevationPersistence(hillNorthID, 0.3);      
	    rmSetAreaElevationNoiseBias(hillNorthID, 0.5);
	    rmSetAreaElevationEdgeFalloffDist(hillNorthID, 20.0);
	    rmSetAreaCoherence(hillNorthID, 0.85);
	    //rmSetAreaLocation(hillNorthID, 0.9, 0.3);
		rmSetAreaLocation(hillNorthID, 0.75, 0.75);
	    rmSetAreaEdgeFilling(hillNorthID, 5);
	    //rmAddAreaInfluenceSegment(hillNorthID, 0.6, 0.0, 1.2, 1.2);
		rmAddAreaInfluenceSegment(hillNorthID, 0.675, 0.825, 0.825, 0.675);
	    rmSetAreaHeightBlend(hillNorthID, 1);
	    rmSetAreaObeyWorldCircleConstraint(hillNorthID, false);
	    rmAddAreaToClass(hillNorthID, rmClassID("classHillArea"));
	    rmBuildArea(hillNorthID);
	    
/*---------------------------------------------------------------------------------------------------------------*/		

	    // CONSTRAINTS OF THE CENTRAL HILLS:
		int hillCentralID=rmCreateArea("central hills");
	    int avoidCentral = rmCreateAreaDistanceConstraint("stuff avoid central", hillCentralID, 50.0);
	    int CentralHillConstraint = rmCreateAreaConstraint("Central Hill Constraint", hillCentralID);

	    // DEFINE AND PLACE THE CENTRAL HILLS:
		//rmSetAreaSize(hillCentralID, 0.2, 0.2);
		rmSetAreaSize(hillCentralID, 0.1, 0.1);
	    rmSetAreaWarnFailure(hillCentralID, false);
	    rmSetAreaSmoothDistance(hillCentralID, 30);
	    rmSetAreaMix(hillCentralID, "saguenay grass");
		//rmSetAreaMix(hillCentralID, "texas_dirt");
	    rmSetAreaElevationType(hillCentralID, cElevTurbulence);
	    rmSetAreaElevationVariation(hillCentralID, 2.0);
	    rmSetAreaBaseHeight(hillCentralID, 4);
	    rmSetAreaElevationMinFrequency(hillCentralID, 0.05);
	    rmSetAreaElevationOctaves(hillCentralID, 3);
	    rmSetAreaElevationPersistence(hillCentralID, 0.3);      
	    rmSetAreaElevationNoiseBias(hillCentralID, 0.5);
	    rmSetAreaElevationEdgeFalloffDist(hillCentralID, 0.0);
	    //rmSetAreaCoherence(hillCentralID, 0.7);
		rmSetAreaCoherence(hillCentralID, 0.85);
	    //rmSetAreaLocation(hillCentralID, 0.5, 0.5);
		rmSetAreaLocation(hillCentralID, 0.60, 0.60);
	    //rmAddAreaInfluenceSegment(hillCentralID, 0.4, 0.0, 0.8, 1);
		rmAddAreaInfluenceSegment(hillCentralID, 0.4, 0.8, 0.8, 0.4);
	    rmSetAreaHeightBlend(hillCentralID, 1);
	    //rmSetAreaObeyWorldCircleConstraint(hillCentralID, false);
	    rmAddAreaToClass(hillCentralID, rmClassID("classHillArea"));
	    rmBuildArea(hillCentralID);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // CONSTRAINTS OF THE SOUTH HILLS:
		int hillSouthID=rmCreateArea("South hills");
	    int avoidSouth = rmCreateAreaDistanceConstraint("stuff avoid south", hillSouthID, 50.0);
	    int SouthHillConstraint = rmCreateAreaConstraint("South Hill Constraint", hillSouthID);

	    // DEFINE AND PLACE THE SOUTH HILLS:
		//rmSetAreaSize(hillSouthID, 0.2, 0.2);
		rmSetAreaSize(hillSouthID, 0.05, 0.05);
	    rmSetAreaWarnFailure(hillSouthID, false);
	    rmSetAreaSmoothDistance(hillSouthID, 20);
	    rmSetAreaMix(hillSouthID, "saguenay grass");
		//  rmSetAreaMix(hillSouthID, "yukon snow");
		rmAddAreaTerrainLayer(hillSouthID, "saguenay\ground5_sag", 4, 8);
	    rmAddAreaTerrainLayer(hillSouthID, "saguenay\ground3_sag", 8, 12);
        rmAddAreaTerrainLayer(hillSouthID, "saguenay\ground2_sag", 12, 16);
        rmAddAreaTerrainLayer(hillSouthID, "saguenay\ground2_sag", 16, 24);
		//rmAddAreaTerrainLayer(hillSouthID, "new_england\ground4_ne", 0, 4);
	    //rmAddAreaTerrainLayer(hillSouthID, "new_england\ground4_ne", 4, 8);
	    //rmAddAreaTerrainLayer(hillSouthID, "new_england\ground4_ne", 8, 12);
		rmSetAreaElevationType(hillSouthID, cElevTurbulence);
	    rmSetAreaElevationVariation(hillSouthID, 12.0);
	    rmSetAreaBaseHeight(hillSouthID, 6.0);
	    rmSetAreaElevationMinFrequency(hillSouthID, 0.05);
	    rmSetAreaElevationOctaves(hillSouthID, 3);
	    rmSetAreaElevationPersistence(hillSouthID, 0.3);      
	    rmSetAreaElevationNoiseBias(hillSouthID, 0.5);
	    rmSetAreaElevationEdgeFalloffDist(hillSouthID, 20.0);
	    rmSetAreaCoherence(hillSouthID, 0.85);
	    //rmSetAreaLocation(hillSouthID, 0.9, 0.3);
		rmSetAreaLocation(hillSouthID, 0.45, 0.45);
	    //rmSetAreaEdgeFilling(hillSouthID, 5);
	    //rmAddAreaInfluenceSegment(hillSouthID, 0.6, 0.0, 1.2, 1.2);
		rmAddAreaInfluenceSegment(hillSouthID, 0.375, 0.525, 0.525, 0.375);
	    rmSetAreaHeightBlend(hillSouthID, 1);
	    //rmSetAreaObeyWorldCircleConstraint(hillSouthID, false);
	    rmAddAreaToClass(hillSouthID, rmClassID("classHillArea"));
	    rmBuildArea(hillSouthID);		

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/
// *************************************** DEFINE THE PLACEMENT ORDER: ***************************************** //
/*===============================================================================================================*/

	    // THE PLACEMENT ORDER:
        // TRADE ROUTE -> RIVER (none on this map) -> NATIVES -> SECRETS -> CLIFFS -> NUGGETS:

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE TRADE ROUTES: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    int tradeRouteID = rmCreateTradeRoute();

	    int socketID=rmCreateObjectDef("sockets for Trade Route");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmAddObjectDefConstraint(socketID, avoidImpassableLand);
	    rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
	    rmSetObjectDefAllowOverlap(socketID, true);
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 10.0);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    if(handedness < 0.5)
	{
		rmAddTradeRouteWaypoint(tradeRouteID, 0.275, 0.925);
		//rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.825, 0.575, 5, 8);
		//rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.575, 0.475, 5, 8);
		//rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.575, 0.325, 5, 8);
		//rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.425, 0.125, 5, 8);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.925, 0.275);
	}
	    else
	{
		rmAddTradeRouteWaypoint(tradeRouteID, 0.925, 0.275);
		//rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.425, 0.125, 5, 8);
		//rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.575, 0.325, 5, 8);
		//rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.575, 0.475, 5, 8);
		//rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.825, 0.575, 5, 8);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.275, 0.925);
	}

	    bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
	    if(placedTradeRoute == false)
		rmEchoError("Failed to place trade route");

/*---------------------------------------------------------------------------------------------------------------*/		

        // ADD THE SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	    vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	    if(handedness < 0.5)
	{
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.35);
	}
	    else
	{
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.45);
	}
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.75);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*===============================================================================================================*/

	    // PLAYER STARTING RESOURCES

        rmClearClosestPointConstraints();
   
/*---------------------------------------------------------------------------------------------------------------*/   
    
        // DEFINE THE TCID:
	    int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
		{
			rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
		}
		else
		{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
		}

	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);

	    rmAddObjectDefConstraint(TCID, avoidTradeRoute);
	    if (rmGetNumberPlayersOnTeam(0) == rmGetNumberPlayersOnTeam(1))
		rmAddObjectDefConstraint(TCID, avoidTownCenterFar);
	    else
		rmAddObjectDefConstraint(TCID, avoidTownCenter);
	    rmAddObjectDefConstraint(TCID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(TCID, longAvoidImpassableLand);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    //WATER HC ARRIVAL POINT

        int waterFlagID = 0;
        for(i=1; <cNumberPlayers)
    {
        waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 20.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
	}  
	
/*---------------------------------------------------------------------------------------------------------------*/	

	    // DEFINE THE PLAYER GOLD:
		int playergoldID = rmCreateObjectDef("player mine");
	    rmAddObjectDefItem(playergoldID, "minegold", 1, 0);
	    rmAddObjectDefConstraint(playergoldID, avoidTradeRoute);
	    rmAddObjectDefConstraint(playergoldID, avoidCliff);
		rmAddObjectDefConstraint(playergoldID, avoidMediumCoin);
	    rmSetObjectDefMinDistance(playergoldID, 10.0);
	    rmSetObjectDefMaxDistance(playergoldID, 15.0);
        rmAddObjectDefConstraint(playergoldID, avoidImpassableLand);
		
		// DEFINE THE PLAYER FAR GOLD:
		int playerfargoldID = rmCreateObjectDef("player far mine");
	    rmAddObjectDefItem(playerfargoldID, "minegold", 1, 0);
	    rmAddObjectDefConstraint(playerfargoldID, avoidTradeRoute);
	    rmAddObjectDefConstraint(playerfargoldID, avoidCliff);
		rmAddObjectDefConstraint(playerfargoldID, avoidMediumCoin);
	    rmSetObjectDefMinDistance(playerfargoldID, 25.0);
	    rmSetObjectDefMaxDistance(playerfargoldID, 35.0);
        rmAddObjectDefConstraint(playerfargoldID, avoidImpassableLand);

	    // DEFINE THE PLAYER SHEEP:
		float sheepstart = rmRandFloat(0.0, 1.0);
	    int playerSheepID = rmCreateObjectDef("player sheep");
	    if(sheepstart < 0.5)
	{
		rmAddObjectDefItem(playerSheepID, "sheep", rmRandInt(5,8), 8.0);
		rmSetObjectDefMinDistance(playerSheepID, 10);
		rmSetObjectDefMaxDistance(playerSheepID, 16);
		rmAddObjectDefConstraint(playerSheepID, avoidAll);
		rmAddObjectDefConstraint(playerSheepID, avoidCloseCoin);
		rmAddObjectDefConstraint(playerSheepID, avoidImpassableLand);
		rmAddObjectDefConstraint(playerSheepID, avoidCliff);
	}
	    else
	{
		rmAddObjectDefItem(playerSheepID, "sheep", rmRandInt(2,3), 2.0);
		rmSetObjectDefMinDistance(playerSheepID, 10);
		rmSetObjectDefMaxDistance(playerSheepID, 16);
		rmAddObjectDefConstraint(playerSheepID, avoidAll);
		rmAddObjectDefConstraint(playerSheepID, avoidCloseCoin);
		rmAddObjectDefConstraint(playerSheepID, avoidImpassableLand);
		rmAddObjectDefConstraint(playerSheepID, avoidCliff);
	}

	    // DEFINE THE PLAYER DEER:
		int playerDeerID=rmCreateObjectDef("player deer");
        rmAddObjectDefItem(playerDeerID, "Deer", rmRandInt(6,7), 8.0);
        rmSetObjectDefMinDistance(playerDeerID, 8);
        rmSetObjectDefMaxDistance(playerDeerID, 18);
	    rmAddObjectDefConstraint(playerDeerID, avoidAll);
		rmAddObjectDefConstraint(playerDeerID, avoidDeer);
		rmAddObjectDefConstraint(playerDeerID, avoidCloseCoin);
	    rmAddObjectDefConstraint(playerDeerID, avoidCliff);
        rmAddObjectDefConstraint(playerDeerID, avoidImpassableLand);
	    rmSetObjectDefCreateHerd(playerDeerID, true);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeSaguenay", rmRandInt(5,9), 8.0);
        rmSetObjectDefMinDistance(playerTreeID, 18);
        rmSetObjectDefMaxDistance(playerTreeID, 25);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
		rmAddObjectDefConstraint(playerTreeID, avoidCloseDeer);
		rmAddObjectDefConstraint(playerTreeID, avoidCloseCoin);
	    rmAddObjectDefConstraint(playerTreeID, avoidCliff);
        rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(playerNuggetID, longAvoidImpassableLand);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidFarNugget);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidAll);
		rmAddObjectDefConstraint(playerNuggetID, avoidCloseDeer);
		rmAddObjectDefConstraint(playerNuggetID, avoidCloseCoin);
	    rmAddObjectDefConstraint(playerNuggetID, avoidCliff);
	    rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
		
		// DEFINE THE PLAYER FAR NUGGET:
		int playerFarNuggetID= rmCreateObjectDef("player far nugget"); 
	    rmAddObjectDefItem(playerFarNuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(playerFarNuggetID, longAvoidImpassableLand);
  	    rmAddObjectDefConstraint(playerFarNuggetID, avoidFarNugget);
  	    rmAddObjectDefConstraint(playerFarNuggetID, avoidTradeRoute);
  	    rmAddObjectDefConstraint(playerFarNuggetID, avoidAll);
		rmAddObjectDefConstraint(playerFarNuggetID, avoidCloseDeer);
		rmAddObjectDefConstraint(playerFarNuggetID, avoidCloseCoin);
	    rmAddObjectDefConstraint(playerFarNuggetID, avoidCliff);
	    rmSetObjectDefMinDistance(playerFarNuggetID, 32.0);
	    rmSetObjectDefMaxDistance(playerFarNuggetID, 36.0);
		
		// PREPARE TO PLACE PLAYER STARTING BERRIES:
	    int playerBerriesID=rmCreateObjectDef("player berries");
	    rmAddObjectDefItem(playerBerriesID, "berrybush", rmRandInt(4,6), 5.0);
        rmSetObjectDefCreateHerd(playerBerriesID, true);		
        rmSetObjectDefMinDistance(playerBerriesID, 21);
        rmSetObjectDefMaxDistance(playerBerriesID, 26);		
	    rmAddObjectDefConstraint(playerBerriesID, avoidAll);
		rmAddObjectDefConstraint(playerBerriesID, avoidMediumFruits);
		rmAddObjectDefConstraint(playerBerriesID, avoidCloseDeer);
        rmAddObjectDefConstraint(playerBerriesID, avoidImpassableLand);
		rmAddObjectDefConstraint(playerBerriesID, avoidCliff);
		rmAddObjectDefConstraint(playerBerriesID, avoidCloseCoin);
		rmAddObjectDefConstraint(playerBerriesID, avoidCloseNugget);
		rmAddObjectDefConstraint(playerBerriesID, avoidTradeRoute);
        	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/
// ************************ PLACE THE STARTING TCID AND THE STARTING UNITS AND RESOURCES: ********************** //
/*===============================================================================================================*/	

	    for(i=1; <cNumberPlayers)
   
   {
	    //PLACE THE STARTING TCID:
	    rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
        // PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    
		// PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playergoldID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    // PLACE THE PLAYER FAR GOLD:
		rmPlaceObjectDefAtLoc(playerfargoldID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	   	// PLACE THE PLAYER TREE:
     	rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    // PLACE THE PLAYER SHEEP:
		rmPlaceObjectDefAtLoc(playerSheepID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    // PLACE THE PLAYER DEER:
		rmPlaceObjectDefAtLoc(playerDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    // PLACE THE PLAYER NUGGET:
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        // PLACE THE PLAYER BERRIES:
		rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc))); 
		rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc))); 
		// PLACE THE WATER FLAG:
	    vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	    rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
   }
        // CLEAR CLOSEST POINT CONSTRAINTS: ( NECESSARY TO BE ABLE TO PLACE THE 2 WATERFLAGS ON THE MAP: ).
		rmClearClosestPointConstraints();

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/
// ******************************** DEFINE AND PLACE THE NATIVE AMERICANS: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
   
	    float NativeVillageLoc = rmRandFloat(0,1); //
     
	    int cherokeeVillageID = -1;
	    int cherokeeVillageType = rmRandInt(1,5);
	    int IroquoisVillageID = -1;
	    int IroquoisVillageType = rmRandInt(1,3);
	    int Iroquois1VillageID = -1;
	    int Iroquois1VillageType = rmRandInt(1,3);
	    int cherokee1VillageID = -1;
	    int cherokee1VillageType = rmRandInt(1,5);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    if(handedness > .5)
	{
		if(subCiv0 == rmGetCivID("Iroquois"))
	{   
		IroquoisVillageID = rmCreateGrouping("Iroquois village", "native Iroquois village "+IroquoisVillageType);
		rmSetGroupingMinDistance(IroquoisVillageID, 0.0);
		rmSetGroupingMaxDistance(IroquoisVillageID, 0.0);
		rmAddGroupingToClass(IroquoisVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(IroquoisVillageID, longAvoidImpassableLand);
		rmAddGroupingToClass(IroquoisVillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(IroquoisVillageID, avoidTradeRoute);
		rmAddGroupingConstraint(IroquoisVillageID, avoidNatives);
		rmAddGroupingConstraint(IroquoisVillageID, avoidTownCenter);

		//rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.36, 0.43);
		rmPlaceGroupingAtLoc(IroquoisVillageID, 0, 0.4, 0.9);
	}

	    else if (subCiv0 == rmGetCivID("Cherokee"))
	{
		cherokeeVillageID = rmCreateGrouping("cherokee village", "native cherokee village "+cherokeeVillageType);
		rmSetGroupingMinDistance(cherokeeVillageID, 0.0);
		rmSetGroupingMaxDistance(cherokeeVillageID, 0.0);
		rmAddGroupingToClass(cherokeeVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokeeVillageID, longAvoidImpassableLand);
		rmAddGroupingToClass(cherokeeVillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(cherokeeVillageID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokeeVillageID, avoidNatives);
		rmAddGroupingConstraint(cherokeeVillageID, avoidTownCenter);
		rmPlaceGroupingAtLoc(cherokeeVillageID, 0, 0.9, 0.4);
	}
	
/*---------------------------------------------------------------------------------------------------------------*/	

	}
	    else
	{
	
/*---------------------------------------------------------------------------------------------------------------*/	

		if(subCiv0 == rmGetCivID("Iroquois"))
	{   
		Iroquois1VillageID = rmCreateGrouping("Iroquois1 village", "native Iroquois village "+Iroquois1VillageType);
		rmSetGroupingMinDistance(Iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(Iroquois1VillageID, 0.0);
		rmAddGroupingToClass(Iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(Iroquois1VillageID, longAvoidImpassableLand);
		rmAddGroupingToClass(Iroquois1VillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(Iroquois1VillageID, avoidTradeRoute);
		rmAddGroupingConstraint(Iroquois1VillageID, avoidTownCenter);
		rmAddGroupingConstraint(Iroquois1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(Iroquois1VillageID, 0, 0.55, 0.55);
	}

		else if (subCiv0 == rmGetCivID("Cherokee"))
	{
		cherokee1VillageID = rmCreateGrouping("cherokee1 village", "native cherokee village "+cherokee1VillageType);
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, longAvoidImpassableLand);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokee1VillageID, avoidTownCenter);
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.55, 0.55);
	}
	
/*---------------------------------------------------------------------------------------------------------------*/	

	}

	    if(subCiv1 == rmGetCivID("Iroquois"))
	{
		int Iroquois2VillageID = -1;
		int Iroquois2VillageType = rmRandInt(4,5);
		Iroquois2VillageID = rmCreateGrouping("Iroquois2 village", "native Iroquois village "+Iroquois2VillageType);
		rmSetGroupingMinDistance(Iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(Iroquois2VillageID, 0.0);
		rmAddGroupingToClass(Iroquois2VillageID, rmClassID("natives"));
		rmAddObjectDefConstraint(Iroquois2VillageID, longAvoidImpassableLand);
		rmAddGroupingConstraint(Iroquois2VillageID, longAvoidImpassableLand);
		rmAddGroupingConstraint(Iroquois2VillageID, avoidTradeRoute);
		rmAddGroupingConstraint(Iroquois2VillageID, avoidTownCenter);
		rmAddGroupingConstraint(Iroquois2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(Iroquois2VillageID, 0, 0.45, 0.65);
	}
	    else if (subCiv1 == rmGetCivID("Cherokee"))
	{   
		int cherokee2VillageID = -1;
		int cherokee2VillageType = rmRandInt(1,5);
		cherokee2VillageID = rmCreateGrouping("cherokee2 village", "native cherokee village "+cherokee2VillageType);
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("importantItem"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidTradeRoute);
		rmAddGroupingConstraint(cherokee2VillageID, avoidTownCenter);
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.65, 0.45);
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*===============================================================================================================*/
// ************************************** DEFINE AND PLACE THE CLIFFS: ***************************************** //	
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
   
      int numTries=cNumberNonGaiaPlayers+3;
   
      for(i=0; <numTries)
   {
      int cliffID=rmCreateArea("cliff"+i);
      rmSetAreaSize(cliffID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(750));
	  //rmSetAreaSize(cliffID, rmAreaTilesToFraction(900), rmAreaTilesToFraction(1800));
      rmSetAreaWarnFailure(cliffID, false);
	  rmSetAreaCliffType(cliffID, "New England");
	  rmSetAreaCliffEdge(cliffID, 1, 0.6, 0.8, 1.0, 0);
      //rmSetAreaCliffEdge(cliffID, 1, 0.6, 0.1, 1.0, 0);
	  //rmSetAreaCliffEdge(cliffID, 1, 1);
      rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
      rmSetAreaCliffHeight(cliffID, 5, 2.0, 0.5);
      rmSetAreaHeightBlend(cliffID, 1);
      rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
      rmAddAreaConstraint(cliffID, longAvoidImpassableLand);
      rmAddAreaConstraint(cliffID, cliffConstraint);
	  rmAddAreaConstraint(cliffID, avoidTownCenterFar);
      rmAddAreaConstraint(cliffID, avoidImportantItem);
      rmAddAreaConstraint(cliffID, avoidTradeRoute);
	  //rmAddAreaConstraint(cliffID, CentralHillConstraint);
	  rmAddAreaConstraint(cliffID, avoidCoin);
	  rmAddAreaConstraint(cliffID, avoidNatives);
	  rmAddAreaConstraint(cliffID, avoidNorth);
	  rmAddAreaConstraint(cliffID, avoidSouth);
	  rmAddAreaConstraint(cliffID, avoidCentral);
      rmSetAreaMinBlobs(cliffID, 4);
      rmSetAreaMaxBlobs(cliffID, 6);
      rmSetAreaMinBlobDistance(cliffID, 16.0);
      rmSetAreaMaxBlobDistance(cliffID, 30.0);
      rmSetAreaSmoothDistance(cliffID, 10);
      rmSetAreaCoherence(cliffID, 0.75);
      rmBuildArea(cliffID);
   } 

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/
// ************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
  
        // THE NUGGET EASY:
		int nuggetID= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggetID, avoidNugget);
  	    rmAddObjectDefConstraint(nuggetID, avoidTownCenter);
  	    rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nuggetID, avoidAll);
		rmAddObjectDefConstraint(nuggetID, avoidNatives);
  	    rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
	    rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // THE NUGGET MEDIUM:
		int nuggetmediumID= rmCreateObjectDef("nugget medium"); 
	    rmAddObjectDefItem(nuggetmediumID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nuggetmediumID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetmediumID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggetmediumID, avoidNugget);
  	    rmAddObjectDefConstraint(nuggetmediumID, avoidTownCenter);
  	    rmAddObjectDefConstraint(nuggetmediumID, avoidTradeRoute);
	    rmAddObjectDefConstraint(nuggetmediumID, avoidCliff);
  	    rmAddObjectDefConstraint(nuggetmediumID, avoidAll);
		rmAddObjectDefConstraint(nuggetmediumID, avoidNatives);
  	    rmAddObjectDefConstraint(nuggetmediumID, longAvoidImpassableLand);
	    rmPlaceObjectDefAtLoc(nuggetmediumID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // THE NUGGET HARD:
	    int nuggethardID= rmCreateObjectDef("nugget hard"); 
	    rmAddObjectDefItem(nuggethardID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 3);
	    rmSetObjectDefMinDistance(nuggethardID, 0.0);
	    rmSetObjectDefMaxDistance(nuggethardID, rmXFractionToMeters(0.5));
  	    rmAddObjectDefConstraint(nuggethardID, avoidNugget);
  	    rmAddObjectDefConstraint(nuggethardID, avoidTownCenter);
  	    rmAddObjectDefConstraint(nuggethardID, avoidTradeRoute);
	    rmAddObjectDefConstraint(nuggethardID, avoidCliff);
  	    rmAddObjectDefConstraint(nuggethardID, avoidAll);
		rmAddObjectDefConstraint(nuggethardID, avoidNatives);
	    rmAddObjectDefConstraint(nuggethardID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggethardID, longAvoidImpassableLand);
	    rmPlaceObjectDefAtLoc(nuggethardID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // PLACE MORE HARD 25% OF THE TIME:
		// THE NUGGET HARD:
		if(rmRandFloat(0,1) < 0.25) //places more hard 25% of the time
	{
		int nuggethard2ID= rmCreateObjectDef("nugget more hard"); 
		rmAddObjectDefItem(nuggethard2ID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(3, 3);
		rmSetObjectDefMinDistance(nuggethard2ID, 0.0);
		rmSetObjectDefMaxDistance(nuggethard2ID, rmXFractionToMeters(0.5));
  		rmAddObjectDefConstraint(nuggethard2ID, avoidNugget);
  		rmAddObjectDefConstraint(nuggethard2ID, avoidTownCenter);
  		rmAddObjectDefConstraint(nuggethard2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nuggethard2ID, avoidCliff);
  		rmAddObjectDefConstraint(nuggethard2ID, avoidAll);
		rmAddObjectDefConstraint(nuggethard2ID, NorthHillConstraint);
		rmAddObjectDefConstraint(nuggethard2ID, playerEdgeConstraint);
  		rmAddObjectDefConstraint(nuggethard2ID, longAvoidImpassableLand);
		rmPlaceObjectDefAtLoc(nuggethard2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2);
	}

/*---------------------------------------------------------------------------------------------------------------*/
	
	    // ONLY TRY TO PLACE THESE 25% OF THE TIME:
	    // THE NUGGET NUTS:
		if(rmRandFloat(0,1) < 0.25)
	{
		int nuggetnutsID= rmCreateObjectDef("nugget nuts"); 
		rmAddObjectDefItem(nuggetnutsID, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nuggetnutsID, 0.0);
		rmSetObjectDefMaxDistance(nuggetnutsID, rmXFractionToMeters(0.5));
  		rmAddObjectDefConstraint(nuggetnutsID, avoidNugget);
  		rmAddObjectDefConstraint(nuggetnutsID, avoidTownCenter);
  		rmAddObjectDefConstraint(nuggetnutsID, avoidTradeRoute);
		rmAddObjectDefConstraint(nuggetnutsID, avoidCliff);
  		rmAddObjectDefConstraint(nuggetnutsID, avoidAll);
		rmAddObjectDefConstraint(nuggetnutsID, SouthHillConstraint);
		rmAddObjectDefConstraint(nuggetnutsID, playerEdgeConstraint);
  		rmAddObjectDefConstraint(nuggetnutsID, longAvoidImpassableLand);
		rmPlaceObjectDefAtLoc(nuggetnutsID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
	}

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/
// ******************************** DEFINE AND PLACE THE WHALES AND THE FISHES: ******************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    if(rmRandFloat(0,1) < 0.5)
   {
		int whaleID=rmCreateObjectDef("whale");
		rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
		rmSetObjectDefMinDistance(whaleID, 0.0);
		rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
		rmAddObjectDefConstraint(whaleID, whaleLand);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 1.0*cNumberNonGaiaPlayers);
   }

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.92);
/*===============================================================================================================*/
// **************************** PLACE RESOURCES THAT WE WANT FORESTS TO AVOID: ********************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // DEFINE AND PLACE THE GOLD WEST:
 	    int goldType = -1;
	    int goldCount = (cNumberNonGaiaPlayers + rmRandInt(1,2));
	    rmEchoInfo("gold count = "+goldCount);

	    for(i=0; < goldCount)
	{
	    int goldID = rmCreateObjectDef("gold West "+i);
	    rmAddObjectDefItem(goldID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(goldID, 0.0);
        rmSetObjectDefMaxDistance(goldID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(goldID, avoidCoin);
        rmAddObjectDefConstraint(goldID, avoidAll);
		rmAddObjectDefConstraint(goldID, avoidNatives);
	    rmAddObjectDefConstraint(goldID, avoidCliff);
        rmAddObjectDefConstraint(goldID, avoidTownCenterFar);
	    rmAddObjectDefConstraint(goldID, avoidTradeRoute);
        rmAddObjectDefConstraint(goldID, mediumAvoidImpassableLand);
	    rmAddObjectDefConstraint(goldID, SouthHillConstraint);
	    rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5);
   }

/*---------------------------------------------------------------------------------------------------------------*/	    
		
		// DEFINE AND PLACE THE GOLD EAST:
		goldCount = (cNumberNonGaiaPlayers + rmRandInt(1,2));
	    rmEchoInfo("gold2 count = "+goldCount);

	    for(i=0; < goldCount)
	{
	    int goldEastID = rmCreateObjectDef("gold East "+i);
	    rmAddObjectDefItem(goldEastID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(goldEastID, 0.0);
        rmSetObjectDefMaxDistance(goldEastID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(goldEastID, avoidCoin);
        rmAddObjectDefConstraint(goldEastID, avoidAll);
		rmAddObjectDefConstraint(goldEastID, avoidNatives);
	    rmAddObjectDefConstraint(goldEastID, avoidCliff);
        rmAddObjectDefConstraint(goldEastID, avoidTownCenterFar);
	    rmAddObjectDefConstraint(goldEastID, avoidTradeRoute);
        rmAddObjectDefConstraint(goldEastID, mediumAvoidImpassableLand);
	    rmAddObjectDefConstraint(goldEastID, NorthHillConstraint);
	    rmPlaceObjectDefAtLoc(goldEastID, 0, 0.5, 0.5);
	}
	
/*---------------------------------------------------------------------------------------------------------------*/	

	    // DEFINE AND PLACE THE GOLD RANDOM:
		
		if (cNumberNonGaiaPlayers > 4)
		goldCount = (2);
	    else
		goldCount = (cNumberNonGaiaPlayers + 1);
	    rmEchoInfo("gold3 count = "+goldCount);

	    for(i=0; < goldCount)
	{
	    int goldRandomID = rmCreateObjectDef("gold Random "+i);
	    rmAddObjectDefItem(goldRandomID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(goldRandomID, 0.0);
        rmSetObjectDefMaxDistance(goldRandomID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(goldRandomID, avoidCoinFar);
        rmAddObjectDefConstraint(goldRandomID, avoidAll);
		rmAddObjectDefConstraint(goldRandomID, avoidNorth);
		rmAddObjectDefConstraint(goldRandomID, avoidSouth);
		//rmAddObjectDefConstraint(goldRandomID, avoidCentral);
		rmAddObjectDefConstraint(goldRandomID, CentralHillConstraint);
		rmAddObjectDefConstraint(goldRandomID, avoidNatives);
		rmAddObjectDefConstraint(goldRandomID, avoidFarFruits);
	    rmAddObjectDefConstraint(goldRandomID, shortAvoidCliff);
        rmAddObjectDefConstraint(goldRandomID, avoidTownCenterFar);
	    rmAddObjectDefConstraint(goldRandomID, avoidTradeRoute);
        rmAddObjectDefConstraint(goldRandomID, mediumAvoidImpassableLand);
	    rmPlaceObjectDefAtLoc(goldRandomID, 0, 0.5, 0.5); 
   }
   
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE THE RANDOM BERRIES: ************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // SCATTERED BERRRIES:		
	    int berriesID=rmCreateObjectDef("random berries");
	    rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(5,8), 6.0);  
	    rmSetObjectDefMinDistance(berriesID, 0.0);
	    rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(berriesID, avoidTownCenterFar);
	    rmAddObjectDefConstraint(berriesID, shortAvoidCliff);   
	    rmAddObjectDefConstraint(berriesID, avoidTradeRoute);
		rmAddObjectDefConstraint(berriesID, avoidCloseImportantItem);
	    rmAddObjectDefConstraint(berriesID, avoidAll);
		rmAddObjectDefConstraint(berriesID, CentralHillConstraint);
		rmAddObjectDefConstraint(berriesID, avoidNorth);
		rmAddObjectDefConstraint(berriesID, avoidSouth);
		rmAddObjectDefConstraint(berriesID, avoidCoin);
		rmAddObjectDefConstraint(berriesID, avoidNugget);
		rmAddObjectDefConstraint(berriesID, avoidNatives);
		rmAddObjectDefConstraint(berriesID, avoidFarFruits);
	    rmAddObjectDefConstraint(berriesID, mediumAvoidImpassableLand);
	    rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers); 

/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int randomTreeID=rmCreateObjectDef("random tree");
        rmAddObjectDefItem(randomTreeID, "TreeSaguenay", rmRandInt(3,7), 5.0);
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, avoidTownCenterFar);
	    rmAddObjectDefConstraint(randomTreeID, shortAvoidCliff);   
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseImportantItem);
	    rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNatives);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseFruits);
	    rmAddObjectDefConstraint(randomTreeID, mediumAvoidImpassableLand);
	    		
        rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 35*cNumberNonGaiaPlayers);		
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.94);
/*===============================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
  
         // THE FOREST REDWOOD:
         int forestTreeID = 0;
         numTries=2.5*cNumberNonGaiaPlayers;
         int failCount=0;
         for (i=0; <numTries)
      {   
         int forestRedwood=rmCreateArea("forest redwood "+i, rmAreaID("big continent"));
         rmSetAreaWarnFailure(forestRedwood, false);
         rmSetAreaSize(forestRedwood, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
         rmSetAreaForestType(forestRedwood, "saguenay forest");
		 rmSetAreaForestDensity(forestRedwood, 0.45);
         rmSetAreaForestClumpiness(forestRedwood, 0.15);
         rmSetAreaForestUnderbrush(forestRedwood, 0.6);
         rmSetAreaMinBlobs(forestRedwood, 12);
         rmSetAreaMaxBlobs(forestRedwood, 22);
         rmSetAreaMinBlobDistance(forestRedwood, 10.0);
         rmSetAreaMaxBlobDistance(forestRedwood, 20.0);
         rmSetAreaCoherence(forestRedwood, 0.35);
         rmSetAreaSmoothDistance(forestRedwood, 10);
         rmAddAreaToClass(forestRedwood, rmClassID("classForest")); 
         rmAddAreaConstraint(forestRedwood, forestConstraint);
         rmAddAreaConstraint(forestRedwood, avoidAll);
		 rmAddAreaConstraint(forestRedwood, avoidCloseImportantItem);
		 rmAddAreaConstraint(forestRedwood, avoidNatives);
         //rmAddAreaConstraint(forestRedwood, avoidCliff);
         rmAddAreaConstraint(forestRedwood, avoidImpassableLand); 
         rmAddAreaConstraint(forestRedwood, avoidTradeRouteShort);
		 rmAddAreaConstraint(forestRedwood, SouthHillConstraint);
		 
         if(rmBuildArea(forestRedwood)==false)
         {
            // Stop trying once we fail 4 times in a row.
            failCount++;
            if(failCount==4)
               break;
         }
         else
            failCount=0; 
      }
	
/*---------------------------------------------------------------------------------------------------------------*/
	
	     // THE FOREST PINE FOREST:
		 forestTreeID = 0;
	     numTries=3*cNumberNonGaiaPlayers;
	     failCount=0;
	     for (i=0; <numTries)
      {   
         int forest=rmCreateArea("forest pine forest "+i, rmAreaID("big continent"));
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
         rmSetAreaForestType(forest, "saguenay forest");
		 rmSetAreaForestDensity(forest, 0.85);
         rmSetAreaForestClumpiness(forest, 0.10);
         rmSetAreaForestUnderbrush(forest, 0.6);
         rmSetAreaMinBlobs(forest, 8);
         rmSetAreaMaxBlobs(forest, 15);
         rmSetAreaMinBlobDistance(forest, 20.0);
         rmSetAreaMaxBlobDistance(forest, 40.0);
         rmSetAreaCoherence(forest, 0.25);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
         rmAddAreaConstraint(forest, forestConstraint);
         rmAddAreaConstraint(forest, avoidAll);
		 rmAddAreaConstraint(forest, avoidCloseImportantItem);
		 rmAddAreaConstraint(forest, avoidNatives);
         //rmAddAreaConstraint(forest, avoidCliff);
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         rmAddAreaConstraint(forest, avoidTradeRouteShort);
		 rmAddAreaConstraint(forest, CentralHillConstraint);
		 
         if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 5 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
      } 

/*---------------------------------------------------------------------------------------------------------------*/	  
	  
	     // THE FOREST DESERT:
		 forestTreeID = 0;
	     numTries=2*cNumberNonGaiaPlayers;
	     failCount=0;
	     for (i=0; <numTries)
      {   
         int forestEast=rmCreateArea("forest desert "+i, rmAreaID("big continent"));
         rmSetAreaWarnFailure(forestEast, false);
         rmSetAreaSize(forestEast, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
         rmSetAreaForestType(forestEast, "saguenay forest");
		 rmSetAreaForestDensity(forestEast, 0.6);
         rmSetAreaForestClumpiness(forestEast, 0.1);
         rmSetAreaForestUnderbrush(forestEast, 0.6);
         rmSetAreaMinBlobs(forestEast, 10);
         rmSetAreaMaxBlobs(forestEast, 20);
         rmSetAreaMinBlobDistance(forestEast, 16.0);
         rmSetAreaMaxBlobDistance(forestEast, 35.0);
         rmSetAreaCoherence(forestEast, 0.8);
         rmSetAreaSmoothDistance(forestEast, 10);
         rmAddAreaToClass(forestEast, rmClassID("classForest")); 
         rmAddAreaConstraint(forestEast, forestConstraint);
         rmAddAreaConstraint(forestEast, avoidAll);
		 rmAddAreaConstraint(forestEast, avoidNatives);
         //rmAddAreaConstraint(forestEast, avoidCliff);
		 rmAddAreaConstraint(forestEast, avoidCloseImportantItem);
         rmAddAreaConstraint(forestEast, avoidImpassableLand); 
         rmAddAreaConstraint(forestEast, avoidTradeRouteShort);
		 rmAddAreaConstraint(forestEast, NorthHillConstraint);
		 
         if(rmBuildArea(forestEast)==false)
         {
            // Stop trying once we fail 6 times in a row.
            failCount++;
            if(failCount==6)
               break;
         }
         else
            failCount=0; 
      } 
	  
/*---------------------------------------------------------------------------------------------------------------*/

         // THE FOREST MADRONE:
		 forestTreeID = 0;
	     numTries=2*cNumberNonGaiaPlayers;
	     failCount=0;
	     for (i=0; <numTries)
      {   
         int forestMadrone=rmCreateArea("forest madrone "+i, rmAreaID("big continent"));
         rmSetAreaWarnFailure(forestMadrone, false);
         rmSetAreaSize(forestMadrone, rmAreaTilesToFraction(150), rmAreaTilesToFraction(400));
         rmSetAreaForestType(forestMadrone, "saguenay forest");
		 rmSetAreaForestDensity(forestMadrone, 0.65);
         rmSetAreaForestClumpiness(forestMadrone, 0.15);
         rmSetAreaForestUnderbrush(forestMadrone, 0.6);
         rmSetAreaMinBlobs(forestMadrone, 10);
         rmSetAreaMaxBlobs(forestMadrone, 20);
         rmSetAreaMinBlobDistance(forestMadrone, 20.0);
         rmSetAreaMaxBlobDistance(forestMadrone, 30.0);
         rmSetAreaCoherence(forestMadrone, 0.35);
         rmSetAreaSmoothDistance(forestMadrone, 10);
         rmAddAreaToClass(forestMadrone, rmClassID("classForest")); 
         rmAddAreaConstraint(forestMadrone, forestConstraint);
         rmAddAreaConstraint(forestMadrone, avoidAll);
		 rmAddAreaConstraint(forestMadrone, avoidNatives);
         rmAddAreaConstraint(forestMadrone, avoidCliff);
         rmAddAreaConstraint(forestMadrone, avoidImpassableLand); 
         rmAddAreaConstraint(forestMadrone, avoidTradeRoute);
		 rmAddAreaConstraint(forestMadrone, avoidCloseImportantItem);
		 rmAddAreaConstraint(forestMadrone, avoidNorth);
		 rmAddAreaConstraint(forestMadrone, avoidSouth);
		 rmAddAreaConstraint(forestMadrone, avoidCentral);
		 
         if(rmBuildArea(forestMadrone)==false)
         {
            // Stop trying once we fail 4 times in a row.
            failCount++;
            if(failCount==4)
               break;
         }
         else
            failCount=0; 
      }

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/
// ********************************* DEFINE AND PLACE THE DEER AND THE ELK: ************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // DEFINE AND PLACE THE DEERS IN THE CENTRAL HILLS:
		int deerID=rmCreateObjectDef("deer herd");
	    rmAddObjectDefItem(deerID, "deer", rmRandInt(6,9), 10.0);
	    rmSetObjectDefMinDistance(deerID, 0.0);
	    rmSetObjectDefMaxDistance(deerID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(deerID, avoidDeer);
	    rmAddObjectDefConstraint(deerID, avoidAll);
		rmAddObjectDefConstraint(deerID, avoidNatives);
		rmAddObjectDefConstraint(deerID, avoidCloseFruits);
	    rmAddObjectDefConstraint(deerID, avoidNorth);
		rmAddObjectDefConstraint(deerID, playerMediumConstraint);
	    rmAddObjectDefConstraint(deerID, CentralHillConstraint);
	    rmAddObjectDefConstraint(deerID, avoidImpassableLand);
	    rmSetObjectDefCreateHerd(deerID, true);

	    // DEFINE AND PLACE THE ELKS IN THE NORTH HILLS:
		int elkID=rmCreateObjectDef("elk herd");
	    rmAddObjectDefItem(elkID, "elk", rmRandInt(8,9), 13);
	    rmSetObjectDefMinDistance(elkID, 0.0);
	    rmSetObjectDefMaxDistance(elkID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(elkID, avoidFarElk);
	    rmAddObjectDefConstraint(elkID, avoidDeer);
	    rmAddObjectDefConstraint(elkID, avoidAll);
		rmAddObjectDefConstraint(elkID, avoidNatives);
		rmAddObjectDefConstraint(elkID, avoidCentral);
		rmAddObjectDefConstraint(elkID, avoidCloseFruits);
		rmAddObjectDefConstraint(elkID, playerMediumConstraint);
	    rmAddObjectDefConstraint(elkID, NorthHillConstraint);
	    rmAddObjectDefConstraint(elkID, avoidImpassableLand);
	    rmSetObjectDefCreateHerd(elkID, true);
		
		// DEFINE AND PLACE THE MOOSES IN THE SOUTH HILLS:
		int MooseID=rmCreateObjectDef("moose herd");
	    rmAddObjectDefItem(MooseID, "moose", rmRandInt(8,9), 13);
	    rmSetObjectDefMinDistance(MooseID, 0.0);
	    rmSetObjectDefMaxDistance(MooseID, rmXFractionToMeters(0.3));
	    rmAddObjectDefConstraint(MooseID, avoidFarElk);
	    rmAddObjectDefConstraint(MooseID, avoidDeer);
	    rmAddObjectDefConstraint(MooseID, avoidAll);
		rmAddObjectDefConstraint(MooseID, avoidNatives);
		rmAddObjectDefConstraint(MooseID, avoidFarMoose);
		rmAddObjectDefConstraint(MooseID, avoidCentral);
		rmAddObjectDefConstraint(MooseID, avoidCloseFruits);
		rmAddObjectDefConstraint(MooseID, playerMediumConstraint);
	    rmAddObjectDefConstraint(MooseID, SouthHillConstraint);
	    rmAddObjectDefConstraint(MooseID, avoidImpassableLand);
	    rmSetObjectDefCreateHerd(MooseID, true);

	    if (cNumberNonGaiaPlayers >= 4)
	{
		rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(elkID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(MooseID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
	}
	    else
	{
		rmPlaceObjectDefAtLoc(deerID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(elkID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		rmPlaceObjectDefAtLoc(MooseID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		
