/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// THE SANTA CRUZ WAR:
// CREATED BY DANY:
// NOVEMBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
		
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	
		subCiv0=rmGetCivID("aztec");
        rmEchoInfo("subCiv0 is aztec" +subCiv0);
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "aztec");
    
        subCiv1=rmGetCivID("maya");
        rmEchoInfo("subCiv1 is maya" +subCiv1);
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "maya");

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int playerTiles=22500;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(600, 600);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** PICKS THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // SET SEA LEVEL:
        rmSetSeaLevel(0.0);

        // SET MAP ELEVATION PARAMETERS:
        rmSetMapElevationParameters(cElevTurbulence, 0.02, 4, 0.5, 8.0);
		//rmSetMapElevationParameters(cElevTurbulence, 0.05, 6, 0.7, 8.0);
        
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("amazon grass");
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("Amazon\ground2_ama", 6);	
        
		// SET LIGHTING:
		rmSetLightingSet("amazon");
        
		// SET MAP TYPE:
		rmSetMapType("amazonia");
        rmSetMapType("tropical");
        rmSetMapType("land");
        
		// SET WORLD CIRCKE CONSTRAINT:
		rmSetWorldCircleConstraint(true);

        // CHOOSE MERCS:
		chooseMercs();
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/

        int classPlayer=rmDefineClass("player");
        int classTop=rmDefineClass("classTop");
        int classConnection=rmDefineClass("classConnection");
        int classStartingRidge = rmDefineClass("startingRidge");
        rmDefineClass("classPatch");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("secrets");
        rmDefineClass("nuggets");
        rmDefineClass("classHillArea");
        rmDefineClass("classSmallHillArea");
        rmDefineClass("socketClass");
        rmDefineClass("natives");
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.20);
/*================================================================================================================*/	
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
   
    // MAP EDGE CONSTRAINTS:
    int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
    int ridgeEdgeConstraint=rmCreateBoxConstraint("keep ridges from hitting border", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
    int silverEdgeConstraint=rmCreateBoxConstraint("silver edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
    int forestEdgeConstraint=rmCreatePieConstraint("forest edge of map", 0.5, 0.5, 0, rmGetMapXSize()-5, 0, 0, 0);
    int heavyForestConstraint=rmCreatePieConstraint("Heavy forests concentrated near edge of map", 0.5, 0.5, rmXFractionToMeters(0.25), rmXFractionToMeters(0.48), rmDegreesToRadians(0), rmDegreesToRadians(360));
    //int nativeConstraint=rmCreatePieConstraint("Natives stay close to middle", 0.5, 0.5, 0, rmXFractionToMeters(0.3), rmDegreesToRadians(0), rmDegreesToRadians(360));

    // PLAYER CONSTRAINTS:
    int playerConstraint = rmCreateClassDistanceConstraint("player vs. player", classPlayer, 15.0);
    int playerConstraintImportantItem = rmCreateClassDistanceConstraint("vs. player far", classPlayer, 65.0);
    int ridgeAvoidsPlayer=rmCreateClassDistanceConstraint("ridge vs. player", classPlayer, 35.0);

    // RESOURCE AVOIDANCE:
    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. things", rmClassID("classForest"), 8.0);
    int forestVsForestConstraint=rmCreateClassDistanceConstraint("forest vs. other forests", rmClassID("classForest"), 15.0);
    if ( cNumberNonGaiaPlayers < 3 ) 
{
    forestVsForestConstraint=rmCreateClassDistanceConstraint("forest vs. other forests smaller", rmClassID("classForest"), 10.0);
}

    int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 15.0);
    int playerConstraintFar=rmCreateClassDistanceConstraint("resources stay away from players", classPlayer, 25.0);
    int avoidTapir=rmCreateTypeDistanceConstraint("stuff avoids tapir", "tapir", 45.0);
    int avoidCapybara=rmCreateTypeDistanceConstraint("stuff avoids capibara", "capybara", 55.0);
	int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 65.0);
    int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.10));
    int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoids coin", "gold", 15.0);
    int coinAvoidCoin= rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 60.0);
    int avoidCoinShort=rmCreateTypeDistanceConstraint("stuff avoids coin short", "gold", 6.0);
    int avoidNuggets=rmCreateTypeDistanceConstraint("stuff avoids nuggets", "AbstractNugget", 5.0);
    int avoidNuggetsLong=rmCreateTypeDistanceConstraint("stuff avoids nuggets far", "AbstractNugget", 50.0);
    int avoidNuggetsMedium=rmCreateTypeDistanceConstraint("stuff avoids nuggets a bit", "AbstractNugget", 30.0);
    int avoidSheep=rmCreateTypeDistanceConstraint("avoids sheep", "sheep", 75.0); 
    
    // AVOID IMPASSABLE LAND:
    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 8.0);
    int ridgeAvoidImpassableLand=rmCreateTerrainDistanceConstraint("ridges avoid impassable land", "Land", false, 12.0);
    int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
    int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
  
    // UNIT AVOIDANCE:
    int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 15.0);
    int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

    // NATIVES AVOIDANCE:
    int avoidNatives=rmCreateClassDistanceConstraint("stuff avoid natives", rmClassID("natives"), 15.0);
  
    // DECORATION AVOIDANCE:
    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

    // VP AVOIDANCE:
    int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 25.0);
    int avoidImportantItemFar=rmCreateClassDistanceConstraint("important stuff avoids each other far", rmClassID("importantItem"), 65.0);
    int avoidImportantItemForest=rmCreateClassDistanceConstraint("important stuff avoids each forest", rmClassID("importantItem"), 10.0);
    int avoidImportantItemCoin=rmCreateClassDistanceConstraint("Coin avoids important stuff", rmClassID("importantItem"), 5.0);
    int avoidImportantItemRidge=rmCreateClassDistanceConstraint("Ridge avoids important stuff", rmClassID("importantItem"), 15.0);
    int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);

    int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
    int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("trade route small", 4.0);

    int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

    // RIDGDE CONSTRAINTS:
    int ridgeAvoidsRidge = rmCreateClassDistanceConstraint("ridges avoid other ridges", classStartingRidge, 16.0);
    int resourceAvoidsRidge = rmCreateClassDistanceConstraint("resources avoid ridges", classStartingRidge, 4.0);
    int resourceAvoidsRidgeShort = rmCreateClassDistanceConstraint("resources avoid ridges short", classStartingRidge, 4.0);
    int paintAvoidsRidge = rmCreateClassDistanceConstraint("paint avoids ridge by a small amt", classStartingRidge, 2.0);
    int avoidStartingAreas = rmCreateBoxConstraint("stay away from spawns areas", .31, 0, .69, 1);
    int behindBottomSpawn = rmCreateBoxConstraint("Place things behind the bottom spawns", 0, 0, .11, 1);
    int behindTopSpawn = rmCreateBoxConstraint("Place things behind the top spawns", .89, 0, 1, 1);
    int southConstraint = rmCreateBoxConstraint("stay in southern portion of map", 0, 0, 1, .33);
    int middleConstraint = rmCreateBoxConstraint("stay in middle portion of map", 0, .33, 1, .66);
    int northConstraint = rmCreateBoxConstraint("stay in northern portion of map", 0, .66, 1, 1);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.25);
/*================================================================================================================*/
// ********************************************* DEFINE THE AREAS: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // PJJ - BUILD UP OUTER CLIFF AREA:
  
        int outerCliff=rmCreateArea("Outer Cliffs");
        rmSetAreaSize(outerCliff, 1.0, 1.0);
        rmSetAreaWarnFailure(outerCliff, false);
        rmSetAreaSmoothDistance(outerCliff, 10);
        rmSetAreaMix(outerCliff, "amazon grass");
        rmSetAreaCoherence(outerCliff, 0.85);
        rmSetAreaLocation(outerCliff, 0.5, 0.5);
        rmSetAreaCliffType(outerCliff, "Amazon");
        rmSetAreaCliffEdge(outerCliff, 1, 1.0, 1.0, 0.0, 0);
        rmSetAreaCliffHeight(outerCliff, -7, 1.0, 0.3);
        rmSetAreaCliffPainting(outerCliff, true, true, true);
        rmAddAreaToClass(outerCliff, classTop);
        rmBuildArea(outerCliff);
  
        int paintGround=rmCreateArea("repaint the ground", outerCliff);
        rmSetAreaSize(paintGround, 1.0, 1.0);
        rmSetAreaWarnFailure(paintGround, false);
        rmSetAreaSmoothDistance(paintGround, 10);
        rmSetAreaCoherence(paintGround, 1);
        rmSetAreaLocation(paintGround, 0.5, 0.5);
        rmSetAreaMix(paintGround, "amazon grass");
        rmAddAreaToClass(paintGround, classTop);
        rmBuildArea(paintGround);
		
/*----------------------------------------------------------------------------------------------------------------*/
  
        int i = 0;
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************* SET UP PLAYER STARTING LOCATIONS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        float teamSide = rmRandFloat(0, 1);

	    if (cNumberTeams == 2)	
{
    
        if (teamSide > .5) 
	{
        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.15, 0.35, 0.35, 0.15, 0.0, 0.0);

        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.85, 0.65, 0.65, 0.85, 0.0, 0.0);
    }
    
        else 
	{
        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.15, 0.35, 0.35, 0.15, 0.0, 0.0);

        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.85, 0.65, 0.65, 0.85, 0.0, 0.0);
    }
}
  
	    else	
	{
	    rmSetTeamSpacingModifier(0.75);
	    rmPlacePlayersCircular(0.4, 0.4, 0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.40);
/*================================================================================================================*/
// ***************************** SET UP VALLEYS ( OR THE AREAS ) FOR EACH PLAYER: ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
 
        int id = 0;
        int startingRidge = 0;
		
        float playerFraction=rmAreaTilesToFraction(2750);
  
        for(i=1; < cNumberPlayers)
	{
        // CREATE THE AREA:
        id=rmCreateArea("Player"+i);

        // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);

        // SET THE AREA SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint);
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");

		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "texas_dirt");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_grass");
	    
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// BUILD AREA:
		rmBuildArea(id);
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.45);
/*================================================================================================================*/

   // PLACEMENT ORDER:
   // NATIVES -> RIDGES -> RESOURCES -> NUGGETS:
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.50);
/*================================================================================================================*/	
// *********************************** DEFINE AND PLACE THE NATIVE AMERICANS: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int aztecVillageAID = -1;
        int aztecVillageType = rmRandInt(1,5);
        aztecVillageAID = rmCreateGrouping("aztec village A", "native aztec village "+aztecVillageType);
        rmSetGroupingMinDistance(aztecVillageAID, 0.0);
        rmSetGroupingMaxDistance(aztecVillageAID, 25.0);
        rmAddGroupingConstraint(aztecVillageAID, avoidImpassableLand);
        rmAddGroupingConstraint(aztecVillageAID, playerConstraintImportantItem);
        rmAddGroupingToClass(aztecVillageAID, rmClassID("natives"));
        rmAddGroupingToClass(aztecVillageAID, rmClassID("importantItem"));
        rmAddGroupingConstraint(aztecVillageAID, avoidImportantItemFar);
        //rmAddGroupingConstraint(aztecVillageAID, nativeConstraint);
        rmAddGroupingConstraint(aztecVillageAID, avoidTradeRoute);
        rmAddGroupingConstraint(aztecVillageAID, avoidSocket);
        rmPlaceGroupingAtLoc(aztecVillageAID, 0, 0.35, 0.85);

/*================================================================================================================*/

        int mayaVillageAID = -1;
        int mayaVillageType = rmRandInt(1,5);
        mayaVillageAID = rmCreateGrouping("maya village A", "native Maya village "+mayaVillageType);
		rmSetGroupingMinDistance(mayaVillageAID, 0.0);
        rmSetGroupingMaxDistance(mayaVillageAID, 25.0);
        rmAddGroupingConstraint(mayaVillageAID, avoidImpassableLand);
        rmAddGroupingConstraint(mayaVillageAID, playerConstraintImportantItem);
		rmAddGroupingToClass(mayaVillageAID, rmClassID("natives"));
        rmAddGroupingToClass(mayaVillageAID, rmClassID("importantItem"));
        rmAddGroupingConstraint(mayaVillageAID, avoidImportantItemFar);
        //rmAddGroupingConstraint(mayaVillageAID, nativeConstraint);
        rmAddGroupingConstraint(mayaVillageAID, avoidTradeRoute);
        rmAddGroupingConstraint(mayaVillageAID, avoidSocket);
        rmPlaceGroupingAtLoc(mayaVillageAID, 0, 0.65, 0.15);
		
/*----------------------------------------------------------------------------------------------------------------*/		
// ********************************** PLACE MORE NATIVE SITES IF MORE PLAYERS: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
        
		if(cNumberNonGaiaPlayers >= 4) 
    {
    
        aztecVillageType = rmRandInt(1,5);
        int aztecVillageBID = rmCreateGrouping("aztec village B", "native aztec village "+aztecVillageType);
        rmSetGroupingMinDistance(aztecVillageBID, 0.0);
        rmSetGroupingMaxDistance(aztecVillageBID, 35.0);
        rmAddGroupingConstraint(aztecVillageBID, avoidImpassableLand);
        rmAddGroupingConstraint(aztecVillageBID, playerConstraintImportantItem);
        rmAddGroupingToClass(aztecVillageBID, rmClassID("importantItem"));
	    rmAddGroupingToClass(aztecVillageBID, rmClassID("natives"));
        rmAddGroupingConstraint(aztecVillageBID, avoidImportantItemFar);
        //rmAddGroupingConstraint(aztecVillageBID, nativeConstraint);
        rmAddGroupingConstraint(aztecVillageBID, avoidTradeRoute);
        rmAddGroupingConstraint(aztecVillageBID, avoidSocket);
        rmPlaceGroupingAtLoc(aztecVillageBID, 0, 0.85, 0.35);
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
        mayaVillageType = rmRandInt(1,5);
        int mayaVillageBID = rmCreateGrouping("maya village B", "native maya village "+mayaVillageType);
        rmSetGroupingMinDistance(mayaVillageBID, 0.0);
        rmSetGroupingMaxDistance(mayaVillageBID, 35.0);
        rmAddGroupingConstraint(mayaVillageBID, avoidImpassableLand);
        rmAddGroupingConstraint(mayaVillageBID, playerConstraintImportantItem);
        rmAddGroupingToClass(mayaVillageBID, rmClassID("importantItem"));
        rmAddGroupingConstraint(mayaVillageBID, avoidImportantItemFar);
        //rmAddGroupingConstraint(mayaVillageBID, nativeConstraint);
        rmAddGroupingConstraint(mayaVillageBID, avoidTradeRoute);
        rmAddGroupingConstraint(mayaVillageBID, avoidSocket);
        rmPlaceGroupingAtLoc(mayaVillageBID, 0, 0.15, 0.65);
  }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.55);
/*================================================================================================================*/
// ********************** BUILD RIDGES WITH RIDGE AVOIDANCE TO START A BASIC TOPOGRAPHY: ************************ //
/*================================================================================================================*/     
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
  
        float edgeCliffCoherence = .9;
        float midCliffCoherence = .75; 
  
        int randomRidge = 5; 
        float ridgeHeightVariance = 1.5;
        int ridgeAvoid = 3;  
        int numTries = -1;
        int failCount = -1;
        int extraRidges = 6 + cNumberNonGaiaPlayers*2;
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        for(i=0; < extraRidges) 
{
    
        if(rmRandInt(1,5) <= randomRidge)
		
  {
        
		startingRidge=rmCreateArea("Ridge 11"+i);
        rmAddAreaConstraint(startingRidge, ridgeAvoidsPlayer); 
        //~ rmAddAreaConstraint(startingRidge, avoidStartingAreas);
        rmAddAreaConstraint(startingRidge, ridgeAvoidsRidge);
        rmAddAreaConstraint(startingRidge, avoidTradeRoute);
        rmAddAreaConstraint(startingRidge, avoidSocket);
        rmAddAreaConstraint(startingRidge, ridgeAvoidImpassableLand);
        rmAddAreaConstraint(startingRidge, avoidImportantItemRidge);      
    
        if (cNumberNonGaiaPlayers <=2)
		rmSetAreaSize(startingRidge, rmAreaTilesToFraction(375), rmAreaTilesToFraction(450));
        else
		rmSetAreaSize(startingRidge, rmAreaTilesToFraction(125), rmAreaTilesToFraction(150));
		
		rmSetAreaWarnFailure(startingRidge, false);
        rmSetAreaCoherence(startingRidge, midCliffCoherence);
        //~ rmSetAreaTerrainType(startingRidge, cliffTerrain);
        rmSetAreaCliffType(startingRidge, "Amazon");
        rmSetAreaCliffEdge(startingRidge, 1, 1.0, 1.0, 0.0, 0);
        rmSetAreaCliffHeight(startingRidge, 7, ridgeHeightVariance, 0.3);
        rmSetAreaCliffPainting(startingRidge, true, false, true, 0, true);
        rmAddAreaToClass(startingRidge, classStartingRidge);
      
        if(rmBuildArea(startingRidge)==false)
	{
        failCount++;
        if(failCount==5) // Stop trying once we fail 5 times in a row.
        break;
    }
        else
        failCount=0;
  }
  
}

/*----------------------------------------------------------------------------------------------------------------*/
// ******* BEGIN SMALLER RIDGES WITH LOWER % CHANCE TO SPAWN AND POSSIBLY NO RIDGE AVOIDANCE CONSTRAINT: ******** //
/*----------------------------------------------------------------------------------------------------------------*/
  
        randomRidge = 4;
        ridgeAvoid = 5;  
        extraRidges = 6 + cNumberNonGaiaPlayers*2;
        numTries = -1;
        failCount = -1;
		
/*----------------------------------------------------------------------------------------------------------------*/		

        for(i=0; < extraRidges)
		
{
    
        if(rmRandInt(1,5) <= randomRidge) 
  {
        startingRidge=rmCreateArea("Ridge 31"+i);
        rmAddAreaConstraint(startingRidge, ridgeAvoidsPlayer); 
        rmAddAreaConstraint(startingRidge, ridgeAvoidImpassableLand);
        rmAddAreaConstraint(startingRidge, avoidImportantItemRidge);   
        rmAddAreaConstraint(startingRidge, avoidTradeRoute);
        rmAddAreaConstraint(startingRidge, avoidSocket);
        rmAddAreaConstraint(startingRidge, ridgeAvoidsRidge);
  
        if (cNumberNonGaiaPlayers <=2)
		rmSetAreaSize(startingRidge, rmAreaTilesToFraction(150), rmAreaTilesToFraction(225));
        else
		rmSetAreaSize(startingRidge, rmAreaTilesToFraction(50), rmAreaTilesToFraction(75));
		
		rmSetAreaWarnFailure(startingRidge, false);
        rmSetAreaCoherence(startingRidge, midCliffCoherence);
        //~ rmSetAreaTerrainType(startingRidge, cliffTerrain);
        rmSetAreaCliffType(startingRidge, "Amazon");
        rmSetAreaCliffEdge(startingRidge, 1, 1.0, 1.0, 0.0, 0);
        rmSetAreaCliffHeight(startingRidge, 7, ridgeHeightVariance, 0.3);
        rmSetAreaCliffPainting(startingRidge, true, false, true, 0, true);
        rmAddAreaToClass(startingRidge, classStartingRidge);
      
        if(rmBuildArea(startingRidge)==false)
	{
        failCount++;
        if(failCount==5) // Stop trying once we fail 5 times in a row.
        break;
    }
        else
        failCount=0;
 }
	
}
  
        failCount = -1;
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.60);
/*================================================================================================================*/
// ****************************** DEFINE THE STARTING TCID AND UNITS AND RESOURCES: ***************************** //
/*================================================================================================================*/
  
        // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
        if ( rmGetNomadStart())
  {
        rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
  }
        else
  {
        rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
  }
        rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(startingTCID, 0.0);
        rmSetObjectDefMaxDistance(startingTCID, 8.0);

        // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
        rmAddObjectDefConstraint(startingUnits, avoidStartingUnitsSmall);
		
/*----------------------------------------------------------------------------------------------------------------*/
  
        // DEFINE THE STARTING FOOD:
		int StartFoodID=rmCreateObjectDef("starting food");
        rmAddObjectDefItem(StartFoodID, "deer", 12, 10.0);
		rmAddObjectDefToClass(StartFoodID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(StartFoodID, 15.0);
        rmSetObjectDefMaxDistance(StartFoodID, 20.0);
        rmSetObjectDefCreateHerd(StartFoodID, false);
        rmAddObjectDefConstraint(StartFoodID, avoidStartingUnitsSmall);
        rmAddObjectDefConstraint(StartFoodID, avoidImpassableLand);

        // DEFINE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
        rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
        rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
        rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnits);
        rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);

        // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
        rmAddObjectDefItem(StartAreaTreeID, "TreeAmazon", 8, 6.0);
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(StartAreaTreeID, 35.0);
        rmSetObjectDefMaxDistance(StartAreaTreeID, 40.0);
        rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
        rmAddObjectDefConstraint(StartAreaTreeID, avoidNuggets);
        rmAddObjectDefConstraint(StartAreaTreeID, avoidImpassableLand);

        // DEFINE THE PLAYER GOLD:
		int playerGoldID = rmCreateObjectDef("player silver closer "+i);
        rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefToClass(playerGoldID, rmClassID("startingUnit"));
        rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
        rmAddObjectDefConstraint(playerGoldID, resourceAvoidsRidge);
        rmSetObjectDefMinDistance(playerGoldID, 20.0);
        rmSetObjectDefMaxDistance(playerGoldID, 25.0);
  
        // DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", 4, 4.0);
		rmAddObjectDefToClass(playerBerryID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerBerryID, 10);
        rmSetObjectDefMaxDistance(playerBerryID, 15);
	    rmAddObjectDefConstraint(playerBerryID, avoidStartingUnitsSmall);
        rmAddObjectDefConstraint(playerBerryID, avoidImpassableLand);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.65);
/*================================================================================================================*/	
   
        for(i=1; <cNumberPlayers)
	{
        // PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

        // PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
        // PLACE THE STARTING FOOD:
        rmPlaceObjectDefAtLoc(StartFoodID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        
		// PLACE THE PLAYER BERRY:
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(playerBerryID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
       
        // PLACE THE STARTING TREES:
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
  
        // PLACE THE MONASTERY BUILDER:
		//if(ypIsAsian(i) && rmGetNomadStart() == false)
        //rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i), i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

        // PLACE THE PLAYER NUGGET:
        rmSetNuggetDifficulty(1, 1);
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
  }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.70);
/*================================================================================================================*/
// ***************************** DENSER MINES AWAY FROM THE PLAYER'S STARTING AREAS: **************************** //
// ************************************** DEFINE AND PLACE THE RESOURCES: *************************************** //
/*================================================================================================================*/

        int silverID = -1;
        int silver2ID = -1;
        int silverCount = cNumberNonGaiaPlayers*6;
  
        rmEchoInfo("silver count = "+silverCount);

        silverID = rmCreateObjectDef("silver mines");
        rmAddObjectDefItem(silverID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silverID, 0.0);
        rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(silverID, coinAvoidCoin);
        rmAddObjectDefConstraint(silverID, avoidTradeRoute);
        rmAddObjectDefConstraint(silverID, avoidImpassableLand);
        rmAddObjectDefConstraint(silverID, playerConstraintFar);
        rmAddObjectDefConstraint(silverID, resourceAvoidsRidge);
        rmAddObjectDefConstraint(silverID, avoidImportantItemCoin);
        rmAddObjectDefConstraint(silverID, silverEdgeConstraint);
        rmPlaceObjectDefPerPlayer(silverID, false, 6);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.75);
/*================================================================================================================*/	
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //  
/*================================================================================================================*/
  
        failCount=0;
  
        int forestTreeID = 0;
  
        numTries = 15 * cNumberNonGaiaPlayers;
        failCount=0;
		
/*----------------------------------------------------------------------------------------------------------------*/		

        for (i=0; <numTries) 
	{   
        int northForest = rmCreateArea("nForest"+i);
        rmSetAreaWarnFailure(northForest, false);
        rmSetAreaSize(northForest, rmAreaTilesToFraction(300), rmAreaTilesToFraction(350));
        rmAddAreaToClass(northForest, rmClassID("classForest"));
        rmSetAreaForestType(northForest, "amazon rain forest");
        rmSetAreaForestDensity(northForest, 0.65);
        rmSetAreaForestClumpiness(northForest, 0.55);
        rmSetAreaForestUnderbrush(northForest, 0.0);
        rmSetAreaCoherence(northForest, 0.3);
        rmSetAreaSmoothDistance(northForest, 10);
        rmSetAreaObeyWorldCircleConstraint(northForest, false);
        rmAddAreaConstraint(northForest, avoidImportantItemForest);		
        rmAddAreaConstraint(northForest, playerConstraintForest);	
        rmAddAreaConstraint(northForest, forestVsForestConstraint);			
        rmAddAreaConstraint(northForest, resourceAvoidsRidge);
        rmAddAreaConstraint(northForest, forestEdgeConstraint);
        rmAddAreaConstraint(northForest, avoidTradeRoute);
        rmAddAreaConstraint(northForest, avoidSocket);
        rmAddAreaConstraint(northForest, avoidCoin);
        rmAddAreaConstraint(northForest, avoidStartingUnits);
        rmAddAreaConstraint(northForest, heavyForestConstraint);
    
        if(rmBuildArea(northForest) == false) 
	{
        // Stop trying once we fail 4 times in a row.
        failCount++;
        if(failCount==4)
        break;
    }
    
        else
        failCount=0; 
  }
  
/*----------------------------------------------------------------------------------------------------------------*/  

        failCount=0; 
  
        for (i=0; <numTries) 
{   
        int northForest2 = rmCreateArea("nForestb"+i);
        rmSetAreaWarnFailure(northForest2, false);
        rmSetAreaSize(northForest2, rmAreaTilesToFraction(100), rmAreaTilesToFraction(150));
        rmAddAreaToClass(northForest2, rmClassID("classForest"));
        rmSetAreaForestType(northForest2, "amazon rain forest");
        rmSetAreaForestDensity(northForest2, 0.3);
        rmSetAreaForestClumpiness(northForest2, 0.2);
        rmSetAreaForestUnderbrush(northForest2, 0.0);
        rmSetAreaCoherence(northForest2, 0.3);
        rmSetAreaSmoothDistance(northForest2, 10);
        rmSetAreaObeyWorldCircleConstraint(northForest2, false);
        rmAddAreaConstraint(northForest2, avoidImportantItemForest);
        rmAddAreaConstraint(northForest2, playerConstraintForest);
        rmAddAreaConstraint(northForest2, forestVsForestConstraint);
        rmAddAreaConstraint(northForest2, resourceAvoidsRidge);
        rmAddAreaConstraint(northForest2, forestEdgeConstraint);
        rmAddAreaConstraint(northForest2, avoidTradeRoute);
        rmAddAreaConstraint(northForest2, avoidSocket);
        rmAddAreaConstraint(northForest2, avoidCoin);
        rmAddAreaConstraint(northForest2, avoidStartingUnits);
    
        if(rmBuildArea(northForest2) == false) 
	{
        // Stop trying once we fail 4 times in a row.
        failCount++;
        if(failCount==4)
        break;
    }
    
        else
        failCount=0;
		
}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.80);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE HUNTABLE HERDS: ************************************* //
/*================================================================================================================*/
 
        // THE TAPIR HERDS 1:
        int Tapir1ID=rmCreateObjectDef("The Tapir Herd 1");
        rmAddObjectDefItem(Tapir1ID, "tapir", rmRandInt(6,7), 10.0);
        rmSetObjectDefMinDistance(Tapir1ID, 0.0);
        rmSetObjectDefMaxDistance(Tapir1ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(Tapir1ID, avoidTapir);
        rmAddObjectDefConstraint(Tapir1ID, avoidImpassableLand);
        rmAddObjectDefConstraint(Tapir1ID, avoidSocket);
        rmAddObjectDefConstraint(Tapir1ID, forestConstraint);
        rmAddObjectDefConstraint(Tapir1ID, avoidCoin);
        rmAddObjectDefConstraint(Tapir1ID, resourceAvoidsRidge);
        rmAddObjectDefConstraint(Tapir1ID, playerConstraintFar);
        rmSetObjectDefCreateHerd(Tapir1ID, true);
        rmPlaceObjectDefAtLoc(Tapir1ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);

        // THE CAPYBARA HERDS 1:
        int Capybara1ID=rmCreateObjectDef("The Capybara Herd 1");
        rmAddObjectDefItem(Capybara1ID, "capybara", rmRandInt(8,9), 10.0);
        rmSetObjectDefMinDistance(Capybara1ID, 0.0);
        rmSetObjectDefMaxDistance(Capybara1ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(Capybara1ID, avoidCapybara);
        rmAddObjectDefConstraint(Capybara1ID, avoidTapir);
        rmAddObjectDefConstraint(Capybara1ID, avoidImpassableLand);
        rmAddObjectDefConstraint(Capybara1ID, forestConstraint);
        rmAddObjectDefConstraint(Capybara1ID, avoidSocket);
        rmAddObjectDefConstraint(Capybara1ID, resourceAvoidsRidge);
        rmAddObjectDefConstraint(Capybara1ID, playerConstraintFar);
        rmSetObjectDefCreateHerd(Capybara1ID, true);
        rmPlaceObjectDefAtLoc(Capybara1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		
		// THE DEER HERDS 1:
        int Deer1ID=rmCreateObjectDef("The Deer Herd 1");
        rmAddObjectDefItem(Deer1ID, "deer", rmRandInt(8,9), 10.0);
        rmSetObjectDefMinDistance(Deer1ID, 0.0);
        rmSetObjectDefMaxDistance(Deer1ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(Deer1ID, avoidDeer);
        rmAddObjectDefConstraint(Deer1ID, avoidCapybara);
        rmAddObjectDefConstraint(Deer1ID, avoidTapir);
        rmAddObjectDefConstraint(Deer1ID, avoidImpassableLand);
        rmAddObjectDefConstraint(Deer1ID, forestConstraint);
        rmAddObjectDefConstraint(Deer1ID, avoidSocket);
        rmAddObjectDefConstraint(Deer1ID, resourceAvoidsRidge);
        rmAddObjectDefConstraint(Deer1ID, playerConstraintFar);
        rmSetObjectDefCreateHerd(Deer1ID, true);
        rmPlaceObjectDefAtLoc(Deer1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.85);
/*================================================================================================================*/	
// ************************************ DEFINE AND PLACE THE SHEEP HERDS: *************************************** //
/*================================================================================================================*/
  
        // THE SHEEP HERDS 1:
        int Sheep1ID=rmCreateObjectDef("The Sheep Herds");
        rmAddObjectDefItem(Sheep1ID, "sheep", 2, 3.0);
        rmSetObjectDefMinDistance(Sheep1ID, 0.0);
        rmSetObjectDefMaxDistance(Sheep1ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(Sheep1ID, avoidSheep);
        rmAddObjectDefConstraint(Sheep1ID, avoidAll);
        rmAddObjectDefConstraint(Sheep1ID, avoidSocket);
        rmAddObjectDefConstraint(Sheep1ID, avoidTradeRoute);
        rmAddObjectDefConstraint(Sheep1ID, forestConstraint);
        rmAddObjectDefConstraint(Sheep1ID, resourceAvoidsRidge);
        rmAddObjectDefConstraint(Sheep1ID, avoidImpassableLand);
        rmAddObjectDefConstraint(Sheep1ID, playerConstraintFar);
        rmPlaceObjectDefAtLoc(Sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);  
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.95);
/*================================================================================================================*/	
// ***************************************** DEFINE AND PLACE NUGGETS: ****************************************** //
/*================================================================================================================*/

        int nuggetID= rmCreateObjectDef("nuggets!"); 
        rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
        rmSetObjectDefMinDistance(nuggetID, 0.0);
        rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
        rmAddObjectDefToClass(nuggetID, rmClassID("nuggets"));
        rmAddObjectDefConstraint(nuggetID, avoidImportantItemForest);
        rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
        rmAddObjectDefConstraint(nuggetID, avoidSocket);
        rmAddObjectDefConstraint(nuggetID, avoidNuggetsLong);
        rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
        rmAddObjectDefConstraint(nuggetID, resourceAvoidsRidge);
        rmAddObjectDefConstraint(nuggetID, playerConstraintFar);
        rmAddObjectDefConstraint(nuggetID, forestEdgeConstraint);
  
        rmSetNuggetDifficulty(1, 2);
        rmPlaceObjectDefPerPlayer(nuggetID, false, 3);
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        int nuggetID2 = rmCreateObjectDef("nuggets! 2"); 
        rmAddObjectDefItem(nuggetID2, "Nugget", 1, 0.0);
        rmSetObjectDefMinDistance(nuggetID2, 0.0);
        rmSetObjectDefMaxDistance(nuggetID2, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nuggetID2, avoidImportantItemForest);
        rmAddObjectDefConstraint(nuggetID2, avoidTradeRoute);
        rmAddObjectDefConstraint(nuggetID2, avoidSocket);
        rmAddObjectDefConstraint(nuggetID2, avoidCoinShort);
        rmAddObjectDefConstraint(nuggetID2, avoidNuggetsLong);
        rmAddObjectDefConstraint(nuggetID2, avoidImpassableLand);
        rmAddObjectDefConstraint(nuggetID2, resourceAvoidsRidge);
        rmAddObjectDefConstraint(nuggetID2, playerConstraintImportantItem);
        rmAddObjectDefConstraint(nuggetID2, forestEdgeConstraint);
  
        rmSetNuggetDifficulty(3, 3);
        rmPlaceObjectDefPerPlayer(nuggetID2, false, 2);
		
/*----------------------------------------------------------------------------------------------------------------*/
  
        int nuggetID3 = rmCreateObjectDef("nuggets! 3"); 
        rmAddObjectDefItem(nuggetID3, "Nugget", 1, 0.0);
        rmSetObjectDefMinDistance(nuggetID3, 0.0);
        rmSetObjectDefMaxDistance(nuggetID3, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nuggetID3, avoidImportantItemForest);
        rmAddObjectDefConstraint(nuggetID3, avoidTradeRoute);
        rmAddObjectDefConstraint(nuggetID3, avoidSocket);
        rmAddObjectDefConstraint(nuggetID3, avoidCoinShort);
        rmAddObjectDefConstraint(nuggetID3, avoidNuggetsMedium);
        rmAddObjectDefConstraint(nuggetID3, avoidImpassableLand);
        rmAddObjectDefConstraint(nuggetID3, resourceAvoidsRidge);
        rmAddObjectDefConstraint(nuggetID3, playerConstraintImportantItem);
        rmAddObjectDefConstraint(nuggetID3, forestEdgeConstraint);
  
        rmSetNuggetDifficulty(4, 4);
        rmPlaceObjectDefPerPlayer(nuggetID3, false, 1);
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/











