/*================================================================================================================*/
// ************************************ THESE ARE INFORMATIONS OF THE MAP: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// THE TEXAS WAR:
// CREATED BY DANY:
// APRIL 2007:

/*================================================================================================================*/ 
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ******************************************** CHOOSE THE NATIVE TRIBES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
		
		if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");

		subCiv1=rmGetCivID("Maya");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Maya"); 

		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Maya");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Maya");
	}	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ********************************************* PICKS THE MAP SIZE: ******************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int playerTiles=17500;
        		
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(530, 530);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ****************************************** SET THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // SET MAP ELEVATION PARAMETERS:
	    rmSetMapElevationParameters(cElevTurbulence, 0.02, 5, 0.7, 8.0);
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(4.0);

        // PICKS THE DEFAULT WATER:
	    rmSetSeaType("Amazon River");


	    // PICKS THE DEFAULT TERRAIN:
		float terrainPicker = rmRandFloat(0.0, 1.0);
	    if (terrainPicker <= 0.5)
	{
		rmSetBaseTerrainMix("texas_dirt");
	}
	    else
	{
		rmSetBaseTerrainMix("texas_dirt");
	}

	    // TERRAIN INITIALIZATION:
	    rmTerrainInitialize("texas\ground4_tex", 5.0);
	
	    // SET MAP TYPE:
	    rmSetMapType("texas");
	    rmSetMapType("desert");
	    rmSetMapType("land");
	
	    // SET THE LIGHTING:
	    rmSetLightingSet("Texas");

	    // CHOOSE THE MERCS:
	    chooseMercs();

	    // CORNER CONSTRAINT:
	    rmSetWorldCircleConstraint(true);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
		rmDefineClass("startingUnit");
		rmDefineClass("SocketClass");
		rmDefineClass("natives");
		rmDefineClass("classCliff");
		rmDefineClass("nuggets");
		rmDefineClass("classForest");
		rmDefineClass("region");
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// **************************************** DEFINE THE CONSTRAINTS: ********************************************* //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHERS: ************************ //
/*================================================================================================================*/		
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // PLAYER AVOIDANCE:
		int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
		
		// Cardinal Directions
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
		
		// IMPASSABLE LAND AVOIDANCE:
		int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
		
		// FOREST AVOIDANCE:
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 35.0);
		
		// REGIONS AVOIDANCE:
		int avoidRegion=rmCreateClassDistanceConstraint("stay away from region", rmClassID("region"), 8.0);
	    int avoidCloseRegion=rmCreateClassDistanceConstraint("close away from region", rmClassID("region"), 2.0);
	   				
		// CLIFF AVOIDANCE:
		int cliffConstraint=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 20.0);
	    int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 10.0);
	    int avoidCloseCliff=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 2.0);
		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
        // STARTING UNITS AVOIDANCE:
	    int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
	
        // RESOURCE AVOIDANCE:	
        int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
		
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 10.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);
				
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// COW AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 2.0);
		
		// DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
						
		// VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
        int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
	    
		// SOCKET AVOIDANCE:
	    int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("SocketClass"), 8.0);
        int avoidCloseSocket=rmCreateClassDistanceConstraint("close socket avoidance", rmClassID("SocketClass"), 2.0);

		// FLAG AVOIDANCE:
		int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
        int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
        //int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
        //int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
				
		// SEA FOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 8.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
	    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 35.0);
	    int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 25.0);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      
        // TEXT:
		// THIS TRADE ROUTE IS A SQUARE:
		// THIS IS MY FIRST ONE:
		
		// DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  
	    int tradeRouteID = rmCreateTradeRoute();
      
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts Square");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 8.0);
	    rmAddObjectDefConstraint(socketID, avoidCloseTradeRoute);

	    rmAddTradeRouteWaypoint(tradeRouteID, 0.20, 0.50); // STARTING THE SQUARE TRADE ROUTE:
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.80);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.80, 0.50);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.20);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.20, 0.50); // CLOSING THE SQUARE TRADE ROUTE:
	  	  	  
        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
	  
/*================================================================================================================*/
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:

	    rmPlaceObjectDefAtLoc(socketID, 0, 0.20, 0.50); 
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.50, 0.80); 
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.80, 0.50); 
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.50, 0.20); 
	  
	    // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// *************************** DEFINE AND PLACE THE POND TO THE CENTER OF THE MAP: ****************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE CENTRAL POND:
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int smallPondID=rmCreateArea("small pond");
	    
	
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(4500), rmAreaTilesToFraction(4500));
		rmSetAreaWaterType(smallPondID, "texas pond");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.95);
		rmSetAreaSmoothDistance(smallPondID, 5);
		//rmAddAreaConstraint(smallPondID, playerConstraint);
		rmSetAreaWarnFailure(smallPondID, false);
		
		rmSetAreaLocation(smallPondID, 0.50, 0.50); 
		rmBuildArea(smallPondID); 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE REGION AREAS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

		int region1ID=rmCreateArea("region 1");
	    // rmSetAreaSize(region1ID, 0.03, 0.03);
		rmSetAreaSize(region1ID, rmAreaTilesToFraction(1500), rmAreaTilesToFraction(1500));
	    rmSetAreaCoherence(region1ID, 1.0);
	    rmAddAreaToClass(region1ID, rmClassID("region"));
		//rmSetAreaMix(region1ID, "rockies_snow");
		rmAddAreaConstraint(region1ID, avoidRegion); 
        rmAddAreaConstraint(region1ID, avoidCloseRegion);
		rmSetAreaLocation(region1ID, 0.25, 0.75);
        rmBuildArea(region1ID);	

        int region2ID=rmCreateArea("region 2");
		rmSetAreaSize(region2ID, rmAreaTilesToFraction(1500), rmAreaTilesToFraction(1500));
	    // rmSetAreaSize(region2ID, 0.03, 0.03);
	    rmSetAreaCoherence(region2ID, 1.0);
	    rmAddAreaToClass(region2ID, rmClassID("region"));
		//rmSetAreaMix(region2ID, "rockies_snow");
		rmAddAreaConstraint(region2ID, avoidRegion); 
        rmAddAreaConstraint(region2ID, avoidCloseRegion);
		rmSetAreaLocation(region2ID, 0.75, 0.25);
        rmBuildArea(region2ID);	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if(cNumberNonGaiaPlayers == 2)
	
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.775,0.775);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.225,0.225);
	}  
		else
    {		
		//rmSetPlacementTeam(0);
		//rmPlacePlayer(1,0.8,0.8);
		//rmPlacePlayer(2,0.8,0.2);
		//rmSetPlacementTeam(1);
		//rmPlacePlayer(3,0.2,0.2);
        //rmPlacePlayer(4,0.2,0.8);
	}  
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ******************************************** SET UP PLAYER AREAS: ******************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		float playerFraction=rmAreaTilesToFraction(120);   
	    
		for(i=1; <cNumberPlayers)
	{
		// CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
		
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
		
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 1);
		
		// ADD AREA CONSTRAINT:
		//  rmAddAreaConstraint(id, playerConstraint); 
		//  rmAddAreaConstraint(id, playerEdgeConstraint); 
		
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);

		// SET THE AREA MIX:
		rmSetAreaMix(id, "texas_dirt");
		
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
	}
	    // BUILD THE AREAS:
        rmBuildAllAreas();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("aztecs"))
	{  
		int aztecs1VillageID = -1;
		aztecs1VillageID = rmCreateGrouping("aztecs village 1", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs1VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs1VillageID, 0.0);
		rmAddGroupingToClass(aztecs1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs1VillageID, 0, 0.275, 0.5);
	}

	    if (subCiv1 == rmGetCivID("maya"))
	{  
		int maya1VillageID = -1;
		maya1VillageID = rmCreateGrouping("maya village 1", "native maya village 3");
		rmSetGroupingMinDistance(maya1VillageID, 0.0);
		rmSetGroupingMaxDistance(maya1VillageID, 0.0);
		rmAddGroupingToClass(maya1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(maya1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya1VillageID, 0, 0.5, 0.725);
	} 
	
	    if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs village 2", "native aztec village 4");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.725, 0.5);
	}

	    if (subCiv3 == rmGetCivID("maya"))
	{  
		int maya2VillageID = -1;
		maya2VillageID = rmCreateGrouping("maya village 2", "native maya village 3");
		rmSetGroupingMinDistance(maya2VillageID, 0.0);
		rmSetGroupingMaxDistance(maya2VillageID, 0.0);
		rmAddGroupingToClass(maya2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(maya2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(maya2VillageID, 0, 0.5, 0.275);
	} 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE CLIFFS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        int numTries=cNumberNonGaiaPlayers*0.5;
   
        for(i=0; <numTries)
   {
        int cliffID=rmCreateArea("cliff");
        rmSetAreaSize(cliffID, rmAreaTilesToFraction(1500), rmAreaTilesToFraction(1500));
        rmSetAreaWarnFailure(cliffID, false);
	    rmSetAreaCliffType(cliffID, "Texas");
	    // rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
        rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffID, 1);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffID, cliffConstraint);
	    rmSetAreaMinBlobs(cliffID, 1);
        rmSetAreaMaxBlobs(cliffID, 1);
        rmSetAreaMinBlobDistance(cliffID, 1);
        rmSetAreaMaxBlobDistance(cliffID, 1);
        rmSetAreaSmoothDistance(cliffID, 10);
        rmSetAreaCoherence(cliffID, 0.95);
		rmSetAreaLocation(cliffID, 0.25, 0.75);
        rmBuildArea(cliffID);
   } 
   
/*----------------------------------------------------------------------------------------------------------------*/

        for(i=0; <numTries)
   {
        int cliff2ID=rmCreateArea("cliff 2");
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(1500), rmAreaTilesToFraction(1500));
        rmSetAreaWarnFailure(cliff2ID, false);
		rmSetAreaCliffType(cliff2ID, "Texas");
	    // rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
	    rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff2ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff2ID, 1);
        rmAddAreaToClass(cliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff2ID, cliffConstraint);
	    rmSetAreaMinBlobs(cliff2ID, 1);
        rmSetAreaMaxBlobs(cliff2ID, 1);
        rmSetAreaMinBlobDistance(cliff2ID, 1);
        rmSetAreaMaxBlobDistance(cliff2ID, 1);
        rmSetAreaSmoothDistance(cliff2ID, 10);
        rmSetAreaCoherence(cliff2ID, 0.95);
		rmSetAreaLocation(cliff2ID, 0.75, 0.25);
        rmBuildArea(cliff2ID);
   }    
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/		

	    // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints(); // CLEAR FOR WATERFLAG PLACEMENT: 
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE STARTING TCID:
	    int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	}
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);
	    //rmAddObjectDefConstraint(TCID, avoidTradeRoute);
	    rmAddObjectDefToClass(TCID, rmClassID("player"));
	    rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));

	    // DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 8.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidStartingUnits);
	
/*================================================================================================================*/
// ************************************* DEFINE THE STARTING RESOURCES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE STARTING BERRYBUSH:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 4, 4.0);
	    rmSetObjectDefMinDistance(StartBerriesID, 0.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 0.0);
	    rmAddObjectDefConstraint(StartBerriesID, avoidFruits);
		rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
		
		// PLACE THE STARTING BERRIES:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.725, 0.775);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.825, 0.775);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.175, 0.225);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.275, 0.225);
		
		// DEFINE THE STARTING GOLDMINES:
		int StartGoldID=rmCreateObjectDef("starting goldmines");
	    rmAddObjectDefItem(StartGoldID, "minegold", 1, 0.0);
	    rmSetObjectDefMinDistance(StartGoldID, 0.0);
	    rmSetObjectDefMaxDistance(StartGoldID, 0.0);
	    rmAddObjectDefConstraint(StartGoldID, avoidGold);
		rmAddObjectDefToClass(StartGoldID, rmClassID("startingUnit"));
		
		// PLACE THE STARTING GOLD:
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.775, 0.825);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.775, 0.725);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.225, 0.275);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.225, 0.175);
		
		// DEFINE THE STARTING DEER:
		int StartDeerID=rmCreateObjectDef("Starting Deer");
	    rmAddObjectDefItem(StartDeerID, "deer", 4, 4.0);
	    rmSetObjectDefMinDistance(StartDeerID, 0.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 0.0);
	    rmSetObjectDefCreateHerd(StartDeerID, true);
	    rmAddObjectDefConstraint(StartDeerID, avoidDeer);
		rmAddObjectDefToClass(StartDeerID, rmClassID("startingUnit"));
		
		// PLACE THE STARTING DEER:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, 0.725, 0.825);
		rmPlaceObjectDefAtLoc(StartDeerID, 0, 0.825, 0.725);
		rmPlaceObjectDefAtLoc(StartDeerID, 0, 0.175, 0.275);
		rmPlaceObjectDefAtLoc(StartDeerID, 0, 0.275, 0.175);
		
		// DEFINE THE STARTING COWS:
		int StartCowID=rmCreateObjectDef("Starting Cows 1");
        rmAddObjectDefItem(StartCowID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(StartCowID, 0.0);
        rmSetObjectDefMaxDistance(StartCowID, 0.0);
	    rmAddObjectDefConstraint(StartCowID, avoidCow);
		rmAddObjectDefToClass(StartCowID, rmClassID("startingUnit"));
			    
		// PLACE THE STARTING COWS:
		rmPlaceObjectDefAtLoc(StartCowID, 0, 0.825, 0.825);
		rmPlaceObjectDefAtLoc(StartCowID, 0, 0.725, 0.725);
        rmPlaceObjectDefAtLoc(StartCowID, 0, 0.175, 0.175);
        rmPlaceObjectDefAtLoc(StartCowID, 0, 0.275, 0.275);

	    // DEFINE THE STARTING TREES:
	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 9);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	    rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidImpassableLand);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseGold);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseFruits);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidResource);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE WATER FLAG:
		int waterFlagID=rmCreateObjectDef("HC water flag"+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        //rmAddClosestPointConstraint(flagEdgeConstraint);
        rmAddClosestPointConstraint(flagVsFlag);
        rmAddClosestPointConstraint(flagLand);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************ PLACE PLAYERS AND STARTING UNITS: *************************************** //
/*================================================================================================================*/
	    
		for(i=1; <cNumberPlayers)
		
	{
		
		// TEST OF MARCIN'S STARTING UNITS STUFF:
		
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
	    vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
						
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
     	// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
        // PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
	}
	
/*----------------------------------------------------------------------------------------------------------------*/
      
        // CLEAR CLOSEST POINT CONSTRAINTS:
		//rmClearClosestPointConstraints();	  
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE COIN RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.15, 0.45);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.45, 0.15);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.55, 0.85);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.85, 0.55);
		
        rmPlaceObjectDefAtLoc(gold1ID, 0, 0.175, 0.825);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.825, 0.175);

        rmPlaceObjectDefAtLoc(gold1ID, 0, 0.325, 0.675);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.675, 0.325);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TREASURES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.675, 0.425);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.575, 0.325);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.325, 0.425);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.425, 0.325);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.325, 0.575);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.425, 0.675);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.575, 0.675);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.675, 0.575);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.05, 0.55);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.55, 0.05);
		
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.95, 0.45);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.45, 0.95);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.05, 0.35);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.35, 0.05);
		
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.65, 0.95);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.95, 0.65);		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE COWS: ********************************************* //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmSetObjectDefCreateHerd(cow1ID, true);
	    
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.125, 0.725);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.725, 0.125);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.275, 0.875);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.875, 0.275);

/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.10, 0.60);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.60, 0.10);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.90, 0.40);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.40, 0.90);

        rmPlaceObjectDefAtLoc(deer1ID, 0, 0.325, 0.325);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.675, 0.675);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.10, 0.30);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.30, 0.10);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.70, 0.90);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.90, 0.70);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(9,15), 15.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.25, 0.75);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.75, 0.25); 		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.86);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE PERCHING VULTURES: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int vultureID=rmCreateObjectDef("perching vultures");
	    int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
	    
	    rmPlaceObjectDefAtLoc(vultureID, 0, 0.10, 0.50);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.50, 0.10);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.50, 0.90);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.90, 0.50);
		
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.365, 0.365);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.375, 0.625);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.625, 0.375);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.625, 0.625);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.87);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE BIG DECORATIVE THINGS: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	    int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "BigPropTexas", 25.0);
	    rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
	    rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	    rmSetObjectDefMaxDistance(bigDecorationID, 0.0);
	    rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
	    
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.15, 0.65);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.65, 0.15);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.35, 0.85);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.85, 0.35);
		
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.10, 0.40);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.40, 0.10);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.60, 0.90);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.90, 0.60);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
		
		int forestTreeID = 0;
        numTries=6*cNumberNonGaiaPlayers;
        int failCount=0;
	    
		for (i=0; <numTries)
    {   
        int forest=rmCreateArea("The Forest 1"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        rmSetAreaForestType(forest, "texas forest dirt");
		rmSetAreaForestDensity(forest, 0.85);
        rmSetAreaForestClumpiness(forest, 0.10);
        rmSetAreaForestUnderbrush(forest, 0.6);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 2);
        rmSetAreaMinBlobDistance(forest, 1);
        rmSetAreaMaxBlobDistance(forest, 2);
        rmSetAreaCoherence(forest, 0.25);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
        rmAddAreaConstraint(forest, avoidRegion);
        rmAddAreaConstraint(forest, avoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest, avoidCloseSocket);
		rmAddAreaConstraint(forest, Northward);
		 
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  
	
/*----------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries)
    {   
        int forest2=rmCreateArea("The Forest 2"+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        rmSetAreaForestType(forest2, "texas forest dirt");
		rmSetAreaForestDensity(forest2, 0.85);
        rmSetAreaForestClumpiness(forest2, 0.10);
        rmSetAreaForestUnderbrush(forest2, 0.6);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 2);
        rmSetAreaMinBlobDistance(forest2, 1);
        rmSetAreaMaxBlobDistance(forest2, 2);
        rmSetAreaCoherence(forest2, 0.25);
        rmSetAreaSmoothDistance(forest2, 10);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, avoidCloseSocket);
        rmAddAreaConstraint(forest2, avoidRegion);
        rmAddAreaConstraint(forest2, avoidImpassableLand); 
        rmAddAreaConstraint(forest2, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest2, Southward);
		 
        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  			

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE WHALE: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    if(rmRandFloat(0,1) < 0.5)
   {
		int whaleID=rmCreateObjectDef("whale");
		rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
		rmSetObjectDefMinDistance(whaleID, 0.0);
		rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
		rmAddObjectDefConstraint(whaleID, whaleLand);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.99);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** // 
/*================================================================================================================*/













