//================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// UNKNOWN COUNTRY 2:
// CREATED BY DANY:
// FEBRUARY 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
       // int playerTiles=25000;
		
		int playerTiles=30000;
	    if(rmRandFloat(0,1) > 0.25)
	{
		playerTiles=30000;
		rmEchoInfo("Extra large map");
	}
	  
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(size, size);
/*================================================================================================================*/
// ************************************* SET THE MAP ELEVATION PARAMETERS: ************************************** //
/*================================================================================================================*/
	    // rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0);
/*================================================================================================================*/
// ****************************************** DEFINE THE BASE TERRAIN: ****************************************** //
/*================================================================================================================*/
	    float baseTerrain = rmRandFloat(0,1);
	    int amazonMap = -1;
		int bayouMap = -1;
        int carolinaMap = -1;
		int pampasMap = -1;
		int patagoniaMap = -1;
		int yucatanMap = -1;
		string riverName = "";
	    string oceanName = "";
	    string pondName = "";
	    string cliffName = "";
	    string forestName = "";
	    string landName = "";
	    string treeName = "";
	    string critterOneName = "";
	    string critterTwoName = "";
	    string livestockName = "";
	    string fishName = "";
	    string whaleName = "";

	    if(baseTerrain < 0.15)
	{
		rmEchoInfo("Amazon terrain");
		amazonMap = 1;
		rmSetBaseTerrainMix("amazon grass");
		rmTerrainInitialize("pampas\ground5_pam", 6);
		rmSetMapType("yucatan");
		rmSetMapType("tropical");
		rmSetMapType("land");
	    rmSetLightingSet("amazon");
		riverName = "Amazon River";
		oceanName = "Amazon River Basin";
		pondName = "Bayou";
		cliffName = "Amazon";
		forestName = "Amazon Rain Forest";
		landName = "amazon grass";
		treeName = "treeAmazon";
		critterOneName = "capybara";
		critterTwoName = "tapir";
		livestockName = "cow";
		fishName = "fishMahi";
		whaleName = "humpbackWhale";
	}

        else if(baseTerrain < 0.30)
	{
		rmEchoInfo("Pampas terrain");
		pampasMap = 1;
		rmSetBaseTerrainMix("pampas_grass");
		rmTerrainInitialize("pampas\ground5_pam", 6);
		rmSetMapType("pampas");
		rmSetMapType("grass");
		rmSetMapType("land");
		rmSetLightingSet("Pampas");
		riverName = "Pampas River";
		oceanName = "hudson bay";
		pondName = "Amazon River Basin";
		cliffName = "Great Plains";
		forestName = "pampas forest";
		landName = "pampas_grass";
		treeName = "TreePampas";
		critterOneName = "deer";
		critterTwoName = "rhea";
		livestockName = "llama";
		fishName = "FishBass";
		whaleName = "minkeWhale";
	}	
	    else if(baseTerrain < 0.45)
	{
		rmEchoInfo("Patagonia terrain");
		patagoniaMap = 1;
		rmSetBaseTerrainMix("patagonia_grass");
		rmTerrainInitialize("patagonia\ground_dirt1_pat", 4.0);
		rmSetMapType("patagonia");
		rmSetMapType("grass");
		rmSetMapType("land");
		rmSetLightingSet("patagonia");
		riverName = "Pampas River";
		oceanName = "new england coast";
		pondName = "hudson bay";
		cliffName = "Patagonia";
		forestName = "patagonia forest";
		landName = "patagonia_grass";
		treeName = "TreePatagoniaDirt";
		critterOneName = "deer";
		critterTwoName = "rhea";
		livestockName = "llama";
		fishName = "FishSalmon";
		whaleName = "minkeWhale";
	}
	
	    else if(baseTerrain < 0.60)
	{
		rmEchoInfo("Yucatan terrain");
		yucatanMap = 1;
		rmSetBaseTerrainMix("yucatan_grass");
		rmTerrainInitialize("pampas\ground5_pam", 6);
		rmSetMapType("yucatan");
		rmSetMapType("tropical");
		rmSetMapType("land");
		rmSetLightingSet("yucatan");
		riverName = "Amazon River";
		oceanName = "yucatan Coast";
		pondName = "Amazon River Basin";
		cliffName = "Amazon";
		forestName = "yucatan forest";
		landName = "yucatan_grass";
		treeName = "TreeYucatan";
		critterOneName = "tapir";
		critterTwoName = "capybara";
		livestockName = "turkey";
		fishName = "FishBass";
		whaleName = "minkeWhale";
	}
	    else if(baseTerrain < 0.75)
	{
		rmEchoInfo("Bayou terrain");
		bayouMap = 1;
		rmSetBaseTerrainMix("bayou_grass");
		rmTerrainInitialize("pampas\ground5_pam", 6);
		rmSetMapType("bayou");
		rmSetMapType("grass");
		rmSetMapType("land");
		rmSetLightingSet("Bayou");
		riverName = "Amazon River";
		oceanName = "yucatan Coast";
		pondName = "bayou";
		cliffName = "Bayou";
		forestName = "bayou swamp forest";
		landName = "bayou_grass";
		treeName = "TreeBayou";
		critterOneName = "turkey";
		critterTwoName = "deer";
		livestockName = "sheep";
		fishName = "FishBass";
		whaleName = "minkeWhale";
	}
	    else 
	{
		rmEchoInfo("Carolina terrain");
		carolinaMap = 1;
		rmSetBaseTerrainMix("carolina_grass");
		rmTerrainInitialize("pampas\ground5_pam", 6);
		rmSetMapType("carolina");
		rmSetMapType("grass");
		rmSetMapType("land");
		rmSetLightingSet("carolina");
		riverName = "Pampas River";
		oceanName = "Atlantic Coast";
		pondName = "Texas Pond";
		cliffName = "Carolina Inland";
		forestName = "Carolina Pine Forest";
		landName = "carolina_grass";
		treeName = "treeCarolinaGrass";
		critterOneName = "turkey";
		critterTwoName = "deer";
		livestockName = "sheep";
		fishName = "fishCod";
		whaleName = "humpbackWhale";
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int classPlayer=rmDefineClass("player");
	    int classNatives=rmDefineClass("natives");
	    int classCanyon=rmDefineClass("canyon");
	    int pondClass=rmDefineClass("pond");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
		rmDefineClass("socketClass"); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHERS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // IMPASSABLE LAND AVOIDANCE:
		int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 24.0);
	    int playerAvoidImpassableLand = rmCreateTerrainDistanceConstraint("player avoid impassable land", "Land", false, 18.0);
	    int mediumAvoidImpassableLand = rmCreateTerrainDistanceConstraint("slightly avoid impassable", "Land", false, 12.0);
	    int shortAvoidImpassableLand = rmCreateTerrainDistanceConstraint("just barely avoid impassable", "Land", false, 4.0);
	    int TCAvoidImpassableLand = rmCreateTerrainDistanceConstraint("TCs vs impassable land", "Land", false, 8.0);
	
	    // PLAYER AVOIDANCE:
		int avoidPlayers = rmCreateClassDistanceConstraint("stay away from players medium", classPlayer, 25.0);
	    int avoidPlayersFar = rmCreateClassDistanceConstraint("stay away from players far", classPlayer, 50.0);
	    
		// TRADE ROUTE AND SOCKET AVOIDANCE:
		int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
		int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 12.0);
	    int TCAvoidTradeRoute = rmCreateTradeRouteDistanceConstraint("TC vs trade route", 4.0);
	    int TCAvoidSocket = rmCreateClassDistanceConstraint("TC avoid trade route sockets", rmClassID("socketClass"), 8.0);
	
	    // NATIVES AVOIDANCE:
		int avoidNatives = rmCreateClassDistanceConstraint("stay away from natives", classNatives, 8.0);
	    int nativesAvoidPlayers = rmCreateClassDistanceConstraint("natives vs. players", classPlayer, 10.0);
   
        // EDGE OF MAP AVOIDANCE:
		int edgeConstraint=rmCreatePieConstraint("continent avoids edge",  0.5, 0.5, 0, rmGetMapXSize()-30, 0, 0, 0);
	    int edgeCloseConstraint=rmCreatePieConstraint("close avoids edge",  0.5, 0.5, 0, rmGetMapXSize()-15, 0, 0, 0);
		
	    // CANYON AVOIDANCE:
		int avoidCanyon = rmCreateClassDistanceConstraint("don't place on mesa where you can't path", classCanyon, 2.0);
   
        // POND AVOIDANCE:
		int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 30.0);
   
        // FOREST AVOIDANCE:
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 15.0);
	
	    // TC AND CW AVOIDANCE:
		int avoidTC=rmCreateTypeDistanceConstraint("vs. TC", "TownCenter", 20.0);
	    int avoidCW=rmCreateTypeDistanceConstraint("vs. CW", "CoveredWagon", 20.0);
   
        // NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "abstractNugget", 15.0);
   
        // SEAFOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 10.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "abstractWhale", 25.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
				
		// New extra stuff for water spawn point avoidance.
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);

	    // ships vs. ships
        int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);

        // FRUITS AVOIDANCE:
		int avoidFruits = rmCreateTypeDistanceConstraint("stuff avoids fruits", "berrybush", 12.0);
		int fruitsAvoidFruits = rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 60.0);
		    
		// FOODS AVOIDANCE:
		int avoidElk=rmCreateTypeDistanceConstraint("stuff avoids elk", "Elk", 15.0);
		int elkAvoidElk=rmCreateTypeDistanceConstraint("elk avoids elk", "Elk", 60.0);
        int avoidMoose=rmCreateTypeDistanceConstraint("stuff avoids moose", "Moose", 15.0);
		int mooseConstraint=rmCreateTypeDistanceConstraint("moose avoids moose", "Moose", 60.0);
		//int mooseAvoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "Moose", 60.0);
		
		// FOOD AVOIDANCE:
		int avoidFood = rmCreateTypeDistanceConstraint("food avoids food", "food", 40.0);
	
	    // SILVER MINES AVOIDANCE:
		int avoidGold = rmCreateTypeDistanceConstraint("stuff avoids gold", "minegold", 15.0);
		int goldAvoidGold = rmCreateTypeDistanceConstraint("gold avoids gold", "minegold", 60.0);

        // DECORATIONS AVOIDANCE:
		int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ********************************** SET UP THE PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
	    if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.15, 0.35);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.13, 0.37);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.65, 0.85);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.63, 0.87);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
	}
	    else
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(50);

	  for(i=1; <cNumberPlayers)
	  
   {
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD THE AREA CONSTRAINT:
	  rmAddAreaConstraint(id, avoidPlayers);
	  // rmAddAreaConstraint(id, avoidWater16); 
	  //rmAddAreaConstraint(id, avoidTradeRoute); 
	  //rmAddAreaConstraint(id, avoidSocket); 
      //rmAddAreaConstraint(id, playerEdgeConstraint); 
      
	  // SET THE AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
      
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
   }
/*----------------------------------------------------------------------------------------------------------------*/
      // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/ 
// *************************************** DEFINE AND PLACE THE AREAS 1: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE LAKE: ******************************************* //     		
/*================================================================================================================*/
        // ============= Great Lakes Style Ocean =============
	    // But don't build ocean every single time
		
			int lakeOfTheUnknown=rmCreateArea("big lake in middle");
			rmSetAreaWaterType(lakeOfTheUnknown, oceanName);
			if(rmRandFloat(0,1) < 0.6)
			{
				//rmSetAreaSize(lakeOfTheUnknown, 0.07, 0.15);
				rmSetAreaSize(lakeOfTheUnknown, 0.03, 0.06);
				rmEchoInfo("larger lake");
			}
			else
			{
				rmSetAreaSize(lakeOfTheUnknown, 0.02, 0.05);
				rmEchoInfo("smaller lake");
			}
			rmSetAreaLocation(lakeOfTheUnknown, 0.5, 0.5);
			rmAddAreaConstraint(lakeOfTheUnknown, avoidPlayers);
			rmSetAreaSmoothDistance(lakeOfTheUnknown, 50);
			rmSetAreaCoherence(lakeOfTheUnknown, 0.25);
			rmBuildArea(lakeOfTheUnknown);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE TRADE ROUTE AND SOCKETS: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/ 
// *************************************** DEFINE AND PLACE THE AREAS 2: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // ************************************ DEFINE AND PLACE 2 SMALL MOUNTAINS: ************************************* //
/*================================================================================================================*/
        //int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);
		
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa 1");
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, cliffName);
		
		if(rmRandFloat(0,1) < 0.8)
		{		
			rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
			rmAddAreaToClass(smallMesaID, classCanyon);	
			rmEchoInfo("no ramps");	
		}
		else
		{
			rmSetAreaCliffEdge(smallMesaID, 4, 0.2, 0.0, 1.0, 0); 
			rmEchoInfo("ramps");
		}
		if(rmRandFloat(0,1) < 0.6)
			rmSetAreaCliffHeight(smallMesaID, rmRandInt(6,8), 1.0, 1.0);
		else
			rmSetAreaCliffHeight(smallMesaID, rmRandInt(-8,-6), 1.0, 1.0);
		
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0); 
		rmSetAreaCoherence(smallMesaID, 0.88);
		rmSetAreaLocation(smallMesaID, 0.5, 0.20); 
		rmBuildArea(smallMesaID); 
/*----------------------------------------------------------------------------------------------------------------*/
        int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);
/*----------------------------------------------------------------------------------------------------------------*/
        int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2");
		rmSetAreaSize(smallMesa2ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(smallMesa2ID, false);
		rmSetAreaCliffType(smallMesa2ID, cliffName);
		
		if(rmRandFloat(0,1) < 0.8)
		{		
			rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
			rmAddAreaToClass(smallMesa2ID, classCanyon);	
			rmEchoInfo("no ramps");	
		}
		else
		{
			rmSetAreaCliffEdge(smallMesa2ID, 4, 0.2, 0.0, 1.0, 0); 
			rmEchoInfo("ramps");
		}
		if(rmRandFloat(0,1) < 0.6)
			rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6,8), 1.0, 1.0);
		else
			rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(-8,-6), 1.0, 1.0);
		
		rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6, 8), 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa2ID, 0.88);
		rmSetAreaLocation(smallMesa2ID, 0.20, 0.5); 
		rmBuildArea(smallMesa2ID); 
/*----------------------------------------------------------------------------------------------------------------*/
        int smallCliff3Height=rmRandInt(0,10);
		int smallMesa3ID=rmCreateArea("small mesa 3");
		rmSetAreaSize(smallMesa3ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(smallMesa3ID, false);
		rmSetAreaCliffType(smallMesa3ID, cliffName);
		
		if(rmRandFloat(0,1) < 0.8)
		{		
			rmSetAreaCliffEdge(smallMesa3ID, 1, 1.0, 0.1, 1.0, 0);
			rmAddAreaToClass(smallMesa3ID, classCanyon);	
			rmEchoInfo("no ramps");	
		}
		else
		{
			rmSetAreaCliffEdge(smallMesa3ID, 4, 0.2, 0.0, 1.0, 0); 
			rmEchoInfo("ramps");
		}
		if(rmRandFloat(0,1) < 0.6)
			rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(6,8), 1.0, 1.0);
		else
			rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(-8,-6), 1.0, 1.0);
		
		rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(6, 8), 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa3ID, 0.88);
		rmSetAreaLocation(smallMesa3ID, 0.80, 0.5); 
		rmBuildArea(smallMesa3ID); 
/*----------------------------------------------------------------------------------------------------------------*/
        int smallCliff4Height=rmRandInt(0,10);
		int smallMesa4ID=rmCreateArea("small mesa 4");
		rmSetAreaSize(smallMesa4ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));  
		rmSetAreaWarnFailure(smallMesa4ID, false);
		rmSetAreaCliffType(smallMesa4ID, cliffName);
		
		if(rmRandFloat(0,1) < 0.8)
		{		
			rmSetAreaCliffEdge(smallMesa4ID, 1, 1.0, 0.1, 1.0, 0);
			rmAddAreaToClass(smallMesa4ID, classCanyon);	
			rmEchoInfo("no ramps");	
		}
		else
		{
			rmSetAreaCliffEdge(smallMesa4ID, 4, 0.2, 0.0, 1.0, 0); 
			rmEchoInfo("ramps");
		}
		if(rmRandFloat(0,1) < 0.6)
			rmSetAreaCliffHeight(smallMesa4ID, rmRandInt(6,8), 1.0, 1.0);
		else
			rmSetAreaCliffHeight(smallMesa4ID, rmRandInt(-8,-6), 1.0, 1.0);
		
		rmSetAreaCliffHeight(smallMesa4ID, rmRandInt(6, 8), 1.0, 1.0); 
		rmSetAreaCoherence(smallMesa4ID, 0.88);
		rmSetAreaLocation(smallMesa4ID, 0.50, 0.8); 
		rmBuildArea(smallMesa4ID);       		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// **************************************** DEFINE THE STARTING UNITS: ****************************************** //
/*================================================================================================================*/
	    int startingTCID= rmCreateObjectDef("startingTC");
	    if (rmGetNomadStart())
		    rmAddObjectDefItem(startingTCID, "CoveredWagon", 1);
	    else
		    rmAddObjectDefItem(startingTCID, "townCenter", 1);
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 20.0);
	    rmAddObjectDefConstraint(startingTCID, TCAvoidImpassableLand);
	    rmAddObjectDefConstraint(startingTCID, TCAvoidTradeRoute);
	    rmAddObjectDefConstraint(startingTCID, TCAvoidSocket);
	    rmAddObjectDefToClass(startingTCID, rmClassID("player"));

	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 8.0);
	    rmSetObjectDefMaxDistance(startingUnits, 14.0);
	    rmAddObjectDefConstraint(startingUnits, shortAvoidImpassableLand);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
/*================================================================================================================*/
// ***************************************** PLACE THE STARTING UNITS: ****************************************** //
/*================================================================================================================*/		
        // ( PLACE STARTING UNITS NOW SO OTHER STUFF CAN AVOID THEM: )
	    
		for(i=1; <cNumberPlayers)
	    
		{
		    rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		    rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/   
// *************************************** DEFINE AND CHOOSE THE NATIVES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1; 
/*----------------------------------------------------------------------------------------------------------------*/		
		if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Maya");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Maya");

		subCiv1=rmGetCivID("Aztecs");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Aztecs"); 

		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Maya");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Maya");
   }
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("maya"))
	{  
		int maya2VillageID = -1;
		maya2VillageID = rmCreateGrouping("maya2 village", "native maya village 1");
		rmSetGroupingMinDistance(maya2VillageID, 0.0);
		rmSetGroupingMaxDistance(maya2VillageID, 0.0);
		//rmAddGroupingConstraint(maya2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(maya2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(maya2VillageID, avoidNatives);
		//rmAddGroupingConstraint(maya2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(maya2VillageID, 0, 0.6, 0.1);
	} 

	    if (subCiv1 == rmGetCivID("aztecs"))
	{  
		int aztecs2VillageID = -1;
		aztecs2VillageID = rmCreateGrouping("aztecs2 village", "native aztec village 1");
		rmSetGroupingMinDistance(aztecs2VillageID, 0.0);
		rmSetGroupingMaxDistance(aztecs2VillageID, 0.0);
		//rmAddGroupingConstraint(aztecs2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecs2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecs2VillageID, avoidNatives);
		//rmAddGroupingConstraint(aztecs2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(aztecs2VillageID, 0, 0.1, 0.6);
	} 

	    if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecsVillageID = -1;
		aztecsVillageID = rmCreateGrouping("aztecs village", "native aztec village 1");
		rmSetGroupingMinDistance(aztecsVillageID, 0.0);
		rmSetGroupingMaxDistance(aztecsVillageID, 0.0);
		//rmAddGroupingConstraint(aztecsVillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecsVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecsVillageID, avoidNatives);
		//rmAddGroupingConstraint(aztecsVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(aztecsVillageID, 0, 0.9, 0.4);
	}

	    if (subCiv3 == rmGetCivID("maya"))
	{  
		int mayaVillageID = -1;
		mayaVillageID = rmCreateGrouping("maya village", "native maya village 1");
		rmSetGroupingMinDistance(mayaVillageID, 0.0);
		rmSetGroupingMaxDistance(mayaVillageID, 0.0);
		//rmAddGroupingConstraint(mayaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(mayaVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(mayaVillageID, avoidNatives);
		//rmAddGroupingConstraint(mayaVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(mayaVillageID, 0, 0.4, 0.9);
	}     
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // DEFINE THE PLAYER SILVER:
	    int playerSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(playerSilverID, 18.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 22.0);
	    rmAddObjectDefConstraint(playerSilverID, avoidAll);
        rmAddObjectDefConstraint(playerSilverID, shortAvoidImpassableLand);
		
		// DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(2,3), 2.0);
        rmSetObjectDefMinDistance(playerBerryID, 10);
        rmSetObjectDefMaxDistance(playerBerryID, 15);
	    rmAddObjectDefConstraint(playerBerryID, avoidAll);
        rmAddObjectDefConstraint(playerBerryID, shortAvoidImpassableLand);
		
		// DEFINE THE PLAYER BERRY:
		int playerBerry2ID=rmCreateObjectDef("player berries 2");
        rmAddObjectDefItem(playerBerry2ID, "berryBush", rmRandInt(2,3), 2.0);
        rmSetObjectDefMinDistance(playerBerry2ID, 16);
        rmSetObjectDefMaxDistance(playerBerry2ID, 25);
	    rmAddObjectDefConstraint(playerBerry2ID, avoidAll);
        rmAddObjectDefConstraint(playerBerry2ID, shortAvoidImpassableLand);
		
		// DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, treeName, 1, 0.0);
	    rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
        rmSetObjectDefMinDistance(playerTreeID, 12);
        rmSetObjectDefMaxDistance(playerTreeID, 18);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, shortAvoidImpassableLand);
		
		// DEFINE THE NEAR DEER:
		int nearDeerID=rmCreateObjectDef("herds near town");
        rmAddObjectDefItem(nearDeerID, critterOneName, rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(nearDeerID, 25);
        rmSetObjectDefMaxDistance(nearDeerID, 30);
        rmAddObjectDefConstraint(nearDeerID, avoidFood);
	    rmAddObjectDefConstraint(nearDeerID, avoidAll);
		//rmAddObjectDefConstraint(nearDeerID, avoidFarDeer);
        rmAddObjectDefConstraint(nearDeerID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(nearDeerID, true);
		
		// DEFINE THE FAR DEER:
		int farDeerID=rmCreateObjectDef("herds far away");
	    rmAddObjectDefItem(farDeerID, critterTwoName, rmRandInt(6,8), 10.0);
        rmSetObjectDefMinDistance(farDeerID, 35);
        rmSetObjectDefMaxDistance(farDeerID, 40);
        rmAddObjectDefConstraint(farDeerID, avoidFood);
		//rmAddObjectDefConstraint(farDeerID, avoidSocket);
	    rmAddObjectDefConstraint(farDeerID, avoidAll);
	    rmAddObjectDefConstraint(farDeerID, avoidImpassableLand);
        rmAddObjectDefConstraint(farDeerID, avoidCanyon);
        rmSetObjectDefCreateHerd(farDeerID, true);
		
		// DEFINE THE NUGGET:
		int nugget1= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget1, avoidNugget);
  	    rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget1, avoidAll);
		rmAddObjectDefConstraint(nugget1, edgeConstraint);
	    rmSetObjectDefMinDistance(nugget1, 35.0);
	    rmSetObjectDefMaxDistance(nugget1, 40.0);
		
		int nugget2= rmCreateObjectDef("nugget medium"); 
	    rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget2, 0.0);
	    rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget2, avoidNugget);
  	    rmAddObjectDefConstraint(nugget2, avoidTC);
  	    rmAddObjectDefConstraint(nugget2, avoidCW);
  	    rmAddObjectDefConstraint(nugget2, avoidCanyon);
  	    rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget2, avoidAll);
		rmAddObjectDefConstraint(nugget2, edgeConstraint);
	    rmSetObjectDefMinDistance(nugget2, 45.0);
	    rmSetObjectDefMaxDistance(nugget2, 50.0);
/*================================================================================================================*/
// *************************************** PLACE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
		for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
		
		// PLACE THE SILVER MINES:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		//rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE BERRIES:
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(playerBerry2ID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        
		// PLACE THE PLAYER TREE:
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
 		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
 		
		// PLACE THE NEAR DEER:
		rmPlaceObjectDefAtLoc(nearDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE FAR DEER:
		//rmPlaceObjectDefAtLoc(farDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE NUGGET:
		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(nugget2, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
/*----------------------------------------------------------------------------------------------------------------*/		
		// PLACE THE WATER FLAG:
		int waterFlagID = -1;
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		//rmAddObjectDefConstraint(waterFlagID, edgeConstraint);
		rmAddObjectDefConstraint(waterFlagID, flagVsFlag);
		rmAddObjectDefConstraint(waterFlagID, fishLand);
		//rmAddObjectDefConstraint(waterFlagID, pondConstraint);

		rmSetObjectDefMinDistance(waterFlagID, 0.0);
		rmSetObjectDefMaxDistance(waterFlagID, rmXFractionToMeters(0.2));
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		if(rmGetNumberUnitsPlaced(waterFlagID) < 1)
		{
		rmEchoInfo("------- FAILED TO PLACE WATER FLAG "+i+". RELAXING CONSTRAINTS");
		rmSetObjectDefMaxDistance(waterFlagID, rmXFractionToMeters(0.7));
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		}
		
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SILVER MINES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int gold1ID= rmCreateObjectDef("Gold Mines 1"); 
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
		rmAddObjectDefConstraint(gold1ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.1, 0.4); 
		
		int gold2ID= rmCreateObjectDef("Gold Mines 2"); 
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
		rmAddObjectDefConstraint(gold2ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.4, 0.1); 
		
		int gold3ID= rmCreateObjectDef("Gold Mines 3"); 
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
		rmAddObjectDefConstraint(gold3ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.9, 0.6); 
		
		int gold4ID= rmCreateObjectDef("Gold Mines 4"); 
		rmAddObjectDefItem(gold4ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold4ID, 0.0);
		rmSetObjectDefMaxDistance(gold4ID, 0.0);
		rmAddObjectDefConstraint(gold4ID, avoidGold);
		rmAddObjectDefConstraint(gold4ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.6, 0.9); 
/*----------------------------------------------------------------------------------------------------------------*/		
		int gold5ID= rmCreateObjectDef("Gold Mines 5"); 
		rmAddObjectDefItem(gold5ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold5ID, 0.0);
		rmSetObjectDefMaxDistance(gold5ID, 0.0);
		rmAddObjectDefConstraint(gold5ID, avoidGold);
		rmAddObjectDefConstraint(gold5ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold5ID, 0, 0.75, 0.15);
		
		int gold6ID= rmCreateObjectDef("Gold Mines 6"); 
		rmAddObjectDefItem(gold6ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold6ID, 0.0);
		rmSetObjectDefMaxDistance(gold6ID, 0.0);
		rmAddObjectDefConstraint(gold6ID, avoidGold);
		rmAddObjectDefConstraint(gold6ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold6ID, 0, 0.15, 0.75);
		
		int gold7ID= rmCreateObjectDef("Gold Mines 7"); 
		rmAddObjectDefItem(gold7ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold7ID, 0.0);
		rmSetObjectDefMaxDistance(gold7ID, 0.0);
		rmAddObjectDefConstraint(gold7ID, avoidGold);
		rmAddObjectDefConstraint(gold7ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold7ID, 0, 0.85, 0.25);
		
		int gold8ID= rmCreateObjectDef("Gold Mines 8"); 
		rmAddObjectDefItem(gold8ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold8ID, 0.0);
		rmSetObjectDefMaxDistance(gold8ID, 0.0);
		rmAddObjectDefConstraint(gold8ID, avoidGold);
		rmAddObjectDefConstraint(gold8ID, goldAvoidGold);
		rmPlaceObjectDefAtLoc(gold8ID, 0, 0.25, 0.85);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE LIVESTOCK: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int sheepID=rmCreateObjectDef("livestock");
	    rmAddObjectDefItem(sheepID, livestockName, rmRandInt(3,7), 4.0);
	    rmSetObjectDefMinDistance(sheepID, 0.0);
	    rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(sheepID, avoidFood);
	    rmAddObjectDefConstraint(sheepID, avoidAll);
		rmAddObjectDefConstraint(sheepID, avoidNatives);
	    rmAddObjectDefConstraint(sheepID, avoidPlayers);
	    rmAddObjectDefConstraint(sheepID, avoidCanyon);
	    rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
	    rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE TREASURES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int nugget3= rmCreateObjectDef("nugget hard 1"); 
	    rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 3);
	    rmSetObjectDefMinDistance(nugget3, 0.0);
	    //rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(nugget3, 0.0);
	    rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget3, avoidNugget);
  	    rmAddObjectDefConstraint(nugget3, avoidPlayersFar);
  	    rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget3, avoidAll);
		rmAddObjectDefConstraint(nugget3, avoidCanyon);
		rmAddObjectDefConstraint(nugget3, avoidNatives);
	    //if(rmRandFloat(0,1) < 0.9)
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.1, 0.5, cNumberNonGaiaPlayers);
	    //else
		//rmPlaceObjectDefAtLoc(nugget3, 0, 0.1, 0.5, cNumberNonGaiaPlayers*rmRandInt(2,4)); 
/*----------------------------------------------------------------------------------------------------------------*/		
		 int nugget33= rmCreateObjectDef("nugget hard 2"); 
	    rmAddObjectDefItem(nugget33, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 3);
	    rmSetObjectDefMinDistance(nugget33, 0.0);
	    //rmSetObjectDefMaxDistance(nugget33, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(nugget33, 0.0);
	    rmAddObjectDefConstraint(nugget33, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget33, avoidNugget);
  	    rmAddObjectDefConstraint(nugget33, avoidPlayersFar);
  	    rmAddObjectDefConstraint(nugget33, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget33, avoidAll);
		rmAddObjectDefConstraint(nugget33, avoidCanyon);
		rmAddObjectDefConstraint(nugget33, avoidNatives);
	    //if(rmRandFloat(0,1) < 0.9)
		rmPlaceObjectDefAtLoc(nugget33, 0, 0.5, 0.1, cNumberNonGaiaPlayers);
	    //else
		//rmPlaceObjectDefAtLoc(nugget33, 0, 0.5, 0.1, cNumberNonGaiaPlayers*rmRandInt(2,4));
/*----------------------------------------------------------------------------------------------------------------*/
         int nugget333= rmCreateObjectDef("nugget hard 3"); 
	    rmAddObjectDefItem(nugget333, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 3);
	    rmSetObjectDefMinDistance(nugget333, 0.0);
	    //rmSetObjectDefMaxDistance(nugget333, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(nugget333, 0.0);
	    rmAddObjectDefConstraint(nugget333, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget333, avoidNugget);
  	    rmAddObjectDefConstraint(nugget333, avoidPlayersFar);
  	    rmAddObjectDefConstraint(nugget333, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget333, avoidAll);
		rmAddObjectDefConstraint(nugget333, avoidCanyon);
		rmAddObjectDefConstraint(nugget333, avoidNatives);
	    //if(rmRandFloat(0,1) < 0.9)
		rmPlaceObjectDefAtLoc(nugget333, 0, 0.9, 0.5, cNumberNonGaiaPlayers);
	    //else
		//rmPlaceObjectDefAtLoc(nugget333, 0, 0.9, 0.5, cNumberNonGaiaPlayers*rmRandInt(2,4)); 
/*----------------------------------------------------------------------------------------------------------------*/
        int nugget3333= rmCreateObjectDef("nugget hard 4"); 
	    rmAddObjectDefItem(nugget3333, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 3);
	    rmSetObjectDefMinDistance(nugget3333, 0.0);
	    //rmSetObjectDefMaxDistance(nugget3333, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(nugget3333, 0.0);
	    rmAddObjectDefConstraint(nugget3333, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget3333, avoidNugget);
  	    rmAddObjectDefConstraint(nugget3333, avoidPlayersFar);
  	    rmAddObjectDefConstraint(nugget3333, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget3333, avoidAll);
		rmAddObjectDefConstraint(nugget3333, avoidCanyon);
		rmAddObjectDefConstraint(nugget3333, avoidNatives);
	    //if(rmRandFloat(0,1) < 0.9)
		rmPlaceObjectDefAtLoc(nugget3333, 0, 0.5, 0.9, cNumberNonGaiaPlayers);
	    //else
		//rmPlaceObjectDefAtLoc(nugget3333, 0, 0.5, 0.9, cNumberNonGaiaPlayers*rmRandInt(2,4));
/*----------------------------------------------------------------------------------------------------------------*/
        int nugget4= rmCreateObjectDef("nugget nuts"); 
		rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nugget4, 0.0);
		rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(nugget4, avoidNugget);
  		rmAddObjectDefConstraint(nugget4, avoidPlayersFar);
  		rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
  		rmAddObjectDefConstraint(nugget4, avoidAll);
		rmAddObjectDefConstraint(nugget4, avoidCanyon);
		rmAddObjectDefConstraint(nugget4, avoidNatives);
		rmPlaceObjectDefAtLoc(nugget4, 0, 0.3, 0.9);
/*----------------------------------------------------------------------------------------------------------------*/
    	int nugget44= rmCreateObjectDef("nugget nuts 2"); 
		rmAddObjectDefItem(nugget44, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nugget44, 0.0);
		rmSetObjectDefMaxDistance(nugget44, 0.0);
		rmAddObjectDefConstraint(nugget44, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(nugget44, avoidNugget);
  		rmAddObjectDefConstraint(nugget44, avoidPlayersFar);
  		rmAddObjectDefConstraint(nugget44, avoidTradeRoute);
  		rmAddObjectDefConstraint(nugget44, avoidAll);
		rmAddObjectDefConstraint(nugget44, avoidCanyon);
		rmAddObjectDefConstraint(nugget44, avoidNatives);
		rmPlaceObjectDefAtLoc(nugget44, 0, 0.9, 0.3);
		
		int nugget444= rmCreateObjectDef("nugget nuts 3"); 
		rmAddObjectDefItem(nugget444, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nugget444, 0.0);
		rmSetObjectDefMaxDistance(nugget444, 0.0);
		rmAddObjectDefConstraint(nugget444, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(nugget444, avoidNugget);
  		rmAddObjectDefConstraint(nugget444, avoidPlayersFar);
  		rmAddObjectDefConstraint(nugget444, avoidTradeRoute);
  		rmAddObjectDefConstraint(nugget444, avoidAll);
		rmAddObjectDefConstraint(nugget444, avoidCanyon);
		rmAddObjectDefConstraint(nugget444, avoidNatives);
		rmPlaceObjectDefAtLoc(nugget444, 0, 0.1, 0.7);
		
		int nugget4444= rmCreateObjectDef("nugget nuts 4"); 
		rmAddObjectDefItem(nugget4444, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nugget4444, 0.0);
		rmSetObjectDefMaxDistance(nugget4444, 0.0);
		rmAddObjectDefConstraint(nugget4444, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(nugget4444, avoidNugget);
  		rmAddObjectDefConstraint(nugget4444, avoidPlayersFar);
  		rmAddObjectDefConstraint(nugget4444, avoidTradeRoute);
  		rmAddObjectDefConstraint(nugget4444, avoidAll);
		rmAddObjectDefConstraint(nugget4444, avoidCanyon);
		rmAddObjectDefConstraint(nugget4444, avoidNatives);
		rmPlaceObjectDefAtLoc(nugget4444, 0, 0.7, 0.1);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE AND PLACE THE OASIS STYLE FOREST: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
		int greatUnknownForest=rmCreateArea("large central forest");
        rmSetAreaWarnFailure(greatUnknownForest, false);
		//rmSetAreaSize(greatUnknownForest, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
        //rmSetAreaSize(greatUnknownForest, 0.08, 0.08);
		rmSetAreaSize(greatUnknownForest, 0.0085, 0.0085);
        rmSetAreaForestType(greatUnknownForest, forestName);
        rmSetAreaForestDensity(greatUnknownForest, 0.8);
        rmSetAreaForestClumpiness(greatUnknownForest, 0.6);
        rmSetAreaForestUnderbrush(greatUnknownForest, 0.0);
        rmSetAreaMinBlobs(greatUnknownForest, 1);
        rmSetAreaMaxBlobs(greatUnknownForest, 5);
        rmSetAreaMinBlobDistance(greatUnknownForest, 16.0);
        rmSetAreaMaxBlobDistance(greatUnknownForest, 70.0);
        rmSetAreaCoherence(greatUnknownForest, 0.15);
        rmSetAreaSmoothDistance(greatUnknownForest, 0);
        rmAddAreaToClass(greatUnknownForest, rmClassID("classForest"));
		rmSetAreaLocation(greatUnknownForest, 0.3, 0.8);
        rmAddAreaConstraint(greatUnknownForest, avoidPlayersFar); 
		rmAddAreaConstraint(greatUnknownForest, avoidNatives);
        rmAddAreaConstraint(greatUnknownForest, avoidGold);
        rmAddAreaConstraint(greatUnknownForest, avoidNugget);
        rmAddAreaConstraint(greatUnknownForest, avoidCanyon);     		
		rmAddAreaConstraint(greatUnknownForest, forestConstraint); 
		rmBuildArea(greatUnknownForest);
		
		int greatUnknownForest2=rmCreateArea("large central forest 2");
        rmSetAreaWarnFailure(greatUnknownForest2, false);
		//rmSetAreaSize(greatUnknownForest2, rmAreaTilesToFraction(400), rmAreaTilesToFraction(400));
        //rmSetAreaSize(greatUnknownForest2, 0.08, 0.08);
		rmSetAreaSize(greatUnknownForest2, 0.0085, 0.0085);
        rmSetAreaForestType(greatUnknownForest2, forestName);
        rmSetAreaForestDensity(greatUnknownForest2, 0.8);
        rmSetAreaForestClumpiness(greatUnknownForest2, 0.6);
        rmSetAreaForestUnderbrush(greatUnknownForest2, 0.0);
        rmSetAreaMinBlobs(greatUnknownForest2, 1);
        rmSetAreaMaxBlobs(greatUnknownForest2, 5);
        rmSetAreaMinBlobDistance(greatUnknownForest2, 16.0);
        rmSetAreaMaxBlobDistance(greatUnknownForest2, 70.0);
        rmSetAreaCoherence(greatUnknownForest2, 0.15);
        rmSetAreaSmoothDistance(greatUnknownForest2, 0);
        rmAddAreaToClass(greatUnknownForest2, rmClassID("classForest"));
		rmSetAreaLocation(greatUnknownForest2, 0.8, 0.3);
        rmAddAreaConstraint(greatUnknownForest2, avoidPlayersFar);
        rmAddAreaConstraint(greatUnknownForest2, avoidNatives);
 		rmAddAreaConstraint(greatUnknownForest2, avoidGold);
        rmAddAreaConstraint(greatUnknownForest2, avoidNugget);
        rmAddAreaConstraint(greatUnknownForest2, avoidCanyon);    		
		rmAddAreaConstraint(greatUnknownForest2, forestConstraint); 
		rmBuildArea(greatUnknownForest2);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);	
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/
	    int numTries=12*cNumberNonGaiaPlayers;
	    int failCount = 0;
	    
	    if(rmRandFloat(0,1) > 0.9)
	{
		numTries = 6*cNumberNonGaiaPlayers;
	}

        for (i=0; <numTries)
	{   
        int forest=rmCreateArea("forest "+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
        rmSetAreaForestType(forest, forestName);
        rmSetAreaForestDensity(forest, 0.8);
        rmSetAreaForestClumpiness(forest, 0.6);
        rmSetAreaForestUnderbrush(forest, 0.0);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 5);
        rmSetAreaMinBlobDistance(forest, 16.0);
        rmSetAreaMaxBlobDistance(forest, 70.0);
        rmSetAreaCoherence(forest, 0.4);
        rmSetAreaSmoothDistance(forest, 0);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidTC);
        rmAddAreaConstraint(forest, avoidCW);
        rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, avoidNatives);
		rmAddAreaConstraint(forest, edgeCloseConstraint);
        rmAddAreaConstraint(forest, avoidCanyon);
        rmAddAreaConstraint(forest, mediumAvoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidTradeRoute);

        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 3 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
	}
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE ELK: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int elkID=rmCreateObjectDef("elk herd");
	    rmAddObjectDefItem(elkID, critterOneName, rmRandInt(3,5), 5.0);
        rmSetObjectDefMinDistance(elkID, 0.0);
        rmSetObjectDefMaxDistance(elkID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(elkID, avoidElk);
		rmAddObjectDefConstraint(elkID, elkAvoidElk);
        rmAddObjectDefConstraint(elkID, avoidMoose);
	    rmAddObjectDefConstraint(elkID, avoidAll);
		rmAddObjectDefConstraint(elkID, avoidPlayers);
		rmAddObjectDefConstraint(elkID, edgeCloseConstraint);
		rmAddObjectDefConstraint(elkID, avoidNatives);
        rmAddObjectDefConstraint(elkID, avoidImpassableLand);
	    rmAddObjectDefConstraint(elkID, avoidSocket);
	    rmAddObjectDefConstraint(elkID, avoidTradeRoute);
	    rmAddObjectDefConstraint(elkID, avoidTC);
		rmAddObjectDefConstraint(elkID, avoidCanyon);
        rmSetObjectDefCreateHerd(elkID, true);
	    rmPlaceObjectDefAtLoc(elkID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE MOOSE: ***************************************** // 
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int mooseID=rmCreateObjectDef("moose herd");
	    rmAddObjectDefItem(mooseID, critterTwoName, rmRandInt(4,5), 5.0);
        rmSetObjectDefMinDistance(mooseID, 0.0);
        rmSetObjectDefMaxDistance(mooseID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(mooseID, avoidElk);
        rmAddObjectDefConstraint(mooseID, avoidMoose);
		rmAddObjectDefConstraint(mooseID, mooseConstraint);
		//rmAddObjectDefConstraint(mooseID, mooseAvoidMoose);
	    rmAddObjectDefConstraint(mooseID, avoidAll);
		rmAddObjectDefConstraint(mooseID, avoidPlayers);
		rmAddObjectDefConstraint(mooseID, edgeCloseConstraint);
        rmAddObjectDefConstraint(mooseID, avoidImpassableLand);
	    rmAddObjectDefConstraint(mooseID, avoidSocket);
	    rmAddObjectDefConstraint(mooseID, avoidTradeRoute);
	    rmAddObjectDefConstraint(mooseID, avoidTC);
		rmAddObjectDefConstraint(mooseID, avoidNatives);
		rmAddObjectDefConstraint(mooseID, avoidCanyon);
        rmSetObjectDefCreateHerd(mooseID, true);
	    rmPlaceObjectDefAtLoc(mooseID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE SCATTERED BERRRIES: ********************************* //
/*================================================================================================================*/
        int berriesID=rmCreateObjectDef("The Fruits");
	    rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(3,5), 4.0);
		//rmAddObjectDefItem(berriesID, "berrybush", 1.0, 0.0);
	    rmSetObjectDefMinDistance(berriesID, 0.0);
	    //rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(berriesID, 0.0);
	    rmAddObjectDefConstraint(berriesID, avoidTC);
	    rmAddObjectDefConstraint(berriesID, avoidSocket);
	    rmAddObjectDefConstraint(berriesID, avoidCW);
	    rmAddObjectDefConstraint(berriesID, avoidAll);
		rmAddObjectDefConstraint(berriesID, avoidPlayers);
	    rmAddObjectDefConstraint(berriesID, avoidFruits);
		rmAddObjectDefConstraint(berriesID, fruitsAvoidFruits);
		rmAddObjectDefConstraint(berriesID, avoidElk);
        rmAddObjectDefConstraint(berriesID, avoidMoose);
	    rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
	    rmAddObjectDefConstraint(berriesID, avoidCanyon);
		rmAddObjectDefConstraint(berriesID, avoidNatives);
		rmAddObjectDefConstraint(berriesID, edgeCloseConstraint);
		//rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		rmPlaceObjectDefAtLoc(berriesID, 0, 0.4, 0.05);
		
		int berries2ID=rmCreateObjectDef("The Fruits 2");
	    rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		//rmAddObjectDefItem(berries2ID, "berrybush", 1.0, 0.0);
	    rmSetObjectDefMinDistance(berries2ID, 0.0);
	    //rmSetObjectDefMaxDistance(berries2ID, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
	    rmAddObjectDefConstraint(berries2ID, avoidTC);
	    rmAddObjectDefConstraint(berries2ID, avoidSocket);
	    rmAddObjectDefConstraint(berries2ID, avoidCW);
	    rmAddObjectDefConstraint(berries2ID, avoidAll);
		rmAddObjectDefConstraint(berries2ID, avoidPlayers);
	    rmAddObjectDefConstraint(berries2ID, avoidFruits);
		rmAddObjectDefConstraint(berries2ID, fruitsAvoidFruits);
		rmAddObjectDefConstraint(berries2ID, avoidElk);
        rmAddObjectDefConstraint(berries2ID, avoidMoose);
	    rmAddObjectDefConstraint(berries2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(berries2ID, avoidCanyon);
		rmAddObjectDefConstraint(berries2ID, avoidNatives);
		rmAddObjectDefConstraint(berries2ID, edgeCloseConstraint);
		//rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.05, 0.40);
		
		int berries3ID=rmCreateObjectDef("The Fruits 3");
	    rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		//rmAddObjectDefItem(berries3ID, "berrybush", 1.0, 0.0);
	    rmSetObjectDefMinDistance(berries3ID, 0.0);
	    //rmSetObjectDefMaxDistance(berries3ID, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
	    rmAddObjectDefConstraint(berries3ID, avoidTC);
	    rmAddObjectDefConstraint(berries3ID, avoidSocket);
	    rmAddObjectDefConstraint(berries3ID, avoidCW);
	    rmAddObjectDefConstraint(berries3ID, avoidAll);
		rmAddObjectDefConstraint(berries3ID, avoidPlayers);
	    rmAddObjectDefConstraint(berries3ID, avoidFruits);
		rmAddObjectDefConstraint(berries3ID, fruitsAvoidFruits);
		rmAddObjectDefConstraint(berries3ID, avoidElk);
        rmAddObjectDefConstraint(berries3ID, avoidMoose);
	    rmAddObjectDefConstraint(berries3ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(berries3ID, avoidCanyon);
		rmAddObjectDefConstraint(berries3ID, avoidNatives);
		rmAddObjectDefConstraint(berries3ID, edgeCloseConstraint);
		//rmPlaceObjectDefAtLoc(berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.95, 0.60);
		
		int berries4ID=rmCreateObjectDef("The Fruits 4");
	    rmAddObjectDefItem(berries4ID, "berrybush", rmRandInt(3,5), 4.0);
		//rmAddObjectDefItem(berries4ID, "berrybush", 1.0, 0.0);
	    rmSetObjectDefMinDistance(berries4ID, 0.0);
	    //rmSetObjectDefMaxDistance(berries4ID, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(berries4ID, 0.0);
	    rmAddObjectDefConstraint(berries4ID, avoidTC);
	    rmAddObjectDefConstraint(berries4ID, avoidSocket);
	    rmAddObjectDefConstraint(berries4ID, avoidCW);
	    rmAddObjectDefConstraint(berries4ID, avoidAll);
		rmAddObjectDefConstraint(berries4ID, avoidPlayers);
	    rmAddObjectDefConstraint(berries4ID, avoidFruits);
		rmAddObjectDefConstraint(berries4ID, fruitsAvoidFruits);
		rmAddObjectDefConstraint(berries4ID, avoidElk);
        rmAddObjectDefConstraint(berries4ID, avoidMoose);
	    rmAddObjectDefConstraint(berries4ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(berries4ID, avoidCanyon);
		rmAddObjectDefConstraint(berries4ID, avoidNatives);
		rmAddObjectDefConstraint(berries4ID, edgeCloseConstraint);
		//rmPlaceObjectDefAtLoc(berries4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.60, 0.95);
		
		int berries5ID=rmCreateObjectDef("The Fruits 5");
	    rmAddObjectDefItem(berries5ID, "berrybush", rmRandInt(3,5), 4.0);
		//rmAddObjectDefItem(berries5ID, "berrybush", 1.0, 0.0);
	    rmSetObjectDefMinDistance(berries5ID, 0.0);
	    //rmSetObjectDefMaxDistance(berries5ID, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(berries5ID, 0.0);
	    rmAddObjectDefConstraint(berries5ID, avoidTC);
	    rmAddObjectDefConstraint(berries5ID, avoidSocket);
	    rmAddObjectDefConstraint(berries5ID, avoidCW);
	    rmAddObjectDefConstraint(berries5ID, avoidAll);
		rmAddObjectDefConstraint(berries5ID, avoidPlayers);
	    rmAddObjectDefConstraint(berries5ID, avoidFruits);
		rmAddObjectDefConstraint(berries5ID, fruitsAvoidFruits);
		rmAddObjectDefConstraint(berries5ID, avoidElk);
        rmAddObjectDefConstraint(berries5ID, avoidMoose);
	    rmAddObjectDefConstraint(berries5ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(berries5ID, avoidCanyon);
		rmAddObjectDefConstraint(berries5ID, avoidNatives);
		rmAddObjectDefConstraint(berries5ID, edgeCloseConstraint);
		//rmPlaceObjectDefAtLoc(berries5ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		rmPlaceObjectDefAtLoc(berries5ID, 0, 0.80, 0.20);
		
		int berries6ID=rmCreateObjectDef("The Fruits 6");
	    rmAddObjectDefItem(berries6ID, "berrybush", rmRandInt(3,5), 4.0);
		//rmAddObjectDefItem(berries6ID, "berrybush", 1.0, 0.0);
	    rmSetObjectDefMinDistance(berries6ID, 0.0);
	    //rmSetObjectDefMaxDistance(berries6ID, rmXFractionToMeters(0.5));
		rmSetObjectDefMaxDistance(berries6ID, 0.0);
	    rmAddObjectDefConstraint(berries6ID, avoidTC);
	    rmAddObjectDefConstraint(berries6ID, avoidSocket);
	    rmAddObjectDefConstraint(berries6ID, avoidCW);
	    rmAddObjectDefConstraint(berries6ID, avoidAll);
		rmAddObjectDefConstraint(berries6ID, avoidPlayers);
	    rmAddObjectDefConstraint(berries6ID, avoidFruits);
		rmAddObjectDefConstraint(berries6ID, fruitsAvoidFruits);
		rmAddObjectDefConstraint(berries6ID, avoidElk);
        rmAddObjectDefConstraint(berries6ID, avoidMoose);
	    rmAddObjectDefConstraint(berries6ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(berries6ID, avoidCanyon);
		rmAddObjectDefConstraint(berries6ID, avoidNatives);
		rmAddObjectDefConstraint(berries6ID, edgeCloseConstraint);
		//rmPlaceObjectDefAtLoc(berries6ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
		rmPlaceObjectDefAtLoc(berries6ID, 0, 0.20, 0.80);
		
/*================================================================================================================*/		
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// *************************************** ADD FISHES IF OCEAN: ************************************************* //
/*================================================================================================================*/
        int fishID=rmCreateObjectDef("fish");
		rmAddObjectDefItem(fishID, fishName, 3, 4.0);
		rmSetObjectDefMinDistance(fishID, 0.0);
		rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fishID, fishVsFishID);
		rmAddObjectDefConstraint(fishID, fishLand);
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);

		int whaleID=rmCreateObjectDef("whale");
		rmAddObjectDefItem(whaleID, whaleName, 1, 9.0);
		rmSetObjectDefMinDistance(whaleID, 0.0);
		rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
		rmAddObjectDefConstraint(whaleID, whaleLand);
		if(rmRandFloat(0,1) < 0.5)
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //  
/*================================================================================================================*/ 
	