//================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// UNKNOWN COUNTRY CREATED BY DANY:
// FEBRUARY 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/   
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
        int playerTiles=25000;
		
	/*	int playerTiles=25000;
	    if(rmRandFloat(0,1) > 0.25)
	{
		playerTiles=25000;
		rmEchoInfo("Extra large map");
	}*/
	  
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(size, size);
/*================================================================================================================*/
// ************************************* SET THE MAP ELEVATION PARAMETERS: ************************************** //
/*================================================================================================================*/
	  rmSetMapElevationParameters(cElevTurbulence, 0.02, rmRandFloat(2, 4), 0.7, 8.0);
/*================================================================================================================*/
// ****************************************** DEFINE THE BASE TERRAIN: ****************************************** //
/*================================================================================================================*/
	    float baseTerrain = rmRandFloat(0,1);
	    int amazonMap = -1;
	    int carolinaMap = -1;
	    int saguenayMap = -1;
	    int rockiesMap = -1;
	    int sonoraMap = -1;
	    string riverName = "";
	    string oceanName = "";
	    string pondName = "";
	    string cliffName = "";
	    string forestName = "";
	    string landName = "";
	    string treeName = "";
	    string critterOneName = "";
	    string critterTwoName = "";
	    string livestockName = "";
	    string fishName = "";
	    string whaleName = "";
	
	    if(baseTerrain < 0.2)
	{
		rmEchoInfo("Amazon terrain");
		amazonMap = 1;
		rmSetBaseTerrainMix("amazon grass");
		rmTerrainInitialize("pampas\ground5_pam", 6);
		rmSetMapType("yucatan");
		rmSetMapType("tropical");
		rmSetMapType("land");
	    rmSetLightingSet("amazon");
		riverName = "Amazon River";
		oceanName = "Amazon River Basin";
		pondName = "Bayou";
		cliffName = "Amazon";
		forestName = "Amazon Rain Forest";
		landName = "amazon grass";
		treeName = "treeAmazon";
		critterOneName = "capybara";
		critterTwoName = "tapir";
		livestockName = "cow";
		fishName = "fishMahi";
		whaleName = "humpbackWhale";
		
	}

	    else if(baseTerrain < 0.4)
	{
		rmEchoInfo("Carolina terrain");
		carolinaMap = 1;
		rmSetBaseTerrainMix("carolina_grass");
		rmTerrainInitialize("pampas\ground5_pam", 6);
		rmSetMapType("carolina");
		rmSetMapType("grass");
		rmSetMapType("land");
		rmSetLightingSet("carolina");
		riverName = "Pampas River";
		oceanName = "Atlantic Coast";
		pondName = "Texas Pond";
		cliffName = "Carolina Inland";
		forestName = "Carolina Pine Forest";
		landName = "carolina_grass";
		treeName = "treeCarolinaGrass";
		critterOneName = "turkey";
		critterTwoName = "deer";
		livestockName = "sheep";
		fishName = "fishCod";
		whaleName = "humpbackWhale";
		
	}

	    else if(baseTerrain < 0.6)
	{
		rmEchoInfo("Saguenay terrain");
		saguenayMap = 1;
		rmSetBaseTerrainMix("saguenay tundra");
		rmTerrainInitialize("saguenay\ground1_sag",6);
		rmSetMapType("saguenay");
		rmSetMapType("grass");
		rmSetMapType("land");
	    rmSetLightingSet("saguenay");
		riverName = "Amazon River";
		oceanName = "Hudson Bay";
		pondName = "Saguenay Lake";
		cliffName = "New England Inland";
		forestName = "Saguenay Forest";
		landName = "saguenay tundra";
		treeName = "treeSaguenay";
		critterOneName = "elk";
		critterTwoName = "moose";
		livestockName = "sheep";
		fishName = "fishSalmon";
		whaleName = "minkeWhale";
			
	}

	    else if(baseTerrain < 0.8)
	{
		rmEchoInfo("Rockies terrain");
		rockiesMap = 1;
		rmSetBaseTerrainMix("rockies_snow");
		rmTerrainInitialize("rockies\groundsnow1_roc", 6);	
		rmSetMapType("rockies");
		rmSetMapType("land");
		rmSetLightingSet("rockies");
		riverName = "Yukon River";
		oceanName = "Great Lakes Ice";
		pondName = "Great Lakes Ice";
		cliffName = "Rocky Mountain2";
		forestName = "Rockies Snow Forest";
		landName = "rockies_snow";
		treeName = "treeRockies";
		critterOneName = "caribou";
		critterTwoName = "muskOx";
		livestockName = "cow";
		fishName = "fishSardine";
		whaleName = "beluga";
	}

	    else
	{
		rmEchoInfo("Sonora terrain");
		sonoraMap = 1;
		rmSetBaseTerrainMix("sonora_dirt");
		rmTerrainInitialize("sonora\ground2_son", 6);
		rmSetMapType("sonora");
		rmSetMapType("grass");
		rmSetMapType("land");
		rmSetLightingSet("Sonora");
		riverName = "Pampas River";
		oceanName = "Great Lakes";
		pondName = "Great Lakes"; 
		cliffName = "Sonora";
		forestName = "Sonora Forest";
		landName = "sonora_dirt";
		treeName = "treeSonora";
		critterOneName = "turkey";
		critterTwoName = "rhea";
		livestockName = "llama";
		fishName = "fishTarpon";
		whaleName = "humpbackWhale";
		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/   
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
        int classPlayer=rmDefineClass("player");
	    int classNatives=rmDefineClass("natives");
	    int classCanyon=rmDefineClass("canyon");
	    int pondClass=rmDefineClass("pond");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
		rmDefineClass("classSocket");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/   
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHERS: ************************* //
/*================================================================================================================*/
        // CREATE AN EDGE OF MAP CONSTRAINT:
	    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.45), rmDegreesToRadians(0), rmDegreesToRadians(360));
		
		// IMPASSABLE LAND AVOIDANCE:
		int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 24.0);
	    int playerAvoidImpassableLand = rmCreateTerrainDistanceConstraint("player avoid impassable land", "Land", false, 18.0);
	    int mediumAvoidImpassableLand = rmCreateTerrainDistanceConstraint("slightly avoid impassable", "Land", false, 12.0);
	    int shortAvoidImpassableLand = rmCreateTerrainDistanceConstraint("just barely avoid impassable", "Land", false, 4.0);
	    int TCAvoidImpassableLand = rmCreateTerrainDistanceConstraint("TCs vs impassable land", "Land", false, 8.0);
	
	    // PLAYER AVOIDANCE:
		int avoidPlayers = rmCreateClassDistanceConstraint("stay away from players medium", classPlayer, 15.0);
	    int avoidPlayersFar = rmCreateClassDistanceConstraint("stay away from players far", classPlayer, 50.0);
	    
		// TRADE ROUTE AND SOCKET AVOIDANCE:
		int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	    int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route sockets", "sockettraderoute", 15.0);
	    int TCAvoidTradeRoute = rmCreateTradeRouteDistanceConstraint("TC vs trade route", 4.0);
	    int TCAvoidTradeRouteSocket = rmCreateTypeDistanceConstraint("TC avoid trade route sockets", "sockettraderoute", 8.0);
	
	    // VP AVOIDANCE:
        //int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 4.0);
      
	    // SOCKET AVOIDANCE:
	    int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("classSocket"), 8.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives = rmCreateClassDistanceConstraint("stay away from natives", classNatives, 20.0);
	    int nativesAvoidPlayers = rmCreateClassDistanceConstraint("natives vs. players", classPlayer, 25.0);
   
        // EDGE OF MAP AVOIDANCE:
		int edgeConstraint=rmCreatePieConstraint("continent avoids edge",  0.5, 0.5, 0, rmGetMapXSize()-30, 0, 0, 0);
	
	    // CANYON AVOIDANCE:
		int avoidCanyon = rmCreateClassDistanceConstraint("don't place on mesa where you can't path", classCanyon, 2.0);
   
        // POND AVOIDANCE:
		int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 30.0);
   
        // FOREST AVOIDANCE:
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
	
	    // TC AND CW AVOIDANCE:
		int avoidTC=rmCreateTypeDistanceConstraint("vs. TC", "TownCenter", 20.0);
	    int avoidCW=rmCreateTypeDistanceConstraint("vs. CW", "CoveredWagon", 20.0);
   
        // NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 30.0);
		
		// FOODS AVOIDANCE:
		int avoidElk=rmCreateTypeDistanceConstraint("elk avoids elk", "Elk", 15.0);
        int avoidMoose=rmCreateTypeDistanceConstraint("moose avoids moose", "Moose", 15.0);
     
        // SEAFOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 10.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "abstractWhale", 25.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	    
		// FLAG AVOIDANCE:
		int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
   
        // FOOD AVOIDANCE:
		int avoidFood = rmCreateTypeDistanceConstraint("food avoids food", "food", 15.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits = rmCreateTypeDistanceConstraint("stuffs avoids fruits", "berrybush", 12.0);
		int fruitsAvoidFruits = rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 40.0);
			
	    // SILVER MINES AVOIDANCE:
		int avoidSilver = rmCreateTypeDistanceConstraint("stuff avoids coin", "gold", 15.0);
		int silverAvoidSilver = rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 50.0);

        // DECORATIONS AVOIDANCE:
		int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ********************************** SET UP THE PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
	    if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.15, 0.35);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.13, 0.37);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.65, 0.85);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.63, 0.87);
		}
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
	}
	    else
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(50);

	  for(i=1; <cNumberPlayers)
	  
   {
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD THE AREA CONSTRAINT:
	  rmAddAreaConstraint(id, avoidPlayers);
	  // rmAddAreaConstraint(id, avoidWater16); 
	  //rmAddAreaConstraint(id, avoidTradeRouteFar); 
	  //rmAddAreaConstraint(id, avoidSocket); 
      //rmAddAreaConstraint(id, playerEdgeConstraint); 
      
	  // SET THE AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
      
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
   }
/*----------------------------------------------------------------------------------------------------------------*/
      // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE TRADE ROUTE AND SOCKETS: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/	
// ********************************** DEFINE AND PLACE THE 2 TRADE ROUTES: ************************************** //
/*================================================================================================================*/ 
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.8, 0.135);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.15);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.25, 0.09);
	  //rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.2, 0.3, 10, 4);

      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.55);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 2:
	  int tradeRoute2ID = rmCreateTradeRoute();
      socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
      rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.725, 0.9);
	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.45, 0.85);
	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.25, 0.9);
	  //rmAddRandomTradeRouteWaypoints(tradeRoute2ID, 0.2, 0.7, 10, 4);

      placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 2:
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.05);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.45);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.95);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
// *************************************** SONORA STYLE PLATEAU / CANYON **************************************** // 
/*================================================================================================================*/
		int centerMesa=rmCreateArea("large mesa or canyon in middle");
		//rmSetAreaSize(centerMesa, rmAreaTilesToFraction(1100), rmAreaTilesToFraction(1100));
		rmSetAreaSize(centerMesa, 0.02, 0.06);  
		rmSetAreaCliffType(centerMesa, cliffName);

		if(rmRandFloat(0,1) < 0.8)
		{		
			rmSetAreaCliffEdge(centerMesa, 1, 1.0, 0.1, 1.0, 0);
			rmAddAreaToClass(centerMesa, classCanyon);
			rmEchoInfo("no ramps");	
		}
		else
		{
			rmSetAreaCliffEdge(centerMesa, 4, 0.2, 0.0, 1.0, 0); 
			rmEchoInfo("ramps");
		}
		if(rmRandFloat(0,1) < 0.6)
			rmSetAreaCliffHeight(centerMesa, rmRandInt(6,8), 1.0, 1.0);
		else
			rmSetAreaCliffHeight(centerMesa, rmRandInt(-8,-6), 1.0, 1.0);
		
		rmSetAreaMinBlobs(centerMesa, 1);
		rmSetAreaMaxBlobs(centerMesa, 1);
		rmSetAreaMinBlobDistance(centerMesa, 1.0);
		rmSetAreaMaxBlobDistance(centerMesa, 1.0);
		rmSetAreaCoherence(centerMesa, 0.3);
		rmSetAreaLocation(centerMesa, 0.5, 0.5);
	    rmSetAreaSmoothDistance(centerMesa, 20);
		rmAddAreaConstraint(centerMesa, avoidPlayers);
		rmBuildArea(centerMesa);
		
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE 2 SMALL PONDS: **************************************** //
/*================================================================================================================*/

	    int smallPondID=rmCreateArea("small pond 1");
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
		// rmSetAreaWaterType(smallPondID, "texas pond");
		   rmSetAreaWaterType(smallPondID, pondName);
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.5);
		rmSetAreaSmoothDistance(smallPondID, 5);
		//rmAddAreaConstraint(smallPondID, pondConstraint);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.85, 0.5); 
		rmBuildArea(smallPondID);
		
		int smallPond2ID=rmCreateArea("small pond 2");
		rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
		// rmSetAreaWaterType(smallPond2ID, "texas pond");
		   rmSetAreaWaterType(smallPond2ID, pondName);
		rmSetAreaBaseHeight(smallPond2ID, 4);
		rmSetAreaMinBlobs(smallPond2ID, 1);
		rmSetAreaMaxBlobs(smallPond2ID, 1);
		rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
		rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
		rmAddAreaToClass(smallPond2ID, pondClass);
		rmSetAreaCoherence(smallPond2ID, 0.5);
		rmSetAreaSmoothDistance(smallPond2ID, 5);
		//rmAddAreaConstraint(smallPond2ID, pondConstraint);
		rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.15, 0.5); 
		rmBuildArea(smallPond2ID);
/*================================================================================================================*/	
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// **************************************** DEFINE THE STARTING UNITS: ****************************************** //
/*================================================================================================================*/
	    int startingTCID= rmCreateObjectDef("startingTC");
	    if (rmGetNomadStart())
		    rmAddObjectDefItem(startingTCID, "CoveredWagon", 1);
	    else
		    rmAddObjectDefItem(startingTCID, "townCenter", 1);
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 20.0);
	    rmAddObjectDefConstraint(startingTCID, TCAvoidImpassableLand);
	    rmAddObjectDefConstraint(startingTCID, TCAvoidTradeRoute);
	    rmAddObjectDefConstraint(startingTCID, TCAvoidTradeRouteSocket);
	    rmAddObjectDefToClass(startingTCID, rmClassID("player"));

	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 8.0);
	    rmSetObjectDefMaxDistance(startingUnits, 14.0);
	    rmAddObjectDefConstraint(startingUnits, shortAvoidImpassableLand);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
/*================================================================================================================*/
// ***************************************** PLACE THE STARTING UNITS: ****************************************** //
/*================================================================================================================*/		
        // ( PLACE STARTING UNITS NOW SO OTHER STUFF CAN AVOID THEM: )
	    
		for(i=1; <cNumberPlayers)
	    
		{
		    rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		    rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// *************************************** DEFINE AND CHOOSE THE NATIVES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int subCiv0=-1;
      int subCiv1=-1;
/*----------------------------------------------------------------------------------------------------------------*/   
      if (rmAllocateSubCivs(2) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Iroquois"); 
   }
/*----------------------------------------------------------------------------------------------------------------*/   
        if (subCiv0 == rmGetCivID("Iroquois"))
	{  
		int iroquois2VillageID = -1;
		 iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		   //comancheVillageID = rmCreateGrouping("comanche village", nativeName);
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		// rmSetGroupingMaxDistance(comanche2VillageID, rmXFractionToMeters(0.5));
		   rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		rmAddGroupingConstraint(iroquois2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		//rmAddGroupingConstraint(comanche2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.85, 0.3);
	} 

	    if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquoisVillageID = -1;
		 iroquoisVillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		   //iroquoisVillageID = rmCreateGrouping("iroquois village", nativeName);
		rmSetGroupingMinDistance(iroquoisVillageID, 0.0);
		// rmSetGroupingMaxDistance(iroquoisVillageID, rmXFractionToMeters(0.5));
		   rmSetGroupingMaxDistance(iroquoisVillageID, 0.0);
		rmAddGroupingConstraint(iroquoisVillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquoisVillageID, 0, 0.2, 0.8);
	} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // DEFINE THE PLAYER SILVER:
	    int playerSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(playerSilverID, 18.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 22.0);
	    rmAddObjectDefConstraint(playerSilverID, avoidAll);
        rmAddObjectDefConstraint(playerSilverID, shortAvoidImpassableLand);
		
		// DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(2,3), 2.0);
        rmSetObjectDefMinDistance(playerBerryID, 10);
        rmSetObjectDefMaxDistance(playerBerryID, 15);
	    rmAddObjectDefConstraint(playerBerryID, avoidAll);
        rmAddObjectDefConstraint(playerBerryID, shortAvoidImpassableLand);
		
		// DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, treeName, 1, 0.0);
	    rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
        rmSetObjectDefMinDistance(playerTreeID, 12);
        rmSetObjectDefMaxDistance(playerTreeID, 18);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, shortAvoidImpassableLand);
		
		// DEFINE THE NEAR DEER:
		int nearDeerID=rmCreateObjectDef("herds near town");
        rmAddObjectDefItem(nearDeerID, critterOneName, rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(nearDeerID, 25);
        rmSetObjectDefMaxDistance(nearDeerID, 30);
        rmAddObjectDefConstraint(nearDeerID, avoidFood);
	    rmAddObjectDefConstraint(nearDeerID, avoidAll);
		//rmAddObjectDefConstraint(nearDeerID, avoidFarDeer);
        rmAddObjectDefConstraint(nearDeerID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(nearDeerID, true);
		
		// DEFINE THE FAR DEER:
		int farDeerID=rmCreateObjectDef("herds far away");
	    rmAddObjectDefItem(farDeerID, critterTwoName, rmRandInt(6,8), 10.0);
        rmSetObjectDefMinDistance(farDeerID, 35);
        rmSetObjectDefMaxDistance(farDeerID, 40);
        rmAddObjectDefConstraint(farDeerID, avoidFood);
		//rmAddObjectDefConstraint(farDeerID, avoidSocket);
	    rmAddObjectDefConstraint(farDeerID, avoidAll);
	    rmAddObjectDefConstraint(farDeerID, avoidImpassableLand);
        rmAddObjectDefConstraint(farDeerID, avoidCanyon);
        rmSetObjectDefCreateHerd(farDeerID, true);
		
		// DEFINE THE NUGGET:
		int nugget1= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(nugget1, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget1, avoidNugget);
  	    rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget1, avoidAll);
	    rmSetObjectDefMinDistance(nugget1, 45.0);
	    rmSetObjectDefMaxDistance(nugget1, 50.0);
		
		int nugget2= rmCreateObjectDef("nugget medium"); 
	    rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget2, 0.0);
	    rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget2, avoidNugget);
  	    rmAddObjectDefConstraint(nugget2, avoidTC);
  	    rmAddObjectDefConstraint(nugget2, avoidCW);
  	    rmAddObjectDefConstraint(nugget2, avoidCanyon);
  	    rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget2, avoidAll);
	    rmSetObjectDefMinDistance(nugget2, 50.0);
	    rmSetObjectDefMaxDistance(nugget2, 60.0);
/*================================================================================================================*/
// *************************************** PLACE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
		for(i=1; <cNumberPlayers)
	{
		rmClearClosestPointConstraints();
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
		
		// PLACE THE SILVER MINES:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE BERRIES:
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        
		// PLACE THE PLAYER TREE:
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
 		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
 		
		// PLACE THE NEAR DEER:
		rmPlaceObjectDefAtLoc(nearDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE FAR DEER:
		rmPlaceObjectDefAtLoc(farDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE NUGGET:
		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(nugget2, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: ******************************************/
/*================================================================================================================*/
        int silverID = -1;
	    int silverCount = (cNumberNonGaiaPlayers*2 + rmRandInt(3,6));
	    rmEchoInfo("silver count = "+silverCount);

	    for(i=0; < silverCount)
	{
        silverID = rmCreateObjectDef("silver "+i);
	    rmAddObjectDefItem(silverID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silverID, 0.0);
        rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID, avoidSilver);
		rmAddObjectDefConstraint(silverID, silverAvoidSilver);
        rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidCanyon);
		rmAddObjectDefConstraint(silverID, avoidPlayersFar);
        rmAddObjectDefConstraint(silverID, avoidImpassableLand);
        rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidSocket);
		rmAddObjectDefConstraint(silverID, avoidNatives);
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE LIVESTOCK: **************************************** //
/*================================================================================================================*/
	    int sheepID=rmCreateObjectDef("livestock");
	    rmAddObjectDefItem(sheepID, livestockName, 2, 4.0);
	    rmSetObjectDefMinDistance(sheepID, 0.0);
	    rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(sheepID, avoidFood);
	    rmAddObjectDefConstraint(sheepID, avoidAll);
		rmAddObjectDefConstraint(sheepID, avoidNatives);
	    rmAddObjectDefConstraint(sheepID, avoidPlayersFar);
	    rmAddObjectDefConstraint(sheepID, avoidCanyon);
	    rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
	    if(rmRandFloat(0,1) > 0.85)
		rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE TREASURES: *************************************** //
/*================================================================================================================*/
	    int nugget3= rmCreateObjectDef("nugget hard"); 
	    rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 3);
	    rmSetObjectDefMinDistance(nugget3, 0.0);
	    rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
  	    rmAddObjectDefConstraint(nugget3, avoidNugget);
  	    rmAddObjectDefConstraint(nugget3, avoidPlayersFar);
  	    rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget3, avoidAll);
		rmAddObjectDefConstraint(nugget3, avoidSocket);
		rmAddObjectDefConstraint(nugget3, avoidCanyon);
		rmAddObjectDefConstraint(nugget3, avoidNatives);
	    if(rmRandFloat(0,1) < 0.9)
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
	    else
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, cNumberNonGaiaPlayers*rmRandInt(2,4));

	    if (rmRandFloat(0,1) > 0.9)
	{
		int nugget4= rmCreateObjectDef("nugget nuts"); 
		rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
		rmSetNuggetDifficulty(4, 4);
		rmSetObjectDefMinDistance(nugget4, 0.0);
		rmSetObjectDefMaxDistance(nugget4, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(nugget4, avoidNugget);
  		rmAddObjectDefConstraint(nugget4, avoidPlayersFar);
  		rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget4, avoidSocket);
  		rmAddObjectDefConstraint(nugget4, avoidAll);
		rmAddObjectDefConstraint(nugget4, avoidCanyon);
		rmAddObjectDefConstraint(nugget4, avoidNatives);
		rmPlaceObjectDefAtLoc(nugget4, 0, 0.5, 0.5, rmRandInt(0,5));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FOREST: ***************************************** //
/*================================================================================================================*/			
	  int numTries=12*cNumberNonGaiaPlayers;
	  int failCount = 0;
	
      for (i=0; <numTries)
	{   
      int forest=rmCreateArea("forest "+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
      rmSetAreaForestType(forest, forestName);
      rmSetAreaForestDensity(forest, 0.8);
      rmSetAreaForestClumpiness(forest, 0.6);
      rmSetAreaForestUnderbrush(forest, 0.0);
      rmSetAreaMinBlobs(forest, 1);
      rmSetAreaMaxBlobs(forest, 1);
      rmSetAreaMinBlobDistance(forest, 1.0);
      rmSetAreaMaxBlobDistance(forest, 1.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 0);
      rmAddAreaToClass(forest, rmClassID("classForest")); 
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidTC);
      rmAddAreaConstraint(forest, avoidCW);
      rmAddAreaConstraint(forest, avoidAll);
	  rmAddAreaConstraint(forest, avoidSocket);
	  rmAddAreaConstraint(forest, avoidNatives);
      rmAddAreaConstraint(forest, avoidCanyon);
	  //rmAddAreaConstraint(forest, avoidCliff);
      rmAddAreaConstraint(forest, mediumAvoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);

      if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0; 
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE ELK: ****************************************** //
/*================================================================================================================*/
        int elkID=rmCreateObjectDef("elk herd");
	    rmAddObjectDefItem(elkID, critterOneName, rmRandInt(7,8), 6.0);
        rmSetObjectDefMinDistance(elkID, 0.0);
        rmSetObjectDefMaxDistance(elkID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(elkID, avoidElk);
        rmAddObjectDefConstraint(elkID, avoidMoose);
	    rmAddObjectDefConstraint(elkID, avoidAll);
        rmAddObjectDefConstraint(elkID, avoidImpassableLand);
	    rmAddObjectDefConstraint(elkID, avoidSocket);
	    rmAddObjectDefConstraint(elkID, avoidTradeRoute);
	    rmAddObjectDefConstraint(elkID, avoidTC);
		rmAddObjectDefConstraint(elkID, avoidCanyon);
        rmSetObjectDefCreateHerd(elkID, true);
	    rmPlaceObjectDefAtLoc(elkID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE MOOSE: ***************************************** // 
/*================================================================================================================*/
        int mooseID=rmCreateObjectDef("moose herd");
	    rmAddObjectDefItem(mooseID, critterTwoName, rmRandInt(4,5), 8.0);
        rmSetObjectDefMinDistance(mooseID, 0.0);
        rmSetObjectDefMaxDistance(mooseID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(mooseID, avoidElk);
        rmAddObjectDefConstraint(mooseID, avoidMoose);
	    rmAddObjectDefConstraint(mooseID, avoidAll);
        rmAddObjectDefConstraint(mooseID, avoidImpassableLand);
	    rmAddObjectDefConstraint(mooseID, avoidSocket);
	    rmAddObjectDefConstraint(mooseID, avoidTradeRoute);
	    rmAddObjectDefConstraint(mooseID, avoidTC);
		rmAddObjectDefConstraint(mooseID, avoidNatives);
		rmAddObjectDefConstraint(mooseID, avoidCanyon);
        rmSetObjectDefCreateHerd(mooseID, true);
	    rmPlaceObjectDefAtLoc(mooseID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE SCATTERED BERRRIES: ********************************* //
/*================================================================================================================*/		
	    int berriesID=rmCreateObjectDef("The Fruits");
	    rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(5,8), 6.0);
	    rmSetObjectDefMinDistance(berriesID, 0.0);
	    rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(berriesID, avoidTC);
	    rmAddObjectDefConstraint(berriesID, avoidSocket);
	    rmAddObjectDefConstraint(berriesID, avoidCW);
	    rmAddObjectDefConstraint(berriesID, avoidAll);
	    rmAddObjectDefConstraint(berriesID, avoidFruits);
		rmAddObjectDefConstraint(berriesID, fruitsAvoidFruits);
		rmAddObjectDefConstraint(berriesID, avoidElk);
        rmAddObjectDefConstraint(berriesID, avoidMoose);
	    rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
	    rmAddObjectDefConstraint(berriesID, avoidCanyon);
		rmAddObjectDefConstraint(berriesID, avoidNatives);
		rmAddObjectDefConstraint(berriesID, playerEdgeConstraint);
		rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FISHBASS: **************************************** //    
/*================================================================================================================*/
	    int fishID=rmCreateObjectDef("fish Bass");
	    rmAddObjectDefItem(fishID, "FishBass", 1, 0.0);
	    rmSetObjectDefMinDistance(fishID, 0.0);
	    rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(fishID, fishVsFishID);
	    //rmAddObjectDefConstraint(fishID, fishVsWhaleID);
	    rmAddObjectDefConstraint(fishID, fishLand);
	    rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}  
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //  
/*================================================================================================================*/
     

	
		