/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAPS: *********************************** //
/*================================================================================================================*/
// WAR OF THE SOUTH:
// CREATED BY DANY:
// MARCH 2007:
/*================================================================================================================*/
// *********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
        int subCiv5=-1;
		
		if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Seminoles");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Seminoles");

		subCiv1=rmGetCivID("Seminoles");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Seminoles"); 

		subCiv2=rmGetCivID("Seminoles");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Seminoles");

		subCiv3=rmGetCivID("Seminoles");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Seminoles");

		subCiv4=rmGetCivID("Seminoles");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Seminoles");

		subCiv5=rmGetCivID("Seminoles");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Seminoles");
   }
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int playerTiles=17500;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(530, 530);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(3);

        // PICKS DEFAULT TERRAIN AND WATER:
        rmSetSeaType("atlantic coast");
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
		
		// SET THE BASE TERRAIN MIX:
		rmSetBaseTerrainMix("carolina_grass"); // added by me for some futur use:
        
		// TERRAIN INITIALIZATION:
		// rmTerrainInitialize("water");
		   rmTerrainInitialize("carolinas\ground_grass2_car", 5); // added by me for some futur use:	
	    
		// SET THE MAP TYPE:
		rmSetMapType("carolina");
	    rmSetMapType("water");
		rmSetMapType("grass");
	    
		// SET THE CORNERS:
		rmSetWorldCircleConstraint(true);
	    
		// SET THE LIGHTING:
        rmSetLightingSet("carolina");
		
		// CHOOSE THE MERCS: // added by me...
		chooseMercs();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/   
// *************************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: *********************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
		rmDefineClass("startingUnit");
		rmDefineClass("socketClass");
		rmDefineClass("natives");
		rmDefineClass("classForest");
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/   
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/   
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 20.0);
		int playerCloseConstraint=rmCreateClassDistanceConstraint("close player vs. player", classPlayer, 10.0);
   
        // TC AND CW CONSTRAINTS:
		int TCvsTC=rmCreateTypeDistanceConstraint("TC avoid same", "TownCenter", 50.0);
        int CWvsCW=rmCreateTypeDistanceConstraint("CW avoid same", "CoveredWagon", 50.0);
		int avoidTC=rmCreateTypeDistanceConstraint("stuff vs TC", "TownCenter", 60.0);
	    int avoidCW=rmCreateTypeDistanceConstraint("stuff vs CW", "CoveredWagon", 60.0);
		
		// SEA FOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "abstractFish", 8.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "humpbackWhale", 25.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
	    //int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
		
		// FORESTS AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
        		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
		int avoidCloseNatives=rmCreateClassDistanceConstraint("trees avoids natives", rmClassID("natives"), 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidBerries=rmCreateTypeDistanceConstraint("berry vs berry", "berryBush", 5.0);
		int avoidCloseBerries=rmCreateTypeDistanceConstraint("trees vs berry", "berryBush", 2.0);
		
		// SILVER MINES AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("stuff coin avoids coin", "mine", 5.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("trees coin avoids coin", "mine", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 5.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("forest avoid fruits", "berrybush", 2.0);
		
		// TREES AVOIDANCE:
		int avoidTree=rmCreateTypeDistanceConstraint("stuff avoid tree", "TreeCarolinaGrass", 5.0);
		int avoidCloseTree=rmCreateTypeDistanceConstraint("lake avoid tree", "TreeCarolinaGrass", 2.0);
		int avoidFarTree=rmCreateTypeDistanceConstraint("forest avoid tree", "TreeCarolinaGrass", 15.0);
		
		// TREASURES AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "abstractNugget", 5.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("trees avoid nugget", "abstractNugget", 2.0);
		
		// DEERS AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "deer", 5.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("trees avoids deer", "deer", 2.0);
		
		// SHEEPS AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 5.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("trees avoids sheep", "sheep", 2.0);
       	    	    
		// AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);

        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 4.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("trees avoid trade route", 2.0);
        
	    // SOCKET AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
		int avoidCloseSocket=rmCreateClassDistanceConstraint("trees avoidance socket", rmClassID("socketClass"), 2.0);
		
		// UNIT AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);
		
		// CONSTRAINT TO AVOID WATER:
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/   
// ********************************************* DEFINE THE AREAS: ********************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/   
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
 
          if(cNumberNonGaiaPlayers == 2)
		{  
		  rmSetPlacementTeam(0);
		  rmPlacePlayer(1,0.775,0.775);
		  rmSetPlacementTeam(1);
		  rmPlacePlayer(2,0.225,0.225);
		}  
		  else
        {		
		  //rmSetPlacementTeam(0);
		  //rmPlacePlayer(1,0.8,0.8);
		  //rmPlacePlayer(2,0.8,0.2);
		  //rmSetPlacementTeam(1);
		  //rmPlacePlayer(3,0.2,0.2);
          //rmPlacePlayer(4,0.2,0.8);
		} 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/   
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        float playerFraction = rmAreaTilesToFraction(100);
        
		for(i = 0; < cNumberNonGaiaPlayers)
   {
        // CREATE THE AREA:
        int id = rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); // removed by me for now:
        //rmAddAreaConstraint(id, playerEdgeConstraint); // removed by me for now:
	   
	    // SET AREA TERRAIN TYPE:
		// rmSetAreaTerrainType(id, "carolinas\ground_grass2_car"); // added by me as a possibility:		
	    
		// SET AREA MIX:
		// rmSetAreaMix(id, "carolina_grass"); // added by me as a possiblity:
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/		
// ************************************ DEFINE AND PLACE SOME OTHER AREAS: ****************************************/
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // ************************************ DEFINE AND PLACE THE TWO SMALL POND: ************************************ //
/*================================================================================================================*/

	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
		int pondCloseConstraint=rmCreateClassDistanceConstraint("trees avoid the pond", rmClassID("pond"), 2.0);
        int smallPondID=rmCreateArea("small pond");
	
		// rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
		   rmSetAreaSize(smallPondID, 0.035, 0.035);
		// rmSetAreaWaterType(smallPondID, "saguenay lake");
		   rmSetAreaWaterType(smallPondID, "atlantic coast");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.9);
		rmSetAreaSmoothDistance(smallPondID, 5);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.40, 0.70); 
		rmBuildArea(smallPondID);
		
/*----------------------------------------------------------------------------------------------------------------*/

        //int pondClass=rmDefineClass("pond");
        //int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int smallPond2ID=rmCreateArea("small pond 2");
	
		// rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
		   rmSetAreaSize(smallPond2ID, 0.035, 0.035);
		// rmSetAreaWaterType(smallPond2ID, "saguenay lake");
		   rmSetAreaWaterType(smallPond2ID, "atlantic coast");
		rmSetAreaBaseHeight(smallPond2ID, 4);
		rmSetAreaMinBlobs(smallPond2ID, 1);
		rmSetAreaMaxBlobs(smallPond2ID, 1);
		rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
		rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
		rmAddAreaToClass(smallPond2ID, pondClass);
		rmSetAreaCoherence(smallPond2ID, 0.9);
		rmSetAreaSmoothDistance(smallPond2ID, 5);
		rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.60, 0.30); 
		rmBuildArea(smallPond2ID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE TRADE ROUTE: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/

        // DEFINE AND PLACE TRADE ROUTE 1:
		int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 6.0);

	    rmAddTradeRouteWaypoint(tradeRouteID, 0.10, 0.775);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.10, 0.70);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.10, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.15, 0.55);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.20, 0.50);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.25, 0.45);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.30, 0.40);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.40);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.45);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.50);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.55, 0.55);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.60, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.75, 0.55);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.80, 0.50);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.85, 0.45);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.40);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.30);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.225);
	    

        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.02);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.20);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc); 
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.35);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc); 
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc); 
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.65);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc); 
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.80);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc); 

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.98);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
/*================================================================================================================*/		
// ******************************* DEFINE AND PLACE THE TREES OF THE TRADE ROUTE: ******************************* //
/*================================================================================================================*/
        int tree1ID= rmCreateObjectDef("The Trees 1"); 
	    rmAddObjectDefItem(tree1ID, "TreeCarolinaGrass", 5.0, 4.0);
		rmSetObjectDefMinDistance(tree1ID, 0.0);
	    rmSetObjectDefMaxDistance(tree1ID, 0.0);
  	    rmAddObjectDefConstraint(tree1ID, avoidCloseTree);
		
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.125, 0.70);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.08, 0.725);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.08, 0.65);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.125, 0.65);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.125, 0.60);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.08, 0.60);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.175, 0.575);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.125, 0.525);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.175, 0.475);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.215, 0.515);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.265, 0.465);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.225, 0.425);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.315, 0.445);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.3, 0.35);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.40, 0.45);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.35, 0.35);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.45, 0.40);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.45, 0.50);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.50, 0.45);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.565, 0.50);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.50, 0.565);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.55, 0.60);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.60, 0.55);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.40, 0.35);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.70, 0.65);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.725, 0.525);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.65, 0.50);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.60, 0.65);	
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.75, 0.60);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.80, 0.55);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.875, 0.50);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.85, 0.40);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.925, 0.40);
        rmPlaceObjectDefAtLoc(tree1ID, 0, 0.925, 0.35);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.85, 0.30);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.915, 0.28);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.85, 0.20);
		rmPlaceObjectDefAtLoc(tree1ID, 0, 0.75, 0.50);
/*================================================================================================================*/		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// *********************** PLAYER STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ********************** //
/*================================================================================================================*/

	    // PLACE TC OR CW NOW: FIND LOCATION LATER TO PLACE OTHER RESOURCES:

	    int TCID = rmCreateObjectDef("player TC");
	    if ( rmGetNomadStart())
		rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	    else
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);
	    rmAddObjectDefConstraint(TCID, avoidTradeRoute);
        rmAddObjectDefConstraint(TCID, TCvsTC);
        rmAddObjectDefConstraint(TCID, CWvsCW);
        rmAddObjectDefConstraint(TCID, avoidImpassableLand);
	    for(i=1; <cNumberPlayers)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

	}

	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 6.0);
        rmSetObjectDefMaxDistance(startingUnits, 12.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
        rmAddObjectDefConstraint(startingUnits, avoidCloseImpassableLand);

	    // DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmSetObjectDefMinDistance(playerSilverID, 18.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 22.0);
	    rmAddObjectDefConstraint(playerSilverID, avoidAll);
        rmAddObjectDefConstraint(playerSilverID, avoidCloseImpassableLand);

	    // DEFINE THE PLAYER CRATE:
		int playerCrateID=rmCreateObjectDef("bonus starting crates");
        rmAddObjectDefItem(playerCrateID, "crateOfFood", rmRandInt(2,3), 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfWood", rmRandInt(1,3), 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 4.0);
        rmSetObjectDefMinDistance(playerCrateID, 6);
        rmSetObjectDefMaxDistance(playerCrateID, 10);
	    rmAddObjectDefConstraint(playerCrateID, avoidAll);
        rmAddObjectDefConstraint(playerCrateID, avoidCloseImpassableLand);

	    // DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", rmRandInt(2,3), 2.0);
        rmSetObjectDefMinDistance(playerBerryID, 10);
        rmSetObjectDefMaxDistance(playerBerryID, 15);
	    rmAddObjectDefConstraint(playerBerryID, avoidAll);
        rmAddObjectDefConstraint(playerBerryID, avoidCloseImpassableLand);

	    // DEFINE THE FAR BERRIES:
		int farBerriesID=rmCreateObjectDef("far berries");
        rmAddObjectDefItem(farBerriesID, "berryBush", rmRandInt(5,8), 4.0);
        rmSetObjectDefMinDistance(farBerriesID, 80);
        rmSetObjectDefMaxDistance(farBerriesID, 120);
	    rmAddObjectDefConstraint(farBerriesID, avoidAll);
	    rmAddObjectDefConstraint(farBerriesID, avoidTC);
	    rmAddObjectDefConstraint(farBerriesID, avoidCW);
	    rmAddObjectDefConstraint(farBerriesID, avoidBerries);
        rmAddObjectDefConstraint(farBerriesID, avoidImpassableLand);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeCarolinaGrass", 1, 0.0);
        rmSetObjectDefMinDistance(playerTreeID, 8);
        rmSetObjectDefMaxDistance(playerTreeID, 12);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, avoidCloseImpassableLand);
		
/*================================================================================================================*/
	    
		// DEFINE THE WATER FLAG:
		int waterFlagID=rmCreateObjectDef("HC water flag "+i);
	    rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        //rmAddClosestPointConstraint(flagEdgeConstraint);
	    rmAddClosestPointConstraint(flagVsFlag);
	    //rmAddClosestPointConstraint(bigContinentConstraint);
	    rmAddClosestPointConstraint(fishLand);
		
/*======================================================================================================================*/	 

        // DEFINE THE NUGGETS PER PLAYER:
	    
		int nugget1= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(nugget1, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nugget1, avoidNugget);
  	    rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget1, avoidAll);
	    rmSetObjectDefMinDistance(nugget1, 25.0);
	    rmSetObjectDefMaxDistance(nugget1, 35.0);

	    int nugget2= rmCreateObjectDef("nugget medium"); 
	    rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(2, 2);
	    rmSetObjectDefMinDistance(nugget2, 0.0);
	    rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(nugget2, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nugget2, avoidNugget);
  	    rmAddObjectDefConstraint(nugget2, avoidTC);
  	    rmAddObjectDefConstraint(nugget2, avoidCW);
  	    rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
  	    rmAddObjectDefConstraint(nugget2, avoidAll);
  	    rmAddObjectDefConstraint(nugget2, avoidWater20);
	    rmSetObjectDefMinDistance(nugget2, 80.0);
	    rmSetObjectDefMaxDistance(nugget2, 120.0);
		
/*================================================================================================================*/

        // DEFINE THE FOOD PER PLAYER:	
        
		int nearDeerID=rmCreateObjectDef("deer herds near town");
        rmAddObjectDefItem(nearDeerID, "deer", rmRandInt(8,10), 10.0);
        rmSetObjectDefMinDistance(nearDeerID, 30);
        rmSetObjectDefMaxDistance(nearDeerID, 40);
        rmAddObjectDefConstraint(nearDeerID, avoidDeer);
	    rmAddObjectDefConstraint(nearDeerID, avoidAll);
        rmAddObjectDefConstraint(nearDeerID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(nearDeerID, true);

	    int farDeerID=rmCreateObjectDef("deer herds far away");
	    int bonusChance=rmRandFloat(0, 1);
        if(bonusChance<0.5)   
        rmAddObjectDefItem(farDeerID, "deer", rmRandInt(8,10), 10.0);
        else
        rmAddObjectDefItem(farDeerID, "deer", rmRandInt(12,16), 10.0);
        rmSetObjectDefMinDistance(farDeerID, 60);
        rmSetObjectDefMaxDistance(farDeerID, 90);
        rmAddObjectDefConstraint(farDeerID, avoidDeer);
	    rmAddObjectDefConstraint(farDeerID, avoidAll);
	    rmAddObjectDefConstraint(farDeerID, avoidTC);
	    rmAddObjectDefConstraint(farDeerID, avoidCW);
        rmAddObjectDefConstraint(farDeerID, avoidImpassableLand);
        rmSetObjectDefCreateHerd(farDeerID, true);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVE AMERICANS: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("seminoles"))
	{  
		int seminoles1VillageID = -1;
		seminoles1VillageID = rmCreateGrouping("seminoles village 1", "native seminole village 1");
		rmSetGroupingMinDistance(seminoles1VillageID, 0.0);
		rmSetGroupingMaxDistance(seminoles1VillageID, 0.0);
		rmAddGroupingToClass(seminoles1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(seminoles1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(seminoles1VillageID, 0, 0.30, 0.90);
	} 
	
	    if (subCiv1 == rmGetCivID("seminoles"))
	{  
		int seminoles2VillageID = -1;
		seminoles2VillageID = rmCreateGrouping("seminoles village 2", "native seminole village 1");
		rmSetGroupingMinDistance(seminoles2VillageID, 0.0);
		rmSetGroupingMaxDistance(seminoles2VillageID, 0.0);
		rmAddGroupingToClass(seminoles2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(seminoles2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(seminoles2VillageID, 0, 0.70, 0.10);
	} 
	
	    if (subCiv2 == rmGetCivID("seminoles"))
	{  
		int seminoles3VillageID = -1;
		seminoles3VillageID = rmCreateGrouping("seminoles village 3", "native seminole village 1");
		rmSetGroupingMinDistance(seminoles3VillageID, 0.0);
		rmSetGroupingMaxDistance(seminoles3VillageID, 0.0);
		rmAddGroupingToClass(seminoles3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(seminoles3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(seminoles3VillageID, 0, 0.25, 0.55);
	} 
	
	    if (subCiv3 == rmGetCivID("seminoles"))
	{  
		int seminoles4VillageID = -1;
		seminoles4VillageID = rmCreateGrouping("seminoles village 4", "native seminole village 1");
		rmSetGroupingMinDistance(seminoles4VillageID, 0.0);
		rmSetGroupingMaxDistance(seminoles4VillageID, 0.0);
		rmAddGroupingToClass(seminoles4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(seminoles4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(seminoles4VillageID, 0, 0.75, 0.45);
	} 
	
	    if (subCiv4 == rmGetCivID("seminoles"))
	{  
		int seminoles5VillageID = -1;
		seminoles5VillageID = rmCreateGrouping("seminoles village 5", "native seminole village 1");
		rmSetGroupingMinDistance(seminoles5VillageID, 0.0);
		rmSetGroupingMaxDistance(seminoles5VillageID, 0.0);
		rmAddGroupingToClass(seminoles5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(seminoles5VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(seminoles5VillageID, 0, 0.55, 0.85);
	} 
	
	    if (subCiv5 == rmGetCivID("seminoles"))
	{  
		int seminoles6VillageID = -1;
		seminoles6VillageID = rmCreateGrouping("seminoles village 6", "native seminole village 1");
		rmSetGroupingMinDistance(seminoles6VillageID, 0.0);
		rmSetGroupingMaxDistance(seminoles6VillageID, 0.0);
		rmAddGroupingToClass(seminoles6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(seminoles6VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(seminoles6VillageID, 0, 0.45, 0.15);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE SOME FAR SILVER: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	   
        int silver1ID = rmCreateObjectDef("silver 1");
	    rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silver1ID, 0.0);
        rmSetObjectDefMaxDistance(silver1ID, 0.0);
		rmAddObjectDefConstraint(silver1ID, avoidCoin);
        rmPlaceObjectDefAtLoc(silver1ID, 0, 0.3, 0.6);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.5, 0.8);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.35, 0.85);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.7, 0.4);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.65, 0.15);
		rmPlaceObjectDefAtLoc(silver1ID, 0, 0.5, 0.2);
		
		int silver2ID = rmCreateObjectDef("silver 2");
	    rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silver2ID, 0.0);
        rmSetObjectDefMaxDistance(silver2ID, 0.0);
		rmAddObjectDefConstraint(silver2ID, avoidCoin);
        rmPlaceObjectDefAtLoc(silver2ID, 0, 0.10, 0.30);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.30, 0.10);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.70, 0.90);
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.90, 0.70);
  
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FRUITS: ***************************************** //
/*================================================================================================================*/
        
		int berries1ID= rmCreateObjectDef("Random Berries 1"); 
	    rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		//rmPlaceObjectDefAtLoc(berries1ID, 0, 0.20, 0.80); 
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.25, 0.65); 
        rmPlaceObjectDefAtLoc(berries1ID, 0, 0.15, 0.45);
        rmPlaceObjectDefAtLoc(berries1ID, 0, 0.35, 0.45); 
 		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.55, 0.65); 
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.85, 0.55); 
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.85, 0.25);
		
		int berries2ID= rmCreateObjectDef("Random Berries 2"); 
	    rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.05, 0.35); 
        rmPlaceObjectDefAtLoc(berries2ID, 0, 0.35, 0.05);
        rmPlaceObjectDefAtLoc(berries2ID, 0, 0.65, 0.95); 
 		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.95, 0.65);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.40, 0.20);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.75, 0.10);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.65, 0.45);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.65, 0.75);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.45, 0.975);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.830, 0.840);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.165, 0.165);
		
		
		
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE DEERS: ****************************************** //		
/*================================================================================================================*/

        int deer1ID= rmCreateObjectDef("Random Deer 1"); 
	    rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,9), 6.0);
		rmSetObjectDefCreateHerd(deer1ID, true);
		rmSetObjectDefMinDistance(deer1ID, 0.0);
		rmSetObjectDefMaxDistance(deer1ID, 0.0);
		rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.05, 0.55); 
        rmPlaceObjectDefAtLoc(deer1ID, 0, 0.25, 0.35); 			
        rmPlaceObjectDefAtLoc(deer1ID, 0, 0.45, 0.55); 	
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.75, 0.65); 	
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.95, 0.45);
		
		int deer2ID= rmCreateObjectDef("Random Deer 2"); 
	    rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,9), 6.0);
		rmSetObjectDefCreateHerd(deer2ID, true);
		rmSetObjectDefMinDistance(deer2ID, 0.0);
		rmSetObjectDefMaxDistance(deer2ID, 0.0);
		rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.30, 0.80); 
        rmPlaceObjectDefAtLoc(deer2ID, 0, 0.80, 0.30); 			
        rmPlaceObjectDefAtLoc(deer2ID, 0, 0.20, 0.70); 	
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.70, 0.20); 	
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.00, 0.00);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE SHEEP 1: **************************************** //
/*================================================================================================================*/		
		
		int sheep1ID= rmCreateObjectDef("Random Sheep 1"); 
	    rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(7,9), 6.0);
		rmSetObjectDefMinDistance(sheep1ID, 0.0);
		rmSetObjectDefMaxDistance(sheep1ID, 0.0);
		rmAddObjectDefConstraint(sheep1ID, avoidDeer);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.05, 0.45); 
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.45, 0.05); 			
        rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.55, 0.95); 	
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.95, 0.55); 	
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.60, 0.75);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.40, 0.25);
		
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/

        int nugget3= rmCreateObjectDef("nugget easy 3"); 
	    rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 1);
	    rmAddObjectDefConstraint(nugget3, avoidNugget);
  	    rmSetObjectDefMinDistance(nugget3, 0.0);
	    rmSetObjectDefMaxDistance(nugget3, 0.0);
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.165, 0.70); 
		rmPlaceObjectDefAtLoc(nugget3, 0, 0.10, 0.50);
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.20, 0.40);
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.30, 0.50);
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.45, 0.35);
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.55, 0.45);
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.65, 0.55);
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.80, 0.40);
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.90, 0.50);   		
        rmPlaceObjectDefAtLoc(nugget3, 0, 0.80, 0.15);

        int nugget4= rmCreateObjectDef("nugget easy 4"); 
	    rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 1);
	    rmAddObjectDefConstraint(nugget4, avoidNugget);
  	    rmSetObjectDefMinDistance(nugget4, 0.0);
	    rmSetObjectDefMaxDistance(nugget4, 0.0);
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.26, 0.86); 
		rmPlaceObjectDefAtLoc(nugget4, 0, 0.35, 0.95);
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.25, 0.60);
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.60, 0.90);
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.55, 0.75);
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.65, 0.05);
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.70, 0.50);
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.40, 0.10);
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.45, 0.25);   		
        rmPlaceObjectDefAtLoc(nugget4, 0, 0.375, 0.525);

        int nugget5= rmCreateObjectDef("nugget easy 5"); 
	    rmAddObjectDefItem(nugget5, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(3, 1);
	    rmAddObjectDefConstraint(nugget5, avoidNugget);
  	    rmSetObjectDefMinDistance(nugget5, 0.0);
	    rmSetObjectDefMaxDistance(nugget5, 0.0);
        rmPlaceObjectDefAtLoc(nugget5, 0, 0.125, 0.225); 
		rmPlaceObjectDefAtLoc(nugget5, 0, 0.225, 0.125);
        rmPlaceObjectDefAtLoc(nugget5, 0, 0.785, 0.875);
        rmPlaceObjectDefAtLoc(nugget5, 0, 0.875, 0.785);
        //rmPlaceObjectDefAtLoc(nugget5, 0, 0.55, 0.75);
        //rmPlaceObjectDefAtLoc(nugget5, 0, 0.65, 0.05);
       // rmPlaceObjectDefAtLoc(nugget5, 0, 0.70, 0.50);
       // rmPlaceObjectDefAtLoc(nugget5, 0, 0.40, 0.10);
       // rmPlaceObjectDefAtLoc(nugget5, 0, 0.45, 0.25);   		
       // rmPlaceObjectDefAtLoc(nugget5, 0, 0.375, 0.525); 		
        		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/   
// **************************************** CREATE AN ISLAND WITH CRATES: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*
	    // IT COULD BE REPLACE BY ANYTHING:
		if(rmRandFloat(0,1) < 0.75)
	{	
		int shipwreckIslandID=rmCreateArea("shipwreck island");
		rmSetAreaSize(shipwreckIslandID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(200));
		rmSetAreaTerrainType(shipwreckIslandID, "Carolinas\shoreline1");
		rmSetAreaBaseHeight(shipwreckIslandID, 3.5);
		rmSetAreaHeightBlend(shipwreckIslandID, 1.0);
		rmSetAreaSmoothDistance(shipwreckIslandID, 10);
		rmSetAreaWarnFailure(shipwreckIslandID, false);
		rmSetAreaCoherence(shipwreckIslandID, 1.0);
		rmAddAreaConstraint(shipwreckIslandID, bigContinentConstraint);
		rmAddAreaConstraint(shipwreckIslandID, longPlayerConstraint);
		rmBuildArea(shipwreckIslandID);

		int islandCrateID= rmCreateObjectDef("island crates"); 
		rmAddObjectDefItem(islandCrateID, "TreeCaribbean", rmRandInt(1,2), 1);
		rmAddObjectDefItem(islandCrateID, "CrateofFood", rmRandInt(0,2), 3);
		rmAddObjectDefItem(islandCrateID, "CrateofWood", rmRandInt(0,2), 4);
		rmAddObjectDefItem(islandCrateID, "CrateofCoin", rmRandInt(0,1), 4);
		rmPlaceObjectDefInArea(islandCrateID, 0, rmAreaID("shipwreck island"), 1);
	}
*/	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        // DEFINE AND PLACE THE SARDINES:
		int fishID=rmCreateObjectDef("sardine");
        rmAddObjectDefItem(fishID, "FishSardine", 1, 0.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);

        // DEFINE AND PLACE THE TARPON:
		int fish2ID=rmCreateObjectDef("tarpon");
        rmAddObjectDefItem(fish2ID, "FishTarpon", 3, 9.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFishID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);

	    // DEFINE AND PLACE THE HUMPBACKWHALE:
		int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "humpbackWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, 0.0);
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.4, 0.7);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.6, 0.3);		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/   
// ****************** PLACE THE PLAYER STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ***************** //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		if (rmGetNomadStart() == false)
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		//rmPlaceObjectDefAtLoc(farBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(nugget1, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		//rmPlaceObjectDefAtLoc(nugget2, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(nearDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		//rmPlaceObjectDefAtLoc(farDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	
	}
	    rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/   
// ******************************************** PLACE SOME EXTRA TREES: ***************************************** //
        int tree2ID= rmCreateObjectDef("The Trees 2"); 
	    rmAddObjectDefItem(tree2ID, "TreeCarolinaGrass", 1.0, 0.0);
		rmSetObjectDefMinDistance(tree2ID, 0.0);
		rmSetObjectDefMaxDistance(tree2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(tree2ID, avoidCloseTree);
		rmAddObjectDefConstraint(tree2ID, avoidCloseNatives);
		rmAddObjectDefConstraint(tree2ID, avoidCloseBerries);
		rmAddObjectDefConstraint(tree2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(tree2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(tree2ID, avoidCloseSheep);
		rmAddObjectDefConstraint(tree2ID, avoidCloseDeer);
		rmAddObjectDefConstraint(tree2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(tree2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(tree2ID, avoidCloseSocket);
		rmAddObjectDefConstraint(tree2ID, avoidCloseImpassableLand);
		rmAddObjectDefConstraint(tree2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(tree2ID, pondCloseConstraint);
		
		rmPlaceObjectDefAtLoc(tree2ID, 0, 0.5, 0.5, 35); 
/*================================================================================================================*/
// NOT FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FORESTS: **************************************** //
/*================================================================================================================*/
// NOT FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
         		 
		 int forest1ID = -1;
         forest1ID=rmCreateArea("forest 1");
         rmSetAreaWarnFailure(forest1ID, false);
         rmSetAreaSize(forest1ID, 0.008, 0.008);
         rmSetAreaForestType(forest1ID, "carolina pine forest");
         rmSetAreaForestDensity(forest1ID, 0.9);
         rmSetAreaForestClumpiness(forest1ID, 0.0);
         rmSetAreaForestUnderbrush(forest1ID, 0.0);
         rmSetAreaMinBlobs(forest1ID, 1);
         rmSetAreaMaxBlobs(forest1ID, 1);
         rmSetAreaMinBlobDistance(forest1ID, 1.0);
         rmSetAreaMaxBlobDistance(forest1ID, 1.0);
         rmSetAreaCoherence(forest1ID, 1.0);
         rmSetAreaSmoothDistance(forest1ID, 10);
         rmAddAreaToClass(forest1ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest1ID, forestConstraint);
		 rmSetAreaLocation(forest1ID, 0.45, 0.90); 
         rmBuildArea(forest1ID);
		 
		 int forest2ID = -1;
         forest2ID=rmCreateArea("forest 2");
         rmSetAreaWarnFailure(forest2ID, false);
         rmSetAreaSize(forest2ID, 0.008, 0.008);
         rmSetAreaForestType(forest2ID, "carolina pine forest");
         rmSetAreaForestDensity(forest2ID, 0.9);
         rmSetAreaForestClumpiness(forest2ID, 0.0);
         rmSetAreaForestUnderbrush(forest2ID, 0.0);
         rmSetAreaMinBlobs(forest2ID, 1);
         rmSetAreaMaxBlobs(forest2ID, 1);
         rmSetAreaMinBlobDistance(forest2ID, 1.0);
         rmSetAreaMaxBlobDistance(forest2ID, 1.0);
         rmSetAreaCoherence(forest2ID, 1.0);
         rmSetAreaSmoothDistance(forest2ID, 10);
         rmAddAreaToClass(forest2ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest2ID, forestConstraint);
		 rmSetAreaLocation(forest2ID, 0.65, 0.85); 
         rmBuildArea(forest2ID);
		 
		 int forest3ID = -1;
         forest3ID=rmCreateArea("forest 3");
         rmSetAreaWarnFailure(forest3ID, false);
         rmSetAreaSize(forest3ID, 0.008, 0.008);
         rmSetAreaForestType(forest3ID, "carolina pine forest");
         rmSetAreaForestDensity(forest3ID, 0.9);
         rmSetAreaForestClumpiness(forest3ID, 0.0);
         rmSetAreaForestUnderbrush(forest3ID, 0.0);
         rmSetAreaMinBlobs(forest3ID, 1);
         rmSetAreaMaxBlobs(forest3ID, 1);
         rmSetAreaMinBlobDistance(forest3ID, 1.0);
         rmSetAreaMaxBlobDistance(forest3ID, 1.0);
         rmSetAreaCoherence(forest3ID, 1.0);
         rmSetAreaSmoothDistance(forest3ID, 10);
         rmAddAreaToClass(forest3ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest3ID, forestConstraint);
		 rmSetAreaLocation(forest3ID, 0.85, 0.65); 
         rmBuildArea(forest3ID);
		 
		 int forest4ID = -1;
         forest4ID=rmCreateArea("forest 4");
         rmSetAreaWarnFailure(forest4ID, false);
         rmSetAreaSize(forest4ID, 0.008, 0.008);
         rmSetAreaForestType(forest4ID, "carolina pine forest");
         rmSetAreaForestDensity(forest4ID, 0.9);
         rmSetAreaForestClumpiness(forest4ID, 0.0);
         rmSetAreaForestUnderbrush(forest4ID, 0.0);
         rmSetAreaMinBlobs(forest4ID, 1);
         rmSetAreaMaxBlobs(forest4ID, 1);
         rmSetAreaMinBlobDistance(forest4ID, 1.0);
         rmSetAreaMaxBlobDistance(forest4ID, 1.0);
         rmSetAreaCoherence(forest4ID, 1.0);
         rmSetAreaSmoothDistance(forest4ID, 10);
         rmAddAreaToClass(forest4ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest4ID, forestConstraint);
		 rmSetAreaLocation(forest4ID, 0.20, 0.80); 
         rmBuildArea(forest4ID);
		 
		 int forest5ID = -1;
         forest5ID=rmCreateArea("forest 5");
         rmSetAreaWarnFailure(forest5ID, false);
         rmSetAreaSize(forest5ID, 0.008, 0.008);
         rmSetAreaForestType(forest5ID, "carolina pine forest");
         rmSetAreaForestDensity(forest5ID, 0.9);
         rmSetAreaForestClumpiness(forest5ID, 0.0);
         rmSetAreaForestUnderbrush(forest5ID, 0.0);
         rmSetAreaMinBlobs(forest5ID, 1);
         rmSetAreaMaxBlobs(forest5ID, 1);
         rmSetAreaMinBlobDistance(forest5ID, 1.0);
         rmSetAreaMaxBlobDistance(forest5ID, 1.0);
         rmSetAreaCoherence(forest5ID, 1.0);
         rmSetAreaSmoothDistance(forest5ID, 10);
         rmAddAreaToClass(forest5ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest5ID, forestConstraint);
		 rmSetAreaLocation(forest5ID, 0.35, 0.20); 
         rmBuildArea(forest5ID);
		 
		 int forest6ID = -1;
         forest6ID=rmCreateArea("forest 6");
         rmSetAreaWarnFailure(forest6ID, false);
         rmSetAreaSize(forest6ID, 0.008, 0.008);
         rmSetAreaForestType(forest6ID, "carolina pine forest");
         rmSetAreaForestDensity(forest6ID, 0.9);
         rmSetAreaForestClumpiness(forest6ID, 0.0);
         rmSetAreaForestUnderbrush(forest6ID, 0.0);
         rmSetAreaMinBlobs(forest6ID, 1);
         rmSetAreaMaxBlobs(forest6ID, 1);
         rmSetAreaMinBlobDistance(forest6ID, 1.0);
         rmSetAreaMaxBlobDistance(forest6ID, 1.0);
         rmSetAreaCoherence(forest6ID, 1.0);
         rmSetAreaSmoothDistance(forest6ID, 10);
         rmAddAreaToClass(forest6ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest6ID, forestConstraint);
		 rmSetAreaLocation(forest6ID, 0.575, 0.075); 
         rmBuildArea(forest6ID);
		 
		 int forest7ID = -1;
         forest7ID=rmCreateArea("forest 7");
         rmSetAreaWarnFailure(forest7ID, false);
         rmSetAreaSize(forest7ID, 0.008, 0.008);
         rmSetAreaForestType(forest7ID, "carolina pine forest");
         rmSetAreaForestDensity(forest7ID, 0.9);
         rmSetAreaForestClumpiness(forest7ID, 0.0);
         rmSetAreaForestUnderbrush(forest7ID, 0.0);
         rmSetAreaMinBlobs(forest7ID, 1);
         rmSetAreaMaxBlobs(forest7ID, 1);
         rmSetAreaMinBlobDistance(forest7ID, 1.0);
         rmSetAreaMaxBlobDistance(forest7ID, 1.0);
         rmSetAreaCoherence(forest7ID, 1.0);
         rmSetAreaSmoothDistance(forest7ID, 10);
         rmAddAreaToClass(forest7ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest7ID, forestConstraint);
		 rmSetAreaLocation(forest7ID, 0.15, 0.35); 
         rmBuildArea(forest7ID);
		 
		 int forest8ID = -1;
         forest8ID=rmCreateArea("forest 8");
         rmSetAreaWarnFailure(forest8ID, false);
         rmSetAreaSize(forest8ID, 0.008, 0.008);
         rmSetAreaForestType(forest8ID, "carolina pine forest");
         rmSetAreaForestDensity(forest8ID, 0.9);
         rmSetAreaForestClumpiness(forest8ID, 0.0);
         rmSetAreaForestUnderbrush(forest8ID, 0.0);
         rmSetAreaMinBlobs(forest8ID, 1);
         rmSetAreaMaxBlobs(forest8ID, 1);
         rmSetAreaMinBlobDistance(forest8ID, 1.0);
         rmSetAreaMaxBlobDistance(forest8ID, 1.0);
         rmSetAreaCoherence(forest8ID, 1.0);
         rmSetAreaSmoothDistance(forest8ID, 10);
         rmAddAreaToClass(forest8ID, rmClassID("classForest")); 
         rmAddAreaConstraint(forest8ID, forestConstraint);
		 rmSetAreaLocation(forest8ID, 0.775, 0.225); 
         rmBuildArea(forest8ID);
		 
     
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/   
}
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //
/*================================================================================================================*/

















































 